<?php require_once("class/Auth/Auth_common.php"); ?>
<?php
class Auth_exterm extends Auth_common {
		
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	/*
	function __construct( $__abstract ){
	}
	 */
	
	/***************************************************************
	 * 名前:getProjectIdByTermRootId
	 * 説明:用語集IDからプロジェクトIDを取得する
	 * 引数:
	 * 返値:
	****************************************************************/
	private function getProjectIdByExtermId($id, $projectId){
		if ( is_numeric($projectId) && ($projectId > 0) ){
			return $projectId;
		} else {
			$objDAOExterm = DAO::instance("exterm");
			$resDAOExterm = $objDAOExterm->get($id);
			if ( $resDAOExterm["result"] === RES_OK ){
				return $resDAOExterm["data"][0]["t_project_id"];
			} else {
				return NULL;
			}
		}
	}
	
	/***************************************************************
	 * 名前:getSqlCondition
	 * 説明:用語抽出一覧のSQL文
	 *      プロジェクトを作成したユーザー or 管理者 or インストラクター or プロジェクトメンバー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function getSqlCondition(){
		$arrCondition = array();
		if ( $this->isManager() ){
			// 管理者はOK
		} else {
			$arrSql = array();
			// 作成者
			$arrSql[] = "(get_user_id_by_project_id(t_project_id) = {$this->userId})";
			// プロジェクトメンバー
			$arrSql[] = "is_project_member(t_project_id, {$this->userId})";
			
			$arrCondition["auth"] = array(
				"type"  => DAO::TYPE_SQL,
				"value" => $this->getSqlOr($arrSql),
			);
		}
		
		return $arrCondition;
	}
	
	/***************************************************************
	 * 名前:readList
	 * 説明:用語抽出一覧閲覧権限があるか？
	 *      プロジェクトを作成したユーザー or 管理者 or インストラクター or プロジェクトメンバー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function readList($projectId){
		return ( $this->isManager() || $this->isCreateInstructor("project", $projectId) || $this->isCreator("project", $projectId) || $this->isProjectMember($projectId) );
	}
	
	/***************************************************************
	 * 名前:read
	 * 説明:用語抽出詳細閲覧権限があるか？
	 *      プロジェクトを作成したユーザー or 管理者 or インストラクター or プロジェクトメンバー
	 * 引数: $id = 用語抽出ID
	 * 返値:
	****************************************************************/
	public function read($id, $projectId){
		if ( ! $this->validID($id) ){
			return FALSE;
		}
		if ( $this->isManager() ){
			return TRUE;
		}
		$refProjectId = $this->getProjectIdByExtermId($id, $projectId);
		if ( $this->isCreateInstructor("project", $refProjectId) || $this->isCreator("project", $refProjectId) || $this->isProjectMember($refProjectId) ){
			return TRUE;
		}
	}
	
	/***************************************************************
	 * 名前:write
	 * 説明:用語抽出書込権限があるか？
	 *      [Create] 管理者 or インストラクター or プロジェクト有権者
	 *      [Update] -
	 * 引数: $id = 用語集ID
	 * 返値:
	****************************************************************/
	public function write($id, $projectId){
		if ( $this->writeIsCreate($id) ){
			// 追加
			return ( $this->isCreateManager("project", $projectId) || $this->isCreateInstructor("project", $projectId) || $this->isProjectVoter($projectId) );
		} else {
			return FALSE;
		}
	}
	
	/***************************************************************
	 * 名前:remove
	 * 説明:用語抽出削除権限があるか？
	 *      管理者 or インストラクター or プロジェクト有権者
	 * 引数: $id = 用語集ID
	 * 返値:
	****************************************************************/
	public function remove($id, $projectId){
		if ( ! $this->validID($id) ){
			return FALSE;
		}
		$refProjectId = $this->getProjectIdByExtermId($id, $projectId);
		return ( $this->isCreateManager("project", $projectId) || $this->isCreateInstructor("project", $projectId) || $this->isProjectVoter($projectId) );
	}
	
	/***************************************************************
	 * 名前:processDownload
	 * 説明:ダウンロード権限があるか？
	 * 引数: $id = 用語集ID
	 * 返値:
	 ****************************************************************/
	public function processDownload($id, $projectId){
		return $this->read($id, $projectId);
	}
	
}
