<?php require_once("class/Auth/Auth_common.php"); ?>
<?php
class Auth_statistics extends Auth_common {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	/*
	function __construct( $__abstract ){
	}
	 */
	
	/***************************************************************
	 * 名前:getSqlCondition
	 * 説明:一覧のSQL文
	 * 引数:
	 * 返値:
	****************************************************************/
	public function getSqlCondition(){
		return array();
	}
	
	/***************************************************************
	 * 名前:process
	 * 説明:各統計 が可能であるか？
	 * 引数:
	 * 返値:
	****************************************************************/
	public function process( $kind, $projectId ){
		switch ( $kind ){
			case Statistics::KIND_TASK_USER:
				return $this->processTaskUser($projectId);
			case Statistics::KIND_TASK_DOCUMENT:
				return $this->processTaskDocument($projectId);
			case Statistics::KIND_TASK_ROLE:
				return $this->processTaskRole($projectId);
			//---
			case Statistics::KIND_BBS_LOG:
				return $this->processBbsLog($projectId);
			case Statistics::KIND_BBS_FLOW_CHARTS:
				return $this->processBbsFlowCharts($projectId);
			case Statistics::KIND_BBS_BAR_GRAPH:
				return $this->processBbsBarGraph($projectId);
			case Statistics::KIND_BBS_LINE_GRAPH:
				return $this->processBbsLineGraph($projectId);
			default:
				return FALSE;
		}
	}
	
	/***************************************************************
	 * 名前:processTaskUser
	 * 説明:タスク - 参加者毎に表示 が可能であるか？
	 *      プロジェクトを作成したユーザー or 管理者 or インストラクター or プロジェクトメンバー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processTaskUser($projectId){
		return ( $this->isCreateManager("project", $projectId) || $this->isCreateInstructor("project", $projectId) || $this->isCreator("project", $projectId) || $this->isProjectMember($projectId) );
	}
	
	/***************************************************************
	 * 名前:processTaskDocument
	 * 説明:タスク - 文書毎に表示 が可能であるか？
	 *      プロジェクトを作成したユーザー or 管理者 or インストラクター or プロジェクトメンバー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processTaskDocument($projectId){
		return ( $this->isCreateManager("project", $projectId) || $this->isCreateInstructor("project", $projectId) || $this->isCreator("project", $projectId) || $this->isProjectMember($projectId) );
	}
	
	/***************************************************************
	 * 名前:processTaskRole
	 * 説明:タスク - タスクと役割毎に表示 が可能であるか？
	 *      プロジェクトを作成したユーザー or 管理者 or インストラクター or プロジェクトメンバー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processTaskRole($projectId){
		return ( $this->isCreateManager("project", $projectId) || $this->isCreateInstructor("project", $projectId) || $this->isCreator("project", $projectId) || $this->isProjectMember($projectId) );
	}
	
	/***************************************************************
	 * 名前:processBbsLog
	 * 説明:掲示板 - ログ が表示可能であるか？
	 *      プロジェクトを作成したユーザー or 管理者 or インストラクター or プロジェクトメンバー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processBbsLog($projectId){
		return ( $this->isCreateManager("project", $projectId) || $this->isCreateInstructor("project", $projectId) || $this->isCreator("project", $projectId) || $this->isProjectMember($projectId) );
	}
	
	/***************************************************************
	 * 名前:processBbsFlowCharts
	 * 説明:掲示板 - 状態遷移図 が表示可能であるか？
	 *      プロジェクトを作成したユーザー or 管理者 or インストラクター or プロジェクトメンバー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processBbsFlowCharts($projectId){
		return ( $this->isCreateManager("project", $projectId) || $this->isCreateInstructor("project", $projectId) || $this->isCreator("project", $projectId) || $this->isProjectMember($projectId) );
	}
	
	/***************************************************************
	 * 名前:processBbsBarGraph
	 * 説明:掲示板 - 担当一覧 が表示可能であるか？
	 *      プロジェクトを作成したユーザー or 管理者 or インストラクター or プロジェクトメンバー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processBbsBarGraph($projectId){
		return ( $this->isCreateManager("project", $projectId) || $this->isCreateInstructor("project", $projectId) || $this->isCreator("project", $projectId) || $this->isProjectMember($projectId) );
	}
	
	/***************************************************************
	 * 名前:processBbsLineGraph
	 * 説明:掲示板 - 影響力スコア が表示可能であるか？
	 *      プロジェクトを作成したユーザー or 管理者 or インストラクター or プロジェクトメンバー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processBbsLineGraph($projectId){
		return ( $this->isCreateManager("project", $projectId) || $this->isCreateInstructor("project", $projectId) || $this->isCreator("project", $projectId) || $this->isProjectMember($projectId) );
	}
	
	
}
