<?php require_once("class/Auth/Auth_common.php"); ?>
<?php
class Auth_statistics_system extends Auth_common {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	/*
	function __construct( $__abstract ){
	}
	 */
	
	/***************************************************************
	 * 名前:getSqlCondition
	 * 説明:一覧のSQL文
	 * 引数:
	 * 返値:
	****************************************************************/
	public function getSqlCondition(){
		return array();
	}
	
	/***************************************************************
	 * 名前:process
	 * 説明:各統計 が可能であるか？
	 * 引数:
	 * 返値:
	****************************************************************/
	public function process( $kind ){
		switch ( $kind ){
			case Statistics::SYSTEM_KIND_TASK_PROJECT:
				return $this->processTaskProject();
			case Statistics::SYSTEM_KIND_TASK_DOCUMENT:
				return $this->processTaskDocument();
			case Statistics::SYSTEM_KIND_LOOKUP_TEXT:
				return $this->processLookupText();
			case Statistics::SYSTEM_KIND_LOOKUP_PROJECT:
				return $this->processLookupProject();
			case Statistics::SYSTEM_KIND_LOOKUP_DOCUMENT:
				return $this->processLookupDocument();
			case Statistics::SYSTEM_KIND_SELLOOKUP_TEXT:
				return $this->processSelLookupText();
			case Statistics::SYSTEM_KIND_SELLOOKUP_PROJECT:
				return $this->processSelLookupProject();
			case Statistics::SYSTEM_KIND_SELLOOKUP_DOCUMENT:
				return $this->processSelLookupDocument();
			//---
			case Statistics::SYSTEM_KIND_ORGTASK_USER:
				return $this->processOrgTaskUser();
			case Statistics::SYSTEM_KIND_ORGTASK_PROJECT:
				return $this->processOrgTaskProject();
			case Statistics::SYSTEM_KIND_ORGTASK_DOCUMENT:
				return $this->processOrgTaskDocument();
			case Statistics::SYSTEM_KIND_ORGLOOKUP_TEXT:
				return $this->processOrgLookupText();
			case Statistics::SYSTEM_KIND_ORGLOOKUP_PROJECT:
				return $this->processOrgLookupProject();
			case Statistics::SYSTEM_KIND_ORGLOOKUP_DOCUMENT:
				return $this->processOrgLookupDocument();
			case Statistics::SYSTEM_KIND_ORGSELLOOKUP_TEXT:
				return $this->processOrgSelLookupText();
			case Statistics::SYSTEM_KIND_ORGSELLOOKUP_PROJECT:
				return $this->processOrgSelLookupProject();
			case Statistics::SYSTEM_KIND_ORGSELLOOKUP_DOCUMENT:
				return $this->processOrgSelLookupDocument();
			//---
			case Statistics::SYSTEM_KIND_ORGANIZATION:
				return $this->processOrganization();
			case Statistics::SYSTEM_KIND_LOGIN:
				return $this->processLogin();
			default:
				return FALSE;
		}
	}
	
	/***************************************************************
	 * 名前:processTaskProject
	 * 説明:タスク - プロジェクト毎に表示 が可能であるか？
	 *      ログインユーザー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processTaskProject(){
		return Auth::isLogin($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processTaskDocument
	 * 説明:タスク - 文書毎に表示 が可能であるか？
	 *      ログインユーザー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processTaskDocument(){
		return Auth::isLogin($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processLookupText
	 * 説明:辞書引き - テキスト毎に表示 が可能であるか？
	 *      ログインユーザー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processLookupText(){
		return Auth::isLogin($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processLookupProject
	 * 説明:辞書引き - プロジェクト毎に表示 が可能であるか？
	 *      ログインユーザー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processLookupProject(){
		return Auth::isLogin($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processLookupDocument
	 * 説明:辞書引き - 文書毎に表示 が可能であるか？
	 *      ログインユーザー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processLookupDocument(){
		return Auth::isLogin($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processSelLookupText
	 * 説明:辞書引き選択 - テキスト毎に表示 が可能であるか？
	 *      ログインユーザー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processSelLookupText(){
		return Auth::isLogin($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processSelLookupProject
	 * 説明:辞書引き選択 - プロジェクト毎に表示 が可能であるか？
	 *      ログインユーザー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processSelLookupProject(){
		return Auth::isLogin($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processSelLookupDocument
	 * 説明:辞書引き選択 - 文書毎に表示 が可能であるか？
	 *      ログインユーザー
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processSelLookupDocument(){
		return Auth::isLogin($this->userType, $this->userId);
	}
	
	
	/***************************************************************
	 * 名前:processOrgTaskUser
	 * 説明:全タスク - ユーザー毎に表示 が可能であるか？
	 *      管理者
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processOrgTaskUser(){
		return Auth::isSysmgr($this->userType, $this->userId) || Auth::isOrgmgr($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processOrgTaskProject
	 * 説明:全タスク - プロジェクト毎に表示 が可能であるか？
	 *      管理者
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processOrgTaskProject(){
		return Auth::isSysmgr($this->userType, $this->userId) || Auth::isOrgmgr($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processOrgTaskDocument
	 * 説明:全タスク - 文書毎に表示 が可能であるか？
	 *      管理者
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processOrgTaskDocument(){
		return Auth::isSysmgr($this->userType, $this->userId) || Auth::isOrgmgr($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processOrgLookupText
	 * 説明:全辞書引き - テキスト毎に表示 が可能であるか？
	 *      管理者
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processOrgLookupText(){
		return Auth::isSysmgr($this->userType, $this->userId) || Auth::isOrgmgr($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processOrgLookupProject
	 * 説明:全辞書引き - プロジェクト毎に表示 が可能であるか？
	 *      管理者
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processOrgLookupProject(){
		return Auth::isSysmgr($this->userType, $this->userId) || Auth::isOrgmgr($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processOrgLookupDocument
	 * 説明:全辞書引き - 文書毎に表示 が可能であるか？
	 *      管理者
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processOrgLookupDocument(){
		return Auth::isSysmgr($this->userType, $this->userId) || Auth::isOrgmgr($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processOrgSelLookupText
	 * 説明:全辞書引き選択 - テキスト毎に表示 が可能であるか？
	 *      管理者
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processOrgSelLookupText(){
		return Auth::isSysmgr($this->userType, $this->userId) || Auth::isOrgmgr($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processOrgSelLookupProject
	 * 説明:全辞書引き選択 - プロジェクト毎に表示 が可能であるか？
	 *      管理者
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processOrgSelLookupProject(){
		return Auth::isSysmgr($this->userType, $this->userId) || Auth::isOrgmgr($this->userType, $this->userId);
	}
	
	/***************************************************************
	 * 名前:processOrgSelLookupDocument
	 * 説明:全辞書引き選択 - 文書毎に表示 が可能であるか？
	 *      管理者
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processOrgSelLookupDocument(){
		return Auth::isSysmgr($this->userType, $this->userId) || Auth::isOrgmgr($this->userType, $this->userId);
	}
	
	
	/***************************************************************
	 * 名前:processOrganization
	 * 説明:組織情報 が可能であるか？
	 *      システム管理者
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processOrganization(){
		return Auth::isSysmgr($this->userType, $this->userId);
	}
	
	
	/***************************************************************
	 * 名前:processOrgSelLookupDocument
	 * 説明:ログイン情報 が可能であるか？
	 *      管理者
	 * 引数:
	 * 返値:
	****************************************************************/
	public function processLogin(){
		return Auth::isSysmgr($this->userType, $this->userId) || Auth::isOrgmgr($this->userType, $this->userId);
	}
	
	
}
