<?php
Class DAO {
	const READ  = "READ";
	const WRITE = "WRITE";
	const NOW   = "NOW()";
	const NULL  = "NULL";
	const ASC   = "ASC";
	const DESC  = "DESC";
	const RAND  = "RAND()";
	
	const TYPE_SQL    = "SQL";
	const TYPE_NOT    = "NOT";
	const TYPE_IN     = "IN";
	const TYPE_NOT_IN = "NOT_IN";
	const TYPE_LIKE   = "LIKE";

	const TABLE_TYPE_INNER = "INNER";
	const TABLE_TYPE_LEFT  = "LEFT";
	const TABLE_TYPE_RIGHT = "RIGHT";
	
	// common
	const ID_INIT = 0;  // ID初期値
	const ORDER_VALUE_ASC  = "asc";
	const ORDER_VALUE_DESC = "desc";
	// t_bbs
	const T_BBS_PROJECT_ID_SYSTEM = 0;  // 掲示板ID(システム)
	// t_bbs_post
	const T_BBS_POST_KIND_NORMAL   = 0; // 種類(通常)
	const T_BBS_POST_KIND_ADDITION = 1; // 種類(テキスト追記)
	const T_BBS_POST_PARENT_NO_NON =  0;  // 親投稿No(なし)
	const T_BBS_POST_STATE_HIDE   = -2;  // 状態(削除)..."削除されました"と表示する
	const T_BBS_POST_STATE_DELETE = -1;  // 状態(削除)
	const T_BBS_POST_STATE_NORMAL =  0;  // 状態(通常)
	const T_BBS_POST_STAGE_COMMIT    = 1;  // ステージ(commission)
	const T_BBS_POST_STAGE_PREPARE   = 2;  // ステージ(preparation)
	const T_BBS_POST_STAGE_TRANSLATE = 3;  // ステージ(translation)
	//const T_BBS_POST_STAGE_QA        = 4;  // ステージ(QA)
	const T_BBS_POST_STAGE_RESUPDATE = 5;  // ステージ(resource_update)
	const T_BBS_POST_STAGE_SIGNOFF   = 6;  // ステージ(sign_off)
	const T_BBS_POST_STAGE_OTHERS    = 7;  // ステージ(others)
	const T_BBS_POST_TYPE_DIRQ =  0x00;  // 掲示板投稿タイプ(information-request)
	const T_BBS_POST_TYPE_DIOF =  0x01;  // 掲示板投稿タイプ(information-offer)
	const T_BBS_POST_TYPE_DISP =  0x02;  // 掲示板投稿タイプ(information-support)
	const T_BBS_POST_TYPE_DIDF =  0x03;  // 掲示板投稿タイプ(information-differ)
	const T_BBS_POST_TYPE_DACK =  0x10;  // 掲示板投稿タイプ(maintenance-acknowledge)
	const T_BBS_POST_TYPE_DMOV =  0x11;  // 掲示板投稿タイプ(maintenance-motivate)
	const T_BBS_POST_TYPE_DCLA =  0x12;  // 掲示板投稿タイプ(maintenance-clarify)
	const T_BBS_POST_TYPE_DMED =  0x13;  // 掲示板投稿タイプ(maintenance-mediate)
	const T_BBS_POST_TYPE_DSCH =  0x20;  // 掲示板投稿タイプ(status-check)
	const T_BBS_POST_TYPE_DSRP =  0x21;  // 掲示板投稿タイプ(status-report)
	const T_BBS_POST_TYPE_DRRQ =  0x30;  // 掲示板投稿タイプ(role-request)
	const T_BBS_POST_TYPE_DROF =  0x31;  // 掲示板投稿タイプ(role-offer)
	const T_BBS_POST_TYPE_DRDC =  0x32;  // 掲示板投稿タイプ(role-decline)
	const T_BBS_POST_TYPE_DRAC =  0x33;  // 掲示板投稿タイプ(role-accept)
	const T_BBS_POST_TYPE_GROUP_INFORMATION = 1;  // 掲示板投稿タイプグループ(information-*)
	const T_BBS_POST_TYPE_GROUP_MAINTENANCE = 2;  // 掲示板投稿タイプグループ(maintenance-*)
	const T_BBS_POST_TYPE_GROUP_STATUS      = 3;  // 掲示板投稿タイプグループ(status-*)
	const T_BBS_POST_TYPE_GROUP_ROLE        = 4;  // 掲示板投稿タイプグループ(role-*)
	const T_BBS_POST_TITLE_LEN_MIN =   0;  // 掲示板投稿タイトルの長さ(最小)
	const T_BBS_POST_TITLE_LEN_MAX = 250;  // 掲示板投稿タイトルの長さ(最大)
	// t_data
	const T_DATA_STATE_DELETE = -1; // 状態(削除)
	const T_DATA_STATE_NORMAL =  0; // 状態(通常)
	const T_DATA_PUBLIC_PRJ = 0;  // 公開状態(プロジェクト)
	const T_DATA_PUBLIC_ORG = 1;  // 公開状態(組織)
	const T_DATA_PUBLIC_OPN = 2;  // 公開状態(一般公開)
	const T_DATA_PROP_BRIEF    =   0;  // 使用タイプ(brief)
	const T_DATA_PROP_RESEARCH =   1;  // 使用タイプ(research-results)
	const T_DATA_PROP_DELIVER  =   2;  // 使用タイプ(deliverable)
	const T_DATA_PROP_OTHERS   = 256;  // 使用タイプ(その他)
	// t_document
	const T_DOCUMENT_STATE_DELETE = -1;  // 状態(削除)
	const T_DOCUMENT_STATE_NORMAL =  0;  // 状態(通常)
	const T_DOCUMENT_STATE_MTWAIT =  1;  // 状態(機械翻訳待ち)
	const T_DOCUMENT_STATE_MTCOMP =  2;  // 状態(機械翻訳完了)
	// t_exterm
	const T_EXTERM_STATE_PROVISIONAL = -2;  // 状態(仮状態:抽出後新規用語集に登録する予定だが新規用語集がまだ登録されていない)
	const T_EXTERM_STATE_DELETE = -1;  // 状態(削除)
	const T_EXTERM_STATE_NORMAL =  0;  // 状態(待機中)
	const T_EXTERM_STATE_WAITNG =  1;  // 状態(処理中)
	const T_EXTERM_STATE_COMPLT =  2;  // 状態(完了)
	const T_EXTERM_STATE_FAILED =  3;  // 状態(失敗)
	// t_log_lookup_select
	const T_LOG_LOOKUP_SELECT_MODE_P  = 0;  // ポップアップモード(P)
	const T_LOG_LOOKUP_SELECT_MODE_L  = 1;  // ポップアップモード(L)
	const T_LOG_LOOKUP_SELECT_MODE_S  = 2;  // ポップアップモード(S)
	const T_LOG_LOOKUP_SELECT_MODE_M  = 3;  // ポップアップモード(M)
	const T_LOG_LOOKUP_SELECT_MODE_R  = 4;  // ポップアップモード(R)
	const T_LOG_LOOKUP_SELECT_MODE_TM = 5; // ポップアップモード(TM)
	// t_login
	const T_LOGIN_STATE_NONE   =  0;  // 状態(無し)
	// t_organization
	// t_project
	const T_PROJECT_STATE_DELETE   = -1;  // 状態(削除)
	const T_PROJECT_STATE_NORMAL   =  0;  // 状態(通常)
	const T_PROJECT_STATE_COMPLETE = 10;  // 状態(完了)
	// t_task
	const T_TASK_STATE_DELETE = -1;  // 状態(削除)
	const T_TASK_STATE_NORMAL =  0;  // 状態(通常)    *js
	const T_TASK_STATE_CARIED = 10;  // 状態(実施中)  *js
	const T_TASK_STATE_FINISH = 20;  // 状態(完了)    *js
	const T_TASK_ORDER_INIT   =  0;  // 並び順(初期値)
	// t_task_actor
	const T_TASK_ACTOR_TYPE_ACTOR   = 0; // 担当者(actor)
	const T_TASK_ACTOR_TYPE_CONTACT = 1; // 接触者(contact)
	// t_term_root
	const T_TERM_ROOT_TYPE_NORMAL    = 0;  // タイプ(プロジェクト)
	const T_TERM_ROOT_TYPE_REFERENCE = 1;  // タイプ(参考)
	const T_TERM_ROOT_STATE_DELETE = -1; // 状態(削除)
	const T_TERM_ROOT_STATE_NORMAL =  0; // 状態(通常)
	const T_TERM_ROOT_PUBLIC_PRJ = 0;  // 公開状態(プロジェクト)
	const T_TERM_ROOT_PUBLIC_ORG = 1;  // 公開状態(組織)
	const T_TERM_ROOT_PUBLIC_OPN = 2;  // 公開状態(一般公開)
	// t_user
	const T_USER_NAME_LEN_MIN       =         3;  // ユーザー名の長さ(最小)
	const T_USER_NAME_LEN_MAX       =        12;  // ユーザー名の長さ(最大)
	const T_USER_STATE_ACTIVE       =         0;  // ユーザー状態(在籍中)
	const T_USER_STATE_QUIT         =         1;  // ユーザー状態(卒業)
	const T_USER_TYPE_______        =       -99;  // ユーザータイプ(未設定)
	const T_USER_TYPE_LOGOFF        =        -1;  // ユーザータイプ(ログオフ)
	const T_USER_TYPE_NORMAL        =         0;  // ユーザータイプ(一般ユーザー)
	const T_USER_TYPE_INSTTR        =        10;  // ユーザータイプ(インストラクター)
	const T_USER_TYPE_ORGMGR        =        20;  // ユーザータイプ(組織管理者)
	const T_USER_TYPE_SYSMGR        =        30;  // ユーザータイプ(システム管理者)
	const T_USER_PASSWORD_LEN_MIN   =         6;  // ユーザーパスワードの長さ(最小)
	const T_USER_PASSWORD_LEN_MAX   =        24;  // ユーザーパスワードの長さ(最大)
	const T_USER_QUESTION_NON       =        -1;  // 秘密の質問(無し)
	const T_USER_LOGIN_OK           =         0;  // ログイン許可
	const T_USER_LOGIN_NG           =         1;  // ログイン拒否
	const T_USER_WARN_NON_ACTIVE_NONE = 0; // 非活発ユーザー表示        *js
	const T_USER_WARN_NON_ACTIVE_HIDE = 1; // 非活発ユーザー表示しない  *js
	const T_USER_QREDIT_DISPLAY_L   =    "left";  // QRedit:原文の位置(左)
	const T_USER_QREDIT_DISPLAY_R   =   "right";  // QRedit:原文の位置(右)
	const T_USER_QREDIT_DISPLAY_U   =     "top";  // QRedit:原文の位置(上)
	const T_USER_QREDIT_DISPLAY_D   =  "bottom";  // QRedit:原文の位置(下)
	const T_USER_QREDIT_WIDTH_AUTO  =         0;  // QRedit:原文の幅(AUTO)
	const T_USER_QREDIT_WIDTH_MIN   =       150;  // QRedit:原文の幅(最小)
	const T_USER_QREDIT_WIDTH_MAX   =      1300;  // QRedit:原文の幅(最大)
	const T_USER_QREDIT_WIDTH_SPAN  =        50;  // QRedit:原文の幅(スパン)
	const T_USER_QREDIT_SCROLL_BOTH =    "both";  // QRedit:同期スクロール(両方向)
	const T_USER_QREDIT_SCROLL_NONE =    "none";  // QRedit:同期スクロール(同期しない)
	const T_USER_QREDIT_SCROLL_ORGN =     "src";  // QRedit:同期スクロール(原文→翻訳文)
	const T_USER_QREDIT_SCROLL_TRNS =  "target";  // QRedit:同期スクロール(翻訳文→原文)
	const T_USER_QREDIT_LOOKUP_M    =  "inside";  // QRedit:訳語表示の位置(原文の中)
	const T_USER_QREDIT_LOOKUP_L    =    "left";  // QRedit:訳語表示の位置(原文の左)
	const T_USER_QREDIT_LOOKUP_R    =   "right";  // QRedit:訳語表示の位置(原文の右)
	const T_USER_QREDIT_ACTION_P    =   "paste";  // QRedit:訳語表示のクリック(P)
	const T_USER_QREDIT_ACTION_L    =  "lookup";  // QRedit:訳語表示のクリック(L)
	const T_USER_QREDIT_ACTION_S    =  "search";  // QRedit:訳語表示のクリック(S)
	const T_USER_QREDIT_ACTION_TM   = "similar"; // QRedit:訳語表示のクリック(TM)
	const T_USER_QREDIT_ACTION_M    =  "memory";  // QRedit:訳語表示のクリック(M)
	const T_USER_QREDIT_ACTION_R    =  "regist";  // QRedit:訳語表示のクリック(R)
	const T_USER_QREDIT_TAG_N       =     "off";  // QRedit:タグ名の表示(非表示)
	const T_USER_QREDIT_TAG_L       =    "left";  // QRedit:タグ名の表示(原文の左)
	const T_USER_QREDIT_TAG_R       =   "right";  // QRedit:タグ名の表示(原文の右)
	// t_workflow
	const T_WORKFLOW_STATE_DELETE = -1;  // 状態(削除)
	const T_WORKFLOW_STATE_NORMAL =  0;  // 状態(通常)
	
	public static $db;
	private static $arrInstance = array();

	// インスタンス変数
	var $tableName = "";
	var $auth = NULL;
	
//=================================================================================================
//     スタティック変数
//=================================================================================================
	
	public static function ORDER_VALUE_SQL_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::ORDER_VALUE_ASC  => DAO::ASC,
			self::ORDER_VALUE_DESC => DAO::DESC,
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_BBS_POST_KIND_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_BBS_POST_KIND_NORMAL   => "",
			self::T_BBS_POST_KIND_ADDITION => "",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_BBS_POST_STATE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_BBS_POST_STATE_HIDE   => "",
			self::T_BBS_POST_STATE_DELETE => "",
			self::T_BBS_POST_STATE_NORMAL => "",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_BBS_POST_STATE_VALID_TABLE(){
		$arrTable = self::T_BBS_POST_STATE_TABLE();
		unset($arrTable[self::T_BBS_POST_STATE_DELETE]);
		
		return $arrTable;
	}
	
	public static function T_BBS_POST_STAGE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_BBS_POST_STAGE_COMMIT    => "{$WORD($wk, 1)}",  // "commission"
			self::T_BBS_POST_STAGE_PREPARE   => "{$WORD($wk, 2)}",  // "preparation"
			self::T_BBS_POST_STAGE_TRANSLATE => "{$WORD($wk, 3)}",  // "translation"
			//self::T_BBS_POST_STAGE_QA        => "{$WORD($wk, 4)}",  // "QA"
			self::T_BBS_POST_STAGE_RESUPDATE => "{$WORD($wk, 5)}",  // "resource_update"
			self::T_BBS_POST_STAGE_SIGNOFF   => "{$WORD($wk, 6)}",  // "sign_off"
			self::T_BBS_POST_STAGE_OTHERS    => "{$WORD($wk, 7)}",  // "others"
		);
		
		return is_null($key) ? $arrTable : (isset($arrTable[$key]) ? $arrTable[$key] : $arrTable[self::T_BBS_POST_STAGE_OTHERS]);
	}
	
	public static function T_BBS_POST_TYPE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_BBS_POST_TYPE_DIRQ => "{$WORD($wk, 8)}",  // 投稿タイプ(information-request)
			self::T_BBS_POST_TYPE_DIOF => "{$WORD($wk, 9)}",  // 投稿タイプ(information-offer)
			self::T_BBS_POST_TYPE_DISP => "{$WORD($wk, 10)}",  // 投稿タイプ(information-support)
			self::T_BBS_POST_TYPE_DIDF => "{$WORD($wk, 11)}",  // 投稿タイプ(information-differ)
			self::T_BBS_POST_TYPE_DACK => "{$WORD($wk, 12)}",  // 投稿タイプ(maintenance-acknowledge)
			self::T_BBS_POST_TYPE_DMOV => "{$WORD($wk, 13)}",  // 投稿タイプ(maintenance-motivate)
			self::T_BBS_POST_TYPE_DCLA => "{$WORD($wk, 14)}",  // 投稿タイプ(maintenance-clarify)
			self::T_BBS_POST_TYPE_DMED => "{$WORD($wk, 15)}",  // 投稿タイプ(maintenance-mediate)
			self::T_BBS_POST_TYPE_DSCH => "{$WORD($wk, 16)}",  // 投稿タイプ(status-check)
			self::T_BBS_POST_TYPE_DSRP => "{$WORD($wk, 17)}",  // 投稿タイプ(status-report)
			self::T_BBS_POST_TYPE_DRRQ => "{$WORD($wk, 18)}",  // 投稿タイプ(role-request)
			self::T_BBS_POST_TYPE_DROF => "{$WORD($wk, 19)}",  // 投稿タイプ(role-offer)
			self::T_BBS_POST_TYPE_DRDC => "{$WORD($wk, 20)}",  // 投稿タイプ(role-decline)
			self::T_BBS_POST_TYPE_DRAC => "{$WORD($wk, 21)}",  // 投稿タイプ(role-accept)
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_BBS_POST_TYPE_GROUP_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_BBS_POST_TYPE_GROUP_INFORMATION => "{$WORD($wk, 22)}",  // 掲示板投稿タイプグループ(information-*)
			self::T_BBS_POST_TYPE_GROUP_MAINTENANCE => "{$WORD($wk, 23)}",  // 掲示板投稿タイプグループ(maintenance-*)
			self::T_BBS_POST_TYPE_GROUP_STATUS      => "{$WORD($wk, 24)}",  // 掲示板投稿タイプグループ(status-*)
			self::T_BBS_POST_TYPE_GROUP_ROLE        => "{$WORD($wk, 25)}",  // 掲示板投稿タイプグループ(role-*)
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_BBS_POST_TYPE_TO_TYPE_GROUP_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_BBS_POST_TYPE_DIRQ => self::T_BBS_POST_TYPE_GROUP_INFORMATION,  // 投稿タイプ(information-request)
			self::T_BBS_POST_TYPE_DIOF => self::T_BBS_POST_TYPE_GROUP_INFORMATION,  // 投稿タイプ(information-offer)
			self::T_BBS_POST_TYPE_DISP => self::T_BBS_POST_TYPE_GROUP_INFORMATION,  // 投稿タイプ(information-support)
			self::T_BBS_POST_TYPE_DIDF => self::T_BBS_POST_TYPE_GROUP_INFORMATION,  // 投稿タイプ(information-differ)
			self::T_BBS_POST_TYPE_DACK => self::T_BBS_POST_TYPE_GROUP_MAINTENANCE,  // 投稿タイプ(maintenance-acknowledge)
			self::T_BBS_POST_TYPE_DMOV => self::T_BBS_POST_TYPE_GROUP_MAINTENANCE,  // 投稿タイプ(maintenance-motivate)
			self::T_BBS_POST_TYPE_DCLA => self::T_BBS_POST_TYPE_GROUP_MAINTENANCE,  // 投稿タイプ(maintenance-clarify)
			self::T_BBS_POST_TYPE_DMED => self::T_BBS_POST_TYPE_GROUP_MAINTENANCE,  // 投稿タイプ(maintenance-mediate)
			self::T_BBS_POST_TYPE_DSCH => self::T_BBS_POST_TYPE_GROUP_STATUS,       // 投稿タイプ(status-check)
			self::T_BBS_POST_TYPE_DSRP => self::T_BBS_POST_TYPE_GROUP_STATUS,       // 投稿タイプ(status-report)
			self::T_BBS_POST_TYPE_DRRQ => self::T_BBS_POST_TYPE_GROUP_ROLE,         // 投稿タイプ(role-request)
			self::T_BBS_POST_TYPE_DROF => self::T_BBS_POST_TYPE_GROUP_ROLE,         // 投稿タイプ(role-offer)
			self::T_BBS_POST_TYPE_DRDC => self::T_BBS_POST_TYPE_GROUP_ROLE,         // 投稿タイプ(role-decline)
			self::T_BBS_POST_TYPE_DRAC => self::T_BBS_POST_TYPE_GROUP_ROLE,         // 投稿タイプ(role-accept)
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_BBS_POST_TYPE_GROUP_TO_TYPE_TABLE( $key = NULL ){
		$arrTable = array();
		foreach ( self::T_BBS_POST_TYPE_GROUP_TABLE() as $typeGroup => $text ){
			$arrTable[$typeGroup] = array();
		}
		
		foreach ( self::T_BBS_POST_TYPE_TO_TYPE_GROUP_TABLE() as $type => $typeGroup ){
			$arrTable[$typeGroup][$type] = self::T_BBS_POST_TYPE_TABLE($type);
		}
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_BBS_POST_TYPE_MARK_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		// One of diamond, circle, square, x, plus, dash, filledDiamond, filledCircle, filledSquare
		
		$arrTable = array(
			self::T_BBS_POST_TYPE_DIRQ => "filledDiamond",  // 投稿タイプ(information-request)
			self::T_BBS_POST_TYPE_DIOF => "filledDiamond",  // 投稿タイプ(information-offer)
			self::T_BBS_POST_TYPE_DISP => "filledDiamond",  // 投稿タイプ(information-support)
			self::T_BBS_POST_TYPE_DIDF => "filledDiamond",  // 投稿タイプ(information-differ)
			self::T_BBS_POST_TYPE_DACK => "filledCircle",   // 投稿タイプ(maintenance-acknowledge)
			self::T_BBS_POST_TYPE_DMOV => "filledCircle",   // 投稿タイプ(maintenance-motivate)
			self::T_BBS_POST_TYPE_DCLA => "filledCircle",   // 投稿タイプ(maintenance-clarify)
			self::T_BBS_POST_TYPE_DMED => "filledCircle",   // 投稿タイプ(maintenance-mediate)
			self::T_BBS_POST_TYPE_DSCH => "filledSquare",   // 投稿タイプ(status-check)
			self::T_BBS_POST_TYPE_DSRP => "filledSquare",   // 投稿タイプ(status-report)
			self::T_BBS_POST_TYPE_DRRQ => "x",              // 投稿タイプ(role-request)
			self::T_BBS_POST_TYPE_DROF => "x",              // 投稿タイプ(role-offer)
			self::T_BBS_POST_TYPE_DRDC => "x",              // 投稿タイプ(role-decline)
			self::T_BBS_POST_TYPE_DRAC => "x",              // 投稿タイプ(role-accept)
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_BBS_POST_TYPE_MARK_COLOR_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_BBS_POST_TYPE_DIRQ => "#2D4071",  // 投稿タイプ(information-request)
			self::T_BBS_POST_TYPE_DIOF => "#C7D0E9",  // 投稿タイプ(information-offer)
			self::T_BBS_POST_TYPE_DISP => "#AAB8DD",  // 投稿タイプ(information-support)
			self::T_BBS_POST_TYPE_DIDF => "#425FAA",  // 投稿タイプ(information-differ)
			self::T_BBS_POST_TYPE_DACK => "#750B3E",  // 投稿タイプ(maintenance-acknowledge)
			self::T_BBS_POST_TYPE_DMOV => "#F7A2CA",  // 投稿タイプ(maintenance-motivate)
			self::T_BBS_POST_TYPE_DCLA => "#F273AF",  // 投稿タイプ(maintenance-clarify)
			self::T_BBS_POST_TYPE_DMED => "#AF105B",  // 投稿タイプ(maintenance-mediate)
			self::T_BBS_POST_TYPE_DSCH => "#3F6C1A",  // 投稿タイプ(status-check)
			self::T_BBS_POST_TYPE_DSRP => "#5EA226",  // 投稿タイプ(status-report)
			self::T_BBS_POST_TYPE_DRRQ => "#835F01",  // 投稿タイプ(role-request)
			self::T_BBS_POST_TYPE_DROF => "#FFE39B",  // 投稿タイプ(role-offer)
			self::T_BBS_POST_TYPE_DRDC => "#C58E01",  // 投稿タイプ(role-decline)
			self::T_BBS_POST_TYPE_DRAC => "#FED66B",  // 投稿タイプ(role-accept)
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_DATE_STATE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_DATA_STATE_DELETE => "{$WORD($wk, 26)}",
			self::T_DATA_STATE_NORMAL => "{$WORD($wk, 27)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
		global $WORD;
	}
	
	public static function T_DATA_STATE_VALID_TABLE(){
		$arrTable = self::T_DATA_STATE_TABLE();
		unset($arrTable[self::T_DATA_STATE_DELETE]);
		
		return $arrTable;
	}
	
	public static function T_DATA_PUBLIC_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_DATA_PUBLIC_PRJ => "{$WORD($wk, 28)}",
			self::T_DATA_PUBLIC_ORG => "{$WORD($wk, 29)}",
			self::T_DATA_PUBLIC_OPN => "{$WORD($wk, 30)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_DATA_PROP_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_DATA_PROP_BRIEF    => "{$WORD($wk, 31)}",
			self::T_DATA_PROP_RESEARCH => "{$WORD($wk, 32)}",
			self::T_DATA_PROP_DELIVER  => "{$WORD($wk, 33)}",
			self::T_DATA_PROP_OTHERS   => "{$WORD($wk, 34)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_DOCUMENT_STATE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_DOCUMENT_STATE_DELETE => "{$WORD($wk, 35)}",
			self::T_DOCUMENT_STATE_NORMAL => "{$WORD($wk, 36)}",
			self::T_DOCUMENT_STATE_MTWAIT => "{$WORD($wk, 37)}",
			self::T_DOCUMENT_STATE_MTCOMP => "{$WORD($wk, 38)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}

	public static function T_DOCUMENT_STATE_VALID_TABLE(){
		$arrTable = self::T_DOCUMENT_STATE_TABLE();
		unset($arrTable[self::T_DOCUMENT_STATE_DELETE]);
		
		return $arrTable;
	}
	
	public static function T_EXTERM_STATE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_EXTERM_STATE_PROVISIONAL => "", // 仮(用語集未登録状態)
			self::T_EXTERM_STATE_DELETE      => "{$WORD($wk, 39)}",
			self::T_EXTERM_STATE_NORMAL      => "{$WORD($wk, 40)}",
			self::T_EXTERM_STATE_WAITNG      => "{$WORD($wk, 41)}",
			self::T_EXTERM_STATE_COMPLT      => "{$WORD($wk, 42)}",
			self::T_EXTERM_STATE_FAILED      => "{$WORD($wk, 43)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_EXTERM_STATE_VALID_TABLE(){
		$arrTable = self::T_EXTERM_STATE_TABLE();
		unset($arrTable[self::T_EXTERM_STATE_PROVISIONAL]);
		unset($arrTable[self::T_EXTERM_STATE_DELETE]);
		
		return $arrTable;
	}
	
	public static function T_LOG_LOOKUP_SELECT_MODE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_LOG_LOOKUP_SELECT_MODE_P  => "P",
			self::T_LOG_LOOKUP_SELECT_MODE_L  => "L",
			self::T_LOG_LOOKUP_SELECT_MODE_S  => "S",
			self::T_LOG_LOOKUP_SELECT_MODE_M  => "M",
			self::T_LOG_LOOKUP_SELECT_MODE_R  => "R",
			self::T_LOG_LOOKUP_SELECT_MODE_TM => "TM",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_PROJECT_STATE_TABLE( $key = NULL, $isExclusionDelete = FALSE ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_PROJECT_STATE_DELETE   => "{$WORD($wk, 44)}",
			self::T_PROJECT_STATE_NORMAL   => "{$WORD($wk, 45)}",
			self::T_PROJECT_STATE_COMPLETE => "{$WORD($wk, 46)}",
		);
		if ( $isExclusionDelete ){
			unset($arrTable[self::T_PROJECT_STATE_DELETE]);
		}
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_PROJECT_STATE_VALID_TABLE(){
		$arrTable = self::T_PROJECT_STATE_TABLE();
		unset($arrTable[self::T_PROJECT_STATE_DELETE]);
		
		return $arrTable;
	}
	
	public static function T_PROJECT_STATE_ALERT_TABLE( $key = NULL, $isExclusionDelete = FALSE ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_PROJECT_STATE_DELETE   => "alert-default",
			self::T_PROJECT_STATE_NORMAL   => "alert-danger",
			self::T_PROJECT_STATE_COMPLETE => "alert-info",
		);
		if ( $isExclusionDelete ){
			unset($arrTable[self::T_PROJECT_STATE_DELETE]);
		}
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_TASK_STATE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_TASK_STATE_NORMAL => "{$WORD($wk, 47)}",
			self::T_TASK_STATE_CARIED => "{$WORD($wk, 48)}",
			self::T_TASK_STATE_FINISH => "{$WORD($wk, 49)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_TASK_STATE_ICON_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_TASK_STATE_NORMAL => "icon-stop",
			self::T_TASK_STATE_CARIED => "icon-play",
			self::T_TASK_STATE_FINISH => "icon-ok",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_TASK_STATE_ALERT_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_TASK_STATE_NORMAL => "alert-success",
			self::T_TASK_STATE_CARIED => "alert-danger",
			self::T_TASK_STATE_FINISH => "alert-info",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_TASK_STATE_ATTR_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_TASK_STATE_NORMAL => "normal",
			self::T_TASK_STATE_CARIED => "caried",
			self::T_TASK_STATE_FINISH => "finish",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_TERM_ROOT_TYPE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_TERM_ROOT_TYPE_NORMAL    => "{$WORD($wk, 50)}",
			self::T_TERM_ROOT_TYPE_REFERENCE => "{$WORD($wk, 51)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_TERM_ROOT_STATE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_TERM_ROOT_STATE_DELETE => "{$WORD($wk, 52)}",
			self::T_TERM_ROOT_STATE_NORMAL => "{$WORD($wk, 53)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
		global $WORD;
	}
	
	public static function T_TERM_ROOT_STATE_VALID_TABLE(){
		$arrTable = self::T_TERM_ROOT_STATE_TABLE();
		unset($arrTable[self::T_TERM_ROOT_STATE_DELETE]);
		
		return $arrTable;
	}
	
	public static function T_TERM_ROOT_PUBLIC_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_TERM_ROOT_PUBLIC_PRJ => "{$WORD($wk, 54)}",
			self::T_TERM_ROOT_PUBLIC_ORG => "{$WORD($wk, 55)}",
			self::T_TERM_ROOT_PUBLIC_OPN => "{$WORD($wk, 56)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_STATE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_USER_STATE_ACTIVE => "{$WORD($wk, 57)}",
			self::T_USER_STATE_QUIT   => "{$WORD($wk, 58)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_STATE_ALERT_TABLE( $key = NULL ){
		$arrTable = array(
			self::T_USER_STATE_ACTIVE => "alert-danger",
			self::T_USER_STATE_QUIT   => "alert-info",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_TYPE_TABLE( $key = NULL, $isExclusionSysManager = FALSE ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_USER_TYPE_SYSMGR => "{$WORD($wk, 59)}",
			self::T_USER_TYPE_ORGMGR => "{$WORD($wk, 60)}",
			self::T_USER_TYPE_INSTTR => "{$WORD($wk, 61)}",
			self::T_USER_TYPE_NORMAL => "{$WORD($wk, 62)}",
		);
		if ( $isExclusionSysManager ){
			unset($arrTable[self::T_USER_TYPE_SYSMGR]);
		}
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_TYPE_COLOR_TABLE( $key = NULL, $isExclusionSysManager = FALSE ){
		$arrTable = array(
			self::T_USER_TYPE_SYSMGR => "#D9534F",
			self::T_USER_TYPE_ORGMGR => "#F0AD4E",
			self::T_USER_TYPE_INSTTR => "#5CB85C",
			self::T_USER_TYPE_NORMAL => "#444444",
		);
		if ( $isExclusionSysManager ){
			unset($arrTable[self::T_USER_TYPE_SYSMGR]);
		}
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_LOGIN_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_USER_LOGIN_OK => "{$WORD($wk, 63)}",
			self::T_USER_LOGIN_NG => "{$WORD($wk, 64)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_WARN_NON_ACTIVE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_USER_WARN_NON_ACTIVE_NONE => "{$WORD($wk, 65)}",
			self::T_USER_WARN_NON_ACTIVE_HIDE => "{$WORD($wk, 66)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_WARN_NON_ACTIVE_ALERT_TABLE( $key = NULL ){
		$arrTable = array(
			self::T_USER_WARN_NON_ACTIVE_NONE => "alert-danger",
			self::T_USER_WARN_NON_ACTIVE_HIDE => "alert-info",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_QREDIT_DISPLAY_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_USER_QREDIT_DISPLAY_L => "{$WORD($wk, 67)}",  // QRedit:原文の位置(左)
			self::T_USER_QREDIT_DISPLAY_R => "{$WORD($wk, 68)}",  // QRedit:原文の位置(右)
			self::T_USER_QREDIT_DISPLAY_U => "{$WORD($wk, 69)}",  // QRedit:原文の位置(上)
			self::T_USER_QREDIT_DISPLAY_D => "{$WORD($wk, 70)}",  // QRedit:原文の位置(下)
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_QREDIT_WIDTH_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_USER_QREDIT_WIDTH_AUTO => "{$WORD($wk, 71)}",  // QRedit:原文の幅(AUTO)
		);
		
		for ( $w=self::T_USER_QREDIT_WIDTH_MIN; $w<=self::T_USER_QREDIT_WIDTH_MAX; $w+=self::T_USER_QREDIT_WIDTH_SPAN ){
			$arrTable[$w] = "{$w}px";
		}
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_QREDIT_SCROLL_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_USER_QREDIT_SCROLL_BOTH => "{$WORD($wk, 72)}",  // QRedit:同期スクロール(両方向)
			self::T_USER_QREDIT_SCROLL_NONE => "{$WORD($wk, 73)}",  // QRedit:同期スクロール(同期しない)
			self::T_USER_QREDIT_SCROLL_ORGN => "{$WORD($wk, 74)}",  // QRedit:同期スクロール(原文→翻訳文)
			self::T_USER_QREDIT_SCROLL_TRNS => "{$WORD($wk, 75)}",  // QRedit:同期スクロール(翻訳文→原文)
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_QREDIT_LOOKUP_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_USER_QREDIT_LOOKUP_M => "{$WORD($wk, 76)}",  // QRedit:訳語表示の位置(原文の中)
			self::T_USER_QREDIT_LOOKUP_L => "{$WORD($wk, 77)}",  // QRedit:訳語表示の位置(原文の左)
			self::T_USER_QREDIT_LOOKUP_R => "{$WORD($wk, 78)}",  // QRedit:訳語表示の位置(原文の右)
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_QREDIT_ACTION_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_USER_QREDIT_ACTION_P  => "{$WORD($wk, 79)}",  // QRedit:訳語表示のクリック(P)
			self::T_USER_QREDIT_ACTION_L  => "{$WORD($wk, 80)}",  // QRedit:訳語表示のクリック(L)
			self::T_USER_QREDIT_ACTION_S  => "{$WORD($wk, 81)}",  // QRedit:訳語表示のクリック(S)
			self::T_USER_QREDIT_ACTION_TM => "{$WORD($wk, 82)}",  // QRedit:訳語表示のクリック(TM)
			self::T_USER_QREDIT_ACTION_M  => "{$WORD($wk, 83)}",  // QRedit:訳語表示のクリック(M)
			self::T_USER_QREDIT_ACTION_R  => "{$WORD($wk, 84)}",  // QRedit:訳語表示のクリック(R)
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function T_USER_QREDIT_TAG_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_DAO";
		
		$arrTable = array(
			self::T_USER_QREDIT_TAG_N => "{$WORD($wk, 85)}",  // QRedit:タグ名の表示(非表示)
			self::T_USER_QREDIT_TAG_L => "{$WORD($wk, 86)}",  // QRedit:タグ名の表示(原文の左)
			self::T_USER_QREDIT_TAG_R => "{$WORD($wk, 87)}",  // QRedit:タグ名の表示(原文の右)
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	/***************************************************************
	 * 名前:instance
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function SQL_ORDER_BY( $field, $arr ){
		$sql = implode(", ", array_merge(array($field), $arr));
		$sql = "FIELD({$sql})";
		return $sql;
	}
	
	/***************************************************************
	 * 名前:instance
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function instance( $table, $classSuffix = NULL ){
		$file = sprintf("DAO_%s", $table);
		require_once("class/DAO/{$file}.php");
		
		$class = $file;
		if ( ! is_null($classSuffix) ){
			$class .= "_" . $classSuffix;
		}
		
		if ( ! isset(self::$arrInstance[$class]) ){
			self::$arrInstance[$class] = new $class("t_{$table}");
		}
		
		return self::$arrInstance[$class];
	}
	
	/***********************************
	 * 名前:connect
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	public static function connect(){
		mb_language("uni");
		mb_internal_encoding("utf-8");
		mb_http_input("auto");
		mb_http_output("utf-8");
		
		self::$db = mysqli_connect(Setting::get("DB_HOST"), Setting::get("DB_USER"), Setting::get("DB_PSWD"));
		mysqli_select_db(self::$db, Setting::get("DB_NAME"));
		
		mysqli_query(self::$db, "SET NAMES utf8;");
	}
	
	/***********************************
	 * 名前:begin
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	public static function begin(){
		// transaction begin
		if( ! mysqli_query(self::$db, "begin") ){
			Util::printLog(mysqli_error(self::$db));
		}
	}
	
	/***********************************
	 * 名前:end
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	public static function end( $result ){
		$query = ($result === RES_OK) ? "commit" : "rollback";
		
		if( ! mysqli_query(self::$db, $query) ){
			Util::printLog(mysqli_error(self::$db));
		}
	}
	
	/***********************************
	 * 名前:lock
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	public static function lock( $arrTable ){
		$arrSql = array();
		
		foreach ( $arrTable as $table => $type ){
			$arrSql[] = "{$table} {$type}";
		}
		
		if ( count($arrSql) === 0 ){
			return FALSE;
		}
		
		if( ! mysqli_query(self::$db, "lock tables " . implode(",", $arrSql)) ){
			Util::printLog(mysqli_error(self::$db));
		}
	}
	
	/***********************************
	 * 名前:unlock
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	public static function unlock(){
		if( ! mysqli_query(self::$db, "unlock tables") ){
			Util::printLog(mysqli_error(self::$db));
		}
	}
	
	/***********************************
	 * 名前:close
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	public static function close(){
		mysqli_close(self::$db);
	}
	
	/***********************************
	 * 名前:fetch
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	public static function fetch( $rs, &$result, &$arrRes ){
		$result = RES_OK;
		/*
		$arrType = array(
			"string"    => "string",
			"int"       => "int",
			"real"      => "float",
			"timestamp" => "string",
			"year"      => "int",
			"time"      => "string",
			"datetime"  => "string",
			"blob"      => "string",
		);
		*/
		$arrType = array(
			1   => "int",     // 'tinyint',
			2   => "int",     // 'smallint',
			3   => "int",     // 'int',
			4   => "float",   // 'float',
			5   => "float",   // 'double',
			7   => "string",  // 'timestamp',
			8   => "int",     // 'bigint',
			9   => "int",     // 'mediumint',
			10  => "string",  // 'date',
			11  => "string",  // 'time',
			12  => "string",  // 'datetime',
			13  => "int",     // 'year',
			16  => "string",  // 'bit',
			253 => "string",  // 'varchar',
			254 => "string",  // 'char',
			246 => "int",     // 'decimal'
		);
		
		$arrField = array();
		
		if ( mysqli_num_rows($rs) > 0 ){
			while ( $field = mysqli_fetch_field($rs) ){
				$arrField[$field->name] = $field->type;
			}
			
			while ( $row = mysqli_fetch_assoc($rs) ){
				foreach ( $row as $name => &$val ){
					$type = isset($arrField[$name]) ? $arrField[$name] : "string";
					$type = isset($arrType[$type])  ? $arrType[$type]  : "string";
					
					if ( ! is_null($val) ){
						if ( ! settype($val, $type) ){
							$result = RES_NG;
						}
					}
				}
				
				$arrRes[] = $row;
			}
		} else {
			$arrRes = array();
			$result = RES_NO_DATA;
		}
		
		return ($result === RES_OK || $result === RES_NO_DATA);
	}
	
	/***************************************************************
	 * 名前:storedFunction
	 * 説明:DB内で保持しているストアドファンクションを実行
	 * 引数:
	 * 返値:
	 * 備考:
	****************************************************************/
	public static function storedFunction( $functionName, $args ){
		$result = RES_OK;
		
		if ( is_array($args) ){
			$arg = implode(",", $args);
		} else {
			$arg = $args;
		}
		$sql = "SELECT {$functionName}({$arg}) as result;";
		
		$rs = mysqli_query(self::$db, $sql);
		if ( ! $rs ) { $result = RES_NG; Util::printLog(mysqli_error(self::$db).$sql); }
	
		if ( $result === RES_OK ){
			self::fetch($rs, $result, $resData);
		}
		if ( $result === RES_OK ){
			return $resData[0]["result"];
		}
		
		return NULL;
	}
	
//=================================================================================================
//     インスタンス変数
//=================================================================================================
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName ){
		$this->tableName = $_tableName;
	}

	/***********************************
	 * 名前:setAuth
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	public function setAuth( $auth ){
		$this->auth = $auth;
	}
	
	/***********************************
	 * 名前:esc
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	public function esc( $val ){
		return mysqli_real_escape_string(DAO::$db, $val);
	}
	
	/***********************************
	 * 名前:sqlTable
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	protected function sqlTable( $arrTable ){
		$res = "";
		$arrSql = array();
		$joinSql = "";
		
		$arrTable = is_array($arrTable) ? $arrTable : array($arrTable);
		
		foreach ( $arrTable as $table ){
			if ( is_array($table) ){
				$escTable  = $table["table"];
				$escColumn = $this->esc($table["column"]);
				$joinSql .= "{$table["type"]} JOIN {$escTable} ON ({$escColumn}) ";
			} else {
				$escTable = $this->esc($table);
				$arrSql[] = "{$escTable}";
			}
		}
		$res = implode(",", $arrSql)." ".$joinSql;
		
		return $res;
	}
	
	/***********************************
	 * 名前:sqlField
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	protected function sqlField( $arrField ){
		$res = "*";
		$arrSql = array();
		
		foreach ( $arrField as $field ){
			//$escField = $this->esc($field);
			$arrSql[] = $field;
		}
		$res = implode(",", $arrSql);
		
		return $res;
	}
	
	/***********************************
	 * 名前:sqlValue
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	protected function sqlValue( $arrValue ){
		$res    = "";
		$arrSql = array();
		
		foreach ( $arrValue as $key => $value ){
			$escKey = $this->esc($key);
			
			if ( $value === DAO::NULL ){
				$escValue = "NULL";
			} else if ( $value === DAO::NOW ){
				$escValue = "NOW()";
			} else {
				$escValue = "'" . $this->esc($value) . "'";
			}
			
			$arrSql[] = "{$escKey} = {$escValue}";
		}
		$sql = implode(",", $arrSql);
		
		return $sql;
	}
	
	/***********************************
	 * 名前:sqlWhere
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	protected function sqlWhere( $arrCondition = NULL ){
		$res    = "TRUE";
		$arrSql = array();
		$arrEscValue = array();
		
		if ( ! is_null($arrCondition) && count($arrCondition) > 0 ){
			foreach ( $arrCondition as $key => $condition ){
				$escKey = $this->esc($key);
				
				if ( is_array($condition) ){
					$type = $condition["type"];
					
					// SQLの場合
					if ( $type === DAO::TYPE_SQL ){
						$arrSql[] = "(".$condition["value"].")";
					}
					// NOTの場合
					else if ( $type === DAO::TYPE_NOT ){
						$arrSql[] = "{$escKey} != '" . $this->esc($condition["value"]) . "'";
					}
					// IN or NOT INの場合
					else if ( $type === DAO::TYPE_IN || $type === DAO::TYPE_NOT_IN ){
						foreach ( $condition["value"] as $value ){
							$arrEscValue[] = "'" . $this->esc($value) . "'";
						}
						if ( count($arrEscValue) > 0 ){
							if ( $type === DAO::TYPE_IN ){
								$arrSql[] = "{$escKey} IN (" . implode(",", $arrEscValue) . ")";
							} else {
								$arrSql[] = "{$escKey} NOT IN (" . implode(",", $arrEscValue) . ")";
							}
						}
					}
					// LIKEの場合
					else if ( $type === DAO::TYPE_LIKE ){
						$arrSql[] = "{$escKey} LIKE '%" . $this->esc($condition["value"]) . "%'";
					}
				} else {
					$arrSql[] = "{$escKey} = '" . $this->esc($condition) . "'";
				}
			}
			
			$res = implode(" AND ", $arrSql);
		}
		
		return $res;
	}
	
	/***********************************
	 * 名前:sqlGroup
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	protected function sqlGroup( $arrGroup = NULL ){
		$res    = "";
		$arrSql = array();
		
		if ( ! is_null($arrGroup) ){
			foreach ( $arrGroup as $group ){
				$arrSql[] = $this->esc($group);
			}
			$res = "GROUP BY " . implode(",", $arrSql);
		}
		
		return $res;
	}
	
	/***********************************
	 * 名前:sqlHaving
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	protected function sqlHaving( $arrHaving = NULL ){
		$res    = "";
		$arrSql = array();
		
		if ( ! is_null($arrHaving) ){
			foreach ( $arrHaving as $having ){
				$arrSql[] = $this->esc($having);
			}
			$res = "HAVING " . implode(" AND ", $arrSql);
		}
		
		return $res;
	}
	
	/***********************************
	 * 名前:sqlOrder
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	protected function sqlOrder( $arrOrder = NULL ){
		$res    = "";
		$arrSql = array();
		
		if ( is_array($arrOrder) && count($arrOrder) > 0 ){
			foreach ( $arrOrder as $key => $order ){
				if ( $order === DAO::TYPE_SQL ){
					$arrSql[] = $key;
				} else {
					$arrSql[] = $this->esc($key) . " " . $this->esc($order);
				}
			}
			$res = "ORDER BY " . implode(",", $arrSql);
		}
		
		return $res;
	}
	
	/***********************************
	 * 名前:sqlLimitOffset
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	protected function sqlLimitOffset( $limit = NULL, $offset = NULL ){
		$res = "";
		
		if ( is_null($limit) ){
			// 何もしない
		} else {
			$escLimit  = $this->esc($limit);
			
			if ( is_null($offset) ){
				$res = "LIMIT {$escLimit}";
			} else {
				$escOffset = $this->esc($offset);
				$res = "LIMIT {$escLimit} OFFSET {$escOffset}";
			}
		}
		
		return $res;
	}
	
	/***********************************
	 * 名前:count
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	protected function count(){
		$res  = 0;
		$result = RES_OK;
		
		$sql = " SELECT FOUND_ROWS() AS count;";
		$rs = mysqli_query(DAO::$db, $sql);
		if ( ! $rs ) { $result = RES_NG; Util::printLog(mysqli_error(DAO::$db).$sql); }
		
		if ( $result === RES_OK ){
			$row = mysqli_fetch_assoc($rs);
			$res = (int)$row["count"];
		}
		
		return $res;
	}
	
	/***********************************
	 * 名前:getValueUpdate
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	protected function getValueUpdate( $arr ){
		$arrValue = array();
		if ( is_array($arr) && count($arr) > 0 ){
			foreach ( $arr as $field => $value ){
				if ( ! is_null($value) ){
					$arrValue[$field] = $value;
				}
			}
		}
		
		return $arrValue;
	}
	
	/***********************************
	 * 名前:getCondition
	 * 説明:
	 * 引数:
	 * 返値:
	************************************/
	protected function getCondition( $arr ){
		$args = func_get_args();
		if ( count($args) > 1 ){
			// 複数渡された状態では、前にある配列ほど優先度が高いものとする
			// (array_mergeで結合すると 後ろの配列のほうが優先度が高くなる)
			$arr = array();
			foreach ( $args as $arg ){
				if ( is_array($arg) ){
					$arr += $arg;
				}
			}
		}
		
		$arrCondition = array();
		if ( is_array($arr) && count($arr) > 0){
			foreach ( $arr as $field => $value ){
				if ( is_array($value) && (! isset($value["type"])) ){
					if ( count($value) > 0 ){
						$arrCondition[$field] = array("type" => DAO::TYPE_IN, "value" => $value);
					}
				} else if ( ! is_null($value) ){
					$arrCondition[$field] = $value;
				}
			}
		}
		
		return $arrCondition;
	}
	
	/***********************************
	 * 名前:getOrderBy
	 * 説明:
	 * 引数: $arr [ $arr2, $arr3 ... ]
	 * 返値:
	************************************/
	protected function getOrderBy( $arr ){
		$args = func_get_args();
		if ( count($args) > 1 ){
			// 複数渡された状態では、前にある配列ほど優先度が高いものとする
			// (array_mergeで結合すると 後ろの配列のほうが優先度が高くなる)
			$arr = array();
			foreach ( $args as $arg ){
				if ( is_array($arg) ){
					$arr += $arg;
				}
			}
		}
		
		$arrOrderBy = array();
		if ( is_array($arr) && count($arr) > 0 ){
			foreach ( $arr as $field => $value ){
				if ( is_array($value) ){
					if ( count($value) === 1 ){
						$arrOrderBy[$field] = reset($value);
					} else {
						// 指定された順番に並び替える
						$ascOrder = $descOrder = $value;
						sort($ascOrder);
						rsort($descOrder);
						if ( count(array_diff($value, $ascOrder)) ){
							$arrOrderBy[$field] = DAO::ASC;
						} else if ( count(array_diff($value, $descOrder)) ){
							$arrOrderBy[$field] = DAO::DESC;
						} else {
							$sql = "FIELD({$field}, ".implode(",", $value).")";
							$arrOrderBy[$sql] = DAO::TYPE_SQL;
						}
					}
				} else if ( ! is_null($value) ){
					$arrOrderBy[$field] = $value;
				}
			}
		}
		
		return $arrOrderBy;
	}
	
	/***************************************************************
	 * 名前:select
	 * 説明:
	 * 引数:
	 * 返値:
	 * 備考:
	****************************************************************/
	protected function _select( $arrField, $arrCondition = NULL, $arrGroup = NULL, $arrHaving = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL, $isCalcFoundRows = TRUE ){
		$res    = NULL;
		$result = RES_OK;
		$sql    = "";
		$count  = 0;
		
		if ( ! is_null($this->auth) ){
			$arrCondition = array_merge($arrCondition, $this->auth->getSqlCondition());
		}
		
		// 
		$sqlTable  = $this->sqlTable($this->tableName);
		$sqlField  = $this->sqlField($arrField);
		$sqlWhere  = $this->sqlWhere($arrCondition);
		$sqlGroup  = $this->sqlGroup($arrGroup);
		$sqlHaving = $this->sqlHaving($arrHaving);
		$sqlOrder  = $this->sqlOrder($arrOrder);
		$sqlLimitOffset = $this->sqlLimitOffset($limit, $offset);
		$sqlCalcFoundRows = $isCalcFoundRows ? "SQL_CALC_FOUND_ROWS" : "";
		
		if ( $result === RES_OK ){
			$sql  = " SELECT {$sqlCalcFoundRows} {$sqlField}";
			$sql .= " FROM {$sqlTable}";
			$sql .= " WHERE {$sqlWhere}";
			$sql .= " {$sqlGroup}";
			$sql .= " {$sqlHaving}";
			$sql .= " {$sqlOrder}";
			$sql .= " {$sqlLimitOffset};";
			
//echo "<textarea style=\"width:100%;height:70px;\">{$sql}</textarea>";
//echo $sql;
//Util::printLog($sql);
			
			$rs = mysqli_query(DAO::$db, $sql);
			if ( ! $rs ) { $result = RES_NG; Util::printLog(mysqli_error(DAO::$db).$sql); }
		}
		
		if ( $isCalcFoundRows ){
			if ( $result === RES_OK ){
				$count = $this->count();
			}
		}
		
		if ( $result === RES_OK ){
			DAO::fetch($rs, $result, $res["data"]);
		}
		
		$res["result"] = $result;
		$res["count"]  = $count;
		
		return $res;
	}
	
	public function select( $arrField, $arrCondition = NULL, $arrGroup = NULL, $arrHaving = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL, $isCalcFoundRows = TRUE ){
		return $this->_select($arrField, $arrCondition, $arrGroup, $arrHaving, $arrOrder, $limit, $offset, $isCalcFoundRows);
	}

	/***************************************************************
	 * 名前:insert
	 * 説明:
	 * 引数: isPrimaryID  挿入IDを取得するか?
	 * 返値:
	 * 備考:
	****************************************************************/
	protected function _insert( $arrValue, $isPrimaryID = FALSE, $isIgnore = FALSE ){
		$res            = NULL;
		$result         = RES_OK;
		$sql            = "";
		
		$sqlTable  = $this->tableName;
		$sqlValue  = $this->sqlValue($arrValue);
		$sqlIgnore = $isIgnore ? "IGNORE" : "";
		
		if ( $result === RES_OK ){
			$sql  = " INSERT {$sqlIgnore} INTO {$sqlTable}";
			$sql .= " SET {$sqlValue};";
			$rs = mysqli_query(DAO::$db, $sql);
			if ( ! $rs ) { $result = RES_NG; Util::printLog(mysqli_error(DAO::$db).$sql); }
		}
		
//echo $sql . "<br />";
		
		if ( $result === RES_OK && $isIgnore ){
			if ( mysqli_affected_rows(DAO::$db) === 0 ){
				$result = RES_NO_DATA;
				//Util::printLog($sql);
			}
		}
		
		if ( $result === RES_OK && $isPrimaryID ){
			$sql  = " SELECT LAST_INSERT_ID() AS id;";
			$rs = mysqli_query(DAO::$db, $sql);
			if ( ! $rs ) { $result = RES_NG; Util::printLog(mysqli_error(DAO::$db).$sql); }
			
			if ( $result === RES_OK ){
				if ( mysqli_num_rows($rs) > 0 ){
					while ( $row = mysqli_fetch_assoc($rs) ){
						$res["id"] = (int)$row["id"];
					}
				} else {
					$result = RES_NG;
				}
			}
		}
		
		$res["result"] = $result;
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:update
	 * 説明:
	 * 引数:
	 * 返値:
	 * 備考:
	****************************************************************/
	protected function _update( $arrValue, $arrCondition ){
		$res    = NULL;
		$result = RES_OK;
		$sql    = "";
		
		$sqlTable = $this->tableName;
		$sqlValue = $this->sqlValue($arrValue);
		$sqlWhere = $this->sqlWhere($arrCondition);
		
		if ( $result === RES_OK ){
			$sql  = " UPDATE {$sqlTable}";
			$sql .= " SET {$sqlValue}";
			$sql .= " WHERE {$sqlWhere};";
			$rs = mysqli_query(DAO::$db, $sql);
			if ( ! $rs ) { $result = RES_NG; Util::printLog(mysqli_error(DAO::$db).$sql); }
		}
		
		/*
		if ( $result === RES_OK ){
			if ( mysqli_affected_rows(DAO::$db) === 0 ){
				//$result = RES_NO_DATA;
//				Util::printLog($sql);
			}
		}
		*/
		
//Util::printLog($sql);
//echo $sql;
		
		$res["result"] = $result;
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:replace
	 * 説明:
	 * 引数:
	 * 返値:
	 * 備考:
	****************************************************************/
	protected function _replace( $arrValue ){
		$res    = NULL;
		$result = RES_OK;
		$sql    = "";
		
		$sqlTable = $this->tableName;
		$sqlValue = $this->sqlValue($arrValue);
		
		if ( $result === RES_OK ){
			$sql  = " REPLACE INTO {$sqlTable}";
			$sql .= " SET {$sqlValue};";
			$rs = mysqli_query(DAO::$db, $sql);
			if ( ! $rs ) { $result = RES_NG; Util::printLog(mysqli_error(DAO::$db).$sql); }
		}
		
		$res["result"] = $result;
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	 * 備考:
	****************************************************************/
	protected function _delete( $arrCondition, $arrOrder = NULL, $limit = NULL ){
		$res    = NULL;
		$result = RES_OK;
		$sql    = "";

		if ( ! is_array($arrCondition) || count($arrCondition) === 0 ){
			$res["result"] = RES_NG;
			return $res;
		}
		
		$sqlTable = $this->tableName;
		$sqlWhere = $this->sqlWhere($arrCondition);
		$sqlOrder  = $this->sqlOrder($arrOrder);
		$sqlLimit = $this->sqlLimitOffset($limit, NULL);
		
		if ( $result === RES_OK ){
			$sql  = " DELETE FROM {$sqlTable}";
			$sql .= " WHERE {$sqlWhere}";
			$sql .= " {$sqlOrder}";
			$sql .= " {$sqlLimit};";
			$rs = mysqli_query(DAO::$db, $sql);
			if ( ! $rs ) { $result = RES_NG; Util::printLog(mysqli_error(DAO::$db).$sql); }
		}
		
//Util::printLog($sql);
		
		$res["result"] = $result;
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:getPrimaryKey
	 * 説明:
	 * 引数:
	 * 返値:
	 * 備考:
	****************************************************************/
	protected function getPrimaryKey( $primaryKeyName, $arrCondition ){
		$arrField = array(
			$primaryKeyName,
		);
		$res = $this->_select($arrField, $arrCondition);
		
		$arrPrimaryKey = array();
		if ( $res["result"] === RES_OK ){
			foreach ( $res["data"] as $data ){
				$arrPrimaryKey[] = $data[$primaryKeyName];
			}
		}
		
		if ( $res["result"] !== RES_NG ){
			return $arrPrimaryKey;
		} else {
			return FALSE;
		}
	}
	
}
