<?php
Class DAO_bbs extends DAO {
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_bbs" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_bbs_name" => "",
			"t_bbs_text" => "",
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $bbsID = NULL, $projectID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_bbs_id",
			"t_bbs_name",
			"t_bbs_text",
			"t_project_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_id"     => $bbsID,
			"t_project_id" => $projectID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_bbs_id"    => DAO::DESC,
		));
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $bbsID, $name = NULL, $text = NULL, $projectID = NULL ){
		$res    = NULL;
		
		// 新規登録
		if ( $bbsID === INIT_ID ){
			// *フィールド
			$arrValue = array(
				"t_bbs_name"   => $name,
				"t_bbs_text"   => $text,
				"t_project_id" => $projectID,
			);
			// *実行
			$res = $this->_insert($arrValue, TRUE);
		}
		// 更新
		else {
			// *フィールド
			$arrValue = $this->getValueUpdate(array(
				"t_bbs_name" => $name,
				"t_bbs_text" => $text,
			));
			// *条件
			$arrCondition = $this->getCondition(array(
				"t_project_id" => $projectID,
			));
			// *実行
			$res = $this->_update($arrValue, $arrCondition);
			$res["id"] = $projectID;
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $bbsID, $projectID = NULL ){
		$res    = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_id"     => $bbsID,
			"t_project_id" => $projectID,
		));
		
		// *削除予定IDを取得
		if ( ($arrBbsID = $this->getPrimaryKey("t_bbs_id", $arrCondition)) === FALSE ){
			$res["result"] = RES_NG;
			return $res;
		} else if ( count($arrBbsID) === 0 ){
			$res["result"] = RES_OK;
			return $res;
		}
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		if ( $res["result"] === RES_OK ){
			//BbsPostの削除
			$objDAOBbsPost = DAO::instance("bbs_post");
			$res = $objDAOBbsPost->delete(NULL, $arrBbsID);
		}
		
		return $res;
	}

}
