<?php
Class DAO_bbs_post extends DAO {
	
	const ORDER_KEY_TITLE    = "title";
	const ORDER_KEY_STAGE    = "stage";
	const ORDER_KEY_TYPE     = "type";
	const ORDER_KEY_USER     = "user";
	const ORDER_KEY_REGISTER = "register";
	public static function ORDER_KEY_SQL_TABLE( $key = NULL ){
		$arrTable = array(
			self::ORDER_KEY_TITLE    => "t_bbs_post_title",
			self::ORDER_KEY_STAGE    => "t_bbs_post_stage",
			self::ORDER_KEY_TYPE     => "t_bbs_post_type",
			self::ORDER_KEY_USER     => "t_user_id",
			self::ORDER_KEY_REGISTER => "t_bbs_post_register",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_bbs_post" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_bbs_post_state"           => DAO::T_BBS_POST_STATE_NORMAL,
			"t_bbs_post_stage"           => DAO::T_BBS_POST_STAGE_OTHERS,
			"t_bbs_post_type"            => DAO::T_BBS_POST_TYPE_DIRQ,
			"t_bbs_post_role"            => Task::ROLE_INIT,
			"t_bbs_post_object"          => "",
			"t_bbs_post_title"           => "",
			"t_bbs_post_text"            => "",
			"t_bbs_post_document"        => "",
			"t_bbs_post_document_select" => "",
			"t_bbs_id"                   => DAO::ID_INIT,
			"t_user_id"                  => DAO::ID_INIT,
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $no = NULL, $bbsID = NULL, $parentNo = NULL, $state = NULL, $text = NULL, $date = NULL, $target = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL){
		// *フィールド
		$arrField = array(
			"t_bbs_post_no",
			"t_bbs_post_parent_no",
			"t_bbs_post_state",
			"t_bbs_post_kind",
			"t_bbs_post_stage",
			"t_bbs_post_type",
			"t_bbs_post_role",
			"t_bbs_post_object",
			"t_bbs_post_title",
			"t_bbs_post_text",
			"t_bbs_post_document",
			"t_bbs_post_document_select",
			"t_bbs_post_register",
			"t_bbs_id",
			"t_user_id",
			"get_user_type(t_user_id) AS t_user_type",
			"get_user_name(t_user_id) AS t_user_name",
			"get_project_id_by_bbs_id(t_bbs_id) AS t_project_id",
			"get_project_name_by_bbs_id(t_bbs_id) AS t_project_name",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_post_kind"      => DAO::T_BBS_POST_KIND_NORMAL,
			"t_bbs_post_no"        => $no,
			"t_bbs_post_parent_no" => $parentNo,
			"t_bbs_id"             => $bbsID,
			"t_bbs_post_state"     => $state,
		));
		if ( ! is_null($text) ){
			$escText = $this->esc($text);
			$arrCondition["t_bbs_post_text"] = array("type" => DAO::TYPE_SQL, "value" => "(t_bbs_post_title LIKE '%{$escText}%')");
			// 本文も検索する場合、掲示板一覧の検索結果に注意が必要(追記した本文が検索一致した時、取得できない)
			//$arrCondition["t_bbs_post_text"] = array("type" => DAO::TYPE_SQL, "value" => "(t_bbs_post_title LIKE '%{$escText}%') OR (t_bbs_post_text LIKE '%{$escText}%')");
		}
		if ( ! is_null($date) ){
			$escDate = $this->esc($date);
			$arrCondition["t_bbs_post_register"] = array("type" => DAO::TYPE_SQL, "value" => "t_bbs_post_register > '{$escDate}'");
		}
		if ( ! is_null($target) ){
			$escTargetUserID = $this->esc($target);
			$arrCondition["t_bbs_post_target"] = array("type" => DAO::TYPE_SQL, "value" => "is_bbs_post_target(t_bbs_id, t_bbs_post_no, {$escTargetUserID})");
		}
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_bbs_post_register" => DAO::DESC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
			
		if ( $res["result"] === RES_OK ){
			$objDAOBbsPostTarget = DAO::instance("bbs_post_target");
			
			foreach ( $res["data"] as &$data ){
				$data["t_bbs_post_target"] = array();
				
				$resDAOBbsPostTarget = $objDAOBbsPostTarget->get($data["t_bbs_post_no"], $data["t_bbs_id"]);
				if ( $resDAOBbsPostTarget["result"] === RES_OK ){
					foreach ( $resDAOBbsPostTarget["data"] as $dataBbsTextTarget ){
						$role     = $dataBbsTextTarget["t_bbs_post_target_role"];
						$userID   = $dataBbsTextTarget["t_user_id"];
						$userName = $dataBbsTextTarget["t_user_name"];
						$userType = $dataBbsTextTarget["t_user_type"];
						
						$data["t_bbs_post_target"][$userID]["name"] = $userName;
						$data["t_bbs_post_target"][$userID]["type"] = $userType;
						$data["t_bbs_post_target"][$userID]["role"][] = $role;
					}
				}
			}
		}
		
		if ( $res["result"] === RES_OK ){
			$objDAOBbsPost = DAO::instance("bbs_post");
			
			foreach ( $res["data"] as &$data ){
				$resDAOBbsPost = $objDAOBbsPost->getAdditionText(NULL, $data["t_bbs_id"], $data["t_bbs_post_no"], array_keys(DAO::T_BBS_POST_STATE_VALID_TABLE()));
				if ( $resDAOBbsPost["result"] === RES_OK ){
					$data["t_bbs_post_addition"] = $resDAOBbsPost["data"];
				} else {
					$data["t_bbs_post_addition"] = array();
				}
			}
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:getAdditionText
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getAdditionText( $no = NULL, $bbsID = NULL, $parentNo = NULL, $state = NULL, $limit = NULL, $offset = NULL ){
		// *フィールド
		$arrField = array(
			"t_bbs_post_no",
			"t_bbs_post_parent_no",
			"t_bbs_post_state",
			"t_bbs_post_kind",
			"t_bbs_post_text",
			"t_bbs_post_register",
			"t_bbs_id",
			"t_user_id",
			"get_user_type(t_user_id) AS t_user_type",
			"get_user_name(t_user_id) AS t_user_name",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_post_kind"      => DAO::T_BBS_POST_KIND_ADDITION,
			"t_bbs_post_no"        => $no,
			"t_bbs_post_parent_no" => $parentNo,
			"t_bbs_id"             => $bbsID,
			"t_bbs_post_state"     => $state,
		));
		// *並び順
		$arrOrder = array(
			"t_bbs_post_register" => DAO::ASC, // 追記テキストは投稿日時が古いものから順に表示
		);
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $parentNo = NULL, $stage = NULL, $type = NULL, $role = NULL, $object = NULL, $title = NULL, $text = NULL, $document = NULL, $documentSelect = NULL, $bbsID = NULL, $userID = NULL ){
		$res    = NULL;
		
		$no = DAO::storedFunction("get_max_bbs_post_no_by_bbs_id", $bbsID)+1;
		
		// *フィールド
		$arrValue = array(
			"t_bbs_post_no"        => $no,
			"t_bbs_post_parent_no" => $parentNo,
			"t_bbs_post_state"     => DAO::T_BBS_POST_STATE_NORMAL,
			"t_bbs_post_kind"      => DAO::T_BBS_POST_KIND_NORMAL,
			"t_bbs_post_text"      => $text,
			"t_bbs_post_register"  => DAO::NOW,
			"t_bbs_id"             => $bbsID,
			"t_user_id"            => $userID,
		);
		if ( ! is_null($stage) ){
			$arrValue["t_bbs_post_stage"] = $stage;
		}
		if ( ! is_null($type) ){
			$arrValue["t_bbs_post_type"] = $type;
		}
		if ( ! is_null($role) ){
			$arrValue["t_bbs_post_role"] = $role;
		}
		if ( ! is_null($object) ){
			$arrValue["t_bbs_post_object"] = $object;
		}
		if ( ! is_null($title) ){
			$arrValue["t_bbs_post_title"] = $title;
		}
		if ( ! is_null($document) ){
			$arrValue["t_bbs_post_document"] = $document;
		}
		if ( ! is_null($documentSelect) ){
			$arrValue["t_bbs_post_document_select"] = $documentSelect;
		}
		
		// *実行
		$res = $this->_insert($arrValue);
		$res["id"] = $no;
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:addition
	 * 説明:
	 * 引数:
	 * 返値:
	 ****************************************************************/
	function addition( $parentNo, $text, $bbsID, $userID){
		$res = NULL;
		
		$no = DAO::storedFunction("get_max_bbs_post_no_by_bbs_id", $bbsID)+1;
		
		$arrValue = array(
			"t_bbs_post_no"        => $no,
			"t_bbs_post_parent_no" => $parentNo,
			"t_bbs_post_state"     => DAO::T_BBS_POST_STATE_NORMAL,
			"t_bbs_post_kind"      => DAO::T_BBS_POST_KIND_ADDITION,
			"t_bbs_post_text"      => $text,
			"t_bbs_post_register"  => DAO::NOW,
			"t_bbs_id"             => $bbsID,
			"t_user_id"            => $userID,
		);
		
		$res = $this->_insert($arrValue);
		$res["id"] = $no;
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:hide
	 * 説明:
	 * 引数:
	 * 返値:
	 ****************************************************************/
	function hide( $no, $bbsID ){
		// *フィールド
		$arrValue = $this->getValueUpdate(array(
			"t_bbs_post_state" => DAO::T_BBS_POST_STATE_HIDE,
		));
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_post_no" => $no,
			"t_bbs_id"      => $bbsID,
		));
		// *実行
		$res = $this->_update($arrValue, $arrCondition);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:disabled
	 * 説明:
	 * 引数:
	 * 返値:
	 ****************************************************************/
	function disabled( $no, $bbsID ){
		// *フィールド
		$arrValue = $this->getValueUpdate(array(
			"t_bbs_post_state" => DAO::T_BBS_POST_STATE_DELETE,
		));
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_post_no" => $no,
			"t_bbs_id"      => $bbsID,
		));
		// *実行
		$res = $this->_update($arrValue, $arrCondition);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $no, $bbsID ){
		$res    = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_post_no" => $no,
			"t_bbs_id"      => $bbsID,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		if ( $res["result"] === RES_OK ){
			//BbsPostTermRootの削除
			$objDAOBbsPostTermRoot = DAO::instance("bbs_post_term_root", Term::KIND_TERM);
			$res = $objDAOBbsPostTermRoot->delete($no, $bbsID);
		}
		
		if ( $res["result"] === RES_OK ){
			//BbsPostBilingualRootの削除
			$objDAOBbsPostBilingualRoot = DAO::instance("bbs_post_term_root", Term::KIND_BILINGUAL);
			$res = $objDAOBbsPostBilingualRoot->delete($no, $bbsID);
		}
		
		if ( $res["result"] === RES_OK ){
			//BbsPostDataの削除
			$objDAOBbsPostData = DAO::instance("bbs_post_data");
			$res = $objDAOBbsPostData->delete($no, $bbsID);
		}
		
		if ( $res["result"] === RES_OK ){
			//BbsPostTargetの削除
			$objDAOBbsPostTarget = DAO::instance("bbs_post_target");
			$res = $objDAOBbsPostTarget->delete($no, $bbsID);
		}
		
		return $res;
	}
	
}
