<?php
Class DAO_bbs_post_data extends DAO {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_bbs_post_data" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_bbs_post_no" => DAO::ID_INIT,
			"t_bbs_id"      => DAO::ID_INIT,
			"t_data_id"     => DAO::ID_INIT,
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $postNo = NULL, $bbsID = NULL, $dataID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_bbs_post_no",
			"t_bbs_id",
			"t_data_id",
			"get_data_title(t_data_id) AS t_data_title",
		);
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_post_no" => $postNo,
			"t_bbs_id"      => $bbsID,
			"t_data_id"     => $dataID,
		));
		
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_bbs_id"      => DAO::DESC,
			"t_bbs_post_no" => DAO::DESC,
			"t_data_id"     => DAO::ASC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $postNo, $bbsID, $arrDataID ){
		$res    = NULL;
		
		// 新規登録
		if ( count($arrDataID) > 0 ){
			foreach ( $arrDataID as $dataID ){
				// *フィールド
				$arrValue = array(
					"t_bbs_post_no" => $postNo,
					"t_bbs_id"      => $bbsID,
					"t_data_id"     => $dataID,
				);
				// *実行
				$res = $this->_insert($arrValue, TRUE);
				if ( $res["result"] !== RES_OK ){
					break;
				}
			}
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $postNo, $bbsID, $dataID = NULL ){
		$res = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_post_no" => $postNo,
			"t_bbs_id"      => $bbsID,
			"t_data_id"     => $dataID,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
}
