<?php
Class DAO_bbs_post_target extends DAO {
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_bbs_post_target" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $bbsPostNo = NULL, $bbsID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_bbs_post_target_role",
			"t_user_id",
			"get_user_type(t_user_id) AS t_user_type",
			"get_user_name(t_user_id) AS t_user_name",
			"t_bbs_post_no",
			"t_bbs_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_post_no" => $bbsPostNo,
			"t_bbs_id"      => $bbsID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_bbs_id"               => DAO::DESC,
			"t_bbs_post_no"          => DAO::DESC,
			"t_user_type"            => DAO::DESC,
			"t_user_id"              => DAO::ASC,
			"t_bbs_post_target_role" => DAO::ASC,
		));
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $bbsPostNo, $bbsID, $arrData ){
		$res    = NULL;
		
		// 一度削除する
		$res = $this->delete($bbsPostNo, $bbsID);
		
		// 新規登録
		if ( $res["result"] === RES_OK ){
			foreach ( $arrData as $data ){
				list($userID, $role) = explode("_", $data);
				
				// *フィールド
				$arrValue = array(
					"t_bbs_post_target_role" => $role,
					"t_user_id"              => $userID,
					"t_bbs_post_no"          => $bbsPostNo,
					"t_bbs_id"               => $bbsID,
				);
				// *実行
				$res = $this->_insert($arrValue, TRUE);
				if ( $res["result"] !== RES_OK ){
					break;
				}
			}
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $bbsPostNo, $bbsID ){
		$res    = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_post_no" => $bbsPostNo,
			"t_bbs_id"      => $bbsID,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}

}
