<?php
Class DAO_bbs_post_term_root extends DAO {
	var $kind = NULL;
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_kind ){
		parent::__construct( "t_bbs_post_{$_kind}_root" );
		$this->kind= $_kind;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_bbs_post_no"  => DAO::ID_INIT,
			"t_bbs_id"       => DAO::ID_INIT,
			"t_term_root_id" => DAO::ID_INIT,
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $postNo = NULL, $bbsID = NULL, $termRootID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_bbs_post_no",
			"t_bbs_id",
			"t_{$this->kind}_root_id as t_term_root_id",
			"get_{$this->kind}_root_name(t_{$this->kind}_root_id) AS t_term_root_name",
		);
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_post_no"           => $postNo,
			"t_bbs_id"                => $bbsID,
			"t_{$this->kind}_root_id" => $termRootID,
		));
		
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_bbs_id"       => DAO::DESC,
			"t_bbs_post_no"  => DAO::DESC,
			"t_term_root_id" => DAO::ASC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $postNo, $bbsID, $arrTermRootID ){
		$res    = NULL;
		
		// 新規登録
		if ( count($arrTermRootID) > 0 ){
			foreach ( $arrTermRootID as $termRootID ){
				// *フィールド
				$arrValue = array(
					"t_bbs_post_no"           => $postNo,
					"t_bbs_id"                => $bbsID,
					"t_{$this->kind}_root_id" => $termRootID,
				);
				// *実行
				$res = $this->_insert($arrValue, TRUE);
				if ( $res["result"] !== RES_OK ){
					break;
				}
			}
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $postNo, $bbsID, $termRootID = NULL ){
		$res = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_bbs_post_no"           => $postNo,
			"t_bbs_id"                => $bbsID,
			"t_{$this->kind}_root_id" => $termRootID,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
}

Class DAO_bbs_post_term_root_term extends DAO_bbs_post_term_root {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_dummy ){
		parent::__construct(Term::KIND_TERM);
	}
}

Class DAO_bbs_post_term_root_bilingual extends DAO_bbs_post_term_root {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_dummy ){
		parent::__construct(Term::KIND_BILINGUAL);
	}
}
