<?php
Class DAO_document_text extends DAO {
	var $_multi = NULL;
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_document_text" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $documentID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_document_text_id",
			"t_document_text_s",
			"t_document_text_t",
			"t_document_id",
			"get_document_title(t_document_id) as t_document_title",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_document_id" => $documentID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_document_id"      => DAO::DESC,
			"t_document_text_id" => DAO::ASC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:getTextSearch
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getTextSearch( $documentID, $text, $limit = NULL, $offset = NULL ){
		$res = NULL;
		
		// *フィールド
		$arrField = array(
			"t_document_text_id",
			"t_document_text_s",
			"t_document_text_t",
			"t_document_id",
			"get_document_title(t_document_id) as t_document_title",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_document_id" => $documentID,
		));
		if ( Validate::isString($text) ){
			$escText = $this->esc($text);
			$arrCondition["t_document_text"] = array(
				"type"  => DAO::TYPE_SQL,
				"value" => "(t_document_text_s LIKE '%{$escText}%') OR (t_document_text_t LIKE '%{$escText}%')",
			);
		}
		// *並び順
		$arrOrder = array(
			"t_document_id"      => DAO::DESC,
			"t_document_text_id" => DAO::ASC,
		);
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $documentTextID, $textS, $textT, $documentID ){
		$res    = NULL;
		
		// 新規登録のみ許可する
		if ( $documentID === INIT_ID ){
			// *フィールド
			$arrValue = array(
				"t_document_text_s" => $textS,
				"t_document_text_t" => $textT,
				"t_document_id"     => $documentID,
			);
			// *実行
			$res = $this->_insert($arrValue, TRUE, TRUE);
			$result = $res["result"];
		}
		// 更新
		else {
			
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:registerMulti
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function registerMulti( $arrText, $documentID ){
		$res    = NULL;
		$result = RES_OK;
		
		if ( count($arrText) === 0 ){
			$result = RES_NO_DATA;
		}
		
		$hArrText = array();
		if ( $result === RES_OK ){
			foreach ( $arrText as $sentence ){
				$textS = isset($sentence["source"]) ? $sentence["source"] : $sentence[0];
				$textT = isset($sentence["target"]) ? $sentence["target"] : $sentence[1];
				$docID = isset($sentence["document_id"]) ? $sentence["document_id"] : $documentID;
				$escTextS = $this->esc($textS);
				$escTextT = $this->esc($textT);
				$escDocID = $this->esc($docID);
				$hArrText[] = "('{$escTextS}', '{$escTextT}', {$escDocID})";
			}
		}
		
		// 追加
		if ( $result === RES_OK ){
			$sqlTable = $this->tableName;
			$sqlValue = implode(",", $hArrText);
			
			$sql  = " INSERT INTO {$sqlTable}";
			$sql .= " ( t_document_text_s, t_document_text_t, t_document_id )";
			$sql .= " VALUES {$sqlValue};";
			$rs = mysqli_query(DAO::$db, $sql);
			if ( ! $rs ) { $result = RES_NG; Util::printLog(mysqli_error(DAO::$db).$sql); }
		}
		
		// 追加数確認
		if ( $result === RES_OK ){
			if ( ($count = mysqli_affected_rows(DAO::$db)) === 0 ){
				$result = RES_NO_DATA;
				//Util::printLog($sql);
			} else {
				$res["count"] = $count;
			}
		}
		
		$res["result"] = $result;
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:registerMulti
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function registerMultiStart(){
		$this->_multi = array();
	}
	
	function registerMultiPush( $textS, $textT, $documentID ){
		$this->_multi[] = array(
			"source" => $textS,
			"target" => $textT,
			"document_id" => $documentID,
		);
	}
	
	function registerMultiEnd(){
		return $this->registerMulti( $this->_multi, NULL );
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $documentTextID, $documentID = NULL ){
		$res    = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_document_text_id" => $documentTextID,
			"t_document_id"      => $documentID,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:outputTsv
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function outputTsv( $outputFile, $documentID ){
		// *フィールド
		$arrField = array(
			"t_document_text_s",
			"t_document_text_t",
		);
		// *条件
		$arrCondition = array(
			"t_document_id" => $documentID,
		);
		// *実行
		$offset = 0;
		$limit = 1000;
		$tsv = array();
		do {
			$res = $this->select($arrField, $arrCondition, NULL, NULL, NULL, $limit, $offset);
			if ( $res["result"] === RES_OK ){
				foreach ( $res["data"] as $data ){
					$sText = trim($data["t_document_text_s"]);
					$tText = trim($data["t_document_text_t"]);
					
					if ( $sText === "" || $tText === "" ){
						continue;
					}
					$tsv[] = "{$sText}\t{$tText}";
				}
			} else if ( $res["result"] === RES_NG ){
				return RES_NG;
			} else {
				break;
			}
			$offset += $limit;
		} while ( $res["count"] > $offset );
		
		if ( count($tsv) > 0 ){
			$text = mb_convert_encoding(implode("\n", $tsv)."\n", "UTF-8");
			file_put_contents($outputFile, $text);
			return RES_OK;
		} else {
			// データが空
			if ( file_exists($outputFile) ){
				unlink($outputFile);
			}
			return RES_NO_DATA;
		}
	}
}

