<?php
Class DAO_exterm extends DAO {
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_exterm" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_exterm_id"       => DAO::ID_INIT,
			"t_exterm_state"    => DAO::T_EXTERM_STATE_NORMAL,
			"t_exterm_title"    => "",
			"t_exterm_lang_s"   => "",
			"t_exterm_lang_t"   => "",
			"t_exterm_register" => NULL,
			"t_exterm_update"   => NULL,
			"t_user_id"         => DAO::ID_INIT,
			"t_project_id"      => DAO::ID_INIT,
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $id = NULL, $state = NULL, $completeTermRootID = NULL, $projectID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_exterm_id",
			"t_exterm_state",
			"t_exterm_title",
			"t_exterm_lang_s",
			"t_exterm_lang_t",
			"t_exterm_complete_term_root_id",
			"get_term_root_name(t_exterm_complete_term_root_id) as t_exterm_complete_term_root_name",
			"t_exterm_register",
			"t_exterm_update",
			"t_user_id",
			"get_user_name(t_user_id) AS t_user_name",
			"t_project_id",
			"get_project_name(t_project_id) AS t_project_name",
			//"get_project_organization_id(t_project_id) AS t_organization_id",
			//"get_organization_name(get_project_organization_id(t_project_id)) AS t_organization_name",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_exterm_id"    => $id,
			"t_exterm_state" => $state,
			"t_project_id"   => $projectID,
			"t_exterm_complete_term_root_id" => $completeTermRootID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_exterm_update"   => DAO::DESC,
			"t_exterm_register" => DAO::DESC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $id, $state = NULL, $title = NULL, $langS = NULL, $langT = NULL, $completeTermRootID = NULL, $projectID = NULL, $userID = NULL ){
		$res    = NULL;
		
		// 新規登録
		if ( $id === INIT_ID ){
			// *フィールド
			$arrValue = array(
				"t_exterm_state"                 => $state,
				"t_exterm_title"                 => $title,
				"t_exterm_lang_s"                => $langS,
				"t_exterm_lang_t"                => $langT,
				"t_exterm_complete_term_root_id" => $completeTermRootID,
				"t_exterm_register"              => DAO::NOW,
				"t_exterm_update"                => DAO::NOW,
				"t_user_id"                      => $userID,
				"t_project_id"                   => $projectID,
			);
			// *実行
			$res = $this->_insert($arrValue, TRUE);
		// 更新
		} else {
			// *フィールド
			$arrValue = $this->getValueUpdate(array(
				"t_exterm_update"                => DAO::NOW,
				"t_exterm_state"                 => $state,
				"t_exterm_title"                 => $title,
				"t_exterm_lang_s"                => $langS,
				"t_exterm_lang_t"                => $langT,
				"t_exterm_complete_term_root_id" => $completeTermRootID,
			));
			// *条件
			$arrCondition = $this->getCondition(array(
				"t_exterm_id" => $id,
			));
			// *実行
			$res = $this->_update($arrValue, $arrCondition);
			$res["id"] = $id;
		}
			
		return $res;
	}
	
	/***************************************************************
	 * 名前:disabled
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function disabled( $id ){
		$res = $this->register($id, DAO::T_EXTERM_STATE_DELETE);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $id ){
		$res    = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_exterm_id" => $id,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
}

