<?php
Class DAO_log_lookup extends DAO {
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_log_lookup" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $userID = NULL, $projectID = NULL, $taskID = NULL, $taskType = NULL, $taskRole = NULL, $documentID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_log_lookup_date",
			"t_log_lookup_no",
			"t_log_lookup_lang_s",
			"t_log_lookup_lang_t",
			"t_log_lookup_index",
			"t_log_lookup_text",
			"t_log_lookup_pos",
			"t_log_lookup_dict_id",
			"t_log_lookup_dict_ids",
			"t_log_lookup_awareness",
			"t_user_id",
			"t_project_id",
			"t_task_id",
			"t_task_type",
			"t_task_role",
			"t_document_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_user_id"     => $userID,
			"t_project_id"  => $projectID,
			"t_task_id"     => $taskID,
			"t_task_type"   => $taskType,
			"t_task_role"   => $taskRole,
			"t_document_id" => $documentID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_log_lookup_date" => DAO::DESC,
		));
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $no, $langS, $langT, $index, $text, $pos, $dictID, $dictIDs, $awareness, $userID, $projectID, $taskID, $taskType, $taskRole, $documentID ){
		$res    = NULL;
		
		// 新規登録
		$arrValue = array(
			"t_log_lookup_date"      => DAO::NOW,
			"t_log_lookup_no"        => $no,
			"t_log_lookup_lang_s"    => $langS,
			"t_log_lookup_lang_t"    => $langT,
			"t_log_lookup_index"     => $index,
			"t_log_lookup_text"      => $text,
			"t_log_lookup_pos"       => $pos,
			"t_log_lookup_dict_id"   => $dictID,
			"t_log_lookup_dict_ids"  => $dictIDs,
			"t_log_lookup_awareness" => $awareness,
			"t_user_id"              => $userID,
			"t_project_id"           => $projectID,
			"t_task_id"              => $taskID,
			"t_task_type"            => $taskType,
			"t_task_role"            => $taskRole,
			"t_document_id"          => $documentID,
		);
		// *実行
		$res = $this->_insert($arrValue);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:deleteProjectLink
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function deleteProjectLink( $projectID ){
		$res = NULL;
		
		// *フィールド
		$arrValue = $this->getValueUpdate(array(
			"t_project_id" => 0,
		));
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_project_id" => $projectID,
		));
		// *実行
		$res = $this->_update($arrValue, $arrCondition);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:deleteTaskLink
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function deleteTaskLink( $taskID ){
		$res = NULL;
		
		// *フィールド
		$arrValue = $this->getValueUpdate(array(
			"t_task_id" => 0,
		));
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_task_id" => $taskID,
		));
		// *実行
		$res = $this->_update($arrValue, $arrCondition);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:deleteDocumentLink
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function deleteDocumentLink( $documentID ){
		$res = NULL;
		
		// *フィールド
		$arrValue = $this->getValueUpdate(array(
			"t_document_id" => 0,
		));
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_document_id" => $documentID,
		));
		// *実行
		$res = $this->_update($arrValue, $arrCondition);
		
		return $res;
	}
	
}
