<?php
Class DAO_log_lookup_select extends DAO {
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_log_lookup_select" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $userID = NULL, $projectID = NULL, $taskID = NULL, $taskType = NULL, $taskRole = NULL, $documentID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res = NULL;
		
		// *フィールド
		$arrField = array(
			"t_log_lookup_select_date",
			"t_log_lookup_select_mode",
			"t_log_lookup_select_no",
			"t_log_lookup_select_lang_s",
			"t_log_lookup_select_lang_t",
			"t_log_lookup_select_text_s",
			"t_log_lookup_select_text_t",
			"t_log_lookup_select_heading",
			"t_log_lookup_select_kind",
			"t_log_lookup_select_search_lang_s",
			"t_log_lookup_select_search_lang_t",
			"t_user_id",
			"t_project_id",
			"t_task_id",
			"t_task_type",
			"t_task_role",
			"t_document_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_user_id"     => $userID,
			"t_project_id"  => $projectID,
			"t_task_id"     => $taskID,
			"t_task_type"   => $taskType,
			"t_task_role"   => $taskType,
			"t_document_id" => $documentID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_log_lookup_select_date" => DAO::DESC,
		));
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $mode, $no, $langS, $langT, $textS, $textT, $heading, $kind, $searchLangS, $searchLangT, $userID, $projectID, $taskID, $taskType, $taskRole, $documentID ){
		$res    = NULL;
		
		// 新規登録
		$arrValue = array(
			"t_log_lookup_select_date"          => DAO::NOW,
			"t_log_lookup_select_mode"          => $mode,
			"t_log_lookup_select_no"            => $no,
			"t_log_lookup_select_lang_s"        => $langS,
			"t_log_lookup_select_lang_t"        => $langT,
			"t_log_lookup_select_text_s"        => $textS,
			"t_log_lookup_select_text_t"        => $textT,
			"t_log_lookup_select_heading"       => $heading,
			"t_log_lookup_select_kind"          => $kind,
			"t_log_lookup_select_search_lang_s" => $searchLangS,
			"t_log_lookup_select_search_lang_t" => $searchLangT,
			"t_user_id"                         => $userID,
			"t_project_id"                      => $projectID,
			"t_task_id"                         => $taskID,
			"t_task_type"                       => $taskType,
			"t_task_role"                       => $taskRole,
			"t_document_id"                     => $documentID,
		);
		// *実行
		$res = $this->_insert($arrValue);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:deleteProjectLink
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function deleteProjectLink( $projectID ){
		$res = NULL;
		
		// *フィールド
		$arrValue = $this->getValueUpdate(array(
			"t_project_id" => 0,
		));
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_project_id" => $projectID,
		));
		// *実行
		$res = $this->_update($arrValue, $arrCondition);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:deleteTaskLink
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function deleteTaskLink( $taskID ){
		$res = NULL;
		
		// *フィールド
		$arrValue = $this->getValueUpdate(array(
			"t_task_id" => 0,
		));
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_task_id" => $taskID,
		));
		// *実行
		$res = $this->_update($arrValue, $arrCondition);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:deleteDocumentLink
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function deleteDocumentLink( $documentID ){
		$res = NULL;
		
		// *フィールド
		$arrValue = $this->getValueUpdate(array(
			"t_document_id" => 0,
		));
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_document_id" => $documentID,
		));
		// *実行
		$res = $this->_update($arrValue, $arrCondition);
		
		return $res;
	}
	
}
