<?php
Class DAO_log_task extends DAO {
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_log_task" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $userID = NULL, $orgID = NULL, $projectID = NULL, $taskID = NULL, $taskState = NULL, $date = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_log_task_date",
			"t_log_task_state",
			"t_user_id",
			"t_project_id",
			"t_task_id",
			"get_task_type(t_task_id) as t_task_type",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_user_id"         => $userID,
			"t_organization_id" => $orgID,
			"t_project_id"      => $projectID,
			"t_task_id"         => $taskID,
			"t_task_state"      => $taskState,
		));
		if ( ! is_null($date) ){
			$escDate = $this->esc($date);
			$arrCondition["t_log_task_date"] = array("type" => DAO::TYPE_SQL, "value" => "t_log_task_date >= '{$escDate}'");
		}
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_log_task_date" => DAO::DESC,
		));
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:getUserGroup
	 * 説明: t_user_idでグループ化したものを取得する
	 * 引数:
	 * 返値:
	****************************************************************/
	function getUserGroup( $orgID = NULL, $projectID = NULL, $taskID = NULL, $taskState = NULL, $date = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		$backTableName = $this->tableName;
		$this->tableName = array(
			"t_log_task T1",
			"(SELECT t_user_id as t2_user_id, MAX(t_log_task_date) as t2_log_task_date FROM t_log_task GROUP BY t_user_id) T2",
		);
		// *フィールド
		$arrField = array(
			"t_log_task_date",
			"t_log_task_state",
			"t_user_id",
			"t_project_id",
			"t_task_id",
			"get_task_type(t_task_id) as t_task_type",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_organization_id" => $orgID,
			"t_project_id"      => $projectID,
			"t_task_id"         => $taskID,
			"t_task_state"      => $taskState,
			// サブクエリ
			"subquery t_user_id"       => array("type" => DAO::TYPE_SQL, "value" => "t_user_id = t2_user_id"),
			"subquery t_log_task_date" => array("type" => DAO::TYPE_SQL, "value" => "t_log_task_date = t2_log_task_date"),
		));
		if ( ! is_null($date) ){
			$escDate = $this->esc($date);
			$arrCondition["t_log_task_date"] = array("type" => DAO::TYPE_SQL, "value" => "t_log_task_date >= '{$escDate}'");
		}
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_log_task_date" => DAO::DESC,
			"t_user_id"       => DAO::ASC,
		));
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		$this->tableName = $backTableName;
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $state, $userID, $organizationID, $projectID, $taskID ){
		$res    = NULL;
		
		// 新規登録
		$arrValue = array(
			"t_log_task_date"   => DAO::NOW,
			"t_log_task_state"  => $state,
			"t_user_id"         => $userID,
			"t_organization_id" => $organizationID,
			"t_project_id"      => $projectID,
			"t_task_id"         => $taskID,
		);
		// *実行
		$res = $this->_insert($arrValue);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $userID, $projectID, $taskID ){
		$res = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_user_id"    => $userID,
			"t_project_id" => $projectID,
			"t_task_id"    => $taskID,
		));
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
	
}
