<?php
Class DAO_login extends DAO {
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_login" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_login_state" => DAO::T_LOGIN_STATE_NONE,
			"t_login_date"  => "",
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:ログイン日時を降順に並び替える（新しいものが先頭）
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $userID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_login_state",
			"t_login_date",
			"t_user_id",
			"get_user_name(t_user_id) AS t_user_name",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_user_id" => $userID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_login_date" => DAO::DESC,
		));
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	
	/***************************************************************
	 * 名前:insert
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function insert( $userID, $state = NULL ){
		$res    = NULL;
		
		if ( is_null($state) ){
			$state = DAO::T_LOGIN_STATE_NONE;
		}
		
		// *フィールド
		$arrValue = array(
			"t_login_state" => $state,
			"t_login_date"  => date("Y/m/d H:i:s"),
			"t_user_id"     => $userID,
		);
		// *実行
		$res = $this->_insert($arrValue, TRUE);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $userID, $state = NULL, $date = NULL, $limit = NULL ){
		$res    = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_user_id"     => $userID,
			"t_login_state" => $state,
			"t_login_date"  => $date,
		));
		// 順番
		$arrOrder = array(
			"t_login_date" => DAO::DESC,
		);
			
		// *実行
		$res = $this->_delete($arrCondition, $arrOrder, $limit);
	}
}
