<?php
Class DAO_organization extends DAO {
	
	const ORDER_KEY_NAME = "name";
	const ORDER_KEY_REGISTER = "register";
	public static function ORDER_KEY_SQL_TABLE( $key = NULL ){
		$arrTable = array(
			self::ORDER_KEY_NAME  => "t_organization_name",
			self::ORDER_KEY_REGISTER => "t_organization_register",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_organization" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_organization_id"   => DAO::ID_INIT,
			"t_organization_name" => "",
			"t_mtauto_name"       => "",
			"t_mtauto_key"        => "",
			"t_mtauto_secret"     => "",
			"t_organization_text" => "",
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:getApiInfo
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getApiInfo( $organizationID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_organization_id",
			"t_mtauto_name",
			"t_mtauto_key",
			"t_mtauto_secret",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_organization_id"   => $organizationID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_organization_id" => DAO::ASC,
		));
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $organizationID = NULL, $organizationName = NULL, $onlyActiveUser = FALSE, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_organization_id",
			"t_organization_name",
			"t_mtauto_name",
			"t_mtauto_key",
			"t_mtauto_secret",
			"t_organization_text",
			"t_organization_register",
			"get_organization_user_count(t_organization_id) AS t_organization_user_count",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_organization_id"   => $organizationID,
			"t_organization_name" => $organizationName,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_organization_id" => DAO::ASC,
		));
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		if ( $res["result"] === RES_OK ){
			$objDAOUser    = DAO::instance("user");
			$objDAOProject = DAO::instance("project");
			
			$userState = $onlyActiveUser ? DAO::T_USER_STATE_ACTIVE : NULL;
			
			foreach ( $res["data"] as &$data ){
				$data["t_user_of_orgmgr"] = array();
				$data["t_user_of_insttr"] = array();
				$data["t_user_of_normal"] = array();
				$data["t_project_of_complete"] = array();
				$data["t_project_of_normal"]   = array();
				
				$org_id = $data["t_organization_id"];
				
				// 組織管理者
				$resDAOUser = $objDAOUser->get(NULL, NULL, $userState, DAO::T_USER_TYPE_ORGMGR, $org_id);
				if ( $resDAOUser["result"] === RES_OK ){
					foreach ( $resDAOUser["data"] as $dataUser ){
						$data["t_user_of_orgmgr"][] = $dataUser["t_user_name"];
					}
				}
				// インストラクター
				$resDAOUser = $objDAOUser->get(NULL, NULL, $userState, DAO::T_USER_TYPE_INSTTR, $org_id);
				if ( $resDAOUser["result"] === RES_OK ){
					foreach ( $resDAOUser["data"] as $dataUser ){
						$data["t_user_of_insttr"][] = $dataUser["t_user_name"];
					}
				}
				// 学習者
				$resDAOUser = $objDAOUser->get(NULL, NULL, $userState, DAO::T_USER_TYPE_NORMAL, $org_id);
				if ( $resDAOUser["result"] === RES_OK ){
					foreach ( $resDAOUser["data"] as $dataUser ){
						$data["t_user_of_normal"][] = $dataUser["t_user_name"];
					}
				}
				
				// 完了プロジェクト
				$resDAOProject = $objDAOProject->get(NULL, NULL, NULL, $org_id, DAO::T_PROJECT_STATE_COMPLETE);
				if ( $resDAOProject["result"] === RES_OK ){
					foreach ( $resDAOProject["data"] as $dataProject ){
						$data["t_project_of_complete"][] = $dataProject["t_project_name"];
					}
				}
				// 進行中プロジェクト
				$resDAOProject = $objDAOProject->get(NULL, NULL, NULL, $org_id, DAO::T_PROJECT_STATE_NORMAL);
				if ( $resDAOProject["result"] === RES_OK ){
					foreach ( $resDAOProject["data"] as $dataProject ){
						$data["t_project_of_normal"][] = $dataProject["t_project_name"];
					}
				}
			}
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $organizationID, $name, $api_name, $api_key, $api_secret, $text ){
		$res    = NULL;
		
		// 新規登録
		if ( $organizationID === INIT_ID ){
			// *フィールド
			$arrValue = array(
				"t_organization_name"     => $name,
				"t_mtauto_name"           => $api_name,
				"t_mtauto_key"            => $api_key,
				"t_mtauto_secret"         => $api_secret,
				"t_organization_text"     => $text,
				"t_organization_register" => DAO::NOW,
			);
			// *実行
			$res = $this->_insert($arrValue, TRUE);
		}
		// 更新
		else {
			// *フィールド
			$arrValue = $this->getValueUpdate(array(
				"t_organization_name" => $name,
				"t_mtauto_name"       => $api_name,
				"t_mtauto_key"        => $api_key,
				"t_mtauto_secret"     => $api_secret,
				"t_organization_text" => $text,
			));
			// *条件
			$arrCondition = $this->getCondition(array(
				"t_organization_id" => $organizationID,
			));
			// *実行
			$res = $this->_update($arrValue, $arrCondition);
			$res["id"] = $organizationID;
		}
		
		return $res;
	}
}
