<?php
Class DAO_project_data extends DAO {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_project_data" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_data_id"    => DAO::ID_INIT,
			"t_project_id" => DAO::ID_INIT,
			"t_user_id"    => DAO::ID_INIT,
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $projectID = NULL, $dataID = NULL, $userID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_data_id",
			"t_project_id",
			"t_user_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_data_id"    => $dataID,
			"t_project_id" => $projectID,
			"t_user_id"    => $userID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_project_id" => DAO::DESC,
			"t_data_id"    => DAO::ASC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $projectID, $dataID, $userID ){
		$res    = NULL;
		
		// *フィールド
		$arrValue = array(
			"t_data_id"    => $dataID,
			"t_project_id" => $projectID,
			"t_user_id"    => $userID,
		);
		// *実行
		$res = $this->_insert($arrValue, FALSE, TRUE);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $projectID, $dataID = NULL, $userID = NULL ){
		$res    = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_data_id"    => $dataID,
			"t_project_id" => $projectID,
			"t_user_id"    => $userID,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
}
