<?php
Class DAO_project_term_root extends DAO {
	var $kind = NULL;
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_kind ){
		parent::__construct( "t_project_{$_kind}_root" );

		$this->kind = $_kind;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_term_root_id"           => DAO::ID_INIT,
			"t_project_id"             => DAO::ID_INIT,
			"t_user_id"                => DAO::ID_INIT,
			"t_project_term_root_type" => DAO::T_TERM_ROOT_TYPE_NORMAL,
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $projectID = NULL, $termRootID = NULL, $userID = NULL, $type = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_{$this->kind}_root_id AS t_term_root_id",
			"t_project_id",
			"t_user_id",
			"t_project_{$this->kind}_root_type AS t_project_term_root_type",
			"get_project_organization_id(t_project_id) as t_organization_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_{$this->kind}_root_id"           => $termRootID,
			"t_project_id"                      => $projectID,
			"t_user_id"                         => $userID,
			"t_project_{$this->kind}_root_type" => $type,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_project_id" => DAO::DESC,
			"t_project_term_root_type" => DAO::ASC,
			"t_term_root_id" => DAO::ASC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $projectID, $termRootID, $userID, $type ){
		$res    = NULL;
		
		// *フィールド
		$arrValue = array(
			"t_{$this->kind}_root_id"           => $termRootID,
			"t_project_id"                      => $projectID,
			"t_user_id"                         => $userID,
			"t_project_{$this->kind}_root_type" => $type,
		);
		// *実行
		$res = $this->_insert($arrValue, FALSE, TRUE);
		
		// 変更
		if ( $res["result"] === RES_NO_DATA ){
			$res = $this->_replace( $arrValue );
		}
		
		return $res;
	}

	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $projectID, $termRootID = NULL, $userID = NULL, $type = NULL ){
		$res    = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_{$this->kind}_root_id"           => $termRootID,
			"t_project_id"                      => $projectID,
			"t_user_id"                         => $userID,
			"t_project_{$this->kind}_root_type" => $type,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
}

Class DAO_project_term_root_term extends DAO_project_term_root {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_dummy ){
		parent::__construct(Term::KIND_TERM);
	}
	
}

Class DAO_project_term_root_bilingual extends DAO_project_term_root {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_dummy ){
		parent::__construct(Term::KIND_BILINGUAL);
	}
	
}

Class DAO_project_term_root_fix extends DAO_project_term_root {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_dummy ){
		parent::__construct(Term::KIND_FIX);
	}
	
}
