<?php
Class DAO_project_user extends DAO {
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_project_user" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_project_id" => DAO::ID_INIT,
			"t_user_id"    => DAO::ID_INIT,
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $projectID, $userID = NULL, $role = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_project_user_role",
			"t_user_id",
			"get_user_type(t_user_id) AS t_user_type",
			"get_user_name(t_user_id) AS t_user_name",
			"get_organization_id_by_user_id(t_user_id) as t_organization_id",
			"get_organization_name(get_organization_id_by_user_id(t_user_id)) as t_organization_name",
			"t_project_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_project_user_role" => $role,
			"t_project_id"        => $projectID,
			"t_user_id"           => $userID,
		));
		
		$arrGroup = NULL;
		if ( is_null($projectID) ){
			$arrGroup[] = "t_project_id";
		}
		
		$arrCustomOrder = array();
		if ( is_null($userID) ){
			$arrCustomOrder["t_organization_id"] = DAO::ASC;
		}
		if ( is_null($projectID) ){
			$arrCustomOrder["get_project_start(t_project_id)"] = DAO::DESC;
			$arrCustomOrder["t_project_id"] = DAO::DESC;
		}
		if ( is_null($userID) ){
			$arrCustomOrder["t_user_type"] = DAO::DESC;
			$arrCustomOrder["t_user_name"] = DAO::ASC;
		}
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, $arrCustomOrder, array(
		));
			
		// *実行
		$res = $this->_select($arrField, $arrCondition, $arrGroup, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:arrUser
	 *        user_id => role
	 * 返値:
	****************************************************************/
	function register( $projectID, $arrUser = NULL ){
		$res    = NULL;
		
		if ( ! is_null($arrUser) ){
			foreach ( $arrUser as $userID => $arrRole ){
				foreach ( $arrRole as $role ){
					// *フィールド
					$arrValue = array(
						"t_project_user_role"  => $role,
						"t_user_id"            => $userID,
						"t_project_id"         => $projectID,
					);
					// *実行
					$res = $this->_insert($arrValue);
					if ( $res["result"] !== RES_OK ){
						break;
					}
				}
			}
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $projectID, $userID = NULL, $role = NULL ){
		$res = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_project_id"        => $projectID,
			"t_user_id"           => $userID,
			"t_project_user_role" => $role,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:update
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function update( $projectID, $arrUser ){
		$res    = NULL;
		$result = RES_OK;
		
		foreach ( $arrUser as $userID => $arrRole ){
			if ( ! is_array($arrRole) || count($arrRole) === 0 ){
				//不参加のユーザー
				$this->delete($projectID, $userID);
			} else {
				// ROLE_INITは役割なしで登録された場合。
				if ( ($key = array_search(Task::ROLE_INIT, $arrRole)) !== FALSE ){
					// 役割が複数送られてきた場合は、”役割なし”ではないので省く
					if ( count($arrRole) > 1 ){
						unset($arrRole[$key]);
					}
				}
				// 役割がない
				$arrNoRole = array_diff(array_keys(Task::ROLE_TABLE()), $arrRole);
				// 一度登録を解除した後、再度登録する
				$this->delete($projectID, $userID);
				// 登録
				$this->register($projectID, array($userID => $arrRole));
			}
		}
		
		$res["result"] = $result;
		
		return $res;
	}
}
