<?php
Class DAO_task_data extends DAO {
	var $kind = NULL;
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_kind = NULL ){
		parent::__construct( "t_task_data" );
		$this->kind= $_kind;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_task_id"     => DAO::ID_INIT,
			"t_data_id"     => DAO::ID_INIT,
			"t_task__props" => "",
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $taskID = NULL, $dataID = NULL, $workflowID = NULL, $state = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_task_id",
			"t_data_id",
			"t_task_props",
			"get_data_title(t_data_id) AS t_data_title",
		);
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_task_id"                             => $taskID,
			"t_data_id"                             => $dataID,
			"get_workflow_id_by_task_id(t_task_id)" => $workflowID,
			"(select t_data_state from t_data where t_data.t_data_id=t_task_data.t_data_id limit 1)" => $state,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_task_id"     => DAO::ASC,
			"t_data_id"   => DAO::ASC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:getSimpleTaskGroup
	 * 説明: t_task_idでグループ化したものを取得する
	 * 引数:
	 * 返値:
	****************************************************************/
	function getSimpleTaskGroup( $dataID, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_task_id",
			"t_task_props",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_data_id"   => $dataID,
		));
		// *グループ
		$arrGroup = array(
			"t_task_id"
		);
		// *グループ条件
		$arrHaving = NULL;
		if ( is_array($dataID) ){
			$arrHaving = array(
				"count(DISTINCT t_data_id) >= ".count($dataID),
			);
		}
		// *実行
		$res = $this->_select($arrField, $arrCondition, $arrGroup, $arrHaving, NULL, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $taskID, $taskProps, $arrDataID ){
		$res = NULL;
		
		if ( is_null($this->kind) ){
			$res["result"] = RES_NG;
			return $res;
		}
		if ( ! is_array($arrDataID) ){
			$arrDataID = array($arrDataID);
		}
		
		// 新規登録
		foreach ( $arrDataID as $dataID ){
			if ( ! is_numeric($dataID) ){
				$res["result"] = RES_OK;
				continue;
			}
			// *フィールド
			$arrValue = array(
				"t_task_id"    => $taskID,
				"t_task_props" => $taskProps,
				"t_data_id"    => $dataID,
			);
			// *実行
			$res = $this->_insert($arrValue, TRUE);
			if ( $res["result"] !== RES_OK ){
				break;
			}
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $taskID, $taskProps = NULL, $dataID = NULL ){
		$res = NULL;
		
		if ( is_null($this->kind) ){
			$res["result"] = RES_NG;
			return $res;
		}
		
		// *条件
		$arrCondition = $this->getCondition( array(
			"t_task_id"    => $taskID,
			"t_task_props" => $taskProps,
			"t_data_id"    => $dataID,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
}
