<?php
Class DAO_task_document extends DAO {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_kind = NULL ){
		parent::__construct( "t_task_document" );
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_task_id"     => DAO::ID_INIT,
			"t_document_id" => DAO::ID_INIT,
			"t_task_props"  => "",
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $taskID = NULL, $documentID = NULL, $workflowID = NULL, $state = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_task_id",
			"t_document_id",
			"t_task_props",
			"get_document_title(t_document_id) AS t_document_title",
		);
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_task_id"     => $taskID,
			"t_document_id" => $documentID,
			"get_workflow_id_by_task_id(t_task_id)" => $workflowID,
			"(select t_document_state from t_document where t_document.t_document_id=t_task_document.t_document_id limit 1)" => $state,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_task_id"     => DAO::ASC,
			"t_document_id" => DAO::ASC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:getSimpleTaskGroup
	 * 説明: t_task_idでグループ化したものを取得する
	 * 引数:
	 * 返値:
	****************************************************************/
	function getSimpleTaskGroup( $documentID, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_task_id",
			"t_task_props",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_document_id" => $documentID,
		));
		// *グループ
		$arrGroup = array(
			"t_task_id"
		);
		// *グループ条件
		$arrHaving = NULL;
		if ( is_array($documentID) ){
			$arrHaving = array(
				"count(DISTINCT t_document_id) >= ".count($documentID),
			);
		}
		// *実行
		$res = $this->_select($arrField, $arrCondition, $arrGroup, $arrHaving, NULL, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $taskID, $taskProps, $arrDocumentID ){
		$res = NULL;
		
		if ( ! is_array($arrDocumentID) ){
			$arrDocumentID = array($arrDocumentID);
		}
		
		// 新規登録
		foreach ( $arrDocumentID as $documentID ){
			if ( ! is_numeric($documentID) ){
				$res["result"] = RES_OK;
				continue;
			}
			// *フィールド
			$arrValue = array(
				"t_task_id"     => $taskID,
				"t_task_props"  => $taskProps,
				"t_document_id" => $documentID,
			);
			// *実行
			$res = $this->_insert($arrValue, TRUE);
			if ( $res["result"] !== RES_OK ){
				break;
			}
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $taskID, $taskProps = NULL, $documentID = NULL ){
		$res = NULL;
		
		// *条件
		$arrCondition = $this->getCondition( array(
			"t_task_id"     => $taskID,
			"t_task_props"  => $taskProps,
			"t_document_id" => $documentID,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
}
