<?php
Class DAO_task_term_root extends DAO {
	var $kind = NULL;
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_kind = NULL ){
		parent::__construct( "t_task_{$_kind}_root" );
		$this->kind= $_kind;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
			"t_task_id"               => DAO::ID_INIT,
			"t_{$this->kind}_root_id" => DAO::ID_INIT,
			"t_task_props"            => "",
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $taskID = NULL, $termRootID = NULL, $workflowID = NULL, $state = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_task_id",
			"t_{$this->kind}_root_id as t_term_root_id",
			"t_task_props",
			"get_{$this->kind}_root_name(t_{$this->kind}_root_id) AS t_term_root_name",
		);
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_task_id"                             => $taskID,
			"t_{$this->kind}_root_id"              => $termRootID,
			"get_workflow_id_by_task_id(t_task_id)" => $workflowID,
			"(select t_{$this->kind}_root_state from t_{$this->kind}_root where t_task_{$this->kind}_root.t_{$this->kind}_root_id=t_{$this->kind}_root.t_{$this->kind}_root_id limit 1)" => $state,
		));
		
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_task_id"      => DAO::ASC,
			"t_term_root_id" => DAO::ASC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:getSimpleTaskGroup
	 * 説明: t_task_idでグループ化したものを取得する
	 * 引数:
	 * 返値:
	****************************************************************/
	function getSimpleTaskGroup( $termRootID, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_task_id",
			"t_task_props",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_{$this->kind}_root_id"   => $termRootID,
		));
		// *グループ
		$arrGroup = array(
			"t_task_id"
		);
		// *グループ条件
		$arrHaving = NULL;
		if ( is_array($termRootID) ){
			$arrHaving = array(
				"count(DISTINCT t_{$this->kind}_root_id) >= ".count($termRootIDID),
			);
		}
		// *実行
		$res = $this->_select($arrField, $arrCondition, $arrGroup, $arrHaving, NULL, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $taskID, $taskProps, $arrTermRootID ){
		$res = NULL;
		
		if ( is_null($this->kind) ){
			$res["result"] = RES_NG;
			return $res;
		}
		if ( ! is_array($arrTermRootID) ){
			$arrTermRootID = array($arrTermRootID);
		}
		
		// 新規登録
		foreach ( $arrTermRootID as $termRootID ){
			if ( ! is_numeric($termRootID) ){
				$res["result"] = RES_OK;
				continue;
			}
			// *フィールド
			$arrValue = array(
				"t_task_id"                => $taskID,
				"t_task_props"             => $taskProps,
				"t_{$this->kind}_root_id" => $termRootID,
			);
			// *実行
			$res = $this->_insert($arrValue, TRUE);
			if ( $res["result"] !== RES_OK ){
				break;
			}
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $taskID, $taskProps = NULL, $termRootID = NULL ){
		$res = NULL;
		
		if ( is_null($this->kind) ){
			$res["result"] = RES_NG;
			return $res;
		}
		
		// *条件
		$arrCondition = $this->getCondition( array(
			"t_task_id"                => $taskID,
			"t_task_props"             => $taskProps,
			"t_{$this->kind}_root_id" => $termRootID,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
}

Class DAO_task_term_root_term extends DAO_task_term_root {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_dummy ){
		parent::__construct(Term::KIND_TERM);
	}
	
}

Class DAO_task_term_root_bilingual extends DAO_task_term_root {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_dummy ){
		parent::__construct(Term::KIND_BILINGUAL);
	}
	
}
