<?php
Class DAO_term extends DAO {
	var $kind = NULL;
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_kind ){
		parent::__construct( "t_{$_kind}" );

		$this->kind = $_kind;
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $termRootID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_{$this->kind}_id AS t_term_id",
			"t_{$this->kind}_text_s AS t_term_text_s",
			"t_{$this->kind}_text_t AS t_term_text_t",
			"t_{$this->kind}_root_id AS t_term_root_id",
			"t_user_id",
			"get_user_name(t_user_id) as t_user_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_{$this->kind}_root_id" => $termRootID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_term_text_s" => DAO::ASC,
			"t_term_text_t" => DAO::ASC,
			"t_term_id"     => DAO::ASC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:getTextSearch
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getTextSearch( $termRootID, $text, $limit = NULL, $offset = NULL ){
		$res = NULL;
		
		// *フィールド
		$arrField = array(
			"t_{$this->kind}_id AS t_term_id",
			"t_{$this->kind}_text_s AS t_term_text_s",
			"t_{$this->kind}_text_t AS t_term_text_t",
			"t_{$this->kind}_root_id AS t_term_root_id",
			"get_{$this->kind}_root_name(t_{$this->kind}_root_id) AS t_term_root_name",
			"t_user_id",
			"get_user_name(t_user_id) as t_user_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_{$this->kind}_root_id" => $termRootID,
		));
		if ( Validate::isString($text) ){
			$escText = $this->esc($text);
			$arrCondition["t_{$this->kind}_text"] = array(
				"type"  => DAO::TYPE_SQL,
				"value" => "(t_{$this->kind}_text_s LIKE '%{$escText}%') OR (t_{$this->kind}_text_t LIKE '%{$escText}%')",
			);
		}
		// *並び順
		$arrOrder = array(
			"t_term_root_id" => DAO::DESC,
			"t_term_id" => DAO::ASC,
		);
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getUser( $termRootID = NULL, $userID = NULL, $limit = NULL, $offset = NULL ){
		$res = NULL;
		
		$arrField = array(
			"distinct t_{$this->kind}_root_id as t_term_root_id",
			"t_user_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_{$this->kind}_root_id" => $termRootID,
			"t_user_id"               => $userID,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, NULL, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $termID, $textS, $textT, $termRootID, $userID ){
		$res    = NULL;
		
		// 新規登録
		if ( $termID === INIT_ID ){
			// *フィールド
			$arrValue = array(
				"t_{$this->kind}_text_s"  => $textS,
				"t_{$this->kind}_text_t"  => $textT,
				"t_{$this->kind}_root_id" => $termRootID,
				"t_user_id"               => $userID,
			);
			// *実行
			$res = $this->_insert($arrValue, TRUE, TRUE);
			$result = $res["result"];
		}
		// 更新
		else {
			//------------------
			// 重複チェック
			//------------------
			// *フィールド
			$arrField = array(
				"1"
			);
			// *条件
			$arrCondition = $this->getCondition(array(
				"t_{$this->kind}_text_s"  => $textS,
				"t_{$this->kind}_text_t"  => $textT,
				"t_{$this->kind}_root_id" => $termRootID,
			));
			$arrCondition["t_{$this->kind}_id"] = array("type" => "NOT", "value" => $termID);
			
			$res = $this->_select($arrField, $arrCondition, NULL, NULL, NULL, 1);
			if ( $res["result"] === RES_OK ){
				// 重複する
				$res["result"] = RES_NO_DATA;
				return;
			}
			
			//------------------
			// 更新
			//------------------
			// *フィールド
			$arrValue = $this->getValueUpdate(array(
				"t_{$this->kind}_text_s" => $textS,
				"t_{$this->kind}_text_t" => $textT,
				"t_user_id"              => $userID,
			));
			// *条件
			$arrCondition = $this->getCondition(array(
				"t_{$this->kind}_id"      => $termID,
				"t_{$this->kind}_root_id" => $termRootID,
			));
			// *実行
			$res = $this->_update($arrValue, $arrCondition);
			$res["id"] = $termID;
			$result = $res["result"];
		}
		
		// 辞書 更新日時 更新
		if ( $result === RES_OK ){
			$objDAOTermRoot = DAO::instance("term_root", $this->kind);
			
			// *フィールド
			$arrValue = array(
				"t_{$this->kind}_root_update" => DAO::NOW,
			);
			// *条件
			$arrCondition = array(
				"t_{$this->kind}_root_id" => $termRootID,
			);
			// *実行
			$resDAOTermRoot = $objDAOTermRoot->_update($arrValue, $arrCondition);
			$res["result"] = $resDAOTermRoot["result"];
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $termID, $termRootID = NULL ){
		$res    = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_{$this->kind}_id"      => $termID,
			"t_{$this->kind}_root_id" => $termRootID,
		));
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:outputTsv
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function outputTsv( $outputFile, $rootID ){
		// *フィールド
		$arrField = array(
			"t_{$this->kind}_text_s",
			"t_{$this->kind}_text_t",
		);
		// *条件
		$arrCondition = array(
			"t_{$this->kind}_root_id" => $rootID,
		);
		// *実行
		$offset = 0;
		$limit = 1000;
		$tsv = array();
		do {
			$res = $this->select($arrField, $arrCondition, NULL, NULL, NULL, $limit, $offset);
			if ( $res["result"] === RES_OK ){
				foreach ( $res["data"] as $dataTerm ){
					$sText = trim($dataTerm["t_{$this->kind}_text_s"]);
					$tText = trim($dataTerm["t_{$this->kind}_text_t"]);
					
					if ( $sText === "" || $tText === "" ){
						continue;
					}
					$tsv[] = "{$sText}\t{$tText}";
				}
			} else if ( $res["result"] === RES_NG ){
				return RES_NG;
			} else {
				break;
			}
			$offset += $limit;
		} while ( $res["count"] > $offset );
		
		if ( count($tsv) > 0 ){
			$text = mb_convert_encoding(implode("\n", $tsv)."\n", "UTF-8");
			file_put_contents($outputFile, $text);
			return RES_OK;
		} else {
			// データが空
			if ( file_exists($outputFile) ){
				unlink($outputFile);
			}
			return RES_NO_DATA;
		}
	}
}

Class DAO_term_term extends DAO_term {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_dummy ){
		parent::__construct(Term::KIND_TERM);
	}
	
}

Class DAO_term_bilingual extends DAO_term {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_dummy ){
		parent::__construct(Term::KIND_BILINGUAL);
	}
	
}

Class DAO_term_fix extends DAO_term {
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_dummy ){
		parent::__construct(Term::KIND_FIX);
	}
	
}
