<?php
Class DAO_workflow extends DAO {
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_tableName = "t_workflow" ){
		$this->tableName = $_tableName;
	}
	
	/***************************************************************
	 * 名前:getInit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getInit( $field ){
		$arrValue = array(
		);
		
		return $arrValue[$field];
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function get( $workflowID = NULL, $projectID = NULL, $arrOrder = NULL, $limit = NULL, $offset = NULL ){
		$res    = NULL;
		
		// *フィールド
		$arrField = array(
			"t_workflow_id",
			"t_workflow_state",
			"t_workflow_name",
			"t_workflow_text",
			"t_workflow_task_type",
			"t_project_id",
		);
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_workflow_id" => $workflowID,
			"t_project_id"  => $projectID,
		));
		// *並び順
		$arrOrder = $this->getOrderBy($arrOrder, array(
			"t_workflow_id" => DAO::ASC,
		));
		
		// *実行
		$res = $this->_select($arrField, $arrCondition, NULL, NULL, $arrOrder, $limit, $offset);
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:register
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function register( $workflowID, $name = NULL, $text = NULL, $taskType = NULL, $projectID = NULL ){
		$res    = NULL;
		
		// 新規登録
		if ( $workflowID === INIT_ID ){
			// *フィールド
			$arrValue = array(
				"t_workflow_state"     => DAO::T_WORKFLOW_STATE_NORMAL,
				"t_workflow_name"      => $name,
				"t_workflow_text"      => $text,
				"t_workflow_task_type" => $taskType,
				"t_project_id"         => $projectID,
			);
			// *実行
			$res = $this->_insert($arrValue, TRUE);
		}
		// 更新
		else {
			// *フィールド
			$arrValue = $this->getValueUpdate(array(
				"t_workflow_name"      => $name,
				"t_workflow_text"      => $text,
				"t_workflow_task_type" => $taskType,
			));
			// *条件
			$arrCondition = $this->getCondition(array(
				"t_workflow_id" => $workflowID,
			));
			// *実行
			$res = $this->_update($arrValue, $arrCondition);
			$res["id"] = $workflowID;
		}
		
		return $res;
	}
	
	/***************************************************************
	 * 名前:delete
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function delete( $id, $projectID = NULL ){
		$res    = NULL;
		
		// *条件
		$arrCondition = $this->getCondition(array(
			"t_workflow_id" => $id,
			"t_project_id"  => $projectID,
		));
		
		// *削除予定IDを取得
		if ( ($arrWorkflowID = $this->getPrimaryKey("t_workflow_id", $arrCondition)) === FALSE ){
			$res["result"] = RES_NG;
			return $res;
		} else if ( count($arrWorkflowID) === 0 ){
			$res["result"] = RES_OK;
			return $res;
		}
		
		// *実行
		$res = $this->_delete($arrCondition);
		
		if ( $res["result"] === RES_OK ){
			//Taskの削除
			$objDAOTask = DAO::instance("task");
			$res = $objDAOTask->delete(NULL, $arrWorkflowID);
		}
		
		return $res;
	}
}
