<?php
Class Printer {
	/***********************************
	 * 名前 : doctype
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function doctype(){
		$html = "";
		
$html = <<< HTML
		<!DOCTYPE html>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : html
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function html( $isOpen = TRUE ){
		$html = "";
		
		if ( $isOpen ){
$html = <<< HTML
			<html>
HTML;
		} else {
$html = <<< HTML
			</html>
HTML;
		}
		
		return $html;
	}
	
	/***********************************
	 * 名前 : head
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function head( $isOpen = TRUE, $title = "", $arrCSS = NULL, $arrJS = NULL, $readyJS = NULL, $arrMETA = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_PRINTER";
		
		$html = "";
		
		if ( $isOpen ){
			// METAタグデフォルト
			$META_HTTP_EQUIV_TABLE = array(
				"Content-Type"        => "text/html; charset=utf-8",
				"Content-Script-Type" => "text/JavaScript",
				"Content-Style-Type"  => "text/css",
				"X-UA-Compatible"     => "IE=EDGE",
			);
			
			// CSSデフォルト
			$CSS_TABLE = array(
				"/css/jquery.ui.custom.css"     => "all",
				"/css/jquery.notify.css"        => "all",
				"/css/bootstrap.css"            => "all",
				//"/css/bootstrap-theme.css"      => "all",
				"/css/minhon.common.css"        => "all",
			);
			
			// JSデフォルト
			$JS_TABLE = array(
				"/js/jquery.js",
				"/js/jquery.ui.custom.min.js",
				"/js/jquery.validate.min.js",
				"/js/jquery.notify.js",
				"/js/bootstrap.min.js",
				"/js/minhon.common.js",
				"/js/minhon.define.js",
				"/js/minhon.util.js",
				"/lang/minhon.word." . User::get("disp_lang") . ".js",
			);
			if ( User::get("disp_lang") !== LANG_EN ){
				$JS_TABLE[] = "/lang/jquery.validate/messages_" . User::get("disp_lang") . ".js";
			}
			if ( User::get("disp_lang") !== LANG_EN ){
				if ( User::get("disp_lang") === LANG_CN || User::get("disp_lang") === LANG_TW ){
					$JS_TABLE[] = "/lang/jquery.datepicker/jquery.ui.datepicker-zh-" . strtoupper(User::get("disp_lang")) . ".js";
				} else {
					$JS_TABLE[] = "/lang/jquery.datepicker/jquery.ui.datepicker-" . User::get("disp_lang") . ".js";
				}
			}
			
			// バージョン情報(js,cssファイルのキャッシュクリアに用いる)
			$hVer = Util::esc(Setting::get("VERSION"));
			
			// 追加(META)
			if ( count($arrMETA) > 0 ){
				$META_HTTP_EQUIV_TABLE = array_merge($META_HTTP_EQUIV_TABLE, $arrMETA); //上書き
			}
			
			// 追加(CSS)
			if ( count($arrCSS) > 0 ){
				foreach ( $arrCSS as $css ){
					$CSS_TABLE[$css] = "all";
				}
			}
			
			// 追加(JS)
			if ( count($arrJS) > 0 ){
				foreach ( $arrJS as $js ){
					$JS_TABLE[] = $js;
				}
			}
			
			// データ作成(metaデフォルト)
			foreach ( $META_HTTP_EQUIV_TABLE as $type => $content ){
				$hType    = Util::esc($type);
				$hContent = Util::esc($content);
				
$html .= <<< HTML
				<meta http-equiv="{$hType}" content="{$hContent}" />
HTML;
			}
			
			// データ作成(cssデフォルト)
			foreach ( $CSS_TABLE as $css => $media ){
				$hCSS = Util::url($css);
					
$html .= <<< HTML
				<link rel="stylesheet" type="text/css" href="{$hCSS}?{$hVer}" media="{$media}" />
HTML;
			}
			
			// データ作成(jsデフォルト)
			foreach ( $JS_TABLE as $js ){
				$hJS = Util::url($js);
				
$html .= <<< HTML
				<script type="text/javascript" src="{$hJS}?{$hVer}"></script>
HTML;
			}
			
			// document.ready
			//if ( ! is_null($readyJS) ){
				//$hReadyJS = Util::esc($readyJS);
				
$html .= <<< HTML
				<script type="text/javascript">
					//<![CDATA[
						$(document).ready(function(){
							$("input[type=text],textarea").filter(":visible:first").focus();
							{$readyJS}
						});
					//]]>
				</script>
HTML;
			//}
			
			// notify
			if ( isset($_SESSION["notify"]) ){
				$hNotify = implode("<br />", $_SESSION["notify"]);
				
$html .= <<< HTML
				<script type="text/javascript">
					//<![CDATA[
						$(document).ready(function(){
							$.notify({html:"{$hNotify}"});
						});
					//]]>
				</script>
HTML;
				unset($_SESSION["notify"]);
			}
			
			// タイトル
			$hSiteTitle = Util::esc(Config::get("SITE_TITLE"));
			$hTitle     = Util::esc($title);
			
$html = <<< HTML
			<head>
			<title>{$hTitle} - {$hSiteTitle}</title>
			<meta name="viewport" content="width=device-width, initial-scale=1.0">
			{$html}
			<!--[if lt IE 9]>
				<script type="text/javascript" src="/js/respond.min.js"></script>
			<![endif]-->
HTML;
		} else {
$html = <<< HTML
			</head>
HTML;
		}
		
		return $html;
	}
	
	/***********************************
	 * 名前 : body
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function body( $isOpen = TRUE ){
		$html = "";
		
		$style = Setting::get("DEBUG") ? "style=\"background-color:#EEE8AA\"" : "";
		
		if ( $isOpen ){
$html = <<< HTML
			<body {$style}>
HTML;
		} else {
$html = <<< HTML
			</body>
HTML;
		}
		
		return $html;
	}
	
	/***********************************
	 * 名前 : container
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function container( $isOpen = TRUE ){
		$html = "";
		
		if ( $isOpen ){
$html = <<< HTML
			<div class="container">
HTML;
		} else {
$html = <<< HTML
			</div>
HTML;
		}
		
		return $html;
	}
	
	/***********************************
	 * 名前 : containerFluid
	 * 説明 : 横幅を画面最大まで伸ばします
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function containerFluid( $isOpen = TRUE ){
		$html = "";
		
		if ( $isOpen ){
$html = <<< HTML
			<div class="container-fluid">
HTML;
		} else {
$html = <<< HTML
			</div>
HTML;
		}
		
		return $html;
	}
	
	/***********************************
	 * 名前 : header
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function header(){
		global $WORD;
		$wk = "WORD_P_CLASS_PRINTER";
		
		global $URL;
		global $G_LANG_DISP_TABLE;
		
		$html = "";
		$hMenu = "";
		
		// サイトインターフェース
		$hSelectSiteInterface = self::select("select_interface", "select_interface", $G_LANG_DISP_TABLE, User::get("disp_lang"), NULL, array("onchange" => "minhon.common.onChangeSiteInterface(this);"));
		// ヘルプ
		$hHelpMenu = self::link("{$WORD($wk, 1)}", "btn btn-default", "icon-question-sign", NULL, "/content/help/");
		
		{
			$arrButton = array();
			// ユーザー情報
			$arrButton[] = self::link("{$WORD($wk, 2)}", NULL, "icon-user", NULL, NULL, "minhon.common.onClickUserInfo();");
			// 設定
			$arrButton[] = self::link("{$WORD($wk, 3)}", NULL, "icon-cog", NULL, "/content/setting/user/");
			// 罫線
			$arrButton[] = "-";
			// ログアウト
			$arrButton[] = self::link("{$WORD($wk, 4)}", NULL, "icon-off", NULL, "/?q_logout=" . ON);
			// 操作
			$hOperation = self::buttonGroup(User::get("name"), $arrButton);
		}
		
		// メニュー
		if ( Auth::isLogin() ){
			$hOrganization = User::get("organization_name");
			$hType         = DAO::T_USER_TYPE_TABLE(User::get("type"));
			
$html .= <<< HTML
			<div class="col-xs-12 col-md-8">
				<div class="menu">
					<ul class="list-unstyled list-inline">
						<li>
							<form class="form-inline">
								<label class="control-label">{$WORD($wk, 5)}：</label>
								{$hSelectSiteInterface}
							</form>
						</li>
						<li>{$hHelpMenu}</li>
						<li>{$hOperation}</li>
					</ul>
				</div>
			</div>
			<div id="dialog_user_info" class="dialog">
				<div class="row form-group">
					<div class="col-xs-4">{$WORD($wk, 6)}</div>
					<div class="col-xs-8">{$hOrganization}</div>
				</div>
				<div class="row form-group">
					<div class="col-xs-4">{$WORD($wk, 7)}</div>
					<div class="col-xs-8">{$hType}</div>
				</div>
			</div>
HTML;
		}
		
		$hSiteTitle = Util::esc(Config::get("SITE_TITLE"));
		
$html = <<< HTML
		<div id="header" class="row">
			<div class="col-xs-12 col-md-4">
				<div class="title">
					<h1><a href="/">{$hSiteTitle}</a></h1>
				</div>
			</div>
			{$html}
		</div>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : footer
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function footer(){
		global $URL;
		global $WORD;
		$wk = "WORD_P_CLASS_PRINTER";
		
		$html = "";
		
		$y = date("Y");
		
$html .= <<< HTML
		<div id="footer">
			<div class="menu">
				<ul class="list-unstyled list-inline">
					<li><a href="/">{$WORD($wk, 8)}</a></li>
				</ul>
			</div>
			<address>Copyright (C) {$y} XXXXXX inc. All rights reserved.</address>
		</div>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : commonToken
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function commonToken(){
		$html = "";
		
		$token = Util::token("token_common");
		$html = Printer::input("hidden", "token_common", "token_common", $token);
		
		return $html;
	}
	
	/***********************************
	 * 名前 : Menu
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function menu(){
		global $G_MENU_TABLE;
		global $URL;
		
		$html = "";
		
		$userType = User::get("type");
		
		foreach ( $G_MENU_TABLE as $key => $menu ){
			$auth    = $menu["auth"];
			$title   = $menu["title"];
			$icon    = $menu["icon"];
			$reg     = $menu["reg"];
			$url     = $menu["url"];
			$args    = $menu["args"];
			$arrItem = $menu["item"];
			
			if ( ! in_array($userType, $auth) ){
				continue;
			}
			
			$hTitle = Util::esc($title);
			if ( is_array($args) ){
				$url .= "?".http_build_query($args);
			}
			$hHref = self::link($title, NULL, $icon, NULL, $url);
			
			// active
			$reg = preg_replace("/\//", "\/", $reg);
			$active = (preg_match("/{$reg}/", $_SERVER["SCRIPT_NAME"]) > 0) ? "active" : "";
			
			// dorpdonws
			if ( count($arrItem) === 0 ){
$html .= <<< HTML
				<li class="{$active}">{$hHref}</li>
HTML;
			} else {
				$count = 0;
				$htmlC = "";
				foreach ( $arrItem as $keyC => $menuC ){
					$authC  = $menuC["auth"];
					$titleC = $menuC["title"];
					$urlC   = $menuC["url"];
					$argsC  = $menuC["args"];
					
					if ( ! in_array($userType, $authC) ){
						continue;
					}
					
					$count++;
					
					if ( strcmp($titleC, "-") === 0 ){
$htmlC .= <<< HTML
					<li class="divider"></li>
HTML;
						continue;
					}
					
					$hTitleC = Util::esc($titleC);
					if ( is_array($argsC) && count($argsC) > 0){
						$hURLC = $URL($urlC . "?" . http_build_query($argsC));
					} else {
						$hURLC = $URL($urlC);
					}
					
$htmlC .= <<< HTML
					<li>
						<a href="{$hURLC}">{$hTitleC}</a>
					</li>
HTML;
				}
				
				if ( $count === 1 ){
$html .= <<< HTML
					<li class="{$active}">{$hHref}</li>
HTML;
				} else if ( $count > 1 ) {
$html .= <<< HTML
					<li class="{$active} dropdown">
						<a class="dropdown-toggle" data-toggle="dropdown" href="#">{$hTitle}<b class="caret"></b></a>
						<ul class="dropdown-menu">
							{$htmlC}
						</ul>
					</li>
HTML;
				}
			}
		}
		$hTitleIcon = Printer::icon("icon-th", NULL, "");
		$hTitleIcon = Printer::ellipsis($hTitleIcon, 20, FALSE);
		{
			$arrBtnState = array();
			foreach ( DAO::T_PROJECT_STATE_TABLE(NULL, TRUE) as $key => $text ){
				$arrBtnState[] = self::link($text, NULL, "icon-none", NULL, NULL, NULL, array("data-state"=>$key));
			}
			$hBtnState = self::buttonGroup( "---", $arrBtnState, "xs", array("id"=>"project-state"));
			$hBtnState .= "<span class=\"btn btn-xs disabled no-opacity hidden\"></span>";
		}
		
$html = <<< HTML
		<nav class="navbar navbar-default">
			<div class="navbar-collapse navbar-ex1-collapse">
				<ul class="nav navbar-nav">
					{$html}
				</ul>
				<span id="title-project" class="navbar-text navbar-right">{$hTitleIcon}{$hBtnState}</span>
			</div>
		</nav>
HTML;

		return $html;
	}
	
	/***********************************
	 * 名前 : menuProject
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function menuProject( $projectID ){
		global $G_MENU_PROJECT_TABLE;
		global $URL;
		
		$html = "";
		
		$hProjectID = Util::esc($projectID);

		foreach ( $G_MENU_PROJECT_TABLE as $key => $menu ){
			$title   = $menu["title"];
			$icon    = $menu["icon"];
			$reg     = $menu["reg"];
			$url     = $menu["url"];
			$args    = $menu["args"];
			$arrItem = $menu["item"];
			$class   = isset($menu["class"]) ? $menu["class"] : NULL;
			$option  = isset($menu["option"]) ? $menu["option"] : NULL;
			
			$args["q_project_id"] = $projectID;
			
			// select
			$reg = preg_replace("/\//", "\/", $reg);
			$select = (preg_match("/{$reg}/", $_SERVER["REQUEST_URI"]) > 0);
			
			if ( $select ){
				$class = trim("active {$class}");
			}
			
			if ( is_null($arrItem) ){
				$hHref = self::link($title, NULL, $icon, NULL, $url."?".http_build_query($args), NULL, $option);
$html .= <<< HTML
				<li class="{$class}">{$hHref}</li>
HTML;
			// dorpdonws
			} else {
				$htmlC = "";
				foreach ( $arrItem as $keyC => $menuC ){
					$titleC = $menuC["title"];
					$urlC   = $menuC["url"];
					$argsC  = $menuC["args"];
					
					$argsC["q_project_id"] = $projectID;
					
					$hTitleC = Util::esc($titleC);
					$hURLC   = $URL($urlC . "?" . http_build_query($argsC));
					
$htmlC .= <<< HTML
					<li>
						<a href="{$hURLC}">{$hTitleC}</a>
					</li>
HTML;
				}
				
				$hTitle = Util::esc($title);
$html .= <<< HTML
				<li class="{$class} dropdown">
					<a class="dropdown-toggle" data-toggle="dropdown" href="#">{$hTitle}<b class="caret"></b></a>
					<ul class="dropdown-menu">
						{$htmlC}
					</ul>
				</li>
HTML;
			}
		}
		
$html = <<< HTML
		<script type="text/javascript">
			//<![CDATA[
				$(document).ready(function(){
					minhon.common.getProjectName({$hProjectID});
				});
			//]]>
		</script>
		<div class="tabbable">
			<ul class="nav nav-pills">
				{$html}
			</ul>
		</div>
HTML;

		return $html;
	}
	
	/***********************************
	 * 名前 : menuTab
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function menuTab( $arrData, $activeTab, $arrSub = NULL ){
		$html = "";
		$htmlSub = "";
		
		foreach ( $arrData as $tab => $data ){
			if ( ! $data ){
				continue;
			}
			if ( is_string($data) && strlen($data) === 0 ){
				continue;
			}
			if ( is_array($data) ){
				if ( $tab === $activeTab ){
					$class = " class=\"active dropdown\"";
				} else {
					$class = " class=\"dropdown\"";
				}
				if ( is_array($data) && isset($data["title"]) && isset($data["item"]) ) {
					$hTitle = Util::esc($data["title"]);
					if ( isset($data["icon"]) ){
						$hTitle = Printer::icon($data["icon"])." ".$hTitle;
					}
					$pullHtml = "";
					foreach ( $data["item"] as $pullDownData ){
						if ( is_array($pullDownData) && isset($pullDownData["title"]) && isset($pullDownData["item"]) ){
							$hSubMenuTitle = Util::esc($pullDownData["title"]);
							$subHtml = "";
							foreach ( $pullDownData["item"] as $subData ){
								if ( strcmp($subData, "-") === 0 ){
									$subHtml .= "<li class=\"divider\"></li>";
								} else {
									$subHtml .= "<li>{$subData}</li>";
								}
							}
$pullHtml .= <<< HTML
						<li class="dropdown-submenu">
							<a tabindex="-1" href="#">{$hSubMenuTitle}</a>
							<ul class="dropdown-menu">
								{$subHtml}
							</ul>
						</li>
HTML;
						} else if ( strcmp($pullDownData, "-") === 0 ){
							$pullHtml .= "<li class=\"divider\"></li>";
						} else {
							$pullHtml .= "<li>{$pullDownData}</li>";
						}
					}
$html .= <<< HTML
				<li{$class}>
					<a class="dropdown-toggle" data-toggle="dropdown" href="#">{$hTitle}<b class="caret"></b></a>
					<ul class="dropdown-menu">
						{$pullHtml}
					</ul>
				</li>
HTML;
				}
			} else {
				if ( $tab === $activeTab ){
					$class = " class=\"active\"";
				} else {
					$class = "";
				}
				$html .= "<li{$class}>{$data}</li>";
			}
		}

		$hSub = "";
		if ( ! is_array($arrSub) ){
			$arrSub = array($arrSub);
		}
		foreach ( $arrSub as $sub ){
			if ( strlen($sub) == 0 ){
				continue;
			}
$hSub .= <<< HTML
			<li>{$sub}</li>
HTML;
		}
		
$html = <<< HTML
		<div class="tabbable nav-tabs-parent">
			<ul class="nav nav-tabs">
				{$html}
			</ul>
			<ul class="nav nav-tabs-right pull-right">
				{$hSub}
			</ul>
		</div>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : wizard
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function wizard( $arrWizard, $active, $title = NULL, $isEsc = TRUE ){
		$html = "";
		
		if ( Validate::isString($title) ){
			$hTitle = $isEsc ? Util::esc($title) : $title;
			$html .= "<li class=\"title\">{$hTitle}</li>";
		}
		
		foreach ( $arrWizard as $key => $value ){
			$hValue = $isEsc ? Util::esc($value) : $value;
			if ( $key === $active ){
				$html .= "<li class=\"active\">{$hValue}</li>";
			} else {
				$html .= "<li>{$hValue}</li>";
			}
		}
$html = <<< HTML
	<ul class="wizard">
		{$html}
	</ul>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : pagination
	 * 説明 : 
	 * 引数 : type      TRUE:URL FALSE:javascript
	 *      : url       URL/javascript関数
	 *      : args      URL/javascript引数
	 *      : count     総数
	 *      : increase  増加幅
	 *      : current   選択ページ位置(offset値)
	 *      : range     ページ番号表示数
	 * 返値 : 
	************************************/
	public static function pagination( $type, $url, $args, $count, $increase, $current, $range, $arrOption = NULL ){
		$html = "";
		$hURL = "";
		$sP   = 0;  // 開始ページ(offset値)
		$eP   = 0;  // 終了ページ(offset値)
		$pageNO = 0; // ページ番号
		
		if ( $count <= $increase ){
			return "";
		}
		
		// 開始ページ
		$sP = $current - ($increase * ($range / 2));
		$sP = ($sP > 0 ) ? $sP : 0;
		
		if ( $current > 0 ){
			$args["q_offset"] = $current - $increase;
			$hURL = self::paginationSub($type, $url, $args, "&laquo;");
			$html .= "<li>{$hURL}</li>";
		} else {
			$hURL = "<span>&laquo;</span>";
			$html .= "<li class=\"disabled\">{$hURL}</li>";
		}
		
		for ( $page=$sP; $page<$count; $page=$page+$increase ){
			if ( $range-- === 0 ){
				break;
			}
			// ページ番号
			$pageNO = ($page / $increase) + 1;
			
			if ( (int)$page === (int)$current ){
				$hURL = "<span>{$pageNO}</span>";
				$html .= "<li class=\"active\">{$hURL}</li>";
			} else {
				$args["q_offset"] = $page;
				$hURL = self::paginationSub($type, $url, $args, $pageNO);
				$html .= "<li>{$hURL}</li>";
			}
		}
		
		if ( $current < ($count - $increase) ){
			$args["q_offset"] = $current + $increase;
			$hURL = self::paginationSub($type, $url, $args, "&raquo;");
			$html .= "<li>{$hURL}</li>";
		} else {
			$hURL = "<span>&raquo;</span>";
			$html .= "<li class=\"disabled\">{$hURL}</li>";
		}
		
		$arrOption["class"] = isset($arrOption["class"]) ? $arrOption["class"]." pagination" : "pagination";
		$hOption = Printer::option($arrOption);
		
$html = <<< HTML
		<ul {$hOption}>{$html}</ul>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : paginationSub
	 * 説明 : 
	 * 引数 : type      TRUE:URL FALSE:javascript
	 *      : url       URL/javascript関数
	 *      : args      URL/javascript引数
	 *      : pageNO    
	 * 返値 : 
	************************************/
	private static function paginationSub( $type, $url, $args, $pageNO ){
		global $URL;
		
		$html = "";
		
		if ( ! is_array($args) ) return "";
		
		if ( $type ){
			$url  = $URL($url);
			$url  = $url . "?" . http_build_query($args, "", "&amp;");
			$html = "<a href=\"{$url}\">{$pageNO}</a>";
		} else {
			foreach ( $args as $arg ){
				$arrEscArg[] = "'{$arg}'";
			}
			$url  = $url . "(" . implode(",", $arrEscArg) . ");";
			$html = "<a href=\"javascript:void(0);\" onclick=\"{$url}\">{$pageNO}</a>";
		}
		
		return $html;
	}
	
	/***********************************
	 * 名前 : paginationTableHeader
	 * 説明 : 
	 * 引数 : type      TRUE:URL FALSE:javascript
	 *      : url       URL/javascript関数
	 *      : args      URL/javascript引数
	 *      : count     総数
	 *      : increase  増加幅
	 *      : current   選択ページ位置(offset値)
	 *      : range     ページ番号表示数
	 * 返値 : 
	************************************/
	public static function paginationTableHeader( $type, $url, $args, $count, $increase, $current, $range ){
		global $WORD;
		$wk = "WORD_P_CLASS_PRINTER";
		
		$arrHeadingOption = array(
			"class" => "pagination-sm",
		);
		$htmlHeading = Printer::pagination($type, $url, $args, $count, $increase, $current, $range, $arrHeadingOption);
		
		$hLink = Printer::link("{$WORD($wk, 9)}", "pagination-reload hide", "icon-refresh", NULL, NULL, "location.reload();");
		
		$start = $current + 1;
		$end   = min($current + $increase, $count);
		$text  = "{$WORD($wk, 10, $start, $end)}";
		$text .= " ({$WORD($wk, 11, $count)})";
		
$html = <<< HTML
		<div class="table-pagination-heading">
			<span>{$text}</span>
			{$hLink}
			{$htmlHeading}
		</div>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : paginationTableFooter
	 * 説明 : 
	 * 引数 : type      TRUE:URL FALSE:javascript
	 *      : url       URL/javascript関数
	 *      : args      URL/javascript引数
	 *      : count     総数
	 *      : increase  増加幅
	 *      : current   選択ページ位置(offset値)
	 *      : range     ページ番号表示数
	 * 返値 : 
	************************************/
	public static function paginationTableFooter( $type, $url, $args, $count, $increase, $current, $range ){
		$htmlFooter  = Printer::pagination($type, $url, $args, $count, $increase, $current, $range);
		
$html = <<< HTML
		<div class="table-pagination-footer">
			{$htmlFooter}
		</div>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : icon
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function icon( $class, $color = NULL, $text = NULL, $textColor = NULL, $space = TRUE ){
		global $URL;
		
		$html   = "";
		
		$hClass     = Util::esc($class);
		$hColor     = Util::esc($color);
		$hText      = Util::esc($text);
		$hTextColor = Util::esc($textColor);
		
		$hColor     = is_null($color)     ? "" : "color:{$hColor}";
		$hTextColor = is_null($textColor) ? "" : "color:{$hTextColor}";
		
		$hStyle     = strlen($hColor)     > 0 ? "style=\"{$hColor}\"" : "";
		$hTextStyle = strlen($hTextColor) > 0 ? "style=\"{$hTextColor}\"" : "";
		
		$html = "<i class=\"glyphicon glyph{$hClass}\" {$hStyle}></i>";
		
		if ( ! is_null($text) ){
			if ( $space ){
				$html .= " ";
			}
			$html .= "<span class=\"i-text\" {$hTextStyle}>{$hText}</span>";
		}
		
		return $html;
	}
	
	public static function iconWarning( $message = NULL ){
		if ( is_null($message) ){
			$html = "<i class=\"glyphicon glyphicon-warning-sign warning-sign\"></i>";
		} else {
			$hMessage = Util::esc($message);
			$html = "<i class=\"glyphicon glyphicon-warning-sign warning-sign\" title=\"{$hMessage}\"></i>";
		}
		return $html;
	}
	
	/***********************************
	 * 名前 : title
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function title( $title, $arrMenu = NULL, $isEsc = TRUE ){
		$html = "";
		
		$hTitle = $isEsc ? Util::esc($title) : $title;
		$hMenu  = is_null($arrMenu) ? "" : implode("", $arrMenu);
		
$html = <<< HTML
		<h2>{$hTitle}{$hMenu}</h2>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : label
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function label( $class = NULL, $text, $arrOption = NULL, $isEsc = TRUE ){
		$html = "";
		
		$hClass = is_null($class) ? "" : Util::esc($class);
		$hText  = $isEsc ? Util::esc($text) : $text;
		
		$hOption = self::option($arrOption);
		
$html = <<< HTML
		<span class="label {$hClass}" {$hOption}>{$hText}</span>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : uList
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function uList( $arrData, $isEsc = TRUE ){
		$html = "";
		
		foreach ( $arrData as $data ){
			$hData = $isEsc ? Util::esc($data) : $data;
			
$html .= <<< HTML
			<li>{$hData}</li>
HTML;
		}
		
$html = <<< HTML
		<ul>{$html}</ul>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : dList
	 * 説明 : definition List
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function dList( $arrData, $arrOption = NULL, $isEsc = TRUE ){
		$html = "";
		
		foreach ( $arrData as $key => $data ){
			$hKey  = $isEsc ? Util::esc($key)  : $key;
			$hData = $isEsc ? Util::esc($data) : $data;
			
$html .= <<< HTML
			<dt>{$hKey}</dt>
			<dd>{$hData}</dd>
HTML;
		}
		
		$hOption = self::option($arrOption);
		
$html = <<< HTML
		<dl {$hOption}>{$html}</dl>
HTML;
		
		return $html;
	}
	
	
	/***********************************
	 * 名前 : link
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function link( $value, $class = NULL, $icon = NULL, $color = NULL, $href = NULL, $onClick = NULL, $arrOption = NULL, $isEsc = TRUE ){
		global $URL;
		
		$html = "";
		
		$hValue   = $isEsc ? Util::esc($value) : $value;
		$hClass   = Util::esc($class);
		$hIcon    = is_null($icon) ? "" : self::icon($icon, $color)." ";
		$hHref    = is_null($href)    ? "javascript:void(0);" : $URL($href);
		$hOnClick = is_null($onClick) ? "javascript:void(0);" : Util::esc($onClick);
		
		$hOption = self::option($arrOption);
		
$html = <<< HTML
		<a class="{$hClass}" href="{$hHref}" onclick="{$hOnClick}" {$hOption}>{$hIcon}{$hValue}</a>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : linkSupportResize
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function linkSupportResize( $value, $class = NULL, $icon = NULL, $color = NULL, $href = NULL, $onClick = NULL, $arrOption = NULL, $isEsc = TRUE ){
		$html = "";
		
		$textClass = trim($class." resize-normal");
		$iconClass = trim($class." resize-short");
		
		$html .= self::link( $value, $textClass, $icon, $color, $href, $onClick, $arrOption, $isEsc);
		$html .= self::link( "",     $iconClass, $icon, $color, $href, $onClick, $arrOption, $isEsc);
		return $html;
	}
	
	/***********************************
	 * 名前 : radio
	 * 説明 : input:radioリスト作成
	 * 引数 : name
	 *      : vals
	 *      : checked
	 *      : arrExclude[]
	 * 返値 :  
	************************************/
	public static function radio( $id = NULL, $name = NULL, $arrValue = NULL, $checked = NULL, $arrOption = NULL, $isInline = TRUE, $isEsc = TRUE ){
		$html     = "";
		$hChecked = "";
		
		$hName = Util::esc($name);
		
		foreach ( $arrValue as $value => $text ){
			// 初期化
			$hChecked = "";
			
			// チェック対象
			if ( $value === $checked ){
				$hChecked = "checked=\"checked\"";
			}
			
			$hValue   = Util::esc($value);
			$hText    = $isEsc ? Util::esc($text) : $text;
			$hInline  = $isInline ? "radio-inline" : "radio";
			$hOption = self::option($arrOption);
			
$html .= <<< HTML
			<label class="{$hInline}">
				<input type="radio" name="{$hName}" value="{$hValue}" {$hChecked} {$hOption} />{$hText}
			</label>
HTML;
		}
		
		return $html;
	}
	
	public static function radioButtons( $name = NULL, $arrValue = NULL, $checked = NULL, $btnClass= NULL, $arrOption = NULL, $isEsc = TRUE ){
		$html     = "";
		
		$hName = Util::esc($name);
		
		foreach ( $arrValue as $value => $text ){
			$hChecked = "";
			if ( $value === $checked ){
				$hChecked = "checked=\"checked\"";
			}
			
			$hValue  = Util::esc($value);
			$hText   = $isEsc ? Util::esc($text) : $text;
			$hOption = self::option($arrOption);
			
$html .= <<< HTML
			<label class="btn {$btnClass}">
				<input name="{$hName}" type="radio" value="{$hValue}" {$hChecked} {$hOption} />{$hText}
			</label>
HTML;
		}
		
$html = <<< HTML
		<div data-toggle="buttons" class="btn-line-group">
			{$html}
		</div>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : select
	 * 説明 : selectリスト作成
	 * 引数 : id              id
	 *      : name           name
	 *      : arrValue       {value => text}
	 *      : selected       選択
	 * 返値 :  
	************************************/
	public static function select( $id = NULL, $name = NULL, $arrValue = NULL, $selected = NULL, $class = NULL, $arrOption = NULL, $isEsc = TRUE ){
		$html = "";
		$class = trim($class." form-control");
		
		foreach ( $arrValue as $value => $text ){
			$hValue    = Util::esc($value);
			$hText     = $isEsc ? Util::esc($text) : $text;
			$hSelected = ($value === $selected) ? "selected=\"selected\"" : "";
			
$html .= <<< HTML
			<option value="{$hValue}" {$hSelected} >{$hText}</option>
HTML;
		}
		
		$hID    = is_null($id)    ? "" : "id=\"" . Util::esc($id) . "\"";
		$hName  = is_null($name)  ? "" : "name=\"" . Util::esc($name) . "\"";
		$hClass = is_null($class) ? "" : "class=\"" . Util::esc($class) . "\"";
		
		$hOption = self::option($arrOption);
		
$html = <<< HTML
		<select {$hID} {$hName} {$hClass} {$hOption}>{$html}</select>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : checkbox
	 * 説明 : checkbox作成
	 * 引数 : id             id
	 *      : name           name
	 *      : vals           {value => text}
	 *      : checked       選択
	 *      : arrExclude[]   除外
	 * 返値 :  
	************************************/
	public static function checkbox( $id = NULL, $name = NULL, $arrValue = NULL, $arrChecked = NULL, $arrOption = NULL, $isInline = TRUE, $isEsc = TRUE ){
		$html     = "";
		$hChecked = "";
		
		$hID = "";
		if ( ! is_null($id) ){
			$hID = "id=\"{$id}\"";
		}
		
		// 全ラベル
		if ( isset($arrOption["label"]) && is_array($arrOption["label"]) ){
			$arrLabelOption = $arrOption["label"];
			unset($arrOption["label"]);
		} else {
			$arrLabelOption = NULL;
		}
		// アイテム
		if ( isset($arrOption["item"]) && is_array($arrOption["item"]) ){
			$arrItemOption = $arrOption["item"];
			unset($arrOption["item"]);
		} else {
			$arrItemOption = NULL;
		}
		// アイテムラベル
		if ( isset($arrOption["item-label"]) && is_array($arrOption["item-label"]) ){
			$arrItemLabelOption = $arrOption["item-label"];
			unset($arrOption["item-label"]);
		} else {
			$arrItemLabelOption = NULL;
		}
		
		$hOption = self::option($arrOption);
		$hLabelOption = self::option($arrLabelOption);
		
		foreach ( $arrValue as $value => $text ){
			// 初期化
			$hChecked = "";
			
			// チェック対象
			if ( is_array($arrChecked) && in_array($value, $arrChecked) ){
				$hChecked = "checked=\"checked\"";
			}
			
			$hValue = Util::esc($value);
			$hText  = $isEsc ? Util::esc($text) : $text;
			$hLabelClass = $isInline ? "checkbox-inline" : "checkbox";
			
			$hItemOption = $hOption;
			if ( is_array($arrItemOption) && isset($arrItemOption[$value]) ){
				if ( is_array($arrOption) ){
					$arr = array_merge($arrItemOption[$value], $arrOption);
				} else {
					$arr = $arrItemOption[$value];
				}
				$hItemOption = self::option($arr);
			}
			$hItemLabelOption = $hLabelOption;
			if ( is_array($arrItemLabelOption) && isset($arrItemLabelOption[$value]) ){
				if ( is_array($arrLabelOption) ){
					$arr = array_merge($arrItemLabelOption[$value], $arrLabelOption);
				} else {
					$arr = $arrItemLabelOption[$value];
				}
				if ( isset($arr["class"]) ){
					$hLabelClass .= " {$arr["class"]}";
					unset($arr["class"]);
				}
				$hItemLabelOption = self::option($arr);
			}
			
$html .= <<< HTML
			<label class="{$hLabelClass}" {$hItemLabelOption}>
				<input {$hID} name="{$name}" type="checkbox" value="{$hValue}" {$hChecked} {$hItemOption} />{$hText}
			</label>
HTML;
		}
		
		return $html;
	}
	
	public static function checkboxButtons( $name = NULL, $arrValue = NULL, $arrChecked = NULL, $btnClass = NULL, $arrOption = NULL, $isEsc = TRUE ){
		$html = "";
		
		$hName = Util::esc($name);
		
		foreach ( $arrValue as $value => $text ){
			$hChecked = "";
			if ( is_array($arrChecked) && in_array($value, $arrChecked) ){
				$hChecked = "checked=\"checked\"";
			} else if ( ! is_null($arrChecked) && $value === $arrChecked ){
				$hChecked = "checked=\"checked\"";
			}
			
			$hValue  = Util::esc($value);
			$hText   = $isEsc ? Util::esc($text) : $text;
			$hOption = self::option($arrOption);
			
$html .= <<< HTML
			<label class="btn {$btnClass}">
				<input name="{$hName}" type="checkbox" value="{$hValue}" {$hChecked} {$hOption} />{$hText}
			</label>
HTML;
		}
		
$html = <<< HTML
		<div data-toggle="buttons" class="btn-line-group">
			{$html}
		</div>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : ellipsis
	 * 説明 : 
	 * 引数 : 
	 * 返値 :  
	************************************/
	public static function ellipsis( $text, $length, $isEsc = TRUE ){
		$html = "";
		if ( strlen($text) === 0 ){
			return $html;
		}
		
		$hText = $isEsc ? Util::esc($text) : $text;
		
		$html = "<span data-ellipsis=\"{$length}\">{$hText}</span>";
		return $html;
	}
	
	/***********************************
	 * 名前 : formText
	 * 説明 : 
	 * 引数 : 
	 * 返値 :  
	************************************/
	public static function formText( $value, $isEsc = TRUE ){
		$html = "";
		
		$hValue = $isEsc ? Util::esc($value) : $value;
		
$html = <<< HTML
		<div class="form-control-static">
			<span class="text">{$hValue}</span>
		</div>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : option
	 * 説明 : 
	 * 引数 : 
	 * 返値 :  
	************************************/
	public static function option( $arrOption ){
		$html = "";
		
		if ( is_null($arrOption) ){
			$html = "";
		} else {
			$arrOp = array();
			foreach ( $arrOption as $key => $option ){
				$hKey    = Util::esc($key);
				$hOption = "";
				if ( is_array($option) ){
					$arrEscOption = array();
					foreach ( $option as $c ){
						$arrEscOption[] = "\"".Util::esc($c)."\"";
					}
					if ( count($arrEscOption) > 0 ){
						$hOption = "[".implode(", ", $arrEscOption)."]";
					}
				} else if ( Validate::isString($option) ){
					$hOption = Util::esc($option);
				}
				
				if ( Validate::isString($hKey) && Validate::isString($hOption) ){
					$arrOp[] = "{$hKey}='{$hOption}'";
				}
			}
			$html = implode(" ", $arrOp);
		}
		
		return $html;
	}
	
	/***********************************
	 * 名前 : input
	 * 説明 : 
	 * 引数 : 
	 * 返値 :  
	************************************/
	public static function input( $type, $id = NULL, $name = NULL, $value = NULL, $class = NULL, $arrOption = NULL ){
		$html = "";
		if ( strcmp($type, "submit") != 0 && strcmp($type, "hidden") != 0 && strcmp($type, "file") != 0 ){
			$class = trim($class." form-control");
		}
		
		$hType  = Util::esc($type);
		$hID    = is_null($id)    ? "" : "id=\"" . Util::esc($id) . "\"";
		$hName  = is_null($name)  ? "" : "name=\"" . Util::esc($name) . "\"";
		$hValue = is_null($value) ? "" : "value=\"" . Util::esc($value) . "\"";
		$hClass = is_null($class) ? "" : "class=\"" . Util::esc($class) . "\"";
		
		$hOption = self::option($arrOption);
		
$html = <<< HTML
		<input type="{$hType}" {$hID} {$hClass} {$hName} {$hValue} {$hOption} />
HTML;
	
		return $html;
	}
	
	/***********************************
	 * 名前 : inputDropdown
	 * 説明 : 
	 * 引数 : 
	 * 返値 :  
	************************************/
	public static function inputDropdown( $id = NULL, $name = NULL, $value = NULL, $class = NULL, $arrOption = NULL, $arrList = NULL ){
		$html = "";
		
		$hInput = self::input("text", $id, $name, $value, $class, $arrOption);
		
		if ( count($arrList) > 0 ){
			foreach ( $arrList as $list ){
				$hList = Util::esc($list);
				
$html .= <<< HTML
				<li>
					<a href="#" onclick="minhon.common.onClickDropdown(this)">{$hList}</a>
				</li>
HTML;
			}
			
$html = <<< HTML
			<div class="input-group">
				<div class="input-group-btn">
					<button type="button" class="btn btn-default dropdown-toggle" data-toggle="dropdown">Select <span class="caret"></span></button>
					<ul class="dropdown-menu">{$html}</ul>
				</div>
				{$hInput}
			</div>
HTML;
		} else {
			$html = $hInput;
		}
		
		
		return $html;
	}
	
	/***********************************
	 * 名前 : button
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function button( $id = NULL, $name = NULL, $value = NULL, $class = NULL, $arrOption = NULL ){
		$html = "";
		
		$hID    = is_null($id)    ? "" : "id=\"" . Util::esc($id) . "\"";
		$hName  = is_null($name)  ? "" : "name=\"" . Util::esc($name) . "\"";
		$hValue = Util::esc($value);
		$hClass = Util::esc($class);
		
		$hOption = self::option($arrOption);
		
$html = <<< HTML
		<button {$hID} class="btn {$hClass}" {$hName} {$hOption}>{$hValue}</button>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : textarea
	 * 説明 : 
	 * 引数 : 
	 * 返値 :  
	************************************/
	public static function textarea( $id, $name, $value, $rows = 5, $class = NULL ){
		$html = "";
		$class = trim($class." form-control");
		
		$hID    = Util::esc($id);
		$hName  = Util::esc($name);
		$hValue = Util::esc($value);
		$hRows  = Util::esc($rows);
		$hClass = Util::esc($class);
		
$html = <<< HTML
		<textarea id="{$hID}" name="{$hName}" class="{$hClass}" rows="{$hRows}">{$hValue}</textarea>
HTML;
	
		return $html;
	}
	
	/***********************************
	 * 名前 : form
	 * 説明 : 
	 * 引数 : 
	 * 返値 :  
	************************************/
	public static function form( $id, $name, $action = NULL, $method = NULL, $arrControl = NULL, $arrAction = NULL, $arrOption = NULL, $isHorizontal = TRUE ){
		$html = "";
		$hFormControl  = "";
		$hFormValidate = "";
		$hFormAction   = "";
		
		if ( ! is_null($arrControl) ){
			$hFormControl  = self::formControl($arrControl, $isHorizontal);
			$hFormValidate = self::formValidate($id, $arrControl);
		}
		if ( ! is_null($arrAction) ){
			$hFormAction = self::formAction($arrAction);
		}
		
		$hID     = Util::esc($id);
		$hName   = Util::esc($name);
		$hAction = is_null($action) ? "" : Util::esc($action);
		$hMethod = is_null($method) ? "" : Util::esc($method);
		
		$hClass = $isHorizontal ? "form-horizontal" : "";
		$hOption = self::option($arrOption);
		
$html = <<< HTML
		<form id="{$hID}" name="{$hName}" class="{$hClass}" action="{$hAction}" method="{$hMethod}" {$hOption}>
			{$hFormControl}
			{$hFormAction}
		</form>
		{$hFormValidate}
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : formControl
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function formControl( $arrControl, $isHorizontal = TRUE, $isTableFrame = FALSE ){
		global $WORD;
		$wk = "WORD_P_CLASS_PRINTER";
		
		$html = "";
		$requiredValid = FALSE;
		
		$hLabelClass = $isHorizontal ?  "col-xs-2" : "";
		$hLabelClass = trim($hLabelClass." control-label");
		$hCtrlClass  = $isHorizontal ? "col-xs-10" : "";
		
		foreach ( $arrControl as $control ){
			$id    = $control["id"];
			$name  = $control["name"];
			$form  = $control["form"];
			if ( is_null($form) ){
				continue;
			}
			
			$hID   = Util::esc($id);
			$hName = Util::esc($name);
			
			if ( isset($control["required"]) && $control["required"] ){
				$hName .= "<span class=\"form-required\">*</span>";
				$requiredValid = TRUE;
			}
			
			if ( isset($control["fullsize"]) && $control["fullsize"] ){
				$hCtrlClass = "col-xs-10";
			}
			
			// 複数存在する場合は結合
			if ( is_array($form) ){
				$hFormClass = count($form) > 1 ? "form-inline" : "";
				$form = implode("\n", $form);
$form = <<< HTML
				<div class="{$hFormClass}">
					{$form}
				</div>
HTML;
			}
			
			if ( $isTableFrame ){
				// ID,Name指定が無い場合 ----------
				if ( is_null($id) && is_null($name) ){
$html .= <<< HTML
					<tr class="hidden">
						<td colspan="2">{$form}</td>
					</tr>
HTML;
				}
				// ID指定がある場合 ----------
				else {
$html .= <<< HTML
					<tr>
						<th class="col-xs-2"><label for="{$hID}">{$hName}</label></th>
						<td>{$form}</td>
					</tr>
HTML;
				}
			} else {
				// ID,Name指定が無い場合 ----------
				if ( is_null($id) && is_null($name) ){
$html .= <<< HTML
					{$form}
HTML;
				}
				// ID指定がある場合 ----------
				else {
$html .= <<< HTML
					<div class="form-group">
						<label class="{$hLabelClass}" for="{$hID}">{$hName}</label>
						<div class="{$hCtrlClass}">{$form}</div>
					</div>
HTML;
				}
			}
		}
		
		if ( $requiredValid ){
			$comment = '<span class="form-required" style="margin:0px 5px">*</span>';
			$comment = "{$WORD($wk, 12, $comment)}";
			
			if ( $isTableFrame ){
$html .= <<< HTML
				<tr>
					<td colspan="2">
						<p class="help-block">{$comment}</p>
					</td>
				</tr>
HTML;
			} else {
$html .= <<< HTML
				<hr />
				<p class="help-block">{$comment}</p>
HTML;
			}
		}
		
		return $html;
	}
	
	/***********************************
	 * 名前 : formValidate
	 * 説明 : 
	 * 引数 : 
	 * 返値 :  
	************************************/
	public static function formValidate( $formID, $arrControl ){
		$arr  = array();
		$html = "";
		
		$arr = array(
			"onkeyup"    => false,
			"errorClass" => "validate-error",
			"ignore"     => ":hidden:not(.validate-item),.novalidate", // hidden要素でも validate-itemクラスを持つものはチェックさせる
		);
		$arrGroup = array();
		
		foreach ( $arrControl as $control ){
			if ( ! isset($control["validate"]) ){
				continue;
			}
			
			$id       = $control["id"];
			$validate = $control["validate"];
			$arr["rules"][$id] = $validate;
			
			if ( isset($control["validate-group"]) ){
				$groupName = $control["validate-group"];
				$arrGroup[$groupName][] = $id;
			}
		}
		
		if ( ! isset($arr["rules"]) ){
			return "";
		}
		if ( count($arrGroup) > 0 ){
			foreach ( $arrGroup as $groupName => $arrItemID ){
				$arr["groups"][$groupName] = implode(" ", $arrItemID);
			}
		}
		
		$hFormID   = Util::esc($formID);
		$hValidate = json_encode($arr);
		
$html = <<< HTML
		<script type="text/javascript">
			//<![CDATA[
				var funcReady;
				$(document).ready(function(){
					funcReady = function(){
						$("#{$hFormID}").validate({$hValidate});
					}
					if ( $("#{$hFormID}").get(0) ){
						funcReady();
					}
				});
			//]]>
		</script>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : formAction
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function formAction( $arrAction ){
		$html = "";
		
		if ( count($arrAction) === 0 ){
			return "";
		}
		
		$col = 2;//12 / count($arrAction);
		
		foreach ( $arrAction as $action ){
$html .= <<< HTML
			<div class="col-xs-{$col}">{$action}</div>
HTML;
		}
		
$html = <<< HTML
		<hr />
		<div class="form-actions">
			<div class="row">
				{$html}
			</div>
		</div>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : direct
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function direct( $icon, $left, $right ){
		global $URL;
		
		$html   = "";
		
		$hIcon  = self::icon($icon, "inherit");
		$hLeft  = Util::esc($left);
		$hRight = Util::esc($right);
		
$html = <<< HTML
		<span>
			<span>{$hLeft}</span>
			{$hIcon}
			<span>{$hRight}</span>
		</span>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : directLang
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function directLang( $sLang, $tLang, $mixTwin = TRUE ){
		global $G_LANG_TABLE;
		
		$html   = "";
		
		$sLangStr = isset($G_LANG_TABLE[$sLang]) ? $G_LANG_TABLE[$sLang] : NULL;
		$tLangStr = isset($G_LANG_TABLE[$tLang]) ? $G_LANG_TABLE[$tLang] : NULL;
		
		if ( is_null($sLangStr) || is_null($tLangStr) ){
			return "";
		}
		
		if ( $mixTwin && strcmp($sLang, $tLang) === 0 ){
			return Util::esc($sLangStr);
		}
		
		$html = Printer::direct("icon-arrow-right", $sLangStr, $tLangStr);
		
		return $html;
	}
	
	/***********************************
	 * 名前 : tooltip
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	 ************************************/
	public static function tooltip( $text, $popupText, $icon = NULL, $color = NULL, $isEsc = TRUE ){
		$hText = $isEsc ? Util::esc($text) : $text;
		$hText = "<span>{$hText}</span>";
		if ( ! is_null($icon) ){
			$hText = self::icon($icon, $color).$hText;
		}
		
		$attrDataHTML = "";
		if ( is_array($popupText) ){
			foreach ( $popupText as &$pt ){
				$pt = Util::esc($pt);
			}
			unset($pt);
			$hPopupText = implode("<br/>", $popupText);
			$attrDataHTML = "data-html=\"true\"";
		} else {
			$hPopupText = Util::esc($popupText);
		}
		
$html = <<< HTML
		<span data-toggle="tooltip" data-placement="top" title="{$hPopupText}" {$attrDataHTML}>
			{$hText}
		</span>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : popover
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	 ************************************/
	public static function popover( $content, $popoverTitle, $popoverContent, $arrOption = NULL, $isEsc = TRUE ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_BBS_POST";
		
		if ( is_array($popoverContent) ){
			if ( $isEsc ){
				foreach ( $popoverContent as &$line ){
					$line = "<li>".Util::esc($line)."</li>";
				}
				$popoverContent = "<ul class=\"list-unstyled\">".implode("", $popoverContent)."</ul>";
			} else {
				$popoverContent = implode("<br/>", $popoverContent);
			}
		}
		$defaultOption = array(
			"data-html"      => "true",
			"data-toggle"    => "popover",
			"data-placement" => "top",
			"data-trigger"   => "hover",
			"title"          => $popoverTitle,
			"data-content"   => $popoverContent,
		);
		if ( ! is_array($arrOption) ){
			$arrOption = array();
		}
		$arrOption = array_merge($arrOption, $defaultOption);
		
		$hOption = Printer::option($arrOption);
		$html = "<span {$hOption}>{$content}</span>";
		
		return $html;
	}
	
	/***********************************
	 * 名前 : buttonGroup
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function buttonGroup( $title, $arrButton, $buttonType = NULL, $arrOption = NULL, $isEsc = TRUE ){
		$html = "";
		
		$hTitle = $isEsc ? Util::esc($title): $title;
		
		foreach ( $arrButton as $button ){
			if ( is_array($button) ){
				$hBtnClass = isset($button["class"]) ? $button["class"] : "";
				$hBtnStyle = isset($button["style"]) ? $button["style"] : "";
				$hBtnText  = isset($button["text"])  ? $button["text"]  : "";
			} else {
				$hBtnClass = "";
				$hBtnStyle = "";
				$hBtnText  = "";
				
				if ( strcmp($button, "-") === 0 ){
					$hBtnClass = "divider";
				} else {
					$hBtnText = $button;
				}
			}
			
			$hBtnClass = strlen($hBtnClass) > 0 ? "class=\"{$hBtnClass}\" " : "";
			$hBtnStyle = strlen($hBtnStyle) > 0 ? "style=\"{$hBtnStyle}\" " : "";
			
$html .= <<< HTML
				<li {$hBtnClass}{$hBtnStyle}>{$hBtnText}</li>
HTML;
		}
		if ( is_null($buttonType) ){
			$buttonType = "success";
		}
		
		if ( ! is_array($arrOption) ){
			$arrOption = array();
		}
		if ( ! isset($arrOption["class"]) ){
			$arrOption["class"] = "";
		}
		$arrOption["class"] = trim("dropdown-toggle btn btn-{$buttonType} " . $arrOption["class"]);
		if ( count($arrButton) === 0 ){
			$arrOption["disabled"] = "disabled";
		}
		$hHrefOption = self::option($arrOption);
		
$html = <<< HTML
		<div class="btn-group">
			<a data-toggle="dropdown" href="#" {$hHrefOption}>
				{$hTitle}
				<span class="caret"></span>
			</a>
			<ul class="dropdown-menu">
				{$html}
			</ul>
		</div>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : tableOrder
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function tableOrder( $headerText, $orderName = NULL, $order = NULL, $isEsc = TRUE ){
		$hHeaderText = $isEsc ? Util::esc($headerText) : $headerText;
		if ( is_null($orderName) ){
			return "<th>{$hHeaderText}</th>";
		}
		
		$orderType = NULL;
		if ( Validate::isString($order) ){
			$arrOrder = explode("-", $order);
			if ( count($arrOrder) == 2 ){
				if ( $arrOrder[0] === $orderName ){
					$orderType = $arrOrder[1];
					if ( ! in_array($orderType, array("asc", "desc")) ){
						$orderType = NULL;
					}
				}
			}
		}
		
		$hOrderIcon = "";
		$class = "";
		$headerClass = "";
		if ( is_null($orderType) ){
			$class = "order-none";
$hOrderIcon .= <<< HTML
			<p class="updown">
				<span class="order-icon-up"></span>
				<span class="order-icon-down"></span>
			</p>
HTML;
		} else if ( $orderType === "asc" ){
			$headerClass = "alert-success";
			$class = "order-asc";
		} else if ( $orderType === "desc" ){
			$headerClass = "alert-success";
			$class = "order-desc";
		} else {
			return "<th>{$hHeaderText}</th>";
		}
		
$hOrderIcon .= <<< HTML
		<span class="order-icon-up"></span>
		<span class="order-icon-down"></span>
HTML;
		
$html = <<< HTML
		<th class="{$headerClass}">
			<a class="{$class}" onclick="minhon.common.onClickOrder(this);" data-order-name="{$orderName}">
				{$hHeaderText}
				{$hOrderIcon}
			</a>
		</th>
HTML;
		
		return $html;
	}
	
	/***********************************
	 * 名前 : alert
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	public static function alert( $isError, $message, $closeButton = FALSE, $arrOption = NULL, $isEsc = TRUE ){
		$isListView = $isError;
		
		if ( ! Validate::isArray($message) ){
			$message = array($message);
		}
		$arrHMessage = array();
		foreach ( $message as $mes ){
			$hMes = $isEsc ? Util::esc($mes) : $mes;
			$arrHMessage[] = $isListView ? "<li>{$hMes}</li>" : $hMes;
		}
		
		$hMessage = "";
		if ( $isListView ){
			$hMessage = "<ul>".implode("", $arrHMessage)."</ul>";
		} else {
			$hMessage = "<span>".implode("<br />", $arrHMessage)."</span>";
		}
		
		if ( $isError ){
			$hTitle = "<strong>Error</strong>";
		} else {
			$hTitle = "";
		}
		
		if ( $closeButton ){
			$hButton = "<button type=\"button\" class=\"close\" data-dismiss=\"alert\" aria-hidden=\"true\">&times;</button>";
		} else {
			$hButton = "";
		}
		
		if ( ! isset($arrOption["class"]) ){
			$arrOption["class"] = "";
		}
		$arrOption["class"] .= " alert";
		$arrOption["class"] .= $isError ? " alert-danger" : " alert-warning";
		$arrOption["class"] = trim($arrOption["class"]);
		
		$hOption = self::option($arrOption);
		
$html = <<< HTML
		<div {$hOption}>
			{$hTitle}
			{$hButton}
			{$hMessage}
		</div>
HTML;
		
		return $html;
	}
}
