<?php
Class Project {
	private $id = NULL;
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct( $_id ){
		$this->id = $_id;
	}
	
	/***************************************************************
	 * 名前:getUser
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getUser(){
		$result = RES_OK;
		$arrRes = array();
		
		$objDAOProjectUser = DAO::instance("project_user");
		
		// ユーザー役割一覧 --------------------
		if ( $result === RES_OK ){
			$resDAOProjectUser = $objDAOProjectUser->get($this->id);
			$result = $resDAOProjectUser["result"];
			
			if ( $result === RES_OK ){
				$arrUsers = array();
				foreach ( $resDAOProjectUser["data"] as $dataProjectUser ){
					$role     = $dataProjectUser["t_project_user_role"];
					$userID   = $dataProjectUser["t_user_id"];
					$userName = $dataProjectUser["t_user_name"];
					
					$arrRes[$role][$userID] = $userName;
					$arrUsers[$userID] = $userName;
				}
				// actors(role-holder, translation-pool, translation-term) は関係者全員から選択
				$arrRes[TASK::ROLE_ARHD] = $arrUsers;
				$arrRes[TASK::ROLE_ATRP] = $arrUsers;
				$arrRes[TASK::ROLE_ATTM] = $arrUsers;
			} else if ( $result === RES_NO_DATA ){
				$result = RES_OK;
			} else {
				$result = RES_NG;
			}
		}
		
		return ($result === RES_OK) ? $arrRes : FALSE;
	}
	
	/***************************************************************
	 * 名前:getAppended
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getAppended(){
		$result = RES_OK;
		$arrRes = array();
		
		// document
		if ( ($arrRes["document"] = $this->getDocument()) === FALSE ){
			$result = RES_NG;
		}
		// document_webapi_exterm
		if ( ($arrRes["document_webapi_exterm"] = $this->getDocumentWebApiExterm()) === FALSE ){
			$result = RES_NG;
		}
		// term
		if ( ($arrRes["term-normal"] = $this->getTermRoot(Term::KIND_TERM, DAO::T_TERM_ROOT_TYPE_NORMAL)) === FALSE ){
			$result = RES_NG;
		}
		// term_webapi_exterm
		if ( ($arrRes["term-normal_webapi_exterm"] = $this->getTermRootWebApiExterm(Term::KIND_TERM, DAO::T_TERM_ROOT_TYPE_NORMAL)) === FALSE ){
			$result = RES_NG;
		}
		if ( ($arrRes["term-reference"] = $this->getTermRoot(Term::KIND_TERM, DAO::T_TERM_ROOT_TYPE_REFERENCE)) === FALSE ){
			$result = RES_NG;
		}
		// bilingual
		if ( ($arrRes["bilingual-normal"] = $this->getTermRoot(Term::KIND_BILINGUAL, DAO::T_TERM_ROOT_TYPE_NORMAL)) === FALSE ){
			$result = RES_NG;
		}
		if ( ($arrRes["bilingual-reference"] = $this->getTermRoot(Term::KIND_BILINGUAL, DAO::T_TERM_ROOT_TYPE_REFERENCE)) === FALSE ){
			$result = RES_NG;
		}
		// data
		if ( ($arrRes["data-brief"] = $this->getData(DAO::T_DATA_PROP_BRIEF)) === FALSE ){
			$result = RES_NG;
		}
		if ( ($arrRes["data-research"] = $this->getData(DAO::T_DATA_PROP_RESEARCH)) === FALSE ){
			$result = RES_NG;
		}
		if ( ($arrRes["data-deliver"] = $this->getData(DAO::T_DATA_PROP_DELIVER)) === FALSE ){
			$result = RES_NG;
		}
		if ( ($arrRes["data-others"] = $this->getData(DAO::T_DATA_PROP_OTHERS)) === FALSE ){
			$result = RES_NG;
		}
		if ( ($arrRes["data"] = $this->getData()) === FALSE ){
			$result = RES_NG;
		}
		
		if ( $result === RES_OK ){
			$arrRes["term"]      = $arrRes["term-normal"] + $arrRes["term-reference"];
			$arrRes["bilingual"] = $arrRes["bilingual-normal"] + $arrRes["bilingual-reference"];
		}
		
		$arrRes["disabled-document"] = NULL; // 選択不可な文書があればここに入れる 例)既に他のタスクで登録されている文書
		
		return ($result === RES_OK) ? $arrRes : FALSE;
	}
	
	/***************************************************************
	 * 名前:getDocument
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getDocument(){
		$result = RES_OK;
		$arrRes = array();
		
		$objDAODocument = DAO::instance("document");
		
		// 文書一覧 --------------------
		if ( $result === RES_OK ){
			$resDAODocument = $objDAODocument->get(NULL, array_keys(DAO::T_DOCUMENT_STATE_VALID_TABLE()), NULL, $this->id);
			$result = $resDAODocument["result"];
			
			if ( $result === RES_OK ){
				foreach ( $resDAODocument["data"] as $dataDocument ){
					$id    = $dataDocument["t_document_id"];
					$title = $dataDocument["t_document_title"];
					
					$arrRes[$id] = $title;
				}
			} else if ( $result === RES_NO_DATA ){
				$result = RES_OK;
			} else {
				$result = RES_NG;
			}
		}
		
		return ($result === RES_OK) ? $arrRes : FALSE;
	}
	
	/***************************************************************
	 * 名前:getDocumentWebApiExterm
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getDocumentWebApiExterm(){
		$result = RES_OK;
		$arrRes = array();
		
		$objDAODocument = DAO::instance("document");
		
		// 文書一覧 --------------------
		if ( $result === RES_OK ){
			$resDAODocument = $objDAODocument->get(NULL, array_keys(DAO::T_DOCUMENT_STATE_VALID_TABLE()), NULL, $this->id);
			$result = $resDAODocument["result"];
			
			if ( $result === RES_OK ){
				foreach ( $resDAODocument["data"] as $dataDocument ){
					$id    = $dataDocument["t_document_id"];
					$title = $dataDocument["t_document_title"];
					$langS = $dataDocument["t_document_lang_s"];
					$langT = $dataDocument["t_document_lang_t"];
					
					// 言語方向の組み合わせとしてWebAPI用の限定言語方向のみ
					if (WebAPI::isSupport(WebAPI::TYPE_EXTERM_WEB_API, $langS, $langT) === TRUE){
						$arrRes[$id] = $title;
					}
				}
			} else if ( $result === RES_NO_DATA ){
				$result = RES_OK;
			} else {
				$result = RES_NG;
			}
		}
		
		return ($result === RES_OK) ? $arrRes : FALSE;
	}
	
	/***************************************************************
	 * 名前:getDisabledDocument
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getDisabledDocument( $taskID, $taskType ){
		$result = RES_OK;
		$arrRes = array();
		
		if ( ! Task::isSingleDocument($taskType) ){
			return $arrRes;
		}
		
		$objDAOTaskDocument = DAO::instance("task_document");
		
		if ( ($arrTask = $this->getTask($taskType)) === FALSE ){
			return FALSE;
		} else {
			if ( isset($arrTask[$taskID]) ){
				unset($arrTask[$taskID]);
			}
			$arrTaskID = array_keys($arrTask);

			if ( count($arrTaskID) > 0 ){
				$resDAOTaskDocument = $objDAOTaskDocument->get( $arrTaskID );
				$result = $resDAOTaskDocument["result"];
				
				if ( $result === RES_OK ){
					foreach ( $resDAOTaskDocument["data"] as $dataTaskDocument ){
						$id    = $dataTaskDocument["t_document_id"];
						$title = $dataTaskDocument["t_document_title"];
						
						$arrRes[$id] = $title;
					}
				} else if ( $result === RES_NO_DATA ){
					$result = RES_OK;
				} else {
					$result = RES_NG;
				}
			}
		}
		
		return ($result === RES_OK) ? $arrRes : FALSE;
	}
	
	/***************************************************************
	 * 名前:getTermRoot
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getTermRoot( $kind, $type = TRUE ){
		$result = RES_OK;
		$arrRes = array();
		
		$objDAOTermRoot  = DAO::instance("term_root", $kind);
		
		// 文書一覧 --------------------
		if ( $result === RES_OK ){
			$resDAOTermRoot = $objDAOTermRoot->get(NULL, DAO::T_TERM_ROOT_STATE_NORMAL, NULL, NULL, $this->id, $type);
			$result = $resDAOTermRoot["result"];
			
			if ( $result === RES_OK ){
				foreach ( $resDAOTermRoot["data"] as $dataTermRoot ){
					$id   = $dataTermRoot["t_term_root_id"];
					$name = $dataTermRoot["t_term_root_name"];
					
					if ( ! Validate::isString($name) ){
						continue;
					}
					$arrRes[$id] = $name;
				}
			} else if ( $result === RES_NO_DATA ){
				$result = RES_OK;
			} else {
				$result = RES_NG;
			}
		}
		
		return ($result === RES_OK) ? $arrRes : FALSE;
	}
	
	/***************************************************************
	 * 名前:getTermRootWebApiExterm
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getTermRootWebApiExterm( $kind, $type = TRUE ){
		$result = RES_OK;
		$arrRes = array();
		
		$objDAOTermRoot  = DAO::instance("term_root", $kind);
		
		// 文書一覧 --------------------
		if ( $result === RES_OK ){
			$resDAOTermRoot = $objDAOTermRoot->get(NULL, DAO::T_TERM_ROOT_STATE_NORMAL, NULL, NULL, $this->id, $type);
			$result = $resDAOTermRoot["result"];
			
			if ( $result === RES_OK ){
				foreach ( $resDAOTermRoot["data"] as $dataTermRoot ){
					$id    = $dataTermRoot["t_term_root_id"];
					$name  = $dataTermRoot["t_term_root_name"];
					$langS = $dataTermRoot["t_term_root_lang_s"];
					$langT = $dataTermRoot["t_term_root_lang_t"];
					
					// 言語方向の組み合わせとしてWebAPI用の限定言語方向のみ
					if (WebAPI::isSupport(WebAPI::TYPE_EXTERM_WEB_API, $langS, $langT) === TRUE){
						if ( ! Validate::isString($name) ){
							continue;
						}
						$arrRes[$id] = $name;
					}
				}
			} else if ( $result === RES_NO_DATA ){
				$result = RES_OK;
			} else {
				$result = RES_NG;
			}
		}
		
		return ($result === RES_OK) ? $arrRes : FALSE;
	}
	
	/***************************************************************
	 * 名前:getData
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function getData( $type = NULL ){
		$result = RES_OK;
		$arrRes = array();
		
		$objDAOData = DAO::instance("data");
		
		// 文書一覧 --------------------
		if ( $result === RES_OK ){
			$resDAOData = $objDAOData->get(NULL, DAO::T_DATA_STATE_NORMAL, NULL, $this->id, TRUE, $type);
			$result = $resDAOData["result"];
			
			if ( $result === RES_OK ){
				foreach ( $resDAOData["data"] as $resDAOData ){
					$id    = $resDAOData["t_data_id"];
					$title = $resDAOData["t_data_title"];
					
					if ( ! Validate::isString($title) ){
						continue;
					}
					$arrRes[$id] = $title;
				}
			} else if ( $result === RES_NO_DATA ){
				$result = RES_OK;
			} else {
				$result = RES_NG;
			}
		}
		
		return ($result === RES_OK) ? $arrRes : FALSE;
	}
	
	/***************************************************************
	 * 名前:getTask
	 * 説明:
	 * 引数:
	 * 返値:
	 ****************************************************************/
	function getTask( $type = NULL ){
		$result = RES_OK;
		$arrRes = array();
		
		$objDAOTask = DAO::instance("task");
		
		$workflowID = DAO::storedFunction("get_workflow_id_by_project_id", $this->id);
		if ( is_numeric($workflowID) ){
			$resDAOTask = $objDAOTask->get(NULL, array(DAO::T_TASK_STATE_NORMAL, DAO::T_TASK_STATE_CARIED, DAO::T_TASK_STATE_FINISH), $type, NULL, NULL, $workflowID);
			$result = $resDAOTask["result"];
			
			if ( $result === RES_OK ){
				foreach ( $resDAOTask["data"] as $dataTask ){
					$id   = $dataTask["t_task_id"];
					$type = $dataTask["t_task_type"];
					
					$arrRes[$id] = $type;
				}
			} else if ( $result === RES_NO_DATA ){
				$result = RES_OK;
			} else {
				$result = RES_NG;
			}
		} else {
			$result = RES_NG;
		}
		
		return ($result === RES_OK) ? $arrRes : FALSE;
	}
	
}
