<?php
Class QReditDict {
	// id
	const ID_GRANDCONCISE_ENJA = 0;
	const ID_EDICT_ENJA = 1;
	const ID_EDICT_JAEN = 2;
	const ID_EIJIRO_ENJA = 3;
	const ID_EIJIRO_JAEN = 4;
	const ID_WIKIPEDIA_ENJA = 5;
	const ID_WIKIPEDIA_JAEN = 6;
	const ID_WIKIPEDIA_ENCN = 7;
	const ID_WIKIPEDIA_CNEN = 8;
	const ID_WIKIPEDIA_JACN = 9;
	const ID_WIKIPEDIA_CNJA = 10;
	const ID_GAKKEN_ENJA = 11;
	const ID_GAKKEN_JAEN = 12;
	const ID_GAKKEN_ENCN = 13;
	const ID_GAKKEN_CNEN = 14;
	const ID_GAKKEN_JACN = 15;
	const ID_GAKKEN_CNJA = 16;
	const ID_USER_ENJA = 17;
	const ID_USER_JAEN = 18;
	const ID_USER_ENCN = 19;
	const ID_USER_CNEN = 20;
	const ID_USER_JACN = 21;
	const ID_USER_CNJA = 22;
	const ID_SCITERM_ENJA = 23;
	const ID_SCITERM_JAEN = 24;
	const ID_KCOM_JAEN = 25;
	const ID_EDR_JACN = 26;
	const ID_EDR_CNJA = 27;
	const ID_EDR_JATW = 28;
	const ID_USER_JATW = 29;
	const ID_DACCO_ENCA = 30;
	const ID_KJDICT_JAKO = 31;
	const ID_EZ_ENCN = 32;
	const ID_EZ_CNEN = 33;
	const ID_EDR_ENCN = 34;
	const ID_EDR_CNEN = 35;
	const ID_LDC_ENCN = 36;
	const ID_LDC_CNEN = 37;
	const ID_GCIDIOM_ENJA = 38;
	const ID_USER_JAKO = 39;
	const ID_WIKIPEDIA_ENCA = 40;
	const ID_JMDICT_JAFR = 41;
	const ID_JMDICT_FRJA = 42;
	const ID_JMDICT_JADE = 43;
	const ID_JMDICT_DEJA = 44;
	const ID_JMDICT_JARU = 45;
	const ID_JMDICT_RUJA = 46;
	const ID_ECOM110903_JAEN = 47;
	const ID_USER_ENCA = 48;
	const ID_USER_JAFR = 49;
	const ID_USER_FRJA = 50;
	const ID_USER_JADE = 51;
	const ID_USER_DEJA = 52;
	const ID_USER_JARU = 53;
	const ID_USER_RUJA = 54;
	const ID_WDK_JADE = 55;
	const ID_WDK_DEJA = 56;
	const ID_GRANDCONCISE_JAEN = 57;
	const ID_WDKIDIOM_JADE = 58;
	const ID_FREEBSD_ENKO = 59;
	const ID_FREEBSD_KOEN = 60;
	const ID_DICTSINFO_ENES = 61;
	const ID_DICTSINFO_ESEN = 62;
	
	// dict
	const DICT_EI = 1;  // 英辞郎
	const DICT_GC = 2;  // グランドコンサイス
	const DICT_ED = 3;  // Edict
	const DICT_WI = 4;  // Wikipedia
	const DICT_UD = 5;  // ユーザー辞書
	const DICT_GA = 6;  // 学研
	const DICT_NI = 7;  // 学術用語
	const DICT_KC = 8;  // Ecom
	const DICT_ER = 9;  // EDR
	const DICT_EC = 10;  // Dacco
	const DICT_JK = 11;  // KJ
	const DICT_EZ = 12;  // ez
	const DICT_LD = 13;  // LDC
	const DICT_JM = 14;  // JMDict
	const DICT_DK = 15;  // WaDoku
	const DICT_BS = 17;  // FreeBSD
	const DICT_DI = 18;  // Dicts.info
	
	// table
	protected static $ID_TABLE_INITIALIZE = FALSE;
	protected static $ID_TABLE = array();
	
	private static function sort_OrderDict($a, $b){
		if ( $a["dict"] < $b["dict"] ){
			return -1;
		} else if ( $a["dict"] > $b["dict"] ){
			return 1;
		} else {
			return ($a["id"] < $b["id"]) ? -1 : 1;
		}
	}
	
	private static function idTableInitizalize(){
		global $WORD;
		$wk = "WORD_P_CLASS_QREDITDICT";
		
		if ( self::$ID_TABLE_INITIALIZE ){
			return;
		}
		self::$ID_TABLE_INITIALIZE = TRUE;
		
		$arrTable = array(
			// ----- 英辞郎 --------------------------------------------------
			/*
			self::ID_EIJIRO_ENJA => array(
				"dict" => self::DICT_EI,
				"slang" => LANG_EN,
				"tlang" => LANG_JA,
			),
			self::ID_EIJIRO_JAEN => array(
				"dict" => self::DICT_EI,
				"slang" => LANG_JA,
				"tlang" => LANG_EN,
			),
			 */
			// ----- グランドコンサイス --------------------------------------------------
			self::ID_GRANDCONCISE_ENJA => array(
				"dict" => self::DICT_GC,
				"slang" => LANG_EN,
				"tlang" => LANG_JA,
			),
			self::ID_GCIDIOM_ENJA => array(
				"name" => "{$WORD($wk, 1)}",
				"dict" => self::DICT_GC,
				"slang" => LANG_EN,
				"tlang" => LANG_JA,
				"fix" => OFF,             //イディオム辞書はグランドコンサイスに連動する
			),
			self::ID_GRANDCONCISE_JAEN => array(
				"dict" => self::DICT_GC,
				"slang" => LANG_JA,
				"tlang" => LANG_EN,
			),
			// ----- Edict --------------------------------------------------
			self::ID_EDICT_ENJA => array(
				"dict" => self::DICT_ED,
				"slang" => LANG_EN,
				"tlang" => LANG_JA,
			),
			self::ID_EDICT_JAEN => array(
				"dict" => self::DICT_ED,
				"slang" => LANG_JA,
				"tlang" => LANG_EN,
			),
			// ----- Wikipedia --------------------------------------------------
			self::ID_WIKIPEDIA_ENJA => array(
				"dict" => self::DICT_WI,
				"slang" => LANG_EN,
				"tlang" => LANG_JA,
			),
			self::ID_WIKIPEDIA_JAEN => array(
				"dict" => self::DICT_WI,
				"slang" => LANG_JA,
				"tlang" => LANG_EN,
			),
			self::ID_WIKIPEDIA_ENCN => array(
				"dict" => self::DICT_WI,
				"slang" => LANG_EN,
				"tlang" => LANG_CN,
			),
			self::ID_WIKIPEDIA_CNEN => array(
				"dict" => self::DICT_WI,
				"slang" => LANG_CN,
				"tlang" => LANG_EN,
			),
			/*
			self::ID_WIKIPEDIA_JACN => array(
				"dict" => self::DICT_WI,
				"slang" => LANG_JA,
				"tlang" => LANG_CN,
			),
			self::ID_WIKIPEDIA_CNJA => array(
				"dict" => self::DICT_WI,
				"slang" => LANG_CN,
				"tlang" => LANG_JA,
			),
			self::ID_WIKIPEDIA_ENCA => array(
				"dict" => self::DICT_WI,
				"slang" => LANG_EN,
				"tlang" => LANG_CA,
			),
			 */
			// ----- ユーザー辞書 --------------------------------------------------
			self::ID_USER_ENJA => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_EN,
				"tlang" => LANG_JA,
				"fix" => ON,
			),
			self::ID_USER_JAEN => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_JA,
				"tlang" => LANG_EN,
				"fix" => ON,
			),
			self::ID_USER_ENCN => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_EN,
				"tlang" => LANG_CN,
				"fix" => ON,
			),
			self::ID_USER_CNEN => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_CN,
				"tlang" => LANG_EN,
				"fix" => ON,
			),
			self::ID_USER_JACN => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_JA,
				"tlang" => LANG_CN,
				"fix" => ON,
			),
			self::ID_USER_CNJA => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_CN,
				"tlang" => LANG_JA,
				"fix" => ON,
			),
			self::ID_USER_JATW => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_JA,
				"tlang" => LANG_TW,
				"fix" => ON,
			),
			self::ID_USER_JAKO => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_JA,
				"tlang" => LANG_KO,
				"fix" => ON,
			),
			self::ID_USER_ENCA => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_EN,
				"tlang" => LANG_CN,
				"fix" => ON,
			),
			self::ID_USER_JAFR => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_JA,
				"tlang" => LANG_FR,
				"fix" => ON,
			),
			self::ID_USER_FRJA => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_FR,
				"tlang" => LANG_JA,
				"fix" => ON,
			),
			self::ID_USER_JADE => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_JA,
				"tlang" => LANG_DE,
				"fix" => ON,
			),
			self::ID_USER_DEJA => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_DE,
				"tlang" => LANG_JA,
				"fix" => ON,
			),
			self::ID_USER_JARU => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_JA,
				"tlang" => LANG_RU,
				"fix" => ON,
			),
			self::ID_USER_RUJA => array(
				"dict" => self::DICT_UD,
				"slang" => LANG_RU,
				"tlang" => LANG_JA,
				"fix" => ON,
			),
			// ----- 学研 --------------------------------------------------
			/*
			self::ID_GAKKEN_ENJA => array(
				"dict" => self::DICT_GA,
				"slang" => LANG_EN,
				"tlang" => LANG_JA,
			),
			self::ID_GAKKEN_JAEN => array(
				"dict" => self::DICT_GA,
				"slang" => LANG_JA,
				"tlang" => LANG_EN,
			),
			 */
			/*
			self::ID_GAKKEN_ENCN => array(
				"dict" => self::DICT_GA,
				"slang" => LANG_EN,
				"tlang" => LANG_CN,
			),
			 */
			/*
			self::ID_GAKKEN_CNEN => array(
				"dict" => self::DICT_GA,
				"slang" => LANG_CN,
				"tlang" => LANG_EN,
			),
			self::ID_GAKKEN_JACN => array(
				"dict" => self::DICT_GA,
				"slang" => LANG_JA,
				"tlang" => LANG_CN,
			),
			self::ID_GAKKEN_CNJA => array(
				"dict" => self::DICT_GA,
				"slang" => LANG_CN,
				"tlang" => LANG_JA,
			),
			 */
			// ----- 学術用語 --------------------------------------------------
			/*
			self::ID_SCITERM_ENJA => array(
				"dict" => self::DICT_NI,
				"slang" => LANG_EN,
				"tlang" => LANG_JA,
			),
			self::ID_SCITERM_JAEN => array(
				"dict" => self::DICT_NI,
				"slang" => LANG_JA,
				"tlang" => LANG_EN,
			),
			 */
			// ----- Ecom --------------------------------------------------
			/*
			self::ID_KCOM_JAEN => array(
				"dict" => self::DICT_KC,
				"slang" => LANG_JA,
				"tlang" => LANG_EN,
			),
			self::ID_ECOM110903_JAEN => array(
				"dict" => self::DICT_KC,
				"slang" => LANG_JA,
				"tlang" => LANG_EN,
			),
			 */
			// ----- EDR --------------------------------------------------
			/*
			self::ID_EDR_JACN => array(
				"dict" => self::DICT_ER,
				"slang" => LANG_JA,
				"tlang" => LANG_CN,
			),
			self::ID_EDR_CNJA => array(
				"dict" => self::DICT_ER,
				"slang" => LANG_CN,
				"tlang" => LANG_JA,
			),
			self::ID_EDR_JATW => array(
				"dict" => self::DICT_ER,
				"slang" => LANG_JA,
				"tlang" => LANG_TW,
			),
			 */
			self::ID_EDR_ENCN => array(
				"dict" => self::DICT_ER,
				"slang" => LANG_EN,
				"tlang" => LANG_CN,
			),
			self::ID_EDR_CNEN => array(
				"dict" => self::DICT_ER,
				"slang" => LANG_CN,
				"tlang" => LANG_EN,
			),
			// ----- Dacco --------------------------------------------------
			/*
			self::ID_DACCO_ENCA => array(
				"dict" => self::DICT_EC,
				"slang" => LANG_EN,
				"tlang" => LANG_CN,
			),
			 */
			// ----- KJ --------------------------------------------------
			self::ID_KJDICT_JAKO => array(
				"dict" => self::DICT_JK,
				"slang" => LANG_JA,
				"tlang" => LANG_KO,
			),
			// ----- ez --------------------------------------------------
			/*
			self::ID_EZ_ENCN => array(
				"dict" => self::DICT_EZ,
				"slang" => LANG_EN,
				"tlang" => LANG_CN,
			),
			self::ID_EZ_CNEN => array(
				"dict" => self::DICT_EZ,
				"slang" => LANG_CN,
				"tlang" => LANG_CN,
			),
			 */
			// ----- LDC --------------------------------------------------
			self::ID_LDC_ENCN => array(
				"dict" => self::DICT_LD,
				"slang" => LANG_EN,
				"tlang" => LANG_CN,
			),
			self::ID_LDC_CNEN => array(
				"dict" => self::DICT_LD,
				"slang" => LANG_CN,
				"tlang" => LANG_EN,
			),
			// ----- JMDict --------------------------------------------------
			/*
			self::ID_JMDICT_JAFR => array(
				"dict" => self::DICT_JM,
				"slang" => LANG_JA,
				"tlang" => LANG_FR,
			),
			self::ID_JMDICT_FRJA => array(
				"dict" => self::DICT_JM,
				"slang" => LANG_FR,
				"tlang" => LANG_JA,
			),
			self::ID_JMDICT_JADE => array(
				"dict" => self::DICT_JM,
				"slang" => LANG_JA,
				"tlang" => LANG_DE,
			),
			self::ID_JMDICT_DEJA => array(
				"dict" => self::DICT_JM,
				"slang" => LANG_DE,
				"tlang" => LANG_JA,
			),
			self::ID_JMDICT_JARU => array(
				"dict" => self::DICT_JM,
				"slang" => LANG_JA,
				"tlang" => LANG_RU,
			),
			self::ID_JMDICT_RUJA => array(
				"dict" => self::DICT_JM,
				"slang" => LANG_RU,
				"tlang" => LANG_JA,
			),
			 */
			// ----- WaDoku --------------------------------------------------
			self::ID_WDK_JADE => array(
				"dict" => self::DICT_DK,
				"slang" => LANG_JA,
				"tlang" => LANG_DE,
			),
			self::ID_WDK_DEJA => array(
				"dict" => self::DICT_DK,
				"slang" => LANG_DE,
				"tlang" => LANG_JA,
			),
			/*
			self::ID_WDKIDIOM_JADE => array(
				"dict"  => self::DICT_DK2,
				"slang" => LANG_JA,
				"tlang" => LANG_DE,
				"fix" => OFF,             //イディオム辞書は連動する
			),
			 */
			// ----- FreeBSD --------------------------------------------------
			self::ID_FREEBSD_ENKO => array(
				"dict" => self::DICT_BS,
				"slang" => LANG_EN,
				"tlang" => LANG_KO,
			),
			self::ID_FREEBSD_KOEN => array(
				"dict" => self::DICT_BS,
				"slang" => LANG_KO,
				"tlang" => LANG_EN,
			),
			// ----- Dicts.Info --------------------------------------------------
			self::ID_DICTSINFO_ENES => array(
				"dict" => self::DICT_DI,
				"slang" => LANG_EN,
				"tlang" => LANG_ES,
			),
			self::ID_DICTSINFO_ESEN => array(
				"dict" => self::DICT_DI,
				"slang" => LANG_ES,
				"tlang" => LANG_EN,
			),
		);
		
		$arrValidTable = array();
		$dictTable = self::DICT_TABLE();
		foreach ( $arrTable as $id => $value ){
			$dict = $arrTable[$id]["dict"];
			if ( ! isset($dictTable[$dict]) ){
				continue;
			}
			$arrValidTable[$id] = $value;
			$arrValidTable[$id]["id"] = $id;
		}
		
		uasort($arrValidTable, array("self", "sort_OrderDict"));
		self::$ID_TABLE = $arrValidTable;
	}
	
	public static function ID_TABLE( $key = NULL ){
		self::idTableInitizalize();
		
		return is_null($key) ? self::$ID_TABLE : self::$ID_TABLE[$key];
	}

	public static function DICT_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_QREDITDICT";
		
		$arrTable = array(
			self::DICT_EI => "{$WORD($wk, 2)}",  // 英辞郎
			self::DICT_GC => "{$WORD($wk, 3)}",  // グランドコンサイス
			self::DICT_ED => "{$WORD($wk, 4)}",  // Edict
			self::DICT_WI => "{$WORD($wk, 5)}",  // Wikipedia
			self::DICT_UD => "{$WORD($wk, 6)}",  // ユーザー辞書
			self::DICT_GA => "{$WORD($wk, 7)}",  // 学研
			self::DICT_NI => "{$WORD($wk, 8)}",  // 学術用語
			self::DICT_KC => "{$WORD($wk, 9)}",  // Ecom
			self::DICT_ER => "{$WORD($wk, 10)}",  // EDR
			self::DICT_EC => "{$WORD($wk, 11)}",  // Dacco
			self::DICT_JK => "{$WORD($wk, 12)}",  // KJ
			self::DICT_EZ => "{$WORD($wk, 13)}",  // ez
			self::DICT_LD => "{$WORD($wk, 14)}",  // LDC
			self::DICT_JM => "{$WORD($wk, 15)}",  // JMDict
			self::DICT_DK => "{$WORD($wk, 16)}",  // WaDoku
			self::DICT_BS => "{$WORD($wk, 17)}",  // FreeBSD
			self::DICT_DI => "{$WORD($wk, 18)}",  // Dicts.Info
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function FLAG_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_QREDITDICT";
		
		$arrTable = array(
			ON => "ON",
			OFF => "OFF",
			"-" => "{$WORD($wk, 19)}" // ユーザー設定を継承,
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function FixIDs( $ids = 0 ){
		foreach ( self::ID_TABLE() as $id => $value ){
			if ( isset($value["fix"])) {
				if ( $id >= (PHP_INT_SIZE * 8) ){
					// 32bitの場合、それ以上は計算させない
					continue;
				}
				if ( $value["fix"] === ON ){
					$ids |= pow(2, $id);
				} else if ( $value["fix"] === OFF ){
					$ids |= pow(2, $id);
					$ids ^= pow(2, $id);
				}
			}
		}
		
		return $ids;
	}
	
	public static function IDsToBitFlag( $ids ){
		if ( is_array($ids) ){
			$bit = 0;
			foreach ( $ids as $id ){
				$bit += pow(2, $id);
			}
			return $bit;
		} else {
			return 0;
		   //	pow(2, $ids);
		}
	}
	
	public static function BitFlagToIDs( $bitflag ){
		$ids = array();
		$id = 0;
		while ( $bitflag !== 0 ){
			if ( ($bitflag & 1) === 1 ){
				$ids[] = $id;
			}
			$bitflag = ($bitflag >> 1);
			$id += 1;
		}
		return $ids;
	}
	
	public static function isBitFlag( $value, $id ){
		return ($value & self::IDsToBitFlag($id)) > 0;
	}
	
	public static function getDictionaryName( $id ){
		$value = self::ID_TABLE($id);
		if ( isset($value["name"]) ){
			return $value["name"];
		} else {
			return self::DICT_TABLE($value["dict"]);
		}
	}
}

