<?php
Class Statistics {
	const KIND_TASK_USER     = 1;
	const KIND_TASK_DOCUMENT = 2;
	const KIND_TASK_ROLE     = 3;
	const KIND_BBS_LOG          = 4;
	const KIND_BBS_FLOW_CHARTS  = 5;
	const KIND_BBS_BAR_GRAPH    = 6;
	const KIND_BBS_LINE_GRAPH   = 7;
	
	const SYSTEM_KIND_TASK_PROJECT          = 1;
	const SYSTEM_KIND_TASK_DOCUMENT         = 2;
	const SYSTEM_KIND_LOOKUP_TEXT           = 11;
	const SYSTEM_KIND_LOOKUP_PROJECT        = 12;
	const SYSTEM_KIND_LOOKUP_DOCUMENT       = 13;
	const SYSTEM_KIND_SELLOOKUP_TEXT        = 21;
	const SYSTEM_KIND_SELLOOKUP_PROJECT     = 22;
	const SYSTEM_KIND_SELLOOKUP_DOCUMENT    = 23;
	const SYSTEM_KIND_ORGTASK_USER          = 101;
	const SYSTEM_KIND_ORGTASK_PROJECT       = 102;
	const SYSTEM_KIND_ORGTASK_DOCUMENT      = 103;
	const SYSTEM_KIND_ORGLOOKUP_TEXT        = 111;
	const SYSTEM_KIND_ORGLOOKUP_PROJECT     = 112;
	const SYSTEM_KIND_ORGLOOKUP_DOCUMENT    = 113;
	const SYSTEM_KIND_ORGSELLOOKUP_TEXT     = 121;
	const SYSTEM_KIND_ORGSELLOOKUP_PROJECT  = 122;
	const SYSTEM_KIND_ORGSELLOOKUP_DOCUMENT = 123;
	const SYSTEM_KIND_ORGANIZATION          = 201;
	const SYSTEM_KIND_LOGIN                 = 202;
	
	/***************************************************************
	 * 名前:KIND_TABLE
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function KIND_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_STATISTICS";
		
		$arrTable = array(
			self::KIND_TASK_USER       => "{$WORD($wk, 1)}",
			self::KIND_TASK_DOCUMENT   => "{$WORD($wk, 2)}",
			self::KIND_TASK_ROLE       => "{$WORD($wk, 3)}",
			self::KIND_BBS_LOG         => "{$WORD($wk, 4)}",
			self::KIND_BBS_FLOW_CHARTS => "{$WORD($wk, 5)}",
			self::KIND_BBS_BAR_GRAPH   => "{$WORD($wk, 6)}",
			self::KIND_BBS_LINE_GRAPH  => "{$WORD($wk, 7)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function SYSTEM_KIND_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_STATISTICS";
		
		$arrTable = array(
			self::SYSTEM_KIND_TASK_PROJECT       => "{$WORD($wk, 8)}",
			self::SYSTEM_KIND_TASK_DOCUMENT      => "{$WORD($wk, 9)}",
			self::SYSTEM_KIND_LOOKUP_TEXT        => "{$WORD($wk, 10)}",
			self::SYSTEM_KIND_LOOKUP_PROJECT     => "{$WORD($wk, 11)}",
			self::SYSTEM_KIND_LOOKUP_DOCUMENT    => "{$WORD($wk, 12)}",
			self::SYSTEM_KIND_SELLOOKUP_TEXT     => "{$WORD($wk, 13)}",
			self::SYSTEM_KIND_SELLOOKUP_PROJECT  => "{$WORD($wk, 14)}",
			self::SYSTEM_KIND_SELLOOKUP_DOCUMENT => "{$WORD($wk, 15)}",
			//---
			self::SYSTEM_KIND_ORGTASK_USER          => "{$WORD($wk, 16)}",
			self::SYSTEM_KIND_ORGTASK_PROJECT       => "{$WORD($wk, 17)}",
			self::SYSTEM_KIND_ORGTASK_DOCUMENT      => "{$WORD($wk, 18)}",
			self::SYSTEM_KIND_ORGLOOKUP_TEXT        => "{$WORD($wk, 19)}",
			self::SYSTEM_KIND_ORGLOOKUP_PROJECT     => "{$WORD($wk, 20)}",
			self::SYSTEM_KIND_ORGLOOKUP_DOCUMENT    => "{$WORD($wk, 21)}",
			self::SYSTEM_KIND_ORGSELLOOKUP_TEXT     => "{$WORD($wk, 22)}",
			self::SYSTEM_KIND_ORGSELLOOKUP_PROJECT  => "{$WORD($wk, 23)}",
			self::SYSTEM_KIND_ORGSELLOOKUP_DOCUMENT => "{$WORD($wk, 24)}",
			//---
			self::SYSTEM_KIND_ORGANIZATION => "{$WORD($wk, 25)}",
			self::SYSTEM_KIND_LOGIN        => "{$WORD($wk, 26)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function viewInstance( $kind, $isSystem = FALSE ){
		$class = "statistics";
		
		if ( $isSystem ){
			switch ( $kind ){
				case self::SYSTEM_KIND_TASK_PROJECT:
				case self::SYSTEM_KIND_TASK_DOCUMENT:
				case self::SYSTEM_KIND_ORGTASK_USER:
				case self::SYSTEM_KIND_ORGTASK_PROJECT:
				case self::SYSTEM_KIND_ORGTASK_DOCUMENT:
					$class = "statistics_task";
					break;
				case self::SYSTEM_KIND_LOOKUP_TEXT:
				case self::SYSTEM_KIND_LOOKUP_PROJECT:
				case self::SYSTEM_KIND_LOOKUP_DOCUMENT:
				case self::SYSTEM_KIND_ORGLOOKUP_TEXT:
				case self::SYSTEM_KIND_ORGLOOKUP_PROJECT:
				case self::SYSTEM_KIND_ORGLOOKUP_DOCUMENT:
					$class = "statistics_lookup";
					break;
				case self::SYSTEM_KIND_SELLOOKUP_TEXT:
				case self::SYSTEM_KIND_SELLOOKUP_PROJECT:
				case self::SYSTEM_KIND_SELLOOKUP_DOCUMENT:
				case self::SYSTEM_KIND_ORGSELLOOKUP_TEXT:
				case self::SYSTEM_KIND_ORGSELLOOKUP_PROJECT:
				case self::SYSTEM_KIND_ORGSELLOOKUP_DOCUMENT:
					$class = "statistics_sellookup";
					break;
				//---
				case self::SYSTEM_KIND_ORGANIZATION:
				case self::SYSTEM_KIND_LOGIN:
					$class = "statistics";
			}
		} else {
			switch ( $kind ){
				case self::KIND_TASK_USER:
				case self::KIND_TASK_DOCUMENT:
				case self::KIND_TASK_ROLE:
					$class = "statistics_task";
					break;
				case self::KIND_BBS_LOG:
				case self::KIND_BBS_FLOW_CHARTS:
				case self::KIND_BBS_BAR_GRAPH:
				case self::KIND_BBS_LINE_GRAPH:
					$class = "statistics_bbspost";
			}
		}
		
		return View::instance($class);
	}
	
}
