<?php
Class Task {
	// roles
	const ROLE_INIT = 0x0000;  // 役割(初期値)
	const ROLE_RREQ = 0x0001;  // 役割(requester)
	const ROLE_RPMG = 0x0002;  // 役割(project-manager)
	const ROLE_RRES = 0x0004;  // 役割(researcher)
	const ROLE_RTMG = 0x0008;  // 役割(terminologist)
	const ROLE_RTRA = 0x0010;  // 役割(translator)
	const ROLE_RREV = 0x0020;  // 役割(reviser)
	const ROLE_RRVW = 0x0040;  // 役割(reviewer)
	const ROLE_RPFR = 0x0080;  // 役割(proof-reader)
	const ROLE_RTMM = 0x0100;  // 役割(tm-manager)
	const ROLE_RMTM = 0x0200;  // 役割(mt-manager)
	const ROLE_RPRE = 0x0400;  // 役割(mt-pre-editor)
	const ROLE_RPED = 0x0800;  // 役割(mt-post-editor)
	const ROLE_ROBS = 0x1000;  // 役割(observer)
	const ROLE_ARHD = 0x2000;  // 役割(role-holder)
	const ROLE_ATRP = 0x4000;  // 役割(translation-pool)
	const ROLE_ATTM = 0x8000;  // 役割(translation-term)
	// props-type
	const PROPTYPE_NONE                     = 0;
	const PROPTYPE_TEXT                     = 1;
	const PROPTYPE_DOCUMENT                 = 2;
	const PROPTYPE_TERM_ROOT_ALL            = 3;
	const PROPTYPE_TERM_ROOT_PROJECT        = 4;
	const PROPTYPE_TERM_ROOT_REFERENCE      = 5;
	const PROPTYPE_BILINGUAL_ROOT_ALL       = 6;
	const PROPTYPE_BILINGUAL_ROOT_PROJECT   = 7;
	const PROPTYPE_BILINGUAL_ROOT_REFERENCE = 8;
	const PROPTYPE_DATA_ALL                 = 9;
	const PROPTYPE_DATA_BRIEF               = 10;
	const PROPTYPE_DATA_DELIVERABLE         = 11;
	const PROPTYPE_DATA_RESEARCH_RESULTS    = 12;
	const PROPTYPE_DATA_OTHERS              = 13;
	// proplabel
	const PROPLABEL_BRIEF                   = 1;
	const PROPLABEL_DELIVERABLE             = 2;
	const PROPLABEL_FINAL_DELIVERABLE       = 3;
	const PROPLABEL_RESEARCH_RESULT         = 4;
	const PROPLABEL_DATA_OTHERS             = 5;
	const PROPLABEL_REGISTER_PARTICIPANTS   = 6;
	const PROPLABEL_WORKFLOW_BRIEF          = 7;
	const PROPLABEL_SCHEDULE                = 8;
	const PROPLABEL_SOURCE_GLOSSARY         = 9;
	const PROPLABEL_DRAFT_GLOSSARY          = 10;
	const PROPLABEL_VALID_GLOSSARY          = 11;
	const PROPLABEL_SOURCE_DOCUMENT         = 12;
	const PROPLABEL_DOCUMENT_LIST           = 13;
	const PROPLABEL_DRAFT_DOCUMENT          = 14;
	const PROPLABEL_REVISED_DOCUMENT        = 15;
	const PROPLABEL_REVIEWED_DOCUMENT       = 16;
	const PROPLABEL_PROOFED_DOCUMENT        = 17;
	const PROPLABEL_TRANSED_DOCUMENT        = 18;
	const PROPLABEL_RAW_DOCUMENT            = 19;
	const PROPLABEL_PRE_EDITED_DOCUMENT     = 20;
	const PROPLABEL_POST_EDITED_DOCUMENT    = 21;
	const PROPLABEL_TERM_ROOT               = 22;
	const PROPLABEL_PROJECT_TERM_ROOT       = 23;
	const PROPLABEL_REFERENCE_TERM_ROOT     = 24;
	const PROPLABEL_BILINGUAL_ROOT          = 25;
	const PROPLABEL_PROJECT_BILINGUAL_ROOT  = 26;
	const PROPLABEL_REFRENCE_BILINGUAL_ROOT = 27;
	const PROPLABEL_NO_REGISTER_TERM        = 28;
	const PROPLABEL_MT                      = 29;
	// type
	const TYPE_BRIEF_AGREE                   =  1;  // タスクタイプ(TAGB:brief-agree)
	const TYPE_BRIEF_SIGN_OFF                =  2;  // タスクタイプ(TSOJ:brief-sign-off)
	const TYPE_WORKFLOW_SELECT               =  3;  // タスクタイプ(TWKF:workflow-select)
	//const TYPE_WORKFLOW_FILL_ROLES           =  4;  // タスクタイプ(TFTR:workflow-fill-roles)
	//const TYPE_WORKFLOW_ASSIGN_DOCUMENTS     =  5;  // タスクタイプ(TADC:workflow-assign-documents)
	//const TYPE_WORKFLOW_ASSIGN_TIME_SLOTS    =  6;  // タスクタイプ(TATS:workflow-assign-time-slots)
	const TYPE_WORKFLOW_MONITOR              =  7;  // タスクタイプ(TMON:workflow-monitor)
	const TYPE_WORKFLOW_ASSEMBLE_TARGET_DOCS =  8;  // タスクタイプ(TASS:workflow-assemble-target-docs)
	const TYPE_WORKFLOW_REGISTER_PARTICIPANTS = 24; // タスクタイプ(TRPA:workflow-register-participants)
	const TYPE_WORKFLOW_REGISTER_DOCUMENTS    = 25; // タスクタイプ(TRDO:workflow-register-documents)
	const TYPE_WORKFLOW_ALLOCATE_TASKS        = 26; // タスクタイプ(TALL:workflow-allocate-tasks)
	const TYPE_TERMINOLOGY_EXTRACT_NEW       =  9;  // タスクタイプ(TEXT:terminology-extract-new)
	const TYPE_TERMINOLOGY_TRANSLATE         = 10;  // タスクタイプ(TTRT:terminology-translate)
	const TYPE_TERMINOLOGY_VALIDATE          = 11;  // タスクタイプ(TVAL:terminology-validate)
	const TYPE_TERMINOLOGY_COMPILE           = 12;  // タスクタイプ(TGLO:terminology-compile)
	const TYPE_TRANSLATION_RESEARCH          = 13;  // タスクタイプ(TRES:translation-research)
	const TYPE_TRANSLATION_TRANSLATE         = 14;  // タスクタイプ(THTR:translation-translate)
	const TYPE_TRANSLATION_REVISE            = 15;  // タスクタイプ(TREV:translation-revise)
	const TYPE_TRANSLATION_REVIEW            = 16;  // タスクタイプ(TRVW:translation-review)
	const TYPE_TRANSLATION_PROOF_READ        = 17;  // タスクタイプ(TPFR:translation-proof-read)
	const TYPE_TM_SELECT                     = 18;  // タスクタイプ(TSTM:tm-select)
	const TYPE_TM_UPDATE                     = 19;  // タスクタイプ(TUTM:tm-update)
	const TYPE_MT_PRE_EDIT                   = 20;  // タスクタイプ(TPRE:mt-pre-edit)
	const TYPE_MT_TRANSLATE                  = 21;  // タスクタイプ(TMTR:mt-translate)
	const TYPE_MT_POST_EDIT                  = 22;  // タスクタイプ(TPED:mt-post-edit)
	const TYPE_MT_UPDATE                     = 23;  // タスクタイプ(TUMT:mt-update)
	// type_group
	const TYPE_GROUP_BRIEF    = 1;
	const TYPE_GROUP_WORKFLOW = 2;
	const TYPE_GROUP_TERM     = 3;
	const TYPE_GROUP_TRANS    = 4;
	const TYPE_GROUP_TM       = 5;
	const TYPE_GROUP_MT       = 6;
	// type_operation_group
	const TYPE_OPERATION_GROUP_FULL     = 1;
	const TYPE_OPERATION_GROUP_MAXIMUM  = 2;
	const TYPE_OPERATION_GROUP_EXTENDED = 3;
	const TYPE_OPERATION_GROUP_CORE     = 4;
	const TYPE_OPERATION_GROUP_MINIMUM  = 5;
	
	protected static $SETTING_TABLE = array(
		// ********************
		// * brief
		// ********************
		// 概要確認(brief-agree)
		self::TYPE_BRIEF_AGREE => array(
			"group" => self::TYPE_GROUP_BRIEF,
			"stage" => DAO::T_BBS_POST_STAGE_COMMIT,
			"actor" => array(
				array("r" => self::ROLE_RPMG, "require" => TRUE),
				array("r" => self::ROLE_RREQ, "require" => TRUE),
			),
			"input" => array(
				"source-documents" => array("type" => self::PROPTYPE_DOCUMENT,              "label" => self::PROPLABEL_SOURCE_DOCUMENT, "selected" => TRUE, "require" => FALSE),
				"research-results" => array("type" => self::PROPTYPE_DATA_RESEARCH_RESULTS, "label" => self::PROPLABEL_RESEARCH_RESULT, "selected" => FALSE),
				"other"            => array("type" => self::PROPTYPE_DATA_OTHERS,           "label" => self::PROPLABEL_DATA_OTHERS,     "selected" => FALSE),
			),
			"output" => array(
				"brief" => array("type" => self::PROPTYPE_DATA_BRIEF, "label" => self::PROPLABEL_BRIEF, "selected" => FALSE),
			)
		),
		// 成果物の最終確認(brief-sign-off)
		self::TYPE_BRIEF_SIGN_OFF => array(
			"group" => self::TYPE_GROUP_BRIEF,
			"stage" => DAO::T_BBS_POST_STAGE_SIGNOFF,
			"actor" => array(
				array("r" => self::ROLE_RPMG, "require" => TRUE),
				array("r" => self::ROLE_RREQ, "require" => TRUE),
			),
			"input" => array(
				"deliverable" => array("type" => self::PROPTYPE_DATA_DELIVERABLE, "label" => self::PROPLABEL_DELIVERABLE, "selected" => FALSE),
				"brief"       => array("type" => self::PROPTYPE_DATA_BRIEF,       "label" => self::PROPLABEL_BRIEF,       "selected" => FALSE),
			),
			"output" => array(
				"final-deliverable" => array("type" => self::PROPTYPE_DATA_DELIVERABLE, "label" => self::PROPLABEL_FINAL_DELIVERABLE, "selected" => FALSE),
			)
		),
		// ********************
		// * workflow
		// ********************
		// 参加者登録(workflow-register-participants)
		self::TYPE_WORKFLOW_REGISTER_PARTICIPANTS => array(
			"group" => self::TYPE_GROUP_WORKFLOW,
			"stage" => DAO::T_BBS_POST_STAGE_PREPARE,
			"actor" => array(
				array("r" => self::ROLE_RPMG, "require" => TRUE),
			),
			"input" => array(
				"source-documents" => array("type" => self::PROPTYPE_DOCUMENT,   "label" => self::PROPLABEL_SOURCE_DOCUMENT, "selected" => TRUE, "require" => FALSE),
				"brief"            => array("type" => self::PROPTYPE_DATA_BRIEF, "label" => self::PROPLABEL_BRIEF,           "selected" => FALSE),
			),
			"output" => array(
				"*" => array("type" => self::PROPTYPE_NONE, "label" => self::PROPLABEL_REGISTER_PARTICIPANTS, "selected" => FALSE),
			),
		),
		// 文書登録(workflow-register-documents)
		self::TYPE_WORKFLOW_REGISTER_DOCUMENTS => array(
			"group" => self::TYPE_GROUP_WORKFLOW,
			"stage" => DAO::T_BBS_POST_STAGE_PREPARE,
			"actor" => array(
				array("r" => self::ROLE_RPMG, "require" => TRUE),
			),
			"input" => array(
				"brief" => array("type" => self::PROPTYPE_DATA_BRIEF, "label" => self::PROPLABEL_BRIEF, "selected" => FALSE),
			),
			"output" => array(
				"source-documents" => array("type" => self::PROPTYPE_DOCUMENT, "label" => self::PROPLABEL_DOCUMENT_LIST, "selected" => FALSE),
			),
		),
		// 作業選択＆期間指定(workflow-select)
		self::TYPE_WORKFLOW_SELECT => array(
			"group" => self::TYPE_GROUP_WORKFLOW,
			"stage" => DAO::T_BBS_POST_STAGE_PREPARE,
			"actor" => array(
				array("r" => self::ROLE_RPMG, "require" => TRUE),
			),
			"input" => array(
				"brief" => array("type" => self::PROPTYPE_DATA_BRIEF, "label" => self::PROPLABEL_BRIEF, "selected" => FALSE),
			),
			"output" => array(
				"*" => array("type" => self::PROPTYPE_NONE, "label" => self::PROPLABEL_WORKFLOW_BRIEF, "selected" => FALSE),
			)
		),
		// タスク割り当て(workflow-allocate-tasks)
		self::TYPE_WORKFLOW_ALLOCATE_TASKS => array(
			"group" => self::TYPE_GROUP_WORKFLOW,
			"stage" => DAO::T_BBS_POST_STAGE_PREPARE,
			"actor" => array(
				array("r" => self::ROLE_RPMG, "require" => TRUE),
			),
			"input" => array(
				"brief" => array("type" => self::PROPTYPE_DATA_BRIEF, "label" => self::PROPLABEL_BRIEF, "selected" => FALSE),
			),
			"output" => array(
				"*" => array("type" => self::PROPTYPE_NONE, "label" => self::PROPLABEL_SCHEDULE, "selected" => FALSE),
			)
		),
		self::TYPE_WORKFLOW_MONITOR => array(  // タスクタイプ(workflow-monitor)
			"group" => self::TYPE_GROUP_WORKFLOW,
			"stage" => DAO::T_BBS_POST_STAGE_OTHERS,
			"actor" => array(
				array("r" => self::ROLE_RPMG, "require" => TRUE),
			),
			"input" => array(
				"*"     => array("type" => self::PROPTYPE_NONE,       "label" => self::PROPLABEL_SCHEDULE, "selected" => FALSE),
				"brief" => array("type" => self::PROPTYPE_DATA_BRIEF, "label" => self::PROPLABEL_BRIEF,    "selected" => FALSE),
			),
			"output" => array(
				"*" => array("type" => self::PROPTYPE_NONE, "label" => self::PROPLABEL_SCHEDULE, "selected" => FALSE),
			)
		),
		self::TYPE_WORKFLOW_ASSEMBLE_TARGET_DOCS => array(  // タスクタイプ(workflow-assemble-target-docs)
			"group" => self::TYPE_GROUP_WORKFLOW,
			"stage" => DAO::T_BBS_POST_STAGE_TRANSLATE,
			"actor" => array(
				array("r" => self::ROLE_RPMG, "require" => TRUE),
				array("r" => self::ROLE_RPFR, "require" => FALSE),
			),
			"input" => array(
				"proofed-target-documents" => array("type" => self::PROPTYPE_DOCUMENT, "label" => self::PROPLABEL_PROOFED_DOCUMENT, "selected" => FALSE),
			),
			"output" => array(
				"deliverable" => array("type" => self::PROPTYPE_DATA_DELIVERABLE, "label" => self::PROPLABEL_DELIVERABLE, "selected" => FALSE),
			)
		),
		// ***** terminology *****
		self::TYPE_TERMINOLOGY_EXTRACT_NEW => array(  // タスクタイプ(terminology-extract-new)
			"group" => self::TYPE_GROUP_TERM,
			"stage" => DAO::T_BBS_POST_STAGE_PREPARE,
			"actor" => array(
				array("r" => self::ROLE_RTMG, "require" => TRUE),
				array("r" => self::ROLE_RTRA, "require" => FALSE),
			),
			"input" => array(
				"source-documents" => array("type" => self::PROPTYPE_DOCUMENT, "label" => self::PROPLABEL_SOURCE_DOCUMENT, "selected" => FALSE),
			),
			"output" => array(
				"source-term-list" => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT, "label" => self::PROPLABEL_SOURCE_GLOSSARY, "selected" => FALSE),
			)
		),
		self::TYPE_TERMINOLOGY_TRANSLATE => array(  // タスクタイプ(terminology-translate)
			"group" => self::TYPE_GROUP_TERM,
			"stage" => DAO::T_BBS_POST_STAGE_PREPARE,
			"actor" => array(
				array("r" => self::ROLE_RTRA, "require" => FALSE),
				array("r" => self::ROLE_RREV, "require" => FALSE),
				array("r" => self::ROLE_RRVW, "require" => FALSE),
			),
			"actor-require" => TRUE,
			"input" => array(
				"source-documents" => array("type" => self::PROPTYPE_DOCUMENT,              "label" => self::PROPLABEL_SOURCE_DOCUMENT, "selected" => FALSE),
				"glossary"         => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT,     "label" => self::PROPLABEL_SOURCE_GLOSSARY, "selected" => FALSE),
				"research-results" => array("type" => self::PROPTYPE_DATA_RESEARCH_RESULTS, "label" => self::PROPLABEL_RESEARCH_RESULT, "selected" => FALSE),
			),
			"output" => array(
				"draft-source-target-term-list" => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT, "label" => self::PROPLABEL_DRAFT_GLOSSARY, "selected" => FALSE),
			)
		),
		self::TYPE_TERMINOLOGY_VALIDATE => array(  // タスクタイプ(terminology-validate)
			"group" => self::TYPE_GROUP_TERM,
			"stage" => DAO::T_BBS_POST_STAGE_PREPARE,
			"actor" => array(
				array("r" => self::ROLE_RTMG, "require" => TRUE),
				array("r" => self::ROLE_RREV, "require" => FALSE),
				array("r" => self::ROLE_RRVW, "require" => FALSE),
			),
			"input" => array(
				"source-documents"               => array("type" => self::PROPTYPE_DOCUMENT,              "label" => self::PROPLABEL_SOURCE_DOCUMENT, "selected" => FALSE),
				"draft-source-target-term-lists" => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT,     "label" => self::PROPLABEL_DRAFT_GLOSSARY,  "selected" => FALSE),
				"research-results"               => array("type" => self::PROPTYPE_DATA_RESEARCH_RESULTS, "label" => self::PROPLABEL_RESEARCH_RESULT, "selected" => FALSE),
			),
			"output" => array(
				"valid-source-target-term-lists" => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT, "label" => self::PROPLABEL_VALID_GLOSSARY, "selected" => FALSE),
			)
		),
		self::TYPE_TERMINOLOGY_COMPILE => array(  // タスクタイプ(terminology-compile)
			"group" => self::TYPE_GROUP_TERM,
			"stage" => DAO::T_BBS_POST_STAGE_PREPARE,
			"actor" => array(
				array("r" => self::ROLE_RTMG, "require" => TRUE),
				//array("r" => self::ROLE_ATTM, "require" => TRUE),
			),
			"input" => array(
				"valid-source-target-term-lists" => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT, "label" => self::PROPLABEL_VALID_GLOSSARY, "selected" => FALSE),
			),
			"output" => array(
				"glossary-compile" => array("type" => self::PROPTYPE_NONE, "label" => self::PROPLABEL_PROJECT_TERM_ROOT, "selected" => FALSE),
			)
		),
		// ***** translation *****
		self::TYPE_TRANSLATION_RESEARCH => array(  // タスクタイプ(translation-research)
			"group" => self::TYPE_GROUP_TRANS,
			"stage" => DAO::T_BBS_POST_STAGE_TRANSLATE,
			"actor" => array(
				array("r" => self::ROLE_RRES, "require" => TRUE),
			),
			"input" => array(
				"source-documents" => array("type" => self::PROPTYPE_DOCUMENT,   "label" => self::PROPLABEL_SOURCE_DOCUMENT, "selected" => TRUE, "require" => FALSE),
				"brief"            => array("type" => self::PROPTYPE_DATA_BRIEF, "label" => self::PROPLABEL_BRIEF,           "selected" => FALSE),
			),
			"output" => array(
				"research-results" => array("type" => self::PROPTYPE_DATA_RESEARCH_RESULTS, "label" => self::PROPLABEL_RESEARCH_RESULT, "selected" => FALSE),
			)
		),
		self::TYPE_TRANSLATION_TRANSLATE => array(  // タスクタイプ(translation-translate)
			"group" => self::TYPE_GROUP_TRANS,
			"stage" => DAO::T_BBS_POST_STAGE_TRANSLATE,
			"actor" => array(
				array("r" => self::ROLE_RTRA, "require" => TRUE, "single" => TRUE),
			),
			"input" => array(
				"source-documents" => array("type" => self::PROPTYPE_DOCUMENT,              "label" => self::PROPLABEL_SOURCE_DOCUMENT,     "selected" => TRUE, "require" => TRUE, "sync" => "draft-target-documents"),
				"brief"            => array("type" => self::PROPTYPE_DATA_BRIEF,            "label" => self::PROPLABEL_BRIEF,               "selected" => FALSE),
				"research-results" => array("type" => self::PROPTYPE_DATA_RESEARCH_RESULTS, "label" => self::PROPLABEL_RESEARCH_RESULT,     "selected" => FALSE),
				"project-glossary" => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT,     "label" => self::PROPLABEL_PROJECT_TERM_ROOT,   "selected" => FALSE),
				"others-glossary"  => array("type" => self::PROPTYPE_TERM_ROOT_REFERENCE,   "label" => self::PROPLABEL_REFERENCE_TERM_ROOT, "selected" => FALSE),
			),
			"output" => array(
				"draft-target-documents" => array("type" => self::PROPTYPE_DOCUMENT, "label" => self::PROPLABEL_DRAFT_DOCUMENT, "selected" => TRUE, "require" => FALSE),
			)
		),
		self::TYPE_TRANSLATION_REVISE => array(  // タスクタイプ(translation-revise)
			"group" => self::TYPE_GROUP_TRANS,
			"stage" => DAO::T_BBS_POST_STAGE_TRANSLATE,
			"actor" => array(
				array("r" => self::ROLE_RREV, "require" => TRUE, "single" => TRUE),
			),
			"contact" => array(
				array("r" => self::ROLE_RTRA, "require" => FALSE),
				array("r" => self::ROLE_RPED, "require" => FALSE),
			),
			"input" => array(
				"draft-target-documents" => array("type" => self::PROPTYPE_DOCUMENT,          "label" => self::PROPLABEL_DRAFT_DOCUMENT,    "selected" => TRUE, "require" => TRUE, "sync" => "revised-target-documents"),
				"brief"                  => array("type" => self::PROPTYPE_DATA_BRIEF,        "label" => self::PROPLABEL_BRIEF,             "selected" => FALSE),
				"project-glossary"       => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT, "label" => self::PROPLABEL_PROJECT_TERM_ROOT, "selected" => FALSE),
			),
			"output" => array(
				"revised-target-documents" => array("type" => self::PROPTYPE_DOCUMENT, "label" => self::PROPLABEL_REVISED_DOCUMENT, "selected" => TRUE, "require" => FALSE),
			)
		),
		self::TYPE_TRANSLATION_REVIEW => array(  // タスクタイプ(translation-review)
			"group" => self::TYPE_GROUP_TRANS,
			"stage" => DAO::T_BBS_POST_STAGE_TRANSLATE,
			"actor" => array(
				array("r" => self::ROLE_RRVW, "require" => TRUE, "single" => TRUE),
			),
			"contact" => array(
				array("r" => self::ROLE_RREV, "require" => FALSE),
				array("r" => self::ROLE_RTRA, "require" => FALSE),
				array("r" => self::ROLE_RPED, "require" => FALSE),
			),
			"input" => array(
				"revised-target-documents" => array("type" => self::PROPTYPE_DOCUMENT,          "label" => self::PROPLABEL_REVISED_DOCUMENT,  "selected" => TRUE, "require" => TRUE, "sync" => "reviewed-target-documents"),
				"brief"                    => array("type" => self::PROPTYPE_DATA_BRIEF,        "label" => self::PROPLABEL_BRIEF,             "selected" => FALSE),
				"project-glossary"         => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT, "label" => self::PROPLABEL_PROJECT_TERM_ROOT, "selected" => FALSE),
			),
			"output" => array(
				"reviewed-target-documents" => array("type" => self::PROPTYPE_DOCUMENT, "label" => self::PROPLABEL_REVIEWED_DOCUMENT, "selected" => TRUE, "require" => FALSE),
			)
		),
		self::TYPE_TRANSLATION_PROOF_READ => array(  // タスクタイプ(translation-proof-read)
			"group" => self::TYPE_GROUP_TRANS,
			"stage" => DAO::T_BBS_POST_STAGE_TRANSLATE,
			"actor" => array(
				array("r" => self::ROLE_RPFR, "require" => TRUE, "single" => TRUE),
			),
			"contact" => array(
				array("r" => self::ROLE_RRVW, "require" => TRUE),
			),
			"input" => array(
				"reviewed-target-documents" => array("type" => self::PROPTYPE_DOCUMENT,          "label" => self::PROPLABEL_REVIEWED_DOCUMENT, "selected" => TRUE, "require" => TRUE, "sync" => "proofed-target-documents"),
				"brief"                     => array("type" => self::PROPTYPE_DATA_BRIEF,        "label" => self::PROPLABEL_BRIEF,             "selected" => FALSE),
				"project-glossary"          => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT, "label" => self::PROPLABEL_PROJECT_TERM_ROOT, "selected" => FALSE),
			),
			"output" => array(
				"proofed-target-documents" => array("type" => self::PROPTYPE_DOCUMENT, "label" => self::PROPLABEL_PROOFED_DOCUMENT, "selected" => TRUE, "require" => FALSE),
			)
		),
		// ***** tm *****
		self::TYPE_TM_SELECT => array(  // タスクタイプ(tm-select)
			"group" => self::TYPE_GROUP_TM,
			"stage" => DAO::T_BBS_POST_STAGE_PREPARE,
			"actor" => array(
				array("r" => self::ROLE_RTMM, "require" => TRUE),
			),
			"input" => array(
				"source-documents" => array("type" => self::PROPTYPE_DOCUMENT,   "label" => self::PROPLABEL_SOURCE_DOCUMENT, "selected" => FALSE, "require" => FALSE),
				"brief"            => array("type" => self::PROPTYPE_DATA_BRIEF, "label" => self::PROPLABEL_BRIEF,           "selected" => FALSE),
			),
			"output" => array(
				"tm" => array("type" => self::PROPTYPE_BILINGUAL_ROOT_PROJECT, "label" => self::PROPLABEL_BILINGUAL_ROOT, "selected" => FALSE),
			)
		),
		self::TYPE_TM_UPDATE => array(  // タスクタイプ(tm-update)
			"group" => self::TYPE_GROUP_TM,
			"stage" => DAO::T_BBS_POST_STAGE_RESUPDATE,
			"actor" => array(
				array("r" => self::ROLE_RTMM, "require" => TRUE),
			),
			"input" => array(
				"source-target-documents" => array("type" => self::PROPTYPE_DOCUMENT,                 "label" => self::PROPLABEL_TRANSED_DOCUMENT,        "selected" => FALSE, "require" => FALSE),
				"project-tm"              => array("type" => self::PROPTYPE_BILINGUAL_ROOT_PROJECT,   "label" => self::PROPLABEL_PROJECT_BILINGUAL_ROOT,  "selected" => FALSE),
				"reference-tm"            => array("type" => self::PROPTYPE_BILINGUAL_ROOT_REFERENCE, "label" => self::PROPLABEL_REFRENCE_BILINGUAL_ROOT, "selected" => FALSE),
			),
			"output" => array(
				"tm" => array("type" => self::PROPTYPE_BILINGUAL_ROOT_ALL, "label" => self::PROPLABEL_BILINGUAL_ROOT, "selected" => FALSE),
			)
		),
		// ***** mt *****
		self::TYPE_MT_PRE_EDIT => array(  // タスクタイプ(mt-pre-edit)
			"group" => self::TYPE_GROUP_MT,
			"stage" => DAO::T_BBS_POST_STAGE_PREPARE,
			"actor" => array(
				array("r" => self::ROLE_RPRE, "require" => TRUE),
			),
			"input" => array(
				"source-documents" => array("type" => self::PROPTYPE_DOCUMENT,   "label" => self::PROPLABEL_SOURCE_DOCUMENT, "selected" => TRUE, "require" => TRUE, "sync" => "pre-edited-source-documents"),
				"brief"            => array("type" => self::PROPTYPE_DATA_BRIEF, "label" => self::PROPLABEL_BRIEF,           "selected" => FALSE),
			),
			"output" => array(
				"pre-edited-source-documents" => array("type" => self::PROPTYPE_DOCUMENT, "label" => self::PROPLABEL_PRE_EDITED_DOCUMENT, "selected" => TRUE, "require" => FALSE),
			)
		),
		self::TYPE_MT_TRANSLATE => array(  // タスクタイプ(mt-translate)
			"group" => self::TYPE_GROUP_MT,
			"stage" => DAO::T_BBS_POST_STAGE_PREPARE,
			"actor" => array(
				array("r" => self::ROLE_RMTM, "require" => TRUE),
			),
			"contact" => array(
				array("r" => self::ROLE_RTMG, "require" => FALSE),
				array("r" => self::ROLE_RPED, "require" => FALSE),
			),
			"input" => array(
				"source-documents" => array("type" => self::PROPTYPE_DOCUMENT,          "label" => self::PROPLABEL_SOURCE_DOCUMENT, "selected" => TRUE, "require" => TRUE, "sync" => "raw-target-documents"),
				"glossary"         => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT, "label" => self::PROPLABEL_TERM_ROOT,       "selected" => FALSE),
				"brief"            => array("type" => self::PROPTYPE_DATA_BRIEF,        "label" => self::PROPLABEL_BRIEF,           "selected" => FALSE),
			),
			"output" => array(
				"raw-target-documents" => array("type" => self::PROPTYPE_DOCUMENT, "label" => self::PROPLABEL_RAW_DOCUMENT,     "selected" => TRUE, "require" => FALSE),
				"not-found-words"      => array("type" => self::PROPTYPE_NONE,     "label" => self::PROPLABEL_NO_REGISTER_TERM, "selected" => FALSE),
			)
		),
		self::TYPE_MT_POST_EDIT => array(  // タスクタイプ(mt-post-edit)
			"group" => self::TYPE_GROUP_MT,
			"stage" => DAO::T_BBS_POST_STAGE_TRANSLATE,
			"actor" => array(
				array("r" => self::ROLE_RPED, "require" => TRUE),
			),
			"contact" => array(
				array("r" => self::ROLE_RMTM, "require" => TRUE),
			),
			"input" => array(
				"raw-target-documents" => array("type" => self::PROPTYPE_DOCUMENT,   "label" => self::PROPLABEL_RAW_DOCUMENT, "selected" => TRUE, "require" => TRUE, "sync" => "post-edited-target-documents"),
				"brief"                => array("type" => self::PROPTYPE_DATA_BRIEF, "label" => self::PROPLABEL_BRIEF,        "selected" => FALSE),
			),
			"output" => array(
				"post-edited-target-documents" => array("type" => self::PROPTYPE_DOCUMENT, "label" => self::PROPLABEL_POST_EDITED_DOCUMENT, "selected" => TRUE, "require" => TRUE),
			)
		),
		self::TYPE_MT_UPDATE => array(  // タスクタイプ(mt-update)
			"group" => self::TYPE_GROUP_MT,
			"stage" => DAO::T_BBS_POST_STAGE_RESUPDATE,
			"actor" => array(
				array("r" => self::ROLE_RMTM, "require" => TRUE),
			),
			"contact" => array(
				array("r" => self::ROLE_RTMG, "require" => FALSE),
			),
			"input" => array(
				"glossary" => array("type" => self::PROPTYPE_TERM_ROOT_PROJECT, "label" => self::PROPLABEL_PROJECT_TERM_ROOT, "selected" => FALSE),
				//"brief"    => array("type" => self::PROPTYPE_DATA_BRIEF,        "require" => FALSE),
			),
			"output" => array(
				"mt" => array("type" => self::PROPTYPE_NONE, "label" => self::PROPLABEL_MT, "selected" => FALSE),
			)
		),
	);
	
	public static function ROLE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_TASK";
		
		$arrTable = array(
			// self::ROLE_INIT => "{$WORD($wk, 1)}",   // ""
			self::ROLE_RREQ => "{$WORD($wk, 2)}",   // "requester"
			self::ROLE_RPMG => "{$WORD($wk, 3)}",   // "project-manager"
			self::ROLE_RRES => "{$WORD($wk, 4)}",   // "researcher"
			self::ROLE_RTMG => "{$WORD($wk, 5)}",   // "terminologist"
			self::ROLE_RTRA => "{$WORD($wk, 6)}",   // "translator"
			self::ROLE_RREV => "{$WORD($wk, 7)}",   // "reviser"
			self::ROLE_RRVW => "{$WORD($wk, 8)}",   // "reviewer"
			self::ROLE_RPFR => "{$WORD($wk, 9)}",   // "proof-reader"
			self::ROLE_RTMM => "{$WORD($wk, 10)}",  // "tm-manager"
			self::ROLE_RMTM => "{$WORD($wk, 11)}",  // "mt-manager"
			self::ROLE_RPRE => "{$WORD($wk, 12)}",  // "mt-pre-editor"
			self::ROLE_RPED => "{$WORD($wk, 13)}",  // "mt-post-editor"
			self::ROLE_ROBS => "{$WORD($wk, 14)}",  // "observer"
			//self::ROLE_ARHD => "{$WORD($wk, 15)}",  // "role-holder"
			//self::ROLE_ATRP => "{$WORD($wk, 16)}",  // "translation-pool"
			//self::ROLE_ATTM => "{$WORD($wk, 17)}",  // "translation-term"
		);
		
		if ( is_null($key) ){
			return $arrTable;
		} else if ( isset($arrTable[$key]) ){
			return $arrTable[$key];
		} else {
			return FALSE;
		}
	}
	
	public static function ROLE_COLOR_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_TASK";
		
		$arrTable = array(
			// self::ROLE_INIT => "#FFFFFF",  // ""
			self::ROLE_RREQ => "#416fa6",  // "requester"
			self::ROLE_RPMG => "#a8423f",  // "project-manager"
			self::ROLE_RRES => "#6e548d",  // "researcher"
			self::ROLE_RTMG => "#3d96ae",  // "terminologist"
			self::ROLE_RTRA => "#da8137",  // "translator"
			self::ROLE_RREV => "#8ea5cb",  // "reviser"
			self::ROLE_RRVW => "#ce8e8d",  // "reviewer"
			self::ROLE_RPFR => "#b5ca92",  // "proof-reader"
			self::ROLE_RTMM => "#a597b9",  // "tm-manager"
			self::ROLE_RMTM => "#8cc0d2",  // "mt-manager"
			self::ROLE_RPRE => "#CCCCCC",  // "mt-pre-editor"
			self::ROLE_RPED => "#CCCCCC",  // "mt-post-editor"
			self::ROLE_ROBS => "#888888",  // "observer" (表示されないはず)
			//self::ROLE_ARHD => "#CCCCCC",  // "role-holder"
			//self::ROLE_ATRP => "#CCCCCC",  // "translation-pool"
			//self::ROLE_ATTM => "#CCCCCC",  // "translation-term"
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	/*
	public static function ROLE_ACTORS_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_TASK";
		
		$arrTable = array(
			self::ROLE_ARHD => "{$WORD($wk, 18)}",  // "role-holder"
			self::ROLE_ATRP => "{$WORD($wk, 19)}",  // "translation-pool"
			self::ROLE_ATTM => "{$WORD($wk, 20)}",  // "translation-term"
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	 */
	
	public static function PROPLABEL_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_TASK";
		
		$arrTable = array(
			self::PROPLABEL_BRIEF                   => "{$WORD($wk, 21)}",
			self::PROPLABEL_DELIVERABLE             => "{$WORD($wk, 22)}",
			self::PROPLABEL_FINAL_DELIVERABLE       => "{$WORD($wk, 23)}",
			self::PROPLABEL_RESEARCH_RESULT         => "{$WORD($wk, 24)}",
			self::PROPLABEL_DATA_OTHERS             => "{$WORD($wk, 25)}",
			self::PROPLABEL_REGISTER_PARTICIPANTS   => "{$WORD($wk, 26)}",
			self::PROPLABEL_WORKFLOW_BRIEF          => "{$WORD($wk, 27)}",
			self::PROPLABEL_SCHEDULE                => "{$WORD($wk, 28)}",
			self::PROPLABEL_SOURCE_GLOSSARY         => "{$WORD($wk, 29)}",
			self::PROPLABEL_DRAFT_GLOSSARY          => "{$WORD($wk, 30)}",
			self::PROPLABEL_VALID_GLOSSARY          => "{$WORD($wk, 31)}",
			self::PROPLABEL_SOURCE_DOCUMENT         => "{$WORD($wk, 32)}",
			self::PROPLABEL_DOCUMENT_LIST           => "{$WORD($wk, 33)}",
			self::PROPLABEL_DRAFT_DOCUMENT          => "{$WORD($wk, 34)}",
			self::PROPLABEL_REVISED_DOCUMENT        => "{$WORD($wk, 35)}",
			self::PROPLABEL_REVIEWED_DOCUMENT       => "{$WORD($wk, 36)}",
			self::PROPLABEL_PROOFED_DOCUMENT        => "{$WORD($wk, 37)}",
			self::PROPLABEL_TRANSED_DOCUMENT        => "{$WORD($wk, 38)}",
			self::PROPLABEL_RAW_DOCUMENT            => "{$WORD($wk, 39)}",
			self::PROPLABEL_PRE_EDITED_DOCUMENT     => "{$WORD($wk, 40)}",
			self::PROPLABEL_POST_EDITED_DOCUMENT    => "{$WORD($wk, 41)}",
			self::PROPLABEL_TERM_ROOT               => "{$WORD($wk, 42)}",
			self::PROPLABEL_PROJECT_TERM_ROOT       => "{$WORD($wk, 43)}",
			self::PROPLABEL_REFERENCE_TERM_ROOT     => "{$WORD($wk, 44)}",
			self::PROPLABEL_BILINGUAL_ROOT          => "{$WORD($wk, 45)}",
			self::PROPLABEL_PROJECT_BILINGUAL_ROOT  => "{$WORD($wk, 46)}",
			self::PROPLABEL_REFRENCE_BILINGUAL_ROOT => "{$WORD($wk, 47)}",
			self::PROPLABEL_NO_REGISTER_TERM        => "{$WORD($wk, 48)}",
			self::PROPLABEL_MT                      => "{$WORD($wk, 49)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function TYPE_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_TASK";
		
		$arrTable = array(
			self::TYPE_BRIEF_AGREE                    => "{$WORD($wk, 50)}",  // "brief-agree"
			self::TYPE_BRIEF_SIGN_OFF                 => "{$WORD($wk, 51)}",  // "brief-sign-off"
			self::TYPE_WORKFLOW_REGISTER_PARTICIPANTS => "{$WORD($wk, 52)}",  // "workflow-register-participants"
			self::TYPE_WORKFLOW_REGISTER_DOCUMENTS    => "{$WORD($wk, 53)}",  // "workflow-register-documents"
			self::TYPE_WORKFLOW_SELECT                => "{$WORD($wk, 54)}",  // "workflow-select"
			self::TYPE_WORKFLOW_ALLOCATE_TASKS        => "{$WORD($wk, 55)}",  // "workflow-allocate-tasks"
			self::TYPE_WORKFLOW_MONITOR               => "{$WORD($wk, 56)}",  // "workflow-monitor"
			self::TYPE_WORKFLOW_ASSEMBLE_TARGET_DOCS  => "{$WORD($wk, 57)}",  // "workflow-assemble-target-docs"
			self::TYPE_TERMINOLOGY_EXTRACT_NEW        => "{$WORD($wk, 58)}",  // "terminology-extract-new"
			self::TYPE_TERMINOLOGY_TRANSLATE          => "{$WORD($wk, 59)}",  // "terminology-translate"
			self::TYPE_TERMINOLOGY_VALIDATE           => "{$WORD($wk, 60)}",  // "terminology-validate"
			self::TYPE_TERMINOLOGY_COMPILE            => "{$WORD($wk, 61)}",  // "terminology-compile"
			self::TYPE_TRANSLATION_RESEARCH           => "{$WORD($wk, 62)}",  // "translation-research"
			self::TYPE_TRANSLATION_TRANSLATE          => "{$WORD($wk, 63)}",  // "translation-translate"
			self::TYPE_TRANSLATION_REVISE             => "{$WORD($wk, 64)}",  // "translation-revise"
			self::TYPE_TRANSLATION_REVIEW             => "{$WORD($wk, 65)}",  // "translation-review"
			self::TYPE_TRANSLATION_PROOF_READ         => "{$WORD($wk, 66)}",  // "translation-proof-read"
			self::TYPE_TM_SELECT                      => "{$WORD($wk, 67)}",  // "tm-select"
			self::TYPE_TM_UPDATE                      => "{$WORD($wk, 68)}",  // "tm-update"
			self::TYPE_MT_PRE_EDIT                    => "{$WORD($wk, 69)}",  // "mt-pre-edit"
			self::TYPE_MT_TRANSLATE                   => "{$WORD($wk, 70)}",  // "mt-translate"
			self::TYPE_MT_POST_EDIT                   => "{$WORD($wk, 71)}",  // "mt-post-edit"
			self::TYPE_MT_UPDATE                      => "{$WORD($wk, 72)}",  // "mt-update"
		);
		
		return is_null($key) ? $arrTable : (isset($arrTable[$key]) ? $arrTable[$key] : "---");
	}
	
	public static function TYPE_GROUP_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_TASK";
		
		$arrTable = array(
			self::TYPE_GROUP_BRIEF    => "{$WORD($wk, 73)}",  // "breif-"
			self::TYPE_GROUP_WORKFLOW => "{$WORD($wk, 74)}",  // "workflow-"
			self::TYPE_GROUP_TERM     => "{$WORD($wk, 75)}",  // "terminology-"
			self::TYPE_GROUP_TRANS    => "{$WORD($wk, 76)}",  // "translation-"
			self::TYPE_GROUP_TM       => "{$WORD($wk, 77)}",  // "tm-"
			self::TYPE_GROUP_MT       => "{$WORD($wk, 78)}",  // "mt-"
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function TYPE_GROUP_ITEM_TABLE( $key = NULL ){
		$arrGroup = self::TYPE_GROUP_TABLE();
		$arrType = self::TYPE_TABLE();
		
		$arrTable = array();
		foreach ( $arrType as $type => $text ){
			$group = self::SETTING_TABLE($type, "group");
			$arrTable[$group][$type] = $text;
		}
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function TYPE_OPERATION_GROUP_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_TASK";
		
		$arrTable = array(
			self::TYPE_OPERATION_GROUP_FULL     => "{$WORD($wk, 79)}",  // "完全"
			self::TYPE_OPERATION_GROUP_MAXIMUM  => "{$WORD($wk, 80)}",  // "翻訳(最大)"
			self::TYPE_OPERATION_GROUP_EXTENDED => "{$WORD($wk, 81)}",  // "翻訳(拡大)"
			self::TYPE_OPERATION_GROUP_CORE     => "{$WORD($wk, 82)}",  // "翻訳(コア)"
			self::TYPE_OPERATION_GROUP_MINIMUM  => "{$WORD($wk, 83)}",  // "翻訳(最小)"
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function TYPE_OPERATION_GROUP_ITEM_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_TASK";
		
		$arrTable = array(
			self::TYPE_OPERATION_GROUP_FULL     => array_keys( self::TYPE_TABLE() ),  // "完全"
			self::TYPE_OPERATION_GROUP_MAXIMUM  => array(  // "翻訳(最大)"
				self::TYPE_TERMINOLOGY_EXTRACT_NEW, self::TYPE_TERMINOLOGY_TRANSLATE, self::TYPE_TERMINOLOGY_VALIDATE, self::TYPE_TERMINOLOGY_COMPILE,
				self::TYPE_TRANSLATION_RESEARCH, self::TYPE_TRANSLATION_TRANSLATE, self::TYPE_TRANSLATION_REVISE, self::TYPE_TRANSLATION_REVIEW, self::TYPE_TRANSLATION_PROOF_READ,
				self::TYPE_TM_SELECT, self::TYPE_TM_UPDATE,
				self::TYPE_MT_PRE_EDIT, self::TYPE_MT_TRANSLATE, self::TYPE_MT_POST_EDIT, self::TYPE_MT_UPDATE,
			),
			self::TYPE_OPERATION_GROUP_EXTENDED => array(  // "翻訳(拡大)"
				self::TYPE_TERMINOLOGY_EXTRACT_NEW, self::TYPE_TERMINOLOGY_TRANSLATE, self::TYPE_TERMINOLOGY_VALIDATE, self::TYPE_TERMINOLOGY_COMPILE,
				self::TYPE_TRANSLATION_RESEARCH, self::TYPE_TRANSLATION_TRANSLATE, self::TYPE_TRANSLATION_REVISE, self::TYPE_TRANSLATION_REVIEW, self::TYPE_TRANSLATION_PROOF_READ,
			),
			self::TYPE_OPERATION_GROUP_CORE     => array(  // "翻訳(コア)"
				self::TYPE_TRANSLATION_RESEARCH, self::TYPE_TRANSLATION_TRANSLATE, self::TYPE_TRANSLATION_REVISE, self::TYPE_TRANSLATION_REVIEW, self::TYPE_TRANSLATION_PROOF_READ,
			),
			self::TYPE_OPERATION_GROUP_MINIMUM  => array(  // "翻訳(最小)"
				self::TYPE_TRANSLATION_TRANSLATE, self::TYPE_TRANSLATION_REVISE,
			),
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	public static function SETTING_TABLE( $key = NULL, $itemKey = NULL ){
		if ( is_null($key) ){
			return self::$SETTING_TABLE;
		} else {
			if ( isset(self::$SETTING_TABLE[$key]) ){
				if ( isset(self::$SETTING_TABLE[$key][$itemKey]) ){
					return self::$SETTING_TABLE[$key][$itemKey];
				}
				return self::$SETTING_TABLE[$key];
			}
		}
		
		return FALSE;
	}
	
	/*
	public static function isActors( $role ){
		return ($role === self::ROLE_ARHD || $role === self::ROLE_ATRP || $role === self::ROLE_ATTM);
	}
	 */
	
	public static function isSingleDocument( $taskType ){
		// 下調べ、翻訳、修正、レビュー、校正タスクの場合のみ
		if ( self::SETTING_TABLE($taskType, "group") === Task::TYPE_GROUP_TRANS ){
			return TRUE;
		} else {
			return FALSE;
		}
		/*
		// 文書を使うタスクすべて
		$io = Task::SETTING_TABLE($taskType, "input") + Task::SETTING_TABLE($taskType, "output");
		$isDocument = FALSE;
		foreach ( $io as $key => $arrProps ){
			if ( Task::isPropTypeDocument($arrProps["type"]) ){
				$isDocument = TRUE;
				break;
			}
		}
		return $isDocument;
		 */
	}
	
	/*
	 *  $propsType の値を渡すか、
	 *  $taskType と $props の２つに値を渡す
	 */
	private static function getPropType( $propType = NULL, $taskType = NULL, $props = NULL ){
		if ( is_null($propType) ){
			$setting = self::SETTING_TABLE($taskType);
			if ( $setting === FALSE ){
				return FALSE;
			}
			if ( isset($setting["input"][$props]) ){
				$propType = $setting["input"][$props]["type"];
			} else if ( isset($setting["output"][$props]) ){
				$propType = $setting["output"][$props]["type"];
			} else {
				return FALSE;
			}
		}
		return $propType;
	}
	
	public static function isPropTypeDocument( $propType = NULL, $taskType = NULL, $props = NULL ){
		if ( ($propType = self::getPropType($propType, $taskType, $props)) === FALSE ){
			return FALSE;
		}
		switch ( $propType ){
			case self::PROPTYPE_DOCUMENT:
				return TRUE;
			default:
				return FALSE;
		}
	}
	
	public static function isPropTypeTermRoot( $propType = NULL, $taskType = NULL, $props = NULL ){
		if ( ($propType = self::getPropType($propType, $taskType, $props)) === FALSE ){
			return FALSE;
		}
		switch ( $propType ){
			case self::PROPTYPE_TERM_ROOT_ALL:
			case self::PROPTYPE_TERM_ROOT_PROJECT:
			case self::PROPTYPE_TERM_ROOT_REFERENCE:
				return TRUE;
			default:
				return FALSE;
		}
	}
	
	public static function isPropTypeBilingualRoot( $propType = NULL, $taskType = NULL, $props = NULL ){
		if ( ($propType = self::getPropType($propType, $taskType, $props)) === FALSE ){
			return FALSE;
		}
		switch ( $propType ){
			case self::PROPTYPE_BILINGUAL_ROOT_ALL:
			case self::PROPTYPE_BILINGUAL_ROOT_PROJECT:
			case self::PROPTYPE_BILINGUAL_ROOT_REFERENCE:
				return TRUE;
			default:
				return FALSE;
		}
	}
	
	public static function isPropTypeData( $propType = NULL, $taskType = NULL, $props = NULL ){
		if ( ($propType = self::getPropType($propType, $taskType, $props)) === FALSE ){
			return FALSE;
		}
		switch ( $propType ){
			case self::PROPTYPE_DATA_ALL:
			case self::PROPTYPE_DATA_BRIEF:
			case self::PROPTYPE_DATA_DELIVERABLE:
			case self::PROPTYPE_DATA_RESEARCH_RESULTS:
			case self::PROPTYPE_DATA_OTHERS:
				return TRUE;
			default:
				return FALSE;
		}
	}
	
	/***************************************************************
	 * 名前:getInputValue
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function getInputValue( $xml, $kind, $taskType ){
		$objXml = simplexml_load_string($xml, "SimpleXMLElement", LIBXML_NOCDATA);
		$arrValue = array();
		
		$setting = self::SETTING_TABLE($taskType);
		
		foreach ( $setting[$kind] as $name => $set ){
			$arrItemValue = array();
			$arrPropsValue = get_object_vars($objXml->$kind->$name);
			
			foreach( $arrPropsValue as $key => $val ){
				if ( strcmp($key, "item") !== 0 ){
					continue;
				}
				
				if ( is_object($val) ){
					$arrItem = get_object_vars($val);
					
					foreach ( $arrItem as $item ){
						$arrItemValue[] = $item;
					}
				} else {
					$arrItemValue[] = $val;
				}
			}
			
			$arrValue[$name] = $arrItemValue;
		}
		
		return $arrValue;
	}
	
	/***************************************************************
	 * 名前:setInputValue
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function setInputValue( $xml, $kind, $taskType, $value ){
		$objXml = simplexml_load_string($xml, "SimpleXMLElement", LIBXML_NOCDATA);
		
		$setting = self::SETTING_TABLE($taskType);
		
		foreach ( $setting[$kind] as $name => $set ){
			if ( isset($value[$name]) ){
				if ( ! is_array($value[$name]) ){
					$value[$name] = array( $value[$name] );
				}
				
				foreach ( $value[$name] as $val ){
					$objXml->$kind->$name->addChild("item", $val);
				}
			}
		}
		
		return $objXml->asXML();
	}
	
	/***************************************************************
	 * 名前:checkTaskObject
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function checkTaskObject( $taskID, $taskType = NULL, $arrActor = NULL, $arrAppended = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_TASK";
		
		$result = array();
		
		$objDAOTaskDocument      = DAO::instance("task_document");
		$objDAOTaskTermRoot      = DAO::instance("task_term_root", Term::KIND_TERM);
		$objDAOTaskBilingualRoot = DAO::instance("task_term_root", Term::KIND_BILINGUAL);
		$objDAOTaskData          = DAO::instance("task_data");
		
		if ( $taskType === NULL ){
			$objDAOTask = DAO::instance("task");
			$resDAOTask = $objDAOTask->get($taskID);
			
			if ( $resDAOTask["result"] !== RES_OK ){
				return FALSE;
			}
			$taskType = $resDAOTask["data"][0]["t_task_type"];
		}
		// actor
		if ( ($arrTaskActor = self::getTaskActor($taskID)) === FALSE ){
			return FALSE;
		}
		// document
		if ( ($arrTaskDocument = self::getTaskDocument($taskID, TRUE, TRUE)) === FALSE ){
			return FALSE;
		}
		// termRoot
		if ( ($arrTaskTermRoot = self::getTaskTermRoot($taskID, TRUE, TRUE)) === FALSE ){
			return FALSE;
		}
		// bilingualRoot
		if ( ($arrTaskBilingualRoot = self::getTaskBilingualRoot($taskID, TRUE, TRUE)) === FALSE ){
			return FALSE;
		}
		// data
		if ( ($arrTaskData = self::getTaskData($taskID, TRUE, TRUE)) === FALSE ){
			return FALSE;
		}
		
		if ( Task::SETTING_TABLE($taskType, "actor-require") === TRUE ){
			if ( (count($arrTaskActor, COUNT_RECURSIVE) - count($arrTaskActor)) === 0 ){ // 多次元配列の子要素数（再帰）
				$result[] = "{$WORD($wk, 84)}";
			}
		}
		
		foreach ( array("actor", "input", "output") as $item ){
			$setting = Task::SETTING_TABLE($taskType, $item);
			foreach ( $setting as $props => $one ){
				$selected = isset($one["selected"]) ? $one["selected"] : FALSE;
				$require = isset($one["require"]) ? $one["require"] : FALSE;
				
				$setted = TRUE;
				if ( $item === "actor" ){
					$actor = $one["r"];
					if ( $setted && $require ){
						// 必須項目に値が入っているか確認する
						$setted = ( isset($arrTaskActor[$actor]) && count($arrTaskActor[$actor]) > 0 );
					}
					if ( $setted && is_array($arrActor) && isset($arrActor[$actor]) && isset($arrTaskActor[$actor]) ){
						// 有効でないユーザーが渡された場合
						foreach ( $arrTaskActor[$actor] as $userID => $dataUser ){
							if ( ($setted = isset($arrActor[$actor][$userID])) === FALSE ){
								break;
							}
						}
					}
					if ( ! $setted ){
						$result[] = "{$WORD($wk, 85, self::ROLE_TABLE($actor))}";
					}
				} else if ( $item === "input" || $item === "output" ){
					$propType = $one["type"];
					if ( isset($one["label"]) ){
						$propLabel = Task::PROPLABEL_TABLE($one["label"]);
					} else if ( isset($one["clabel"]) ){
						$propLabel = $one["clabel"];
					} else {
						$propLabel = $props;
					}
					$arr = array();
					if ( self::isPropTypeDocument($propType) ){
						$arr = $arrTaskDocument;
					} else if ( self::isPropTypeTermRoot($propType) ){
						$arr = $arrTaskTermRoot;
					} else if ( self::isPropTypeBilingualRoot($propType) ){
						$arr = $arrTaskBilingualRoot;
					} else if ( self::isPropTypeData($propType) ){
						$arr = $arrTaskData;
					}
					
					if ( $setted && $require ){
						// 必須項目に値が入っているか確認する
						$setted = ( isset($arr[$props]) && count($arr[$props]) > 0 );
					}
					if ( $setted && $selected && isset($arr[$props]) ){
						$arrValidObject = NULL;
						switch ( $propType ){
							case Task::PROPTYPE_DOCUMENT:
								$arrValidObject = $arrAppended["document"];
								break;
							case Task::PROPTYPE_TERM_ROOT_ALL:
								$arrValidObject = $arrAppended["term"];
								break;
							case Task::PROPTYPE_TERM_ROOT_PROJECT:
								$arrValidObject = $arrAppended["term-normal"];
								break;
							case Task::PROPTYPE_TERM_ROOT_REFERENCE:
								$arrValidObject = $arrAppended["term-reference"];
								break;
							case Task::PROPTYPE_BILINGUAL_ROOT_ALL:
								$arrValidObject = $arrAppended["bilingual"];
								break;
							case Task::PROPTYPE_BILINGUAL_ROOT_PROJECT:
								$arrValidObject = $arrAppended["bilingual-normal"];
								break;
							case Task::PROPTYPE_BILINGUAL_ROOT_REFERENCE:
								$arrValidObject = $arrAppended["bilingual-reference"];
								break;
							case Task::PROPTYPE_DATA_ALL:
								$arrValidObject = $arrAppended["data"];
								break;
							case Task::PROPTYPE_DATA_BRIEF:
								$arrValidObject = $arrAppended["data-brief"];
								break;
							case Task::PROPTYPE_DATA_DELIVERABLE:
								$arrValidObject = $arrAppended["data-deliver"];
								break;
							case Task::PROPTYPE_DATA_RESEARCH_RESULTS:
								$arrValidObject = $arrAppended["data-research"];
								break;
							case Task::PROPTYPE_DATA_OTHERS:
								$arrValidObject = $arrAppended["data-others"];
								break;
						}
						if ( is_array($arrValidObject) ){
							foreach ( $arr[$props] as $id => $name ){
								if ( ($setted = isset($arrValidObject[$id])) === FALSE ){
									break;
								}
							}
						}
					}
					if ( ! $setted ){
						if ( $item === "input" ){
							$result[] = "{$WORD($wk, 86, $propLabel)}";
						} else if ( $item === "output" ){
							$result[] = "{$WORD($wk, 87, $propLabel)}";
						}
					}
				}
			}
		}
		
		if ( count($result) > 0 ){
			return $result;
		} else {
			return TRUE;
		}
	}
	
	/***************************************************************
	 * 名前:getTaskActual
	 * 説明: タスクの実績
	 * 引数:
	 * 返値:
	 ****************************************************************/
	public static function getTaskActual( $taskID ){
		$result = array();
		$objDAOLogTask = DAO::instance("log_task");
		
		$arrOrder = array(
			"t_log_task_date" => DAO::ASC,
		);
		$resDAOLogTask = $objDAOLogTask->get(NULL, NULL, NULL, $taskID, NULL, NULL, $arrOrder);
		if ( $resDAOLogTask["result"] === RES_NG ){
			return FALSE;
		} else {
			foreach ( $resDAOLogTask["data"] as $dataLogTask ){
				$date  = $dataLogTask["t_log_task_date"];
				$state = $dataLogTask["t_log_task_state"];
				$result[] = array(
					"date"  => $date,
					"state" => $state,
				);
			}
		}
		
		return $result;
	}
	
	/***************************************************************
	 * 名前:getTaskActor
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function getTaskActor( $taskID ){
		$result = array();
		
		$objDAOTaskActor = DAO::instance("task_actor");
		
		$arrOrder = array(
			"t_user_type" => array_keys(DAO::T_USER_TYPE_TABLE()),
			"t_user_name" => DAO::ASC,
			"t_task_role" => array_keys(Task::ROLE_TABLE()),
		);
		$resDAOTaskActor = $objDAOTaskActor->get($taskID, NULL, NULL, DAO::T_TASK_ACTOR_TYPE_ACTOR, NULL, $arrOrder);
		if ( $resDAOTaskActor["result"] === RES_NG ){
			return FALSE;
		} else {
			foreach ( $resDAOTaskActor["data"] as $dataTaskActor ){
				$userID = $dataTaskActor["t_user_id"];
				$type   = $dataTaskActor["t_user_type"];
				$name   = $dataTaskActor["t_user_name"];
				$role   = $dataTaskActor["t_task_role"];
				$result[$role][$userID] = $dataTaskActor;
			}
		}
		
		return $result;
	}
	
	/***************************************************************
	 * 名前:getTaskContact
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function getTaskContact( $taskID ){
		$result = array();
		
		$objDAOTaskActor = DAO::instance("task_actor");
		
		$arrOrder = array(
			"t_user_type" => array_keys(DAO::T_USER_TYPE_TABLE()),
			"t_user_name" => DAO::ASC,
			"t_task_role" => array_keys(Task::ROLE_TABLE()),
		);
		$resDAOTaskActor = $objDAOTaskActor->get($taskID, NULL, NULL, DAO::T_TASK_ACTOR_TYPE_CONTACT, NULL, $arrOrder);
		if ( $resDAOTaskActor["result"] === RES_NG ){
			return FALSE;
		} else {
			foreach ( $resDAOTaskActor["data"] as $dataTaskActor ){
				$userID = $dataTaskActor["t_user_id"];
				$type   = $dataTaskActor["t_user_type"];
				$name   = $dataTaskActor["t_user_name"];
				$role   = $dataTaskActor["t_task_role"];
				$result[$role][$userID] = $dataTaskActor;
			}
		}
		
		return $result;
	}
	
	/***************************************************************
	 * 名前:getTaskDocument
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function getTaskDocument( $taskID, $isAllState = FALSE, $setProps = FALSE ){
		$result = array();
		
		$objDAOTaskDocument = DAO::instance("task_document");

		$arrOrder = array(
			"t_document_title" => DAO::ASC,
		);
		$resDAOTaskDocument = $objDAOTaskDocument->get($taskID, NULL, NULL, $isAllState ?  NULL : array_keys(DAO::T_DOCUMENT_STATE_VALID_TABLE()), $arrOrder);
		if ( $resDAOTaskDocument["result"] === RES_NG ){
			return FALSE;
		} else {
			foreach ( $resDAOTaskDocument["data"] as $dataTaskDocument ){
				$documentID = $dataTaskDocument["t_document_id"];
				$name       = $dataTaskDocument["t_document_title"];
				$props      = $dataTaskDocument["t_task_props"];
				if ( $setProps ){
					$result[$props][$documentID] = $name;
				} else {
					$result[$documentID] = $name;
				}
			}
		}
		
		return $result;
	}
	
	/***************************************************************
	 * 名前:getTaskTermRoot
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function getTaskTermRoot( $taskID, $isAllState = FALSE, $setProps = FALSE ){
		$result = array();
		
		$objDAOTaskTermRoot = DAO::instance("task_term_root", Term::KIND_TERM);
		
		$arrOrder = array(
			"t_term_root_name" => DAO::ASC,
		);
		$resDAOTaskTermRoot = $objDAOTaskTermRoot->get($taskID, NULL, NULL, $isAllState ? NULL : array_keys(DAO::T_TERM_ROOT_STATE_VALID_TABLE()), $arrOrder);
		if ( $resDAOTaskTermRoot["result"] === RES_NG ){
			return FALSE;
		} else {
			foreach ( $resDAOTaskTermRoot["data"] as $dataTaskTermRoot ){
				$rootID = $dataTaskTermRoot["t_term_root_id"];
				$name   = $dataTaskTermRoot["t_term_root_name"];
				$props  = $dataTaskTermRoot["t_task_props"];
				if ( $setProps ){
					$result[$props][$rootID] = $name;
				} else {
					$result[$rootID] = $name;
				}
			}
		}
		
		return $result;
	}
	
	/***************************************************************
	 * 名前:getTaskBilingualRoot
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function getTaskBilingualRoot( $taskID, $isAllState = FALSE, $setProps = FALSE ){
		$result = array();
		
		$objDAOTaskBilingualRoot = DAO::instance("task_term_root", Term::KIND_BILINGUAL);
		
		$arrOrder = array(
			"t_term_root_name" => DAO::ASC,
		);
		$resDAOTaskBilingualRoot = $objDAOTaskBilingualRoot->get($taskID, NULL, NULL, $isAllState ? NULL : array_keys(DAO::T_TERM_ROOT_STATE_VALID_TABLE()), $arrOrder);
		if ( $resDAOTaskBilingualRoot["result"] === RES_NG ){
			return FALSE;
		} else {
			foreach ( $resDAOTaskBilingualRoot["data"] as $dataTaskBilingualRoot ){
				$rootID = $dataTaskBilingualRoot["t_term_root_id"];
				$name   = $dataTaskBilingualRoot["t_term_root_name"];
				$props  = $dataTaskBilingualRoot["t_task_props"];
				if ( $setProps ){
					$result[$props][$rootID] = $name;
				} else {
					$result[$rootID] = $name;
				}
			}
		}
		
		return $result;
	}
	
	/***************************************************************
	 * 名前:getTaskData
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function getTaskData( $taskID, $isAllState = FALSE, $setProps = FALSE ){
		$result = array();
		
		$objDAOTaskData = DAO::instance("task_data");
		
		$arrOrder = array(
			"t_data_title" => DAO::ASC,
		);
		$resDAOTaskData = $objDAOTaskData->get($taskID, NULL, NULL, $isAllState ? NULL : array_keys(DAO::T_DATA_STATE_VALID_TABLE()), $arrOrder);
		if ( $resDAOTaskData["result"] === RES_NG ){
			return FALSE;
		} else {
			foreach ( $resDAOTaskData["data"] as $dataTaskData ){
				$rootID = $dataTaskData["t_data_id"];
				$name   = $dataTaskData["t_data_title"];
				$props  = $dataTaskData["t_task_props"];
				if ( $setProps ){
					$result[$props][$rootID] = $name;
				} else {
					$result[$rootID] = $name;
				}
			}
		}
		
		return $result;
	}
	
	/***************************************************************
	 * 名前:getTaskDOMData
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function getTaskDOMData( $type, $obj ){
		$arrPropsType = array(
			self::PROPTYPE_TEXT,
		);
		
		$dom = new domDocument("1.0", "UTF-8");
		$dom->formatOutput = TRUE;
		$dom->preserveWhiteSpace = FALSE;
		
		$elmData = $dom->createElement("data");
		$dom->appendChild($elmData);
		
		$setting = Task::SETTING_TABLE($type);
		$arrTaskProps = array_merge($setting["input"], $setting["output"]);
		foreach ( $arrTaskProps as $name => $dataTaskProps ){
			if ( in_array($dataTaskProps["type"], $arrPropsType) ) {
				if ( isset($obj[$name]) ){
					$elm = $dom->createElement($name);
					$elm->appendChild($dom->createCDATASection($obj[$name]));
					$elmData->appendChild($elm);
				}
			}
		}
		return $dom->saveXml();
	}

	/***************************************************************
	 * 名前:convertTaskObject
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function convertTaskObject( $taskID, $taskType, $taskXMLData ){
		$arrRes = array();
		
		// タスクデータ一覧 ---------------------
		$objXml = simplexml_load_string($taskXMLData, "SimpleXMLElement", LIBXML_NOCDATA);
		foreach ( $objXml->children() as $childNode ){
			$childName = $childNode->getName();
			if ( strcmp($childName, "input") === 0 || strcmp($childName, "output") === 0 ){
				// 以前の形式にも対応
				foreach ( $childNode->children() as $grandNode ){
					if ( count($grandNode->children()) === 0 ){
						$props = $grandNode->getName();
						$id = (string)$grandNode;
						if ( is_numeric($id) ){
							$arrRes[$props][$id] = "";
						}
					}
				}
			} else {
				$props = $childName;
				$id = (string)$childNode;
				if ( is_numeric($id) ){
					$arrRes[$props][$id] = "";
				}
			}
		}
		foreach ( $arrRes as $props => &$arrObject ){
			foreach ( $arrObject as $id => &$text ){
				if ( self::isPropTypeDocument(NULL, $taskType, $props) ){
					$text = DAO::storedFunction("get_document_title", $id);
				} else if ( self::isPropTypeTermRoot(NULL, $taskType, $props) ){
					$text = DAO::storedFunction("get_term_root_name", $id);
				} else if ( self::isPropTypeBilingualRoot(NULL, $taskType, $props) ){
					$text = DAO::storedFunction("get_bilingual_root_name", $id);
				} else if ( self::isPropTypeData(NULL, $taskType, $props) ){
					$text = DAO::storedFunction("get_data_title", $id);
				}
			}
		}
		
		// Document
		if ( ($arrTaskDocument = self::getTaskDocument($taskID, TRUE, TRUE)) === FALSE ){
			return FALSE;
		}
		
		// TermRoot
		if ( ($arrTaskTermRoot = self::getTaskTermRoot($taskID, TRUE, TRUE)) === FALSE ){
			return FALSE;
		}
		
		// BilingualRoot
		if ( ($arrTaskBilingualRoot = self::getTaskBilingualRoot($taskID, TRUE, TRUE)) === FALSE ){
			return FALSE;
		}
		
		// Data
		if ( ($arrTaskData = self::getTaskData($taskID, TRUE, TRUE)) === FALSE ){
			return FALSE;
		}
		
		$arrMerge = array_merge($arrTaskDocument, $arrTaskTermRoot, $arrTaskBilingualRoot, $arrTaskData);
		foreach ( $arrMerge as $props => $arrIDName ){
			if ( isset($arrRes[$props]) ){
				$arrRes[$props] = array_merge($arrRes[$props], $arrIDName);
			} else {
				$arrRes[$props] = $arrIDName;
			}
		}
		
		return $arrRes;
	}
	
	/***************************************************************
	 * 名前:getHtmlState
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function getHtmlState($id, $state = NULL){
		global $WORD;
		$wk = "WORD_P_CLASS_TASK";
		
		if ( is_null($state) ){
			$objDAOTask = DAO::instance("task");
			$resDAOTask = $objDAOTask->get($id);
			if ($resDAOTask["result"] !== RES_OK ){
				return FALSE;
			}
			$dataTask = $resDAOTask["data"][0];
			$state = $dataTask["t_task_state"];
		}
		if ( ! Validate::inKeyArray($state, DAO::T_TASK_STATE_TABLE()) ){
			return FALSE;
		}
		
		// 状態
		$labelClass = "label-default";
		if ( $state === DAO::T_TASK_STATE_NORMAL ){ $labelClass = "label-success"; }
		else if ( $state === DAO::T_TASK_STATE_CARIED ){ $labelClass = "label-danger"; }
		else if ( $state === DAO::T_TASK_STATE_FINISH ){ $labelClass = "label-primary"; }
		
		$hState = Printer::label("label-only {$labelClass}", DAO::T_TASK_STATE_TABLE($state));
		return $hState;
	}
	
	/***************************************************************
	 * 名前:getHtmlDateSpan
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function getHtmlDateSpan($id, $start = NULL, $end = NULL, $userID = NULL, $arrDocument = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_TASK";
		
		if ( is_null($start) || is_null($end) ){
			$objDAOTask = DAO::instance("task");
			$resDAOTask = $objDAOTask->get($id);
			if ($resDAOTask["result"] !== RES_OK ){
				return FALSE;
			}
			$dataTask = $resDAOTask["data"][0];
			$start = $dataTask["t_task_start"];
			$end   = $dataTask["t_task_end"];
		}
		
		// 期間
		$hDate = Printer::direct("icon-arrow-right", $start, $end);
		// 超過
		$arrEnd = getDate(strtotime($end));
		$arrNow = getDate();
		if ( $arrEnd["year"] < $arrNow["year"] || $arrEnd["yday"] < $arrNow["yday"] ){
			$hDate .= " ({$WORD($wk, 88)})";
			
			// 前が詰まっているか確認し、詰まっていない場合は 赤く表示させる
			$isBlock = FALSE;
			if ( is_numeric($userID) && is_array($arrDocument) ){
				foreach ( $arrDocument as $documentID => $documentTitle ){
					$document = new Document($documentID);
					if ( $document->canStartTask($userID, $id) === FALSE ){
						$isBlock = TRUE;
						break;
					}
				}
			}
			if ( $isBlock ){
				$hDate = "<span class=\"normal\">{$hDate}</span>";
			} else {
				$hDate = "<span class=\"warn\">{$hDate}</span>";
			}
		}
		
		return $hDate;
	}
}

