<?php require_once("class/WebAPI.php"); ?>
<?php
Class ToolSimilarityWebAPI {

	const LIMIT_LISTBILINGUAL  = 100;
	const OFFSET_LISTBILINGUAL = 0;
	const LIMIT_RUN            = 100;

	var $USER_WEBAPI   = NULL;
	var $KEY_WEBAPI    = NULL;
	var $SECRET_WEBAPI = NULL;
	
	/***************************************************************
	 * 名前:ToolSimilarityWebAPI
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function ToolSimilarityWebAPI($apiName, $apiKey, $apiSecret){
		// WebAPI接続情報
		$this->USER_WEBAPI   = $apiName;
		$this->KEY_WEBAPI    = $apiKey;
		$this->SECRET_WEBAPI = $apiSecret;
		
	}

	/***************************************************************
	 * name    :getListBilingual
	 * explain : 対訳集一覧取得
	 * input   :
	 * output  : array() : 成功
	 *       FALSE   : 失敗
	****************************************************************/
	function getListBilingual( $lang_s, $lang_t, $limit, $offset ){
		$result    = array();
		
		//////////////////////////////
		// 対訳集データ一覧(WebAPI) //
		//////////////////////////////
		$objWebAPI     = new WebAPI($this->USER_WEBAPI, $this->KEY_WEBAPI, $this->SECRET_WEBAPI);
		if ( ($result = $objWebAPI->getListBilingual( $lang_s, $lang_t, $limit, $offset ) ) === FALSE ){
			$result = FALSE;
		}
		return $result;
	}
	
	/***************************************************************
	 * name    : run
	 * explain : 
	 * input   :
	 * output  : 
	****************************************************************/
	function run( $text, $score, $arrBilingualRootID, $limit ){
		$result = array();
		
		if ($text === ""){
			return $result;
		}
		
		////////////////////////
		// 類似文検索(WebAPI) //
		////////////////////////
		$objWebAPI     = new WebAPI($this->USER_WEBAPI, $this->KEY_WEBAPI, $this->SECRET_WEBAPI);
		$result = $objWebAPI->getSimilarity( $text, $score, $arrBilingualRootID, $limit );
		
		return $result;
	}
}
