<?php
// ユーザー基本情報
$gUser["id"]                = DAO::ID_INIT;
$gUser["name"]              = "";
$gUser["state"]             = DAO::T_USER_STATE_ACTIVE;
$gUser["type"]              = DAO::T_USER_TYPE_LOGOFF;
$gUser["disp_lang"]         = LANG_EN;
$gUser["login"]             = DAO::T_USER_LOGIN_OK;
$gUser["organization_id"]   = DAO::ID_INIT;
$gUser["organization_name"] = "";
$gUser["last_login"]        = 0; //前回のログイン時間
// 表示中プロジェクトID
$gUser["project_id"] = NULL;

Class User {
	/***************************************************************
	 * 名前:set
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function set( $key, $value ){
		global $gUser;
		
		$gUser[$key] = $value;
	}
	
	/***************************************************************
	 * 名前:get
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function get( $key ){
		global $gUser;
		
		if ( ! isset($gUser[$key]) ){
			throw new Exception("");
			return FALSE;
		}
		
		return $gUser[$key];
	}
	
	/***************************************************************
	 * 名前:setInitialize
	 * 説明:ログイン情報セット
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function setInitialize( $userID = NULL ){
		global $gUser;
		
		$result = RES_OK;
		
		if ( is_null($userID) ){
			$gUser["type"] = DAO::T_USER_TYPE_LOGOFF;
		} else {
			$objDAOUser = DAO::instance("user");
			$objDAOLogin = DAO::instance("login");
			
			if ( $result === RES_OK ){
				$resDAOUser = $objDAOUser->get($userID);
				$result = $resDAOUser["result"];
				
				if ( $result === RES_OK ){
					$dataUser = $resDAOUser["data"][0];
					
					$gUser["id"]                = $dataUser["t_user_id"];
					$gUser["name"]              = $dataUser["t_user_name"];
					$gUser["state"]             = $dataUser["t_user_state"];
					$gUser["type"]              = $dataUser["t_user_type"];
					$gUser["disp_lang"]         = $dataUser["t_user_disp_lang"];
					$gUser["login"]             = $dataUser["t_user_login"];
					$gUser["organization_id"]   = $dataUser["t_organization_id"];
					$gUser["organization_name"] = $dataUser["t_organization_name"];
					if ( is_null($gUser["organization_name"]) ){
						$gUser["organization_name"] = "";
					}
					
					if ($result === RES_OK ){
						// 前回のログイン日時を取得（最新ではないことに注意）
						$resDAOLogin = $objDAOLogin->get($userID, NULL, 1, 1);
						if ( $resDAOLogin["result"] === RES_OK ){
							$gUser["last_login"] = $resDAOLogin["data"][0]["t_login_date"];
						} else {
							$gUser["last_login"] = 0;
						}
					}
				} else {
					$result = RES_NG;
				}
			}
		}
		
		return ($result === RES_OK);
	}
}
