<?php
Class View {
	// クラス内部でのみ使用
	const _FORM_TYPE_DOCUMENT  = 1;
	const _FORM_TYPE_TERM      = 2;
	const _FORM_TYPE_BILINGUAL = 3;
	const _FORM_TYPE_DATA      = 4;
	
	/***************************************************************
	 * 名前:__construct
	 * 説明:コンストラクタ
	 * 引数:
	 * 返値:
	****************************************************************/
	function __construct(){
	}
	
	/***************************************************************
	 * 名前:instance
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public static function instance( $name ){
		$class = sprintf("View_%s", $name);
		require_once("class/View/{$class}.php");
		return new $class();
	}
	
	/***************************************************************
	 * 名前:formText
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	protected function formText( $isEdit, $name, $value ){
		$html = "";
		
		// 編集 --------------------
		if ( $isEdit ){
			$html = Printer::input("text", NULL, $name, $value);
		}
		// 表示 --------------------
		else {
			$html = Printer::formText($value);
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:formCheckbox
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	protected function formCheckbox($name, $value, $select, $required = FALSE, $arrOption = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW";
		
		$html = "";
		
		if( ! is_array($value) ){
			$value = array(0 => $value);
		}
		// チェックボックスでテキストがないものは非表示にする
		foreach ( $value as $key => $data ){
			if ( strlen($data) === 0 ){
				unset($value[$key]);
			}
		}
		
		if ( count($value) === 0 ){
			if ( $required ){
				// 無理矢理 validateエラーを発生させる
				$html .= Printer::input("hidden", NULL, "{$name}[]", NULL, "validate-item");
			}
		} else {
			if ( ! is_array($arrOption) ){
				$arrOption = array();
			}
			if ( ! isset($arrOption["label"]) ){
				$arrOption["label"] = array();
			}
			$arrOption["label"] = array_merge($arrOption["label"], array(
				"data-ellipsis" => 20,
			));
			
			if ( $select === TRUE ){
				$select = array_keys($value);
			} else if ( $select === FALSE ){
				$select = array();
			} else if ( is_array($select) && count($select) > 0 ){
				$select = array_keys($select);
			}
			$html = Printer::checkbox(NULL, "{$name}[]", $value, $select, $arrOption);
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:formDocument
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formDocument( $isEdit, $name, $value, $select, $required = FALSE, $arrOption = NULL, $arrButtons = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW";
		
		$html = "";
		if ( $isEdit ){
			// エディットモードの時はチェックボックスを表示
			$html = $this->formCheckbox($name, $value, $select, $required, $arrOption);
		} else {
			if ( $select === TRUE ){
				$select = $value;
			}
			if ( ! is_array($select) || count($select) === 0 ){
				return "";
			}
			foreach ( $select as $id => $text ){
				$hText = "";
				if ( is_array($value) && isset($value[$id]) ){
					$hText = Printer::link($text, NULL, "icon-file", NULL, "/content/document/detail.html?q_id={$id}");
				} else if ( ! empty($text) ){
					// 有効でない場合は、警告メッセージを付加して表示
					$hText  = Printer::iconWarning("{$WORD($wk, 1)}");
					$hText .= Printer::icon("icon-file", NULL, $text);
				}
				
				if ( ! empty($hText) ){
					$html .= Printer::ellipsis($hText, 20, FALSE);
					if ( is_array($arrButtons) && isset($arrButtons[$id]) ){
						$html .= $arrButtons[$id];
					}
				}
			}
		}
		return $html;
	}
	
	/***************************************************************
	 * 名前:formTerm
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formTerm( $isEdit, $name, $value, $select, $required = FALSE, $arrOption = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW";
		
		$html = "";
		if ( $isEdit ){
			// エディットモードの時はチェックボックスを表示
			$html = $this->formCheckbox($name, $value, $select, $required, $arrOption);
		} else {
			if ( $select === TRUE ){
				$select = $value;
			}
			if ( ! is_array($select) || count($select) === 0 ){
				return "";
			}
			foreach ( $select as $id => $text ){
				$hText = "";
				if ( is_array($value) && isset($value[$id]) ){
					$hText = Printer::link($text, NULL, "icon-book", NULL, "/content/term/?q_kind=".Term::KIND_TERM."&q_id={$id}");
				} else if ( ! empty($text) ){
					$hText  = Printer::iconWarning("{$WORD($wk, 2)}");
					$hText .= Printer::icon("icon-book", NULL, $text);
				}
				
				if ( ! empty($hText) ){
					$html .= Printer::ellipsis($hText, 20, FALSE);
				}
			}
		}
		return $html;
	}
	
	/***************************************************************
	 * 名前:formBilingual
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formBilingual( $isEdit, $name, $value, $select, $required = FALSE, $arrOption = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW";
		
		$html = "";
		if ( $isEdit ){
			// エディットモードの時はチェックボックスを表示
			$html = $this->formCheckbox($name, $value, $select, $required, $arrOption);
		} else {
			if ( $select === TRUE ){
				$select = $value;
			}
			if ( ! is_array($select) || count($select) === 0 ){
				return "";
			}
			foreach ( $select as $id => $text ){
				$hText = "";
				if ( is_array($value) && isset($value[$id]) ){
					$hText = Printer::link($text, NULL, "icon-book", NULL, "/content/term/?q_kind=".Term::KIND_BILINGUAL."&q_id={$id}");
				} else if ( ! empty($text) ){
					$hText  = Printer::iconWarning("{$WORD($wk, 3)}");
					$hText .= Printer::icon("icon-book", NULL, $text);
				}
				
				if ( ! empty($hText) ){
					$html .= Printer::ellipsis($hText, 20, FALSE);
				}
			}
		}
		return $html;
	}
	
	/***************************************************************
	 * 名前:formData
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formData( $isEdit, $name, $value, $select, $required = FALSE, $arrOption = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW";
		
		$html = "";
		if ( $isEdit ){
			// エディットモードの時はチェックボックスを表示
			$html = $this->formCheckbox($name, $value, $select, $required, $arrOption);
		} else {
			if ( $select === TRUE ){
				$select = $value;
			}
			if ( ! is_array($select) || count($select) === 0 ){
				return "";
			}
			foreach ( $select as $id => $text ){
				$hText = "";
				if ( is_array($value) && isset($value[$id]) ){
					$hText = Printer::link($text, NULL, "icon-paperclip", NULL, "/content/data/?q_id={$id}");
				} else if ( ! empty($text) ){
					$hText  = Printer::iconWarning("{$WORD($wk, 4)}");
					$hText .= Printer::icon("icon-paperclip", NULL, $text);
				}
				
				if ( ! empty($hText) ){
					$html .= Printer::ellipsis($hText, 20, FALSE);
				}
			}
		}
		return $html;
	}
	
	/***************************************************************
	 * 名前:xml2array
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	protected function xml2array( $xml, $kind, $key ){
		$arrRes = array();
		
		if ( strcmp($xml, "") === 0 ){
			return array();
		}
		
		$objXml = simplexml_load_string($xml, "SimpleXMLElement", LIBXML_NOCDATA);
		
		$arrRes = self::xml2arraySub($objXml->$kind->$key);
		
		return $arrRes;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	protected function xml2arraySub($objXml) {
		$arr = array();
		
		if ( is_object($objXml) ){
			$objXml = get_object_vars($objXml);
		} else {
			$objXml = $objXml;
		}
		
		foreach ( $objXml as $key => $val ){
			if ( is_object($objXml[$key]) ){
				$arr[$key] = self::xml2arraySub($val);
			} else if ( is_array($val) ){
				if ( strcmp($key, "item") === 0 ){
					foreach ( $val as $v ){
						$arr[] = $v;
					}
				} else {
					foreach ( $val as $k => $v ){
						if ( is_object($v) || is_array($v) ){
							$arr[$key][$k] = self::xml2arraySub($v);
						} else {
							$arr[$key][$k] = $v;
						}
					}
				}
			} else {
				if ( strcmp($key, "item") === 0 ){
					$arr[] = $val;
				} else {
					$arr[$key] = $val;
				}
			}
			
		}
		
		return $arr;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	protected function tabLink( $value, $class=NULL, $icon=NULL, $color=NULL, $href=NULL, $hrefQuery=NULL, $arrOption=NULL ){
		if ( is_array($hrefQuery) ){
			$href .= "?".http_build_query($hrefQuery);
		}
		
		return Printer::link($value, $class, $icon, $color, $href, NULL, $arrOption);
	}
	
	/***************************************************************
	 * 名前: tableHeaderPullDown
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	protected function tableHeaderPullDown( $headerText, $headerClass = NULL, $headerIcon = NULL, $headerIconColor = NULL, $arrItem = NULL, $arrOption = NULL){
		$hHeaderText = Printer::icon($headerIcon, $headerIconColor, $headerText);
		
		$arrDropdown = array();
		if ( ! is_array($arrOption) ){
			$arrOption = array();
		}
		if ( ! isset($arrOption["class"]) ){
			$arrOption["class"] = "";
		}
		$arrOption["class"] = "th-filter {$headerClass} ".$arrOption["class"];
		
		if ( Validate::isArray($arrItem) ){
			foreach ( $arrItem as $item ){
				if ( Validate::isArray($item) ){
					$liAttr = "";
					if ( isset($item["attr"]) ){
						$liAttr = $item["attr"];
					}
					if ( isset($item["value"]) ){
						$arrDropdown[] = "<li {$liAttr}>".$item["value"]."</li>";
					}
					continue;
				}
				if ( Validate::isString($item) && $item === "-" ){
					$arrDropdown[] = "<li class=\"divider\"></li>";
					continue;
				}
				
				$arrDropdown[] = "<li>".$item."</li>";
			}
		}
		
		if ( count($arrDropdown) > 0 ){
			$hOption = Printer::option($arrOption);
			$htmlDropdown = implode("\n", $arrDropdown);
$html = <<< HTML
			<div {$hOption}>
				<div class="dropdown">
					<a data-toggle="dropdown" href="#" class="dropdown-toggle">
						{$hHeaderText}
						<span class="caret"></span>
					</a>
					<ul class="dropdown-menu">
						{$htmlDropdown}
					</ul>
				</div>
			</div>
HTML;
		} else {
			$html = $hHeaderText;
		}
		
		return $html;
	}
	
	private function _getTableHeaderOrderPlus( $arrPullDown, $query, $orderKey ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW";

		if ( ! is_array($arrPullDown)){
			$arrPullDown = array();
		}
		
		$arrOrderLink = array();
		if ( ! is_null($orderKey) ){
			unset($query["q_offset"]);
			// 昇順
			$subQuery = $query;
			if ( isset($query["q_order"]) && $query["q_order"] === "{$orderKey}-asc" ){
				$linkClass = "alert-success";
				unset($subQuery["q_order"]);
			} else {
				$linkClass = NULL;
				$subQuery["q_order"] = "{$orderKey}-asc";
			}
			$arrOrderOption = array(
				"data-order-name" => $orderKey,
				"data-order-type" => "asc",
			);
			$arrOrderLink[] = $this->tabLink("{$WORD($wk, 5)}", $linkClass, "icon-sort-by-alphabet", NULL, "./", $subQuery, $arrOrderOption);
			// 降順
			$subQuery = $query;
			if ( isset($query["q_order"]) && $query["q_order"] === "{$orderKey}-desc" ){
				$linkClass = "alert-success";
				unset($subQuery["q_order"]);
			} else {
				$linkClass = NULL;
				$subQuery["q_order"] = "{$orderKey}-desc";
			}
			$arrOrderOption = array(
				"data-order-name" => $orderKey,
				"data-order-type" => "desc",
			);
			$arrOrderLink[] = $this->tabLink("{$WORD($wk, 6)}", $linkClass, "icon-sort-by-alphabet-alt", NULL, "./", $subQuery, $arrOrderOption);
			if ( count($arrPullDown) > 0 ){
				$arrOrderLink[] = "-";
			}
		}
		
		return array_merge($arrOrderLink, $arrPullDown);
	}
	
	/***************************************************************
	 * 名前: tableHeader
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	protected function tableHeader( $headerText, $headerIcon = NULL, $headerColor = NULL, $arrPullDownLink = NULL, $query = NULL, $queryName = NULL, $orderKey = NULL, $arrOption = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW";
		
		$alreadyOrder = FALSE;
		if ( isset($query["q_order"]) ){
			if ( substr($query["q_order"], 0, strlen($orderKey)+1) === "{$orderKey}-" ){
				$alreadyOrder = TRUE;
			}
		}
		
		if ( isset($query[$queryName]) && strlen($query[$queryName]) > 0 ){
			$headerIcon .= " select";
		}
		
		$arr = $this->_getTableHeaderOrderPlus( $arrPullDownLink, $query, $orderKey );
		$html = $this->tableHeaderPullDown( $headerText, $alreadyOrder ? "alert-success" : NULL, $headerIcon, $headerColor, $arr, $arrOption );
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: tableHeaderQueryFilter
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	protected function tableHeaderQueryFilter( $headerText, $arrItem = NULL, $query = NULL, $queryName = NULL, $orderKey = NULL, $arrOption = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW";
		
		if ( isset($query["q_offset"]) ){
			unset($query["q_offset"]);
		}
		
		$selectedValue = NULL;
		if ( isset($query[$queryName]) ){
			$selectedValue = $query[$queryName];
			if ( Validate::isNumeric($selectedValue) ){
				setType($selectedValue, "int");
			}
		}
		
		$arrStateFilter = array();
		// ヘッダー
		$arrStateFilter[] = array(
			"attr"  => "class=\"dropdown-header\"",
			"value" => Printer::icon("icon-filter", NULL, "{$WORD($wk, 7)}"),
		);
		// すべて表示
		$subQuery = $query;
		if ( isset($subQuery[$queryName]) ){
			unset($subQuery[$queryName]);
		}
		$arrFilterOption = array(
			"data-filter-name" => $queryName,
		);
		$arrStateFilter[] = $this->tabLink("{$WORD($wk, 8)}", NULL, is_null($selectedValue) ? "icon-ok" : "icon-none", NULL, "./", $subQuery, $arrFilterOption);
		
		foreach ( $arrItem as $key => $text ){
			$subQuery = array_merge($query, array($queryName => $key));
			$arrFilterOption = array(
				"data-filter-name"  => $queryName,
				"data-filter-value" => $key,
			);
			$arrStateFilter[] = $this->tabLink($text, NULL, $selectedValue===$key ? "icon-ok" : "icon-none" , NULL, "./", $subQuery, $arrFilterOption);
		}
		
		return $this->tableHeader($headerText, "icon-filter", NULL, $arrStateFilter, $query, $queryName, $orderKey, $arrOption);
	}
}
