<?php require_once("class/View.php"); ?>
<?php
Class View_data extends View {
	const TAB_LIST                  = 0;
	const TAB_LIST_BRIEF            = 1;
	const TAB_LIST_RESEARCH_RESULTS = 2;
	const TAB_LIST_DELIVERABLE      = 3;
	const TAB_LIST_OTHER            = 4;
	const TAB_LIST_PUBLIC           = 5;
	const TAB_NEW                   = 6;
	const TAB_EDIT                  = 7;
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $tab, $auth, $projectID, $id = 0 ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DATA";
		
		$html = FALSE;
		$query = array(
			"q_project_id" => $projectID,
		);
		
		switch ( $tab ){
			//------------------------
			// データ一覧
			case self::TAB_LIST:
				$html = $this->tab_list($auth, $projectID);
				break;
			//------------------------
			// 概要データ一覧
			case self::TAB_LIST_BRIEF:
				if ( $auth->readList($projectID) ){
					$query["q_prop"] = DAO::T_DATA_PROP_BRIEF;
					$html = $this->tabLink("{$WORD($wk, 1)}", NULL, NULL, NULL, "./", $query);
				}
				break;
			//------------------------
			// 調査結果データ一覧
			case self::TAB_LIST_RESEARCH_RESULTS:
				if ( $auth->readList($projectID) ){
					$query["q_prop"] = DAO::T_DATA_PROP_RESEARCH;
					$html = $this->tabLink("{$WORD($wk, 2)}", NULL, NULL, NULL, "./", $query);
				}
				break;
			//------------------------
			// 納品物データ一覧
			case self::TAB_LIST_DELIVERABLE:
				if ( $auth->readList($projectID) ){
					$query["q_prop"] = DAO::T_DATA_PROP_DELIVER;
					$html = $this->tabLink("{$WORD($wk, 3)}", NULL, NULL, NULL, "./", $query);
				}
				break;
			//------------------------
			// その他データ一覧
			case self::TAB_LIST_OTHER:
				if ( $auth->readList($projectID) ){
					$query["q_prop"] = DAO::T_DATA_PROP_OTHERS;
					$html = $this->tabLink("{$WORD($wk, 4)}", NULL, NULL, NULL, "./", $query);
				}
				break;
			//------------------------
			// 公開データ一覧
			case self::TAB_LIST_PUBLIC:
				if ( $auth->write(INIT_ID, $projectID) ){
					$query["q_is_public"] = ON;
					$html = $this->tabLink("{$WORD($wk, 5)}", NULL, NULL, NULL, "./", $query);
				}
				break;
			//------------------------
			// データ新規登録
			case self::TAB_NEW:
				if ( $auth->write(INIT_ID, $projectID) ){
					$html = $this->tabLink("{$WORD($wk, 6)}", NULL, "icon-plus", NULL, "./edit.html", $query);
				}
				break;
			//------------------------
			// データ編集
			case self::TAB_EDIT:
				if ( $auth->write($id, $projectID) ){
					$query["q_id"] = $id;
					$html = $this->tabLink("{$WORD($wk, 7)}", NULL, "icon-pencil", NULL, "./edit.html", $query);
				}
				break;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab_list( $auth, $projectID ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DATA";
		
		$html = FALSE;
		if ( ! $auth->readList($projectID) ){
			return $html;
		}
		
		$arrPullDown = array();
		// 概要
		if ( $auth->readList($projectID) ){
			$query = array(
				"q_project_id" => $projectID,
				"q_prop"       => DAO::T_DATA_PROP_BRIEF,
			);
			$arrPullDown[] = $this->tabLink("{$WORD($wk, 8)}", NULL, NULL, NULL, "./", $query);
		}
		// 調査結果
		if ( $auth->readList($projectID) ){
			$query = array(
				"q_project_id" => $projectID,
				"q_prop"       => DAO::T_DATA_PROP_RESEARCH,
			);
			$arrPullDown[] = $this->tabLink("{$WORD($wk, 9)}", NULL, NULL, NULL, "./", $query);
		}
		// 納品物
		if ( $auth->readList($projectID) ){
			$query = array(
				"q_project_id" => $projectID,
				"q_prop"       => DAO::T_DATA_PROP_DELIVER,
			);
			$arrPullDown[] = $this->tabLink("{$WORD($wk, 10)}", NULL, NULL, NULL, "./", $query);
		}
		// その他
		if ( $auth->readList($projectID) ){
			$query = array(
				"q_project_id" => $projectID,
				"q_prop"       => DAO::T_DATA_PROP_OTHERS,
			);
			$arrPullDown[] = $this->tabLink("{$WORD($wk, 11)}", NULL, NULL, NULL, "./", $query);
		}
		// 公開
		if ( $auth->write(INIT_ID, $projectID) ){
			$query = array(
				"q_project_id" => $projectID,
				"q_is_public"  => ON,
			);
			$arrPullDown[] = $this->tabLink("{$WORD($wk, 12)}", NULL, NULL, NULL, "./", $query);
		}
		
		$html = array(
			"title" => "{$WORD($wk, 13)}",
			"item"  => $arrPullDown,
		);
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function table( $tablist, $projectID, $arrData, $arrProjectData, $query ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DATA";
		
		$auth = Auth::instance("data");
		
		$html = "";
		$htmlError = "";
		
		// タイプ(prop)の表示
		$viewProp = TRUE;
		if ( $tablist === self::TAB_LIST_BRIEF || $tablist === self::TAB_LIST_DELIVERABLE || $tablist === self::TAB_LIST_RESEARCH_RESULTS || $tablist === self::TAB_LIST_OTHER ){
			$viewProp = FALSE;
		}
		// 登録者の表示
		$viewRegister = TRUE;
		if ( $tablist === self::TAB_LIST_PUBLIC ){
			$viewRegister = FALSE;
		}
		
		// 公開範囲の絞り込みリスト
		$filterPublic = DAO::T_DATA_PUBLIC_TABLE();
		if ( $tablist === self::TAB_LIST_PUBLIC ){
			unset($filterPublic[DAO::T_DATA_PUBLIC_PRJ]);
		}
		
		$arrPrepareProjectData = array();
		$arrUser = array();
		foreach ( $arrProjectData as $dataProjectData ){
			$dataID = $dataProjectData["t_data_id"];
			$userID = $dataProjectData["t_user_id"];
			if ( $userID === INIT_ID || isset($arrPrepareProjectData[$dataID]) ){
				continue;
			}
			
			if ( ! isset($arrUser[$userID]) ){
				$arrUser[$userID] = Util::esc(DAO::storedFunction("get_user_name", $userID));
			}
			$dataProjectData["t_user_name"] = $arrUser[$userID];
			$arrPrepareProjectData[$dataID] = $dataProjectData;
		}
		
		$organizationID = DAO::storedFunction("get_project_organization_id", $projectID);
		
		foreach ( $arrData as $data ){
			$id            = $data["t_data_id"];
			$state         = $data["t_data_state"];
			$public        = $data["t_data_public"];
			$title         = $data["t_data_title"];
			$prop          = $data["t_data_props"];
			$comment       = $data["t_data_comment"];
			$userID        = $data["t_user_id"];
			$organizationName = $data["t_organization_name"];
			$dataProjectID    = $data["t_project_id"];
			$dataProjectName  = $data["t_project_name"];
			if ( isset($arrPrepareProjectData[$id]) ){
				$isRegister = TRUE;
				$user = $arrPrepareProjectData[$id]["t_user_name"];
			} else {
				$isRegister = FALSE;
				$user = " - ";
			}
			
			// 状態によるチェック
			$isErrorState = ($state !== DAO::T_DATA_STATE_NORMAL);
			
			// 公開範囲によるチェック
			switch ( $public ){
				case DAO::T_DATA_PUBLIC_PRJ:
					$isErrorPublic = ($dataProjectID !== $projectID);
					break;
				case DAO::T_DATA_PUBLIC_ORG:
					$isErrorPublic = (DAO::storedFunction("get_project_organization_id", $dataProjectID) !== $organizationID);
					break;
				case DAO::T_DATA_PUBLIC_OPN:
					$isErrorPublic = FALSE;
					break;
				default:
					$isErrorPublic = TRUE;
			}
			
			$isError = $isErrorPublic || $isErrorState;
			
			// タイトル
			$hTitle = Printer::ellipsis($title, 20);
			$icon = ($projectID === $dataProjectID || $tablist === self::TAB_LIST_PUBLIC) ? "icon-paperclip" : "icon-share-alt";
			if ( $isErrorState ){
				$hTitle = Printer::iconWarning("{$WORD($wk, 14)}")." ".$hTitle;
			} else if ( $isErrorPublic ){
				$hTitle = Printer::iconWarning("{$WORD($wk, 15)}")." ".$hTitle;
			} else {
				// ファイルが存在する
				$file = Setting::get("PATH_DATA_DATA") . "/{$id}";
				if ( $auth->processDownload($id, $projectID) && file_exists($file) ){
					// ダウンロード
					$hTitle = Printer::link($hTitle, NULL, $icon, NULL, NULL, "minhon.common.onClickPost('/app/dataController.php', {q_id:{$id}});", NULL, NULL, FALSE);
				} else if ( $auth->write($id, $projectID) ){
					// 編集
					$hTitle = Printer::link($hTitle, NULL, $icon, NULL, "/content/data/edit.html?q_id={$id}", NULL, NULL, NULL, FALSE);
				} else {
					$hTitle = Printer::icon($icon)." ".$hTitle;
				}
			}
			// タイプ
			$hProp = DAO::T_DATA_PROP_TABLE($prop);
			// 公開
			$hPublic = DAO::T_DATA_PUBLIC_TABLE($public);
			// プロジェクト名
			$hProjectName = Printer::icon("icon-th") . " " . Printer::ellipsis($dataProjectName, 10);
			// 組織
			$hOrganizationName = Printer::icon("icon-star") . " " . Util::esc($organizationName);
			// コメント
			$hComment = Printer::ellipsis($comment, 20);
			// 登録者
			$hRegister = Util::esc($user);
			// 操作
			$hOperation = "";
			if ( ! $isRegister ){
				// プロジェクトに未登録なら、利用登録ボタンを表示させる
				if ( $auth->refrence($id, $projectID) ){
					$hOperation = Printer::link("{$WORD($wk, 16)}", "btn btn-success", "icon-plus", "#FFF", NULL, "minhon.common.onClickPost('./project.html', {q_id:{$id}, q_delete:".OFF."}, '{$WORD($wk, 17)}');");
				}
			} else {
				$arrButton = array();
				// 編集
				if ( $auth->write($id, $projectID) ){
					$arrButton[] = array(
						"class" => ! $isError ? "" : "disabled",
						"text"  => Printer::link("{$WORD($wk, 18)}", NULL, "icon-pencil", NULL, "/content/data/edit.html?q_id={$id}"),
					);
				}
				// ダウンロード
				$arrButton[] = array(
					"class" => $auth->processDownload($id, $projectID) && ! $isError ? "" : "disabled",
					"text"  => Printer::link("{$WORD($wk, 19)}", NULL, "icon-save", NULL, NULL, "minhon.common.onClickPost('/app/dataController.php', {q_id:{$id}});"),
				);
				// 削除
				if ( $auth->remove($id, $projectID) ){
					$arrButton[] = array(
						"class" => ! $isError ? "" : "disabled",
						"text"  => Printer::link("{$WORD($wk, 20)}", NULL, "icon-remove", NULL, NULL, "minhon.common.onClickPost('./delete.html', {q_id:{$id}}, '{$WORD($wk, 21)}');"),
					);
				}
				// 除外
				if ( $dataProjectID !== $projectID ){
					if ( $auth->refrence($id, $projectID) ){
						$arrButton[] = "-";
						$arrButton[] = Printer::link("{$WORD($wk, 22)}", NULL, "icon-minus", NULL, NULL, "minhon.common.onClickPost('./project.html', {q_id:{$id}, q_delete:".ON."}, '{$WORD($wk, 23)}');");
					}
				}
				
				// 操作
				$hOperation = Printer::buttonGroup("{$WORD($wk, 24)}", $arrButton);
			}
			
			$hRow = "";
			// タイトル
			$hRow .= "<td>{$hTitle}</td>";
			if ( $viewProp ){
				// Prop
				$hRow .= "<td>{$hProp}</td>";
			}
			// 公開範囲
			$hRow .= "<td>{$hPublic}</td>";
			if ( $viewRegister){
				// 登録者
				$hRow .= "<td>{$hRegister}</td>";
			}
			// プロジェクト
			$hRow .= "<td>{$hProjectName}</td>";
			// 組織
			$hRow .= "<td>{$hOrganizationName}</td>";
			// 組織
			$hRow .= "<td class=\"col-tight\">{$hOperation}</td>";
			$hRow = "<tr>{$hRow}</tr>";
			
			if ( $isError ){
				$htmlError .= $hRow;
			} else {
				$html .= $hRow;
			}
		}
		
		if ( strlen($htmlError) > 0 ){
$htmlError = <<< HTML
			<thead class="thead-danger">
				<tr>
					<th colspan="8">{$WORD($wk, 25)}</th>
				</tr>
			</thead>
			<tbody class="tbody-danger">
				{$htmlError}
			</tbody>
HTML;
		}
		
		$hRow = "";
		// 名前
		$hRow .= "<th>{$WORD($wk, 26)}</th>";
		if ( $viewProp ){
			// タイプ
			$headerProp = $this->tableHeaderQueryFilter("{$WORD($wk, 27)}", DAO::T_DATA_PROP_TABLE(), $query, "q_prop", DAO_data::ORDER_KEY_PROP);
			$hRow .= "<th>{$headerProp}</th>";
		}
		// 公開範囲
		$headerPublic = $this->tableHeaderQueryFilter("{$WORD($wk, 28)}", $filterPublic, $query, "q_public", DAO_data::ORDER_KEY_PUBLIC);
		$hRow .= "<th>{$headerPublic}</th>";
		if ( $viewRegister){
			// 登録者
			$hRow .= "<th>{$WORD($wk, 29)}</th>";
		}
		// プロジェクト
		$hRow .= "<th>{$WORD($wk, 30)}</th>";
		// 組織
		$hRow .= "<th>{$WORD($wk, 31)}</th>";
		// 操作
		$hRow .= "<th class=\"col-tight\">{$WORD($wk, 32)}</th>";
		
$html = <<< HTML
		<table class="table table-striped">
			<thead>
				{$hRow}
			</thead>
			<tbody>
				{$html}
			</tbody>
			{$htmlError}
		</table>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:title
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function title( $data ){
		$title  = Util::esc($data["t_data_title"]);
		$public = $data["t_data_public"];
		
		$title = "{$title}（".DAO::T_DATA_PUBLIC_TABLE($public)."）";
		
		return $title;
	}
}
