<?php require_once("class/DocTmx.php"); ?>
<?php require_once("class/View.php"); ?>
<?php
Class View_document extends View {
	const TAB_LIST           = 0;
	const TAB_NEW            = 1;
	const TAB_EDIT           = 2;
	const TAB_DETAIL         = 3;
	const TAB_WORKFLOW       = 4;
	const TAB_EXPORT         = 5;
	const TAB_QREDIT         = 6;
	const TAB_QREDIT_COMPARE = 7;
	const TAB_DIFF           = 8;
	const TAB_DIFF_SELECT    = 9;
	const TAB_SEARCH         = 10;
	const TAB_DOWNLOAD_ALL   = 11;
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $tab, $auth, $projectID, $id = 0, $dataXML = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DOCUMENT";
		
		$html = FALSE;
		$query = array(
			"q_project_id" => $projectID,
		);
		
		switch ( $tab ){
			//------------------------
			// 文書一覧
			case self::TAB_LIST:
				if ( $auth->readList($projectID) ){
					$html = $this->tabLink("{$WORD($wk, 1)}", NULL, NULL, NULL, "/content/document/", $query);
				}
				break;
			//------------------------
			// 文書新規登録
			case self::TAB_NEW:
				if ( $auth->write(INIT_ID, $projectID) ){
					$html = $this->tabLink("{$WORD($wk, 2)}", NULL, "icon-plus", NULL, "/content/document/edit.html", $query);
				}
				break;
			//------------------------
			// 文書編集
			case self::TAB_EDIT:
				if ( $auth->write($id, $projectID) ){
					$query["q_id"] = $id;
					$html = $this->tabLink("{$WORD($wk, 3)}", NULL, "icon-pencil", NULL, "/content/document/edit.html", $query);
				}
				break;
			//------------------------
			// 文書詳細
			case self::TAB_DETAIL:
				if ( $auth->read($id, $projectID) ){
					$query["q_id"] = $id;
					$html = $this->tabLink("{$WORD($wk, 4)}", NULL, NULL, NULL, "/content/document/detail.html", $query);
				}
				break;
			//------------------------
			// ワークフロー詳細
			case self::TAB_WORKFLOW:
				if ( $auth->processWorkflowRead($id, $projectID) ){
					$query["q_id"] = $id;
					$html = $this->tabLink("{$WORD($wk, 5)}", NULL, NULL, NULL, "/content/document/workflow.html", $query);
				}
				break;
			//------------------------
			// ダウンロード
			case self::TAB_EXPORT:
				if ( $auth->processExport($id, $projectID) && ! is_null($dataXML) ){
					$tmxQuery = array(
						"q_mode" => APP_DOCUMENT_CONTROLLER_MODE_EXPORT,
						"q_id"   => $id,
					);
					$transQuery = array(
						"q_mode" => APP_DOCUMENT_CONTROLLER_MODE_EXPORT2,
						"q_id"   => $id,
					);
					
					$arrPullDown = array();
					if ( ($revList = $this->revisionList($dataXML)) === FALSE ){
						$revList = array();
					}
					if ( is_array($revList) && count($revList) > 0 ){
						//**************
						// TMX
						//**************
						$arrTMX = array();
						$arrTMX[] = $this->tabLink("{$WORD($wk, 6)}", NULL, NULL, NULL, "/app/documentController.php", $tmxQuery + array("q_revision"=>0));
						$arrTMX[] = $this->tabLink("{$WORD($wk, 7)}", NULL, NULL, NULL, "/app/documentController.php", $tmxQuery);
						$arrTMX[] = "-";
						foreach ( $revList as $revInfo ){
							$rev   = $revInfo["revision"];
							$title = $revInfo["title"];
							$arrTMX[] = $this->tabLink("{$rev}: {$title}", NULL, NULL, NULL, "/app/documentController.php", $tmxQuery + array("q_revision"=>$rev));
						}
						$arrPullDown[] = array(
							"title" => "{$WORD($wk, 8)}",
							"item"  => $arrTMX,
						);
						
						//**************
						// 訳文
						//**************
						$arrTrans = array();
						$arrTrans[] = $this->tabLink("{$WORD($wk, 9)}", NULL, NULL, NULL, "/app/documentController.php", $transQuery + array("q_revision"=>0));
						$arrTrans[] = "-";
						foreach ( $revList as $revInfo ){
							$rev   = $revInfo["revision"];
							$title = $revInfo["title"];
							$arrTrans[]= $this->tabLink("{$rev}: {$title}", NULL, NULL, NULL, "/app/documentController.php", $transQuery + array("q_revision"=>$rev));
						}
						$arrTrans[] = "-";
						$arrTrans[] = $this->tabLink("{$WORD($wk, 10)}", NULL, NULL, NULL, "/app/documentController.php", $transQuery);
						$arrPullDown[] = array(
							"title" => "{$WORD($wk, 11)}",
							"item"  => $arrTrans,
						);
					} else {
						$arrPullDown[] = $this->tabLink("{$WORD($wk, 12)}", NULL, NULL, NULL, "/app/documentController.php", $tmxQuery + array("q_revision"=>0));
						$arrPullDown[] = $this->tabLink("{$WORD($wk, 13)}", NULL, NULL, NULL, "/app/documentController.php", $transQuery + array("q_revision"=>0));
					}
					
					$html = array(
						"title" => "{$WORD($wk, 14)}",
						"item"  => $arrPullDown,
						"icon"  => "icon-save",
					);
				}
				break;
			//------------------------
			// 翻訳、修正
			case self::TAB_QREDIT:
				if ( $auth->processEditor($id, $projectID) && ! is_null($dataXML) ){
					$document = new Document($id);
					$document->xml = $dataXML;
					
					$qreditMode = $document->getQReditMode(User::get("id"));
					if ( ($qreditInfo = $document->getQReditModeInfo($qreditMode, $id)) !== FALSE ){
						$html = Printer::link($qreditInfo["text"], "tab-danger", $qreditInfo["icon"], NULL, $qreditInfo["url"], NULL, $qreditInfo["opt"]);
					}
				}
				break;
			//------------------------
			// 比較
			case self::TAB_QREDIT_COMPARE:
				if ( $auth->processEditor($id, $projectID) && ! is_null($dataXML) ){
					$document = new Document($id);
					$document->xml = $dataXML;
					
					$qreditMode = $document->getQReditMode(User::get("id"));
					if ( ($qreditMode !== FALSE) && $document->getQReditMode_Compare() ){
						if ( ($qreditInfo = $document->getQReditModeInfo(Document::QREDIT_MODE_COMPARE, $id)) !== FALSE ){
							$html = Printer::link($qreditInfo["text"], "tab-danger", $qreditInfo["icon"], NULL, $qreditInfo["url"], NULL, $qreditInfo["opt"]);
						}
					}
				}
				break;
			//------------------------
			// 文書比較
			case self::TAB_DIFF:
				if ( $auth->processDiff($projectID) ){
					$html = $this->tabLink("{$WORD($wk, 15)}", NULL, "icon-resize-horizontal", NULL, "/content/document/diff/", $query);
				}
				break;
			//------------------------
			// 文書比較選択
			case self::TAB_DIFF_SELECT:
				if ( $auth->processDiff($projectID) ){
					$html = $this->tabLink("{$WORD($wk, 16)}", "tab-warning tab-document-select");
				}
				break;
			//------------------------
			// 検索
			case self::TAB_SEARCH:
				$authProject = Auth::instance("project");
				if ( $authProject->processDSearch($projectID) ){
					$arrQuery = array(
						"q_project_id" => $projectID,
						"q_mode" => CONTENT_SEARCH_INDEX_MODE_DOCUMENT,
					);
					$html = Printer::link("{$WORD($wk, 17)}", "tab-search", "icon-search", NULL, "/content/search/?".http_build_query($arrQuery), NULL, array("target"=>"_blank"));
				}
				break;
			//------------------------
			// 一括ダウンロード
			case self::TAB_DOWNLOAD_ALL:
				if ( $auth->readList($projectID) ){
					$html = $this->tabLink("{$WORD($wk, 18)}", NULL, "icon-save", NULL, "/content/document/download.html", $query);
				}
				break;
		}
		
		return $html;
	}

	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function table( $arrData ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DOCUMENT";
		
		$auth = Auth::instance("document");
		
		$html = "";
		$disabledBatchScript = FALSE;
		
		$organizationId = "";
		$qAPIName       = "";
		$qAPIKey        = "";
		$qAPISecret     = "";
		$WebAPIFlag     = TRUE;
		////////////////////////
		// WebAPI接続情報取得 //
		////////////////////////
		$objDAOOrganization  = DAO::instance("organization");
		$organizationId = User::get("organization_id");
		// 組織情報テーブルよりWebAPI接続情報を取得
		$resDAOOrganizationApiInfo = $objDAOOrganization->getApiInfo($organizationId);
		if ( $resDAOOrganizationApiInfo["result"] === RES_OK ){
			$dataApiInfo = $resDAOOrganizationApiInfo["data"][0];
			$qAPIName   = $dataApiInfo["t_mtauto_name"];
			$qAPIKey    = $dataApiInfo["t_mtauto_key"];
			$qAPISecret = $dataApiInfo["t_mtauto_secret"];
		}
		// 取得した接続情報が不正の場合
		if (($qAPIName === "")||($qAPIKey === "")||($qAPISecret === "")){
			$WebAPIFlag = FALSE;
		}

		foreach ( $arrData as $data ){
			$id        = $data["t_document_id"];
			$state     = $data["t_document_state"];
			$langS     = $data["t_document_lang_s"];
			$langT     = $data["t_document_lang_t"];
			$title     = $data["t_document_title"];
			$projectID = $data["t_project_id"];

			$document = new Document($id);
			$document->xml = $data["t_document_text"];
			
			// タイトル
			$hTitle = Printer::ellipsis($title, 30);
			$hTitle = Printer::link($hTitle, NULL, "icon-file", NULL, "/content/document/detail.html?q_id={$id}", NULL, NULL, FALSE);
			// 言語
			$hLang = Printer::directLang($langS, $langT);
			// 状態
			$hState = Util::esc(DAO::T_DOCUMENT_STATE_TABLE($state));
			// ボタン(翻訳)
			$buttonEdit = "";
			$qreditMode = $document->getQReditMode(User::get("id"));
			if ( ($qreditInfo = $document->getQReditModeInfo($qreditMode, $id)) !== FALSE ){
				$buttonEdit .= Printer::link($qreditInfo["text"], "btn btn-danger", $qreditInfo["icon"], NULL, $qreditInfo["url"], NULL, $qreditInfo["opt"]);
			}
			if ( ($qreditMode !== FALSE) && $document->getQReditMode_Compare() ){
				if ( ($qreditInfo = $document->getQReditModeInfo(Document::QREDIT_MODE_COMPARE, $id)) !== FALSE ){
					$buttonEdit .= Printer::link($qreditInfo["text"], "btn btn-danger", $qreditInfo["icon"], NULL, $qreditInfo["url"], NULL, $qreditInfo["opt"]);
				}
			}
			if ( strlen($buttonEdit) === 0 ){
				$buttonEdit = " - ";
			}
			// 操作
			{
				$arrButton = array();
				// 一括挿入
				{
					$arrBatch = array();
					// 原文を挿入
					if ( $auth->processInsertSourceText($id, $projectID) ){
						$batchMode = Document::BATCH_MODE_SOURCE_TEXT;
						$arrBatch[] = Printer::link(Document::BATCH_MODE_TABLE($batchMode), NULL, "icon-play", NULL, NULL, "minhon.common.onClickPost('./batch.html', {q_id:{$id}, q_mode:{$batchMode}}, '{$WORD($wk, 19)}');");
					}
					// 類似文を挿入
					if (( $auth->processInsertSimilarity($id, $projectID) ) && $WebAPIFlag ){
						$batchMode = Document::BATCH_MODE_SIMILARITY;
						$arrBatch[] = Printer::link(Document::BATCH_MODE_TABLE($batchMode), NULL, "icon-play", NULL, NULL, "minhon.common.onClickPost('./batch.html', {q_id:{$id}, q_mode:{$batchMode}}, '{$WORD($wk, 20)}');");
					}
					// 機械翻訳
					if ( $auth->processRunMT($id, $projectID) ){
						// 言語方向がWebAPI機械翻訳の限定言語方向に一致する場合に、「機械翻訳」を表示する。
						if (WebAPI::isSupport(WebAPI::TYPE_TRANSLATE_WEB_API, $langS, $langT) === TRUE){
							$batchMode = Document::BATCH_MODE_MT;
							$arrBatch[] = Printer::link(Document::BATCH_MODE_TABLE($batchMode), NULL, "icon-play", NULL, NULL, "minhon.common.onClickPost('./batch.html', {q_id:{$id}, q_mode:{$batchMode}}, '{$WORD($wk, 21)}\\n{$WORD($wk, 22)}');");
						}
					}
					if ( count($arrBatch) > 0 ){
						$arrButton[] = array(
							"class" => "dropdown-header",
							"text"  => "{$WORD($wk, 23)}",
						);
						if ( $state === DAO::T_DOCUMENT_STATE_MTWAIT ){
							foreach( $arrBatch as $batchLink ){
								$arrButton[] = array(
									"class" => "disabled",
									"text"  => $batchLink,
								);
							}
						} else {
							$arrButton = array_merge($arrButton, $arrBatch);
						}
						$arrButton[] = "-";
						$disabledBatchScript = TRUE;
					}
				}
				// 編集
				if ( $auth->write($id, $projectID) ){
					$arrButton[] = Printer::link("{$WORD($wk, 24)}", NULL, "icon-pencil", NULL, "/content/document/edit.html?q_id={$id}");
				}
				// ダウンロード
				if ( $auth->processExport($id, $projectID) ){
					$arrButton[] = Printer::link("{$WORD($wk, 25)}", NULL, "icon-save", NULL, "/app/documentController.php?q_mode=".APP_DOCUMENT_CONTROLLER_MODE_EXPORT."&q_id={$id}&q_revision=0");
				}
				// コピー
				if ( $auth->processCopy($id, $projectID) ){
					$arrButton[] = Printer::link("{$WORD($wk, 26)}", NULL, "icon-file", NULL, NULL, "minhon.common.onClickGet('./edit.html', {q_copy_id:{$id}}, '{$WORD($wk, 27)}');");
				}
				// 削除
				if ( $auth->remove($id, $projectID) ){
					$arrButton[] = Printer::link("{$WORD($wk, 28)}", NULL, "icon-remove", NULL, NULL, "minhon.common.onClickPost('./delete.html', {q_id:{$id}}, '{$WORD($wk, 29)}');");
				}
				// 操作
				$hOperation = Printer::buttonGroup("{$WORD($wk, 30)}", $arrButton);
			}
			
$html .= <<< HTML
			<tr>
				<td>{$hTitle}</td>
				<td>{$hLang}</td>
				<td>{$hState}</td>
				<td>{$buttonEdit}</td>
				<td class="col-tight">{$hOperation}</td>
			</tr>
HTML;
		}
		
$html = <<< HTML
		<table class="table">
			<thead>
				<th>{$WORD($wk, 31)}</th>
				<th>{$WORD($wk, 32)}</th>
				<th>{$WORD($wk, 33)}</th>
				<th>{$WORD($wk, 34)}</th>
				<th class="col-tight">{$WORD($wk, 35)}</th>
			</thead>
			<tbody>
				{$html}
			</tbody>
		</table>
HTML;
		
		if ( $disabledBatchScript ){
$html .= <<< HTML
			<script>
				$(".dropdown-menu .disabled a").each( function(){
					this.onclick = null;
				});
			</script>
HTML;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tableDiff( $arrData, $searchValue, $query ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DOCUMENT";
		
		$html = "";
		
		foreach ( $arrData as $data ){
			$id     = $data["t_document_id"];
			$state  = $data["t_document_state"];
			$langS  = $data["t_document_lang_s"];
			$langT  = $data["t_document_lang_t"];
			$title  = $data["t_document_title"];
			
			// チェックボックス
			$hCheck = Printer::checkbox(NULL, "q_doc_id[]", array($id => $title));
			// 言語
			$hLang = Printer::directLang($langS, $langT);
			// 状態
			$hState = Util::esc(DAO::T_DOCUMENT_STATE_TABLE($state));
			
$html .= <<< HTML
			<tr>
				<td>{$hCheck}</td>
				<td>{$hLang}</td>
				<td>{$hState}</td>
			</tr>
HTML;
		}
		
		$headerTitle = $this->tableHeader("{$WORD($wk, 36)}", "icon-search", NULL, array(
			Printer::link("{$WORD($wk, 37)}", NULL, "icon-search", NULL, NULL, "minhon.document.diff.onClickFilterTitle();"),
			Validate::isString($searchValue) ? Printer::link("{$WORD($wk, 38)}", NULL, "icon-none", NULL, NULL, "minhon.document.diff.onClickFilterTitleClear();") : NULL,
		), $query, "q_keyword", DAO_document::ORDER_KEY_TITLE);
		
		$headerLang  = $this->tableHeader("{$WORD($wk, 39)}", NULL, NULL, NULL, $query, NULL, DAO_document::ORDER_KEY_LANG);
		
$html = <<< HTML
		<table class="table">
			<thead>
				<th>{$headerTitle}</th>
				<th>{$headerLang}</th>
				<th>{$WORD($wk, 40)}</th>
			</thead>
			<tbody>
				{$html}
			</tbody>
		</table>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tableDiffForm( $searchValue ){
		$html = "";
		
		$html .= $this->_dialogFilterTitle($searchValue);
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:title
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function title( $data ){
		$html = "";
		
		$title = Util::esc($data["t_document_title"]);
		$title = Printer::ellipsis($title, 15, FALSE);
		
		return $title;
	}
	
	/***************************************************************
	 * 名前:detail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function detail( $data ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DOCUMENT";
		
		$html = "";
		
		$objDocTmx = new DocTmx();
		
		$text = $data["t_document_text"];
		
		if ( ($html = $objDocTmx->xml2Table($text)) === FALSE ){
			return FALSE;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:revisionList
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function revisionList( $data ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DOCUMENT";
		
		$objDocTmx = new DocTmx();
		
		$xml = is_array($data) && isset($data["t_document_text"]) ? $data["t_document_text"] : $data;
		
		return $objDocTmx->getRevisionList($xml);
	}
	
	/***************************************************************
	 * 名前:editorHeader
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function editorHeader( $data, $buttons ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DOCUMENT";
		
		$html = "";
		
		if ( $data ){
			$hTitle  = Printer::icon("icon-file", NULL, $data["t_document_title"]);
			$hTitle  = Printer::ellipsis($hTitle, 20, FALSE);
			$sLang  = $data["t_document_lang_s"];
			$tLang  = $data["t_document_lang_t"];
		} else {
			$hTitle = "";
			$sLang = NULL;
			$tLang = NULL;
		}
		
		$hLang  = Printer::directLang($sLang, $tLang);
		$hTaskIcon = Printer::icon("icon-list-alt", NULL, "---");
		
		$htmlButtons = "";
		foreach ( $buttons as $btn ){
$htmlButtons .= <<< HTML
					<li>{$btn}</li>
HTML;
		}
		
$html = <<< HTML
		<nav class="navbar navbar-default">
			<div class="navbar-collapse navbar-ex1-collapse">
				<span id="editor-document" class="navbar-text">{$hTitle}{$hLang}</span>
				<span id="editor-task" class="navbar-text">{$hTaskIcon}</span>
				<ul class="nav navbar-nav navbar-right">
					{$htmlButtons}
				</ul>
			</div>
		</nav>
HTML;
		
		return $html;
		
	}
	
	/***************************************************************
	 * 名前:qredit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function qredit( $mode, $data ){
		global $URL;
		
		$html = "";
		
		$langS     = $data["t_document_lang_s"];
		$langT     = $data["t_document_lang_t"];
		$projectID = $data["t_project_id"];
		
		$arr = array(
			"mode"       => Document::QREDIT_MODE_COLLECTION_TABLE($mode),
			"url"        => $URL("/qreditrh_edudb/"),
			"type"       => "tmx",
			"slang"      => $langS,
			"tlang"      => $langT,
			"dlang"      => User::get("disp_lang"),
			"project_id" => $projectID,
		);
		// 比較モードの時は、モード切り替えボタンを非表示にする
		if ( $mode === Document::QREDIT_MODE_COMPARE ){
			$arr["modebutton"] = "false";
		}
		
		$arrDataAttr = array();
		foreach ( $arr as $key => $value ){
			$arrDataAttr[] = "data-{$key}=\"{$value}\"";
		}
		$hDataAttr = implode(" ", $arrDataAttr);
		
$html = <<< HTML
		<iframe id="qredit" frameborder="0" {$hDataAttr}></iframe>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:diff
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function diff( $arrData ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DOCUMENT";
		
		$html = "";
		
		$arrDiff = array();
		$arrDiffDoc = array();
		
		$objDocTmx = new DocTmx();
		
		foreach ( $arrData as $data ){
			$id    = $data["t_document_id"];
			$title = $data["t_document_title"];
			$text  = $data["t_document_text"];
			
			$objDocTmx->load($text);
			$arrSentence = $objDocTmx->getSentence();
			
			$count = 0;
			
			foreach ( $arrSentence as $sentence ){
				$count++;
				
				$textS = $sentence["source_text"];
				$textT = $sentence["target_text"];
				
				if ( strcmp(trim($textS), "") === 0 ){
					continue;
				}
				
				$hash = md5($textS) . "-" . $count;
				$arrDiff[$hash]["textS"] = $textS;
				$arrDiff[$hash]["textT"][$id] = array("title" => $title, "text" => $textT);
			}
			$arrDiffDoc[$id] = $title;
		}
		
		if ( count($arrDiffDoc) === 2 ){
		}
		
		$no = 1;
		foreach ( $arrDiff as $diff ){
			$hRowID = "row-{$no}";
			$hTextS = Util::esc($diff["textS"]);
			
$html .= <<< HTML
			<table id="{$hRowID}" class="table table-bordered table-condensed table_diff">
				<tr class="source">
					<th>{$WORD($wk, 41)}</th>
					<td>{$hTextS}</td>
				</tr>
HTML;
			
			foreach ( $diff["textT"] as $id => $doc ){
				$hID = Util::esc($id);
				$hTitle = Util::esc($doc["title"]);
				$hTextT = Util::esc($doc["text"]);
				
$html .= <<< HTML
				<tr class="target" data-doc-id="{$hID}">
					<th>{$hTitle}</th>
					<td>{$hTextT}</td>
				</tr>
HTML;
			}
$html .= <<< HTML
			</table>
HTML;
			
			$no++;
		}
		
		$html = $this->_alertDocumentSelect($arrDiffDoc) . $html;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: _alertDocumentSelect
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function _alertDocumentSelect( $arrDoc ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DOCUMENT";
		
		$html = "";
		if ( count($arrDoc) > 2 ){
			$message = "";
			$message .= Util::esc("{$WORD($wk, 42)}");
			$message .= "<br/>";
			$message .= UTil::esc("{$WORD($wk, 43)}");
			$message = "<p>{$message}</p>";
			$message .= Printer::link("{$WORD($wk, 44)}", "btn btn-warning btn-document-select");
			$message .= Printer::link("{$WORD($wk, 45)}", "btn btn-default btn-alert-close");
			
			$html = Printer::alert(false, $message, TRUE, array("id" => "alert_diff_document_select"), FALSE);
			$html .= $this->_dialogDocumentSelect($arrDoc);
		}
		foreach ( $arrDoc as $docID => $docTitle ){
			$html .= Printer::input("hidden", NULL, "q_doc_id[]", $docID);
		}
		
		return $html;
	}
	
	function _dialogDocumentSelect( $arrDoc ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DOCUMENT";
		
		$radio = Printer::checkboxButtons("q_diff_document[]", $arrDoc, NULL, "btn btn-default btn-active-danger");
$html = <<< HTML
		<div id="dialog_diff_document_select" class="dialog">
			{$radio}
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: _dialogFilterTitle
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _dialogFilterTitle( $keyword ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_DOCUMENT";
		
		$html = "";
		
		$arrControl = array();
		$arrControl[] = array(
			"id" => NULL,
			"name" => "{$WORD($wk, 46)}",
			"form" => Printer::input("text", "q_keyword", "q_keyword", $keyword, NULL, array("style"=>"width: 100%")),
		);
		$form = Printer::formControl($arrControl, FALSE, TRUE);
		
$html = <<< HTML
		<div id="dialog_document_filter_title" class="dialog">
			<form>
				<table class="table except-table-cell">
					{$form}
				</table>
			</form>
		</div>
HTML;
		
		return $html;
	}
	
}
