<?php require_once("class/View.php"); ?>
<?php
Class View_exterm extends View {
	const TAB_LIST        = 0;
	const TAB_NEW         = 2;
	
	const COMPLETE_REGISTER_NONE   = 0;
	const COMPLETE_REGISTER_NEW    = 1;
	const COMPLETE_REGISTER_SELECT = 2;
	static function COMPLETE_REGISTER_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_EXTERM";
		
		$arrTable = array(
			self::COMPLETE_REGISTER_NONE   => "{$WORD($wk, 1)}",
			self::COMPLETE_REGISTER_NEW    => "{$WORD($wk, 2)}",
			self::COMPLETE_REGISTER_SELECT => "{$WORD($wk, 3)}",
		);
		
		return is_null($key) ? $arrTable : $arrTable[$key];
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $tab, $auth, $projectID ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_EXTERM";
		
		$html = FALSE;
		$query = array(
			"q_project_id" => $projectID,
		);
		
		switch ( $tab ){
			//------------------------
			// 用語集一覧
			case self::TAB_LIST:
				if ( $auth->readList($projectID) ){
					$html = $this->tabLink("{$WORD($wk, 4)}", NULL, NULL, NULL, "/content/exterm/", $query);
				}
				break;
			//------------------------
			// 用語抽出登録
			case self::TAB_NEW:
				if ( $auth->write(INIT_ID, $projectID) ){
					$html = $this->tabLink("{$WORD($wk, 5)}", NULL, "icon-plus", NULL, "/content/exterm/edit.html", $query);
				}
				break;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: table
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function table( $projectID, $arrData, $arrProjectTermRoot ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_EXTERM";
		
		$auth = Auth::instance("exterm");
		
		$html = "";
		$htmlError = "";
		
		$organizationID = DAO::storedFunction("get_project_organization_id", $projectID);
		
		foreach ( $arrData as $data ){
			$id                   = $data["t_exterm_id"];
			$state                = $data["t_exterm_state"];
			$title                = $data["t_exterm_title"];
			$completeTermRootID   = $data["t_exterm_complete_term_root_id"];
			$completeTermRootName = $data["t_exterm_complete_term_root_name"];
			$register             = $data["t_exterm_register"];
			$update               = $data["t_exterm_update"];
			$userID               = $data["t_user_id"];
			$userName             = $data["t_user_name"];
			
			$arrDownloadParam = array(
				"q_id"         => $id,
				"q_project_id" => $projectID,
			);
			
			// タイトル
			$hTitle = Printer::ellipsis($title, 20);
			// 状態
			if ( $state === DAO::T_EXTERM_STATE_COMPLT && $auth->processDownload($id, $projectID) ){
				// ダウンロードボタン
				$hState = Printer::link("{$WORD($wk, 6)}", "btn btn-danger", "icon-save", NULL, "./export.html?".http_build_query($arrDownloadParam));
			} else {
				$hState = DAO::T_EXTERM_STATE_TABLE($state);
			}
			// 抽出後用語登録
			$hTermRootName = "";
			if ( Validate::isString($completeTermRootName) ){
				$hTermRootName = self::formTerm(FALSE, "", $arrProjectTermRoot, array($completeTermRootID => $completeTermRootName));
			}
			// 登録者
			$hUser = Util::esc($userName);
			// 更新日
			$hUpdate = Util::esc($update);
			// 操作
			$arrButton = array();
			if ( $state === DAO::T_EXTERM_STATE_COMPLT && $auth->processDownload($id, $projectID) ){
				// ダウンロード
				$arrButton[] = Printer::link("{$WORD($wk, 7)}", NULL, "icon-save", NULL, "./export.html?".http_build_query($arrDownloadParam));
			}
			if ( $state !== DAO::T_EXTERM_STATE_WAITNG && $auth->remove($id, $projectID) ){
				// 削除
				$arrButton[] = Printer::link("{$WORD($wk, 8)}", NULL, "icon-remove", NULL, NULL, "minhon.common.onClickPost('./delete.html', {q_id:{$id}}, '{$WORD($wk, 9)}');");
			}
			// 操作
			$hOperation = Printer::buttonGroup("{$WORD($wk, 10)}", $arrButton);
			
$hRow = <<< HTML
			<tr>
				<td>{$hTitle}</td>
				<td>{$hState}</td>
				<td>{$hTermRootName}</td>
				<td>{$hUser}</td>
				<td class="col-tight">{$hUpdate}</td>
				<td class="col-tight">{$hOperation}</td>
			</tr>
HTML;
			$html .= $hRow;
		}
		
$html = <<< HTML
		<table class="table table-striped">
			<thead>
				<tr>
					<th>{$WORD($wk, 11)}</th>
					<th>{$WORD($wk, 12)}</th>
					<th>{$WORD($wk, 13)}</th>
					<th>{$WORD($wk, 14)}</th>
					<th class="col-tight">{$WORD($wk, 15)}</th>
					<th class="col-tight">{$WORD($wk, 16)}</th>
				</tr>
			</thead>
			<tbody>
				{$html}
			</tbody>
			{$htmlError}
		</table>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: formTarget
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formTarget( $arrDocument, $selectedDocument = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_EXTERM";
		
		$html = "";
		
		//------------------------
		// 文書
		//------------------------
		// 各文書
		$arrDocumentButton = array();
		$isChecked = FALSE;
		foreach ( $arrDocument as $id => $title ){
			if ( is_array($title) ){
				$data = $title;
				$id    = $data["t_document_id"];
				$title = $data["t_document_title"];
			}
			
			// title
			if ( Validate::isNumeric($id) && $id > 0 ){
				$hTitle = Printer::icon("icon-file", NULL, $title);
			} else {
				$hTitle = Util::esc($title);
			}
			$hTitle = Printer::ellipsis($hTitle, 20, FALSE);
			
			// option
			$arrOption = array(
				"type" => "checkbox",
				"name" => "q_target_document_id[]",
				"value" => Util::esc($id),
			);
			if ( count($selectedDocument) == 0 ){
				$arrOption["checked"] = "checked";
			} else {
				if (in_array($id , $selectedDocument)){
					$arrOption["checked"] = "checked";
					$isChecked = TRUE;
				}
			}
			
			$hOption = Printer::option($arrOption);
			
$hButton = <<< HTML
			<label class="btn btn-default btn-active-danger">
				<input {$hOption} />{$hTitle}
			</label>
HTML;
			$arrDocumentButton[$id] = $hButton;
		}
		
		if ( count($arrDocumentButton) > 0 ){
			$hDocButton = implode("\n", $arrDocumentButton);
			
			// すべての文書
			$arrOption = array(
				"type" => "checkbox",
				"name" => "q_target_all_document",
				"value" => ON,
			);
			if ( ! $isChecked ){
				$arrOption["checked"] = "checked";
			}
			$hTitle = Util::esc("{$WORD($wk, 17)}");
			$hOption = Printer::option($arrOption);
		
$html .= <<< HTML
			<label id="label_all_document" class="checkbox">
				<input {$hOption}/> {$hTitle}
			</label>
			<div data-toggle="buttons" class="btn-line-group">
				{$hDocButton}
			</div>
HTML;
		} else {
			$html .= Printer::alert(TRUE, "{$WORD($wk, 18)}");
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: formCompleteRegisterTermRoot
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formCompleteRegisterTermRoot($isRegister, $arrTermRoot, $selectTermRootID = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_EXTERM";
		
		$html = "";
		
		$select = NULL;
		if ( $isRegister ){
			if ( Validate::isNumeric($selectTermRootID) && $selectTermRootID > 0 ){
				$select = self::COMPLETE_REGISTER_SELECT;
			} else {
				$select = self::COMPLETE_REGISTER_NEW;
			}
		} else {
			$selectTermRootID = NULL;
			$select = self::COMPLETE_REGISTER_NONE;
		}
		
		// 既存用語集一覧
		$arrTermRootButton = array();
		foreach ( $arrTermRoot as $id => $name ){
			if ( is_array($name) ){
				$data = $name;
				$id   = $data["t_term_root_id"];
				$name = $data["t_term_root_name"];
			}
			
			// name
			if ( Validate::isNumeric($id) && $id > 0 ){
				$hName = Printer::icon("icon-book", NULL, $name);
			} else {
				$hName = Util::esc($name);
			}
			$hName = Printer::ellipsis($hName, 20, FALSE);
			
			// option
			$arrOption = array(
				"type" => "radio",
				"name" => "q_register_term_root_id",
				"value" => Util::esc($id),
			);
			if ( $id === $selectTermRootID ){
				$arrOption["checked"] = "checked";
			}
			$hOption = Printer::option($arrOption);
			
$arrTermRootButton[] = <<< HTML
			<label class="btn btn-default btn-active-danger">
				<input {$hOption} />{$hName}
			</label>
HTML;
		}
		
		if ( count($arrTermRootButton) > 0 ){
			$hTermRootButton = implode("\n", $arrTermRootButton);
$hTermRoot = <<< HTML
			<div data-toggle="buttons" class="btn-line-group">{$hTermRootButton}</div>
HTML;
		} else {
			$hTermRoot = Printer::alert(TRUE, "{$WORD($wk, 19)}");
		}
		
		// 用語集登録なし -------------
		$radioValue = array(self::COMPLETE_REGISTER_NONE => self::COMPLETE_REGISTER_TABLE(self::COMPLETE_REGISTER_NONE));
		$hRadio = Printer::radio(NULL, "q_complete_register", $radioValue, $select, NULL, FALSE);
		$html .= $hRadio;
		
		// 新規登録 -------------------
		$radioValue = array(self::COMPLETE_REGISTER_NEW => self::COMPLETE_REGISTER_TABLE(self::COMPLETE_REGISTER_NEW));
		$hRadio = Printer::radio(NULL, "q_complete_register", $radioValue, $select, NULL, FALSE);
		$html .= $hRadio;
		
		// 既存登録 -------------------
		$radioValue = array(self::COMPLETE_REGISTER_SELECT => Util::esc(self::COMPLETE_REGISTER_TABLE(self::COMPLETE_REGISTER_SELECT))."<span class=\"form-required\">*</span>");
		$hRadio = Printer::radio(NULL, "q_complete_register", $radioValue, $select, NULL, FALSE, FALSE);
		if ( count($arrTermRootButton) > 0 ){
			$html .= $hRadio;
		} else {
			$html .= "<fieldset disabled>{$hRadio}</fieldset>";
		}
		
$html .= <<< HTML
		<div id="div_complete_register_term_root">
			{$hTermRoot}
		</div>
HTML;
		
		return $html;
	}
	
}
