<?php require_once("class/View.php"); ?>
<?php
Class View_home extends View {
	/***************************************************************
	 * 名前: userList
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function userList( $arrData, $orgID ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_HOME";
		
		$html = "";
		
		foreach ( $arrData as $data ){
			$userID           = $data["t_user_id"];
			$userName         = $data["t_user_name"];
			$userType         = $data["t_user_type"];
			$organizationID   = $data["t_organization_id"];
			$organizationName = $data["t_organization_name"];
			$lastLoginDate    = $data["t_last_login_date"];
			
			$diff = floor((time() - strtotime($lastLoginDate)) / (60*60*24));
			
			$hUserName = Util::esc($userName);
			$hUserType = DAO::T_USER_TYPE_TABLE($userType);
			$hOrgName  = Util::esc($organizationName);
			$hLastLogin = Util::esc("{$WORD($wk, 1, $diff)}") . "<span style=\"margin-left: 5px; font-size: 90%\">(".Util::esc($lastLoginDate).")</span>";
			$hButton = Printer::link("{$WORD($wk, 2)}", "btn btn-danger", NULL, NULL, NULL, "minhon.home.onClickHidden(this)", array("data-user-id"=>$userID));
				
$html .= <<< HTML
			<tr>
				<td>{$hUserName}</td>
				<td>{$hUserType}</td>
				<td>{$hLastLogin}</td>
				<td>{$hButton}</td>
			</tr>
HTML;
		}
		
		$hToken = Printer::input("hidden", "q_token", "q_token", Util::token());
		$btnAll = Printer::link("{$WORD($wk, 3)}", "btn btn-danger", NULL, NULL, NULL, "minhon.home.onClickHidden($(\"#table_home_user a\").get())");
		
		$hLoginLink = Printer::link(">> "."{$WORD($wk, 4)}", NULL, NULL, NULL, "/content/user/?q_org_id=".$orgID);
		
$html = <<< HTML
		<div class="panel panel-default">
			<div class="panel-heading clearfix">{$WORD($wk, 5)}<span class="pull-right">{$btnAll}</span></div>
			<div class="panel-body">
				<table id="table_home_user" class="table">
					<thead>
						<th>{$WORD($wk, 6)}</th>
						<th>{$WORD($wk, 7)}</th>
						<th>{$WORD($wk, 8)}</th>
						<th>{$WORD($wk, 9)}</th>
					</thead>
					<tbody>
						{$html}
					</tbody>
				</table>
				{$hToken}
				<p style="text-align:right; margin: 0">{$WORD($wk, 10)} {$hLoginLink}</p>
			</div>
		</div>
HTML;
		return $html;
		
	}
	
	/***************************************************************
	 * 名前: taskList
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function taskList( $arrData, $order, $prefixMessage = "", $suffixMessage = "" ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_HOME";
		
		$viewTask = View::instance("task");
		
		$html = "";
		if ( count($arrData) > 0 ){
			//メッセージ
			if ( strlen($prefixMessage) > 0 ){
				$prefixMessage = Printer::alert( FALSE, $prefixMessage, TRUE );
			}
			if ( strlen($suffixMessage) > 0 ){
				$suffixMessage = Printer::alert( FALSE, $suffixMessage);
			}
			
			$arrInsDocument = array();
			
			foreach ( $arrData as $data ){
				$id          = $data["t_task_id"];
				$state       = $data["t_task_state"];
				$type        = $data["t_task_type"];
				$xml         = $data["t_task_data"];
				$start       = $data["t_task_start"];
				$end         = $data["t_task_end"];
				$workflowID  = $data["t_workflow_id"];
				$projectID   = $data["t_project_id"];
				$projectName = $data["t_project_name"];
				
				// タイプ
				$hType = Printer::link(Task::TYPE_TABLE($type), NULL, "icon-ok", NULL, "/content/task/index.html?q_project_id={$projectID}&q_workflow_id={$workflowID}&q_id={$id}");
				// 文書
				$hDocument = "";
				$arrDocument = Task::getTaskDocument($id);
				foreach ( $arrDocument as $documentID => $documentTitle ){
					$documentTitle = Printer::ellipsis($documentTitle, 10);
					$hDocument .= Printer::icon("icon-file").$documentTitle." ";
					//$hDocument .= Printer::link($documentTitle, NULL, "icon-file", NULL, "/content/document/detail.html?q_project_id={$projectID}&q_id={$documentID}", NULL, NULL, FALSE);
					if ( ! isset($arrInsDocument[$documentID]) ){
						$arrInsDocument[$documentID] = new Document($documentID);
					}
				}
				if ( strlen($hDocument) === 0 ){
					$hDocument = " - ";
				}
				// プロジェクト
				$hProject = Printer::ellipsis($projectName, 15);
				$hProject = Printer::link($hProject, NULL, "icon-th", NULL, "/content/project/detail.html?q_project_id={$projectID}", NULL, NULL, FALSE);
				// 期間
				$hDate = Task::getHtmlDateSpan($id, $start, $end, User::get("id"), $arrDocument);
				// 状態
				$hState = Task::getHtmlState($id, $state);
				
$html .= <<< HTML
				<tr>
					<td>{$hType}</td>
					<td>{$hDocument}</td>
					<td>{$hProject}</td>
					<td>{$hDate}</td>
					<td>{$hState}</td>
				</tr>
HTML;
			}
			
			$hHeaderType     = Printer::tableOrder("{$WORD($wk, 11)}", "task", $order);
			$hHeaderDocument = Printer::tableOrder("{$WORD($wk, 12)}", NULL, $order);
			$hHeaderProject  = Printer::tableOrder("{$WORD($wk, 13)}", "project", $order);
			$hHeaderDate     = Printer::tableOrder("{$WORD($wk, 14)}", "date", $order);
			$hHeaderState    = Printer::tableOrder("{$WORD($wk, 15)}", "state", $order);
			
$html = <<< HTML
			{$prefixMessage}
			<table id="table_home_task" class="table">
				<thead>
					{$hHeaderType}
					{$hHeaderDocument}
					{$hHeaderProject}
					{$hHeaderDate}
					{$hHeaderState}
				</thead>
				<tbody>
					{$html}
				</tbody>
			</table>
			{$suffixMessage}
HTML;
		
		} else {
			$html = Printer::alert( FALSE, "{$WORD($wk, 16)}" );
		}
		
$html = <<< HTML
		<div class="panel panel-default">
			<div class="panel-heading clearfix">{$WORD($wk, 17)}</div>
			<div class="panel-body">
				{$html}
			</div>
		</div>
HTML;
		return $html;
	}
	
	/***************************************************************
	 * 名前: actionList
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function actionList( $arrData, $order, $prefixMessage = "", $suffixMessage = ""  ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_HOME";
		
		$html = "";
		if ( count($arrData) > 0 ){
			//メッセージ
			if ( strlen($prefixMessage) > 0 ){
				$prefixMessage = Printer::alert( FALSE, $prefixMessage, TRUE );
			}
			if ( strlen($suffixMessage) > 0 ){
				$suffixMessage = Printer::alert( FALSE, $suffixMessage);
			}
			
			foreach ( $arrData as $data ){
				$id          = $data["t_task_id"];
				$type        = $data["t_task_type"];
				$date        = $data["t_log_task_date"];
				$state       = $data["t_log_task_state"];
				$userID      = $data["t_user_id"];
				$userType    = DAO::storedFunction("get_user_type", $userID);
				$userName    = DAO::storedFunction("get_user_name", $userID);
				$projectID   = $data["t_project_id"];
				$projectName = DAO::storedFunction("get_project_name", $projectID);
				$workflowID  = DAO::storedFunction("get_workflow_id_by_project_id", $projectID);
				
				// ユーザー
				$hUser = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
				// アクション日時
				$hActionDate = Util::esc($date);
				// アクション
				$act = Task::getHtmlState($id, $state);
				$hAction = "{$WORD($wk, 18, $act)}";
				// タイプ
				$hType = Printer::link(Task::TYPE_TABLE($type), NULL, "icon-ok", NULL, "/content/task/index.html?q_project_id={$projectID}&q_workflow_id={$workflowID}&q_id={$id}");
				// プロジェクト
				$hProject = Printer::ellipsis($projectName, 15);
				$hProject = Printer::link($hProject, NULL, "icon-th", NULL, "/content/project/detail.html?q_project_id={$projectID}", NULL, NULL, FALSE);
				// 期間
				$hDate = Task::getHtmlDateSpan($id);
				
$html .= <<< HTML
				<tr>
					<td>{$hUser}</td>
					<td>{$hActionDate}</td>
					<td>{$hAction}</td>
					<td>{$hType}</td>
					<td>{$hProject}</td>
					<td>{$hDate}</td>
				</tr>
HTML;
			}
			
			$hHeaderUser       = Util::esc("{$WORD($wk, 19)}");
			$hHeaderActionDate = Util::esc("{$WORD($wk, 20)}");
			$hHeaderAction     = Util::esc("{$WORD($wk, 21)}");
			$hHeaderType       = Util::esc("{$WORD($wk, 22)}");
			$hHeaderProject    = Util::esc("{$WORD($wk, 23)}");
			$hHeaderDate       = Util::esc("{$WORD($wk, 24)}");
			
$html = <<< HTML
			{$prefixMessage}
			<table id="table_home_task" class="table">
				<thead>
					<th>{$hHeaderUser}</th>
					<th>{$hHeaderActionDate}</th>
					<th>{$hHeaderAction}</th>
					<th>{$hHeaderType}</th>
					<th>{$hHeaderProject}</th>
					<th>{$hHeaderDate}</th>
				</thead>
				<tbody>
					{$html}
				</tbody>
			</table>
			{$suffixMessage}
HTML;
		} else {
			$html = Printer::alert( FALSE, "{$WORD($wk, 25)}" );
		}
		
$html = <<< HTML
		<div class="panel panel-default">
			<div class="panel-heading clearfix">{$WORD($wk, 26)}</div>
			<div class="panel-body">
				{$html}
			</div>
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: bbsPostList
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function bbsPostList( $arrData ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_HOME";
		
		$html = "";
		
		if ( count($arrData) > 0 ){
			foreach ( $arrData as $data ){
				$no          = $data["t_bbs_post_no"];
				$title       = $data["t_bbs_post_title"];
				$register    = $data["t_bbs_post_register"];
				$arrTarget   = $data["t_bbs_post_target"];
				$userID      = $data["t_user_id"];
				$userType    = $data["t_user_type"];
				$userName    = $data["t_user_name"];
				$projectID   = $data["t_project_id"];
				$projectName = $data["t_project_name"];
				$bbsID       = $data["t_bbs_id"];
				
				// 件名
				$hTitle = Printer::link($title, NULL, "icon-comment", NULL, "/content/bbs/detail.html?q_project_id={$projectID}&q_id={$bbsID}#bbs-post-row-{$no}");
				// 差出人
				$hUser  = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
				// 宛先
				$hTarget = "";
				if ( count($arrTarget) > 0 ){
					foreach ( $arrTarget as $userID => $target ){
						if ( $userID == 0 ){
							$hTarget  .= Printer::icon("icon-user", NULL, "{$WORD($wk, 27)}");
							continue;
						}
						$userType = $target["type"];
						$userName = $target["name"];
						
						$hTarget .= " ";
						$hTarget .= Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
						
						foreach ( $target["role"] as $role ){
							if ( ($roleText = Task::ROLE_TABLE($role)) !== FALSE ){
								$hTarget .= Printer::label("label-default", $roleText);
							}
						}
					}
				}
				// プロジェクト
				$hProject = Printer::ellipsis($projectName, 15);
				$hProject = Printer::link($hProject, NULL, "icon-th", NULL, "/content/project/detail.html?q_project_id={$projectID}", NULL, NULL, FALSE);
				// 時刻
				$hDate = Printer::icon("icon-time", NULL, $register);
				
$html .= <<< HTML
				<tr>
					<td>{$hTitle}</td>
					<td>{$hUser}</td>
					<td>{$hTarget}</td>
					<td>{$hProject}</td>
					<td>{$hDate}</td>
				</tr>
HTML;
			}
			
$html = <<< HTML
			<table id="table_home_bbs_post" class="table">
				<thead>
					<th>{$WORD($wk, 28)}</th>
					<th>{$WORD($wk, 29)}</th>
					<th>{$WORD($wk, 30)}</th>
					<th>{$WORD($wk, 31)}</th>
					<th>{$WORD($wk, 32)}</th>
				</thead>
				<tbody>
					{$html}
				</tbody>
			</table>
HTML;
		
		} else {
			$html = Printer::alert( FALSE, "{$WORD($wk, 33)}" );
		}
		
$html = <<< HTML
		<div class="panel panel-default">
			<div class="panel-heading clearfix">{$WORD($wk, 34)}</div>
			<div class="panel-body">
				{$html}
			</div>
		</div>
HTML;
		
		return $html;
	}
	
}
