<?php require_once("class/View.php"); ?>
<?php
Class View_organization extends View {
	const TAB_LIST   = 0;
	const TAB_NEW    = 1;
	const TAB_EDIT   = 2;
	const TAB_DETAIL = 3;
	const TAB_DETAIL_EDIT = 4;
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $tab, $auth, $id = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_ORGANIZATION";
		
		$html = FALSE;
		$query = array();
		
		switch ( $tab ){
			//------------------------
			// 組織一覧
			case self::TAB_LIST:
				if ( $auth->readList() ){
					$html = $this->tabLink("{$WORD($wk, 1)}", NULL, NULL, NULL, "/content/organization/", $query);
				}
				break;
			//------------------------
			// 組織新規登録
			case self::TAB_NEW:
				if ( $auth->write(INIT_ID) ){
					$html = $this->tabLink("{$WORD($wk, 2)}", NULL, "icon-plus", NULL, "/content/organization/edit.html", $query);
				}
				break;
			//------------------------
			// 組織編集
			case self::TAB_EDIT:
				if ( $auth->write($id) || $auth->write_isInfo($id) ){
					$query["q_id"] = $id;
					$html = $this->tabLink("{$WORD($wk, 3)}", NULL, "icon-pencil", NULL, "/content/organization/edit.html", $query);
				}
				break;
			//------------------------
			// 組織情報
			case self::TAB_DETAIL:
				if ( $auth->read($id) ){
					$query["q_id"] = $id;
					$html = $this->tabLink("{$WORD($wk, 4)}", NULL, NULL, NULL, "/content/organization/detail.html", $query);
				}
				break;
			//------------------------
			// | 組織情報 |▼|
			// | 編集        |
			case self::TAB_DETAIL_EDIT:
				if ( ($detail = $this->tab(self::TAB_DETAIL, $auth, $id)) !== FALSE ){
					if ( ($edit = $this->tab(self::TAB_EDIT, $auth, $id)) !== FALSE ){
						$html = array(
							"title" => "{$WORD($wk, 5)}",
							"item"  => array(
								$edit,
							),
						);
					} else {
						// 編集許可がない場合
						$html = $detail;
					}
				}
				break;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function table( $arrData, $searchValue, $query ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_ORGANIZATION";
		
		$auth = Auth::instance("organization");
		
		$html = "";
		$operationValid = FALSE;
		
		foreach ( $arrData as $data ){
			$id              = $data["t_organization_id"];
			$name            = $data["t_organization_name"];
			$register        = $data["t_organization_register"];
			$userOrgMgr      = $data["t_user_of_orgmgr"];
			$userInsttr      = $data["t_user_of_insttr"];
			$userNormal      = $data["t_user_of_normal"];
			$projectComplete = $data["t_project_of_complete"];
			$projectNormal   = $data["t_project_of_normal"];
			
			// 名前
			if ( $auth->read($id) ){
				$hName = Printer::link($name, NULL, "icon-star", NULL, "/content/organization/detail.html?q_id={$id}");
			} else {
				$hName = Printer::icon("icon-star", NULL, $name);
			}
			// 組織管理者
			if ( count($userOrgMgr) > 0 ){
				$hMgrName = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE(DAO::T_USER_TYPE_ORGMGR), $userOrgMgr[0]);
			} else {
				$hMgrName = "";
			}
			// 登録日時
			if ( Validate::isDateTime($register) ){
				$hRegister = Printer::icon("icon-time", NULL, $register);
			} else {
				$hRegister = " - ";
			}
			
			// ユーザー数
			$hUserCount = array(
				Printer::link(count($userOrgMgr)+count($userInsttr)+count($userNormal), NULL, "icon-user", NULL, "/content/user/?q_org_id={$id}"),
				Printer::link(count($userOrgMgr),                                       NULL, NULL,        NULL, "/content/user/?q_org_id={$id}&q_type=".DAO::T_USER_TYPE_ORGMGR),
				Printer::link(count($userInsttr),                                       NULL, NULL,        NULL, "/content/user/?q_org_id={$id}&q_type=".DAO::T_USER_TYPE_INSTTR),
				Printer::link(count($userNormal),                                       NULL, NULL,        NULL, "/content/user/?q_org_id={$id}&q_type=".DAO::T_USER_TYPE_NORMAL),
			);
			$hUserCount1 = $hUserCount[0];
			$hUserCount2 = " ( {$hUserCount[1]} / {$hUserCount[2]} / {$hUserCount[3]} ) ";
			
			// プロジェクト数
			$hProjectCount = array(
				Printer::link(count($projectComplete)+count($projectNormal), NULL, "icon-th", NULL, "/content/project/?q_org_id={$id}"),
				Printer::link(count($projectNormal),                         NULL, NULL,      NULL, "/content/project/?q_org_id={$id}&q_state=".DAO::T_PROJECT_STATE_NORMAL),
				Printer::link(count($projectComplete),                       NULL, NULL,      NULL, "/content/project/?q_org_id={$id}&q_state=".DAO::T_PROJECT_STATE_COMPLETE),
			);
			$hProjectCount1 = $hProjectCount[0];
			$hProjectCount2 = " ( {$hProjectCount[1]} / {$hProjectCount[2]} ) ";
			
			// 操作
			$hOperation = "";
			if ( $auth->write($id) ){
				$operationValid = TRUE;
				$arrButton = array(
					Printer::link("{$WORD($wk, 6)}", NULL, NULL, NULL, "/content/organization/edit.html?q_id={$id}"),
				);
				// 操作
				$hOperation = Printer::buttonGroup("{$WORD($wk, 7)}", $arrButton);
			}
			
$html .= <<< HTML
			<tr>
				<td>{$hName}</td>
				<td>{$hMgrName}</td>
				<td class="col-tight">{$hRegister}</td>
				<td class="col-tight col-join hidden-xs large-font" style="text-align: right">{$hUserCount1}</td>
				<td class="col-tight hidden-xs">{$hUserCount2}</td>
				<td class="col-tight visible-xs">{$hUserCount1}{$hUserCount2}</td>
				<td class="col-tight col-join hidden-xs large-font" style="text-align: right">{$hProjectCount1}</td>
				<td class="col-tight hidden-xs">{$hProjectCount2}</td>
				<td class="col-tight visible-xs">{$hProjectCount1}{$hProjectCount2}</td>
				<td>{$hOperation}</td>
			</tr>
HTML;
		}
		
		// 名前
		$hHeaderName = $this->tableHeader("{$WORD($wk, 8)}", "icon-search", NULL, array(
			Printer::link("{$WORD($wk, 9)}", NULL, "icon-search", NULL, NULL, "minhon.organization.onClickFilterName();"),
			Validate::isString($searchValue) ? Printer::link("{$WORD($wk, 10)}", NULL, "icon-none", NULL, NULL, "minhon.organization.onClickFilterNameClear();") : NULL,
		), $query, "q_keyword", DAO_organization::ORDER_KEY_NAME);
		// 登録日時
		$hHeaderRegister = $this->tableHeader("{$WORD($wk, 11)}", NULL, NULL, NULL, $query, NULL, DAO_organization::ORDER_KEY_REGISTER);
		
		$hHeaderOperation = "";
		if ( $operationValid ){
			$hHeaderOperation = "{$WORD($wk, 12)}";
		}
		
$html = <<< HTML
		<table class="table table-grid">
			<thead>
				<th>{$hHeaderName}</th>
				<th>{$WORD($wk, 13)}</th>
				<th class="col-tight">{$hHeaderRegister}</th>
				<th class="col-tight col-join">{$WORD($wk, 14)}</th>
				<th class="col-tight hidden-xs">({$WORD($wk, 15)} / {$WORD($wk, 16)} / {$WORD($wk, 17)})</th>
				<th class="col-tight col-join">{$WORD($wk, 18)}</th>
				<th class="col-tight hidden-xs">({$WORD($wk, 19)} / {$WORD($wk, 20)})</th>
				<th>{$hHeaderOperation}</th>
			</thead>
			<tbody>
				{$html}
			</tbody>
		</table>
HTML;
		
		$html .= $this->_dialogFilterName( $searchValue );
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: detail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function detail( $data ){
		global $WORD;
		global $G_LANG_TABLE;
		$wk = "WORD_P_CLASS_VIEW_ORGANIZATION";
		
		// システム管理者は全組織のAPI情報が参照可能
		// 上記以外の権限者は自組織のみAPI情報が参照可能
		$APIFlag = Auth::isSysmgr();
		if ( !$APIFlag ){
			$organizationId = User::get("organization_id");
			if ($organizationId === $data["t_organization_id"]){
				$APIFlag = TRUE;
			}
		}
		
		$html = "";

		// 名前
		$name = $data["t_organization_name"];
		$hName = Util::esc($name);
		// APIName
		$API_name = $data["t_mtauto_name"];
		$hAPIName = Util::esc($API_name);
		// APIKey
		$API_key = $data["t_mtauto_key"];
		$hAPIKey = Util::esc($API_key);
		// APISecret
		$API_secret = $data["t_mtauto_secret"];
		$hAPISecret = Util::esc($API_secret);
		$hAPISecret = str_repeat('*', strlen($hAPISecret));			// APISecretマスク化
		// 説明
		$text = $data["t_organization_text"];
		$hText = Util::esc($text);
		
		$arrControl  = array();
		// 名前
		$arrControl[] = array(
			"id"   => "q_name",
			"name" => "{$WORD($wk, 21)}",
			"form" => array(
				Printer::formText("{$hName}", FALSE),
			),
		);
		if ($APIFlag){
			// APIName
			$arrControl[] = array(
				"id"   => "q_api_name",
				"name" => "{$WORD($wk, 22)}",
				"form" => array(
					Printer::formText("{$hAPIName}", FALSE),
				),
			);
			// APIKey
			$arrControl[] = array(
				"id"   => "q_api_key",
				"name" => "{$WORD($wk, 23)}",
				"form" => array(
					Printer::formText("{$hAPIKey}", FALSE),
				),
			);
			// APISecret
			$arrControl[] = array(
				"id"   => "q_api_secret",
				"name" => "{$WORD($wk, 24)}",
				"form" => array(
					Printer::formText("{$hAPISecret}", FALSE),
				),
			);
		}
		// 説明
		$arrControl[] = array(
			"id"   => "q_text",
			"name" => "{$WORD($wk, 25)}",
			"form" => array(
				Printer::formText(nl2br($hText), FALSE),
			),
		);
		
		$html = Printer::form("form_project", "form_project", "./", "post", $arrControl);
		return $html;
	}
	
	/***************************************************************
	 * 名前: _dialogFilterName
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _dialogFilterName( $keyword ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_ORGANIZATION";
		
		$html = "";
		
		$arrControl = array();
		$arrControl[] = array(
			"id" => NULL,
			"name" => "{$WORD($wk, 26)}",
			"form" => Printer::input("text", "q_keyword", "q_keyword", $keyword, NULL, array("style"=>"width: 100%")),
		);
		$form = Printer::formControl($arrControl, FALSE, TRUE);
		
$html = <<< HTML
		<div id="dialog_organization_filter_name" class="dialog">
			<form>
				<table class="table except-table-cell">
					{$form}
				</table>
			</form>
		</div>
HTML;
		
		return $html;
	}
	
}
