<?php require_once("class/View.php"); ?>
<?php
Class View_project extends View {
	const TAB_LIST      = 0;
	const TAB_NEW       = 1;
	const TAB_EDIT      = 2;
	const TAB_DETAIL    = 3;
	const TAB_STRUCTURE = 4;
	const TAB_IMPORT    = 5;
	const TAB_EXPORT    = 6;
	const TAB_DETAIL_EDIT = 7;

	const LIST_VIEW_MEMBER = 0;
	const LIST_VIEW_CREATE = 1;
	const LIST_VIEW_ORG    = 2;
	const LIST_VIEW_ALL    = 3;
	public static function LIST_VIEW_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		$arr = array(
			self::LIST_VIEW_MEMBER => "{$WORD($wk, 1)}",
			self::LIST_VIEW_CREATE => "{$WORD($wk, 2)}",
			self::LIST_VIEW_ORG    => "{$WORD($wk, 3)}",
			self::LIST_VIEW_ALL    => "{$WORD($wk, 4)}",
		);
		
		if ( is_null($key) ){
			return $arr;
		} else {
			return $arr[$key];
		}
	}
	public static function LIST_VIEW_SHORT_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		$arr = array(
			self::LIST_VIEW_MEMBER => "{$WORD($wk, 5)}",
			self::LIST_VIEW_CREATE => "{$WORD($wk, 6)}",
			self::LIST_VIEW_ORG    => "{$WORD($wk, 7)}",
			self::LIST_VIEW_ALL    => "{$WORD($wk, 8)}",
		);
		
		if ( is_null($key) ){
			return $arr;
		} else {
			return $arr[$key];
		}
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $tab, $auth, $id = 0, $tabMode = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		$html = FALSE;
		$query = array();
		
		switch ( $tab ){
			//------------------------
			// 参加プロジェクト一覧
			case self::TAB_LIST:
				if ( $auth->readList() ){
					$html = $this->tab_list( $auth );
				}
				break;
			//------------------------
			// プロジェクト新規登録
			case self::TAB_NEW:
				if ( $auth->write(INIT_ID) ){
					$html = $this->tabLink("{$WORD($wk, 9)}", NULL, "icon-plus", NULL, "./edit.html", $query);
				}
				break;
			//------------------------
			// プロジェクト編集
			case self::TAB_EDIT:
				if ( $auth->write($id) ){
					$query["q_id"] = $id;
					$html = $this->tabLink("{$WORD($wk, 10)}", NULL, "icon-pencil", NULL, "./edit.html", $query);
				}
				break;
			//------------------------
			// プロジェクト概要
			case self::TAB_DETAIL:
				if ( $auth->read($id) ){
					$query["q_project_id"] = $id;
					$html = $this->tabLink("{$WORD($wk, 11)}", NULL, NULL, NULL, "./detail.html", $query);
				}
				break;
			//------------------------
			// プロジェクト詳細
			case self::TAB_STRUCTURE:
				if ( $auth->read($id) ){
					$query["q_project_id"] = $id;
					$html = $this->tabLink("{$WORD($wk, 12)}", NULL, NULL, NULL, "./structure.html", $query);
				}
				break;
			//------------------------
			// プロジェクトインポート
			case self::TAB_IMPORT:
				if ( $auth->processImport($id) ){
					$query["q_project_id"] = $id;
					$html = $this->tabLink("{$WORD($wk, 13)}", NULL, "icon-open", NULL, "./import.html", $query);
				}
				break;
			//------------------------
			// プロジェクトエクスポート
			case self::TAB_EXPORT:
				if ( $auth->processExport($id) ){
					$exportQuery = array(
						"q_mode" => APP_PROJECT_CONTROLLER_MODE_EXPORT,
						"q_id"   => $id,
					);
					$html = $this->tabLink("{$WORD($wk, 14)}", NULL, "icon-save", NULL, "/app/projectController.php", $exportQuery);
				}
				break;
			//------------------------
			// | 概要 |▼|
			// | 編集    |
			case self::TAB_DETAIL_EDIT:
				if ( ($detail = $this->tab(self::TAB_DETAIL, $auth, $id)) !== FALSE ){
					if ( ($edit = $this->tab(self::TAB_EDIT, $auth, $id)) !== FALSE ){
						$html = array(
							"title" => "{$WORD($wk, 15)}",
							"item"  => array(
								$edit,
							),
						);
					} else {
						// 編集許可がない場合
						$html = $detail;
					}
				}
				break;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab_list( $auth, $selectListView = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		$html = FALSE;

		$arrListView = self::LIST_VIEW_TABLE();
		if ( ! $auth->readList() ){
			unset($arrListView[self::LIST_VIEW_MEMBER]);
		}
		if ( ! $auth->readList_isCreate() ){
			unset($arrListView[self::LIST_VIEW_CREATE]);
		}
		if ( ! $auth->readList_isOrg() ){
			unset($arrListView[self::LIST_VIEW_ORG]);
		}
		if ( ! $auth->readList_isAll() ){
			unset($arrListView[self::LIST_VIEW_ALL]);
		}
		
		if ( ! Validate::inKeyArray($selectListView, $arrListView) && $selectListView !== NULL ){
			return $html;
		}
		
		$arrPullDown = array();
		foreach ( $arrListView as $key => $text ){
			$query = array();
			if ( $key !== self::LIST_VIEW_MEMBER ){
				$query["q_view"] = $key;
			}
			$arrPullDown[$key] = $this->tabLink($text, NULL, NULL, NULL, "./", $query);
		}

		$title = "{$WORD($wk, 16)}";
		if ( Validate::inKeyArray($selectListView, $arrListView) ){
			$title .= " - ".self::LIST_VIEW_SHORT_TABLE($selectListView);
		}
		
		$html = array(
			"title" => $title,
			"item"  => $arrPullDown,
		);
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: table
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function table( $arrData, $searchValue = NULL, $query = NULL, $viewOrg = FALSE ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		$auth = Auth::instance("project");
		
		$html = "";
		
		foreach ( $arrData as $data ){
			$id       = $data["t_project_id"];
			$state    = $data["t_project_state"];
			$name     = $data["t_project_name"];
			$register = $data["t_project_register"];
			$userID   = $data["t_user_id"];
			$orgID    = $data["t_organization_id"];
			$orgName  = $data["t_organization_name"];
			
			// 状態
			/*
			$labelClass = "label-default";
			if ( $state === DAO::T_PROJECT_STATE_NORMAL ){ $labelClass = "label-danger"; }
			else if ( $state === DAO::T_PROJECT_STATE_COMPLETE ){ $labelClass = "label-primary"; }
			$hState = Printer::label("label-only {$labelClass}", DAO::T_PROJECT_STATE_TABLE($state));
			*/
			if ( $auth->write_isState($id) ){
				$arrButton = array();
				foreach ( DAO::T_PROJECT_STATE_TABLE(NULL, TRUE) as $key => $text ){
					$stateClass = ($state === $key) ? "icon-arrow-right" : "icon-none";
					$arrButton[] = Printer::link($text, NULL, $stateClass, NULL, NULL, "minhon.common.setProjectState({$id}, {$key});", array("data-state"=>$key));
				}
				$hState = Printer::buttonGroup( DAO::T_PROJECT_STATE_TABLE($state), $arrButton, "non", array("class"=>DAO::T_PROJECT_STATE_ALERT_TABLE($state)));
			} else {
				$stateClass = DAO::T_PROJECT_STATE_ALERT_TABLE($state);
				$stateText  = DAO::T_PROJECT_STATE_TABLE($state);
				$hState = "<span class=\"btn disabled {$stateClass} no-opacity\">{$stateText}</span>";
			}
			
			// 名前
			$hName = Printer::ellipsis($name, 15);
			$hName = Printer::link($hName, "project-tooltip tooltip-project", "icon-th", NULL, "/content/project/detail.html?q_project_id={$id}", NULL, NULL, FALSE);
			// 登録日時
			$hRegister = Printer::icon("icon-time", NULL, $register);
			// メンバー
			$hMember = Printer::linkSupportResize("{$WORD($wk, 17)}", "project-tooltip tooltip-member", "icon-user", NULL, "/content/member/?q_project_id={$id}");
			// 文書
			$hDocument = Printer::linkSupportResize("{$WORD($wk, 18)}", "project-tooltip tooltip-document", "icon-file", NULL, "/content/document/?q_project_id={$id}");
			// ワークフロー
			$hWorkflow = Printer::linkSupportResize("{$WORD($wk, 19)}", "project-tooltip tooltip-task", "icon-list-alt", NULL, "/content/workflow/?q_project_id={$id}");
			// 用語
			$hTerm = Printer::linkSupportResize("{$WORD($wk, 20)}", "project-tooltip tooltip-term", "icon-book", NULL, "/content/term_root/?q_kind=".Term::KIND_TERM."&q_project_id={$id}");
			// 翻訳メモリ
			$hBilingual = Printer::linkSupportResize("{$WORD($wk, 21)}", "project-tooltip tooltip-bilingual", "icon-book", NULL, "/content/term_root/?q_kind=".Term::KIND_BILINGUAL."&q_project_id={$id}");
			// データ
			$hData = Printer::linkSupportResize("{$WORD($wk, 22)}", "project-tooltip tooltip-data", "icon-paperclip", NULL, "/content/data/?q_project_id={$id}");
			// 掲示板
			$hBBS = Printer::linkSupportResize("{$WORD($wk, 23)}", "project-tooltip tooltip-bbs", "icon-comment", NULL, "/content/bbs/?q_project_id={$id}");
			// 統計
			$hStatistics = Printer::linkSupportResize("{$WORD($wk, 24)}", NULL, "icon-stats", NULL, "/content/statistics/?q_kind=".Statistics::KIND_TASK_USER."&q_project_id={$id}");
			
			$arrButton = array();
			if ( $auth->processBSearch($id) ){
				$mode = CONTENT_SEARCH_INDEX_MODE_BILINGUAL;
				$arrButton[] = Printer::linK("{$WORD($wk, 25)}", NULL, "icon-search", NULL, "/content/search/?q_mode={$mode}&q_project_id={$id}", NULL, array("target"=>"_blank"));
			}
			if ( $auth->processSimilarity($id) ){
				$mode = CONTENT_SEARCH_INDEX_MODE_SIM;
				$arrButton[] = Printer::linK("{$WORD($wk, 26)}", NULL, "icon-search", NULL, "/content/search/?q_mode={$mode}&q_project_id={$id}", NULL, array("target"=>"_blank"));
			}
			$arrButton[] = "-";
			if ( $auth->processCopy($id) ){
				// コピー
				$arrButton[] = Printer::link("{$WORD($wk, 27)}", NULL, "icon-th", NULL, NULL, "minhon.common.onClickGet('./edit.html', {q_copy_id:{$id}}, '{$WORD($wk, 28)}');");
			}
			if ( $auth->remove($id) ){
				// 削除
				$arrButton[] = Printer::link("{$WORD($wk, 29)}", NULL, "icon-remove", NULL, NULL, "minhon.common.onClickPost('./delete.html', {q_id:{$id}}, '{$WORD($wk, 30)}');");
			}
			if ( end($arrButton) === "-" ){
				if ( count($arrButton) === 0 ){
					$arrButton = array();
				} else {
					$arrButton = array_slice($arrButton, 0, -1);
				}
			}
			// 操作
			$hOperation = Printer::buttonGroup("{$WORD($wk, 31)}", $arrButton);
			
			// 組織
			if ( $viewOrg ){
				$subQuery = array_merge($query, array("q_org_id" => $orgID));
				unset($subQuery["q_offset"]);
				$tdOrgName = "<td>" . $this->tabLink($orgName, NULL, "icon-star", NULL, "/content/project/", $subQuery) . "</td>";
			} else {
				$tdOrgName = "";
			}
			
$html .= <<< HTML
			<tr data-project-id="{$id}">
				<td>{$hName}</td>
				<td class="col-tight">{$hState}</td>
				<td class="col-tight">{$hRegister}</td>
				{$tdOrgName}
				<td class="col-tight">{$hMember}</td>
				<td class="col-tight">{$hDocument}</td>
				<td class="col-tight">{$hWorkflow}</td>
				<td class="col-tight">{$hTerm}</td>
				<td class="col-tight">{$hBilingual}</td>
				<td class="col-tight">{$hData}</td>
				<td class="col-tight">{$hBBS}</td>
				<td class="col-tight">{$hStatistics}</td>
				<td class="col-tight">{$hOperation}</td>
			</tr>
HTML;
		}

		// タイトル
		$headerName = $this->tableHeader("{$WORD($wk, 32)}", "icon-search", NULL, array(
			Printer::link("{$WORD($wk, 33)}", NULL, "icon-search", NULL, NULL, "minhon.project.onClickFilterName();"),
			Validate::isString($searchValue) ? Printer::link("{$WORD($wk, 34)}", NULL, "icon-none", NULL, NULL, "minhon.project.onClickFilterNameClear();") : NULL,
		), $query, "q_keyword", DAO_project::ORDER_KEY_NAME);
		// 状態
		$headerState = $this->tableHeaderQueryFilter("{$WORD($wk, 35)}", DAO::T_PROJECT_STATE_VALID_TABLE(), $query, "q_state", DAO_project::ORDER_KEY_STATE);
		// 登録日時
		$headerRegister = $this->tableHeader("{$WORD($wk, 36)}", NULL, NULL, NULL, $query, NULL, DAO_project::ORDER_KEY_REGISTER);
		// 組織
		if ( $viewOrg ){
			$arrDropdown = array();
			$icon = NULL;
			if ( isset($query["q_org_id"]) ){
				$icon = "icon-filter";
				$subQuery = $query;
				unset($subQuery["q_offset"]);
				unset($subQuery["q_org_id"]);
				$arrDropdown[] = $this->tabLink("{$WORD($wk, 37)}", NULL, "icon-none", NULL, "./", $subQuery);
			}
			$thOrgName = "<th>" . $this->tableHeader("{$WORD($wk, 38)}", $icon, NULL, $arrDropdown, $query, "q_org_id" ) . "</th>";
		} else {
			$thOrgName = "";
		}
		
$html = <<< HTML
		<table id="project_list" class="table table-grid">
			<thead>
				<tr>
					<th>{$headerName}</th>
					<th>{$headerState}</th>
					<th>{$headerRegister}</th>
					{$thOrgName}
					<th colspan="8">{$WORD($wk, 39)}</th>
					<th>{$WORD($wk, 40)}</th>
				</tr>
			</thead>
			<tbody>
				{$html}
			</tbody>
		</table>
HTML;
		
		$html .= $this->_dialogFilterName( $searchValue );
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: _dialogFilterName
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function _dialogFilterName( $keyword ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		$html = "";
		
		$arrControl = array();
		$arrControl[] = array(
			"id" => NULL,
			"name" => "{$WORD($wk, 41)}",
			"form" => Printer::input("text", "q_keyword", "q_keyword", $keyword, NULL, array("style"=>"width: 100%")),
		);
		$form = Printer::formControl($arrControl, FALSE, TRUE);
		
$html = <<< HTML
		<div id="dialog_project_filter_name" class="dialog">
			<form>
				<table class="table except-table-cell">
					{$form}
				</table>
			</form>
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: detail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function detail( $data, $arrProjectManagerUser = array() ){
		global $WORD;
		global $G_LANG_TABLE;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		$html = "";

		// 名前
		$name = $data["t_project_name"];
		$hName = Util::esc($name);
		// 日程
		$start = $data["t_project_start"];
		$end = $data["t_project_end"];
		if ( is_null($start) && is_null($end) ){
			$hDate = "";
		} else {
			$start = is_null($start) ? "---" : Util::esc($start);
			$end   = is_null($end)   ? "---" : Util::esc($end);
			$hDate = "(".Printer::direct("icon-arrow-right", $start, $end).")";
		}
		// 作成者
		$userName = $data["t_user_name"];
		$userType = DAO::storedFunction("get_user_type", $data["t_user_id"]);
		$hUser = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
		$hOrg  = Util::esc($data["t_organization_name"]);
		// 説明
		$text = $data["t_project_text"];
		if ( strcmp(trim($text), "") === 0 ){
			$hText = Printer::alert( FALSE, "{$WORD($wk, 42)}", FALSE, array("style" => "margin: 0px;") );
		} else {
			$hText = Printer::formText(nl2br(Util::esc($text)), FALSE);
		}
		// 言語
		$langS = $data["t_project_lang_s"];
		$hHiddenLang = Printer::input("hidden", NULL, "q_lang_s", $langS);
		$arrLang = array();
		foreach ( $data["t_project_lang_t"] as $langT ){
			$arrLang[] = Printer::directLang($langS, $langT, FALSE);
			$hHiddenLang .= Printer::input("hidden", NULL, "q_lang_t[]", $langT);
		}
		$dict = $data["t_project_qredit_dictionary"];
		// プロジェクト管理者
		$arrPmUser = array();
		foreach ( $arrProjectManagerUser as $dataUser ){
			if ( $dataUser["t_project_user_role"] === Task::ROLE_RPMG ){
				$pmUserName = $dataUser["t_user_name"];
				$pmUserType = $dataUser["t_user_type"];
				$hPmUser = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($pmUserType), $pmUserName);
				$hPmOrg = Util::esc($dataUser["t_organization_name"]);
				$arrPmUser[$dataUser["t_user_id"]] = "{$hPmUser} ({$hPmOrg})";
			}
		}
		if ( count($arrPmUser) > 0 ){
			$formPmUser = Printer::formText(implode("<br />", $arrPmUser), FALSE);
		} else {
			$formPmUser = Printer::alert( FALSE, "{$WORD($wk, 43)}", FALSE, array("style"=>"margin: 0px"));
		}
		
		$arrControl  = array();
		// 名前
		$arrControl[] = array(
			"id"   => "q_name",
			"name" => "{$WORD($wk, 44)}",
			"form" => array(
				Printer::formText("{$hName} {$hDate}", FALSE),
			),
		);
		// 作成者
		$arrControl[] = array(
			"id"   => "q_user",
			"name" => "{$WORD($wk, 45)}",
			"form" => array(
				Printer::formText("{$hUser} ({$hOrg})", FALSE),
			),
		);
		// PM(管理者)
		$arrControl[] = array(
			"id"   => "q_user",
			"name" => "{$WORD($wk, 46)}",
			"form" => array(
				$formPmUser,
			),
		);
		// フォーム(言語)
		$arrControl[] = array(
			"id"   => "q_lang",
			"name" => "{$WORD($wk, 47)}",
			"form" => array(
				Printer::formText( implode("<br />", $arrLang), FALSE ),
			),
		);
		$arrControl[] = array(
			"id"   => NULL,
			"name" => NULL,
			"form" => $hHiddenLang,
		);
		// フォーム(コメント)
		$arrControl[] = array(
			"id"   => "q_text",
			"name" => "{$WORD($wk, 48)}",
			"form" => array(
				$hText,
			),
		);
		// フォーム(使用辞書)
		$arrControl[] = array(
			"id"   => "q_dict",
			"name" => "{$WORD($wk, 49)}",
			"form" => array(
				$this->dictionary($dict),
			),
		);
		
		$html = Printer::form("form_project", "form_project", "./", "post", $arrControl);
		return $html;
	}
	
	function dictionary( $dictionary, $isReadOnly = TRUE ){
		global $WORD;
		global $G_LANG_TABLE;
		global $G_ONOFF_TABLE;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		$html = "";
		
		$qreditDictionary = str_pad($dictionary, 63, "-", STR_PAD_LEFT);
		$langOrder = array_keys($G_LANG_TABLE);
		
		$hTable = "";
		foreach ( QReditDict::ID_TABLE() as $id => $value ){
			if  ( isset($value["fix"]) ){
				// 決まった値のものはON/OFFさせない
				continue;
			}
			$name = QReditDict::getDictionaryName($id);
			$sLang = $value["slang"];
			$tLang = $value["tlang"];
			if ( ($sLangOrder = array_search($sLang, $langOrder)) === FALSE ){
				// 対応外の言語が指定されている場合は表示させない
				continue;
			}
			if ( ($tLangOrder = array_search($tLang, $langOrder)) === FALSE ){
				// 対応外の言語が指定されている場合は表示させない
				continue;
			}
			
			$flag = substr($qreditDictionary, -($id+1), 1);
			if ( is_numeric($flag) ){
				$flag = (integer) $flag;
			}
			
			$hName = Util::esc($name);
			$hLang = Printer::directLang($sLang, $tLang);
			if ( $isReadOnly ){
				$hUseDict = "<span>".QReditDict::FLAG_TABLE($flag)."</span>";
			} else {
				$hUseDict = Printer::radio(NULL, "q_dict[{$id}]", QReditDict::FLAG_TABLE(), $flag);
			}
$hTable .= <<< HTML
			<tr data-dictionary-id="{$id}" data-source-lang="{$sLang}" data-source-lang-order="{$sLangOrder}" data-target-lang="{$tLang}" data-target-lang-order="{$tLangOrder}" data-flag="{$flag}">
				<td>{$hName}</td>
				<td>{$hLang}</td>
				<td>{$hUseDict}</td>
			</tr>
HTML;
		}
		
		if ( $isReadOnly ){
			$arrDropdown = array(
				Printer::link("{$WORD($wk, 50)}", NULL, NULL, NULL, NULL, "minhon.project.detail.onClickViewDictionaryAll();"),
				Printer::link("{$WORD($wk, 51)}", NULL, NULL, NULL, NULL, "minhon.project.detail.onClickViewDictionaryRelated();"),
				Printer::link("{$WORD($wk, 52)}", NULL, NULL, NULL, NULL, "minhon.project.detail.onClickViewDictionaryDialog();"),
			);
			$hDropDown = Printer::buttonGroup("{$WORD($wk, 53)}", $arrDropdown, "success");
		} else {
			$hDropDown = "";
		}
		
$html = <<< HTML
	<div id="project_qredit_dictionary" style="width: 100%">
		<table class="table">
			<thead>
				<th>{$WORD($wk, 54)}</th>
				<th>{$WORD($wk, 55)}</th>
				<th>{$WORD($wk, 56)}</th>
			</thead>
			<tbody>
				{$hTable}
			</tbody>
		</table>
		{$hDropDown}
	</div>
HTML;
		
		return $html;
	}
	
	function dictionaryDialog( $sourceLang, $arrTargetLang ){
		global $G_LANG_TABLE;
		global $G_ONOFF_TABLE;
		
		$langOrder = array_keys($G_LANG_TABLE);
		
		$arrSelected = array();
		$arrCheckList = array();
		$arrCheckOption = array();
		$arrLabelOption = array();
		foreach ( QReditDict::ID_TABLE() as $id => $value ){
			if  ( isset($value["fix"]) ){
				// 決まった値のものはON/OFFさせない
				continue;
			}
			$name = QReditDict::getDictionaryName($id);
			$sLang = $value["slang"];
			$tLang = $value["tlang"];
			if ( ($sLangOrder = array_search($sLang, $langOrder)) === FALSE ){
				continue;
			}
			if ( ($tLangOrder = array_search($tLang, $langOrder)) === FALSE ){
				continue;
			}
			
			$order = $sLangOrder * count($langOrder) + $tLangOrder;
			$arrCheckList[$order] = Printer::directLang($sLang, $tLang);
			$arrCheckLang[$order] = array(
				"data-source-lang" => $sLang,
				"data-target-lang" => $tLang,
			);
			if ( $sourceLang === $sLang && in_array($tLang, $arrTargetLang) ){
				$arrSelected[$order] = $order;
				$arrLabelOption[$order] = array(
					"class" => "highlight",
				);
			}
		}
		ksort($arrCheckList);
		
		$html = Printer::checkbox(NULL, "selectLang", $arrCheckList, $arrSelected, array("item" => $arrCheckLang, "item-label" => $arrLabelOption), FALSE, FALSE);
		
$html = <<< HTML
	<div id="dialog_project_qredit_dictionary">
		{$html}
	</div>
HTML;
		
		return $html;
	}
	
	private function _getDAOArrayKeyValue( $arr, $keyName ){
		$arrBuf = array();
		foreach ( $arr as $data ){
			$arrBuf[$data[$keyName]] = $data;
		}
		return $arrBuf;
	}
	
	/***************************************************************
	 * 名前: structureUserDetail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function structureUserDetail( $arrProjectUser, $arrTask, $arrTaskActor ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		// ユーザーごと
		$arrUser = array();
		foreach( $arrProjectUser as $dataProjectUser ){
			$userID = $dataProjectUser["t_user_id"];
			if ( ! isset($arrUser[$userID]) ){
				$arrUser[$userID] = $dataProjectUser;
				$arrUser[$userID]["role"] = array();
			}
			$role = $dataProjectUser["t_project_user_role"];
			$arrUser[$userID]["role"][$role] = Task::ROLE_TABLE($role);
			$arrUser[$userID]["task"] = array();
		}
		foreach ( $arrTaskActor as $dataTaskActor ){
			$taskID   = $dataTaskActor["t_task_id"];
			$userID   = $dataTaskActor["t_user_id"];
			if ( isset($arrUser[$userID]) ){
				$arrUser[$userID]["task"][$taskID] = $taskID;
			}
		}
		
		// $arrTaskのインデックスをTaskIDにする
		$arrTask = $this->_getDAOArrayKeyValue($arrTask, "t_task_id");
		
		$arrDetail = array();
		foreach ( $arrUser as $dataUser ){
			$userID   = $dataUser["t_user_id"];
			$userName = $dataUser["t_user_name"];
			$userType = $dataUser["t_user_type"];
			
			// タイプ
			$hUserType = DAO::T_USER_TYPE_TABLE($userType);
			// 役割
			$dataUser["role"] = array_intersect_key(Task::ROLE_TABLE(), $dataUser["role"]); // roleの並び替え
			if ( count($dataUser["role"]) == 0 ){
				$hUserRole = "---";
			} else {
				$hUserRole = implode(", ", $dataUser["role"]);
			}
			// タスク
			$hUserTask = "---";
			$arrUserTask = array_intersect_key($arrTask, $dataUser["task"]); // taskの並び替え及び、データセット
			if ( count($arrUserTask) > 0 ){
				if ( $isSlice = (count($arrUserTask) > 5) ){
					$arrUserTask = array_slice($arrUserTask, 0, 5);
				}
				$arrContent = array();
				foreach ( $arrUserTask as $dataTask ){
					$taskID   = $dataTask["t_task_id"];
					$taskType = $dataTask["t_task_type"];
					
					$hTaskType  = Task::TYPE_TABLE($taskType);
					$hTaskStart = Util::esc($dataTask["t_task_start"]);
					$hTaskEnd   = Util::esc($dataTask["t_task_end"]);
					$arrContent[] = "{$hTaskType} : {$hTaskStart}~{$hTaskEnd}";
				}
				if ( count($arrContent) > 0 ){
					$hUserTask = implode("<br/>", $arrContent);
					if ( $isSlice ){
						$hUserTask .= "...";
					}
				}
			}
			
$hPopoverContent = <<< HTML
			<dl>
				<dt>{$WORD($wk, 57)}</dt>
				<dd>{$hUserType}</dd>
				<dt>{$WORD($wk, 58)}</dt>
				<dd>{$hUserRole}</dd>
				<dt>{$WORD($wk, 59)}</dt>
				<dd>{$hUserTask}</dd>
			</dl>
HTML;
			
			$hUser = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
			$arrDetail[] = Printer::popover($hUser, $hUser, $hPopoverContent, NULL, FALSE);
		}
		
		return $arrDetail;
	}
	
	/***************************************************************
	 * 名前: structureDocumentDetail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function structureDocumentDetail( $arrDocument, $arrProjectUser, $arrTask, $arrTaskDocument, $arrTaskActor ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		// $arrProjectUserのインデックスをTaskIDにする
		$arrProjectUser = $this->_getDAOArrayKeyValue($arrProjectUser, "t_user_id");
		
		$arrDocumentTaskID = array();
		foreach ( $arrTaskDocument as $dataTaskDocument ){
			$documentID = $dataTaskDocument["t_document_id"];
			$taskID     = $dataTaskDocument["t_task_id"];
			$arrDocumentTaskID[$documentID][$taskID] = $taskID;
		}
		
		// $arrTaskUser[$taskID][$userID] とする(役割が複数セットされていた場合も1つになる)
		$arrTaskUser = array();
		foreach ( $arrTaskActor as $dataTaskActor ){
			$taskID   = $dataTaskActor["t_task_id"];
			$userID   = $dataTaskActor["t_user_id"];
			$userName = $dataTaskActor["t_user_name"];
			if ( isset($arrProjectUser[$userID]) ){
				$arrTaskUser[$taskID][$userID] = Util::esc($userName);
			}
		}
		
		// $arrTaskのインデックスをTaskIDにする
		$arrTask = $this->_getDAOArrayKeyValue($arrTask, "t_task_id");
		
		$arrDetail = array();
		foreach ( $arrDocument as $dataDocument ){
			$documentID    = $dataDocument["t_document_id"];
			$documentTitle = $dataDocument["t_document_title"];
			
			$hDocumentTask = "---";
			if ( isset($arrDocumentTaskID[$documentID]) ){
				$arrDocTask = array_intersect_key($arrTask, $arrDocumentTaskID[$documentID]);
				if ( $isSlice = (count($arrDocTask) > 5) ){
					$arrDocTask = array_slice($arrDocTask, 0, 5);
				}
				$arrContent = array();
				foreach ( $arrDocTask as $dataTask ){
					$taskID   = $dataTask["t_task_id"];
					$taskType = $dataTask["t_task_type"];
					
					$hTaskType  = Task::TYPE_TABLE($taskType);
					$hTaskStart = Util::esc($dataTask["t_task_start"]);
					$hTaskEnd   = Util::esc($dataTask["t_task_end"]);
					$hTaskUser  = isset($arrTaskUser[$taskID]) ? "(".implode(",", $arrTaskUser[$taskID]).")" : "";
					$arrContent[] = "{$hTaskType} : {$hTaskStart}~{$hTaskEnd} {$hTaskUser}";
				}
				if ( count($arrContent) > 0 ){
					$hDocumentTask = implode("<br/>", $arrContent);
					if ( $isSlice ){
						$hDocumentTask .= "...";
					}
				}
			}
			
$hPopoverContent = <<< HTML
			<dl>
				<dt>{$WORD($wk, 60)}</dt>
				<dd>{$hDocumentTask}</dd>
			</dl>
HTML;
			
			$hDocument = Printer::icon("icon-file", NULL, $documentTitle);
			$hDocumentShort = Printer::ellipsis($hDocument, 20, FALSE);
			$arrDetail[] = Printer::popover($hDocumentShort, $hDocument, $hPopoverContent, NULL, FALSE);
		}

		return $arrDetail;
	}
	
	/***************************************************************
	 * 名前: structureTaskDetail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function structureTaskDetail( $arrTask, $arrProjectUser, $arrTaskActor ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		// $arrTaskUser[$taskID][$userID] とする(役割が複数セットされていた場合も1つになる)
		$arrTaskUser = array();
		foreach ( $arrTaskActor as $dataTaskActor ){
			$taskID   = $dataTaskActor["t_task_id"];
			$userID   = $dataTaskActor["t_user_id"];
			$userName = $dataTaskActor["t_user_name"];
			$arrTaskUser[$taskID][$userID] = Util::esc($userName);
		}
		
		// $arrProjectUserのインデックスをUserIDにする
		$arrProjectUser = $this->_getDAOArrayKeyValue($arrProjectUser, "t_user_id");
		
		$arrDetail = array();
		foreach ( $arrTask as $dataTask ){
			$taskID   = $dataTask["t_task_id"];
			$taskType = $dataTask["t_task_type"];
			
			$hTaskStart = Util::esc($dataTask["t_task_start"]);
			$hTaskEnd   = Util::esc($dataTask["t_task_end"]);
			$hTaskSpan  = "{$hTaskStart}~{$hTaskEnd}";
			
			$hTaskUser = "---";
			if ( isset($arrTaskUser[$taskID]) ){
				$arrUser = array_intersect_key($arrProjectUser, $arrTaskUser[$taskID]);
				if ( $isSlice = (count($arrUser) > 5) ){
					$arrUser = array_slice($arrUser, 0, 5);
				}
				$arrContent = array();
				foreach ( $arrUser as $dataUser ){
					$userID   = $dataUser["t_user_id"];
					$userName = $dataUser["t_user_name"];
					
					$hUserName = Util::esc($userName);
					$arrContent[] = $hUserName;
				}
				if ( count($arrContent) > 0 ){
					$hTaskUser = implode("<br/>", $arrContent);
					if ( $isSlice ){
						$hTaskUser .= "...";
					}
				}
			}
			
$hPopoverContent = <<< HTML
			<dl>
				<dt>{$WORD($wk, 61)}</dt>
				<dd>{$hTaskSpan}</dd>
				<dt>{$WORD($wk, 62)}</dt>
				<dd>{$hTaskUser}</dd>
			</dl>
HTML;
			
			$hTask = Printer::icon("icon-ok", NULL, Task::TYPE_TABLE($taskType));
			$arrDetail[] = Printer::popover($hTask, $hTask, $hPopoverContent, NULL, FALSE);
		}
		
		return $arrDetail;
	}
	
	/***************************************************************
	 * 名前: structureTermRootDetail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function structureTermRootDetail( $arrTermRoot, $arrProjectTermRoot, $arrTask, $arrDocument, $arrTaskTermRoot, $arrTaskDocument ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		// $arrIDsTermRootTask[$termRootID][$taskID] とする
		$arrIDsTermRootTask = array();
		foreach ( $arrTaskTermRoot as $dataTaskTermRoot ){
			$termRootID = $dataTaskTermRoot["t_term_root_id"];
			$taskID     = $dataTaskTermRoot["t_task_id"];
			$arrIDsTermRootTask[$termRootID][$taskID] = $taskID;
		}
		
		// $arrIDsTaskDocument[$taskID][$documentID] とする
		$arrIDsTaskDocument = array();
		foreach ( $arrTaskDocument as $dataTaskDocument ){
			$taskID     = $dataTaskDocument["t_task_id"];
			$documentID = $dataTaskDocument["t_document_id"];
			$arrIDsTaskDocument[$taskID][$documentID] = $documentID;
		}
		
		$arrTermRootType = array();
		foreach ( $arrProjectTermRoot as $dataProjectTermRoot ){
			$termRootID = $dataProjectTermRoot["t_term_root_id"];
			$type       = $dataProjectTermRoot["t_project_term_root_type"];
			$arrTermRootType[$termRootID] = $type;
		}
		
		// $arrTaskのインデックスをtaskIDにする
		$arrTask = $this->_getDAOArrayKeyValue($arrTask, "t_task_id");
		
		// $arrDocumentのインデックスをdocumentIDにする
		$arrDocument = $this->_getDAOArrayKeyValue($arrDocument, "t_document_id");
		
		$arrDetail = array();
		foreach ( $arrTermRoot as $dataTermRoot ){
			$termRootID   = $dataTermRoot["t_term_root_id"];
			$termRootName = $dataTermRoot["t_term_root_name"];
			if ( isset($arrTermRootType[$termRootID]) ){
				$type = $arrTermRootType[$termRootID];
				$hType = DAO::T_TERM_ROOT_TYPE_TABLE($type);
			} else {
				continue;
			}
			
			$hTermRootDocument = "---";
			if ( isset($arrIDsTermRootTask[$termRootID]) ){
				$arr = array_intersect_key($arrTask, $arrIDsTermRootTask[$termRootID]);
				$arr = array_intersect_key($arrIDsTaskDocument, $arrTask);
				$arrUnionDocumentID = array();
				foreach ( $arr as $taskID => $arrDocumentID ){
					$arrUnionDocumentID = array_merge($arrUnionDocumentID, $arrDocumentID);
				}
				$arrUnionDocumentID = array_unique($arrUnionDocumentID);
				$arrTermRootDocument = array();
				$isSlice = FALSE;
				foreach ( $arrUnionDocumentID as $documentID ){
					if ( isset($arrDocument[$documentID]) ){
						if ( count($arrTermRootDocument) >= 5 ){
							$isSlice = TRUE;
							break;
						}
						$arrTermRootDocument[$documentID] = $arrDocument[$documentID];
					}
				}
				
				$arrContent = array();
				foreach ( $arrTermRootDocument as $dataDocument ){
					$documentID    = $dataDocument["t_document_id"];
					$documentTitle = $dataDocument["t_document_title"];
					
					$hDocumentTitle = Util::esc($documentTitle);
					$arrContent[] = $hDocumentTitle;
				}
				if ( count($arrContent) > 0 ){
					$hTermRootDocument = implode("<br/>", $arrContent);
					if ( $isSlice ){
						$hTermRootDocument .= "...";
					}
				}
			}
			
$hPopoverContent = <<< HTML
			<dl>
				<dt>{$WORD($wk, 63)}</dt>
				<dd>{$hType}</dd>
				<dt>{$WORD($wk, 64)}</dt>
				<dd>{$hTermRootDocument}</dd>
			</dl>
HTML;
			
			$hTask = Printer::icon("icon-book", NULL, $termRootName);
			$hTaskShort = Printer::ellipsis($hTask, 20, FALSE);
			$arrDetail[] = Printer::popover($hTaskShort, $hTask, $hPopoverContent, NULL, FALSE);
			
		}
			
		return $arrDetail;
	}
	
	/***************************************************************
	 * 名前: structureDataDetail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function structureDataDetail( $arrData ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		$arrDetail = array();
		foreach ( $arrData as $dataData ){
			$dataID     = $dataData["t_data_id"];
			$dataTitle  = $dataData["t_data_title"];
			$dataProp   = $dataData["t_data_props"];
			$dataPublic = $dataData["t_data_public"];
			
			// 公開
			$hDataPublic = DAO::T_DATA_PUBLIC_TABLE($dataPublic);
			// タイプ
			$hDataProp = DAO::T_DATA_PROP_TABLE($dataProp);
			
$hPopoverContent = <<< HTML
			<dl>
				<dt>{$WORD($wk, 65)}</dt>
				<dd>{$hDataProp}</dd>
				<dt>{$WORD($wk, 66)}</dt>
				<dd>{$hDataPublic}</dd>
			</dl>
HTML;
			
			$hData = Printer::icon("icon-paperclip", NULL, $dataTitle);
			$hDataShort = Printer::ellipsis($hData, 20, FALSE);
			$arrDetail[] = Printer::popover($hDataShort, $hData, $hPopoverContent, NULL, FALSE);
		}
		
		return $arrDetail;
	}
	
	/***************************************************************
	 * 名前: structureBbsPostDetail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function structureBbsPostDetail( $arrBbsPost ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT";
		
		$arrPost = array();
		foreach  ($arrBbsPost as $dataBbsPost ){
			$postNo   = $dataBbsPost["t_bbs_post_no"];
			$postType = $dataBbsPost["t_bbs_post_type"];
			$arrPost[$postType][$postNo] = $dataBbsPost;
		}
		
		$arrDetail = array();
		foreach ( $arrPost as $postType => $arrBbsPost ){
			// 数
			$postCount  = count($arrBbsPost);
			$hPostCount = Util::esc($postCount);
			
			// ユーザー
			$arrPostUser = array();
			foreach ( $arrBbsPost as $dataBbsPost ){
				$userID   = $dataBbsPost["t_user_id"];
				$userName = $dataBbsPost["t_user_name"];
				$arrPostUser[$userID] = Util::esc($userName);
			}
			$hPostUser = implode(", ", $arrPostUser);
			
$hPopoverContent = <<< HTML
			<dl>
				<dt>{$WORD($wk, 67)}</dt>
				<dd>{$hPostUser}</dd>
				<dt>{$WORD($wk, 68)}</dt>
				<dd>{$hPostCount}</dd>
			</dl>
HTML;
			
			$hPost = Printer::icon("icon-comment", NULL, DAO::T_BBS_POST_TYPE_TABLE($postType));
			$arrDetail[] = Printer::popover($hPost, $hPost, $hPopoverContent, NULL, FALSE);
		}
		
		return $arrDetail;
	}
}
