<?php require_once("class/View.php"); ?>
<?php
Class View_project_user extends View {
	const TAB_LIST     = 0;
	const TAB_EDIT     = 1;
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $tab, $auth, $projectID ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT_USER";
		
		$html = FALSE;
		$query = array(
			"q_project_id" => $projectID,
		);
		
		switch ( $tab ){
			//------------------------
			// 参加者一覧
			case self::TAB_LIST:
				if ( $auth->read($projectID) ){
					$html = $this->tabLink("{$WORD($wk, 1)}", NULL, NULL, NULL, "./", $query);
				}
				break;
			//------------------------
			// 参加者登録
			case self::TAB_EDIT:
				if ( $auth->write_isMember($projectID, NULL) ){
					$html = $this->tabLink("{$WORD($wk, 2)}", NULL, "icon-pencil", NULL, "./edit.html", $query);
				}
				break;
		}
		
		return $html;
	}

	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function wizard(){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT_USER";
		
		$html = "";
		
		// ウィザード表示
		$arrWizard = array(
			0 => "{$WORD($wk, 3)}",
			1 => "{$WORD($wk, 4)}",
		);
		$hWiz = Printer::wizard($arrWizard, 0);
		
$html = <<< HTML
		<div style="margin: 10px 0; padding: 5px 10px; background-color: #EEE">
			{$hWiz}
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: formRegTable
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formRegTable( $arrUser ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT_USER";
		
		$html = "";
		$arrUserName = array();
		$arrUserState = array();
		$arrUserType = array();
		$arrReg = array();
		
		// 並び替え
		foreach ( $arrUser as $dataUser ){
			$userID   = $dataUser["t_user_id"];
			$userName = $dataUser["t_user_name"];
			$userState = $dataUser["t_user_state"];
			$userType = $dataUser["t_user_type"];
			$arrUserName[$userID] = $userName;
			$arrUserState[$userID] = $userState;
			$arrUserType[$userID] = $userType;
		}
		natsort($arrUserName);
		
		foreach ( $arrUserName as $userID => $userName ){
			$arrReg[substr($userName, 0, 1)][$userID] = $userName;
		}
		
		// 
		foreach ( $arrReg as $alphabet => $arr ){
			$htmlUser = "";
			
			foreach ( $arr as $userID => $userName ){
				$color = DAO::T_USER_TYPE_COLOR_TABLE($arrUserType[$userID]);
				$type = DAO::T_USER_TYPE_TABLE($arrUserType[$userID]);
				$hUser = Printer::icon("icon-user", $color, $userName, "inherit");
				if ( $arrUserState[$userID] === DAO::T_USER_STATE_QUIT ){
					$hUser = Printer::iconWarning("{$WORD($wk, 5)}").$hUser;
				}
				$hLinkUser = Printer::link($hUser, "btn btn-default btn-user", NULL, NULL, NULL, NULL, array("data-user" => $userName), FALSE);
				
$htmlUser .= <<< HTML
				<span data-toggle="popover" data-trigger="hover" data-placement="top" data-delay='{"show":500, "hide":100}' data-content="{$type}">{$hLinkUser}</span>
HTML;
			}
			
			$hAlphabet = Util::esc($alphabet);
			$hLabelAlphabet = Printer::label("label-success", $alphabet);
			
$html .= <<< HTML
			<tr>
				<th>{$hAlphabet}</th>
				<td>{$htmlUser}</td>
			</tr>
HTML;
		}
		
$html = <<< HTML
		<table class="table table-reg">
			<tbody>
				{$html}
			</tbody>
		</table>
HTML;
		
		return $html;
	}

	function _sortOrg( &$a, &$b ){
		if ( $a === User::get("organization_id") ){
			return -1;
		}
		if ( $b === User::get("organization_id") ){
			return 1;
		}
		return ($a - $b);
	}
	
	/***************************************************************
	 * 名前: formReg
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formReg( $arrUser, $arrOrganization ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT_USER";
		
		$html = "";
		
		// 組織ごとに分ける
		$arrOrg     = array();
		$arrOrgUser = array();
		foreach ( $arrUser as $userID => $dataUser ){
			$orgID   = $dataUser["t_organization_id"];
			$orgName = $dataUser["t_organization_name"];
			
			$arrOrg[$orgID] = $orgName;
			$arrOrgUser[$orgID][$userID] = $dataUser;
		}
		// ユーザー組織 > 組織ID の順で並べる
		uksort($arrOrgUser, array($this, "_sortOrg"));
		
		$hTabs = "";
		$hTabContents = "";
		foreach ( $arrOrgUser as $orgID => $arrIndividualUser ){
			// 組織が自分自身の組織かどうか
			$isMyOrg = ($orgID===User::get("organization_id"));
			// 組織ID
			$hOrgID = Util::esc($orgID);
			// 組織名
			$hOrgName = Util::esc($arrOrg[$orgID]);
			// 人数
			$hUserCount = Util::esc( count($arrIndividualUser) );
			// テーブル
			$hTableReg = $this->formRegTable($arrIndividualUser);
			
			// タブクラス
			$hAttrClass = ($isMyOrg) ? "class=\"fix-tab\"" : "";
			// タブ
$hTabs .= <<< HTML
	<li data-org="{$hOrgName}" data-org-id="{$hOrgID}" {$hAttrClass}><a href="#tab_org_{$hOrgID}">{$hOrgName} (<span class="select-count">0</span> / {$hUserCount})</a></li>
HTML;

$hTabContents .= <<< HTML
	<div id="tab_org_{$hOrgID}" data-org="{$hOrgName}">
		{$hTableReg}
	</div>
HTML;
		}
		
		// 検索フォーム
		$hInputSearch = Printer::input("text", "member-edit-search", NULL, NULL, NULL, array("placeholder" => "{$WORD($wk, 6)}"));
		// 追加ボタン
		$hOrgAddButton = Printer::link("{$WORD($wk, 7)}", "btn btn-default", "icon-plus", NULL, NULL, "minhon.member.showOrgSelectDialog();");
		$hOrgAddButton = "<span style=\"display: inline-block; margin: -1px 0 0 5px\">{$hOrgAddButton}</span>";
		
$html = <<< HTML
		<div class="form-reg">
			<div id="tabs_org">
				<ul>
					{$hTabs}
					{$hOrgAddButton}
				</ul>
				<div id="tab_org_common">
					<div class="row">
						<div class="col-xs-3">
							{$hInputSearch}
						</div>
					</div>
				</div>
					
				{$hTabContents}
			</div>
		</div>
HTML;
		
		$html .= $this->_dialogOrganizationSelect($arrOrganization);
		
		return $html;
	}
	
	function _dialogOrganizationSelect( $arrOrganization ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT_USER";
		
		$html = "";
		
		foreach ( $arrOrganization as $dataOrg ){
			$id              = $dataOrg["t_organization_id"];
			$name            = $dataOrg["t_organization_name"];
			$userOrgMgr      = $dataOrg["t_user_of_orgmgr"];
			$userInsttr      = $dataOrg["t_user_of_insttr"];
			$userNormal      = $dataOrg["t_user_of_normal"];
			$projectComplete = $dataOrg["t_project_of_complete"];
			$projectNormal   = $dataOrg["t_project_of_normal"];
			
			// 名前
			$hName = Printer::icon("icon-star", NULL, $name);
			// 組織管理者
			if ( count($userOrgMgr) > 0 ){
				$hMgrName = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE(DAO::T_USER_TYPE_ORGMGR), $userOrgMgr[0]);
			} else {
				$hMgrName = "";
			}
			// ユーザー数
			$hUserCount = array(
				Printer::icon("icon-user", NULL, count($userOrgMgr)+count($userInsttr)+count($userNormal)),
				Util::esc(count($userOrgMgr)),
				Util::esc(count($userInsttr)),
				Util::esc(count($userNormal)),
			);
			$hUserCount1 = $hUserCount[0];
			$hUserCount2 = " ( {$hUserCount[1]} / {$hUserCount[2]} / {$hUserCount[3]} ) ";
			
			// プロジェクト数
			$hProjectCount = array(
				Printer::icon("icon-th", NULL, count($projectComplete)+count($projectNormal)),
				Util::esc(count($projectNormal)),
				Util::esc(count($projectComplete))
			);
			$hProjectCount1 = $hProjectCount[0];
			$hProjectCount2 = " ( {$hProjectCount[1]} / {$hProjectCount[2]} ) ";
			
			$escID        = Util::esc($id);
			$escName      = Util::esc($name);
			$escUserCount = count($userOrgMgr) + count($userInsttr) + count($userNormal);
$html .= <<< HTML
			<tr data-org="{$escName}" data-org-id="{$escID}" data-user-count="{$escUserCount}">
				<td>{$hName}</td>
				<td>{$hMgrName}</td>
				<td class="col-tight col-join hidden-xs" style="text-align: right; font-size: 17px">{$hUserCount1}</td>
				<td class="col-tight hidden-xs">{$hUserCount2}</td>
				<td class="col-tight visible-xs">{$hUserCount1}{$hUserCount2}</td>
				<td class="col-tight col-join hidden-xs" style="text-align: right; font-size: 17px">{$hProjectCount1}</td>
				<td class="col-tight hidden-xs">{$hProjectCount2}</td>
				<td class="col-tight visible-xs">{$hProjectCount1}{$hProjectCount2}</td>
			</tr>
HTML;
		}
		
$html = <<< HTML
		<div id = "dialog_org">
			<table class="table">
				<thead>
					<th>{$WORD($wk, 8)}</th>
					<th>{$WORD($wk, 9)}</th>
					<th class="col-tight col-join">{$WORD($wk, 10)}</th>
					<th class="col-tight hidden-xs">({$WORD($wk, 11)} / {$WORD($wk, 12)} / {$WORD($wk, 13)})</th>
					<th class="col-tight col-join">{$WORD($wk, 14)}</th>
					<th class="col-tight hidden-xs">({$WORD($wk, 15)} / {$WORD($wk, 16)})</th>
				</thead>
				<tbody>
					{$html}
				</tbody>
			</table>
		</div>
		<div id="dialog_org_remove_check">
			<p>{$WORD($wk, 17)}</p>
			<ul>
			</ul>
			<p>{$WORD($wk, 18)}</p>
		</div>
HTML;
		
		return $html;
	}
	
	function formRoleTableRow( $dataUser, $arrProjectUser ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT_USER";
		
		$html = "";
		
		$arrRole = array();

		$orgName   = $dataUser["t_organization_name"];
		$userID    = $dataUser["t_user_id"];
		$userState = $dataUser["t_user_state"];
		$userType  = $dataUser["t_user_type"];
		$userName  = $dataUser["t_user_name"];
		
		$hUserName = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
		if ( $userState === DAO::T_USER_STATE_QUIT ){
			$hUserName = Printer::iconWarning("{$WORD($wk, 19)}").$hUserName;
		}
		
		foreach ( Task::ROLE_TABLE() as $role => $strRole ){
			$key = "{$userID}_{$role}";
			
			$checkClass = "";
			if ( $role === Task::ROLE_RPMG ){
				$checkClass = "class=\"isProjectManager\"";
			}
			$checkSelect = "";
			if ( is_array($arrProjectUser) && in_array($key, $arrProjectUser) ){
				$checkSelect = "checked=\"checked\"";
			}
			
			$element = "<input type=\"checkbox\" name=\"q_user_role[]\" value=\"{$key}\" {$checkClass} {$checkSelect} />";
			$element = Printer::link($element, "btn", NULL, NULL, NULL, "minhon.member.onClickUserRole(this, event);", NULL, FALSE);
			$arrRole[] = "<td>{$element}</td>";
		}
		$hRole = implode("\n", $arrRole);
		
		// 役割なしメンバー
		$hNoRoleInput = Printer::checkbox(NULL, "q_user_role[]", array("{$userID}_".Task::ROLE_INIT => ""), $arrProjectUser, array("class"=>"no_role"));
		
		// all-roleボタン
		$hButton = Printer::link(NULL, "btn btn-default", "icon-check", NULL, NULL, "minhon.member.onClickAllRole(this);", array("style" => "width:100%;"));
		
		$escOrgName  = Util::esc($orgName);
		$escUserID   = Util::esc($userID);
		$escUserName = Util::esc($userName);
$html .= <<< HTML
		<tr data-user="{$escUserName}" data-user-id="{$escUserID}" data-org="{$escOrgName}">
			<th class="user">{$hUserName}{$hNoRoleInput}</th>
			<th class="organization">{$escOrgName}</th>
			<th>{$hButton}</th>
			{$hRole}
		</tr>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: formRoleTable
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formRoleTable( $arrUser, $arrProjectUser ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT_USER";
		
		$html = "";
		
		// header
		$arrColGroup = array();
		$arrHead = array();
		foreach ( Task::ROLE_TABLE() as $role => $strRole ){
			$arrColGroup[] = "<colgroup></colgroup>";
			$arrHead[] = "<th class=\"role\"><div>" . Util::esc($strRole) . "</div></th>";
		}
		$hColGroup = implode("\n", $arrColGroup);
		$hHead = implode("\n", $arrHead);
		
		// role
		foreach ( $arrUser as $userID => $dataUser ){
			$html .= $this->formRoleTableRow($dataUser, $arrProjectUser);
		}
		
$html = <<< HTML
		<table class="table table-role">
			<colgroup></colgroup>
			<colgroup></colgroup>
			<colgroup></colgroup>
			{$hColGroup}
			<thead>
				<th></th>
				<th>{$WORD($wk, 20)}</th>
				<th>All-Role</th>
				{$hHead}
			</thead>
			<tbody>
				{$html}
			</tbody>
		</table>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: table
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function table( $projectID, $arrData ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT_USER";
		
		$auth = Auth::instance("project");
		$authUser = Auth::instance("user");
		
		$html = "";
		$arrUser = array();
		
		// まとめる
		foreach ( $arrData as $data ){
			$role     = $data["t_project_user_role"];
			$userID   = $data["t_user_id"];
			$userType = $data["t_user_type"];
			$userName = $data["t_user_name"];
			$orgID    = $data["t_organization_id"];
			$orgName  = $data["t_organization_name"];
			
			$arrUser[$userID]["type"]  = $userType;
			$arrUser[$userID]["name"]  = $userName;
			$arrUser[$userID]["orgID"] = $orgID;
			$arrUser[$userID]["org"]   = $orgName;
			if ( Validate::inKeyArray($role, Task::ROLE_TABLE()) ){
				$arrUser[$userID]["role"][] = $role;
			} else if (! isset($arrRole[$userID]["role"]) ){
				$arrUser[$userID]["role"] = array();
			}
		}
		
		foreach ( $arrUser as $userID => $user ){
			$userType = $user["type"];
			$userName = $user["name"];
			$orgID    = $user["orgID"];
			$orgName  = $user["org"];
			$role     = $user["role"];
			$roleCount = count($role);
			
			$hasToggle = ( count($role) > 1 );
			sort($role);
			$roleList = array();
			if ( count($role) > 0 ){
				foreach ( $role as $dataRole ){
					$hRoleList = Util::esc(Task::ROLE_TABLE($dataRole));
					if ( $dataRole === Task::ROLE_RPMG ){
						$hRoleList = "<b>{$hRoleList}</b>";
						array_unshift( $roleList, $hRoleList );
					} else {
						$roleList[] = $hRoleList;
					}
				}
			}
			
			// 名前
			if ( $authUser->read($userID, $orgID) ){
				$hUserName = Printer::link($userName, NULL, "icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), NULL, "minhon.member.onClickUserInfo(this)");
			} else {
				$hUserName = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
			}
			// 組織
			$hOrgName = Printer::icon("icon-star", NULL, $orgName);
			// タイプ
			$hUserType = DAO::T_USER_TYPE_TABLE($userType);
			// 役割カウント
			$hRoleCount = "<span class=\"badge\">" . Util::esc($roleCount) . "</span>";
			if ( $roleCount === 0 ){
				$hRoleCount = "";
			} else if ( $hasToggle ){
				$hRoleCount = Printer::link($hRoleCount, NULL, NULL, NULL, NULL, "minhon.common.onClickToggleCell(this)", NULL, NULL, FALSE);
			}
			
			// 役割省略
			$hRole = implode( array_slice($roleList, 0, 3), " / ");
			if ( count($roleList) > 3 ){
				$hRole .= Util::esc("...");
			}
			$hRoleClass = $hasToggle ? "" : "hidden";
			$hRoleToggle = Printer::link("{$WORD($wk, 21)}", "link-toggle", "icon-circle-arrow-right", NULL, NULL, "minhon.common.onClickToggleCell(this)");
			// 役割
			$hRoleList = Printer::uList($roleList, FALSE);
			$hRoleListClass = $hasToggle ? "hidden" : "";
			if ( count($roleList) > 1 ){
				$hRoleListToggle = Printer::link("{$WORD($wk, 22)}", "link-toggle", "icon-circle-arrow-left", NULL, NULL, "minhon.common.onClickToggleCell(this)");
			} else {
				$hRoleListToggle = "";
			}
			
			// 操作
			{
				$arrButton = array();
				// 編集
				if ( $auth->write_isMember($projectID, $orgID) ){
					$arrButton[] = Printer::link("{$WORD($wk, 23)}", NULL, "icon-pencil", NULL, "./edit.html?q_project_id={$projectID}&q_id={$userID}");
				}
				// 削除
				if ( $auth->write_isMember($projectID, $orgID) ){
					$arrButton[] = Printer::link("{$WORD($wk, 24)}", NULL, "icon-remove", NULL, NULL, "minhon.common.onClickPost('./delete.html', {q_project_id:{$projectID}, q_id:{$userID}}, '{$WORD($wk, 25)}');");
				}
				// 操作
				$hOperation = Printer::buttonGroup("{$WORD($wk, 26)}", $arrButton);
			}
			
$html .= <<< HTML
			<tr data-user-id="{$userID}">
				<td>{$hUserName}</td>
				<td>{$hOrgName}</td>
				<td>{$hUserType}</td>
				<td class="col-join col-tight">{$hRoleCount}</td>
				<td class="toggle-role {$hRoleClass}">{$hRole}</td>
				<td class="toggle-role {$hRoleListClass} list-none">{$hRoleList}</td>
				<td class="col-tight toggle-role-link {$hRoleClass}">{$hRoleToggle}</td>
				<td class="col-tight toggle-role-link {$hRoleListClass}">{$hRoleListToggle}</td>
				<td class="col-tight">{$hOperation}</td>
			</tr>
HTML;
		}
		
$html = <<< HTML
		<table class="table table-striped">
			<thead>
				<th>{$WORD($wk, 27)}</th>
				<th>{$WORD($wk, 28)}</th>
				<th>{$WORD($wk, 29)}</th>
				<th colspan="3">{$WORD($wk, 30)}</th>
				<th class="col-tight">{$WORD($wk, 31)}</th>
			</thead>
			<tbody>
				{$html}
			</tbody>
		</table>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: dialogUserInfo
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function dialogUserInfo(){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_PROJECT_USER";
		
$html = <<< HTML
		<div id="member_dialog_user_info">
			<div class="row form-group">
				<div class="col-xs-4">{$WORD($wk, 32)}</div>
				<div class="col-xs-8 value user_name"></div>
			</div>
			<div class="row form-group">
				<div class="col-xs-4">{$WORD($wk, 33)}</div>
				<div class="col-xs-8 value organization_name"></div>
			</div>
			<div class="row form-group">
				<div class="col-xs-4">{$WORD($wk, 34)}</div>
				<div class="col-xs-8 value user_type"></div>
			</div>
			<div class="row form-group">
				<div class="col-xs-4">{$WORD($wk, 35)}<br/>{$WORD($wk, 36)}</div>
				<div class="col-xs-8 value project"></div>
			</div>
		</div>
HTML;
		
		return $html;
	}

	function listProject( $arr ){
		$wk = "WORD_P_CLASS_VIEW_PROJECT_USER";
		
		$auth = Auth::instance("project");
		
		$html = "";
		$arrProject = array();
		
		// まとめる
		foreach ( $arr as $data ){
			$projectID = $data["t_project_id"];
			if ( ($projectName = DAO::storedFunction("get_project_name", $projectID)) === NULL ){
				continue;
			}
			if ( $auth->read($projectID) ){
				$hProjectName = Printer::link($projectName, NULL, "icon-th", NULL, "/content/project/detail.html?q_project_id={$projectID}", NULL, NULL, FALSE);
			} else {
				$hProjectName = Printer::icon("icon-th", NULL, $projectName);
			}
			$arrProject[$projectID] = "<p>".Printer::ellipsis($hProjectName, 20, FALSE)."</p>";
		}
		//krsort($arrProject);
		
		return implode("\n", $arrProject);
	}

}
