<?php require_once("class/View.php"); ?>
<?php
Class View_search extends View {
	
	/***************************************************************
	 * 名前: formSearchOptionTarget
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formSearchOptionTarget( $target ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SEARCH";
		
		$arrRadio = array(
			0 => "{$WORD($wk, 1)}",
			0 => "{$WORD($wk, 2)}",
		);
		$hOptTarget = Printer::radio("", "q_target", $arrRadio, 0, NULL, FALSE);
		
$html = <<< HTML
		<div class="form-group">
			<label class="col-xs-2 control-label">{$WORD($wk, 3)}</label>
			<div class="col-xs-8">
				{$hOptTarget}
			</div>
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: formSearchOptionSimilarity
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formSearchOptionSimilarity( $score ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SEARCH";
		
		$hOptScore = Printer::input("text", "q_score", "q_score", $score, "form-control text-right");
		$hOptScoreList = "";
		for ( $scoreval = 0.3; $scoreval <= 1; $scoreval+=0.1 ){
			$hOptScoreList .= "<li>".Printer::link(number_format($scoreval, 1), NULL, NULL, NULL, NULL, NULL, array("data-set-score" => $scoreval))."</li>";
		}
		
$html = <<< HTML
		<div class="form-group">
			<label class="col-xs-2 control-label" for="q_score">{$WORD($wk, 4)}</label>
			<div class="col-xs-8">
				<div class="input-group" style="width: 200px">
					{$hOptScore}
					<div class="input-group-btn">
						<a class="dropdown-toggle btn btn-default" data-toggle="dropdown" href="#"><span class="caret"></span></a>
						<ul class="dropdown-menu pull-right">
							{$hOptScoreList}
						</ul>
					</div>
				</div>
				<p class="help-block">{$WORD($wk, 5)}</p>
			</div>
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: tableDSearch
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tableDSearch( $arrData, $projectID ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SEARCH";
		
		$html = "";
		
		$prevDocumentID = 0;
		foreach ( $arrData as $dataDocumentText ){
			$documentTextID = $dataDocumentText["t_document_text_id"];
			$documentTextS  = $dataDocumentText["t_document_text_s"];
			$documentTextT  = $dataDocumentText["t_document_text_t"];
			$documentID     = $dataDocumentText["t_document_id"];
			$documentTitle  = $dataDocumentText["t_document_title"];
			
			$hDocumentTextID = Util::esc($documentTextID);
			$hDocumentTextS  = Util::esc($documentTextS);
			$hDocumentTextT  = Util::esc($documentTextT);
			$hDocumentID     = Util::esc($documentID);
			$hDocumentTitle  = Util::esc($documentTitle);
			
			if ( $documentID !== $prevDocumentID ){
				$hOpenLink = Printer::link("{$WORD($wk, 6)}", NULL, NULL, NULL, "/content/document/detail.html?&q_project_id={$projectID}&q_id={$documentID}", NULL, array("target"=>"_blank"));
				// 別の翻訳メモリに変わった場合はヘッダーを挿入する
$html .= <<< HTML
				<thead>
					<tr>
						<th colspan="2">
							<span>{$hDocumentTitle}</span>
							{$hOpenLink}
						</th>
					</tr>
				</thead>
HTML;
			}
			
$html .= <<< HTML
			<tr class="text">
				<td>{$hDocumentTextS}</td>
				<td>{$hDocumentTextT}</td>
			</tr>
HTML;
			$prevDocumentID = $documentID;
		}
		
$html = <<< HTML
		<div>
			<table class="table table-hover" id="table_dsearch" style="table-layout: fixed">
				{$html}
			</table>
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: tableBSearch
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tableBSearch( $arrData, $projectID ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SEARCH";
		
		$html = "";
		
		$kind = Term::KIND_BILINGUAL;
		
		$prevBilingualRootID = 0;
		foreach ( $arrData as $dataBilingual ){
			$bilingualID       = $dataBilingual["t_term_id"];
			$bilingualTextS    = $dataBilingual["t_term_text_s"];
			$bilingualTextT    = $dataBilingual["t_term_text_t"];
			$bilingualRootID   = $dataBilingual["t_term_root_id"];
			$bilingualRootName = $dataBilingual["t_term_root_name"];
			$userID            = $dataBilingual["t_user_id"];
			
			$hBilingualID       = Util::esc($bilingualID);
			$hBilingualTextS    = Util::esc($bilingualTextS);
			$hBilingualTextT    = Util::esc($bilingualTextT);
			$hBilingualRootName = Util::esc($bilingualRootName);
			
			if ( $bilingualRootID !== $prevBilingualRootID ){
				$hOpenLink = Printer::link("{$WORD($wk, 6)}", NULL, NULL, NULL, "/content/term/?q_kind={$kind}&q_project_id={$projectID}&q_id={$bilingualRootID}", NULL, array("target"=>"_blank"));
				// 別の翻訳メモリに変わった場合はヘッダーを挿入する
$html .= <<< HTML
				<thead>
					<tr>
						<th colspan="2">
							<span>{$hBilingualRootName}</span>
							{$hOpenLink}
						</th>
					</tr>
				</thead>
HTML;
			}
			
$html .= <<< HTML
			<tr class="text">
				<td>{$hBilingualTextS}</td>
				<td>{$hBilingualTextT}</td>
			</tr>
HTML;
			$prevBilingualRootID = $bilingualRootID;
		}
		
$html = <<< HTML
		<div>
			<table class="table table-hover" id="table_bsearch" style="table-layout: fixed">
				{$html}
			</table>
		</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: tableSimSearch
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tableSimSearch( $arrData ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_SEARCH";
		
		$html = "";
		
		mb_internal_encoding("UTF-8"); //mb_***
		
		foreach ( $arrData as $dataSim ){
			$source   = $dataSim["source"];
			$target   = $dataSim["target"];
			$score    = $dataSim["score"];
			$position = $dataSim["position"];
			$arrPosition = explode(",", $position);
			
			$hTarget   = Util::esc($target);
			$hScore    = Util::esc($score);
			
			// ハイライト
			$pos = 0;
			$arrSource = array();
			foreach ( $arrPosition as $position ){
				list($start, $length) = explode("-", $position);
				
				$before  = mb_substr($source, $pos, ( $start - $pos )); // ハイライト対象文字列の左に存在する文字列
				$current = mb_substr($source, $start, $length);         // ハイライト対象文字列
				
				$arrSource[] = Util::esc($before);
				$arrSource[] = "<span class=\"highlight\">" . Util::esc($current) . "</span>";
				
				$pos = $start + $length;
			}
			if ( $pos < mb_strlen($source) ){
				$after = mb_substr($source, $pos); // ハイライト対象文字列
				$arrSource[] = Util::esc($after);
			}
			$hSource = join("", $arrSource);
			
$html .= <<< HTML
			<tr class="text">
				<td class="col-xs-5">{$hSource}</td>
				<td class="col-xs-5">{$hTarget}</td>
				<td class="col-xs-2">{$hScore}</td>
			</tr>
HTML;
		}
		
$html = <<< HTML
		<div>
			<table class="table table-hover" id="table_simsearch">
				<thead>
					<tr>
						<th class="col-xs-5">{$WORD($wk, 7)}</th>
						<th class="col-xs-5">{$WORD($wk, 8)}</th>
						<th class="col-xs-2">{$WORD($wk, 9)}</th>
					</tr>
				</thead>
				<tbody>
					{$html}
				</tbody>
			</table>
		</div>
HTML;
		
		return $html;
	}
	
}
