<?php
Class View_statistics extends View {
	const TAB_TASK = 0;
	const TAB_BBS  = 1;
	const TAB_SYSTEM_TASK = 2;
	const TAB_SYSTEM_LOOKUP = 3;
	const TAB_SYSTEM_SELLOOKUP = 4;
	const TAB_SYSTEM_ORGTASK = 5;
	const TAB_SYSTEM_ORGLOOKUP = 6;
	const TAB_SYSTEM_ORGSELLOOKUP = 7;
	const TAB_SYSTEM_ORGANIZATION = 8;
	const TAB_SYSTEM_LOGIN = 9;

	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $tab, $auth, $projectID ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS";
		
		$html = FALSE;
		$query = array();
		
		$isSystem = NULL;
		$tabText = NULL;
		$arrPullDownKind = NULL;
		switch ( $tab ){
			//------------------------
			// タスク統計
			case self::TAB_TASK:
				$isSystem = FALSE;
				$tabText = "{$WORD($wk, 1)}";
				$arrPullDownKind = array(
					Statistics::KIND_TASK_USER,
					Statistics::KIND_TASK_DOCUMENT,
					Statistics::KIND_TASK_ROLE,
				);
				break;
			//------------------------
			// 掲示板統計
			case self::TAB_BBS:
				$isSystem = FALSE;
				$tabText = "{$WORD($wk, 2)}";
				$arrPullDownKind = array(
					Statistics::KIND_BBS_LOG,
					Statistics::KIND_BBS_FLOW_CHARTS,
					Statistics::KIND_BBS_BAR_GRAPH,
					Statistics::KIND_BBS_LINE_GRAPH,
				);
				break;
			//------------------------
			// タスク統計（システム）
			case self::TAB_SYSTEM_TASK:
				$isSystem = TRUE;
				$tabText = "{$WORD($wk, 3)}";
				$arrPullDownKind = array(
					Statistics::SYSTEM_KIND_TASK_PROJECT,
					Statistics::SYSTEM_KIND_TASK_DOCUMENT,
				);
				break;
			//------------------------
			// 辞書引き統計（システム）
			case self::TAB_SYSTEM_LOOKUP:
				$isSystem = TRUE;
				$tabText = "{$WORD($wk, 4)}";
				$arrPullDownKind = array(
					Statistics::SYSTEM_KIND_LOOKUP_TEXT,
					Statistics::SYSTEM_KIND_LOOKUP_PROJECT,
					Statistics::SYSTEM_KIND_LOOKUP_DOCUMENT,
				);
				break;
			//------------------------
			// 辞書引き選択統計（システム）
			case self::TAB_SYSTEM_SELLOOKUP:
				$isSystem = TRUE;
				$tabText = "{$WORD($wk, 5)}";
				$arrPullDownKind = array(
					Statistics::SYSTEM_KIND_SELLOOKUP_TEXT,
					Statistics::SYSTEM_KIND_SELLOOKUP_PROJECT,
					Statistics::SYSTEM_KIND_SELLOOKUP_DOCUMENT,
				);
				break;
			//------------------------
			// 全タスク統計（システム）
			case self::TAB_SYSTEM_ORGTASK:
				$isSystem = TRUE;
				$tabText = "{$WORD($wk, 6)}";
				$arrPullDownKind = array(
					Statistics::SYSTEM_KIND_ORGTASK_USER,
					Statistics::SYSTEM_KIND_ORGTASK_PROJECT,
					Statistics::SYSTEM_KIND_ORGTASK_DOCUMENT,
				);
				break;
			//------------------------
			// 全辞書引き統計（システム）
			case self::TAB_SYSTEM_ORGLOOKUP:
				$isSystem = TRUE;
				$tabText = "{$WORD($wk, 7)}";
				$arrPullDownKind = array(
					Statistics::SYSTEM_KIND_ORGLOOKUP_TEXT,
					Statistics::SYSTEM_KIND_ORGLOOKUP_PROJECT,
					Statistics::SYSTEM_KIND_ORGLOOKUP_DOCUMENT,
				);
				break;
			//------------------------
			// 全辞書引き選択統計（システム）
			case self::TAB_SYSTEM_ORGSELLOOKUP:
				$isSystem = TRUE;
				$tabText = "{$WORD($wk, 8)}";
				$arrPullDownKind = array(
					Statistics::SYSTEM_KIND_ORGSELLOOKUP_TEXT, 
					Statistics::SYSTEM_KIND_ORGSELLOOKUP_PROJECT, 
					Statistics::SYSTEM_KIND_ORGSELLOOKUP_DOCUMENT,
				);
				break;
			//------------------------
			// 組織情報
			case self::TAB_SYSTEM_ORGANIZATION:
				$isSystem = TRUE;
				$tabText = "";
				$arrPullDownKind = array(
					Statistics::SYSTEM_KIND_ORGANIZATION,
				);
				break;
			//------------------------
			// ログイン情報
			case self::TAB_SYSTEM_LOGIN:
				$isSystem = TRUE;
				$tabText = "";
				$arrPullDownKind = array(
					Statistics::SYSTEM_KIND_LOGIN,
				);
				break;
		}

		if ( is_array($arrPullDownKind) && count($arrPullDownKind) > 0 ){
			$arrPullDown = array();
			foreach ( $arrPullDownKind as $kind ){
				if ( ! $auth->process($kind, $projectID) ){
					continue;
				}
				
				if ( $isSystem ){
					$kindText = Statistics::SYSTEM_KIND_TABLE($kind);
				} else {
					$kindText = Statistics::KIND_TABLE($kind);
				}
				$query = array();
				$query["q_kind"] = $kind;
				if ( ! $isSystem ){
					$query["q_project_id"] = $projectID;
				}
				$arrPullDown[$kind] = $this->tabLink($kindText, NULL, NULL, NULL, "./", $query);
			}

			if ( count($arrPullDown) > 0 ){
				if ( count($arrPullDownKind) === 1 ){
					// 通常タブ
					$html = $arrPullDown[$arrPullDownKind[0]];
				} else {
					// プルダウンタブ
					$html = array(
						"title" => $tabText,
						"item"  => $arrPullDown,
					);
				}
			}
		}
		
		return $html;
	}
	
	const COLUMN_TYPE_LINK  = 0;
	const COLUMN_TYPE_LIST  = 1;
	const COLUMN_TYPE_COUNT = 2;
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	protected function getColumnName( $column ){
		return NULL;
	}
	
	protected function getColumnRequestName( $column ){
		return NULL;
	}
	
	protected function getColumnIcon( $column ){
		return NULL;
	}
	
	protected function getColumnData( $column, $DAOData ){
		// 初期値
		return array(
			"id"     => NULL,
			"text"   => NULL,
			"color"  => NULL,
			"isHtml" => NULL,
		);
	}
	
	protected function getHeaderTextCount(){
		return NULL;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明: cells
	 * 引数:
	 * 返値:
	****************************************************************/
	protected static function CreateElementCell( $value, $isEsc = TRUE ){
		if ( ! is_array($value) ){
			$value = array($value);
		}
		
		$html = "";
		foreach ( $value as $cvalue ){
			$hValue = $isEsc ? Util::esc($cvalue) : $cvalue;
$html .= <<< HTML
				<td>{$hValue}</td>
HTML;
		}
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明: cellsIcon
	 * 引数:
	 * 返値:
	****************************************************************/
	protected static function CreateElementIconCell( $value, $icon, $color = NULL ){
		$html = "";
		$hValue = is_null($value) ? "" : Printer::icon($icon, $color, $value);
$html .= <<< HTML
				<td>{$hValue}</td>
HTML;
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明: cellsToggle
	 * 引数:
	 * 返値:
	****************************************************************/
	protected static function CreateElementToggleCell( $arrValue, $isEsc = TRUE, $omitCount = 3 ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS";
		
		$count = count($arrValue);
		// トグル付きかどうか
		$hasToggle = ($count > 1);
		
		// カウント
		$hCount = Util::esc($count);
		$hCount = "<span class=\"badge\">{$hCount}</span>";
		if ( $hasToggle ){
			$hCount = Printer::link($hCount, NULL, NULL, NULL, NULL, "minhon.common.onClickToggleCell(this)", NULL, FALSE);
		}
		
		if ( $isEsc ){
			foreach ( $arrValue as &$value ){
				$value = Util::esc($value);
			}
		}
		
		// 省略
		$hValue = implode( array_slice($arrValue, 0, $omitCount), " / ");
		$hValueClass = $hasToggle ? "" : "hidden";
		if ( $count > 3 ){
			$hValue .= Util::esc("...");
		}
		if ( $count > 1 ){
			$hValueLink = Printer::link("{$WORD($wk, 9)}", "link-toggle", "icon-circle-arrow-right", NULL, NULL, "minhon.common.onClickToggleCell(this)");
		} else {
			$hValueLink = "";
		}
		
		// リスト
		$hList = Printer::uList($arrValue, FALSE);
		$hListClass = $hasToggle ? "hidden" : "";
		if ( $count > 1 ){
			$hListLink = Printer::link("{$WORD($wk, 10)}", "link-toggle", "icon-circle-arrow-left", NULL, NULL, "minhon.common.onClickToggleCell(this)");
		} else {
			$hListLink = "";
		}
		
$html = <<< HTML
				<td class="col-join col-tight">{$hCount}</td>
				<td class="toggle-role {$hValueClass}">{$hValue}</td>
				<td class="toggle-role {$hListClass} list-none">{$hList}</td>
				<td class="col-tight toggle-role-link {$hValueClass}">{$hValueLink}</td>
				<td class="col-tight toggle-role-link {$hListClass}">{$hListLink}</td>
HTML;
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明: cellsLink
	 * 引数:
	 * 返値:
	****************************************************************/
	protected static function CreateElementLinkCell( $value, $icon, $arrArgs, $isNumeric = FALSE, $isEsc = TRUE ){
		$html = "";
		$hLink = Printer::link($value, NULL, $icon, NULL, "./?".http_build_query($arrArgs), NULL, NULL, $isEsc);
		if ( ! $isNumeric ){
$html .= <<< HTML
				<td class="col-tight">{$hLink}</td>
HTML;
		} else {
$html .= <<< HTML
				<td class="col-tight large-font" style="text-align: center">{$hLink}</td>
HTML;
		}
			
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明: cellsCount
	 *       詳細リンクは詳細数を表示させる
	 * 引数:
	 * 返値:
	****************************************************************/
	protected static function CreateElementDetailLinkCell( $count, $arrArgs, $isEsc = TRUE ){
		$html = "";
		$hCount = Printer::link($count, NULL, NULL, NULL, "./detail.html?".http_build_query($arrArgs), NULL, NULL, $isEsc);
$html .= <<< HTML
				<td class="col-tight large-font" style="text-align: center">{$hCount}</td>
HTML;
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明: 内部
	 * 引数:
	 * 返値:
	 ****************************************************************/
	private $_dataValue = NULL;
	
	private function _dataClear(){
		$this->_dataValue = array();
	}
	private function _dataGet( $mainColumn, $subColumn, $column, $id = NULL ){
		if ( isset($this->_dataValue[$mainColumn][$subColumn][$column]) ){
			if ( ! is_null($id) ){
				// テキスト
				return $this->_dataValue[$mainColumn][$subColumn][$column][$id];
			} else {
				// 配列
				return $this->_dataValue[$mainColumn][$subColumn][$column];
			}
		} else {
			return FALSE;
		}
	}
	private function _dataSet( $mainColumnID, $subColumnID, $column, $columnData ){
		if ( $columnData && $columnData["id"] && $columnData["text"] ){
			$id   = $columnData["id"];
			$text = $columnData["text"];
			$this->_dataValue[$mainColumnID][$subColumnID][$column][$id] = $text;
		} else {
			return FALSE;
		}
	}
	private function _dataValid(){
		return ( count($this->_dataValue) > 0 );
	}
	private function _dataIncrement( $mainColumnID, $subColumnID ){
		if ( ! isset($this->_dataValue[$mainColumnID][$subColumnID]["data-count"]) ){
			$this->_dataValue[$mainColumnID][$subColumnID]["data-count"] = 0;
		}
		$this->_dataValue[$mainColumnID][$subColumnID]["data-count"] += 1;
	}
	private function _dataGetCount( $mainColumnID, $subColumnID ){
		return $this->_dataValue[$mainColumnID][$subColumnID]["data-count"];
	}
	
	protected function isSkipColumn( $column ){
		$columnName = $this->getColumnName($column);
		return ( strlen($columnName) === 0 );
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	protected function table( &$result, $arrData, $mainColumn, $subColumn, $arrColumn ){
		$this->_dataClear();
		
		//-----------------------------------
		// データをまとめる
		//-----------------------------------
		foreach ( $arrData as $data ){
			// mainColumn
			$mcValid = FALSE;
			if ( $mcData = $this->getColumnData($mainColumn, $data)) {
				if ( is_null($mcData["id"]) || is_null($mcData["text"]) ){
				} else {
					$mcID = $mcData["id"];
					$arrMCData[$mcID] = $mcData;
					$mcValid = TRUE;
				}
			}
			if ( ! $mcValid ){
				continue;
			}
			// subColumn
			$scValid = FALSE;
			if ( $scData = $this->getColumnData($subColumn,  $data)) {
				if ( is_null($scData["id"]) || is_null($scData["text"]) ){
				} else {
					$scID = $scData["id"];
					$arrSCData[$scID] = $scData;
					$scValid = TRUE;
				}
			}
			if ( ! $scValid ){
				continue;
			}
			
			// 数
			$this->_dataIncrement($mcID, $scID);
			
			// 値
			foreach ( $arrColumn as $col => $colType ){
				$columnData = $this->getColumnData($col, $data);
				$this->_dataSet($mcID, $scID, $col, $columnData);
			}
		}
		if ( ! $this->_dataValid() ){
			$result = RES_NO_DATA;
			return;
		}
		
		//-----------------------------------
		// Body
		//-----------------------------------
		$htmlBody = "";
		foreach ( $this->_dataValue as $mcID => $arrSubDataValue ){ // row
			// mainColumn
			if ( $mcRequestName = $this->getColumnRequestName($mainColumn) ){
				$data = $arrMCData[$mcID];
				if ( isset($data["isHtml"]) && $data["isHtml"] === TRUE ){
					$mcCell = self::CreateElementCell($data["text"], FALSE );
				} else {
					$iconColor = isset($data["color"]) ? $data["color"] : NULL;
					$mcCell = self::CreateElementIconCell($data["text"], $this->getColumnIcon($mainColumn), $iconColor);
				}
			}
			
			foreach ( $arrSubDataValue as $scID => $arrColumnDataValue ){
				$arrLinkURL = $_GET + $_POST;
				$arrCell    = array();
				if ( $mcRequestName ){
					$arrLinkURL[$mcRequestName] = $mcID;
					$arrCell[] = $mcCell;
				}
				
				// subColumn
				if ( $scRequestName = $this->getColumnRequestName($subColumn) ){
					$data = $arrSCData[$scID];
					if ( isset($data["isHtml"]) && $data["isHtml"] === TRUE ){
						$scCell = self::CreateElementCell($data["text"], FALSE );
					} else {
						$iconColor = isset($data["color"]) ? $data["color"] : NULL;
						$scCell = self::CreateElementIconCell($data["text"], $this->getColumnIcon($subColumn), $iconColor);
					}
					//
					$arrLinkURL[$scRequestName] = $scID;
					$arrCell[] = $scCell;
				}
				
				// 数
				$arrCell[] = self::CreateElementDetailLinkCell($this->_dataGetCount($mcID, $scID), $arrLinkURL);
				
				foreach ( $arrColumn as $col => $colType ){ // column
					$arrLinkURL["q_sub"] = $col;
					switch ( $colType ){
						case self::COLUMN_TYPE_LINK:
							$arrCell[] = self::CreateElementLinkCell($this->getColumnName($col), $this->getColumnIcon($col), $arrLinkURL);
							break;
						case self::COLUMN_TYPE_LIST:
							if ( $data = $this->_dataGet($mcID, $scID, $col) ){
								$arrCell[] = self::CreateElementToggleCell($data);
							} else {
								$arrCell[] = self::CreateElementCell(array("", ""));
							}
							break;
						case self::COLUMN_TYPE_COUNT:
							$arrCell[] = self::CreateElementLinkCell(count($this->_dataGet($mcID, $scID, $col)), NULL, $arrLinkURL, TRUE);
							break;
					}
				}
				
				$htmlBody .= "<tr>\n" . implode("\n", $arrCell) . "\n<tr>\n";
			}
		}
		
		//-----------------------------------
		// Header
		//-----------------------------------
		$htmlHeader = "";
		if ( ! $this->isSkipColumn($mainColumn) ){
			$htmlHeader .= "<th>". $this->getColumnName($mainColumn) . "</th>\n";
		}
		if ( ! $this->isSkipColumn($subColumn) ){
			$htmlHeader .= "<th>". $this->getColumnName($subColumn) . "</th>\n";
		}
		{ //詳細数
			$htmlHeader .= "<th class=\"col-tight\">" . $this->getHeaderTextCount() . "</th>\n";
		}
		foreach ( $arrColumn as $col => $colType ){
			switch ( $colType ){
				case self::COLUMN_TYPE_LINK:
					$htmlHeader .= "<th class=\"col-tight\"></th>\n";
					break;
				case self::COLUMN_TYPE_LIST:
					$htmlHeader .= "<th colspan=\"3\">" . $this->getColumnName($col) . "</th>\n";
					break;
				case self::COLUMN_TYPE_COUNT:
					$htmlHeader .= "<th class=\"col-tight\">" . $this->getColumnName($col) . "</th>\n";
					break;
			}
		}
		
$html = <<< HTML
		<table class="table">
			<thead>
				<tr>
					{$htmlHeader}
				</tr>
			</thead>
			<tbody>
				{$htmlBody}
			</tbody>
		</table>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	protected function detail( $arrData, $arrPriorityColumn, $arrColumn ){
		$arrColumn = array_unique(array_merge($arrPriorityColumn, $arrColumn));
		
		//----------------------------------
		// Body
		//----------------------------------
		$htmlBody = "";
		foreach ( $arrData as $data ){
			$hColumn = "";
			foreach ( $arrColumn as $column ){
				$value  = NULL;
				$hValue = NULL;
				$color  = NULL;
				
				if ( $columnData = $this->getColumnData( $column, $data ) ){
					if ( isset($columnData["isHtml"]) && $columnData["isHtml"] === TRUE ){
						$hColumn .= self::CreateElementCell($columnData["text"], FALSE);
					} else {
						$iconColor = isset($columnData["color"]) ? $columnData["color"] : NULL;
						$hColumn .= self::CreateElementIconCell($columnData["text"], $this->getColumnIcon($column), $iconColor);
					}
				}
			}
			
			$htmlBody .= "<tr>\n{$hColumn}\n<tr>\n";
		}
		
		//----------------------------------
		// Header
		//----------------------------------
		$htmlHeader = "";
		foreach ( $arrColumn as $column ){
			$htmlHeader .= "<th>" . $this->getColumnName($column) . "</th>\n";
		}
		
$html = <<< HTML
		<table class="table">
			<thead>
				<tr>
					{$htmlHeader}
				</tr>
			</thead>
			<tbody>
				{$htmlBody}
			</tbody>
		</table>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	private function download( $arrData, $arrPriorityColumn, $arrColumn ){
		$arrColumn = array_unique(array_merge($arrPriorityColumn, $arrColumn));
		
		foreach ( $arrData as $data ){
			$arrTSV = array();
			
			foreach ( $arrColumn as $column ){
				$columnData = $this->getColumnData( $column, $data );
				$arrTSV[] = preg_replace("/\t|\r|\r/", "", $columnData["text"]);
			}
			
			echo implode("\t", $arrTSV) . "\r\n";
		}
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public function tableSystemStatisticByOrganizationInfo( $arrOrgData ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS";
		
		$html = "";
		
		$minUserCount   = PHP_INT_MAX;
		$maxUserCount   = -1;
		$totalUserCount = 0;
		
		$minProjectCount   = PHP_INT_MAX;
		$maxProjectCount   = -1;
		$totalProjectCount = 0;
		
		$orgCount = count($arrOrgData);
		
		foreach( $arrOrgData as $data ){
			$userCount = $data["t_user_count"];
			$projectCount = $data["t_project_count"];
			
			$minUserCount    = ($userCount < $minUserCount) ? $userCount : $minUserCount;
			$maxUserCount    = ($maxUserCount < $userCount) ? $userCount : $maxUserCount;
			$totalUserCount += $userCount;
			$minProjectCount    = ($projectCount < $minProjectCount) ? $projectCount : $minProjectCount;
			$maxProjectCount    = ($maxProjectCount < $projectCount) ? $projectCount : $maxProjectCount;
			$totalProjectCount += $projectCount;
		}
		
		if ( $orgCount > 0 ){
			$avgUserCount = $totalUserCount / $orgCount;
			$avgProjectCount = $totalProjectCount / $orgCount;
		} else {
			$minUserCount = 0;
			$maxUserCount = 0;
			$avgUserCount = "NAN";
			$minProjectCount = 0;
			$maxProjectCount = 0;
			$avgProjectCount = "NAN";
		}
		
$html = <<< HTML
	<div class="col-xs-8">
		<div class="panel panel-default">
			<div class="panel-heading">{$WORD($wk, 11)}</div>
			<div class="panel-body">
				<div class="text-right" style="font-weight: bold"><span style="margin-right: 1em;">{$WORD($wk, 12)}</span>{$orgCount}</span>
			</div>
		</div>
	</div>
	<table class="table">
		<thead>
			<tr>
				<th></th>
				<th>{$WORD($wk, 13)}</th>
				<th>{$WORD($wk, 14)}</th>
				<th>{$WORD($wk, 15)}</th>
			</tr>
		</thead>
		<tbody>
			<tr>
				<td class="col-tight">{$WORD($wk, 16)}</td>
				<td>{$minUserCount}</td>
				<td>{$maxUserCount}</td>
				<td>{$avgUserCount}</td>
			</tr>
			<tr>
				<td class="col-tight">{$WORD($wk, 17)}</td>
				<td>{$minProjectCount}</td>
				<td>{$maxProjectCount}</td>
				<td>{$avgProjectCount}</td>
			</tr>
		</tbody>
	</table>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	public function tableSystemStatisticByLoginInfo( $arrData ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS";
		
		$html = "";
		
		foreach( $arrData as $data ){
			$userID    = $data["t_user_id"];
			$userName  = $data["t_user_name"];
			$loginDate = $data["t_login_date"];
			
			$hUserName = Printer::link($userName, NULL, "icon-user", NULL, "./?".http_build_query(array("q_kind"=>Statistics::SYSTEM_KIND_LOGIN, "q_user_id"=>$userID)));
			$hLoginDate = Util::esc($loginDate);
			
$html .= <<< HTML
			<tr>
				<td>{$hUserName}</td>
				<td>{$hLoginDate}</td>
			</tr>
HTML;
		}
$html = <<< HTML
	<table class="table">
		<thead>
			<tr>
				<th>{$WORD($wk, 18)}</th>
				<th>{$WORD($wk, 19)}</th>
			</tr>
		</thead>
		<tbody>
			{$html}
		</tbody>
	</table>
HTML;
		
		return $html;
	}
	
}
