<?php require_once("class/View/View_statistics.php"); ?>
<?php
Class View_statistics_bbspost extends View_statistics {
	// function detail()
	const COLUMN_NONE     = 0;
	const COLUMN_USER     = 1;
	const COLUMN_TYPE     = 2;
	const COLUMN_ROLE     = 3;
	const COLUMN_TITLE    = 4;
	// function detail()
	const COLUMN_TARGET   = 5;
	const COLUMN_DATE     = 6;
	
	private function COLUMN_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS_BBSPOST";
		
		$arrValue = array(
			self::COLUMN_NONE   => "",
			self::COLUMN_USER   => "{$WORD($wk, 1)}",
			self::COLUMN_TYPE   => "{$WORD($wk, 2)}",
			self::COLUMN_ROLE   => "{$WORD($wk, 3)}",
			self::COLUMN_TITLE  => "{$WORD($wk, 4)}",
			self::COLUMN_TARGET => "{$WORD($wk, 5)}",
			self::COLUMN_DATE   => "{$WORD($wk, 6)}",
		);
		return is_null($key) ? $arrValue : $arrValue[$key];
	}

	/****************************************************************************************************************
	 * override
	 ****************************************************************************************************************/
	protected function getHeaderTextCount(){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS_BBSPOST";
		
		return "{$WORD($wk, 7)}";
	}
	
	protected function getColumnName( $column ){
		return $this->COLUMN_TABLE($column);
	}
	
	protected function getColumnRequestName( $column ){
		$arrValue = array(
			self::COLUMN_NONE   => NULL,
			self::COLUMN_USER   => "q_user_id",
			self::COLUMN_TYPE   => NULL,
			self::COLUMN_ROLE   => NULL,
			self::COLUMN_TITLE  => NULL,
			self::COLUMN_TARGET => NULL,
			self::COLUMN_DATE   => NULL,
		);
		return is_null($key) ? $arrValue : $arrValue[$key];
	}
	
	protected function getColumnIcon( $column ){
		$arrValue = array(
			self::COLUMN_NONE   => NULL,
			self::COLUMN_USER   => "icon-user",
			self::COLUMN_TYPE   => NULL,
			self::COLUMN_ROLE   => "icon-start",
			self::COLUMN_TITLE  => NULL,
			self::COLUMN_TARGET => "icon-user",
			self::COLUMN_DATE   => "icon-time",
		);
		return is_null($column) ? $arrValue : $arrValue[$column];
	}
	
	protected function getColumnData( $column, $data ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS_BBSPOST";
		
		$ret = parent::getColumnData($column, $data);
		
		switch ( $column ){
			case self::COLUMN_NONE:
				$ret["id"]    = 0;
				$ret["text"]  = "";
				break;
			case self::COLUMN_USER:
				$ret["id"]    = $data["t_user_id"];
				$ret["text"]  = $data["t_user_name"];
				$ret["color"] = DAO::T_USER_TYPE_COLOR_TABLE($data["t_user_type"]);
				break;
			case self::COLUMN_TYPE:
				$ret["text"]  = DAO::T_BBS_POST_TYPE_TABLE($data["t_bbs_post_type"]);
				break;
			case self::COLUMN_ROLE:
				$ret["text"]  = TASK::ROLE_TABLE($data["t_bbs_post_role"]);
				break;
			case self::COLUMN_TITLE:
				$ret["text"]  = $data["t_bbs_post_title"];
				break;
			case self::COLUMN_TARGET:
				if ( isset($data["t_bbs_post_target_user_id"]) && $data["t_bbs_post_target_user_id"] === 0 ){
					$ret["text"] = "{$WORD($wk, 8)}";
				} else {
					$value1 = isset($data["t_bbs_post_target_user_name"]) ? $data["t_bbs_post_target_user_name"]              : "???";
					$value2 = isset($data["t_bbs_post_target_role"])      ? TASK::ROLE_TABLE($data["t_bbs_post_target_role"]) : "???";
					//
					$ret["text"] = "{$value1} - {$value2}";
				}
				break;
			case self::COLUMN_DATE:
				$ret["text"] = $data["t_bbs_post_register"];
				break;
			default:
				return FALSE;
		}
		
		return $ret;
	}
	
	
	/****************************************************************************************************************
	 * table
	 ****************************************************************************************************************/
	
	/****************************************************************************************************************
	 * detail
	 ****************************************************************************************************************/
	function tableDetailBbsPostByProject( $arrData, $arrPriorityColumn ){
		$column = array(
			self::COLUMN_USER,
			self::COLUMN_ROLE,
			self::COLUMN_TYPE,
			self::COLUMN_TITLE,
			self::COLUMN_TARGET,
			self::COLUMN_DATE,
		);
		return $this->detail( $arrData, $arrPriorityColumn, $column);
	}
	function tableDetailBbsPostByProjectDownload( $arrData, $arrPriorityColumn ){
		$column = array(
			self::COLUMN_USER,
			self::COLUMN_ROLE,
			self::COLUMN_TYPE,
			self::COLUMN_TITLE,
			self::COLUMN_TARGET,
			self::COLUMN_DATE,
		);
		$this->download( $arrData, $arrPriorityColumn, $column);
	}
	
	/****************************************************************************************************************
	 * その他
	 ****************************************************************************************************************/
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function graphBbsPostTransition( $projectID ){
		$html = "";
		
		$arrTransitionStage = array(
			DAO::T_BBS_POST_STAGE_PREPARE,
			DAO::T_BBS_POST_STAGE_TRANSLATE,
			//DAO::T_BBS_POST_STAGE_QA,
		);
		foreach ( $arrTransitionStage as $stage ){
			$graph = new Graph(Graph::KIND_TRANSITION, $projectID, $stage);
			if ( $graph->fileExists() ){
				$hTitle = Printer::title( DAO::T_BBS_POST_STAGE_TABLE($stage) );
				$kind = Graph::KIND_TRANSITION;
$html .= <<< HTML
<div class="graph">
	{$hTitle}
	<img src="/app/graphController.php?q_kind={$kind}&q_id={$projectID}&q_option={$stage}" alt="graph" height="500px" />
</div>
HTML;
			}
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function graphBbsPostBar( $arrData ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS_BBSPOST";
		
		$arrHtmlData = array(
			DAO::T_BBS_POST_STAGE_COMMIT    => array(),
			DAO::T_BBS_POST_STAGE_PREPARE   => array(),
			DAO::T_BBS_POST_STAGE_TRANSLATE => array(),
			//DAO::T_BBS_POST_STAGE_QA        => array(),
			DAO::T_BBS_POST_STAGE_RESUPDATE => array(),
			DAO::T_BBS_POST_STAGE_SIGNOFF   => array(),
			DAO::T_BBS_POST_STAGE_OTHERS    => array(),
		);
		
		//-----------------------------------------
		// ステージごとのヘッダーを作成
		//-----------------------------------------
		foreach ( $arrHtmlData as $stage => &$arr ){
			$hStage = DAO::T_BBS_POST_STAGE_TABLE($stage);
$arr[] = <<< HTML
			<td data-stage-type="{$stage}">{$hStage}</td>
HTML;
		}
		
		//-----------------------------------------
		// データをステージ毎に分ける
		//  $arrHtmlData[col][row]
		//-----------------------------------------
		foreach ( $arrData as $data ){
			$stage = $data["t_bbs_post_stage"];
			$type  = $data["t_bbs_post_type"];
			$role  = $data["t_bbs_post_role"];
			
			if ( ! isset($arrHtmlData[$stage]) ){
				continue;
			}
			
			$hRole = TASK::ROLE_TABLE($role);
$arrHtmlData[$stage][] = <<< HTML
			<td data-bbs-post-type="{$type}">{$hRole}</td>
HTML;
		}
		
		//-----------------------------------------
		// データの縦数と横数（ステージ数）
		//-----------------------------------------
		$dataRowCount = 0;
		$dataColCount = count($arrHtmlData);
		foreach ( $arrHtmlData as $arrHtml ){
			if ( $dataRowCount < count($arrHtml) ){
				$dataRowCount = count($arrHtml);
			}
		}
		
		//-----------------------------------------
		// データ描画
		//-----------------------------------------
		$hArrData = array();
		for ( $y = 0; $y < $dataRowCount; $y++ ){
			$htmlRow = "";
			foreach ( $arrHtmlData as $stage => $arrCell ){
				if ( isset($arrCell[$y]) ){
					$htmlRow .= $arrCell[$y];
				} else {
					$htmlRow .= "<td></td>";
				}
			}
			$hArrData[] = "<tr>{$htmlRow}</tr>";
		}
		$hArrData = array_reverse($hArrData);
		$hData = implode("\r\n", $hArrData);
		
		//-----------------------------------------
		// テンプレート(ROLE)
		//-----------------------------------------
		$hArrRole = array();
		$arrBoldRoles = array(TASK::ROLE_RRES, TASK::ROLE_RTMG, TASK::ROLE_RTRA, TASK::ROLE_RREV, TASK::ROLE_RRVW, TASK::ROLE_RPFR);
		foreach ( TASK::ROLE_TABLE() as $role => $roleText ){
			$class = "";
			if ( in_array($role, $arrBoldRoles) ){
				$class = " class=\"bold\"";
			}
			$hArrRole[] = "<tr><td{$class}>{$roleText}</td></tr>";
		}
		$hRoleHeader = "<tr><th>{$WORD($wk, 9)}</th></tr>";
		$hRole       = implode("\r\n", $hArrRole);
		
		//-----------------------------------------
		// テンプレート(DIALOG ACTS)
		//-----------------------------------------
		$hArrDialogActs = array();
		$arrActs = DAO::T_BBS_POST_TYPE_GROUP_TO_TYPE_TABLE();
		$dialogActsColSpan = count($arrActs);
		$arrActsHorizontal = array();
		$x = 0;
		foreach ( $arrActs as $typeGroup => $arrCells ){
			$actsText = DAO::T_BBS_POST_TYPE_GROUP_TABLE($typeGroup);
			$actsText = "{$WORD($wk, 10, $actsText)}";
			$y = 0;
			// Header
			$arrActsHorizontal[$y++][$x] = "<td>{$actsText}</td>";
			foreach ( $arrCells as $bbsPostType => $bbsPostTypeText ){
				$bbsPostTypeText = mb_substr($bbsPostTypeText, mb_strlen($actsText));
				$arrActsHorizontal[$y++][$x] = "<td data-bbs-post-type=\"{$bbsPostType}\">{$bbsPostTypeText}</td>";
			}
			while ( $y < $dialogActsColSpan+1 ){
				$arrActsHorizontal[$y++][$x] = "<td></td>";
			}
			$x++;
		}
		foreach ( $arrActsHorizontal as $row => $arrTableData ){
			$hRow = "";
			foreach ( $arrTableData as $col => $hCell ){
				$hRow .= $hCell;
			}
			$hArrDialogActs[] = "<tr>{$hRow}</tr>";
		}
		$hDialogActsHeader = "<tr><th colspan=\"{$dialogActsColSpan}\">{$WORD($wk, 11)}</th></tr>";
		$hDialogActs       = implode("\r\n", $hArrDialogActs);
		
		//-----------------------------------------
		// 表の座標軸の説明
		//-----------------------------------------
		// Y軸
		$yAxisCount = $dataRowCount + 1;
		$dataCellsHeight = 24 * $yAxisCount;
$htmlYAxis = <<< HTML
			<td rowspan="{$yAxisCount}" class="axis_label axis_y_label">
				<div class="rotate">
					<div class="rotate_container" style="width: {$dataCellsHeight}px; height: {$dataCellsHeight}px">
						{$WORD($wk, 12)}
						<div class="hr" />
					</div>
				</div>
			</td>
			<td colspan="{$dataColCount}" class="axis_spacing"></td>
HTML;
		
		// x軸
$htmlXAxis = <<< HTML
			<td class="axis_label axis_x_label axis_y_label"></td>
			<td colspan="{$dataColCount}" class="axis_label axis_x_label">
				<div class="hr" />
				{$WORD($wk, 13)}
			</td>
HTML;
		
		//-----------------------------------------
		// グラフ描画
		//-----------------------------------------
$html = <<< HTML
<div id="graph_bar" class="graph">
	<div id="graph_bar_main">
		<table id="graph_bar">
			<tbody>
				<tr>{$htmlYAxis}</tr>
				{$hData}
				<tr>{$htmlXAxis}</tr>
			</tbody>
		</table>
	</div>
	<div id="graph_bar_legend">
		<div>
		<table>
			<thead>
				{$hRoleHeader}
			</thead>
			<tbody>
				{$hRole}
			</tbody>
		</table>
		</div>
		<div>
		<table class="fixed">
			<thead>
				{$hDialogActsHeader}
			</thead>
			<tbody>
				{$hDialogActs}
			</tbody>
		</table>
		</div>
	</div>
</div>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数: interval (hour) 初期値は0.5hour(=30分)が1となる
	 * 返値:
	****************************************************************/
	function graphBbsPostLine( $arrData, $dialogActs = NULL, $interval = 0.5 ){
		$html = "";
		
		$arrFilterBbsPostType = NULL;
		if ( Validate::inKeyArray($dialogActs, DAO::T_BBS_POST_TYPE_GROUP_TABLE()) ){
			$arrFilterBbsPostType = array_keys(DAO::T_BBS_POST_TYPE_GROUP_TO_TYPE_TABLE($dialogActs));
		}
		
		// インターバルを秒に直す
		$intervalUnit = $interval * 60 * 60;
		
		// 役割の数(=線数)
		$arrRoleOrder = array( TASK::ROLE_RREQ, TASK::ROLE_RPMG, TASK::ROLE_RTMG, TASK::ROLE_RRES, TASK::ROLE_RTRA, TASK::ROLE_RREV, TASK::ROLE_RRVW, TASK::ROLE_RPFR );
		
		$startDate = PHP_INT_MAX;
		$endDate   = -PHP_INT_MAX;
		foreach ( $arrData as $data ){
			$date = strtotime($data["t_bbs_post_register"]);
			$startDate = min($date, $startDate);
			$endDate   = max($date, $endDate);
		}
		$startDate = $startDate - ($startDate % $intervalUnit);
		$endDate   = $endDate - ($endDate % $intervalUnit) + $intervalUnit;
		
		$maxXValue = abs($endDate - $startDate) / $intervalUnit;
		
		$arrGraph = array();
		// 値を取得
		foreach ( $arrData as $data ){
			$type = $data["t_bbs_post_type"];
			$role = $data["t_bbs_post_role"];
			$date = strtotime($data["t_bbs_post_register"]);
			if ( ! is_null($arrFilterBbsPostType) && array_search($type, $arrFilterBbsPostType) === FALSE ){
				continue;
			}
			if ( ($roleOrder = array_search($role, $arrRoleOrder)) !== FALSE ){
				$xValue = ($date - $startDate) / $intervalUnit;
				// $arrGraph[ 線 ][ 印 ]
				$arrGraph[$roleOrder][$type][] = $xValue;
			}
		}
		// 値の並び替え
		foreach ( $arrGraph as $roleOrder => &$arrBbsPostType ){
			ksort( $arrBbsPostType ); //key(BbsPostType)で並び替え
			foreach ( $arrBbsPostType as $bbsPostType => &$arrXValue ){
				asort( $arrXValue ); // value(時間軸)で並び替え
			}
			unset($arrXValue);
		}
		unset($arrBbsPostType);
		
		// Javascript用に変換
		$hData = "";
		foreach ( $arrGraph as $roleOrder => $arrLineValue ){
			$hRole = Util::esc(TASK::ROLE_TABLE($arrRoleOrder[$roleOrder]));
			
			$arrMarks = array();
			foreach ( $arrLineValue as $bbsPostType => $arrXValue ){
				$hBbsPostType = Util::esc(DAO::T_BBS_POST_TYPE_TABLE($bbsPostType));
				$arrMarks[] = "'{$hBbsPostType}' : [".implode(", ", $arrXValue)."]";
			}
			$hMarks = implode(",\n\t\t\t\t", $arrMarks);
			
$hData .= <<< HTML
			data["{$hRole}"] = {
				{$hMarks}
			};

HTML;
		}
		
		// 線情報
		$arrLineOption = array();
		foreach ( $arrRoleOrder as $role ){
			$hRole      = Util::esc(TASK::ROLE_TABLE($role));
			$hRoleColor = TASK::ROLE_COLOR_TABLE($role);
			$arrLineOption[] = "{label: '{$hRole}', color: '{$hRoleColor}'}";
		}
		$hLineOption = implode(",\n\t\t\t\t", $arrLineOption);
		
		// マーク情報
		$arrMarkOption = array();
		foreach ( DAO::T_BBS_POST_TYPE_TABLE() as $bbsPostType => $text ){
			$hBbsPostType      = Util::esc($text);
			$hBbsPostMarkStyle = DAO::T_BBS_POST_TYPE_MARK_TABLE($bbsPostType);
			$hBbsPostMarkColor = DAO::T_BBS_POST_TYPE_MARK_COLOR_TABLE($bbsPostType);
			$arrMarkOption[] = "{label: '{$hBbsPostType}', color: '{$hBbsPostMarkColor}', style: '{$hBbsPostMarkStyle}'}";
		}
		$hMarkOption = implode(",\n\t\t\t\t", $arrMarkOption);
		
$html = <<< HTML
<div id="line_graph" class="graph" style="height: 500px">
</div>
<script type="text/javascript">
	//<![CDATA[
		$(document).ready(function(){
			var data = {};
{$hData}
			var lineOption = [
				{$hLineOption}
			];
			var markOption = [
				{$hMarkOption}
			];
			
			minhon.statistics.bbs.lineGraph( data, lineOption, markOption, {$maxXValue});
		});
	//]]>
</script>
HTML;
		return $html;
	}
}
