<?php require_once("class/View/View_statistics.php"); ?>
<?php
Class View_statistics_sellookup extends View_statistics {
	// function table() / function detail()
	const COLUMN_NONE     = 0;
	const COLUMN_USER     = 1;
	const COLUMN_PROJECT  = 2;
	const COLUMN_DOCUMENT = 3;
	const COLUMN_TASK     = 4;
	const COLUMN_ROLE     = 5;
	const COLUMN_TEXT     = 6;
	const COLUMN_SELTEXT  = 7;
	const COLUMN_MODE     = 8;
	// function detail()
	const COLUMN_DATE     = 9;
	const COLUMN_LANG     = 10;
	const COLUMN_ROW      = 11;
	
	private function COLUMN_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS_SELLOOKUP";
		
		$arrValue = array(
			self::COLUMN_NONE     => "",
			self::COLUMN_USER     => "{$WORD($wk, 1)}",
			self::COLUMN_PROJECT  => "{$WORD($wk, 2)}",
			self::COLUMN_DOCUMENT => "{$WORD($wk, 3)}",
			self::COLUMN_TASK     => "{$WORD($wk, 4)}",
			self::COLUMN_ROLE     => "{$WORD($wk, 5)}",
			self::COLUMN_TEXT     => "{$WORD($wk, 6)}",
			self::COLUMN_SELTEXT  => "{$WORD($wk, 7)}",
			self::COLUMN_MODE     => "{$WORD($wk, 8)}",
			self::COLUMN_DATE     => "{$WORD($wk, 9)}",
			self::COLUMN_LANG     => "{$WORD($wk, 10)}",
			self::COLUMN_ROW      => "{$WORD($wk, 11)}",
		);
		return is_null($key) ? $arrValue : $arrValue[$key];
	}

	/****************************************************************************************************************
	 * override
	 ****************************************************************************************************************/
	protected function getHeaderTextCount(){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS_SELLOOKUP";
		
		return "{$WORD($wk, 12)}";
	}
	
	protected function getColumnName( $column ){
		return $this->COLUMN_TABLE($column);
	}
	
	protected function getColumnRequestName( $column ){
		$arrValue = array(
			self::COLUMN_NONE     => NULL,
			self::COLUMN_USER     => "q_user_id",
			self::COLUMN_PROJECT  => "q_project_id",
			self::COLUMN_DOCUMENT => "q_document_id",
			self::COLUMN_TASK     => "q_task_type",
			self::COLUMN_ROLE     => "q_task_role",
			self::COLUMN_TEXT     => "q_text",
			self::COLUMN_SELTEXT  => "q_select_text",
			self::COLUMN_MODE     => "q_mode",
			self::COLUMN_DATE     => NULL,
			self::COLUMN_LANG     => NULL,
			self::COLUMN_ROW      => NULL,
		);
		return is_null($column) ? $arrValue : $arrValue[$column];
	}
	
	protected function getColumnIcon( $column ){
		$arrValue = array(
			self::COLUMN_NONE     => NULL,
			self::COLUMN_USER     => "icon-user",
			self::COLUMN_PROJECT  => "icon-th",
			self::COLUMN_DOCUMENT => "icon-file",
			self::COLUMN_TASK     => "icon-ok",
			self::COLUMN_ROLE     => "icon-star",
			self::COLUMN_TEXT     => NULL,
			self::COLUMN_SELTEXT  => NULL,
			self::COLUMN_MODE     => NULL,
			self::COLUMN_DATE     => "icon-time",
			self::COLUMN_LANG     => NULL,
			self::COLUMN_ROW      => NULL,
		);
		return is_null($column) ? $arrValue : $arrValue[$column];
	}
	
	protected function getColumnData( $column, $data ){
		$ret = parent::getColumnData($column, $data);
		
		switch ( $column ){
			case self::COLUMN_NONE:
				$ret["id"]    = 0;
				$ret["text"]  = "";
				break;
			case self::COLUMN_USER:
				$ret["id"]    = $data["t_user_id"];
				$ret["text"]  = $data["t_user_name"];
				$ret["color"] = DAO::T_USER_TYPE_COLOR_TABLE($data["t_user_type"]);
				break;
			case self::COLUMN_PROJECT:
				$ret["id"]    = $data["t_project_id"];
				$ret["text"]  = $data["t_project_name"];
				break;
			case self::COLUMN_DOCUMENT:
				$ret["id"]    = $data["t_document_id"];
				$ret["text"]  = $data["t_document_title"];
				break;
			case self::COLUMN_TASK:
				$ret["id"]    = $data["t_task_type"];
				$ret["text"]  = TASK::TYPE_TABLE($data["t_task_type"]);
				break;
			case self::COLUMN_ROLE:
				$ret["id"]    = $data["t_task_role"];
				$ret["text"]  = TASK::ROLE_TABLE($data["t_task_role"]);
				break;
			case self::COLUMN_TEXT:
				$ret["id"]    = $data["t_log_lookup_select_text_s"];
				$ret["text"]  = $data["t_log_lookup_select_text_s"];
				break;
			case self::COLUMN_SELTEXT:
				$ret["id"]    = $data["t_log_lookup_select_text_t"];
				$ret["text"]  = $data["t_log_lookup_select_text_t"];
				break;
			case self::COLUMN_MODE:
				$ret["id"]    = $data["t_log_lookup_select_mode"];
				$ret["text"]  = DAO::T_LOG_LOOKUP_SELECT_MODE_TABLE($data["t_log_lookup_select_mode"]);
				break;
			case self::COLUMN_DATE:
				$ret["text"] = $data["t_log_lookup_select_date"];
				break;
			case self::COLUMN_LANG:
				$value1 = isset($data["t_log_select_lookup_lang_s"]) ? $data["t_log_select_lookup_lang_s"] : "???";
				$value2 = isset($data["t_log_select_lookup_lang_t"]) ? $data["t_log_select_lookup_lang_t"] : "???";
				//
				$ret["text"] = Printer::directLang($value1, $value2);
				$ret["isHtml"] = TRUE;
				break;
			case self::COLUMN_ROW:
				$ret["text"] = $data["t_log_lookup_select_no"];
				break;
			default:
				return FALSE;
		}
		
		return $ret;
	}
	
	
	/****************************************************************************************************************
	 * table
	 ****************************************************************************************************************/
	function tableSelLookupByUser_ColumnText( &$result, $arrData ){
		$column = array(
			self::COLUMN_PROJECT  => self::COLUMN_TYPE_LIST,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_TEXT, self::COLUMN_NONE, $column );
	}
	
	function tableSelLookupByUser_ColumnProject( &$result, $arrData ){
		$column = array(
			self::COLUMN_TEXT     => self::COLUMN_TYPE_COUNT,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_NONE, $column );
	}
	function tableSelLookupByUser_ColumnProjectAndText( &$result, $arrData ){
		$column = array(
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_TEXT, $column );
	}
	
	function tableSelLookupByUser_ColumnDocument( &$result, $arrData ){
		$column = array(
			self::COLUMN_TEXT    => self::COLUMN_TYPE_COUNT,
			self::COLUMN_PROJECT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_NONE, $column );
	}
	function tableSelLookupByUser_ColumnDocumentAndText( &$result, $arrData ){
		$column = array(
			self::COLUMN_PROJECT=>self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_TEXT, $column );
	}
	
	function tableSelLookupByOrganization_ColumnText( &$result, $arrData ){
		$column = array(
			self::COLUMN_USER     => self::COLUMN_TYPE_COUNT,
			self::COLUMN_PROJECT  => self::COLUMN_TYPE_LIST,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_TEXT, self::COLUMN_NONE, $column );
	}
	function tableSelLookupByOrganization_ColumnTextAndUser( &$result, $arrData ){
		$column = array(
			self::COLUMN_PROJECT  => self::COLUMN_TYPE_LIST,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_TEXT, self::COLUMN_USER, $column );
	}
	
	function tableSelLookupByOrganization_ColumnProject( &$result, $arrData ){
		$column = array(
			self::COLUMN_USER     => self::COLUMN_TYPE_COUNT,
			self::COLUMN_TEXT     => self::COLUMN_TYPE_COUNT,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_NONE, $column );
	}
	function tableSelLookupByOrganization_ColumnProjectAndUser( &$result, $arrData ){
		$column = array(
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_USER, $column );
	}
	function tableSelLookupByOrganization_ColumnProjectAndText( &$result, $arrData ){
		$column = array(
			self::COLUMN_USER     => self::COLUMN_TYPE_LIST,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_TEXT, $column );
	}
	
	function tableSelLookupByOrganization_ColumnDocument( &$result, $arrData ){
		$column = array(
			self::COLUMN_USER    => self::COLUMN_TYPE_COUNT,
			self::COLUMN_TEXT    => self::COLUMN_TYPE_COUNT,
			self::COLUMN_PROJECT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_NONE, $column );
	}
	function tableSelLookupByOrganization_ColumnDocumentAndUser( &$result, $arrData ){
		$column = array(
			self::COLUMN_PROJECT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_USER, $column );
	}
	function tableSelLookupByOrganization_ColumnDocumentAndText( &$result, $arrData ){
		$column = array(
			self::COLUMN_USER    => self::COLUMN_TYPE_LIST,
			self::COLUMN_PROJECT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_TEXT, $column );
	}
	
	/****************************************************************************************************************
	 * detail
	 ****************************************************************************************************************/
	function tableDetailSelLookupByUser( $arrData, $arrPriorityColumn ){
		$column = array(
			self::COLUMN_TEXT,
			self::COLUMN_SELTEXT,
			self::COLUMN_MODE,
			self::COLUMN_LANG,
			self::COLUMN_DATE,
			self::COLUMN_PROJECT,
			self::COLUMN_DOCUMENT,
			self::COLUMN_ROW,
			self::COLUMN_TASK,
			self::COLUMN_ROLE,
		);
		return $this->detail( $arrData, $arrPriorityColumn, $column);
	}
	
	function tableDetailSelLookupByOrganization( $arrData, $arrPriorityColumn ){
		$column = array(
			self::COLUMN_USER,
			self::COLUMN_TEXT,
			self::COLUMN_SELTEXT,
			self::COLUMN_MODE,
			self::COLUMN_LANG,
			self::COLUMN_DATE,
			self::COLUMN_PROJECT,
			self::COLUMN_DOCUMENT,
			self::COLUMN_ROW,
			self::COLUMN_TASK,
			self::COLUMN_ROLE,
		);
		return $this->detail( $arrData, $arrPriorityColumn, $column);
	}
	
}
