<?php require_once("class/View/View_statistics.php"); ?>
<?php
Class View_statistics_task extends View_statistics {
	// function table() / function detail()
	const COLUMN_NONE     = 0;
	const COLUMN_USER     = 1;
	const COLUMN_PROJECT  = 2;
	const COLUMN_DOCUMENT = 3;
	const COLUMN_TASK     = 4;
	const COLUMN_ROLE     = 5;
	const COLUMN_USERROLE = 6;
	const COLUMN_TASKROLE = 7;
	// function detail()
	const COLUMN_DATE     = 8;
	
	private function COLUMN_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS_TASK";
		
		$arrValue = array(
			self::COLUMN_NONE     => "",
			self::COLUMN_USER     => "{$WORD($wk, 1)}",
			self::COLUMN_PROJECT  => "{$WORD($wk, 2)}",
			self::COLUMN_DOCUMENT => "{$WORD($wk, 3)}",
			self::COLUMN_TASK     => "{$WORD($wk, 4)}",
			self::COLUMN_ROLE     => "{$WORD($wk, 5)}",
			self::COLUMN_USERROLE => "{$WORD($wk, 6)}",
			self::COLUMN_TASKROLE => "{$WORD($wk, 7)}",
			self::COLUMN_DATE     => "{$WORD($wk, 8)}",
		);
		return is_null($key) ? $arrValue : $arrValue[$key];
	}
	
	/****************************************************************************************************************
	 * override
	 ****************************************************************************************************************/
	protected function getHeaderTextCount(){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_STATISTICS_TASK";
		
		return "{$WORD($wk, 9)}";
	}
	
	protected function getColumnName( $column ){
		return $this->COLUMN_TABLE($column);
	}
	
	protected function getColumnRequestName( $column ){
		$arrValue = array(
			self::COLUMN_NONE     => NULL,
			self::COLUMN_USER     => "q_user_id",
			self::COLUMN_PROJECT  => "q_project_id",
			self::COLUMN_DOCUMENT => "q_document_id",
			self::COLUMN_TASK     => "q_task_type",
			self::COLUMN_ROLE     => "q_task_role",
			self::COLUMN_USERROLE => NULL,
			self::COLUMN_TASKROLE => NULL,
			self::COLUMN_DATE     => NULL,
		);
		return is_null($column) ? $arrValue : $arrValue[$column];
	}
	
	protected function getColumnIcon( $column ){
		$arrValue = array(
			self::COLUMN_NONE     => NULL,
			self::COLUMN_USER     => "icon-user",
			self::COLUMN_PROJECT  => "icon-th",
			self::COLUMN_DOCUMENT => "icon-file",
			self::COLUMN_TASK     => "icon-ok",
			self::COLUMN_ROLE     => "icon-star",
			self::COLUMN_USERROLE => NULL,
			self::COLUMN_TASKROLE => NULL,
			self::COLUMN_DATE     => "icon-time",
		);
		return is_null($column) ? $arrValue : $arrValue[$column];
	}
	
	protected function getColumnData( $column, $data ){
		$ret = parent::getColumnData($column, $data);
		
		switch ( $column ){
			case self::COLUMN_NONE:
				$ret["id"]    = 0;
				$ret["text"]  = "";
				break;
			case self::COLUMN_USER:
				$ret["id"]    = $data["t_user_id"];
				$ret["text"]  = $data["t_user_name"];
				$ret["color"] = DAO::T_USER_TYPE_COLOR_TABLE($data["t_user_type"]);
				break;
			case self::COLUMN_PROJECT:
				$ret["id"]    = $data["t_project_id"];
				$ret["text"]  = $data["t_project_name"];
				break;
			case self::COLUMN_DOCUMENT:
				$ret["id"]    = $data["t_document_id"];
				$ret["text"]  = $data["t_document_title"];
				break;
			case self::COLUMN_TASK:
				$ret["id"]    = $data["t_task_type"];
				$ret["text"]  = TASK::TYPE_TABLE($data["t_task_type"]);
				break;
			case self::COLUMN_ROLE:
				$ret["id"]    = $data["t_task_role"];
				$ret["text"]  = TASK::ROLE_TABLE($data["t_task_role"]);
				break;
			case self::COLUMN_USERROLE:
				$userID   = isset($data["t_user_id"])   ? $data["t_user_id"]   : 0;
				$userName = isset($data["t_user_name"]) ? $data["t_user_name"] : "???";
				$role     = isset($data["t_task_role"]) ? $data["t_task_role"] : 0;
				$roleText = isset($data["t_task_role"]) ? TASK::ROLE_TABLE($data["t_task_role"]) : "???";
				//
				$ret["id"]   = "{$userID}-{$role}";
				$ret["text"] = "{$userName} - {$roleText}";
				break;
			case self::COLUMN_TASKROLE:
				$type     = isset($data["t_task_type"]) ? $data["t_task_type"] : 0;
				$typeText = isset($data["t_task_type"]) ? TASK::TYPE_TABLE($data["t_task_type"]) : "???";
				$role     = isset($data["t_task_role"]) ? $data["t_task_role"] : 0;
				$roleText = isset($data["t_task_role"]) ? TASK::ROLE_TABLE($data["t_task_role"]) : "???";
				//
				$ret["id"]   = "{$type}-{$role}";
				$ret["text"] = "{$typeText} - {$roleText}";
				break;
			case self::COLUMN_DATE:
				$start = isset($data["t_task_start"]) ? $data["t_task_start"] : "???";
				$end   = isset($data["t_task_end"])   ? $data["t_task_end"]   : "???";
				//
				$ret["text"] = "{$start} - {$end}";
				break;
			default:
				return FALSE;
		}
		
		return $ret;
	}
	
	
	/****************************************************************************************************************
	 * table
	 ****************************************************************************************************************/
	function tableTaskByUser_ColumnProject( &$result, $arrData ){
		$column = array(
			self::COLUMN_TASK     => self::COLUMN_TYPE_LINK,
			self::COLUMN_ROLE     => self::COLUMN_TYPE_LINK,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_NONE, $column );
	}
	function tableTaskByUser_ColumnProjectAndTask( &$result, $arrData ){
		$column = array(
			self::COLUMN_ROLE     => self::COLUMN_TYPE_LIST,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_TASK, $column );
	}
	function tableTaskByUser_ColumnProjectAndRole( &$result, $arrData ){
		$column = array(
			self::COLUMN_TASK     => self::COLUMN_TYPE_LIST,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_ROLE, $column );
	}
	
	function tableTaskByUser_ColumnDocument( &$result, $arrData ){
		$column = array(
			self::COLUMN_TASK    => self::COLUMN_TYPE_LINK,
			self::COLUMN_ROLE    => self::COLUMN_TYPE_LINK,
			self::COLUMN_PROJECT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_NONE, $column );
	}
	function tableTaskByUser_ColumnDocumentAndTask( &$result, $arrData ){
		$column = array(
			self::COLUMN_ROLE    => self::COLUMN_TYPE_LIST,
			self::COLUMN_PROJECT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_TASK, $column );
	}
	function tableTaskByUser_ColumnDocumentAndRole( &$result, $arrData ){
		$column = array(
			self::COLUMN_TASK    => self::COLUMN_TYPE_LIST,
			self::COLUMN_PROJECT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_ROLE, $column );
	}
	
	function tableTaskByProject_ColumnUser( &$result, $arrData ){
		$column = array(
			self::COLUMN_TASK => self::COLUMN_TYPE_LINK,
			self::COLUMN_ROLE => self::COLUMN_TYPE_LINK,
		);
		return $this->table( $result, $arrData, self::COLUMN_USER, self::COLUMN_NONE, $column );
	}
	function tableTaskByProject_ColumnUserAndTask( &$result, $arrData ){
		$column = array(
			self::COLUMN_ROLE => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_USER, self::COLUMN_TASK, $column );
	}
	function tableTaskByProject_ColumnUserAndRole( &$result, $arrData ){
		$column = array(
			self::COLUMN_TASK => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_USER, self::COLUMN_ROLE, $column );
	}
	
	function tableTaskByProject_ColumnDocument( &$result, $arrData ){
		$column = array(
			self::COLUMN_TASK => self::COLUMN_TYPE_LINK,
			self::COLUMN_ROLE => self::COLUMN_TYPE_LINK,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_NONE, $column );
	}
	function tableTaskByProject_ColumnDocumentAndTask( &$result, $arrData ){
		$column = array(
			self::COLUMN_USERROLE => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_TASK, $column );
	}
	function tableTaskByProject_ColumnDocumentAndRole( &$result, $arrData ){
		$column = array(
			self::COLUMN_TASK => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_ROLE, $column );
	}
	
	function tableTaskByProject_ColumnTaskAndRole( &$result, $arrData ){
		$column = array(
			self::COLUMN_USER     => self::COLUMN_TYPE_LIST,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_TASK, self::COLUMN_ROLE, $column );
	}
	
	function tableTaskByOrganization_ColumnProject( &$result, $arrData ){
		$column = array(
			self::COLUMN_USER     => self::COLUMN_TYPE_LINK,
			self::COLUMN_TASK     => self::COLUMN_TYPE_LINK,
			self::COLUMN_ROLE     => self::COLUMN_TYPE_LINK,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_NONE, $column );
	}
	function tableTaskByOrganization_ColumnProjectAndUser( &$result, $arrData ){
		$column = array(
			self::COLUMN_TASKROLE => self::COLUMN_TYPE_LIST,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_USER, $column );
	}
	function tableTaskByOrganization_ColumnProjectAndTask( &$result, $arrData ){
		$column = array(
			self::COLUMN_USERROLE => self::COLUMN_TYPE_LIST,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_TASK, $column);
	}
	function tableTaskByOrganization_ColumnProjectAndRole( &$result, $arrData ){
		$column = array(
			self::COLUMN_USER     => self::COLUMN_TYPE_LIST,
			self::COLUMN_DOCUMENT => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_PROJECT, self::COLUMN_ROLE, $column );
	}
	
	function tableTaskByOrganization_ColumnUser( &$result, $arrData ){
		$column = array(
			self::COLUMN_TASK => self::COLUMN_TYPE_LIST,
			self::COLUMN_ROLE => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_USER, self::COLUMN_NONE, $column );
	}
	
	function tableTaskByOrganization_ColumnDocument( &$result, $arrData ){
		$column = array(
			self::COLUMN_PROJECT  => self::COLUMN_TYPE_LIST,
			self::COLUMN_TASKROLE => self::COLUMN_TYPE_LIST,
		);
		return $this->table( $result, $arrData, self::COLUMN_DOCUMENT, self::COLUMN_NONE, $column );
	}
	
	/****************************************************************************************************************
	 * detail
	 ****************************************************************************************************************/
	function tableDetailTaskByUser( $arrData, $arrPriorityColumn ){
		$column = array(
			self::COLUMN_TASK,
			self::COLUMN_PROJECT,
			self::COLUMN_ROLE,
			self::COLUMN_DOCUMENT,
			self::COLUMN_DATE,
		);
		return $this->detail( $arrData, $arrPriorityColumn, $column);
	}
	
	function tableDetailTaskByProject( $arrData, $arrPriorityColumn ){
		$column = array(
			self::COLUMN_USER,
			self::COLUMN_TASK,
			self::COLUMN_ROLE,
			self::COLUMN_DOCUMENT,
			self::COLUMN_DATE
		);
		return $this->detail( $arrData, $arrPriorityColumn, $column);
	}
	
	function tableDetailTaskByOrganization( $arrData, $arrPriorityColumn ){
		$column = array(
			self::COLUMN_USER,
			self::COLUMN_TASK,
			self::COLUMN_PROJECT,
			self::COLUMN_ROLE,
			self::COLUMN_DOCUMENT,
			self::COLUMN_DATE,
		);
		return $this->detail( $arrData, $arrPriorityColumn, $column );
	}
	
}
