<?php
Class View_task extends View {
	const TAB_LIST        = 0;
	const TAB_CHART       = 1;
	const TAB_NEW         = 2;
	const TAB_EDIT        = 3;
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $tab, $auth, $projectID, $workflowID, $id = 0 ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TASK";
		
		$html = FALSE;
		$query = array(
			"q_project_id"  => $projectID,
			"q_workflow_id" => $workflowID,
		);
		
		switch ( $tab ){
			//------------------------
			// 担当タスク一覧
			case self::TAB_LIST:
				if ( $auth->readList($projectID) ){
					$html = $this->tabLink("{$WORD($wk, 1)}", NULL, NULL, NULL, "/content/task/index.html", $query);
				}
				break;
			//------------------------
			// ワークフロー詳細
			case self::TAB_CHART:
				if ( $auth->readList($projectID) ){
					unset($query["q_workflow_id"]);
					$query["q_id"] = $workflowID;
					$html = $this->tabLink("{$WORD($wk, 2)}", NULL, "icon-calendar", NULL, "/content/workflow/detail.html", $query);
				}
				break;
			//------------------------
			// ワークフロー設定
			case self::TAB_NEW:
				if ( $auth->write_isWorkflow(INIT_ID, $projectID) ){
					unset($query["q_workflow_id"]);
					$query["q_id"] = $workflowID;
					$html = $this->tabLink("{$WORD($wk, 3)}", NULL, "icon-pencil", NULL, "/content/workflow/edit.html", $query);
				}
				break;
			//------------------------
			// タスク割当て
			case self::TAB_EDIT:
				if ( $auth->write_isAllocate(INIT_ID, $projectID) ){
					$html = $this->tabLink("{$WORD($wk, 4)}", NULL, "icon-plus", NULL, "/content/task/edit.html", $query);
				}
				break;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:formType
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function formType( $id = NULL, $arrValue = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TASK";
		
		$html = "";
		$hId = Util::esc($id);
		
		$arrTypeGroup = array();
		foreach ( Task::SETTING_TABLE() as $type => $item ){
			$arrTypeGroup[$item["group"]][] = $type;
		}
		
		foreach ( $arrTypeGroup as $typeGroup => $arrType ){
			$strTypeGroup = Task::TYPE_GROUP_TABLE($typeGroup);
			
			$hLinkGroup = Printer::link($strTypeGroup, "btn btn-default");
			
			$arr = array();
			
			foreach ( $arrType as $type ){
				$arr[$type] = Task::TYPE_TABLE($type);
			}
			
			$hCheckbox = Printer::checkbox(NULL, "q_types[]", $arr, $arrValue);
			
$html .= <<< HTML
			<tr data-type-group="{$typeGroup}">
				<td>{$hLinkGroup}</td>
				<td>{$hCheckbox}</td>
			</tr>
HTML;
		}
		
$html = <<< HTML
		<table class="table" id="{$hId}">
			{$html}
		</table>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:state
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function state( $state, $id = NULL, $class = NULL, $arrOption = NULL ){
		if ( ! is_array($arrOption) ){
			$arrOption = array();
		}
		$arrOption += array(
			"id"    => "",
			"class" => "",
		);
		if ( ! is_null($id) ){
			$arrOption["id"]    = $id;
		}
		if ( ! is_null($class) ){
			$arrOption["class"] = trim($arrOption["class"]." ".$class);
		}
		$hOption = Printer::option($arrOption);
		
		$icon = Printer::icon(DAO::T_TASK_STATE_ICON_TABLE($state), "inherit", DAO::T_TASK_STATE_TABLE($state), "inherit");
		$attr = DAO::T_TASK_STATE_ATTR_TABLE($state);
$html = <<< HTML
	<span data-task-state="{$attr}" {$hOption}>{$icon}</span>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:stateButton
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function stateButton( $isEdit, $taskID, $selectState ){
		$hButtons = array();
		if ( $isEdit ){
			$arrTaskState = array_reverse(DAO::T_TASK_STATE_TABLE(), TRUE);
		} else {
			$arrTaskState = array($selectState => DAO::T_TASK_STATE_TABLE($selectState));
		}
		$disabled = (count($arrTaskState) === 1) ? "disabled=\"disabled\"" : "";
		foreach ( $arrTaskState as $state => $text ){
			$active = ($state === $selectState) ? "active" : "";
			$iconText = Printer::icon(DAO::T_TASK_STATE_ICON_TABLE($state), "inherit", $text, "inherit");
			$attr = DAO::T_TASK_STATE_ATTR_TABLE($state);
$hButtons[$state] = <<< HTML
			<label class="btn btn-default {$active}" data-task-state="{$attr}" {$disabled}><input type="radio" name="task-state" value="{$state}">{$iconText}</label>
HTML;
		}
		$hBtnGroup = implode("\r\n", $hButtons);
		
		$arrParam = array(
			Printer::input("hidden", NULL, "q_task_id", $taskID),
			Printer::input("hidden", NULL, "q_token", Util::token("q_token")),
		);
		$hParam = implode("\r\n", $arrParam);
		
$html = <<< HTML
		<span id="task-state-change">
			<div class="btn-group" data-toggle="buttons">
				{$hBtnGroup}
			</div>
			{$hParam}
		</span>
HTML;
		return $html;
	}
	
	/***************************************************************
	 * 名前: table
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function table( $arrData, $selectTaskID, $order, $myUserID, $arrActor = NULL, $arrAppended = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TASK";
		
		$auth = Auth::instance("task");
		
		$arrInsDocument = array();
		
		$html = "";
		if ( count($arrData) > 0 ){
			foreach ( $arrData as $data ){
				$id          = $data["t_task_id"];
				$state       = $data["t_task_state"];
				$type        = $data["t_task_type"];
				$xml         = $data["t_task_data"];
				$start       = $data["t_task_start"];
				$end         = $data["t_task_end"];
				$workflowID  = $data["t_workflow_id"];
				$projectID   = $data["t_project_id"];
				$projectName = $data["t_project_name"];
				
				$check = Task::checkTaskObject($id, $type, $arrActor, $arrAppended);
				if ( $check === TRUE ){
					// タイプ
					$hType = Printer::link(Task::TYPE_TABLE($type), NULL, "icon-ok", NULL, NULL, "minhon.task.onClickTask({$id});");
				} else {
					$hType = Printer::tooltip(Printer::iconWarning("")." ".Util::esc(Task::TYPE_TABLE($type)), $check, NULL, NULL, FALSE);
					$hType = Printer::link($hType, NULL, NULL, NULL, "/content/workflow/detail.html?q_project_id={$projectID}&q_id={$workflowID}&q_task_id={$id}", NULL, NULL, FALSE);
				}
				
				// 文書
				$hDocument = "";
				$arrDocument = Task::getTaskDocument($id);
				foreach ( $arrDocument as $documentID => $documentTitle ){
					$documentTitle = Printer::ellipsis($documentTitle, 10);
					$hDocument .= Printer::link($documentTitle, NULL, "icon-file", NULL, "/content/document/detail.html?q_project_id={$projectID}&q_id={$documentID}", NULL, NULL, FALSE);
					if ( ! isset($arrInsDocument[$documentID]) ){
						$arrInsDocument[$documentID] = new Document($documentID);
					}
				}
				if ( strlen($hDocument) === 0 ){
					$hDocument = " - ";
				}
				// 共同作業者
				$arrTogether = array();
				$arrTaskActor = Task::getTaskActor($id);
				foreach ( $arrTaskActor as $role => $arrUser ){
					$arrTogether += $arrUser;
				}
				$hTogether = "";
				foreach ( $arrTogether as $dataUser ){
					if ( $myUserID === $dataUser["t_user_id"] ){
						continue;
					}
					$hTogether .= Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($dataUser["t_user_type"]), $dataUser["t_user_name"])." ";
				}
				if ( strlen($hTogether) === 0 ){
					$hTogether = " - ";
				}
				// 期間
				$hDate = Task::getHtmlDateSpan($id, $start, $end, User::get("id"), $arrDocument);
				// 状態
				//$hState = Task::getHtmlState($id, $state);
				if ( $auth->write_isState($id, $projectID) ){
					$arrButton = array();
					foreach ( DAO::T_TASK_STATE_TABLE(NULL) as $key => $text ){
						$stateClass = ($state === $key) ? "icon-arrow-right" : "icon-none";
						$arrButton[] = Printer::link($text, NULL, $stateClass, NULL, NULL, "minhon.task.setTaskState({$id}, {$key});", array("data-state"=>$key));
					}
					$hState = Printer::buttonGroup( DAO::T_TASK_STATE_TABLE($state), $arrButton, "non", array("class"=>DAO::T_TASK_STATE_ALERT_TABLE($state)));
				} else {
					$stateClass = DAO::T_TASK_STATE_ALERT_TABLE($state);
					$stateText  = DAO::T_TASK_STATE_TABLE($state);
					$hState = "<span class=\"btn disabled {$stateClass} no-opacity\">{$stateText}</span>";
				}
				
				$trClass = "";
				if ( $selectTaskID === $id ){
					$trClass = "alert-warning";
				}
				
$html .= <<< HTML
				<tr class="{$trClass}">
					<td>{$hType}</td>
					<td>{$hDocument}</td>
					<td>{$hTogether}</td>
					<td>{$hDate}</td>
					<td>{$hState}</td>
				</tr>
HTML;
			}
			
			$hHeaderType     = Printer::tableOrder("{$WORD($wk, 5)}", "task", $order);
			$hHeaderDocument = Printer::tableOrder("{$WORD($wk, 6)}", "document", $order);
			$hHeaderTogether = Printer::tableOrder("{$WORD($wk, 7)}", NULL, $order);
			$hHeaderSpan     = Printer::tableOrder("{$WORD($wk, 8)}", "date", $order);
			$hHeaderState    = Printer::tableOrder("{$WORD($wk, 9)}", "state", $order);
			
$html = <<< HTML
			<table id="table_home_task" class="table">
				<thead>
					{$hHeaderType}
					{$hHeaderDocument}
					{$hHeaderTogether}
					{$hHeaderSpan}
					{$hHeaderState}
				</thead>
				<tbody>
					{$html}
				</tbody>
			</table>
HTML;
		
			$token = Printer::input("hidden", "q_token", "q_token", Util::token("q_token"));
			$html .= $token;
			
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:edit
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function edit( $data, $arrTaskType, $arrActor, $arrAppended, $arrTaskActor, $arrTaskContact, $arrTaskObject, $isNew = FALSE ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TASK";
		
		$auth = Auth::instance("task");
		
		// 初期値
		$html = "";
		
		$id         = $data["t_task_id"];
		$state      = $data["t_task_state"];
		$type       = $data["t_task_type"];
		$start      = $data["t_task_start"];
		$end        = $data["t_task_end"];
		$workflowID = $data["t_workflow_id"];
		$projectID  = $data["t_project_id"];
		
		$setting = Task::SETTING_TABLE($type);
		$arrControl = array();
		
		// タイプ
		if ( Validate::isArray($arrTaskType) ){
			$hArrType = array();
			foreach ( $arrTaskType as $taskType ){
				$hArrType[$taskType] = Task::TYPE_TABLE($taskType);
			}
			$hTaskType = Printer::wizard($hArrType, $type);
			$hArrTaskType = Printer::input("hidden", NULL, "q_task_types", implode(",", $arrTaskType));
		} else {
			$hTaskType = Task::TYPE_TABLE($type);
			$hArrTaskType = "";
		}
		$hTaskState = "";
		if ( ! $isNew ){
			// 状態
			if ( $auth->write_isEditState($id, $projectID) ){
				foreach ( DAO::T_TASK_STATE_TABLE() as $key => $text ){
					$active = ($state === $key) ? "active" : "";
					$iconText = Printer::icon(DAO::T_TASK_STATE_ICON_TABLE($key), "inherit", $text, "inherit");
					$stateClass = DAO::T_TASK_STATE_ALERT_TABLE($state);
					$attr = DAO::T_TASK_STATE_ATTR_TABLE($key);
$hTaskState .= <<< HTML
					<label class="btn {$active} {$stateClass}" data-task-state="{$attr}"><input type="radio" name="q_state" value="{$key}">{$iconText}</label>
HTML;
				}
$hTaskState = <<< HTML
				<span id="task-state-change">
					<div class="btn-group" data-toggle="buttons">
						{$hTaskState}
					</div>
				</span>
HTML;
			} else {
				$stateClass = DAO::T_TASK_STATE_ALERT_TABLE($state);
				$stateText  = DAO::T_TASK_STATE_TABLE($state);
				$hTaskState  = " <span class=\"btn disabled {$stateClass} no-opacity\">{$stateText}</span>";
			}
		}
		$arrControl[] = array(
			"id"   => NULL,
			"name" => "{$WORD($wk, 10)}",
			"form" => array(
				Printer::formText($hTaskType.$hTaskState, FALSE),
				$hArrTaskType,
				Printer::input("hidden", NULL, "q_task_type", $type),
			)
		);
		// フォーム(start-end)
		$arrControl[] = array(
			"id"   => "q_start",
			"name" => "{$WORD($wk, 11)}",
			"form" => array(
				Printer::input("text", "q_start", "q_start", $start),
				Printer::icon("icon-arrow-right"),
				Printer::input("text", "q_end", "q_end", $end),
			),
			"validate" => array(
				"required" => TRUE,
				"date"     => TRUE,
			),
			"required" => TRUE,
		);
		$arrControl[] = array(
			"id"   => "q_end",
			"name" => NULL,
			"form" => NULL,
			"validate" => array(
				"required" => TRUE,
				"date"     => TRUE,
				"greatherThanEqual" => "#q_start",
			),
		);
		// フォーム(actor)
		$arrControl[] = array(
			"id"   => NULL,
			"name" => "{$WORD($wk, 12)}",
			"form" => $this->actor($type, $arrTaskActor, $arrActor),
			"required" => ( isset($setting["actor-require"]) && $setting["actor-require"] ) ? TRUE : FALSE,
		);
		foreach ( $setting["actor"] as $actor ){
			if ( isset($actor["require"]) && $actor["require"] ){
				$arrControl[] = array(
					"id" => "q_actor[{$actor["r"]}][]",
					"name" => NULL,
					"form" => NULL,
					"validate" => array(
						"required" => TRUE,
					),
				);
			}
			else if ( isset($setting["actor-require"]) && $setting["actor-require"] ){
				$arrControl[] = array(
					"id" => "q_actor[{$actor["r"]}][]",
					"name" => NULL,
					"form" => NULL,
					"validate" => array(
						"required_group" => array(1, "[name^=q_actor]"),
					),
					"validate-group" => "actor",
				);
			}
		}
		// フォーム(contact)
		$hContact = $this->actor($type, $arrTaskContact, $arrActor, TRUE, "contact");
		if ( strlen($hContact) > 0 ){
			$arrControl[] = array(
				"id"   => NULL,
				"name" => "{$WORD($wk, 13)}",
				"form" => $hContact,
			);
		}
		// フォーム(input)
		$arrControl[] = array(
			"id"   => NULL,
			"name" => "{$WORD($wk, 14)}",
			"form" => $this->formObject($type, "input", $arrTaskObject, $arrAppended, $id, TRUE, $isNew),
		);
		foreach ( $setting["input"] as $name => $input ){
			if ( isset($input["require"]) && $input["require"] ){
				$arrControl[] = array(
					"id" => "q_object[{$name}][]",
					"name" => NULL,
					"form" => NULL,
					"validate" => array("required" => TRUE),
				);
			}
		}
		// フォーム(output)
		$arrControl[] = array(
			"id"   => NULL,
			"name" => "{$WORD($wk, 15)}",
			"form" => $this->formObject($type, "output", $arrTaskObject, $arrAppended, $id, TRUE, $isNew),
		);
		foreach ( $setting["output"] as $name => $output ){
			if ( isset($output["require"]) && $output["require"] ){
				$arrControl[] = array(
					"id" => "q_object[{$name}][]",
					"name" => NULL,
					"form" => NULL,
					"validate" => array("required" => TRUE),
				);
			}
		}
		// フォーム(プロジェクトid)
		$arrControl[] = array(
			"id"   => NULL,
			"name" => NULL,
			"form" => Printer::input("hidden", "q_project_id", "q_project_id", $projectID),
		);
		// フォーム(ワークフローid)
		$arrControl[] = array(
			"id"   => NULL,
			"name" => NULL,
			"form" => Printer::input("hidden", "q_workflow_id", "q_workflow_id", $workflowID),
		);
		// フォーム(タスクid)
		$arrControl[] = array(
			"id"   => NULL,
			"name" => NULL,
			"form" => Printer::input("hidden", "q_task_id", "q_task_id", $id),
		);
		// フォーム(token)
		$arrControl[] = array(
			"id"   => NULL,
			"name" => NULL,
			"form" => Printer::input("hidden", "q_token", "q_token", Util::token()),
		);

		$hFormID   = Util::esc("form_task_edit2");
		$hFormName = Util::esc("form_task_edit2");
		
		$hFormControl  = Printer::formControl($arrControl, FALSE, TRUE);
		$hFormValidate = Printer::formValidate($hFormID, $arrControl);
		
$html = <<< HTML
		<form id="{$hFormID}" name="{$hFormName}" action="" method="post">
			<table class="table task-dialog-table table-noborder">
				{$hFormControl}
			</table>
		</form>
		{$hFormValidate}
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:detail
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function detail( $data, $arrActor, $arrAppended, $arrTaskID = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TASK";
		
		$auth = Auth::instance("task");
		
		$html = "";
		
		$id         = $data["t_task_id"];
		$state      = $data["t_task_state"];
		$type       = $data["t_task_type"];
		$xml        = $data["t_task_data"];
		$start      = $data["t_task_start"];
		$end        = $data["t_task_end"];
		$workflowID = $data["t_workflow_id"];
		$projectID  = $data["t_project_id"];
		
		if ( ($arrTaskObject = Task::convertTaskObject($id, $type, $xml)) === FALSE ){
			return NULL;
		}
		
		$setting = Task::SETTING_TABLE($type);
		
		// タスクタイプ
		$hType = Util::esc(Task::TYPE_TABLE($type));
		// 期間
		$hDate = Printer::direct("icon-arrow-right", $start, $end);
		// 担当
		$hActor = $this->actor($type, Task::getTaskActor($id), $arrActor, FALSE);
		// 接触者
		$hContact = $this->actor($type, Task::getTaskContact($id), $arrActor, FALSE, "contact");
		// input
		$hInput = $this->formObject($type, "input", $arrTaskObject, $arrAppended, $id);
		// output
		$hOutput = $this->formObject($type, "output", $arrTaskObject, $arrAppended, $id);
		
		// 状態
		$stateClass = DAO::T_TASK_STATE_ALERT_TABLE($state);
		$stateText  = DAO::T_TASK_STATE_TABLE($state);
		$hState = "<span class=\"btn disabled {$stateClass} no-opacity\">{$stateText}</span>";
		
		// ページング
		if ( Validate::isArray($arrTaskID) && Validate::inArray($id, $arrTaskID) ){
			$jsonArrTaskID = json_encode($arrTaskID);
			// index
			$key = array_search($id, $arrTaskID, TRUE);
			// 左向きボタン
			$prevID      = ($key === 0) ? "0" : $arrTaskID[$key-1];
			$pagingClass = ($key === 0) ? "disabled" : "";
			$hPagingLeft = Printer::link("", "btn btn-default ".$pagingClass, "icon-chevron-left", NULL, NULL, "minhon.task.chart.onClickTaskDetail({$prevID}, {$jsonArrTaskID})");
			// 右向きボタン
			$nextID      = ($key === count($arrTaskID)-1) ? "0" : $arrTaskID[$key+1];
			$pagingClass = ($key === count($arrTaskID)-1) ? "disabled" : "";
			$hPagingRight = Printer::link("", "btn btn-default ".$pagingClass, "icon-chevron-right", NULL, NULL, "minhon.task.chart.onClickTaskDetail({$nextID}, {$jsonArrTaskID})");
			
$html .= <<< HTML
			<div style="position: absolute; left: 1em;" >
				{$hPagingLeft}{$hPagingRight}
			</div>
HTML;
		}
		
		// 掲示板
		$hBbs = "";
		if ( $auth->write($id, $projectID) ){
			$objDAOBbs  = DAO::instance("bbs");
			$resDAOBbs = $objDAOBbs->get(NULL, $projectID);
			if ( $resDAOBbs["result"] === RES_OK ){
				$bbsID = $resDAOBbs["data"][0]["t_bbs_id"];
				$hBbs = Printer::link("{$WORD($wk, 16)}", "btn btn-default", "icon-comment", NULL, NULL, "minhon.bbs.post.postDialog(false, {$bbsID}, null, {q_task_id: {$id}})");
			}
		}
		// 編集
		$hEdit = "";
		if ( $auth->write($id, $projectID) ){
			$hEdit = Printer::link("{$WORD($wk, 17)}", "btn btn-default", "icon-pencil", NULL, NULL, "minhon.task.chart.onClickTaskEdit({$id});");
		}
		// 削除
		$hDelete = "";
		if ( $auth->remove($id, $projectID) ){
			$hDelete = Printer::link("{$WORD($wk, 18)}", "btn btn-danger", "icon-remove", "inherit", NULL, "minhon.task.chart.onClickTaskDelete({$id}, '{$WORD($wk, 19)}');");
		}
		if ( strlen($hBbs) > 0 || strlen($hEdit) > 0 || strlen($hDelete) > 0 ){
$html .= <<< HTML
			<div class="menu">
				{$hBbs}
				{$hEdit}
				{$hDelete}
			</div>
HTML;
		}
		
		if ( isset($setting["actor-require"]) && $setting["actor-require"] ){
			$actorRequire = "<span class=\"form-required\">*</span>";
		} else {
			$actorRequire = "";
		}
		
$hActor = <<< HTML
		<tr>
			<th>{$WORD($wk, 20)}{$actorRequire}</th>
			<td>{$hActor}</td>
		</tr>
HTML;
		if ( strlen($hContact) > 0 ){
$hActor .= <<< HTML
			<tr>
				<th>{$WORD($wk, 21)}</th>
				<td>{$hContact}</td>
			</tr>
HTML;
		}
		
$hInput = <<< HTML
		<tr>
			<th>{$WORD($wk, 22)}</th>
			<td>{$hInput}</td>
		</tr>
HTML;
$hOutput = <<< HTML
		<tr>
			<th>{$WORD($wk, 23)}</th>
			<td>{$hOutput}</td>
		</tr>
HTML;
		
		
$html .= <<< HTML
		<table class="table task-dialog-table table-noborder">
			<tbody>
				<tr>
					<th>{$WORD($wk, 24)}</th>
					<td>{$hType} ({$hDate}) {$hState}</td>
				</tr>
				{$hActor}
				{$hInput}
				{$hOutput}
			</tbody>
		</table>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: chart
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function chart( $class ){
		$html = "";
		
		$hClass = Util::esc($class);
$html = <<< HTML
		<div id="chart" class="{$hClass}"></div>
HTML;
	
		return $html;
	}
	
	/***************************************************************
	 * 名前:actor
	 * 説明:
	 * 引数: arrActorSelected ( role => array( userId => dataUser ) )
	 *     : arrActor         ( role => array( userId => userName ) )
	 * 返値:
	****************************************************************/
	function actor( $type, $arrActorSelected, $arrActor, $isEdit = TRUE, $key = "actor" ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TASK";
		
		$html = "";
		
		$setting = Task::SETTING_TABLE($type);
		
		if ( ! is_array($setting) ){
			return "";
		}
		if ( ! isset($setting[$key]) ){
			return "";
		}
		
		$arrHtmlList = array();
		for ( $i=0; $i<count($setting[$key]); $i++ ){
			$hSelectActor = "";
			
			$index = $i + 1;
			
			$actor = $setting[$key][$i];
			$r = $actor["r"];
			$isRadio = isset($actor["single"]) && $actor["single"];
			
			$hRole = Printer::label("label-danger", Task::ROLE_TABLE($r));
			if ( isset($actor["require"]) && $actor["require"] ){
				$hRole .= "<span class=\"form-required\">*</span>";
			}
			
			$arrSelected = isset($arrActorSelected[$r]) ? $arrActorSelected[$r] : array();
			
			// 編集 --------------------
			if ( $isEdit ){
				if ( isset($arrActor[$r]) ){
					if ( $isRadio ){
						$selected = count($arrSelected) > 0 ? key($arrSelected) : NULL;
						$hSelectActor = Printer::radio(NULL, "q_actor[{$r}][]", $arrActor[$r], $selected);
					} else {
						$hSelectActor = Printer::checkbox(NULL, "q_actor[{$r}][]", $arrActor[$r], array_keys($arrSelected));
					}
				} else {
					$hSelectActor = "{$WORD($wk, 25)}";
					$hSelectActor .= Printer::input("hidden", NULL, "q_actor[{$r}][]", NULL, "validate-item");
				}
			}
			// 表示 --------------------
			else {
				if ( isset($arrActor[$r]) ){
					foreach ( $arrSelected as $userID => $dataUser ) {
						$userType = $dataUser["t_user_type"];
						$userName = $dataUser["t_user_name"];
						
						if ( ! isset($arrActor[$r][$userID]) ){
							// プロジェクトメンバーではないがタスク担当者
							$hSelectActor .= Printer::iconWarning("{$WORD($wk, 26)}");
						}
						$hSelectActor .= Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($userType), $userName);
					}
				} else {
					$hSelectActor = "";
				}
			}
			if ( strlen($hSelectActor) === 0 ){
				$hSelectActor = "&nbsp;";
			}
			
$arrHtmlList[] .= <<< HTML
			<div class="task-prop">
				<span class="task-prop-title">{$hRole}</span>
				<span class="task-prop-detail">
					{$hSelectActor}
				</span>
			</div>
HTML;
		}
		
		$html = implode("", $arrHtmlList);
		
		return $html;
	}

	function formDocument_ReadOnly( $isEdit, $name, $value, $select, $taskID ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TASK";
		
		if ( $isEdit || is_null($taskID) ){
			return parent::formDocument($isEdit, $name, $value, $select);
		}
			
		$html = "";
		
		// タスクで文書を表示させるとき、翻訳リンクや添削リンクを付ける
		if ( is_array($select) && count($select) > 0 ){
			foreach ( $select as $id => $text ){
				if ( is_array($value) && isset($value[$id]) ){
					$html .= Printer::ellipsis( Printer::link($text, NULL, "icon-file", NULL, "/content/document/detail.html?q_id={$id}"), 20, FALSE);
					
					$document = new Document($id);
					$qreditMode = $document->getQReditMode(User::get("id"), $taskID);
					if ( ($qreditInfo = $document->getQReditModeInfo($qreditMode, $id, $taskID)) !== FALSE ){
						$html .= Printer::link($qreditInfo["text"], "btn btn-danger", $qreditInfo["icon"], NULL, $qreditInfo["url"], NULL, $qreditInfo["opt"]);
					}
					if ( ($qreditMode !== FALSE) && $document->getQReditMode_Compare() ){
						if ( ($qreditInfo = $document->getQReditModeInfo(Document::QREDIT_MODE_COMPARE, $id, $taskID)) !== FALSE ){
							$html .= Printer::link($qreditInfo["text"], "btn btn-danger", $qreditInfo["icon"], NULL, $qreditInfo["url"], NULL, $qreditInfo["opt"]);
						}
					}
					if ( $qreditMode !== FALSE ){
						$html .= "<span style=\"padding-right: 10px;\"></span>";
					}
				} else {
					$html .= Printer::ellipsis( Printer::icon("icon-file", NULL, $text), 20, FALSE);
				}
			}
		}
		
		return $html;
	}
	
	
	function formObject( $taskType, $io, $arrTaskObject, $arrAppended, $taskID = NULL, $isEdit = FALSE, $isNew = FALSE ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TASK";
		
		$html = "";
		
		$setting = Task::SETTING_TABLE($taskType);
		
		// タスクで文書を表示させるとき、翻訳リンクや添削リンクを付ける
		$arrDocumentSuffix = array();
		foreach ( $arrAppended["document"] as $documentID => $documentTitle ){
			$document = new Document($documentID);
			if ( ($qreditMode = $document->getQReditMode(User::get("id"), $taskID)) !== FALSE ){
				$html = "";
				
				// 翻訳/添削ボタン
				if ( ($qreditInfo = $document->getQReditModeInfo($qreditMode, $documentID, $taskID)) !== FALSE ){
					$html .= Printer::link($qreditInfo["text"], "btn btn-danger", $qreditInfo["icon"], NULL, $qreditInfo["url"], NULL, $qreditInfo["opt"]);
				}
				// 比較ボタン
				if ( $document->getQReditMode_Compare() ){
					if ( ($qreditInfo = $document->getQReditModeInfo(Document::QREDIT_MODE_COMPARE, $documentID, $taskID)) !== FALSE ){
						$html .= Printer::link($qreditInfo["text"], "btn btn-danger", $qreditInfo["icon"], NULL, $qreditInfo["url"], NULL, $qreditInfo["opt"]);
					}
				}
				$html .= "<span style=\"padding-right: 10px;\"></span>";
				
				$arrDocumentSuffix[$documentID] = $html;
			}
		}
		
		$arrHtmlList = array();
		foreach ( $setting[$io] as $name => $set ){
			$arrOption = array();
			
			if ( isset($set["selected"]) && $set["selected"] === FALSE ){
				$isSelected = FALSE;
			} else {
				$isSelected = TRUE;
			}
			
			$propsType = $set["type"];
			if ( isset($set["label"]) ){
				$propLabel = Task::PROPLABEL_TABLE($set["label"]);
			} else if ( isset($set["clabel"]) ){
				$propLabel = $set["clabel"];
			} else {
				$propLabel = $name;
			}
			if ( $isSelected ){
				$hPropsName = Printer::label("label-danger", $propLabel);
			} else {
				$hPropsName = Printer::label("label-default", $propLabel);
			}
			$required = FALSE;
			if ( isset($set["require"]) && $set["require"] ){
				$hPropsName .= "<span class=\"form-required\">*</span>";
				$required = TRUE;
			}
			
			// 現在の設定を取得
			$data     = isset($arrTaskObject[$name]) ? $arrTaskObject[$name] : NULL;
			$dataText = isset($data[0]) ? $data[0] : "";
			if ( $isEdit && $isNew && isset($set["checked"]) && $set["checked"] ){
				// 新規登録する時、自動でONにする項目
				$data = TRUE;
			}
			if ( isset($set["sync"]) ){
				$arrOption["data-object-sync"] = $set["sync"];
			}
			// selectedがfalseの場合は表示のみ
			if ( $isSelected ){
				$isEditProp = $isEdit;
			} else {
				$isEditProp = FALSE;
				$data = TRUE;
			}
			
			// フォーム
			$eleName = "q_object[{$name}]";
			$hForm = "";
			switch ( $propsType ){
				case Task::PROPTYPE_NONE:
					break;
				case Task::PROPTYPE_TEXT:
					$hForm = $this->formText($isEditProp, $eleName, $dataText);
					break;
				case Task::PROPTYPE_DOCUMENT:
					if ( $isEditProp ){
						$arrDocument = array_diff_key($arrAppended["document"], $arrAppended["disabled-document"]);
						$hForm  = $this->formDocument($isEditProp, $eleName, $arrDocument, $data, $required, $arrOption, $arrDocumentSuffix);
						// disabled
						$arrOption["disabled"] = "disabled";
						$arrOption["label"] = array("disabled" => "disabled", "title" => "{$WORD($wk, 27)}");
						$hForm .= $this->formDocument($isEditProp, $eleName, $arrAppended["disabled-document"], $data, FALSE, $arrOption, $arrDocumentSuffix);
					} else {
						$hForm  = $this->formDocument($isEditProp, $eleName, $arrAppended["document"], $data, $required, $arrOption, $arrDocumentSuffix);
					}
					break;
				case Task::PROPTYPE_TERM_ROOT_ALL:
					$hForm = $this->formTerm($isEditProp, $eleName, $arrAppended["term"], $data, $required, $arrOption);
					break;
				case Task::PROPTYPE_TERM_ROOT_PROJECT:
					$hForm = $this->formTerm($isEditProp, $eleName, $arrAppended["term-normal"], $data, $required, $arrOption);
					break;
				case Task::PROPTYPE_TERM_ROOT_REFERENCE:
					$hForm = $this->formTerm($isEditProp, $eleName, $arrAppended["term-reference"], $data, $required, $arrOption);
					break;
				case Task::PROPTYPE_BILINGUAL_ROOT_ALL:
					$hForm = $this->formBilingual($isEditProp, $eleName, $arrAppended["bilingual"], $data, $required, $arrOption);
					break;
				case Task::PROPTYPE_BILINGUAL_ROOT_PROJECT:
					$hForm = $this->formBilingual($isEditProp, $eleName, $arrAppended["bilingual-normal"], $data, $required, $arrOption);
					break;
				case Task::PROPTYPE_BILINGUAL_ROOT_REFERENCE:
					$hForm = $this->formBilingual($isEditProp, $eleName, $arrAppended["bilingual-reference"], $data, $required, $arrOption);
					break;
				case Task::PROPTYPE_DATA_ALL:
					$hForm = $this->formData($isEditProp, $eleName, $arrAppended["data"], $data, $required, $arrOption);
					break;
				case Task::PROPTYPE_DATA_BRIEF:
					$hForm = $this->formData($isEditProp, $eleName, $arrAppended["data-brief"], $data, $required, $arrOption);
					break;
				case Task::PROPTYPE_DATA_DELIVERABLE:
					$hForm = $this->formData($isEditProp, $eleName, $arrAppended["data-deliver"], $data, $required, $arrOption);
					break;
				case Task::PROPTYPE_DATA_RESEARCH_RESULTS:
					$hForm = $this->formData($isEditProp, $eleName, $arrAppended["data-research"], $data, $required, $arrOption);
					break;
				case Task::PROPTYPE_DATA_OTHERS:
					$hForm = $this->formData($isEditProp, $eleName, $arrAppended["data-others"], $data, $required, $arrOption);
					break;
			}
			if ( strlen($hForm) === 0 ){
				$hForm = "&nbsp;";
			}
			
$arrHtmlList[] = <<< HTML
			<div class="task-prop">
				<span class="task-prop-title">{$hPropsName}</span>
				<span class="task-prop-detail">
					{$hForm}
				</span>
			</div>
HTML;
		}
		
		$html = implode("", $arrHtmlList);
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: selectTaskAndRole
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function selectTaskAndRole( $arrTaskData, $arrTaskActorData ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TASK";
		
		$html = "";

		$arrRole = array();
		foreach ( $arrTaskActorData as $dataTask ){
			$taskID    = $dataTask["t_task_id"];
			$taskRole  = $dataTask["t_task_role"];
			$arrRole[$taskID][] = $taskRole;
		}
		
		foreach ( $arrTaskData as $dataTask ){
			$taskID = $dataTask["t_task_id"];
			if ( ! isset($arrRole[$taskID]) ){
				continue;
			}
			// タスク
			$type = $dataTask["t_task_type"];
			$hText = TASK::TYPE_TABLE($type);
			// 状態
			$state = $dataTask["t_task_state"];
			$hState = $this->state($state);
			// 期間
			$start = $dataTask["t_task_start"];
			$end   = $dataTask["t_task_end"];
			$hDate = Printer::direct("icon-arrow-right", $start, $end);
			// 役割
			$hRole = "";
			foreach ( $arrRole[$taskID] as $role ){
				$arrOption = array(
					"data-task-id" => $taskID,
					"data-role"    => $role,
				);
				$hRole .= Printer::button(NULL, NULL, TASK::ROLE_TABLE($role), "btn-default", $arrOption);
			}
			
$html .= <<< HTML
			<tr>
				<td>{$hText}</td>
				<td>{$hState}</td>
				<td>{$hDate}</td>
				<td class="danger">{$hRole}</td>
			</tr>
HTML;
		}
		
$html = <<< HTML
		<div>
			<h5>{$WORD($wk, 28)}</h5>
			<table class="table table-striped">
				<thead>
					<tr>
						<th>{$WORD($wk, 29)}</th>
						<th>{$WORD($wk, 30)}</th>
						<th>{$WORD($wk, 31)}</th>
						<th class="danger">{$WORD($wk, 32)}</th>
					</tr>
				</thead>
				<tbody>
					{$html}
				</tbody>
			</table>
		</div>
HTML;

		return $html;
	}
	
	/***************************************************************
	 * 名前:xml2array
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	// private function xml2array( $xml, $kind, $key ){}
	// private function xml2arraySub($objXml) {}
	// -> View.php
}
