<?php require_once("class/View.php"); ?>
<?php
Class View_term extends View {
	/***************************************************************
	 * 名前: table
	 * 説明:
	 * 引数: kind (Term::KIND_XXX)
	 * 返値:
	****************************************************************/
	function table( $termRootID, $kind, $arrData = NULL, $isReadOnly = TRUE ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TERM";
		
		$html = "";
		
		$titleTerm = Term::KIND_TABLE($kind);
		
		if ( is_array($arrData) ){
			foreach ( $arrData as $data ){
				$id         = $data["t_term_id"];
				$textS      = $data["t_term_text_s"];
				$textT      = $data["t_term_text_t"];
				$termRootID = $data["t_term_root_id"];
				
				$hID    = Util::esc($id);
				$hTextS = Util::esc($textS);
				$hTextT = Util::esc($textT);
				
				$hButtons = "";
				if ( ! $isReadOnly ){
					$hButtonDelete = Printer::link("{$WORD($wk, 1)}", "btn btn-danger", NULL, NULL, NULL, "minhon.term.onClickDelete(this);");
					$hButtonUpdate = Printer::link("{$WORD($wk, 2)}", "btn btn-primary", NULL, NULL, NULL, "minhon.term.onClickUpdate(this);");
$hButtons = <<< HTML
						<span class="delete">{$hButtonDelete}</span>
						<span class="update">{$hButtonUpdate}</span>
HTML;
				}
				
$html .= <<< HTML
				<tr class="term_{$hID}">
					<td><span class="text">{$hTextS}</span></td>
					<td><span class="text">{$hTextT}</span></td>
					<td>{$hButtons}</td>
				</tr>
HTML;
			}
		}
		if ( ! $isReadOnly ){
			$hInputTextS = Printer::input("text", "text_s", "text_s", "");
			$hInputTextT = Printer::input("text", "text_t", "text_t", "");
			$hButtonTerm = Printer::link("{$WORD($wk, 3)}", "btn btn-primary", NULL, NULL, NULL, "minhon.term.onClickRegister();");
$html .= <<< HTML
			<tr id="term_register">
				<td>{$hInputTextS}</td>
				<td>{$hInputTextT}</td>
				<td class="col-tight">{$hButtonTerm}</td>
			</tr>
HTML;
		}
		
		$hHeaderTextS = "{$WORD($wk, 4)}";
		$hHeaderTextT = "{$WORD($wk, 5)}";
		$hHeaderOpe   = "{$WORD($wk, 6)}";
		if ( $isReadOnly ){
			$hHeaderOpe = "";
		}
		
		$hForm = "";
		if ( ! $isReadOnly ){
			$hID    = Printer::input("hidden", "q_id",    "q_id",    $termRootID);
			$hKind  = Printer::input("hidden", "q_kind",  "q_kind",  $kind);
			$hToken = Printer::input("hidden", "q_token", "q_token", Util::token());
$hForm = <<< HTML
			<form id="form_term" name="form_term">
				{$hID}
				{$hKind}
				{$hToken}
			</form>
HTML;
		}
		
$html = <<< HTML
		<table class="table table-striped">
			<thead>
				<tr>
					<th style="width: 50%;">{$hHeaderTextS}</th>
					<th style="width: 50%">{$hHeaderTextT}</th>
					<th class="col-tight">{$hHeaderOpe}</th>
				</tr>
			</thead>
			<tbody>
				{$html}
			</tbody>
		</table>
		{$hForm}
HTML;
		
		return $html;
	}
	
	
	/***************************************************************
	 * 名前: form
	 * 説明:
	 * 引数: 
	 * 返値:
	****************************************************************/
	function form( $textS, $textT, $arrDict ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TERM";
		
		global $G_LANG_TABLE;
		
		$html = "";
		
		$hTextS = Util::esc($textS);
		$hTextT = Util::esc($textT);
		
		// 用語集
		$arr = array();
		foreach ( $arrDict as $dict ){
			$dictID    = $dict["t_term_root_id"];
			$dictName  = $dict["t_term_root_name"];
			$dictLangS = $dict["t_term_root_lang_s"];
			$dictLangT = $dict["t_term_root_lang_t"];
			
			$arr[$dictID] = "{$dictName} ({$G_LANG_TABLE[$dictLangS]} - {$G_LANG_TABLE[$dictLangT]})";
		}
		
		$hRootID = Printer::select("q_root_id", "q_root_id", $arr);
		
		// 用語
		$hTextS = Printer::input("text", "q_text_s", "q_text_s", $textS);
		$hTextT = Printer::input("text", "q_text_t", "q_text_t", $textT);
		
$html = <<< HTML
		<form class="form-horizontal">
			<div class="form-group">
				<label class="col-sm-2">{$WORD($wk, 7)}</label>
				{$hRootID}
			</div>
			<div class="form-group">
				<label class="col-sm-2">{$WORD($wk, 8)}</label>
				{$hTextS}
			</div>
			<div class="form-group">
				<label class="col-sm-2">{$WORD($wk, 9)}</label>
				{$hTextT}
			</div>
		</form>
HTML;
		
		return $html;
	}
	
	
	/***************************************************************
	 * 名前: fileDescription
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function fileDescription( $kind ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TERM";
		
		$kindText = Term::KIND_TABLE($kind, FALSE);
		
		$html = "";
		
		$link = Printer::link("{$WORD($wk, 10)}", NULL, "icon-question-sign", NULL, "#");
		
$html = <<< HTML
		<div class="term_description">
			{$link}
			<div>
				<div>{$WORD($wk, 11)}</div>
				<ul>
					<li>
						<h5>{$WORD($wk, 12, $kindText)}</h5>
						<div>{$WORD($wk, 13, $kindText)}</div>
						<div>{$WORD($wk, 14)}</div>
						<div>{$WORD($wk, 15)}</div>
						<div>{$WORD($wk, 16, $kindText)}</div>
						<div>こんにちは(TAB)hello</div>
						<div>たまご(TAB)</div>
						<div>リンゴ(TAB)apple</div>
					</li>
					<!--
					<li>
						<h5>{$WORD($wk, 17, $kindText)}</h5>
						<div>{$WORD($wk, 18, $kindText)}</div>
					</li>
					<li>
						<h5>{$WORD($wk, 19, $kindText)}</h5>
						<div>{$WORD($wk, 20, $kindText)}</div>
					</li>
					-->
				</ul>
			</div>
		</div>
HTML;
		
		return $html;
	}
}
