<?php require_once("class/View.php"); ?>
<?php
Class View_term_root extends View {
	const TAB_LIST          = 0;
	const TAB_LIST_PROJECT  = 1;
	const TAB_LIST_REFRENCE = 2;
	const TAB_LIST_PUBLIC   = 3;
	const TAB_NEW           = 4;
	const TAB_EDIT          = 5;
	const TAB_IMPORT        = 6;
	const TAB_EXPORT        = 7;
	const TAB_ITEM_LIST     = 8;
	const TAB_ITEM_EDIT     = 9;
	const TAB_SEARCH        = 10;

	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $kind, $tab, $auth, $projectID, $rootID = 0 ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TERM_ROOT";
		
		$html = FALSE;
		$query = array(
			"q_kind"       => $kind,
			"q_project_id" => $projectID,
		);
		$kindText  = Term::KIND_TABLE($kind);
		$cKindText = Term::KIND_TABLE($kind, FALSE);
		
		switch ( $tab ){
			//------------------------
			// 用語集一覧
			case self::TAB_LIST:
				$html = $this->tab_list($kind, $auth, $projectID);
				break;
			//------------------------
			// プロジェクト用語集一覧
			case self::TAB_LIST_PROJECT:
				if ( $auth->readList($projectID) ){
					$query["q_type"] = DAO::T_TERM_ROOT_TYPE_NORMAL;
					$html = $this->tabLink("{$WORD($wk, 1, $kindText)}", NULL, NULL, NULL, "/content/term_root/", $query);
				}
				break;
			//------------------------
			// 参考用語集一覧
			case self::TAB_LIST_REFRENCE:
				if ( $auth->readList($projectID) ){
					$query["q_type"] = DAO::T_TERM_ROOT_TYPE_REFERENCE;
					$html = $this->tabLink("{$WORD($wk, 2, $kindText)}", NULL, NULL, NULL, "/content/term_root/", $query);
				}
				break;
			//------------------------
			// 公開用語集一覧
			case self::TAB_LIST_PUBLIC:
				if ( $auth->write(INIT_ID, $projectID) ){
					$query["q_is_public"] = ON;
					$html = $this->tabLink("{$WORD($wk, 3, $kindText)}", NULL, NULL, NULL, "/content/term_root/", $query);
				}
				//$html = $this->tab_list_public( $kind, $auth, $projectID );
				break;
			//------------------------
			// 用語集新規登録
			case self::TAB_NEW:
				if ( $auth->write(INIT_ID, $projectID) ){
					$html = $this->tabLink("{$WORD($wk, 4, $kindText)}", NULL, "icon-plus", NULL, "/content/term_root/edit.html", $query);
				}
				break;
			//------------------------
			// 用語集編集
			case self::TAB_EDIT:
				if ( $auth->write($rootID, $projectID) ){
					$query["q_id"] = $rootID;
					$html = $this->tabLink("{$WORD($wk, 5, $kindText)}", NULL, "icon-pencil", NULL, "/content/term_root/edit.html", $query);
				}
				break;
			//------------------------
			// 用語集インポート
			case self::TAB_IMPORT:
				if ( $auth->processImport($rootID, $projectID) ){
					$query["q_id"] = $rootID;
					$html = $this->tabLink("{$WORD($wk, 6)}", NULL, "icon-open", NULL, "/content/term/import.html", $query);
				}
				break;
			//------------------------
			// 用語集エクスポート（ファイル出力）
			case self::TAB_EXPORT:
				if ( $auth->processExport($rootID, $projectID) ){
					$query["q_id"] = $rootID;
					$html = $this->tabLink("{$WORD($wk, 7)}", NULL, "icon-save", NULL, "/content/term/export.html", $query);
				}
				break;
			//------------------------
			// 用語一覧
			case self::TAB_ITEM_LIST:
				if ( $auth->read($rootID, $projectID) ){
					$query["q_id"] = $rootID;
					$html = $this->tabLink("{$WORD($wk, 8, $cKindText)}", NULL, NULL, NULL, "/content/term/", $query);
				}
				break;
			//------------------------
			// 用語登録
			case self::TAB_ITEM_EDIT:
				if ( $auth->read($rootID, $projectID) && $auth->write($rootID, $projectID) ){
					$query["q_id"] = $rootID;
					$html = $this->tabLink("{$WORD($wk, 9, $cKindText)}", NULL, NULL, NULL, "/content/term/", $query);
				}
				break;
			//------------------------
			// 検索
			case self::TAB_SEARCH:
				if ( $kind === Term::KIND_BILINGUAL ){
					$authProject = Auth::instance("project");
					if ( $authProject->processBSearch($projectID) ){
						$arrQuery = array(
							"q_project_id" => $projectID,
							"q_mode" => CONTENT_SEARCH_INDEX_MODE_BILINGUAL,
						);
						$html = Printer::link("{$WORD($wk, 10)}", "tab-search", "icon-search", NULL, "/content/search/?".http_build_query($arrQuery), NULL, array("target"=>"_blank"));
					}
				}
				break;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab_list( $kind, $auth, $projectID ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TERM_ROOT";
		
		$html = FALSE;
		
		$kindText  = Term::KIND_TABLE($kind);
		
		$arrPullDown = array();
		// プロジェクト用語集
		if ( $auth->readList($projectID) ){
			$query = array(
				"q_kind"       => $kind,
				"q_project_id" => $projectID,
				"q_type"       => DAO::T_TERM_ROOT_TYPE_NORMAL,
			);
			$arrPullDown[self::TAB_LIST_PROJECT] = $this->tabLink("{$WORD($wk, 11, $kindText)}", NULL, NULL, NULL, "/content/term_root/", $query);
		}
		// 参考用語集
		if ( $auth->readList($projectID) ){
			$query = array(
				"q_kind"       => $kind,
				"q_project_id" => $projectID,
				"q_type"       => DAO::T_TERM_ROOT_TYPE_REFERENCE,
			);
			$arrPullDown[self::TAB_LIST_REFRENCE] = $this->tabLink("{$WORD($wk, 12, $kindText)}", NULL, NULL, NULL, "/content/term_root/", $query);
		}
		// 公開用語集
		if ( $auth->write(INIT_ID, $projectID) ){
			$query = array(
				"q_kind"       => $kind,
				"q_project_id" => $projectID,
				"q_is_public"  => ON,
			);
			$arrPullDown[self::TAB_LIST_PUBLIC] = $this->tabLink("{$WORD($wk, 13, $kindText)}", NULL, NULL, NULL, "/content/term_root/", $query);
		}
		
		if ( count($arrPullDown) === 0 ){
			return $html;
		}
		
		$html = array(
			"title" => "{$WORD($wk, 14, $kindText)}",
			"item"  => $arrPullDown,
		);
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: table
	 * 説明:
	 * 引数: kind (Term::KIND_XXX)
	 * 返値:
	****************************************************************/
	function table( $kind, $tablist, $projectID, $arrData, $arrProjectTermRoot, $query ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_TERM_ROOT";
		
		$kindText  = Term::KIND_TABLE($kind);
		
		$auth = Auth::instance("term_root", $kind);
		
		$html = "";
		$htmlError = "";
		
		$titleTerm = Term::KIND_TABLE($kind);
		
		// 登録者情報表示
		$viewRegister = TRUE;
		if ( $tablist === self::TAB_LIST_PUBLIC ){
			$viewRegister = FALSE;
		}
		// プロジェクト、組織情報
		$viewBelong = TRUE;
		if ( $tablist === self::TAB_LIST_PROJECT ){
			$viewBelong = FALSE;
		}
		
		// 公開範囲のフィルタ
		$filterPublic = DAO::T_TERM_ROOT_PUBLIC_TABLE();
		if ( $tablist === self::TAB_LIST_PUBLIC ){
			unset($filterPublic[DAO::T_TERM_ROOT_PUBLIC_PRJ]);
		}
		
		$arrPrepareProjectTermRoot = array();
		$arrUser = array();
		foreach ( $arrProjectTermRoot as $dataProjectTermRoot ){
			$termRootID = $dataProjectTermRoot["t_term_root_id"];
			$userID     = $dataProjectTermRoot["t_user_id"];
			if ( $userID === INIT_ID || isset($arrPrepareProjectTermRoot[$termRootID]) ){
				continue;
			}
			
			if ( ! isset($arrUser[$userID]) ){
				$arrUser[$userID] = Util::esc(DAO::storedFunction("get_user_name", $userID));
			}
			$dataProjectTermRoot["t_user_name"] = $arrUser[$userID];
			$arrPrepareProjectTermRoot[$termRootID] = $dataProjectTermRoot;
		}
		
		$organizationID = DAO::storedFunction("get_project_organization_id", $projectID);
		
		foreach ( $arrData as $data ){
			$id               = $data["t_term_root_id"];
			$state            = $data["t_term_root_state"];
			$public           = $data["t_term_root_public"];
			$name             = $data["t_term_root_name"];
			$langS            = $data["t_term_root_lang_s"];
			$langT            = $data["t_term_root_lang_t"];
			$extermState      = $data["t_exterm_state"];
			$organizationName = $data["t_organization_name"];
			$termProjectID    = $data["t_project_id"];
			$termProjectName  = $data["t_project_name"];
			if ( isset($arrPrepareProjectTermRoot[$id]) ){
				$type  = $arrPrepareProjectTermRoot[$id]["t_project_term_root_type"];
				$user  = $arrPrepareProjectTermRoot[$id]["t_user_name"];
			} else {
				$type  = NULL;
				$user  = " - ";
			}
			
			// 状態によるチェック
			$isErrorState = ($state !== DAO::T_TERM_ROOT_STATE_NORMAL);
			
			// 公開範囲によるチェック
			switch ( $public ){
				case DAO::T_TERM_ROOT_PUBLIC_PRJ:
					$isErrorPublic = ($termProjectID !== $projectID);
					break;
				case DAO::T_TERM_ROOT_PUBLIC_ORG:
					$isErrorPublic = (DAO::storedFunction("get_project_organization_id", $termProjectID) !== $organizationID);
					break;
				case DAO::T_TERM_ROOT_PUBLIC_OPN:
					$isErrorPublic = FALSE;
					break;
				default:
					$isErrorPublic = TRUE;
			}
			
			$isError = $isErrorPublic || $isErrorState;
			$isAuthRefrence = (! $isError) && $auth->refrence($id, $projectID);
			
			// 名前
			$icon = ($projectID === $termProjectID || $tablist === self::TAB_LIST_PUBLIC) ? "icon-book" : "icon-share-alt";
			$hName = Printer::ellipsis($name, 20);
			if ( $isErrorState ){
				$hName = Printer::iconWarning("{$WORD($wk, 15)}")." ".$hName;
			} else if ( $isErrorPublic ){
				$hName = Printer::iconWarning("{$WORD($wk, 16)}")." ".$hName;
			} else if ( $auth->read($id, $projectID) ){
				$hName = Printer::link($hName, NULL, $icon, NULL, "/content/term/index.html?q_kind={$kind}&q_id={$id}", NULL, NULL, FALSE);
			} else {
				$hName = Printer::icon($icon)." ".$hName;
			}
			// 公開
			$hPublic = DAO::T_TERM_ROOT_PUBLIC_TABLE($public);
			// 言語方向
			$hLang = Printer::directLang($langS, $langT);
			// 登録者
			$hRegister = Util::esc($user);
			// プロジェクト名
			$hProjectName = Printer::icon("icon-th") . " " . Printer::ellipsis($termProjectName, 10);
			// 組織
			$hOrganizationName = Printer::icon("icon-star") . " " . Util::esc($organizationName);
			
			// 操作
			$hOperation = "";
			// タイプによって操作ボタンを変更する
			$arrButton = array();
			if ( $type === DAO::T_TERM_ROOT_TYPE_REFERENCE || $type === NULL ){
				// プロジェクト用語集
				if ( $termProjectID !== $projectID ){
					$message = "{$WORD($wk, 17, $kindText)}"."\\n"."{$WORD($wk, 18, $kindText)}"."\\n\\n"."{$WORD($wk, 19, $kindText)}";
				} else {
					$message = "{$WORD($wk, 20)}";
				}
				$arrButton[] = array(
					"class" => $isAuthRefrence ? "" : "disabled",
					"text"  => Printer::link("{$WORD($wk, 21, $kindText)}", NULL, "icon-none", NULL, NULL, "minhon.common.onClickRequest('./project.html', {q_kind:'{$kind}'}, {q_id:{$id}, q_project_id:{$projectID}, q_type:".DAO::T_TERM_ROOT_TYPE_NORMAL."}, '{$message}');"),
				);
			}
			if ( $type === DAO::T_TERM_ROOT_TYPE_NORMAL || $type === NULL ){
				// 参考用語集
				$message = "{$WORD($wk, 22)}";
				$arrButton[] = array(
					"class" => $isAuthRefrence ? "" : "disabled",
					"text"  => Printer::link("{$WORD($wk, 23, $kindText)}", NULL, "icon-none", NULL, NULL, "minhon.common.onClickRequest('./project.html', {q_kind:'{$kind}'}, {q_id:{$id}, q_project_id:{$projectID}, q_type:".DAO::T_TERM_ROOT_TYPE_REFERENCE."}, '{$message}');"),
				);
			}
			if ( $type !== NULL ){
				$arrButton[] = "-";
				// 編集
				if ( $auth->write($id, $projectID) ){
					$arrButton[] = array(
						"class" => (! $isError) ? "" : "disabled",
						"text"  => Printer::link("{$WORD($wk, 24, $kindText)}", NULL, "icon-pencil", NULL, "/content/term_root/edit.html?q_kind={$kind}&q_id={$id}"),
					);
				}
				// ファイル登録
				if ( $auth->processImport($id, $projectID) ){
					$arrButton[] = array(
						"class" => (! $isError) ? "" : "disabled",
						"text"  => Printer::link("{$WORD($wk, 25)}", NULL, "icon-open", NULL, "/content/term/import.html?q_kind={$kind}&q_id={$id}"),
					);
				}
				// ダウンロード
				if ( $auth->processExport($id, $projectID) ){
					$arrButton[] = array(
						"class" => (! $isError) ? "" : "disabled",
						"text"  => Printer::link("{$WORD($wk, 26)}", NULL, "icon-save", NULL, "/content/term/export.html?q_kind={$kind}&q_id={$id}"),
					);
				}
				// コピー
				if ( $auth->processCopy($id, $projectID) ){
					$arrButton[] = array(
						"class" => (! $isError) ? "" : "disabled",
						"text"  => Printer::link("{$WORD($wk, 27)}", NULL, "icon-book", NULL, NULL, "minhon.common.onClickGet('./edit.html', {q_copy_id:{$id}, q_kind:'{$kind}'}, '{$WORD($wk, 28)}');"),
					);
				}
				// 削除
				if ( $auth->remove($id, $projectID) ){
					$arrButton[] = array(
						"class" => (! $isError) ? "" : "disabled",
						"text"  => Printer::link("{$WORD($wk, 29)}", NULL, "icon-remove", NULL, NULL, "minhon.common.onClickRequest('./delete.html', {q_kind:'{$kind}'}, {q_id:{$id}}, '{$WORD($wk, 30)}');"),
					);
				}
				
				// 利用登録解除
				if ( $termProjectID !== $projectID && ($type !== DAO::T_TERM_ROOT_TYPE_NORMAL || $isError) ){
					$arrButton[] = "-";
					$arrButton[] = Printer::link("{$WORD($wk, 31)}", NULL, "icon-minus", NULL, NULL, "minhon.common.onClickRequest('./project.html', {q_kind:'{$kind}'}, {q_id:{$id}, q_delete:".ON."}, '{$WORD($wk, 32)}');");
				}
				
				if ( ! is_array(end($arrButton)) && strcmp(end($arrButton), "-") === 0 ){
					$arrButton = array_splice($arrButton, -1);
				}
			}
			// 操作
			$hOperation = Printer::buttonGroup("{$WORD($wk, 33)}", $arrButton);
			
			$hRow = "";
			// 名前
			$hRow .= "<td>{$hName}</td>";
			// 公開範囲
			$hRow .= "<td>{$hPublic}</td>";
			// 言語
			$hRow .= "<td>{$hLang}</td>";
			if ( $viewRegister ){
				// 登録者
				$hRow .= "<td>{$hRegister}</td>";
			}
			if ( $viewBelong ){
				// プロジェクト
				$hRow .= "<td>{$hProjectName}</td>";
				// 組織
				$hRow .= "<td>{$hOrganizationName}</td>";
			}
			// 操作
			$hRow .= "<td class=\"col-tight\">{$hOperation}</td>";
			$hRow = "<tr>{$hRow}</tr>";
			
			// UNLINKの用語集は強調表示
			if ( $isError ){
				$htmlError .= $hRow;
			} else {
				$html .= $hRow;
			}
		}
		
		if ( strlen($htmlError) > 0 ){
$htmlError = <<< HTML
			<thead class="thead-danger">
				<tr>
					<th colspan="9">{$WORD($wk, 34)}</th>
				</tr>
			</thead>
			<tbody class="tbody-danger">
				{$htmlError}
			</tbody>
HTML;
		}
		
		$hRow = "";
		// 名前
		$hRow .= "<th>{$WORD($wk, 35)}</th>";
		// 公開範囲
		$headerPublic = $this->tableHeaderQueryFilter("{$WORD($wk, 36)}", $filterPublic, $query, "q_public", DAO_term_root::ORDER_KEY_PUBLIC);
		$hRow .= "<th>{$headerPublic}</th>";
		// 言語
		$hRow .= "<th>{$WORD($wk, 37)}</th>";
		if ( $viewRegister ){
			// 登録者
			$hRow .= "<th>{$WORD($wk, 38)}</th>";
		}
		if ( $viewBelong ){
			// プロジェクト
			$hRow .= "<th>{$WORD($wk, 39)}</th>";
			// 組織
			$hRow .= "<th>{$WORD($wk, 40)}</th>";
		}
		// 操作
		$hRow .= "<th class=\"col-tight\">{$WORD($wk, 41)}</th>";
		
$html = <<< HTML
		<table class="table table-striped">
			<thead>
				<tr>
					{$hRow}
				</tr>
			</thead>
			<tbody>
				{$html}
			</tbody>
			{$htmlError}
		</table>
HTML;
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:title
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function title( $data ){
		$name   = Util::esc($data["t_term_root_name"]);
		$langS  = $data["t_term_root_lang_s"];
		$langT  = $data["t_term_root_lang_t"];
		$public = $data["t_term_root_public"];
		
		$lang  = Printer::directLang($langS, $langT);
		$name  = Printer::ellipsis($name, 10, FALSE);
		$title = "{$name}({$lang}、".DAO::T_TERM_ROOT_PUBLIC_TABLE($public).")";
		
		return $title;
	}
}
