<?php require_once("class/View.php"); ?>
<?php
Class View_user extends View {
	const TAB_LIST     = 0;
	const TAB_LIST_ALL = 1;
	const TAB_NEW      = 2;
	const TAB_EDIT     = 3;
	
	const LIST_VIEW_ORG = 0;
	const LIST_VIEW_ALL = 1;
	public static function LIST_VIEW_TABLE( $key = NULL ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_USER";
		
		$arr = array(
			self::LIST_VIEW_ORG => "{$WORD($wk, 1)}",
			self::LIST_VIEW_ALL => "{$WORD($wk, 2)}",
		);
		
		if ( is_null($key) ){
			return $arr;
		} else {
			return $arr[$key];
		}
	}
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function tab( $tab, $auth, $orgID, $id = 0 ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_USER";
		
		$html = FALSE;
		$query = array();
		
		switch ( $tab ){
			//------------------------
			// ユーザ一覧
			case self::TAB_LIST:
				if ( $auth->readList($orgID) ){
					$query["q_org_id"] = $orgID;
					$html = $this->tabLink("{$WORD($wk, 3)}", NULL, NULL, NULL, "/content/user/", $query);
				}
				break;
			//------------------------
			// 全ユーザ一覧
			case self::TAB_LIST_ALL:
				if ( $auth->readList(INIT_ID) ){
					$html = $this->tabLink("{$WORD($wk, 4)}", NULL, NULL, NULL, "/content/user/", $query);
				}
				break;
			//------------------------
			// ユーザ新規登録
			case self::TAB_NEW:
				if ( $auth->write(INIT_ID, $orgID) ){
					$query["q_organization_id"] = $orgID;
					$html = $this->tabLink("{$WORD($wk, 5)}", NULL, "icon-plus", NULL, "/content/user/edit.html", $query);
				}
				break;
			//------------------------
			// ユーザ編集
			case self::TAB_EDIT:
				if ( $auth->write($id, $orgID) ){
					$query["q_id"] = $id;
					$html = $this->tabLink("{$WORD($wk, 6)}", NULL, "icon-pencil", NULL, "/content/user/edit.html", $query);
				}
				break;
		}
		
		return $html;
	}
	
	/***************************************************************
	 * 名前:
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function table( $arrData, $searchValue, $searchOrgID, $query, $viewOrg = FALSE ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_USER";
		
		if ( isset($query["q_offset"]) ){
			unset($query["q_offset"]);
		}
		
		$auth = Auth::instance("user");
		
		$html = "";
		
		$viewDetail = $auth->readList_isInfo($searchOrgID);
		foreach ( $arrData as $data ){
			$arrCol = array();
			
			$id            = $data["t_user_id"];
			$name          = $data["t_user_name"];
			$state         = $data["t_user_state"];
			$type          = $data["t_user_type"];
			$register      = $data["t_user_register"];
			$warnNonActive = $data["t_user_warn_non_active"];
			$orgID         = $data["t_organization_id"];
			$orgName       = $data["t_organization_name"];
			if ( $state === DAO::T_USER_STATE_QUIT ){
				$warnNonActive = DAO::T_USER_WARN_NON_ACTIVE_HIDE;
			}
			$disabledRegister = $disabledLastLoginDate = $disabledNonActive = $viewDetail && $auth->readList_isInfo($orgID);
			
			// ID
			$hID = Util::esc($id);
			
			// 名前
			$hName = Printer::icon("icon-user", DAO::T_USER_TYPE_COLOR_TABLE($type), $name);
			if ( $auth->write($id, $orgID) ){
				$hName = Printer::link($name, NULL, "icon-user", DAO::T_USER_TYPE_COLOR_TABLE($type), "/content/user/edit.html?q_id={$id}");
			}
			$arrCol[] = $hName;
			
			// タイプ
			$bufQuery = $query;
			$bufQuery["q_type"] = $type;
			$hType = Printer::link(DAO::T_USER_TYPE_TABLE($type), NULL, NULL, NULL, "/content/user/?".http_build_query($bufQuery));
			$arrCol[] = $hType;
			
			// 状態
			if ( $auth->write($id, $orgID) ){
				$arrButton = array();
				foreach ( DAO::T_USER_STATE_TABLE() as $key => $text ){
					$stateClass = ($state === $key) ? "icon-arrow-right" : "icon-none";
					$arrButton[] = Printer::link($text, NULL, $stateClass, NULL, NULL, "minhon.user.onClickUserState(this);", array("data-state"=>$key));
				}
				$hState = Printer::buttonGroup( DAO::T_USER_STATE_TABLE($state), $arrButton, "non", array("class"=>DAO::T_USER_STATE_ALERT_TABLE($state)));
				// クラス名で "btn-non" にしてるが、cssでは使用していない
			} else {
				$stateClass = DAO::T_USER_STATE_ALERT_TABLE($state);
				$stateText  = DAO::T_USER_STATE_TABLE($state);
				$hState = "<span class=\"btn disabled {$stateClass} no-opacity\">{$stateText}</span>";
				//$hState = " - ";
			}
			$arrCol[] = $hState;
			
			// 組織
			if ( $viewOrg ){
				$bufQuery = array();
				$bufQuery["q_view"] = self::LIST_VIEW_ALL;
				$bufQuery["q_org_id"] = $orgID;
				$hOrgName = Printer::link($orgName, NULL, "icon-star", NULL, "/content/user/?".http_build_query($bufQuery));
				$arrCol[] = $hOrgName;
			} else {
				$hOrgName = Printer::icon("icon-star", NULL, $orgName, NULL);
			}
			
			// 登録日時
			if ( $viewDetail ){
				if ( $disabledRegister ){
					if ( Validate::isDateTime($register) ){
						$hRegister = Printer::icon("icon-time", NULL, $register);
					} else {
						$hRegister = " - ";
					}
					$arrCol[] = array("value"=>$hRegister, "class"=>"col-tight");
				} else {
					$arrCol[] = array("value"=>" - ", "class"=>"active col-tight");
				}
			}
			
			// 最終ログイン日時
			if ( $viewDetail ){
				if ( $disabledLastLoginDate ){
					$loginDate = DAO::storedFunction("get_last_login_date_by_user_id", $id);
					if ( ! is_null($loginDate) ){
						$diff = floor((time() - strtotime($loginDate)) / (60*60*24));
						$hLastLoginDate = Util::esc("{$WORD($wk, 7, $diff)}") . "<span style=\"margin-left: 5px; font-size: 90%\">(".Util::esc($loginDate).")</span>";
					} else {
						$hLastLoginDate = " - ";
					}
					$arrCol[] = $hLastLoginDate;
				} else {
					$arrCol[] = array("value"=>" - ", "class"=>"active");
				}
			}
			
			// 非活発ユーザー表示
			if ( $viewDetail ){
				if ( $disabledNonActive ){
					if ( $auth->write_isLoginState($id, $orgID) ){
						$nonActiveClass = DAO::T_USER_WARN_NON_ACTIVE_ALERT_TABLE($warnNonActive);
						$nonActiveText  = DAO::T_USER_WARN_NON_ACTIVE_TABLE($warnNonActive);
						if ( $state === DAO::T_USER_STATE_QUIT ){
							// 非表示
							$nonActiveClass = DAO::T_USER_WARN_NON_ACTIVE_ALERT_TABLE(DAO::T_USER_WARN_NON_ACTIVE_HIDE);
							$nonActiveText  = DAO::T_USER_WARN_NON_ACTIVE_TABLE(DAO::T_USER_WARN_NON_ACTIVE_HIDE);
							$hWarnNonActive = "<span class=\"btn disabled {$nonActiveClass} no-opacity\">{$nonActiveText}</span>";
						} else {
							// ドロップダウンリスト
							$arrButton = array();
							foreach ( DAO::T_USER_WARN_NON_ACTIVE_TABLE() as $key => $text ){
								$class = ($warnNonActive === $key) ? "icon-arrow-right" : "icon-none";
								$arrButton[] = Printer::link($text, NULL, $class, NULL, NULL, "minhon.user.onClickWarnNonActive(this);", array("data-value"=>$key));
							}
							$hWarnNonActive = Printer::buttonGroup( $nonActiveText, $arrButton, "non", array("class"=>$nonActiveClass));
						}
						$hWarnNonActive .= Printer::link("{$WORD($wk, 8)}", "hide state-change-reload", NULL, NULL, NULL, "minhon.common.reload()");
					} else {
						$nonActiveClass = DAO::T_USER_WARN_NON_ACTIVE_ALERT_TABLE($warnNonActive);
						$nonActiveText  = DAO::T_USER_WARN_NON_ACTIVE_TABLE($warnNonActive);
						$hWarnNonActive = "<span class=\"btn disabled {$nonActiveClass} no-opacity\">{$nonActiveText}</span>";
					}
					$arrCol[] = $hWarnNonActive;
				} else {
					$arrCol[] = array("value"=>" - ", "class"=>"active");
				}
			}
			
			// 行クラス
			$hTrClass = "";
			if ( $state === DAO::T_USER_STATE_QUIT ){
				$hTrClass = "active";
			}
			
			$htmlCol = "";
			foreach ( $arrCol as $col ){
				if ( is_array($col) ){
					$colValue = isset($col["value"]) ? $col["value"] : "";
					$colAttr = "";
					if ( isset($col["class"]) ){
						$colAttr .= " class=\"".$col["class"]."\"";
					}
					$htmlCol .= "<td{$colAttr}>{$colValue}</td>";
				} else {
					$htmlCol .= "<td>{$col}</td>";
				}
			}
			
$html .= <<< HTML
			<tr class="{$hTrClass}" data-user-id="{$hID}">
				{$htmlCol}
			</tr>
HTML;
		}

		// 名前
		$arrHeader[] = $this->tableHeader("{$WORD($wk, 9)}", "icon-search", NULL, array(
			Printer::link("{$WORD($wk, 10)}", NULL, "icon-search", NULL, NULL, "minhon.user.onClickFilterName();"),
			Validate::isString($searchValue) ? Printer::link("{$WORD($wk, 11)}", NULL, "icon-none", NULL, NULL, "minhon.user.onClickFilterNameClear();") : NULL,
		), $query, "q_keyword", DAO_user::ORDER_KEY_NAME);
		// タイプ
		$isSysMgr = Auth::isSysMgr(User::get("type"), User::get("id"));
		$headerType  = $this->tableHeaderQueryFilter("{$WORD($wk, 12)}", DAO::T_USER_TYPE_TABLE(NULL, ! $isSysMgr), $query, "q_type", DAO_user::ORDER_KEY_TYPE);
		$arrHeader[] = $headerType;
		// 状態
		$headerState = $this->tableHeaderQueryFilter("{$WORD($wk, 13)}", DAO::T_USER_STATE_TABLE(), $query, "q_state", DAO_user::ORDER_KEY_STATE);
		$arrHeader[] = $headerState;
		if ( $viewOrg ){
			//組織
			$arrDropdown = array();
			$icon = NULL;
			if ( isset($query["q_org_id"]) ){
				$icon = "icon-filter";
				$subQuery = $query;
				unset($subQuery["q_offset"]);
				unset($subQuery["q_org_id"]);
				$arrDropdown[] = $this->tabLink("{$WORD($wk, 14)}", NULL, "icon-none", NULL, "./", $subQuery);
			}
			$arrHeader[] = $this->tableHeader("{$WORD($wk, 15)}", $icon, NULL, $arrDropdown, $query, "q_org_id" );
		}
		// 登録日時
		if ( $viewDetail ){
			$headerRegister = $this->tableHeader("{$WORD($wk, 16)}", NULL, NULL, NULL, $query, NULL, DAO_user::ORDER_KEY_REGISTER);
			$arrHeader[] = array("value"=>$headerRegister, "class"=>"col-tight");
		}
		// 最終ログイン日
		if ( $viewDetail ){
			$arrHeader[] = "{$WORD($wk, 17)}";
		}
		// 非活発ユーザ表示
		if ( $viewDetail ){
			$arrHeader[] = "{$WORD($wk, 18)}";
		}
		
		$htmlHeader = "";
		foreach ( $arrHeader as $header ){
			if ( is_array($header) ){
				$headerValue = isset($header["value"]) ? $header["value"] : "";
				$headerAttr = "";
				if ( isset($header["class"]) ){
					$headerAttr .= " class=\"".$header["class"]."\"";
				}
				$htmlHeader .= "<th{$headerAttr}>{$headerValue}</th>";
			} else {
				$htmlHeader .= "<th>{$header}</th>";
			}
		}
		
$html = <<< HTML
		<table class="table table-grid">
			<thead>
				{$htmlHeader}
			</thead>
			<tbody>
				{$html}
			</tbody>
		</table>
HTML;
		
		$html .= $this->_tableDialogFilterName($searchValue, $searchOrgID);
		
		return $html;
	}
	
	/***************************************************************
	 * 名前: _tableDialogFilterName
	 * 説明:
	 * 引数:
	 * 返値:
	****************************************************************/
	function _tableDialogFilterName( $keyword, $orgID ){
		global $WORD;
		$wk = "WORD_P_CLASS_VIEW_USER";
		
		$html = "";
		
		$arrControl = array();
		$arrControl[] = array(
			"id" => NULL,
			"name" => "{$WORD($wk, 19)}",
			"form" => Printer::input("text", "q_keyword", "q_keyword", $keyword, "typeahead", array("style"=>"width: 100%", "data-provide"=>"typeahead", "autocomplete"=>"off")),
		);
		$arrControl[] = array(
			"id" => NULL,
			"name" => NULL,
			"form" => Printer::input("hidden", NULL, "q_org_id", $orgID),
		);
		$form = Printer::formControl($arrControl, FALSE, TRUE);
		
$html = <<< HTML
		<div id="dialog_user_filter_name" class="dialog">
			<form>
				<table class="table except-table-cell">
					{$form}
				</table>
			</form>
		</div>
HTML;
		
		return $html;
	}
	
}
