<?php require_once(dirname(__FILE__) . "/setting.ini"); ?>
<?php require_once("class/DocTmx.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : Version12.11にアップデートするさいに実行する処理
//   ・t_document.t_document_textで保持しているTMXの原タイトルをt_document.t_document_titleに変更する。
//     (訳タイトルは現状のまま。)
//
// argument : 
//--------------------------------------------------------------------
// タイムアウト解除
set_time_limit(0);

//----------------------------
// define
//----------------------------

//----------------------------
// function
//----------------------------
function main(){
	DAO::connect();
	
	$objDAODocument = DAO::instance("document");
	
	$objDocTmx = new DocTmx();
	
	// *実行
	$offset = 0;
	$limit = 1000;
	do {
		$resDAODocument = $objDAODocument->get(NULL, NULL, NULL, NULL, array("t_document_id" => DAO::ASC), $limit, $offset);
		if ( $resDAODocument["result"] === RES_OK ){
			foreach ( $resDAODocument["data"] as $dataDocument ){
				$id    = $dataDocument["t_document_id"];
				$tmx   = $dataDocument["t_document_text"];
				$title = $dataDocument["t_document_title"];
				if ( mb_strlen($tmx) === 0 ){
					echo "Warning | 文書が空のためスキップします。(id:{$id})\n";
					continue;
				}
				if ( ! $objDocTmx->load($tmx) ){
					echo "Warning | 不正な文書が登録されています。(id:{$id})\n";
					continue;
				}
				
				// タイトル変更
				$objDocTmx->setHeaderPropValue("source_title", $title, TRUE);
				
				// tmxを更新
				$tmx = $objDocTmx->saveXML();
				$resDAODocumentAdd = $objDAODocument->register($id, NULL, NULL, NULL, NULL,$tmx);
				
				if ( $resDAODocumentAdd["result"] === RES_OK ){
					echo "Success | 文書を更新しました。(id:{$id})\n";
				} else {
					echo "Warning | 文書の更新に失敗しました。(id:{$id})\n";
				}
			}
		} else if ( $resDAODocument["result"] === RES_NO_DATA ){
			echo "Warning | 文書が見つかりませんでした。\n";
			break;
		} else {
			echo "Error   | 文書の取得に失敗しました。\n";
			break;
		}
		$offset += $limit;
	} while ( $resDAODocument["count"] > $offset );
	
}

//----------------------------
// process
//----------------------------
// 引数チェック
if ( $argc === 1 ){
	main();
} else {
	echo "usage:\n";
	echo "php -f run.php\n";
}
