<?php require_once(dirname(__FILE__) . "/setting.ini"); ?>
<?php require_once("class/DocTmx.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : Version12.8にアップデートするさいに実行する処理
//   ・t_document.t_document_textから原文、訳文を抽出し、t_document_textに追加します
//
// argument : 
//--------------------------------------------------------------------
// タイムアウト解除
set_time_limit(0);

//----------------------------
// define
//----------------------------

//----------------------------
// function
//----------------------------
function main(){
	DAO::connect();
	
	$objDAODocument     = DAO::instance("document");
	$objDAODocumentText = DAO::instance("document_text");
	
	// 予め既に登録された文書テキストをすべて削除する
	$resDAODocumentText = $objDAODocumentText->delete(NULL, array("type"=>DAO::TYPE_NOT, "value"=>0));
	if ( $resDAODocumentText["result"] === RES_NG ){
		echo "Error   | 既存の文書テキストの削除に失敗しました。\n";
		return;
	}
	
	$objDocTmx = new DocTmx();
	
	// *実行
	$offset = 0;
	$limit = 1000;
	do {
		$resDAODocument = $objDAODocument->get(NULL, array_keys(DAO::T_DOCUMENT_STATE_VALID_TABLE()), NULL, NULL, array("t_document_id" => DAO::ASC), $limit, $offset);
		if ( $resDAODocument["result"] === RES_OK ){
			foreach ( $resDAODocument["data"] as $dataDocument ){
				$id  = $dataDocument["t_document_id"];
				$tmx = $dataDocument["t_document_text"];
				if ( mb_strlen($tmx) === 0 ){
					echo "Warning | 文書が空のためスキップします。(id:{$id})\n";
					continue;
				}
				if ( ! $objDocTmx->load($tmx) ){
					echo "Warning | 不正な文書が登録されています。(id:{$id})\n";
					continue;
				}
				
				// 一括登録開始
				$objDAODocumentText->registerMultiStart();
				
				// 対訳更新
				$arrSentence = $objDocTmx->getSentence();
				foreach ( $arrSentence as $key => $sentence ){
					$textS = trim($sentence["source_text"]);
					$textT = trim($sentence["target_text"]);
					
					$objDAODocumentText->registerMultiPush($textS, $textT, $id);
				}
				
				// 一括登録終了(コミット)
				$resDAODocumentText = $objDAODocumentText->registerMultiEnd();
				if ( $resDAODocumentText["result"] === RES_OK ){
					echo "Success | 文書テキストを登録しました。(id:{$id}, count:{$resDAODocumentText["count"]})\n";
				} else {
					echo "Warning | 文書テキストの登録に失敗しました。(id:{$id})\n";
				}
			}
		} else if ( $resDAODocument["result"] === RES_NO_DATA ){
			echo "Success | 文書が見つかりませんでした。\n";
		} else {
			echo "Error   | 文書の取得に失敗しました。\n";
		}
		$offset += $limit;
	} while ( $resDAODocument["count"] > $offset );
	
}

//----------------------------
// process
//----------------------------
// 引数チェック
if ( $argc === 1 ){
	main();
} else {
	echo "usage:\n";
	echo "php -f run.php\n";
}
