<?php require_once("common/Common.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_CHECK_NAME_CONTROLLER";
// result
$result = RES_OK;
// data
$data = "";
// html

//----------------------------
// request parameter
//----------------------------
$qProjectID = isset($_SESSION["project_id"]) ? $_SESSION["project_id"] : REQ_NON;

$qName  = isset($_REQUEST["q_name"])  ? $_REQUEST["q_name"]  : REQ_NON;
$qTitle = isset($_REQUEST["q_title"]) ? $_REQUEST["q_title"] : REQ_NON;
$qKind = isset($_REQUEST["q_kind"]) ? $_REQUEST["q_kind"] : REQ_NON;
$qID   = isset($_REQUEST["q_id"])   ? $_REQUEST["q_id"]   : REQ_NON;

//----------------------------
// judge post
//----------------------------

//----------------------------
// set types
//----------------------------
Util::setType($qName, "string");
Util::setType($qTitle, "string");
Util::setType($qKind, "int");
Util::setType($qID,   "int");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::isString($qName) && ! Validate::isString($qTitle) ){
		$result = RES_NG;
	}
	if ( ! Validate::inArray($qKind, $G_APP_CHECK_NAME_CONTROLLER_KIND_TABLE) ){
		$result = RES_NG;
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::isNumeric($qID) ){
		$qID = INIT_ID;
	}
}

//----------------------------
// function
//----------------------------

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	switch ( $qKind ){
		case APP_CHECK_NAME_CONTROLLER_KIND_USER:
			$objDAOUser = DAO::instance("user");
			
			if ( ! $objDAOUser->exists($qName) ){
				$result = RES_NO_DATA;
			}
			break;
		case APP_CHECK_NAME_CONTROLLER_KIND_DOCUMENT:
			$objDAODocument = DAO::instance("document");
			
			if ( ! $objDAODocument->exists($qTitle, $qProjectID, $qID) ){
				$result = RES_NO_DATA;
			}
			break;
		case APP_CHECK_NAME_CONTROLLER_KIND_TERM:
		case APP_CHECK_NAME_CONTROLLER_KIND_BILINGUAL:
			if ( $qKind === APP_CHECK_NAME_CONTROLLER_KIND_TERM ){
				$objDAOTermRoot = DAO::instance("term_root", Term::KIND_TERM);
			} else {
				$objDAOTermRoot = DAO::instance("term_root", Term::KIND_BILINGUAL);
			}
			
			if ( ! $objDAOTermRoot->exists($qName, $qID) ){
				$result = RES_NO_DATA;
			}
			break;
		case APP_CHECK_NAME_CONTROLLER_KIND_DATA:
			$objDAOData = DAO::instance("data");
			
			if ( ! $objDAOData->exists($qTitle, $qID) ){
				$result = RES_NO_DATA;
			}
			break;
	}
}

if ( $result === RES_NO_DATA ){
	echo "true";
} else {
	// エラーメッセージ
	$message = ""; // 空のままだと、jquery.validate.jsの既定のテキストが出力される
	switch ( $qKind ){
		case APP_CHECK_NAME_CONTROLLER_KIND_USER:
			$message = "{$WORD($wk, 1)}";
			break;
		case APP_CHECK_NAME_CONTROLLER_KIND_DOCUMENT:
			$message = "{$WORD($wk, 2)}";
			break;
		case APP_CHECK_NAME_CONTROLLER_KIND_TERM:
			$message = "{$WORD($wk, 3)}";
			break;
		case APP_CHECK_NAME_CONTROLLER_KIND_BILINGUAL:
			$message = "{$WORD($wk, 4)}";
			break;
		case APP_CHECK_NAME_CONTROLLER_KIND_DATA:
			$message = "{$WORD($wk, 5)}";
			break;
	}
	if ( strcmp($message, "") === 0 ){
		echo "false";
	} else {
		echo json_encode($message);
	}
}
