<?php require_once("common/Common.php"); ?>
<?php require_once("class/diff.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_DIFF_CONTROLLER";
// result
$result = RES_OK;
// data
$arrDiff = array();
// html

//----------------------------
// request parameter
//----------------------------
$qToken = isset($_REQUEST["q_token"]) ? $_REQUEST["q_token"] : REQ_NON;
$qID    = isset($_REQUEST["q_id"])    ? $_REQUEST["q_id"]    : REQ_NON;
$qText1 = isset($_REQUEST["q_text1"]) ? $_REQUEST["q_text1"] : REQ_NON;
$qText2 = isset($_REQUEST["q_text2"]) ? $_REQUEST["q_text2"] : REQ_NON;

// max_input_varsを検知
// http://stackoverflow.com/questions/12169818/in-php-how-can-i-detect-that-input-vars-were-truncated-due-to-max-input-vars-be
if ( ($maxInputVars = ini_get("max_input_vars")) !== FALSE ){
	$phpInput = substr_count(file_get_contents("php://input"), "&");
	$post = count($_POST, COUNT_RECURSIVE);
	
	if ( $phpInput > $post ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 1)}");
	}
}

//----------------------------
// judge post
//----------------------------

//----------------------------
// set types
//----------------------------
Util::setType($qToken, "string");
Util::setType($qID,    "int");
Util::setType($qText1, "string");
Util::setType($qText2, "string");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::isNumeric($qID) ){
		//$result = RES_NG;
	}
	if ( ! Validate::isToken($qToken, "token_common", FALSE) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 1)}");
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
}

//----------------------------
// function
//----------------------------

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	$diff = new SimpleDiff($qText1, $qText2);
	$arrDiffKey = array_keys($diff->edits);
	
	// xml
	$diffformatter = new XMLDiffFormatter();
	$xml = $diffformatter->format($diff);
	if ( strlen($xml) === 0 ){
		foreach ( $qText1 as $key => $tmp ){
			$target1 = array_shift($qText1);
			$target2 = array_shift($qText2);
			$arrDiff[$key] = array(
				"isSame" => TRUE,
				1 => "<td>".Util::esc($target1)."</td>",
				2 => "<td>".Util::esc($target2)."</td>",
			);
		}
	} else {
		if ( $result === RES_OK ){
			$dom = new DOMDocument("1.0", "UTF-8");
			if ( ! @$dom->loadXML($xml)){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 1)}");
			}
		}
		if ( $result === RES_OK ){
			$arrNodeRoot = $dom->getElementsByTagName("root");
			if ( $arrNodeRoot->length >= 1 ){
				$nodeRoot = $arrNodeRoot->item(0);
			} else {
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 1)}");
			}
		}
		if ( $result === RES_OK ){
			$arrNodeRow = $nodeRoot->getElementsByTagName("row");
			if ( $arrNodeRow->length >= 1 ){
				$keyIndex = 0;
				foreach ( $arrNodeRow as $nodeRow ){
					$key = $arrDiffKey[$keyIndex++];
					$type = $nodeRow->getAttribute("type");
					$arrNodeCol = $nodeRow->getElementsByTagName("col");
					if ( $arrNodeCol->length >= 2 ){
						$col1 = $arrNodeCol->item(0)->nodeValue;
						$col2 = $arrNodeCol->item(1)->nodeValue;
						
						$target1 = "";
						$target2 = "";
						if ( $type === "add" ){
							$target1 = '<td class="col_diff"></td>';
							$target2 = '<td class="col_diff">'.$col2.'</td>';
						} elseif ( $type === "delete" ){
							$target1 = '<td class="col_diff">'.$col1.'</td>';
							$target2 = '<td class="col_diff"></td>';
						} elseif ( $type === "change" ){
							$col1 = $arrNodeCol->item(0);
							$col2 = $arrNodeCol->item(1);
							foreach ( $col1->childNodes as $node ){
								if ( $node->nodeType === XML_ELEMENT_NODE ){
									if ( $node->nodeName === "x" ){
										$target1 .= '<span class="merge">'.$node->nodeValue.'</span>';
									} else if ( $node->nodeName === "xadd" ){
										$target1 .= '<span class="merge">'.$node->nodeValue.'</span>';
									} else if ( $node->nodeName === "xdel" ){
										$target1 .= '<span class="merge">'.$node->nodeValue.'</span>';
									}
								} else {
									$target1 .= $node->nodeValue;
								}
							}
							foreach ( $col2->childNodes as $node ){
								if ( $node->nodeType === XML_ELEMENT_NODE ){
									if ( $node->nodeName === "x" ){
										$target2 .= '<span class="merge">'.$node->nodeValue.'</span>';
									} else if ( $node->nodeName === "xadd" ){
										$target2 .= '<span class="merge">'.$node->nodeValue.'</span>';
									} else if ( $node->nodeName === "xdel" ){
										$target2 .= '<span class="merge">'.$node->nodeValue.'</span>';
									}
								} else {
									$target2 .= $node->nodeValue;
								}
							}
							$target1 = '<td class="col_part_diff">'.$target1.'</td>';
							$target2 = '<td class="col_part_diff">'.$target2.'</td>';
						} elseif ( $type === "copy" ){
							$target1 = '<td>'.$col1.'</td>';
							$target2 = '<td>'.$col2.'</td>';
						}
						
						$arrDiff[$key] = array(
							"isSame" => ($type=== "copy") ? TRUE : FALSE,
							1 => $target1,
							2 => $target2
						);
					}
				}
			}
		}
	}
}

$res["result"] = $result;
$res["message"] = $gResult->string(FALSE, $result);
$res["data"] = $arrDiff;

echo json_encode($res);

