<?php require_once("common/Common.php"); ?>
<?php require_once("class/DocTmx.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_DOCUMENT_CONTROLLER";
// result
$result = RES_OK;
$res = array();
// data
$data = "";
// html

//----------------------------
// request parameter
//----------------------------
$qToken = isset($_REQUEST["q_token"]) ? $_REQUEST["q_token"] : REQ_NON;
$qMode  = isset($_REQUEST["q_mode"])  ? $_REQUEST["q_mode"]  : REQ_NON;
$qID    = isset($_REQUEST["q_id"])    ? $_REQUEST["q_id"]    : REQ_NON;
$qText  = isset($_REQUEST["q_text"])  ? $_REQUEST["q_text"]  : REQ_NON;
$qName  = isset($_REQUEST["q_name"])  ? $_REQUEST["q_name"]  : REQ_NON;
$qRevision  = isset($_REQUEST["q_revision"])   ? $_REQUEST["q_revision"]   : REQ_NON;
$qProjectID = isset($_REQUEST["q_project_id"]) ? $_REQUEST["q_project_id"] : REQ_NON;

//----------------------------
// judge post
//----------------------------

//----------------------------
// change types
//----------------------------
Util::setType($qToken, "string");
Util::setType($qMode,  "int");
Util::setType($qID,    "int");
Util::setType($qText,  "string");
Util::setType($qName,  "string");
Util::setType($qRevision,  "int");
Util::setType($qProjectID, "int");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::inArray($qMode, $G_APP_DOCUMENT_CONTROLLER_MODE_TABLE) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 1)}");
	}
	if ( ! Validate::isNumeric($qID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 2)}");
	}
	switch ( $qMode ){
		case APP_DOCUMENT_CONTROLLER_MODE_SET:
			if ( ! Validate::isToken($qToken, "q_token_qredit", FALSE) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 3)}");
			}
			break;
		case APP_DOCUMENT_CONTROLLER_MODE_COPY:
			if ( ! Validate::isToken($qToken, "token_common", FALSE) && ! Validate::isToken($qToken, "q_token_qredit", FALSE) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 4)}");
			}
			if ( ! Validate::isNumeric($qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 5)}");
			}
			break;
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
	$auth = Auth::instance("document");
	switch ( $qMode ){
		case APP_DOCUMENT_CONTROLLER_MODE_GET:
		case APP_DOCUMENT_CONTROLLER_MODE_EXPORT:
		case APP_DOCUMENT_CONTROLLER_MODE_EXPORT2:
			if( ! $auth->read($qID, NULL)){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 6)}");
			}
			break;
		case APP_DOCUMENT_CONTROLLER_MODE_SET:
			if( ! $auth->write($qID, NULL)){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 7)}");
			}
			break;
		case APP_DOCUMENT_CONTROLLER_MODE_COPY:
			if( ! $auth->processCopy($qID, $qProjectID)){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 8)}");
			}
			break;
	}
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
	switch ( $qMode ){
		case APP_DOCUMENT_CONTROLLER_MODE_SET:
			if ( ! Validate::isString($qText) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 9)}");
			}
			break;
	}
}

//----------------------------
// function
//----------------------------

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	DAO::begin();
	
	$objDAODocument = DAO::instance("document");
	
	if ( $result === RES_OK ){
		$objDAODocument->setAuth($auth);
		$resDAODocument = $objDAODocument->get($qID, array_keys(DAO::T_DOCUMENT_STATE_VALID_TABLE()));
		$result = $resDAODocument["result"];
	}
	
	if ( $result === RES_OK ){
		switch ( $qMode ){
			case APP_DOCUMENT_CONTROLLER_MODE_GET:
				$dataDocument = $resDAODocument["data"][0];
				$data = array(
					"xml" => $dataDocument["t_document_text"],
				);
				
				$objDocTmx = new DocTmx();
				$revList = $objDocTmx->getRevisionList($data["xml"]);
				$data["is_revision"] = ($revList !== FALSE) && count($revList) > 0;
				
				break;
			case APP_DOCUMENT_CONTROLLER_MODE_SET:
				$objDocTmx = new DocTmx();
				$objDocTmx->load($qText);
				
				$arrError = array();
				if ( ! $objDocTmx->validate($arrError) ){
					$result = RES_NG;
					foreach ( $arrError as $err ){
						$gResult->push($err);
					}
				}

				if ( $result === RES_OK ){
					$resDAODocument = $objDAODocument->register($qID, NULL, NULL, NULL, NULL, $qText);
					$result = $resDAODocument["result"];
					if ( $result !== RES_OK ){
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 10)}");
					}
				}
				break;
			case APP_DOCUMENT_CONTROLLER_MODE_EXPORT:
				$dataDocument = $resDAODocument["data"][0];
				$data  = $dataDocument["t_document_text"];
				$title = $dataDocument["t_document_title"];
				
				if ( Validate::isNumeric($qRevision) ){
					$objDocTmx = new DocTmx();
					$objDocTmx->load($data);
					if ( $qRevision > 0 ){
						$data = $objDocTmx->getRevisionTsv($qRevision);
					} else {
						$data = $objDocTmx->getLatestTsv(FALSE);
					}
				}
				
				header('Content-Disposition: attachment; filename="'.$title.'.tmx"');
				header('Content-Type: text/xml; charset=UTF-8');
				header('Content-Length: '.strlen($data));
				
				echo $data;
				exit();
				break;
			case APP_DOCUMENT_CONTROLLER_MODE_EXPORT2:
				$dataDocument = $resDAODocument["data"][0];
				$data  = $dataDocument["t_document_text"];
				$title = $dataDocument["t_document_title"];
				
				$objDocTmx = new DocTmx();
				$objDocTmx->load($data);
				
				if ( Validate::isNumeric($qRevision) ){
					if ( $qRevision > 0 ){
						$arrSentence = $objDocTmx->getRevisionSentence($qRevision);
					} else {
						$arrSentence = $objDocTmx->getSentence();
					}
					$arrTarget = array();
					foreach ( $arrSentence as $dataSentence ){
						$arrTarget[] = $dataSentence["target_text"];
					}
					$data = implode("\r\n", $arrTarget);
					
					header('Content-Disposition: attachment; filename="'.$title.'.txt"');
					header('Content-Type: text/plain; charset=UTF-8');
					header('Content-Length: '.strlen($data));
					
					echo $data;
				} else {
					// zipに固める
					$files = array();
					$zipDir = Setting::get("PATH_DATA_TMP")."/".User::get("id")."_zip";
					if ( file_exists($zipDir) && is_dir($zipDir) ){
						Tool::removeDir($zipDir);
					}
					if ( Tool::makedir($zipDir) === FALSE ){
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 11)}");
					}
					
					// 履歴ファイル
					if ( $result === RES_OK ){
						if ( ($revList = $objDocTmx->getRevisionList($data)) === FALSE ){
							// 履歴情報なし
						} else {
							foreach ( $revList as $revInfo ){
								$revision = $revInfo["revision"];
								$arrSentence = $objDocTmx->getRevisionSentence($revision);
								$arrTarget = array();
								foreach ( $arrSentence as $dataSentence ){
									$arrTarget[] = $dataSentence["target_text"];
								}
								$file = $zipDir."/{$title}({$revision}).txt";
								if ( file_put_contents($file, implode("\r\n", $arrTarget)) === FALSE ){
									$result = RES_NG;
									$gResult->push("{$WORD($wk, 12)}");
									break;
								} else {
									$files[] = $file;
								}
							}
						}
					}
					
					// 最新ファイル
					if ( $result === RES_OK ){
						$arrSentence = $objDocTmx->getSentence();
						$arrTarget = array();
						foreach ( $arrSentence as $dataSentence ){
							$arrTarget[] = $dataSentence["target_text"];
						}
						$file = $zipDir."/{$title}.txt";
						if ( file_put_contents($file, implode("\r\n", $arrTarget)) === FALSE ){
							$result = RES_NG;
							$gResult->push("{$WORD($wk, 13)}");
						} else {
							$files[] = $file;
						}
					}
					
					// zip
					if ( $result === RES_OK ){
						$zip = new ZipArchive();
						$zipFile = Setting::get("PATH_DATA_TMP")."/".User::get("id").".zip";
						if ( $zip->open($zipFile, ZipArchive::CREATE) === FALSE ){
							$result = RES_NG;
							$gResult->push("{$WORD($wk, 14)}");
						} else {
							foreach ( $files as $file ){
								$name = mb_convert_encoding(basename($file), "SJIS", "AUTO");
								$zip->addFile($file, $name);
							}
							$zip->close();
							
							header('Content-Disposition: attachment; filename="'.$title.'.zip"');
							header('Content-Type: application/zip; name="'.$title.'.zip"');
							header('Content-Length: '.filesize($zipFile));
							
							echo file_get_contents($zipFile);
							unlink($zipFile);
						}
					}
					
					Tool::removeDir($zipDir);
				}
				
				exit();
				break;
			case APP_DOCUMENT_CONTROLLER_MODE_COPY:
				$resDAODocument = $objDAODocument->get($qID, DAO::T_DOCUMENT_STATE_NORMAL);
				if ( $resDAODocument["result"] === RES_OK ){
					$dataDocument = $resDAODocument["data"][0];
					
					// $qNameが空で渡された時は自動で名前をセット
					if ( ! Validate::isString($qName) ){
						$qName = $dataDocument["t_document_title"];
						$idx = 0;
						if ( preg_match( "/(.*)\((\d)\)\s*$/", $qName, $matches) > 0 ){ // "○○ (%d)"となっていれば、%dの値を変える
							$qName = trim($matches[1]);
							$idx   = $matches[2];
						}
						while ( $idx < 10000 ){
							$idx += 1;
							$testName = "{$qName} ({$idx})";
							if ( ! $objDAODocument->exists($testName, $qProjectID) ){
								$qName = $testName;
								break;
							}
						}
					}
					
					$resDAODocument = $objDAODocument->register(INIT_ID, DAO::T_DOCUMENT_STATE_NORMAL, $dataDocument["t_document_lang_s"], $dataDocument["t_document_lang_t"], $qName, $dataDocument["t_document_text"], $dataDocument["t_document_comment"], $qProjectID, User::get("id"));
					
					if ( $resDAODocument["result"] === RES_OK ){
						$data["document_id"] = $resDAODocument["id"];
					} else {
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 15)}");
					}
				} else {
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 16)}");
				}
				
				break;
		}
	}
	
	DAO::end($result);
}

$res["result"] = $result;
$res["message"] = $gResult->string(FALSE, $result);
$res["data"]   = $data;

echo json_encode($res);
