<?php require_once("common/Common.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : ロギング
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
$LOG_LOOKUP_SELECT_MODE_TABLE = array(
	"P"  => DAO::T_LOG_LOOKUP_SELECT_MODE_P,
	"L"  => DAO::T_LOG_LOOKUP_SELECT_MODE_L,
	"S"  => DAO::T_LOG_LOOKUP_SELECT_MODE_S,
	"TM" => DAO::T_LOG_LOOKUP_SELECT_MODE_TM,
	"M"  => DAO::T_LOG_LOOKUP_SELECT_MODE_M,
	"R"  => DAO::T_LOG_LOOKUP_SELECT_MODE_R,
);

//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_LOGGING_CONTROLLER";
// result
$result = RES_OK;
// data
$transText = "";
// html

//----------------------------
// request parameter
//----------------------------
$qToken      = isset($_REQUEST["q_token"])       ? $_REQUEST["q_token"]       : REQ_NON;
$qMode       = isset($_REQUEST["q_mode"])        ? $_REQUEST["q_mode"]        : REQ_NON;
$qProjectID  = isset($_REQUEST["q_project_id"])  ? $_REQUEST["q_project_id"]  : REQ_NON;
$qTaskID     = isset($_REQUEST["q_task_id"])     ? $_REQUEST["q_task_id"]     : REQ_NON;
$qTaskType   = isset($_REQUEST["q_task_type"])   ? $_REQUEST["q_task_type"]   : REQ_NON;
$qTaskRole   = isset($_REQUEST["q_task_role"])   ? $_REQUEST["q_task_role"]   : REQ_NON;
$qDocumentID = isset($_REQUEST["q_document_id"]) ? $_REQUEST["q_document_id"] : REQ_NON;
$qData       = isset($_REQUEST["q_data"])        ? $_REQUEST["q_data"]        : REQ_NON;

//----------------------------
// judge post
//----------------------------

//----------------------------
// change types
//----------------------------
Util::setType($qToken,      "string");
Util::setType($qMode,       "int");
Util::setType($qProjectID,  "int");
Util::setType($qTaskID,     "int");
Util::setType($qTaskType,   "int");
Util::setType($qTaskRole,   "int");
Util::setType($qDocumentID, "int");
Util::setType($qData,       "string");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::isToken($qToken, "q_token_qredit", FALSE) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 1)}");
	}
	if ( ! Validate::inArray($qMode, $APP_LOGGING_CONTROLLER_MODE_TABLE) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 2)}");
	}
	if ( ! Validate::isNumeric($qProjectID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 3)}");
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::isNumeric($qTaskID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 4)}");
	}
	if ( ! Validate::inKeyArray($qTaskType, Task::TYPE_TABLE()) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 5)}");
	}
	if ( ! Validate::inKeyArray($qTaskRole, Task::ROLE_TABLE()) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 6)}");
	}
	if ( ! Validate::isNumeric($qDocumentID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 7)}");
	}
	if ( ! Validate::isArray($qData) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 8)}");
	}
}

//----------------------------
// function
//----------------------------

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	DAO::begin();
	
	$objDAOLogLookup       = DAO::instance("log_lookup");
	$objDAOLogLookupSelect = DAO::instance("log_lookup_select");
	
	if ( $result === RES_OK ){
		switch ( $qMode ){
			case APP_LOGGING_CONTROLLER_MODE_LOOKUP:
				$no        = isset($qData["paragraph-number"]) ? $qData["paragraph-number"] : 0;
				$langS     = isset($qData["slang"])            ? $qData["slang"]            : "";
				$langT     = isset($qData["tlang"])            ? $qData["tlang"]            : "";
				$index     = isset($qData["lookup-index"])     ? $qData["lookup-index"]     : 0;
				$text      = isset($qData["lookup-text"])      ? $qData["lookup-text"]      : "";
				$pos       = isset($qData["lookup-pos"])       ? $qData["lookup-pos"]       : "";
				$dictID    = isset($qData["place"])            ? $qData["place"]            : "";
				$dictIDs   = isset($qData["dict-ids"])         ? $qData["dict-ids"]         : "";
				$awareness = isset($qData["awareness"])        ? $qData["awareness"]        : "";
				
				Util::setType($no,        "integer");
				Util::setType($langS,     "string");
				Util::setType($langT,     "string");
				Util::setType($index,     "integer");
				Util::setType($text,      "string");
				Util::setType($pos,       "string");
				Util::setType($dictID,    "string");
				Util::seTType($dictIDs,   "string");
				Util::setType($awareness, "string");
				
				if ( $result === RES_OK ){
					$resDAOLogLookup = $objDAOLogLookup->register($no, $langS, $langT, $index, $text, $pos, $dictID, $dictIDs, $awareness, User::get("id"), $qProjectID, $qTaskID, $qTaskType, $qTaskRole, $qDocumentID);
					if ( ($result = $resDAOLogLookup["result"]) !== RES_OK ){
						$gResult->push("{$WORD($wk, 9)}");
					}
				}
				break;
			case APP_LOGGING_CONTROLLER_MODE_LKUPSL:
				$mode  = isset($qData["mode"])                       ? $qData["mode"]                       : "";
				$mode  = isset($LOG_LOOKUP_SELECT_MODE_TABLE[$mode]) ? $LOG_LOOKUP_SELECT_MODE_TABLE[$mode] : -1;
				$no    = isset($qData["paragraph-number"])           ? $qData["paragraph-number"]           : 0;
				$langS = isset($qData["slang"])                      ? $qData["slang"]                      : "";
				$langT = isset($qData["tlang"])                      ? $qData["tlang"]                      : "";
				$kind  = isset($qData["is-midashi"])                 ? $qData["is-midashi"]                 : FALSE;
				Util::setType($mode,        "integer");
				Util::setType($no,          "integer");
				Util::setType($langS,       "string");
				Util::setType($langT,       "string");
				Util::setType($kind,        "boolean");
				
				$heading     = "";
				$textS       = isset($qData["lookup-text"]) ? $qData["lookup-text"] : "";
				$textT       = "";
				$searchLangS = "";
				$searchLangT = "";
				
				switch ( $mode ){
					case DAO::T_LOG_LOOKUP_SELECT_MODE_P:
						$textT = isset($qData["P-word"]) ? $qData["P-word"] : "";
						break;
					case DAO::T_LOG_LOOKUP_SELECT_MODE_L:
						$textT       = isset($qData["L-word"])  ? $qData["L-word"]  : "";
						$searchLangS = isset($qData["L-slang"]) ? $qData["L-slang"] : "";
						$searchLangT = isset($qData["L-tlang"]) ? $qData["L-tlang"] : "";
						break;
					case DAO::T_LOG_LOOKUP_SELECT_MODE_S:
						$textT = isset($qData["S-query"])  ? $qData["S-query"]  : "";
						break;
					case DAO::T_LOG_LOOKUP_SELECT_MODE_TM:
						$textT       = isset($qData["TM-word"])  ? $qData["TM-word"]  : "";
						$searchLangS = isset($qData["TM-slang"]) ? $qData["TM-slang"] : "";
						$searchLangT = isset($qData["TM-tlang"]) ? $qData["TM-tlang"] : "";
						break;
					case DAO::T_LOG_LOOKUP_SELECT_MODE_M:
						$textT       = isset($qData["M-word"])  ? $qData["M-word"]  : "";
						$searchLangS = isset($qData["M-slang"]) ? $qData["M-slang"] : "";
						$searchLangT = isset($qData["M-tlang"]) ? $qData["M-tlang"] : "";
						break;
					case DAO::T_LOG_LOOKUP_SELECT_MODE_R:
						$heading     = isset($qData["R-midashi"])     ? $qData["R-midashi"]     : "";
						$textT       = isset($qData["R-translation"]) ? $qData["R-translation"] : "";
						break;
					default:
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 10)}");
						break;
				}
				
				Util::setType($heading,     "string");
				Util::setType($textS,       "string");
				Util::setType($textT,       "string");
				Util::setType($searchLangS, "string");
				Util::setType($searchLangT, "string");
				
				if ( $result === RES_OK ){
					$resDAOLogLookupSelect = $objDAOLogLookupSelect->register($mode, $no, $langS, $langT, $textS, $textT, $heading, $kind, $searchLangS, $searchLangT, User::get("id"), $qProjectID, $qTaskID, $qTaskType, $qTaskRole, $qDocumentID);
					if ( ($result = $resDAOLogLookupSelect["result"]) !== RES_OK ){
						$gResult->push("{$WORD($wk, 11)}");
					}
				}
				break;
			default:
				break;
		}
	}
	
	DAO::end($result);
}

$res["result"]  = $result;
$res["message"] = $gResult->string(FALSE, $result);

echo json_encode($res);
