<?php require_once("common/Common.php"); ?>
<?php require_once("class/DocProject.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_PROJECT_CONTROLLER";
// result
$result = RES_OK;
// data
$data = "";
// html

//----------------------------
// request parameter
//----------------------------
$qToken = isset($_REQUEST["q_token"]) ? $_REQUEST["q_token"] : REQ_NON;
$qMode  = isset($_REQUEST["q_mode"])  ? $_REQUEST["q_mode"]  : REQ_NON;
$qID    = isset($_REQUEST["q_id"])    ? $_REQUEST["q_id"]    : REQ_NON;
$qState = isset($_REQUEST["q_state"]) ? $_REQUEST["q_state"] : REQ_NON;

//----------------------------
// judge post
//----------------------------

//----------------------------
// set types
//----------------------------
Util::setType($qToken, "string");
Util::setType($qMode,  "int");
Util::setType($qID,    "int");
Util::setType($qState, "int");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::inArray($qMode, $APP_PROJECT_CONTROLLER_MODE_TABLE) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 1)}");
	}
	if ( ! Validate::isNumeric($qID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 2)}");
	}
	if ( $qMode === APP_PROJECT_CONTROLLER_MODE_SET ){
		if ( ! Validate::isToken($qToken, "token_common", FALSE) ){
			$result = RES_NG;
			$gResult->push("{$WORD($wk, 3)}");
		}
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
	$auth = Auth::instance("project");
	switch ( $qMode ){
		case APP_PROJECT_CONTROLLER_MODE_GET:
		case APP_PROJECT_CONTROLLER_MODE_INFO:
			if ( ! $auth->read($qID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 4)}");
			}
			break;
		case APP_PROJECT_CONTROLLER_MODE_EXPORT:
			if ( ! $auth->processExport($qID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 5)}");
			}
			break;
		case APP_PROJECT_CONTROLLER_MODE_SET:
			if ( ! $auth->write_isState($qID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 6)}");
			}
			break;
	}
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
}

//----------------------------
// function
//----------------------------

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	$objDAOProject = DAO::instance("project");
	$objDAOProjectUser    = DAO::instance("project_user");
	$objDAODocument       = DAO::instance("document");
	$objDAOTask           = DAO::instance("task");
	$objDAOTermRoot       = DAO::instance("term_root", Term::KIND_TERM);
	$objDAOBilingualRoot  = DAO::instance("term_root", Term::KIND_BILINGUAL);
	$objDAOData           = DAO::instance("data");
	$objDAOBbsPost        = DAO::instance("bbs_post");
	
	if ( $result === RES_OK ){
		switch ( $qMode ){
			case APP_PROJECT_CONTROLLER_MODE_GET:
				$objDAOProject->setAuth($auth);
				$resDAOProject = $objDAOProject->get($qID);
				$result = $resDAOProject["result"];
				
				if ( $result === RES_OK ){
					$dataProject = $resDAOProject["data"][0];
					$state = $dataProject["t_project_state"];
					
					$data = array(
						"title" => Util::esc($dataProject["t_project_name"]),
						"state" => $state,
						"state_text"  => DAO::T_PROJECT_STATE_TABLE( $state ),
						"state_class" => DAO::T_PROJECT_STATE_ALERT_TABLE( $state ),
						"state_auth"  => $auth->write_isState($qID),
					);
				}
				break;
			case APP_PROJECT_CONTROLLER_MODE_INFO:
				$data = array();
				
				// プロジェクト
				if ( $result === RES_OK ){
					$objDAOProject->setAuth($auth);
					$resDAOProject = $objDAOProject->get($qID);
					$resDAOProjectUser = $objDAOProjectUser->get($qID, NULL, Task::ROLE_RPMG);
					if ( $resDAOProjectUser["result"] === RES_OK ){
						foreach ( $resDAOProjectUser["data"] as $dataProjectUser ){
							$arrPmUser[ $dataProjectUser["t_user_id"] ] = $dataProjectUser["t_user_name"];
						}
						$pmUser = implode(", ", $arrPmUser);
					} else {
						$pmUser = "{$WORD($wk, 7)}";
					}
					if ( $resDAOProject["result"] === RES_OK ){
						$dataProject = $resDAOProject["data"][0];
						$data["project"] = Printer::dList( array(
							"{$WORD($wk, 8)}" => $dataProject["t_user_name"],
							"{$WORD($wk, 9)}" => is_null($dataProject["t_project_start"]) ? "---" : $dataProject["t_project_start"],
							"{$WORD($wk, 10)}" => is_null($dataProject["t_project_end"])   ? "---" : $dataProject["t_project_end"],
							"{$WORD($wk, 11)}" => $pmUser,
						));
					} else {
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 12)}");
					}
				}
				
				// メンバー
				if ( $result === RES_OK ){
					$resDAOProjectUser = $objDAOProjectUser->get($qID);
					if ( $resDAOProjectUser["result"] === RES_OK ){
						$arrMember = array();
						foreach ( $resDAOProjectUser["data"] as $dataProjectUser ){
							$arrMember[ $dataProjectUser["t_user_id"] ] = $dataProjectUser["t_user_name"];
						}
						$data["member"] = Printer::dList( array(
							"{$WORD($wk, 13)}" => count($arrMember),
							"{$WORD($wk, 14)}" => implode(", ", $arrMember),
						));
					} else if ( $resDAOProjectUser["result"] === RES_NO_DATA ){
						$data["member"] = "{$WORD($wk, 15)}";
					} else {
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 16)}");
					}
				}
				
				// 文書
				if ( $result === RES_OK ){
					$resDAODocument = $objDAODocument->get(NULL, array_keys(DAO::T_DOCUMENT_STATE_VALID_TABLE()), NULL, $qID);
					if ( $resDAODocument["result"] === RES_OK ){
						$arrDocument = array();
						foreach ( $resDAODocument["data"] as $dataDocument ){
							$arrDocument[ $dataDocument["t_document_id"] ] = $dataDocument["t_document_title"];
						}
						$data["document"] = Printer::dList( array(
							"{$WORD($wk, 17)}" => count($arrDocument),
							"{$WORD($wk, 18)}" => implode(", ", $arrDocument),
						));
					} else if ( $resDAODocument["result"] === RES_NO_DATA ){
						$data["document"] = "{$WORD($wk, 19)}";
					} else {
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 20)}");
					}
				}
				
				// ワークフロー
				if ( $result === RES_OK ){
					$workflowID = DAO::storedFunction("get_workflow_id_by_project_id", $qID);
					if ( is_null($workflowID) ){
						$result = RES_NG;
					}
					if ( $result === RES_OK ){
						$resDAOTask = $objDAOTask->get(NULL, NULL, NULL, NULL, NULL, $workflowID);
						if ( $resDAOTask["result"] === RES_OK ){
							$arrTask = array();
							foreach ( $resDAOTask["data"] as $dataTask ){
								$arrTask[] = $dataTask["t_task_start"] . "~ : " . Util::esc(Task::TYPE_TABLE($dataTask["t_task_type"]));
							}
							if ( count($arrTask) > 3 ){
								array_splice($arrTask, 3);
								$hTask = implode(", <br/>", $arrTask)."...";
							} else {
								$hTask = implode(", <br/>", $arrTask);
							}
							$data["task"] = Printer::dList( array(
								Util::esc("{$WORD($wk, 21)}") => Util::esc($resDAOTask["count"]),
								Util::esc("{$WORD($wk, 22)}")   => $hTask,
							), NULL, FALSE);
						} else if ( $resDAOTask["result"] === RES_NO_DATA ){
							$data["task"] = "{$WORD($wk, 23)}";
						} else {
							$result = RES_NG;
						}
					}
					if ( $result === RES_NG ){
						$gResult->push("{$WORD($wk, 24)}");
					}
				}
				
				// 用語集
				if ( $result === RES_OK ){
					$resDAOTermRoot = $objDAOTermRoot->get(NULL, DAO::T_TERM_ROOT_STATE_NORMAL, NULL, NULL, $qID, TRUE);
					if ( $resDAOTermRoot["result"] === RES_OK ){
						$arrTermRoot = array();
						foreach ( $resDAOTermRoot["data"] as $dataTermRoot ){
							$arrTermRoot[ $dataTermRoot["t_term_root_id"] ] = $dataTermRoot["t_term_root_name"];
						}
						$data["term"] = Printer::dList( array(
							"{$WORD($wk, 25)}" => count($arrTermRoot),
							"{$WORD($wk, 26)}" => implode(", ", $arrTermRoot),
						));
					} else if ( $resDAOTermRoot["result"] === RES_NO_DATA ){
						$data["term"] = "{$WORD($wk, 27)}";
					} else {
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 28)}");
					}
				}
				
				// 翻訳メモリ(対訳集)
				if ( $result === RES_OK ){
					$resDAOBilingualRoot = $objDAOBilingualRoot->get(NULL, DAO::T_TERM_ROOT_STATE_NORMAL, NULL, NULL, $qID, TRUE);
					if ( $resDAOBilingualRoot["result"] === RES_OK ){
						$arrBilingualRoot = array();
						foreach ( $resDAOBilingualRoot["data"] as $dataBilingualRoot ){
							$arrBilingualRoot[ $dataBilingualRoot["t_term_root_id"] ] = $dataBilingualRoot["t_term_root_name"];
						}
						$data["bilingual"] = Printer::dList( array(
							"{$WORD($wk, 29)}"     => count($arrBilingualRoot),
							"{$WORD($wk, 30)}" => implode(", ", $arrBilingualRoot),
						));
					} else if ( $resDAOBilingualRoot["result"] === RES_NO_DATA ){
						$data["bilingual"] = "{$WORD($wk, 31)}";
					} else {
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 32)}");
					}
				}
				
				// データ
				if ( $result === RES_OK ){
					$resDAOData = $objDAOData->get(NULL, DAO::T_DATA_STATE_NORMAL, NULL, $qID, TRUE);
					if ( $resDAOData["result"] === RES_OK ){
						$arrData = array();
						foreach ( $resDAOData["data"] as $dataData ){
							$arrData[ $dataData["t_data_id"] ] = $dataData["t_data_title"];
						}
						$data["data"] = Printer::dList( array(
							"{$WORD($wk, 33)}" => count($arrData),
							"{$WORD($wk, 34)}" => implode(", ", $arrData),
						));
					} else if ( $resDAOData["result"] === RES_NO_DATA ){
						$data["data"] = "{$WORD($wk, 35)}";
					} else {
						$result = RES_NG;
						$gResult->push("{$WORD($wk, 36)}");
					}
				}
				
				// 掲示板
				if ( $result === RES_OK ){
					$bbsID = DAO::storedFunction("get_bbs_id_by_project_id", $qID);
					if ( is_null($bbsID) ){
						$result = RES_NG;
					}
					if ( $result === RES_OK ){
						$resDAOBbsPost = $objDAOBbsPost->get(NULL, $bbsID);
						if ( $resDAOBbsPost["result"] === RES_OK ){
							$data["bbs"] = Printer::dList( array(
								"{$WORD($wk, 37)}" => $resDAOBbsPost["count"],
							));
						} else if ( $resDAOBbsPost["result"] === RES_NO_DATA ){
							$data["bbs"] = "{$WORD($wk, 38)}";
						} else {
							$result = RES_NG;
						}
					}
					if ( $result === RES_NG ){
						$gResult->push("{$WORD($wk, 39)}");
					}
				}
				
				break;
			case APP_PROJECT_CONTROLLER_MODE_EXPORT:
				$doc = new DocProject();
				$doc->create($qID);
				
				$xmlfile = $doc->saveXML();
				
				header('Content-Disposition: attachment; filename="export.xml"');
				header('Content-Type: text/xml; charset=UTF-8');
				header('Content-Length: '.strlen(bin2hex($xmlfile)));
				
				echo $xmlfile;
				exit();
				break;
			case APP_PROJECT_CONTROLLER_MODE_SET:
				$resDAOProject = $objDAOProject->register($qID, $qState);
				$result = $resDAOProject["result"];
				
				if ( $result !== RES_OK ){
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 40)}");
				}
			default:
				break;
		}
	}
}

$res["result"]  = $result;
$res["message"] = $gResult->string(FALSE, $result);
$res["data"]    = $data;

echo json_encode($res);
