<?php require_once("common/Common.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
Define("HTML_LIMIT", 20); //limitを増やしたい場合は、呼び元のtypeaheadのlimit値も変更する
//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_SUGGEST_CONTROLLER";
// result
$result = RES_OK;
// data
$arrData = array();
// html

//----------------------------
// request parameter
//----------------------------
$qProjectID = isset($_SESSION["project_id"]) ? $_SESSION["project_id"] : REQ_NON;

$qMode    = isset($_REQUEST["q_mode"])    ? $_REQUEST["q_mode"]    : REQ_NON;
$qKeyword = isset($_REQUEST["q_keyword"]) ? $_REQUEST["q_keyword"] : REQ_NON;
$qOrgID   = isset($_REQUEST["q_org_id"])  ? $_REQUEST["q_org_id"]  : REQ_NON;

//----------------------------
// judge post
//----------------------------

//----------------------------
// set types
//----------------------------
Util::setType($qMode,    "int");
Util::setType($qKeyword, "string");
Util::setType($qOrgID,   "int");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::inArray($qMode, $G_APP_SUGGEST_CONTROLLER_KIND_TABLE) ){
		$result = RES_NG;
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
	switch ( $qMode ){
		case APP_SUGGEST_CONTROLLER_MODE_USER_NAME:
			if ( ! Validate::isNumeric($qOrgID) || $qOrgID == 0 ){
				$qOrgID = NULL;
			}
			
			$auth = Auth::instance("user");
			if ( ! $auth->readlist($qOrgID) ){
				$result = RES_NG;
			}
			break;
		case APP_SUGGEST_CONTROLLER_MODE_ORG_NAME:
			$auth = Auth::instance("organization");
			if ( ! $auth->readlist() ){
				$result = RES_NG;
			}
			break;
	}
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
}

//----------------------------
// function
//----------------------------

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	switch ( $qMode ){
		case APP_SUGGEST_CONTROLLER_MODE_USER_NAME:
			$objDAOUser = DAO::instance("user");
			
			$escKeyword = Util::esc($qKeyword);
			$usernameSql = array(
				"type"  => DAO::TYPE_SQL,
				"value" => "t_user_name LIKE '%{$escKeyword}%'",
			);
			$resDAOUser = $objDAOUser->get(NULL, $usernameSql, NULL, array_keys(DAO::T_USER_TYPE_TABLE(NULL, ! Auth::isSysMgr(User::get("type")))), $qOrgID, NULL, HTML_LIMIT);
			
			$result = $resDAOUser["result"];
			if ( $result === RES_OK ){
				foreach ( $resDAOUser["data"] as $dataUser ){
					$arrData[] = array(
						"value" => $dataUser["t_user_name"],
						"org"   => isset($dataUser["t_organization_name"]) ? $dataUser["t_organization_name"] : "",
					);
				}
			}
			
			break;
		case APP_SUGGEST_CONTROLLER_MODE_ORG_NAME:
			$objDAOOrganization = DAO::instance("organization");
			
			$escKeyword = Util::esc($qKeyword);
			$orgnameSql = array(
				"type"  => DAO::TYPE_SQL,
				"value" => "t_organization_name LIKE '%{$escKeyword}%'",
			);
			$resDAOOrganization = $objDAOOrganization->get(NULL, $orgnameSql, FALSE, NULL, HTML_LIMIT);
			
			$result = $resDAOOrganization["result"];
			if ( $result === RES_OK ){
				foreach ( $resDAOOrganization["data"] as $dataOrganization ){
					$arrData[] = array(
						"value" => $dataOrganization["t_organization_name"],
					);
				}
			}
			
			break;
	}
}

if ( $result === RES_NO_DATA ){
	$arrData = array();
} else if ( $result === RES_NG ){
	$arrData = array();
}

header("Content-Type: application/json; charset=utf-8");
echo json_encode($arrData);
