<?php require_once("common/Common.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 用語
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_TERM_CONTROLLER";
// result
$result = RES_OK;
$resData = NULL;
// data
$transText = "";
// html

//----------------------------
// request parameter
//----------------------------
$qToken     = isset($_REQUEST["q_token"])      ? $_REQUEST["q_token"]      : REQ_NON;
$qMode      = isset($_REQUEST["q_mode"])       ? $_REQUEST["q_mode"]       : REQ_NON;
$qKind      = isset($_REQUEST["q_kind"])       ? $_REQUEST["q_kind"]       : REQ_NON;
$qProjectID = isset($_REQUEST["q_project_id"]) ? $_REQUEST["q_project_id"] : REQ_NON;
$qRootID    = isset($_REQUEST["q_root_id"])    ? $_REQUEST["q_root_id"]    : REQ_NON;
$qID        = isset($_REQUEST["q_id"])         ? $_REQUEST["q_id"]         : REQ_NON;
$qTextS     = isset($_REQUEST["q_text_s"])     ? $_REQUEST["q_text_s"]     : REQ_NON;
$qTextT     = isset($_REQUEST["q_text_t"])     ? $_REQUEST["q_text_t"]     : REQ_NON;

//----------------------------
// judge post
//----------------------------

//----------------------------
// set types
//----------------------------
Util::setType($qToken,     "string");
Util::setType($qMode,      "int");
Util::setType($qKind,      "string");
Util::setType($qProjectID, "int");
Util::setType($qRootID,    "int");
Util::setType($qID,        "int");
Util::setType($qTextS,     "string");
Util::setType($qTextT,     "string");
Util::setType($qRootID,    "int");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::inKeyArray($qKind, Term::KIND_TABLE()) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 1)}");
	}
	if ( ! Validate::inArray($qMode, $G_APP_TERM_CONTROLLER_MODE_TABLE) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 2)}");
	}
	switch ( $qMode ){
		case APP_TERM_CONTROLLER_MODE_FRM:
			if ( ! Validate::isNumeric($qProjectID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 3)}");
			}
			break;
		case APP_TERM_CONTROLLER_MODE_SET:
		case APP_TERM_CONTROLLER_MODE_DEL:
			if ( ! Validate::isToken($qToken, "q_token", FALSE) && ! Validate::isToken($qToken, "q_token_qredit", FALSE)){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 4)}");
			}
			if ( ! Validate::inArray($qMode, $G_APP_TERM_CONTROLLER_MODE_TABLE) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 5)}");
			}
			if ( ! Validate::isNumeric($qID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 6)}");
			}
			if ( ! Validate::isNumeric($qRootID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 7)}");
			}
			break;
	}
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
	if ( $qMode !== APP_TERM_CONTROLLER_MODE_DEL){
		if ( ! Validate::isString($qTextS) && ! Validate::isString($qTextT) ){
			$result = RES_NG;
			$gResult->push("{$WORD($wk, 8)}");
		}
	}
}

//----------------------------
// function
//----------------------------

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	DAO::begin();
	
	$objDAOTermRoot = DAO::instance("term_root", $qKind);
	$objDAOTerm     = DAO::instance("term",      $qKind);
	
	$objViewTerm = View::instance("term");
	
	$kindText  = Term::KIND_TABLE($qKind);
	$cKindText = Term::KIND_TABLE($qKind, FALSE);
	
	// 辞書情報取得 --------------------
	switch ( $qMode ){
		case APP_TERM_CONTROLLER_MODE_FRM:
			$resDAOTermRoot = $objDAOTermRoot->get(NULL, DAO::T_TERM_ROOT_STATE_NORMAL, NULL, NULL, $qProjectID, TRUE);
			$result = $resDAOTermRoot["result"];
			break;
		case APP_TERM_CONTROLLER_MODE_SET:
		case APP_TERM_CONTROLLER_MODE_DEL:
			$resDAOTermRoot = $objDAOTermRoot->get($qRootID, DAO::T_TERM_ROOT_STATE_NORMAL);
			$result = $resDAOTermRoot["result"];
			if ( $result !== RES_OK ){
				$result = RES_NG;
			}
			break;
	}
	
	// 処理 --------------------
	if ( $result === RES_OK ){
		switch ( $qMode ){
			// フォーム
			case APP_TERM_CONTROLLER_MODE_FRM:
				$resData = $objViewTerm->form($qTextS, $qTextT, $resDAOTermRoot["data"]);
				break;
			// 登録
			case APP_TERM_CONTROLLER_MODE_SET:
				$resDAOTerm = $objDAOTerm->register($qID, $qTextS, $qTextT, $qRootID, User::get("id"));
				$result = $resDAOTerm["result"];
				if ( $result === RES_OK ){
					$_REQUEST["q_id"] = $resDAOTerm["id"];
				} else if ( $result === RES_NO_DATA ){
					$gResult->push("{$WORD($wk, 9, $cKindText)}");
				} else {
					$gResult->push("{$WORD($wk, 10)}");
				}
				$resData = $_REQUEST;
				break;
			// 削除
			case APP_TERM_CONTROLLER_MODE_DEL:
				$resDAOTerm = $objDAOTerm->delete($qID);
				$result = $resDAOTerm["result"];
				$resData = $_REQUEST;
				break;
			default:
				break;
		}
	} else if ( $result === RES_NO_DATA ){
		$gResult->push("{$WORD($wk, 11)}");
	} else {
		$gResult->push("{$WORD($wk, 12)}");
	}
	
	DAO::end($result);
}

$res["result"]  = $result;
$res["message"] = $gResult->string(FALSE, $result);
$res["data"]    = $resData;

echo json_encode($res);
