<?php require_once("common/Common.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 用語
// argument : 
//--------------------------------------------------------------------
//----------------------------
// define
//----------------------------
//----------------------------
// variable
//----------------------------
// word key
$wk = "WORD_P_APP_USER_CONTROLLER";
// result
$result = RES_OK;
$resData = NULL;
// data
// html

//----------------------------
// request parameter
//----------------------------
$qToken     = isset($_REQUEST["q_token"])      ? $_REQUEST["q_token"]      : REQ_NON;
$qMode      = isset($_REQUEST["q_mode"])       ? $_REQUEST["q_mode"]       : REQ_NON;
$qID        = isset($_REQUEST["q_id"])         ? $_REQUEST["q_id"]         : REQ_NON;
$qState     = isset($_REQUEST["q_state"])      ? $_REQUEST["q_state"]      : REQ_NON;
$qNonActive = isset($_REQUEST["q_non_active"]) ? $_REQUEST["q_non_active"] : REQ_NON;

//----------------------------
// judge post
//----------------------------

//----------------------------
// set types
//----------------------------
Util::setType($qToken,     "string");
Util::setType($qMode,      "int");
Util::setType($qID,        "int");
Util::setType($qState,     "int");
Util::setType($qNonActive, "int");

//----------------------------
// Auth-Before validate
//----------------------------
if ( $result === RES_OK ){
	if ( ! Validate::inArray($qMode, $G_APP_USER_CONTROLLER_MODE_TABLE) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 1)}");
	}
	if ( ! Validate::isNumeric($qID) ){
		$result = RES_NG;
		$gResult->push("{$WORD($wk, 2)}");
	}
	switch ( $qMode ){
		case APP_USER_CONTROLLER_MODE_GET:
			break;
		case APP_USER_CONTROLLER_MODE_SET_STATE:
			if ( ! Validate::isToken($qToken, "token_common", FALSE) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 3)}");
			}
			if ( ! Validate::inKeyArray($qState, DAO::T_USER_STATE_TABLE()) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 4)}");
			}
			break;
		case APP_USER_CONTROLLER_MODE_SET_WARN_NON_ACTIVE:
			if ( ! Validate::isToken($qToken, "token_common", FALSE) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 5)}");
			}
			if ( ! Validate::inKeyArray($qNonActive, DAO::T_USER_WARN_NON_ACTIVE_TABLE()) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 6)}");
			}
			break;
	}
}
if ( $result === RES_OK ){
	$qOrgID = DAO::storedFunction("get_organization_id_by_user_id", $qID);
}

//----------------------------
// Auth
//----------------------------
if ( $result === RES_OK ){
	$auth = Auth::instance("user");
	switch ( $qMode ){
		case APP_USER_CONTROLLER_MODE_GET:
			if ( ! $auth->read($qID, $qOrgID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 7)}");
			}
			break;
		case APP_USER_CONTROLLER_MODE_SET_STATE:
			if( ! $auth->write($qID, $qOrgID)){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 8)}");
			}
		case APP_USER_CONTROLLER_MODE_SET_WARN_NON_ACTIVE:
			if ( ! $auth->write_isLoginState($qID, $qOrgID) ){
				$result = RES_NG;
				$gResult->push("{$WORD($wk, 9)}");
			}
			break;
	}
}

//----------------------------
// Auth-After validate
//----------------------------
if ( $result === RES_OK ){
	
}

//----------------------------
// function
//----------------------------

//----------------------------
// process
//----------------------------
if ( $result === RES_OK ){
	DAO::begin();
	
	$objDAOUser        = DAO::instance("user");
	$objDAOProjectUser = DAO::instance("project_user");
	$objViewProjectUser = View::instance("project_user");
	
	$resDAOUser = $objDAOUser->get($qID);
	$result = $resDAOUser["result"];
	
	// 処理 --------------------
	if ( $result === RES_OK ){
		$dataUser = $resDAOUser["data"][0];
		
		switch ( $qMode ){
			// ゲット
			case APP_USER_CONTROLLER_MODE_GET:
				$resDAOProjectUser = $objDAOProjectUser->get(NULL, $qID, NULL, NULL, 10);
				if ( $resDAOProjectUser["result"] === RES_OK ){
					$hProject = $objViewProjectUser->listProject( $resDAOProjectUser["data"] );
				} else {
					$hProject = "";
				}
				$resData = array(
					"userName" => Util::esc($dataUser["t_user_name"]),
					"orgName" => Util::esc($dataUser["t_organization_name"]),
					"userType" => DAO::T_USER_TYPE_TABLE($dataUser["t_user_type"]),
					"htmlProject" => $hProject,
				);
				break;
			case APP_USER_CONTROLLER_MODE_SET_STATE:
				$resDAOUser = $objDAOUser->register($qID, NULL, $qState);
				$result = $resDAOUser["result"];
				if ( $result === RES_OK ){
					$resData = array(
						"stateText"  => DAO::T_USER_STATE_TABLE($qState)." ",
						"alertClass" => DAO::T_USER_STATE_ALERT_TABLE($qState),
					);
				} else {
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 10)}");
				}
				break;
			case APP_USER_CONTROLLER_MODE_SET_WARN_NON_ACTIVE:
				$resDAOUser = $objDAOUser->registerWarnNonActive($qID, $qNonActive);
				$result = $resDAOUser["result"];
				if ( $result === RES_OK ){
					$resData = array(
						"text"       => DAO::T_USER_WARN_NON_ACTIVE_TABLE($qNonActive)." ",
						"alertClass" => DAO::T_USER_WARN_NON_ACTIVE_ALERT_TABLE($qNonActive),
					);
				} else {
					$result = RES_NG;
					$gResult->push("{$WORD($wk, 11)}");
				}
				break;
		}
	} else if ( $result === RES_NO_DATA ){
		$gResult->push("{$WORD($wk, 12)}");
	} else {
		$gResult->push("{$WORD($wk, 13)}");
	}
	
	DAO::end($result);
}

$res["result"]  = $result;
$res["message"] = $gResult->string(FALSE, $result);
$res["data"]    = $resData;

echo json_encode($res);
