/*
* Notify Bar - jQuery plugin
*
* Copyright (c) 2009-2010 Dmitri Smirnov
*
* Licensed under the MIT license:
* http://www.opensource.org/licenses/mit-license.php
*
* Version: 1.2.2
*
* Project home:
* http://www.dmitri.me/blog/notify-bar
*/
jQuery.notify = function( settings ){
(function($) {
	var bar = notify = {};
	notify.shown = false;
	
	if( ! settings ){
		settings = {};
	}
	
	// HTML inside bar
	notify.html = settings.html || "Your message here";
	
	//How long bar will be delayed, doesn't count animation time.
	notify.delay = settings.delay || 6000;
	
	//How long notify bar will be slided up and down
	notify.animationSpeed = settings.animationSpeed || 200;
	
	//Set up own class
	notify.cls = settings.cls || "";
	
	//close button
	notify.close = settings.close || false;
	
	bar = jQuery("<div></div>").addClass("jquery-notify-bar").addClass(notify.cls).attr("id", "__notify");
	bar.html(notify.html).hide();
	
	var id = bar.attr("id");
	
	var asTime = 500;
	
	if( bar !== "object"); {
		jQuery("body").prepend(bar);
	}
	
	if( $(".jquery-notify-bar:visible").length > 0 ){
		$(".jquery-notify-bar:visible").stop().slideUp(asTime, function(){
			bar.stop().slideDown(asTime);
		});
	} else {
		bar.slideDown(asTime);
	}
	
	if( bar.attr("id") == "__notify"){
		setTimeout("jQuery('#" + id + "').stop().slideUp(" + asTime +", function() {jQuery('#" + id + "').remove()});", notify.delay + asTime);
	} else {
		setTimeout("jQuery('#" + id + "').stop().slideUp(" + asTime +", function() {jQuery('#" + id + "')});", notify.delay + asTime);
	}
})(jQuery) };