minhon.bbs = {
	initialize : function(){
		$("a.glyphicon").on("click" , function(){
			var threadNoParent = $(this).attr("data-thread-no");
			
			// 再非表示
			$("#bbs-post-row-"+ threadNoParent).trigger("click");
			
			// 子の書き込みの表示・非表示
			$("#bbs-post-table tr.bbs-post-row").each(function(){
				var threadNo  = $(this).attr("data-thread-no");
				var bbsPostNo = $(this).attr("data-bbs-post-no");
				// 親と一致した子の書き込みの場合
				if ((threadNo != bbsPostNo) && (threadNo == threadNoParent)){
					if ( $(this).is(".hidden") ){
						$(this).removeClass("hidden");
					} else {
						$(this).addClass("hidden");
					}
				}
			});
			
			// 表示アイコン切り替え
			if ($(this).is(".glyphicon-chevron-down")){
				$(this).removeClass("glyphicon-chevron-down");
				$(this).addClass("glyphicon-chevron-right");
			} else {
				$(this).removeClass("glyphicon-chevron-right");
				$(this).addClass("glyphicon-chevron-down");
			}
			
			// ストライプ処理
			minhon.bbs.striped();
		});

		// 一覧テーブルの行をクリックされた時の処理
		$("tr.bbs-post-row").on("click", function(e){
			if ( $(this).is(".select") ){
				$("tr.bbs-post-row.select").removeClass("select");
			} else {
				$("tr.bbs-post-row.select").removeClass("select");
				$(this).addClass("select");
			}
			
			var $content = $(this).next(".bbs-post-detail");
			if ( $content.length == 0 ){
				return;
			}
			$("tr.bbs-post-detail").stop(true, true);
			if ( $content.is(":visible") ){
				$("tr.bbs-post-detail").hide();
			} else {
				$("tr.bbs-post-detail").hide();
				$content.animate({
					"opacity": "show",
				}, 500);
				minhon.common.ellipsis( $content );
			}
		});
		
		// タイトル検索ダイアログで送信された時の処理
		//minhon.common.search.setEvent("#dialog_bbs_filter_title");
		$("#dialog_bbs_filter_title form").on("submit", function(){
			jQuery.each($("#dialog_bbs_filter_title form").serializeArray(), function(idx, v){
				var $ele = $("#form-bbs-post-table input[name='"+v.name+"']");
				if ( $ele.length == 0 ){
					$ele = $("<input>").attr({
						"type" : "hidden",
						"name" : v.name
					}).appendTo( $("#form-bbs-post-table") );
				}
				$ele.val( v.value );
			});
			$("#form-bbs-post-table").submit();
			
			return false;
		});
		
		// フィルターダイアログ内のボタンが押された時の処理
		$("#dialog_bbs_filter_user,#dialog_bbs_filter_object").on("click", "a.btn-active-danger", function(e){
			var name  = $(this).attr("data-filter-name");
			var value = $(this).attr("data-filter-value");
			
			if ( $(this).is(".active") ){
				$(this).removeClass("active");
				value = null;
			} else {
				$(this).closest("div").find("a.active").removeClass("active");
				$(this).toggleClass("active");
			}
			
			$("#bbs-post-table").triggerHandler("filter", [name, value]);
		});
		
		// フィルターがかけられた時の処理
		$("#bbs-post-table").on("filter", function(e, name, value){
			// value だけが空の時は、指定のフィルタを解除する
			// name,value が空の時は、フィルタをかけるだけ
			
			var valueNo = null
			var valueObjectTerm = null;
			var valueObjectBilingual = null;
			var valueObjectData = null;
			
			if ( name ){
				var $filter = $("#form-bbs-post-table input[name='"+name+"']");
				if ( typeof value == "undefined" || value == null ){
					$filter.remove();
				} else if ( value ){
					if ( $filter.length > 0 ){
						$filter.val( value );
					} else {
						$("<input>").attr({
							"type" : "hidden",
							"name" : name,
						}).val( value ).appendTo( $("#form-bbs-post-table") );
					}
				}
				if ( history && history.replaceState ){
					history.replaceState(null, null, "./detail.html?"+$("#form-bbs-post-table").serialize());
				}
			}
			
			$(".th-filter .dropdown-toggle").find(".glyphicon.select").filter(function(){
				return ! $(this).closest(".th-filter").is(".filter-title");
			}).removeClass("select");
			
			var selector = "tr.bbs-post-row";
			$("#form-bbs-post-table")
			.find("input[name='q_no']").each( function(){
				selector += '[data-bbs-post-no]';
				valueNo = JSON.parse( $(this).val() );
			}).end()
			.find("input[name='q_stage']").each( function(){
				if ( $.isNumeric($(this).val()) ){
					selector += '[data-stage="'+$(this).val()+'"]';
					$(".th-filter.filter-stage").find(".dropdown-toggle .glyphicon").addClass("select");
				}
			}).end()
			.find("input[name='q_type']").each( function(){
				if ( $.isNumeric($(this).val()) ){
					selector += '[data-type="'+$(this).val()+'"]';
					$(".th-filter.filter-type").find(".dropdown-toggle .glyphicon").addClass("select");
				}
			}).end()
			.find("input[name='q_user_id']").each( function(){
				if ( $.isNumeric($(this).val()) ){
					selector += '[data-user-id="'+$(this).val()+'"]';
					$(".th-filter.filter-user").find(".dropdown-toggle .glyphicon").addClass("select");
				}
			}).end()
			.find("input[name='q_user_role']").each( function(){
				if ( $.isNumeric($(this).val()) ){
					selector += '[data-user-role="'+$(this).val()+'"]';
					$(".th-filter.filter-user").find(".dropdown-toggle .glyphicon").addClass("select");
				}
			}).end()
			.find("input[name='q_object_term']").each( function(){
				if ( $.isNumeric($(this).val()) ){
					selector += '[data-object-term]';
					valueObjectTerm = $(this).val();
					$(".th-filter.filter-object").find(".dropdown-toggle .glyphicon").addClass("select");
				}
			}).end()
			.find("input[name='q_object_bilingual']").each( function(){
				if ( $.isNumeric($(this).val()) ){
					selector += '[data-object-bilingual]';
					valueObjectBilingual = $(this).val();
					$(".th-filter.filter-object").find(".dropdown-toggle .glyphicon").addClass("select");
				}
			}).end()
			.find("input[name='q_object_data']").each( function(){
				if ( $.isNumeric($(this).val()) ){
					selector += '[data-object-data]';
					valueObjectData = $(this).val();
					$(".th-filter.filter-object").find(".dropdown-toggle .glyphicon").addClass("select");
				}
			}).end()
			;
			
			$("#bbs-post-table tr.bbs-post-row").addClass("hidden").removeClass("filter-disabled");
			$("#bbs-post-table "+selector).filter( function(){
				if ( valueNo != null && $.inArray(parseInt($(this).attr("data-bbs-post-no")), valueNo) == -1 ){
					return false;
				}
				if ( valueObjectTerm != null && $.inArray(valueObjectTerm, JSON.parse($(this).attr("data-object-term"))) == -1 ){
					return false;
				}
				if ( valueObjectBilingual != null && $.inArray(valueObjectBilingual, JSON.parse($(this).attr("data-object-bilingual"))) == -1 ){
					return false;
				}
				if ( valueObjectData != null && $.inArray(valueObjectData, JSON.parse($(this).attr("data-object-data"))) == -1 ){
					return false;
				}
				return true;
			}).removeClass("hidden");
			if ( $("#bbs-post-table").is(".thread") ){
				$("#bbs-post-table tr.bbs-post-row:visible").each ( function(){
					var threadNo = $(this).attr("data-thread-no");
					if ( threadNo ){
						$("#bbs-post-table tr.bbs-post-row.hidden[data-thread-no='"+threadNo+"']").removeClass("hidden").addClass("filter-disabled");
					}
				});
			}
			$("#bbs-post-table tr.bbs-post-row.hidden").each( function(){
				$(this).removeClass("select");
				$(this).next(".bbs-post-detail").hide();
			});
			if ( $("#bbs-post-table tr.bbs-post-row:visible").length > 0 ){
				$("#bbs-post-table tr.bbs-post-nodata").hide();
			} else {
				$("#bbs-post-table tr.bbs-post-nodata").show();
			}

			// 親の書き込みのみを表示
			minhon.bbs.dispParentThread();
			// ストライプ処理
			minhon.bbs.striped();

		});
		
		// テーブルのセル幅が変更しないようにする
		$("#bbs-post-table > thead > tr > th").each(function(){
			$(this).width( $(this).width() );
		});
		
		// メッセージに追記
		$("#form_bbs_post_addition").on("submit", function(){
			minhon.bbs.onClickAdditionOK();
			return false;
		});
		
		// フィルターをかける
		$("#bbs-post-table").triggerHandler("filter");
		
		// セルにカーソルを合わせた時のポップオーバー処理
		$('[data-toggle="popover"]').popover({
			container : 'body'
		});
		
		// >>x のリンク処理
		$("#bbs-post-table .bbs-post-body a[href^=#]").click(function(){
			var hash = $(this.hash);
			
			if ( ! $(hash).offset() ){
				return;
			}
			
			$(hash).find("div.body").show(1500);
			
			var HashOffset = $(hash).offset().top - $("#header").height() - 20;
			
			$("html,body").animate({
				scrollTop: HashOffset
			}, 1000, null, function(){
				$(hash).fadeOut(250,function(){$(this).fadeIn(250)});
			});
			
			return false;
		});
		
		// 並び替え(昇順、降順)クリック
		$(".th-filter .dropdown-menu a[data-order-name]").on("click", function(e){
			var name = $(this).attr("data-order-name");
			var order = null;
			if ( $(this).is(".order-none") ){
				order = "asc";
			} else if ( $(this).is(".order-asc") ){
				order = "desc";
			} else if ( $(this).is(".order-desc") ){
				order = "asc";
			}
			if ( order == null ){
				order = $(this).attr("data-order-type");
			}
			var value = name+"-"+order;
			if ( $("#form-bbs-post-table input[name='q_order']").val() == value ){
				console.log("true");
				$("#form-bbs-post-table input[name='q_order']").remove();
			} else {
				$("#form-bbs-post-table input[name='q_order']").val( value );
			}
			
			$("#form-bbs-post-table").submit();
			
			e.preventDefault();
			//return false;
		});
		// フィルタクリック
		$(".th-filter .dropdown-menu a[data-filter-name]").on("click", function(e){
			var name = $(this).attr("data-filter-name");
			var value = $(this).attr("data-filter-value");
			var $owner = $("#bbs-post-table");
			
			// ドロップダウンメニューなら チェックアイコンを移動
			if ( $(this).closest(".dropdown").length > 0 ){
				// チェックアイコンをクリアする
				$(this).closest("th").find("[data-filter-name='"+name+"'] > .glyphicon-ok").removeClass("glyphicon-ok").addClass("glyphicon-none");
				// 自分自身にチェックアイコンを表示
				$(this).children(".glyphicon").removeClass("glyphicon-none").addClass("glyphicon-ok");
			}
			
			$owner.triggerHandler("filter", [name, value]);
			
			e.preventDefault();
			//return false;
		});
		
		// 親の書き込みのみを表示
		minhon.bbs.dispParentThread();
		// ストライプ処理
		minhon.bbs.striped();
	},
	
	dispParentThread : function(){
		$("#bbs-post-table tr.bbs-post-row:visible").each(function(){
			var threadNo  = $(this).attr("data-thread-no");
			var bbsPostNo = $(this).attr("data-bbs-post-no");
			// 親の書き込み以外はデフォルト非表示
			if (threadNo != bbsPostNo){
				$(this).addClass("hidden");
			}
		});
	},
	
	striped : function(){
		var indx = 0
		$("tr.striped-zebra").removeClass("striped-zebra");
		$("#bbs-post-table tr.bbs-post-row:visible").each(function(){
			indx++;
			if ( (indx % 2) == 1 ){
				$(this).addClass("striped-zebra");
			}
		});
	},
	
	onClickFilterTitle : function(){
		minhon.common.search.onClickOpenDialog("#dialog_bbs_filter_title");
	},
	
	onClickFilterTitleClear : function(){
		minhon.common.search.onClickClear("#dialog_bbs_filter_title");
	},
	
	onClickFilterUser : function(){
		var back = $("#dialog_bbs_filter_user").html();
		
		var searchTimer = null;
		$("#dialog_bbs_filter_user").dialog({
			"width" : "800px",
			modal : true,
			resizable: false,
			buttons : [
				minhon.common.dialogButton.OK(function(){
					$(this).dialog("close");
				}),
				minhon.common.dialogButton.Cancel(function(){
					$("#dialog_bbs_filter_user").html( back );
					// フィルタ状態を更新する
					var val;
					// ユーザー
					val = $("#dialog_bbs_filter_user a[data-filter-name='user_id'].active").attr("data-filter-value"); //.activeがなければ null
					$("#bbs-post-table").triggerHandler("filter", ["user_id", val]);
					// 役割
					val = $("#dialog_bbs_filter_user a[data-filter-name='user_role'].active").attr("data-filter-value"); //.activeがなければ null
					$("#bbs-post-table").triggerHandler("filter", ["user_role", val]);
					
					// 閉じる
					$(this).dialog("close");
				})
			],
			open : function(){
				$(this).find("*:focus").blur(); //フォーカスを外す
				
				// タイマーセット
				var $search = $(this).find(".user-search");
				var $table  = $search.next("table");
				if ( $search.length > 0 && $table.length > 0 ){
					searchTimer = setInterval(function(){
						var val = $search.val();
						if ( val.length == 0 ){
							$table.find(".btn-user").removeAttr("disabled").css("opacity", 1.0);
							return;
						}
						
						$table.find(".btn-user").attr("disabled", "disabled").css("opacity", 0.2);
						$table.find(".btn-user").filter(function(){
							return $(this).text().trim().match("^" + val + ".*");
						}).removeAttr("disabled").css("opacity", 1.0);
					}, 100);
				}
			},
			close : function(){
				if ( searchTimer ){
					clearInterval(searchTimer);
				}
			}
		});
	},
	
	onClickFilterObject : function(){
		var back = $("#dialog_bbs_filter_object").html();
		
		$("#dialog_bbs_filter_object").dialog({
			"width" : "800px",
			modal : true,
			resizable: false,
			buttons : [
				minhon.common.dialogButton.OK(function(){
					$(this).dialog("close");
				}),
				minhon.common.dialogButton.Cancel(function(){
					$("#dialog_bbs_filter_object").html( back );
					// フィルタ状態を更新する
					var val;
					// 用語集
					val = $("#dialog_bbs_filter_object a[data-filter-name='object_term'].active").attr("data-filter-value");
					$("#bbs-post-table").triggerHandler("filter", ["object_term", val]);
					// 翻訳メモリ
					val = $("#dialog_bbs_filter_object a[data-filter-name='object_bilingual'].active").attr("data-filter-value");
					$("#bbs-post-table").triggerHandler("filter", ["object_bilingual", val]);
					// データ
					val = $("#dialog_bbs_filter_object a[data-filter-name='object_data'].active").attr("data-filter-value");
					$("#bbs-post-table").triggerHandler("filter", ["object_data", val]);
					
					// 閉じる
					$(this).dialog("close");
				})
			],
			open : function(){
				$(this).find("*:focus").blur(); //フォーカスを外す
				minhon.common.ellipsis( $(this) );
			}
		});
	},
	
	onClickAddition : function( bbsID, postNo ){
		var $detail = $(".bbs-post-detail[data-bbs-post-no='"+postNo+"']");
		if ( ! $detail.is(":visible") ){
			// 非表示ならクリックイベントを発生させ開く
			$(".bbs-post-row[data-bbs-post-no='"+postNo+"']").triggerHandler("click");
		}
		
		if ( $detail.find("#form_bbs_post_addition").length > 0 ){
			minhon.bbs.onClickAdditionCancel();
		} else {
			$("#form_bbs_post_addition textarea").val("");
			$("#form_bbs_post_addition [name='q_id']").val(bbsID);
			$detail.find(".bbs-post-body").after( $("#form_bbs_post_addition") );
			$("#form_bbs_post_addition textarea").focus();
		}
	},
	
	onClickAdditionOK : function(){
		var $form = $("#form_bbs_post_addition");
		var $row = $form.closest(".bbs-post-detail");
		if ( $row.length == 0 ){
			return false;
		}
		var bbsID = $form.find("[name='q_id']").val();
		var text  = $form.find("[name='q_addition_text']").val();
		jQuery.ajax({
			url      : "/app/bbsController.php",
			type     : "POST",
			data     : {
							"q_mode"    : minhon.define.APP_BBS_CONTROLLER_MODE_ADDITION,
							"q_id"      : bbsID,
							"q_post_no" : $row.attr("data-bbs-post-no"),
							"q_text"    : text,
							"q_token"   : $("#token_common").val()
						},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					minhon.common.reload();
				} else {
					$("#token_common").val( res.data.token );
					alert(res.message);
				}
			}
		});
	},
	
	onClickAdditionCancel : function(){
		$("#form_bbs_post_addition").appendTo( $(".container") );
	},
	
	onClickDelete : function( bbsID, postNo, message ){
		var def = null;
		if ( message ){
			def = minhon.common.dialog.confirm(message);
		}
		
		$.when(def).done(function(){
			jQuery.ajax({
				url      : "/app/bbsController.php",
				type     : "POST",
				data     : {
								"q_mode"    : minhon.define.APP_BBS_CONTROLLER_MODE_DELETE,
								"q_id"      : bbsID,
								"q_post_no" : postNo,
								"q_token"   : $("#token_common").val()
							},
				dataType : "json",
				error    : function(){
					alert(minhon.define.AJAX_ERROR);
				},
				success  : function( res ){
					if ( res.result == minhon.define.RES_OK ){
						minhon.common.reload();
					} else {
						$("#token_common").val( res.data.token );
						alert(res.message);
					}
				}
			});
		});
	},
	
	onClickViewMode : function(self){
		var viewMode = $(self).attr("data-view-mode");
		
		$("#form-bbs-post-table")
			.find("input[name='q_view_mode']").val(viewMode).end()
			.submit();
	},
	
	eod : null
};

minhon.bbs2 = {
	dropdown : null,
	
	VIEW_MODE_DETAIL : 0, //*php
	VIEW_MODE_SIMPLE : 1, //*php
	
	VIEW_REPLY_SHOW : 0, //*php
	VIEW_REPLY_HIDE : 1, //*php
	
	initialize : function(){
		// Dropdown
		minhon.bbs2.dropdown = $("#bbsRootDropdown");
		$("#bbsViewModeSimple").on("click", function(e){
			var ul = $(this).closest("ul.list-group");
			minhon.bbs2.changeViewMode(ul, minhon.bbs2.VIEW_MODE_SIMPLE);
			$(minhon.bbs2.dropdown).dropdown('toggle');
			return false;
		});
		$("#bbsViewModeDetail").on("click", function(){
			var ul = $(this).closest("ul.list-group");
			minhon.bbs2.changeViewMode(ul, minhon.bbs2.VIEW_MODE_DETAIL);
			$('html,body').stop(true).animate({scrollTop: $(ul).offset().top}, 500, "easeInOutQuart")
		});
		$("#bbsViewReplyHide").on("click", function(){
			var ul = $(this).closest("ul.list-group");
			minhon.bbs2.changeViewReply(ul, minhon.bbs2.VIEW_REPLY_HIDE);
			$(minhon.bbs2.dropdown).dropdown('toggle');
			return false;
		});
		$("#bbsViewReplyShow").on("click", function(){
			var ul = $(this).closest("ul.list-group");
			minhon.bbs2.changeViewReply(ul, minhon.bbs2.VIEW_REPLY_SHOW);
			$('html,body').stop(true).animate({scrollTop: $(ul).offset().top}, 500, "easeInOutQuart")
		});
		$(".btnViewReply").on("click", function(){
			var ul = $(this).closest("ul.list-group");
			if ( $(ul).attr("data-view-reply") == minhon.bbs2.VIEW_REPLY_SHOW ){
				minhon.bbs2.changeViewReply(ul, minhon.bbs2.VIEW_REPLY_HIDE);
			} else {
				minhon.bbs2.changeViewReply(ul, minhon.bbs2.VIEW_REPLY_SHOW);
			}
			$('html,body').stop(true).animate({scrollTop: $(ul).offset().top}, 500, "easeInOutQuart")
		});
		$(".btnViewReply").each( function(i, ele){
			var ul = $(ele).closest("ul.list-group");
			var childcount = $(ul).find(".list-group-item:not(.item-root)").length;
			$(ele).find("span").text(childcount);
		});
		
		$("#form_bbs_search").on("submit", function(){
			if ( $("#q_stage").val() >= 0 ){
				$("<input />").attr({
					"type" : "hidden",
					"name" : "q_stage",
					"value" : $("#q_stage").val()
				}).appendTo( $("#form_bbs_search") );
			}
			if ( $("#q_type").val() >= 0 ){
				$("<input />").attr({
					"type" : "hidden",
					"name" : "q_type",
					"value" : $("#q_type").val()
				}).appendTo( $("#form_bbs_search") );
			}
			if ( $("#q_role").val() >= 0 ){
				$("<input />").attr({
					"type" : "hidden",
					"name" : "q_role",
					"value" : $("#q_role").val()
				}).appendTo( $("#form_bbs_search") );
			}
		});
		
		$("a[href^=#]").click(function(){
			var hash = $(this.hash);
			
			if ( ! $(hash).offset() ){
				return;
			}
			
			$(hash).find("div.body").show(1500);
			
			var HashOffset = $(hash).offset().top - $("#header").height() - 20;
			
			$("html,body").animate({
				scrollTop: HashOffset
			}, 1000, null, function(){
				$(hash).fadeOut(250,function(){$(this).fadeIn(250)});
			});
			
			return false;
		});
		
		var isShowForm = false;
		isShowForm = isShowForm || ( $("#q_stage").val() >= 0 );
		isShowForm = isShowForm || ( $("#q_type").val() >= 0 );
		isShowForm = isShowForm || ( $("#q_role").val() >= 0 );
		minhon.bbs2.formToggle(isShowForm);
		
		minhon.bbs2.onAsyncSubmit();
	},
	
	changeViewMode : function( ul, viewMode ){
		if ( typeof viewMode !== "undefined" ){
			$(ul).attr("data-view-mode", viewMode);
		} else {
			viewMode = $(ul).attr("data-view-mode");
		}
		
		if ( viewMode == minhon.bbs2.VIEW_MODE_DETAIL ){
			$(ul).find(".bbs-post-body").show();
		} else { // simple
			$(ul).find(".bbs-post-body").hide();
		}
	},
	allChangeViewMode : function( viewMode ){
		if ( typeof viewMode !== "undefined" ){
			$("#form_bbs_search *[name=q_view_mode]").attr("value", viewMode);
		}
		$("#form_bbs_search").submit();
	},
	
	changeViewReply : function( ul, viewReply  ){
		if ( typeof viewReply !== "undefined" ){
			$(ul).attr("data-view-reply", viewReply);
		} else {
			viewReply = $(ul).attr("data-view-reply");
		}
		
		if ( viewReply == minhon.bbs2.VIEW_REPLY_SHOW ){
			$(ul).find("li.list-group-item").show();
		} else {
			$(ul).find("li.list-group-item:not(.item-root)").hide();
		}
	},
	allChangeViewReply : function( viewReply ){
		if ( typeof viewReply !== "undefined" ){
			$("#form_bbs_search *[name=q_view_reply]").attr("value", viewReply);
		}
		$("#form_bbs_search").submit();
	},
	
	changeOrder : function( order ){
		$("#form_bbs_search *[name=q_order]").attr("value", order);
		$("#form_bbs_search").submit();
	},
	
	onClickDropdownLink : function( self ){
		$(self).after(minhon.bbs2.dropdown);
		
		var ul = $(self).closest("ul.list-group");
		$("#bbsViewModeDetail").hide();
		$("#bbsViewModeSimple").hide();
		if ( $(ul).attr("data-view-mode") == minhon.bbs2.VIEW_MODE_DETAIL ){
			$("#bbsViewModeSimple").show();
		} else {
			$("#bbsViewModeDetail").show();
		}
		
		$("#bbsViewReplyNone").hide();
		$("#bbsViewReplyShow").hide();
		$("#bbsViewReplyHide").hide();
		var childcount = $(ul).find(".list-group-item:not(.item-root)").length;
		if( childcount === 0 ){
			$("#bbsViewReplyNone").show();
		} else {
			if ( $(ul).attr("data-view-reply") == minhon.bbs2.VIEW_REPLY_SHOW ){
				$("#bbsViewReplyHide").show();
			} else {
				$("#bbsViewReplyShow").show()
					.find("span").text(childcount);
			}
		}
		
		$(self).dropdown();
	},
	
	formToggle : function( bool ){
		$("#form_bbs_search").closest(".panel").toggle(bool);
	},
	
	onAsyncSubmit : function(){
		$(".list-group-overlay.enabled").removeClass("enabled");
		
		var stage = $("#q_stage").val();
		var stageHit = null;
		if ( stage >= 0 ){
			var stageHit = $("*[data-bbs-post-stage="+stage+"]").closest("li.list-group-item");
		}
		
		var type = $("#q_type").val();
		var typeHit = null;
		if ( type >= 0 ){
			typeHit = $("*[data-bbs-post-type="+type+"]").closest("li.list-group-item");
		}
		
		var role = $("#q_role").val();
		var roleHit = null;
		if ( role >= 0 ){
			roleHit = $("*[data-user-role="+role+"]").closest("li.list-group-item");
		}
		
		$.each( $("li.list-group-item"), function(){
			if ( stageHit && ($.inArray( this, stageHit ) === -1) ){
				$(this).children(".list-group-overlay").addClass("enabled");
			}
			if ( typeHit && ($.inArray( this, typeHit ) === -1) ){
				$(this).children(".list-group-overlay").addClass("enabled");
			}
			if ( roleHit && ($.inArray( this, roleHit ) === -1) ){
				$(this).children(".list-group-overlay").addClass("enabled");
			}
		});
		
		var viewMode  = $("#form_bbs_search *[name=q_view_mode]").val();
		var viewReply = $("#form_bbs_search *[name=q_view_reply]").val();
		$.each( $("ul.list-group"), function(i, ul){
			minhon.bbs2.changeViewMode(ul, viewMode);
			minhon.bbs2.changeViewReply(ul, viewReply);
		});
		// フィルタをかけた時に返答要素のみがヒットした時は無条件で返答要素を表示させる
		$.each( $("ul.list-group"), function(){
			if ( $(this).children("li.list-group-item").children(".list-group-overlay:not(.enabled)").length === 0 ){
				$(this).hide();
			} else {
				$(this).show();
				if ( $(this).children("li.list-group-item.item-root").children(".list-group-overlay.enabled").length > 0 ){
					if ( stageHit || typeHit || roleHit ){
						minhon.bbs2.changeViewReply(this, minhon.bbs2.VIEW_REPLY_SHOW);
					}
				}
			}
		});
	},
	
	eod : null
};

minhon.bbs.post = {
	initialize : function( target ){
		if ( $("input[name='q_target[]']").is("[checked]") ){
			$("#q_target_body").removeClass("in");
		}
		
		$.validator.addMethod('rule_target', function(value){
			return $("input[name='q_target[]']").is("[checked]");
		}, "("+WORD_J_JS_MINHON_BBS_001+")");
		$("#form_bbs").validate({
			rules : {
				"q_text" : {
					required : true
				},
				"q_target[]" : {
					rule_target : true
				}
			},
			ignore : "",
			errorClass : "validate-error",
			errorPlacement : function(label, element){
				if ( $(element).is("[name='q_target[]']") ){
					$(label).css({ "margin-left" : "8px" });
					$("#q_target .panel-title").append( label );
				} else {
					label.insertAfter(element);
				}
			},
			invalidHandler : function(e, validator){
				$(validator.errorList).each( function(){
					if ( $(this.element).is("[name='q_target[]']") ){
						$("#q_target_body").collapse('show');
					}
				});
			}
		});
  		$(document).on('click', '[data-toggle^=button]', function (event) {
			var chk = $(event.target).find("input[type=checkbox]");
			if ( chk.length > 0 ){
				$("#form_bbs").validate().element(chk);
			}
		});
		
		$("#q_target input[type=checkbox][checked]").each( function(){
			$(this).parent(".btn").addClass("active");
		});
		minhon.bbs.post.updateTargetButton();
		minhon.bbs.post.updateTargetText();
		
		$("#q_target_all").on("click", function(e){
			var chk = $(e.target).find("input[type=checkbox]");
			$(chk).prop("checked") ? $(chk).prop("checked", false) : $(chk).prop("checked", true);
//			$(chk).is("[checked]") ? $(chk).removeAttr("checked") : $(chk).attr("checked", "checked");
			
			minhon.bbs.post.updateTargetButton();
			minhon.bbs.post.updateTargetText();
		});
		$("#q_target table .btn").on("change", function(e){
			minhon.bbs.post.updateTargetButton();
			minhon.bbs.post.updateTargetText();
		});
		
		//$('.accordion').accordion({ active : false, collapsible: true, heightStyle : 'content' });
		
	},
	
	updateTargetButton : function(){
		if ( $("#q_target_all input[type=checkbox]").prop("checked") ){
			// all-user
			$("#q_target table .btn").attr("disabled", "disabled");
		}
		else {
			$("#q_target table .btn").removeAttr("disabled");
		}
		
		if ( $("#q_target_all input[type=checkbox]").prop("checked") ){
			$("#q_target_all").addClass("btn-danger");
		} else {
			$("#q_target_all").removeClass("btn-danger");
		}
		$("#q_target table .btn input[type=checkbox]").each( function(){
			if ( $(this).prop("checked") ){
				$(this).closest(".btn").addClass("btn-danger");
			} else {
				$(this).closest(".btn").removeClass("btn-danger");
			}
		});
	},
	
	updateTargetText : function(){
		if ( $("#q_target #q_target_all").is(".btn-danger") ){
			$("#q_target .panel-title").html(WORD_J_JS_MINHON_BBS_002);
		} else {
			var text = "";
			$("#q_target table tr").each( function(){
				var user = $(this).children("td:eq(0)").text().replace(/(^\s+)|(\s+$)/g, "");
				var role = "";
				$(this).find(".btn-danger").each( function(){
					role += $(this).text().replace(/(^\s+)|(\s+$)/g, "") + ",";
				});
				if ( role.length > 0 ){
					role = role.substr(0, role.length-1);
					text += user + "(" + role + ") / ";
				}
			});
			if ( text.length > 0 ){
				text = text.substr(0, text.length-3);
			} else {
				text = WORD_J_JS_MINHON_BBS_003;
			}
			$("#q_target .panel-title").html(text);
		}
	},
	
	postDialog : function( autoReload, bbsID, parentNo, params ){
		var dfd = $.Deferred();
		
		jQuery.ajax({
			url : "/app/bbsController.php",
			type : "POST",
			data : $.extend({
				"q_mode"       : minhon.define.APP_BBS_CONTROLLER_MODE_POSTFRM,
				"q_id"         : bbsID,
				"q_post_no"    : minhon.define.INIT_ID,
				"q_parent_no"  : parentNo,
			}, params),
			dataType : "json",
			error : function(){
				alert(minhon.define.AJAX_ERROR);
				dfd.reject();
			},
			success : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					minhon.bbs.post.showPostDialog(autoReload, res.data).then(function(){
						dfd.resolve();
					}, function(){
						dfd.reject();
					});
				} else {
					alert(res.message);
					dfd.reject();
				}
			}
		});
		
		return dfd.promise();
	},
	
	showPostDialog : function ( autoReload, data ){
		var dfd = $.Deferred();
		
		var dialog = $("<div>").html( data ).dialog({
			width : "80%",
			maxHeight: $(window).height() * 0.85,
			modal : true,
			title : WORD_J_JS_MINHON_BBS_004,
			buttons : [
				minhon.common.dialogButton.OK(), 
				minhon.common.dialogButton.Cancel(),
			],
			create : function(){
				$(this).css("maxHeight", $(window).height() * 0.75);
			},
			open : function(){
				minhon.common.ellipsis( $(this) );
			},
			close : function(){
				if ( dfd.state() == "pending" ){
					dfd.reject();
				}
				$(this).dialog("destroy").remove();
			}
		});
		minhon.bbs.post.initialize();
		$(dialog).find("form").bind("submit", function(){
			var sendData = $(dialog).find("form").serializeArray();
			sendData.push({ name: "q_mode", value: minhon.define.APP_BBS_CONTROLLER_MODE_POSTSET });
			jQuery.ajax({
				url : "/app/bbsController.php",
				type : "POST",
				data : sendData,
				dataType : "json",
				error : function(){
					alert(minhon.define.AJAX_ERROR);
				},
				success : function( res ){
					if ( res.result == minhon.define.RES_OK ){
						dfd.resolve();
						$(dialog).dialog("close");
						if ( autoReload ){
							location.reload();
						} else if ( res.message.length > 0 ){
							alert( res.message );
						}
					} else {
						alert(res.message);
					}
				},
				close : function(){
					if ( dfd.state() == "pending" ){
						dfd.reject();
					}
					$(dialog).dialog("destroy").remove();
				}
			});
			return false;
		});
		
		return dfd.promise();
	},
	
	documentDialog : function( bbsID, postNo ){
		jQuery.ajax({
			url      : "/app/bbsController.php",
			type     : "POST",
			data     : {
							"q_mode"    : minhon.define.APP_BBS_CONTROLLER_MODE_POSTDOC,
							"q_id"      : bbsID,
							"q_post_no" : postNo,
						},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					minhon.bbs.post.showDocumentDialog( res.data );
				} else {
					alert(res.message);
				}
			}
		});
	},
	
	showDocumentDialog : function( data ){
		var dialog = $("<div>").html( data ).dialog({
			width : "90%",
			maxHeight: $(window).height() * 0.85,
			modal : true,
			title : WORD_J_JS_MINHON_BBS_005,
			buttons : [
				minhon.common.dialogButton.Close()
			],
			create : function(){
				$(this).css("maxHeight", $(window).height() * 0.7);
			},
			open : function(){
				var height = $(window).height() * 0.9;
				height = height - $(this).dialog("widget").find(".ui-dialog-titlebar").height() - $(this).dialog("widget").find(".ui-dialog-buttonpane").height();
				$(this).css("maxHeight", height);
				$(this).dialog("option", "position", { "my" : "center", "at" : "center" });
			},
			close : function(){
				$(this).dialog("destroy").remove();
			}
		});
	},
	
	eod : null
}
