var minhon = {};

(function(){
	window.alert = function(){
		return minhon.common.dialog.alert.apply(this, arguments);
	};
		
	if ( $.validator ){
		// date のチェック条件を変更する(yyyy-m-dでも許可する)
		$.validator.addMethod("date", function( value, element ) {
			return this.optional(element) || /^\d{4}[\/\-]\d{1,2}[\/\-]\d{1,2}$/.test(value);
		});
	}
})();

minhon.common = {
	reload : function(){
		location.reload();
	},
	
	overlay : function( overlay ){
		if ( overlay ){
			$("<div>").attr("id", "overlay").appendTo("body");
			$("div#overlay").append($("<i>").addClass("glyphicon glyphicon-refresh glyphicon-spin"));
		} else {
			$("div#overlay").remove();
		}
	},
	
	getParameter : function(){
		var params = location.href.split("?");
		var vars = {};
		if ( params.length >= 2 ){
			var hash;
			var hashParams = params[1].split('&');
			for (var i = 0; i < hashParams.length; i++) {
				hash = hashParams[i].split('=');
				vars[hash[0]] = unescape(hash[1]);
			}
		}
		
		return vars;
	},
	
	getFormParamter : function(form){
		var param = {};
		var $form = $(form);
		
		$.each($form.serializeArray(), function(i, v){
			if ( v.value.length > 0 ){
				param[v.name] = v.value;
			} else if ( v.name in param ){
				delete param[v.name];
			}
		});
		
		return param;
	},
	
	checkLoginState : function( funcLogin, funcLogout ){
		var dfd = new $.Deferred().done(funcLogin).fail(funcLogout);
		
		jQuery.ajax({
			url      : "/app/loginStateController.php",
			type     : "POST",
			dataType : "json",
			success  : function(res){
				if ( res.result === minhon.define.RES_OK ){
					dfd.resolve();
				} else {
					dfd.reject();
				}
			},
			error : function(res){
				dfd.reject();
			}
		});
		
		return dfd.promise();
	},
	
	onChangeSiteInterface : function( obj ){
		jQuery.ajax({
			url      : "/app/settingController.php",
			type     : "POST",
			data     : {
							"q_disp_lang" : $(obj).val()
					   },
			dataType : "json",
			context  : obj,
			error    : function(){
	//					alert("Error");
			},
			success  : function(res){
				if ( res.result === minhon.define.RES_OK ){
					minhon.common.reload();
				} else {
					alert("Error");
				}
			}
		});
	},
	
	getProjectName : function( projectID ){
		jQuery.ajax({
			url      : "/app/projectController.php",
			type     : "POST",
			data     : {
							"q_mode" : minhon.define.APP_PROJECT_CONTROLLER_MODE_GET,
							"q_id"   : projectID
					   },
			dataType : "json",
			error    : function(){
	//					alert("Error");
			},
			success  : function(res){
				if ( res.result === minhon.define.RES_OK ){
					// alert-* のクラス名を消す
					$("#project-state").removeClass( function(index, css){
						return ( css.match(/\balert-\S+/g) || []).join(' ');
					} );
					if ( res.data.state_auth ){
						$("#title-project .dropdown-menu *[data-state]").on("click", function(){
							minhon.common.setProjectState( projectID, $(this).attr("data-state") );
							return false;
						});
					} else {
						$("#title-project > .btn-group").addClass("hidden");
						$("#title-project > .btn").removeClass("hidden").addClass( res.data.state_class ).text( res.data.state_text );
						// 選択不可
//						$("#project-state").attr("disabled", "disabled");
//						$("#project-state-normal").attr("disabled", "disabled");
//						$("#project-state-complete").attr("disabled", "disabled");
					}
					
					var caret = $("<span>").addClass("caret");
					$("#project-state").addClass( res.data.state_class ).text( res.data.state_text ).append( caret );
					
					jQuery.each ( $("#project-state").nextAll("ul.dropdown-menu").find("li > a"), function(){
						var $img = $(this).children("i");
						if ( $(this).attr("data-state") == res.data.state ){
							$img.removeClass("glyphicon-none").addClass("glyphicon-arrow-right");
						} else {
							$img.removeClass("glyphicon-arrow-right").addClass("glyphicon-none");
						}
					});
					
					// プロジェクトタイトルの更新
					$("#title-project .i-text").html(res.data.title);
					$("#title-project").show();
					minhon.common.ellipsis( $("#title-project") );
				} else {
//					alert("Error");
				}
			}
		});
	},
	
	setProjectState : function( projectID, state ){
		jQuery.ajax({
			url      : "/app/projectController.php",
			type     : "POST",
			data     : {
							"q_mode"  : minhon.define.APP_PROJECT_CONTROLLER_MODE_SET,
							"q_token" : $("#token_common").val(),
							"q_id"    : projectID,
							"q_state" : state,
					   },
			dataType : "json",
			error    : function(){
	//					alert("Error");
			},
			success  : function(res){
				if ( res.result === minhon.define.RES_OK ){
					
				}
				if ( res.message.length > 0 ){
					alert(res.message);
				}
				minhon.common.reload();
			}
		});
		
	},
	
	onClickRequest : function( action, arrGetParameter, arrPostParameter, message ){
		var param = "";
		for ( var key in arrGetParameter ){
			var value = arrGetParameter[key];
			param += encodeURI(key) + "=" + encodeURI(value) + "&";
		}
		if ( param.length > 0 ){
			param = "?" + param.slice(0, -1);
		}
		minhon.common.onClickPost( action+param, arrPostParameter, message );
	},
	
	onClickGet : function( action, arrData, message ){
		var def = null;
		if ( message ){
			def = minhon.common.dialog.confirm(message);
		}
		
		$.when(def).done(function(){
			var form = $("<form>")
				.attr("action", action)
				.attr("method", "get")
				.appendTo("body");
			
			for ( var key in arrData ){
				var value = arrData[key];
				
				$(form).append(
					$("<input>")
						.attr("type", "hidden")
						.attr("name", key)
						.val(value)
				)
			}
			
			$(form).submit();
		});
	},
	
	onClickPost : function( action, arrData, message ){
		var def = null;
		if ( message ){
			def = minhon.common.dialog.confirm(message);
		}
		
		$.when(def).done(function(){
			var form = $("<form>")
				.attr("action", action)
				.attr("method", "post")
				.appendTo("body");
				
			$(form).append(
				$("<input>")
					.attr("type", "hidden")
					.attr("name", "q_token")
					.val($("#token_common").val())
			);
			
			for ( var key in arrData ){
				var value = arrData[key];
				
				$(form).append(
					$("<input>")
						.attr("type", "hidden")
						.attr("name", key)
						.val(value)
				)
			}
			
			$(form).submit();
		});
	},
	
	onClickSubmit : function( form ){
		$(form).submit();
	},
	
	onClickDropdown : function( obj ){
		var text = $(obj).text();
		
		$(obj).closest(".input-group").find("input").val(text);
	},
	
	onClickToggleCell : function( self ){
		var tr = $(self).closest("tr");
		var twidth = $(tr).find("td.toggle-role:visible").width() + $(tr).find("td.toggle-role-link:visible").width();
		$.each ( $(tr).find("td.toggle-role-link"), function(){
			$(this).toggleClass("hidden");
		});
		
		var width = twidth - $(tr).find("td.toggle-role-link:visible").width();
		$.each( $(tr).find("td.toggle-role"), function(){
			$(this).toggleClass("hidden");
			$(this).width( width );
		});
	},
	
	onClickUserInfo : function( userID ){
		var dlg = $("#dialog_user_info");
		
		$(dlg).dialog({
			title : WORD_J_JS_MINHON_COMMON_001,
			width : "600px",
			modal : true,
			resizable : false,
			buttons: [
				minhon.common.dialogButton.Close()
			]
		});
	},
	
	onClickOrder : function( self ){
		var name = $(self).attr("data-order-name");
		
		var order = null;
		if ( $(self).is(".order-none") ){
			order = "asc";
		} else if ( $(self).is(".order-asc") ){
			order = "desc";
		} else if ( $(self).is(".order-desc") ){
			order = "asc";
		}
		if ( order == null ){
			order = $(self).attr("data-order-type");
		}
		
		var params = location.href.split("?");
		var vars = {};
		if ( params.length >= 2 ){
			var hash;
			var hashParams = params[1].split('&');
			for (var i = 0; i < hashParams.length; i++) {
				hash = hashParams[i].split('=');
				vars[hash[0]] = hash[1];
			}
		}
		
		vars["q_order"] = name + "-" + order;
		
		// offsetはクリアする
		delete vars["q_offset"];
		
		window.location.href = params[0] + "?" + $.param(vars);
	},
	
	dialogHelp : null,
	
	help : function( kind, page ){
		if ( ! minhon.common.dialogHelp ){
			var menu = $("<div>").addClass("menu").hide();
			menu.append($("<a>").addClass("btn btn-default").text("top").on("click", function(){minhon.common.help(kind, page);}));
			
			minhon.common.dialogHelp  = $("<div>")
				.attr("id", "dialog-help")
				.append(menu)
				.append($("<div>").addClass("main"))
			;
		}
		
		jQuery.ajax({
			"url"         : "/app/helpController.php",
			"type"        : "post",
			"data"        : {
				"q_kind" : kind,
				"q_page" : page,
			},
			"dataType"    : "json",
			"error"       : function(){
				
			},
			"success"     : function( res ){
				if ( res.result === minhon.define.RES_OK ){
					if ( res.isMenu ){
						minhon.common.dialogHelp.find("div.menu").show();
					}
					
					minhon.common.dialogHelp.find("div.main").html(res.data);
					minhon.common.dialogHelp.dialog({
						"title"  : res.title,
						"width"  : $(window).width() * 0.75,
						"height" : $(window).height() * 0.75
					});
				} else {
					alert("error");
				}
			}
		});
	},
	
	ellipsis : function( $baseElement ){
		$baseElement.find("[data-ellipsis]").each(function(){
			var size = $(this).data("ellipsis");
			var maxsize = size * parseInt($(this).css("font-size"));
			
			if ( $(this).width() > maxsize ){
				$(this).attr({
					"data-toggle" : "tooltip"
				}).tooltip({
					"placement" : "bottom",
					"title" : $(this).text(),
					"container" : "body"
				}).css({
					"max-width" : maxsize+"px"
				});
				
				if ( ! $(this).is(".btn") ){
					$(this).hover(function(){
						$(this).stop(true);
						var bg = $(this).css("background-color");
						$(this).animate({"background-color" : "#ffff88"}, 300).delay(3000).animate({"background-color" : bg}, 1000).css({"background-color" : "inherit"});
					}, function(){
						$(this).stop(true).css({"background-color" : "inherit"});
					});
				}
			}
		});
	},
	
	eod : null
};

minhon.common.dialog = {
	alert : function( text, title ){
		if ( text ){
			text = text.replace(/[\r\n]+/g, "<br />");
		}
		var dialog =  $("<div>");
		$(dialog).append( $("<p>").html(text) );
		$(dialog).dialog({
			"title" : title,
			"width" : "auto",
			modal : true,
			resizable: false,
			buttons : [
				minhon.common.dialogButton.OK(function(){
					$(this).dialog("close");
				})
			],
			open : function(event, ui){
				$(".ui-dialog-titlebar-close", $(dialog).parent()).remove();
			},
			close : function(event, ui){
				$(dialog).dialog("destroy").remove();
			}
		});
	},
	
	confirm : function( text, callback ){
		var dialog =  $("<div>");
		var dfd = jQuery.Deferred().done(function(){
			if ( callback ){
				callback.apply(dialog, arguments);
			};
		});
		
		if ( text ){
			text = text.replace(/(\r\n|\r|\n)/g, "<br />");
		}
		$(dialog).append(text);
		$(dialog).dialog({
			"title" : "",
			"width" : "auto",
			"modal" : true,
			"resizable" : false,
			"buttons" : [
				minhon.common.dialogButton.OK(function(){
					dfd.resolve();
					$(dialog).dialog("close");
				}),
				minhon.common.dialogButton.Cancel()
			],
			"open" : function(event, ui){
				
			},
			"close" : function(event, ui){
				$(dialog).dialog("destroy").remove();
				if ( dfd.state() === "pending" ){
					dfd.reject();
				}
			}
		});
		
		return dfd.promise();
	},
	
	form : function( selector, dialogOption){
		var $dialog = $(selector);
		
		var back = $dialog.html();
		
		$dialog.dialog($.extend({
			width : "800px",
			modal : true,
			resizable: false,
			buttons : [
				minhon.common.dialogButton.OK(), // dialog内のformにsubmitを送る
				minhon.common.dialogButton.Cancel(function(){
					$dialog.html(back);
					$(this).dialog("close");
				})
			],
			open : function(){
				$(this).find("*:focus").blur(); //フォーカスを外す
				$(this).find("input:first").focus();
			}
		}, dialogOption));
	},
	
	eod : null
}

minhon.common.dialogButton = {
	Close : function( clickevent, option ){
		var opt = option || {};
		if ( clickevent ){
			opt.click = clickevent;
		}
		
		var opt = $.extend({}, {
			"text" : "Close",
			"class" : "btn btn-default",
			"click" : function(){
				$(this).dialog("close");
			},
		}, opt);
		
		return opt;
	},
	
	OK : function( clickevent, option ){
		var opt = option || {};
		if ( clickevent ){
			opt.click = clickevent;
		}
		
		var opt = $.extend({}, {
			"text" : "OK",
			"class" : "btn btn-primary",
			"click" : function(){
				$(this).find("form:first").submit();
			},
		}, opt);
		
		return opt;
	},
	
	Cancel : function( clickevent, option ){
		var opt = option || {};
		if ( clickevent ){
			opt.click = clickevent;
		}
		
		var opt = $.extend({}, {
			"text" : "Cancel",
			"class" : "btn btn-default",
			"click" : function(){
				$(this).dialog("close");
			},
		}, opt);
		
		return opt;
	},
	
	eod : null
};

minhon.common.search = {
	setEvent : function( dialog ){
		$(dialog).find("form").on("submit", function(){
			var param = minhon.common.getParameter();
			// q_offset を削除する
			if ( "q_offset" in param ){
				delete param["q_offset"];
			}
			
			var formParam = $(this).serializeArray();
			$.each(formParam, function(i, v){
				if ( v.value.length > 0 ){
					param[v.name] = v.value;
				} else if ( v.name in param ){
					delete param[v.name];
				}
			});
			
			minhon.common.onClickGet("", param);
			return false;
		});
	},
	
	onClickOpenDialog : function( dialog, dialogOption ){
		var $dialog = $(dialog);
		var back = $dialog.html();
		
		$dialog.dialog($.extend({
			width : "800px",
			modal : true,
			resizable: false,
			buttons : [
				minhon.common.dialogButton.OK(), // dialog内のformにsubmitを送る
				minhon.common.dialogButton.Cancel(function(){
					$dialog.html(back);
					$(this).dialog("close");
				})
			],
			open : function(){
				$(this).find("*:focus").blur(); //フォーカスを外す
				$(this).find("input:first").focus();
			}
		}, dialogOption));
	},
	
	onClickClear : function( dialog ){
		$(dialog).find("form [name='q_keyword']").val("");
		$(dialog).find("form").submit();
	},
	
	eod : null
};

$(function(){
	minhon.common.ellipsis( $(document) );
});
