minhon.document = {
	
	initialize : function(){
		
	},
	
	eod : null
};

minhon.document.edit = {
	
	initialize : function(){
		// ファイルタイプのヒント表示
		$('[data-toggle="popover"]').popover({
			container : "#form_user"
		});
	},
	
	eod : null
};

minhon.document.diff = {
	initialize : function( isTableMode ){
		if ( $("#form_diff").length > 0 ){
			if ( $.validator ){
				$.validator.setDefaults({
					errorPlacement : function(error, element){
						// 通常処理
						error.insertAfter(element);
						if ( element.closest("table.table").length > 0 ){
							error.insertAfter($("table.table"));
						}
					}
				});
			}
			// 検索
			minhon.common.search.setEvent("#dialog_document_filter_title");
		} else {
			// 文書選択アラート閉じた時
			$("#alert_diff_document_select").on("closed.bs.alert", function(){
				$(".tab-document-select").fadeIn("2000").css("display", "block");
			});
			// 文書選択アラート内のボタン
			$(".btn-document-select, .tab-document-select").on("click", function(){
				$(this).closest(".alert").alert("close");
				$("#dialog_diff_document_select").dialog({
					minWidth : 300,
					minHeight: 300,
					modal : false,
					resizable : true,
					buttons : [
						minhon.common.dialogButton.OK(function(){
							var $selected = $("#dialog_diff_document_select input:checked");
							if ($selected.length != 2){
								return false;
							}
							
							minhon.document.diff.merge($selected.eq(0).val(), $selected.eq(1).val());
							$(this).dialog("close");
						}),
						minhon.common.dialogButton.Cancel()
					]
				});
			});
			$(".btn-alert-close").on("click", function(){
				$(this).closest(".alert").alert("close");
			});
			// 文書選択ダイアログ
			$("#dialog_diff_document_select").on("dialogopen", function(event, ui){
				$("#dialog_diff_document_select input[name='q_diff_document[]']").each(function(){
					$(this).triggerHandler("change");
				});
			}).on("dialogclose", function(event, ui){
				$(".table_diff tr.target.select").removeClass("select");
			});
			$("#dialog_diff_document_select input[name='q_diff_document[]']").change(function(){
				var id = $(this).val();
				var $tr = $("table.table_diff tr.target[data-doc-id='"+id+"']");
				if ($(this).is(":checked")){
					$tr.addClass("select");
				} else {
					$tr.removeClass("select");
				}
				
				if ($("#dialog_diff_document_select input:checked").length == 2){
					$("#dialog_diff_document_select").siblings(".ui-dialog-buttonpane").find(".btn-primary").removeAttr("disabled");
				} else {
					$("#dialog_diff_document_select").siblings(".ui-dialog-buttonpane").find(".btn-primary").attr("disabled", "disabled");
				}
			});
			
			// 差分を調べる
			var $doc = $("input[name='q_doc_id[]']");
			if ( $doc.length == 2 ){
				var docID1 = $doc.eq(0).val();
				var docID2 = $doc.eq(1).val();
				minhon.document.diff.merge(docID1, docID2);
			}
		}
	},
	
	merge : function( docID1, docID2 ){
		$("table.table_diff tr.no_subject").removeClass("no_subject");
		$("nav.affix-nav li").removeAttr("data-diff");
		
		var docText1 = {};
		var docText2 = {};
		
		$("table.table_diff").each(function(){
			var row = $(this).attr("id");
			var $targetRow1 = $(this).find("tr.target[data-doc-id='"+docID1+"'] td");
			var $targetRow2 = $(this).find("tr.target[data-doc-id='"+docID2+"'] td");
			
			if ( $targetRow1.length > 0 ){
				docText1[row] = $targetRow1.text();
			}
			if ( $targetRow2.length > 0 ){
				docText2[row] = $targetRow2.text();
			}
		});
		
		minhon.common.overlay(true);
		jQuery.ajax({
			url      : "/app/diffController.php",
			type     : "POST",
			data     : {
							"q_text1" : docText1,
							"q_text2" : docText2,
							"q_token" : $("#token_common").val()
						},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result === minhon.define.RES_OK ){
					$(".table_diff").addClass("no_subject");
					for ( var key in res.data ){
						var $table = $("#"+key).removeClass("no_subject");
						var $sourceRow = $table.find("tr.source");
						var $targetRow1 = $table.find("tr.target[data-doc-id='"+docID1+"']").find("td").remove().end();
						var $targetRow2 = $table.find("tr.target[data-doc-id='"+docID2+"']").find("td").remove().end();
						
						$targetRow1.append(res.data[key][1]);
						$targetRow2.append(res.data[key][2]);
						
						$sourceRow.after($targetRow2);
						$sourceRow.after($targetRow1);
						//$sourceRow.after($targetRow1).next().after($targetRow2);
						var $otherRow = $table.find("tr.target").filter(function(){
							var docID = $(this).attr("data-doc-id");
							if ( docID != docID1 && docID != docID2 ){
								return true;
							} else {
								return false;
							}
						});
						$otherRow.addClass("no_subject").find("td").each(function(){
							$(this).text($(this).text()).removeClass("col_diff").removeClass("col_part_diff");
						});
					}
				} else {
					alert(res.message);
				}
			},
			complete : function(){
				minhon.common.overlay(false);
			}
		});
	},
		
	merge2 : function( docID1, docID2 ){
		$("table.table_diff tr.no_subject").removeClass("no_subject");
		
		$("table.table_diff").each(function(){
			var row = $(this).attr("id");
			
			var $sourceRow = $(this).find("tr.source");
			if ( docID1 && docID2 ){
				var $targetRow1 = $(this).find("tr.target[data-doc-id='"+docID1+"']");
				var $targetRow2 = $(this).find("tr.target[data-doc-id='"+docID2+"']");
				if ( $targetRow1.length == 0 || $targetRow2.length == 0 ){
					$nav.attr("data-diff", "none");
					return true; // continue
				}
			} else {
				var $targetRow = $(this).find("tr.target[data-doc-id]");
				if ( $targetRow.length == 2 ){
					var $targetRow1 = $($targetRow.eq(0));
					var $targetRow2 = $($targetRow.eq(1));
				} else {
					$nav.attr("data-diff", "none");
					return true; // continue
				}
			}
			
			if ( $targetRow1.find("td").text() === $targetRow2.find("td").text() ){
				$nav.attr("data-diff", "same");
			} else {
				$nav.attr("data-diff", "diff");
			}
			
			$sourceRow.after($targetRow1).next().after($targetRow2);
			$targetRow2.nextAll().addClass("no_subject");
		});
	},
	
	onClickFilterTitle : function(){
		minhon.common.search.onClickOpenDialog("#dialog_document_filter_title");
	},
	
	onClickFilterTitleClear : function(){
		minhon.common.search.onClickClear("#dialog_document_filter_title");
	},
	
	eod : null
};
