minhon.member = {
	projectID : null,
	
	initialize : function( projectID, userID ){
		minhon.member.projectID = projectID;
		
		$("#form_project_member_select").show();
		$("#form_project_member_edit").hide();
		
		minhon.member.initializeUserSelect();
		minhon.member.initializeActorSet( userID > 0 );
		
		minhon.member.initializeActiveUser();
		minhon.member.updateAllRole();
		
		if ( userID ){
			minhon.member.onClickNext();
		}
	},
	
	initializeUserSelect : function(){
		$("#tabs_org").tabs();
		$("#tabs_org").on("click", "table.table-reg .btn-user", minhon.member.onClickUser);
		
		if ( $("#member-edit-search").length > 0 ){
			setInterval(minhon.member.onSearch, 100);
		}
		
		// ユーザータイプをツールチップで表示
		$("[data-toggle=popover]").popover();
		
		// 組織選択
		$("#dialog_org tr").bind("click.trselect", function(){
			$(this).toggleClass("select");
		});
		$("#dialog_org .table").addClass("table-hover");
		$("#tabs_org > ul > li").each(function(){
			var orgName = $(this).attr("data-org");
			if ( $(this).is(".fix-tab") ){
				$("#dialog_org tr[data-org="+orgName+"]").addClass("selectFix").unbind("click.trselect");
			} else {
				$("#dialog_org tr[data-org="+orgName+"]").addClass("select");
			}
		});
		
		$("#form_project_member_select").on("submit", function(e){
			if ( $("table.table-reg .btn-user.btn-danger").length === 0 ){
				alert(WORD_J_JS_MINHON_MEMBER_001);
				return false;
			}
			
			minhon.member.onClickNext();
			return false;
		});
	},
	
	initializeActorSet : function( isOneUser ){
		$("table.table-role").on("click", "input", function(){
			minhon.member.updateRole( $(this).closest("tr") );
		});
		$("table.table-role").on("mouseover", "td", function(e){
			$(this).addClass("hover");
			$(this).closest("tr").addClass("hover-line");
			$(this).closest("table").find("colgroup").eq( $(this).index() ).addClass("hover-line");
		});
		$("table.table-role").on("mouseleave", "td", function(e){
			$(this).removeClass("hover");
			$(this).closest("tr").removeClass("hover-line");
			$(this).closest("table").find("colgroup").eq( $(this).index() ).removeClass("hover-line");
		});
		
		if ( ! isOneUser ){
			$("#form_project_member_edit").on("submit", function(e){
				if ( $("#form_project_member_edit .isProjectManager:checked").length === 0 ){
					alert(WORD_J_JS_MINHON_MEMBER_002);
					return false;
				}
				
				return true;
			});
		}
	},
	
	initializeActiveUser : function(){
		jQuery.each($("table.table-role tr"), function(){
			var isCheck = false;
			var user = $(this).data("user");
			
			jQuery.each($(this).find("input"), function(){
				if ( $(this).is(":checked") ){
					isCheck = true;
					return;
				}
			});
			
			if ( isCheck ){
				$("table.table-reg .btn-user[data-user='" + user + "']").addClass("btn-danger");
			}
		});
		
		minhon.member.updateRegUser();
	},
	
	showOrgSelectDialog : function(){
		$("#dialog_org").dialog({
			width : "80%",
			modal : true,
			title : WORD_J_JS_MINHON_MEMBER_003,
			buttons : [
				minhon.common.dialogButton.OK(function(){
					var arrAdd    = [];
					var arrRemove = [];
					var removeSelectCount = 0;
					var removeMessage = "";
					
					$("#dialog_org tr").each( function(){
						var orgName   = $(this).attr("data-org");
						var orgID     = $(this).attr("data-org-id");
						var userCount = $(this).attr("data-user-count");
						
						if ( $(this).is(".select:not(.was-selecting)") ){
							arrAdd.push({
								"name"      : orgName,
								"id"        : orgID,
								"userCount" : userCount
							});
						} else if ( $(this).is(".was-selecting:not(.select)") ){
							var selectCount = $("#tabs_org > div[data-org="+orgName+"] .btn-danger").length;
							removeSelectCount += selectCount;
							arrRemove.push({
								"name" : orgName,
								"selectCount" : selectCount
							});
							removeMessage += "<li>"+orgName+" ("+WORD_J_JS_MINHON_MEMBER_004+": "+selectCount+")"+"</li>";
						}
					});
					
					if ( removeSelectCount > 0 ){
						$("#dialog_org_remove_check ul").html( removeMessage );
						$("#dialog_org_remove_check").dialog({
							width: "auto",
							height: "auto",
							modal : true,
							buttons : [
								minhon.common.dialogButton.OK(function(){
									for ( var i in arrAdd ){
										minhon.member.addOrgTab( arrAdd[i].id, arrAdd[i].name, arrAdd[i].userCount );
									}
									for ( var i in arrRemove ){
										minhon.member.removeOrgTab( arrRemove[i].name );
									}
									$("#tabs_org").tabs("refresh");
										
									$("#dialog_org").dialog("close");
									$("#dialog_org_remove_check").dialog("close");
								}),
								minhon.common.dialogButton.Cancel()
							]
						});
					} else {
						for ( var i in arrAdd ){
							minhon.member.addOrgTab( arrAdd[i].id, arrAdd[i].name, arrAdd[i].userCount );
						}
						for ( var i in arrRemove ){
							minhon.member.removeOrgTab( arrRemove[i].name );
						}
						$("#tabs_org").tabs("refresh");
							
						$("#dialog_org").dialog("close");
					}
				}),
				minhon.common.dialogButton.Cancel(function(){
					$(this).find("tr").removeClass("select");
					$(this).find("tr.was-selecting").addClass("select");
					$(this).dialog("close");
				}),
			],
			open : function(){
				$(this).find("tr").removeClass("was-selecting");
				$(this).find("tr.select").addClass("was-selecting");
			},
			close : function(){
			}
		});
	},
	
	addOrgTab : function( orgID, orgName, userCount ){
		userCount = userCount || "?";
		
		// タブ
		var tabElement = $("<li>").attr({
			"data-org"    : orgName,
			"data-org-id" : orgID
		});
		$("<a>").attr({
				"href" : "#tab_org_"+orgID,
			})
			.html(orgName+" (<span class=\"select-count\">0</span> / "+userCount+")")
			.appendTo(tabElement);
		$("#tabs_org > ul > li:last").after(tabElement);
		
		// ユーザー選択
		var tabContent = $("<div>").attr({
			"id"       : "tab_org_"+orgID,
			"data-org" : orgName
		}).append( $("<img>").attr("src", "/img/loader.gif") );
		$(tabContent).appendTo($("#tabs_org"));
		
		jQuery.ajax({
			url      : "/app/memberController.php",
			type     : "POST",
			data     : {
							"q_mode"   : minhon.define.APP_MEMBER_CONTROLLER_MODE_GET_ORG,
							"q_id"     : minhon.member.projectID,
							"q_org_id" : orgID,
					   },
			dataType : "json",
			error    : function(){
				alert("Error");
			},
			success  : function(res){
				$(tabContent).empty();
				if ( res.result === minhon.define.RES_OK ){
					// ユーザー選択
					$(tabContent).html( res.data.html_reg );
					// 役割
					$(".table-role > tbody").append( res.data.html_role );
					
					minhon.member.updateRegUser();
					minhon.member.updateAllRole();
				} else {
					alert(res.message);
				}
			}
		});
	},
	
	removeOrgTab : function( orgName ){
		// タブ
		$("#tabs_org > ul > li[data-org="+orgName+"]").remove();
		// ユーザー選択
		$("#tabs_org > div[data-org="+orgName+"]").remove();
		// 役割
		$(".table-role tr[data-org="+orgName+"]").remove();
	},
	
	onClickUserInfo : function( that ){
		var userID = $(that).closest("tr").attr("data-user-id");
		if ( ! isFinite(userID) ){
			return;
		}
		
		var dialog = $("#member_dialog_user_info");
		
		jQuery.ajax({
			url      : "/app/userController.php",
			type     : "POST",
			data     : {
							"q_mode"   : minhon.define.APP_USER_CONTROLLER_MODE_GET,
							"q_id"     : userID,
					   },
			dataType : "json",
			error    : function(){
				alert("Error");
			},
			success  : function(res){
				$(dialog).find("td.value").empty();
				if ( res.result === minhon.define.RES_OK ){
					// ユーザー名
					$(dialog).find(".user_name").text(res.data.userName);
					// 組織
					$(dialog).find(".organization_name").text(res.data.orgName);
					// タイプ
					$(dialog).find(".user_type").text(res.data.userType);
					// 参加プロジェクト
					$(dialog).find(".project").html(res.data.htmlProject);
					$(dialog).dialog({
						"width": "600px",
						"height": "auto",
						"modal" : true,
						"resizable" : false,
						"title" : WORD_J_JS_MINHON_MEMBER_005,
						"buttons": [
							minhon.common.dialogButton.Close()
						]
					});
					minhon.common.ellipsis( $(dialog) );
				} else {
					alert(res.message);
				}
			}
		});
	},
	
	onClickNext : function(){
		$("#form_project_member_select").hide();
		$("#form_project_member_edit").show();
		//
		$(".wizard li.active").removeClass("active");
		$(".wizard li").eq(1).addClass("active");
		
		minhon.member.updateAllRole();
	},
	
	onClickBack : function(){
		$("#form_project_member_select").show();
		$("#form_project_member_edit").hide();
		//
		$(".wizard li.active").removeClass("active");
		$(".wizard li").eq(0).addClass("active");
	},
	
	onSearch : function(){
		var val = $("#member-edit-search").val();
		
		if ( val.length == 0 ){
			$("table.table-reg .btn-user").removeAttr("disabled").css("opacity", 1.0);
			return;
		}
		
		$("table.table-reg .btn-user").attr("disabled", "disabled").css("opacity", 0.2);
		$("table.table-reg .btn-user").filter(function(){
			return $(this).data("user").match("^" + val + ".*");
		}).removeAttr("disabled").css("opacity", 1.0);
	},
	
	onClickUser : function(){
		var user = $(this).data("user");
		
		if ( $(this).hasClass("btn-danger") ){
			$(this).removeClass("btn-danger");
		} else {
			$(this).addClass("btn-danger");
		}
		
		minhon.member.updateRegUser();
	},
	
	updateRegUser : function(){
		var counts = {};
		
		jQuery.each($("table.table-reg .btn-user"), function(){
			var user = $(this).attr("data-user");
			var org  = $(this).closest("div.ui-tabs-panel").attr("data-org");
			
			var $tr = $("table.table-role tr[data-user='" + user + "']");
			if ( $(this).hasClass("btn-danger") ){
				counts[org] = (counts[org] || 0) + 1;
				$tr.show();
				if ( $tr.find("td input:checked").length === 0 ){
					$tr.find(".no_role").attr("checked", true);
				} else {
					$tr.find(".no_role").removeAttr("checked");
				}
			} else {
				$tr.hide();
				$tr.find("input").removeAttr("checked", false);
			}
		});
		
		$("#tabs_org > ul > li").each( function(){
			var org = $(this).attr("data-org");
			$(this).find("span.select-count").text( counts[org] || 0 );
		});
		
		minhon.member.updateAllRole();
	},
	
	onClickUserRole : function( obj, e ){
		e.stopPropagation();
		var chk = $(obj).find("input[type=checkbox]");
		
		if ( chk.is("[checked]") ){
			chk.removeAttr("checked");
		} else {
			chk.attr("checked", true);
		}
		
		minhon.member.updateRole( $(obj).closest("tr") );
	},
	
	onClickAllRole : function( obj ){
		var arrInput = $(obj).closest("tr").find("td input[type=checkbox]");
		
		if ( $(obj).hasClass("btn-danger") ){
			arrInput.attr("checked", false);
			$(obj).removeClass("btn-danger");
		} else {
			arrInput.attr("checked", true);
			$(obj).addClass("btn-danger");
		}
		minhon.member.updateRole( $(obj).closest("tr") );
	},
	
	updateRole : function( tr ){
		if ( ! $(tr).is(":visible") ){
			return;
		}
		
		//$(tr).find("input:checked").closest(".btn").addClass("btn-danger");
		//$(tr).find("input:not(:checked)").closest(".btn").removeClass("btn-danger");
		
		var checkCount = $(tr).find("td input:checked").length;
		if ( $(tr).find("td input").length === checkCount ){
			$(tr).find("th a").addClass("btn-danger");
		} else {
			$(tr).find("th a").removeClass("btn-danger");
		}
		
		if ( checkCount === 0 ){
			$(tr).find(".no_role").attr("checked", true);
		} else {
			$(tr).find(".no_role").removeAttr("checked");
		}
	},
	
	updateAllRole : function(){
		jQuery.each($("table.table-role tr:visible"), function(){
			minhon.member.updateRole(this);
		});
	},
	
	eod : null
};
