minhon.organization = {
	initialize : function(){
		minhon.common.search.setEvent("#dialog_organization_filter_name");
		minhon.organization.initializeSuggest();
	},
	
	initializeSuggest : function(){
		var engine = new Bloodhound({
			datumTokenizer: Bloodhound.tokenizers.obj.whitespace("value"),
			queryTokenizer: Bloodhound.tokenizers.whitespace,
			remote : {
				url: "/app/suggestController.php",
				prepare : function(inputValue, setting){
					var param = minhon.common.getFormParamter($("#dialog_organization_filter_name form"));
					param["q_mode"] = minhon.define.APP_SUGGEST_CONTROLLER_MODE_ORG_NAME;
					
					return $.extend({}, setting, {
						type : "post",
						data : param,
					});
				}
			}
		});
		
		$("#q_keyword").typeahead({
			hint : false,
			highlight : false
		}, {
			displayKey : "value",
			name : "suggest",
			source : engine,
			limit : 20,
			templates : {
				suggestion : function(data){
					var $element = $("<div>");
					var reg = new RegExp(data._query, "i");
					if ( match = reg.exec(data.value) ){
						var before = document.createTextNode( data.value.substring(0, match.index) );
						var after  = document.createTextNode( data.value.substring(match.index + match[0].length) );
						var hit    = $("<strong>").text(match[0]);
						$element.append(before).append(hit).append(after);
					} else {
						$element.text(data.value);
					}
					return $element;
				}
			}
		}).on("typeahead:open", function(){
			$(this).closest(".ui-dialog").css("overflow", "visible");
			$(this).closest(".ui-dialog-content").css("overflow", "visible");
		}).on("typeahead:close", function(){
			$(this).closest(".ui-dialog").css("overflow", "hidden");
			$(this).closest(".ui-dialog-content").css("overflow", "hidden");
		});
	},
	
	onClickFilterName : function(){
		minhon.common.search.onClickOpenDialog("#dialog_organization_filter_name");
	},
	
	onClickFilterNameClear : function(){
		minhon.common.search.onClickClear("#dialog_organization_filter_name");
	},
	
	eod : null
};
