minhon.project = {
	resizeTimer : false,
	
	initialize : function(){
		minhon.common.search.setEvent("#dialog_project_filter_name");
		
		minhon.project.listResize();
		
		$(".project-tooltip").popover({
			html : true,
			content : "<img src=\"/img/qredit-loader.gif\" width=20 height=20 />",
			placement : "top",
			trigger: "hover",
			delay : {show : 400, hide : 0}
		});
		$(".project-tooltip").on("show.bs.popover", function(){
			var that = this;
			var tr = $(this).closest("tr[data-project-id]");
			var projectID = $(tr).attr("data-project-id");
			if ( ! isFinite(projectID) ){
				return;
			}
			
			jQuery.ajax({
				url      : "/app/projectController.php",
				type     : "POST",
				data     : {
								"q_mode" : minhon.define.APP_PROJECT_CONTROLLER_MODE_INFO,
								"q_id"   : projectID
						   },
				dataType : "json",
				error    : function( xhr, textStatus, errorThrown){
					if ( xhr.readyState == 0 || xhr.status == 0 ){
						return;
					} else {
						alert("Error");
					}
				},
				success  : function(res){
					if ( res.result === minhon.define.RES_OK ){
						$(tr).find(".tooltip-project").attr("data-content", res.data.project);
						$(tr).find(".tooltip-member").attr("data-content", res.data.member);
						$(tr).find(".tooltip-document").attr("data-content", res.data.document);
						$(tr).find(".tooltip-task").attr("data-content", res.data.task);
						$(tr).find(".tooltip-term").attr("data-content", res.data.term);
						$(tr).find(".tooltip-bilingual").attr("data-content", res.data.bilingual);
						$(tr).find(".tooltip-data").attr("data-content", res.data.data);
						$(tr).find(".tooltip-bbs").attr("data-content", res.data.bbs);
						
						$(tr).find(".project-tooltip").off("show.bs.popover");
						$(that).popover("show");
					} else {
						$(tr).find(".project-tooltip").popover("destroy");
						alert(res.message);
					}
				}
			});
		});
		
		$(window).resize( function(){
			if ( minhon.project.resizeTimer !== false ){
				clearTimeout(minhon.project.resizeTimer);
			}
			minhon.project.resizeTimer = setTimeout(function(){
				minhon.project.listResize();
			}, 300);
		});
	},
	
	listResize : function(){
		var $table = $("#project_list");
		
		$table.find("tr").find(".resize-short:visible").hide();
		$table.find("tr").find(".resize-normal:hidden").show();
		
		while ( $table.outerWidth(true) > $table.parent().width() ){
			$table.find("tr").find(".resize-normal:visible:last").hide();
			$table.find("tr").find(".resize-short:hidden:last").show();
			if ( $table.find("tr").find(".resize-normal:visible").length === 0 ){
				break;
			}
		}
	},
	
	onClickFilterName : function(){
		minhon.common.search.onClickOpenDialog("#dialog_project_filter_name");
	},
	
	onClickFilterNameClear : function(){
		minhon.common.search.onClickClear("#dialog_project_filter_name");
	},
	
	eod : null
};

minhon.project.detail = {
	sourceLang : null,
	targetLang : null,
	
	initialize : function(){
		var sourceLang = $("#form_project input[name=q_lang_s]").val();
		var $target    = $("#form_project input[name=\"q_lang_t[]\"]");
		var targetLang = $target.map(function(index, element){ return $(this).val(); });
		
		minhon.project.detail.onDictionarySort(sourceLang, targetLang);
		
		minhon.project.detail.sourceLang = sourceLang;
		minhon.project.detail.targetLang = targetLang;
		minhon.project.detail.onClickViewDictionaryRelated();
	},
	
	onClickExport : function( projectID ){
		jQuery.ajax({
			url      : "/app/projectController.php",
			type     : "POST",
			data     : {
							"q_mode" : minhon.define.APP_PROJECT_CONTROLLER_MODE_EXPORT,
							"q_id"   : projectID
					   },
			dataType : "json",
			error    : function(){
				alert("Error");
			},
			success  : function(res){
				if ( res.result !== minhon.define.RES_OK ){
					alert(res.message);
				}
			}
		});
	},
	
	onDictionarySort : function( sourceLang, targetLang ){
		$("#project_qredit_dictionary tbody").html(
			$("#project_qredit_dictionary tbody tr").sort( function(a, b){
				var isEqualA = false;
				var isEqualB = false;
				
				if ( $(a).attr("data-source-lang") !== $(b).attr("data-source-lang") ){
					if ( $(a).attr("data-source-lang") === sourceLang ){
						return -1;
					} else if ( $(b).attr("data-source-lang") === sourceLang ){
						return 1;
					} else if ( $(a).attr("data-source-lang-order") < $(b).attr("data-source-lang-order") ){
						return -1
					} else if ( $(b).attr("data-source-lang-order") < $(a).attr("data-source-lang-order") ){
						return 1;
					} else {
						return isFinite($(a).attr("data-source-lang-order")) ? -1 : 1;
					}
				} else if ( $(a).attr("data-target-lang") !== $(b).attr("data-target-lang") ){
					var sortReturn = 0;
					targetLang.each( function(){
						var tlang = String(this);
						if ( $(a).attr("data-target-lang") === tlang ){
							sortReturn = -1;
							return false; //break
						} else if ( $(b).attr("data-target-lang") === tlang ){
							sortReturn = 1;
							return false; //break;
						}
					});
					if ( (sortReturn !== 0) && ($(a).attr("data-source-lang") === sourceLang) ){
						return sortReturn;
					} else {
						if ( $(a).attr("data-target-lang-order") < $(b).attr("data-target-lang-order") ){
							return -1;
						} else if ( $(b).attr("data-target-lang-order") < $(a).attr("data-target-lang-order") ){
							return 1;
						} else {
							return isFinite($(a).attr("data-target-lang-order")) ? -1 : 1;
						}
					}
				} else {
					return ( $(a).attr("data-dictionary-id") < $(b).attr("data-dictionary-id") ? -1 : 1 );
				}
			})
		);
		
		$("#project_qredit_dictionary tbody tr").removeClass("disabled").each( function(){
			if ( sourceLang !== $(this).attr("data-source-lang") ){
				$(this).addClass("disabled");
				return true; //continue;
			}
			if ( targetLang.length > 0 && ($.inArray($(this).attr("data-target-lang"), targetLang) === -1) ){
				$(this).addClass("disabled");
				return true;
			}
		});
		
	},
	
	onClickViewDictionaryAll : function(){
		$("#project_qredit_dictionary tbody tr").each( function(){
			$(this).show();
		});
	},
	
	onClickViewDictionaryRelated : function(){
		var sourceLang = minhon.project.detail.sourceLang;
		var targetLang = minhon.project.detail.targetLang;
		
		$("#project_qredit_dictionary tbody tr").each( function(){
			var trSourceLang = $(this).attr("data-source-lang");
			var trTargetLang = $(this).attr("data-target-lang");
			var trFlag = $(this).attr("data-flag");
			if ( sourceLang === trSourceLang && targetLang.length > 0 && ($.inArray(trTargetLang, targetLang) >= 0) ){
				$(this).show();
			} else if ( trFlag !== "-" ){
				$(this).show();
			} else {
				$(this).hide();
			}
		} );
	},
	
	onClickViewDictionaryDialog : function(){
		$("#dialog_project_qredit_dictionary").dialog({
			title : WORD_J_JS_MINHON_PROJECT_001,
			width : "600px",
			modal : true,
			resizable : false,
			buttons : [
				minhon.common.dialogButton.OK( function(){
					$("#project_qredit_dictionary tbody tr").hide();
					$("#dialog_project_qredit_dictionary [name=selectLang]:checked").each( function(){
						var sLang = $(this).attr("data-source-lang");
						var tLang = $(this).attr("data-target-lang");
						$("#project_qredit_dictionary tbody tr[data-source-lang="+sLang+"][data-target-lang="+tLang+"]").show();
					} );
					$("#dialog_project_qredit_dictionary").dialog("close");
				} ),
				minhon.common.dialogButton.Cancel()
			]
		});
	},
	
	eod : null
};

minhon.project.structure = {
	initialize : function(){
		$('[data-toggle="popover"]').popover({
			container : "#project_structure"
		});
	},
	
	eod : null
};

minhon.project.edit = {
	initialize : function(){
		$("#q_start").datepicker({"dateFormat" : "yy-mm-dd"});
		$("#q_end").datepicker({"dateFormat" : "yy-mm-dd"});
		
		$("#form_project [name=q_lang_s]").on("change", function(){
			minhon.project.edit.onDictSort();
		});
		$("#form_project [name=\"q_lang_t[]\"]").on("click", function(){
			minhon.project.edit.onDictSort();
		});
		
		minhon.project.edit.onDictSort();
		
		if ( $.validator ){
			$.validator.setDefaults({
				errorPlacement : function(error, element){
					// 通常処理
					error.insertAfter(element);
					if ( element.closest(".form-horizontal").length > 0 ){
						// タスク選択
						if ( element.is(":checkbox") && element.parent().is("label.checkbox-inline") ){
							var label = element.closest("label.checkbox-inline");
							var category = label.prevAll(":not(label.checkbox-inline)").get(0);
							// labelに"*"が表示されている
							if ( category !== undefined && $(category).find(".form-required").length > 0 ){
								$(category).append(error);
							} else {
								label.parent().parent().append(error);
							}
						} else if ( element.is(":radio") && element.parent().is("label.radio-inline") ){
							var label = element.closest("label.radio-inline");
							var category = label.prevAll(":not(label.radio-inline)").get(0);
							// labelに"*"が表示されている
							if ( category !== undefined && $(category).find(".form-required").length > 0 ){
								$(category).append(error);
							} else {
								label.parent().parent().append(error);
							}
						}
					}
				}
			});
		}
	},
	
	onDictSort : function(){
		var sourceLang = $("#form_project [name=q_lang_s]").val();
		var $target    = $("#form_project [name=\"q_lang_t[]\"]:checked");
		var targetLang = $target.map(function(index, element){ return $(this).val(); });
		
		minhon.project.detail.onDictionarySort( sourceLang, targetLang );
	},
	
	eod : null
};

minhon.project.import = {
	initialize : function(){
		$("#q_start").datepicker({"dateFormat" : "yy-mm-dd"});
	},

	eod : null
};
