minhon.qredit = {
	editor     : null,
	projectID  : null,
	documentID : null,
	userName   : null,
	taskID     : null,
	taskName   : null, //タスク履歴保存時でのみ使用
	taskType   : null, //ロギング時でのみ使用
	taskRole   : null, //ロギング時でのみ使用
	hash       : null,
	dialog     : null,
	
	overlay    : null,
	
	timer      : null, // ログインチェック用タイマー
	
	initialize : function( _projectID, _documentID, _userName, _taskID, _role ){
		minhon.qredit.projectID  = _projectID;
		minhon.qredit.documentID = _documentID;
		minhon.qredit.userName   = _userName;
		minhon.qredit.editor     = $("#qredit").get(0);
		minhon.qredit.dialog     = $("<div>");
		
		$("#btnClose").on("click", function(){
			minhon.qredit.close();
			return false; // IE8対応
		});
	
		if ( minhon.qredit.editor ){
			minhon.qredit.overlay    = $("<div>").addClass("ui-widget-overlay").appendTo("body");
			
			if ( minhon.qredit.isCompareMode() ){
				minhon.qredit.initialize_QRedit();
			} else {
				minhon.qredit.initialize_TaskSelect(_taskID, _role);
			}
		}
		
		minhon.qredit.timer = setInterval( "minhon.qredit.checkLogin()", 1000 * 60);
	},
	
	checkLogin : function(){
		minhon.common.checkLoginState( null, function(){
			var dialog = $("<div>");
			$(dialog).append( $("<p>").text(WORD_J_JS_MINHON_QREDIT_001) )
				.append( $("<p>").text(WORD_J_JS_MINHON_QREDIT_002) )
			$(dialog).dialog({
				"width" : "auto",
				modal : true,
				resizable: false,
				buttons : [
					minhon.common.dialogButton.OK(function(){
						$(dialog).dialog("close");
					})
				],
				close : function(){
					minhon.common.reload();
				}
			});
			
			clearInterval(minhon.qredit.timer);
			minhon.qredit.timer = null;
		});
	},
	
	// タスク未選択時に、選択させる
	initialize_TaskSelect : function( _taskID, _role ){
		if ( _taskID === 0 ){
			_taskID = undefined;
		}
		if ( _role === 0 ){
			_role = undefined;
		}
		
		if ( typeof _taskID === "undefined" || typeof _role === "undefined" ){
			jQuery.ajax({
				url      : "/app/taskController.php",
				type     : "POST",
				data     : {
								"q_mode"        : minhon.define.APP_TASK_CONTROLLER_MODE_GET_TASKS_FROM_DOCUMENT,
								"q_project_id"  : minhon.qredit.projectID,
								"q_document_id" : minhon.qredit.documentID,
								"q_task_id"     : _taskID
							},
				dataType : "json",
				error    : function(){
					alert(minhon.define.AJAX_ERROR);
				},
				success  : function( res ){
					if ( res.result == minhon.define.RES_OK ){
						$(minhon.qredit.dialog).empty()
							.html(res.data.dialog)
							.dialog({
								"title" : res.data.title,
								"modal" : true,
								"closeOnEscape" : false,
								"width" : $(minhon.qredit.editor).width() * 0.6,
								"buttons" : [{
									"text" : WORD_J_JS_MINHON_QREDIT_003,
									"class" : "btn btn-default",
									"click" : function(){
										minhon.qredit.close();
									}
								}],
								"open"  : function(event, ui){
									$(this).closest(".ui-dialog").find(".ui-dialog-titlebar-close").hide();
									$(minhon.qredit.dialog).find("button").on("click", function(){
										$(minhon.qredit.dialog).dialog("close");
										minhon.qredit.initialize_TaskLoad( $(this).data("task-id"), $(this).data("role") );
										return false; // IE8対応
									});
									$(this).find('*:focus').blur(); // フォーカスを与えない
								},
								"close" : function(){
									$(minhon.qredit.dialog).empty();
								}
							});
					} else if ( res.result == minhon.define.RES_NO_DATA ){
						// 選択肢が1つしかない場合は、自動で選ぶ
						minhon.qredit.initialize_TaskLoad( res.data.taskID, res.data.role );
					} else {
						alert(res.message);
					}
				}
			});
		} else {
			minhon.qredit.initialize_TaskLoad(_taskID, _role);
		}
	},
	
	// タスクIDからタスクの情報を取得
	initialize_TaskLoad : function( _taskID, _role ){
		if ( typeof _taskID === "undefined" || _taskID === 0 || ! _taskID){
			minhon.qredit.initialize_TaskSelect();
			return;
		}
		
		jQuery.ajax({
			url      : "/app/taskController.php",
			type     : "POST",
			data     : {
							"q_mode"        : minhon.define.APP_TASK_CONTROLLER_MODE_GET_TASKINFO,
							"q_task_id"     : _taskID,
							"q_role"        : _role
						},
			dataType : "json",
			error    : function(){
				alert(WORD_J_JS_MINHON_QREDIT_004);
				minhon.qredit.initialize_TaskSelect();
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					alert(res.data.message);
					minhon.qredit.taskID   = _taskID;
					minhon.qredit.taskRole = _role;
					
					// タスク情報を更新
					minhon.qredit.taskType = res.data.type;
					minhon.qredit.taskName = res.data.name;
					$("#editor-task .i-text").text(minhon.qredit.taskName);
					$("#editor-task").show();
					
					if ( ! minhon.qredit.isCompareMode() ){
						$(minhon.qredit.editor).attr("data-mode", res.data.qredit_mode);
					}
					minhon.qredit.initialize_QRedit();
				} else if ( res.result == minhon.define.RES_NO_DATA ){
					minhon.qredit.initialize_TaskSelect( _taskID );
				} else {
					alert(WORD_J_JS_MINHON_QREDIT_005);
					minhon.qredit.initialize_TaskSelect( 0 );
				}
			}
		});
	},
	
	// タスクの情報からモードを指定してQREDITを起動
	initialize_QRedit : function(){
		var dataList = $(minhon.qredit.editor).data();
		if ( ! "mode" in dataList ){
			alert(WORD_J_JS_MINHON_QREDIT_006);
			minhon.qredit.close();
		}
		
		var url = dataList["url"] + "?";
		delete dataList["url"];
		for ( var key in dataList ){
			url += key + "=" + dataList[key] + "&";
		}
		url = encodeURI(url.slice(0, -1));
		
		$(minhon.qredit.editor).attr("src", url);
		if ( typeof qreditrh === "undefined" ){
			minhon.qredit.onChangeMode( $(minhon.qredit.editor).attr("data-mode") );
			minhon.qredit.onQReditorCompleted();
		}
	},
	
	initialize_Load : function(){
		$(window).on("beforeunload", minhon.qredit.onBeforeunload);
		$(window).bind("resize", minhon.qredit.onResize);
		
		$("#btnTemporarySave").bind("click", function(){
			if ( typeof qreditrh !== "undefined" ){
				qreditrh.saveHistory("qredit", false);
			}
			minhon.qredit.saveData( this );
			return false; // IE8対応
		});
		$("#btnEditSave").bind("click", function(){
			minhon.common.dialog.confirm(WORD_J_JS_MINHON_QREDIT_007+"\r\n"+WORD_J_JS_MINHON_QREDIT_008).done(function(){
				if ( typeof qreditrh !== "undefined" ){
					qreditrh.saveHistory("qredit", true, minhon.qredit.taskName+"(ID:"+minhon.qredit.taskID+")");
				}
				minhon.qredit.saveData( this);
			})
			return false; // IE8対応
		});
		$("#btnCorrectSave").bind("click", function(){
			if ( typeof qreditrh !== "undefined" ){
				qreditrh.saveHistory("qredit", true, minhon.qredit.taskName+"(ID:"+minhon.qredit.taskID+")");
			}
			minhon.qredit.saveData( this);
			return false; // IE8対応
		});
		
		minhon.qredit.onResize();
		minhon.qredit.loadData();
		
		// 操作不能を解除
		if ( minhon.qredit.overlay ){
			$(minhon.qredit.overlay).remove();
		}
	},
	
	close : function(){
		// IE対応( openで開いたウィンドウを閉じるときに確認ダイアログが自動で開かれるのを止める )
		(window.open("", "_self").opener=window).close();
	},
	
	isCompareMode : function(){
		if ( $(minhon.qredit.editor).attr("data-mode") === "compare" ){
			return true;
		} else {
			return false;
		}
	},
	
	getHash : function(){
		var text = "";
		if ( typeof qreditrh !== "undefined" ){
			text = qreditrh.getTMX("qredit");
		} else {
			text = minhon.qreditrh.document;
		}
		
		return MD5(text);
	},
	
	checkUpdate : function(){
		var hash = minhon.qredit.getHash();
		
		if ( hash === minhon.qredit.hash ){
			$(".btn-save").removeClass("update");
		} else {
			$(".btn-save").addClass("update");
		}
	},
	
	onBeforeunload : function(e){
		$(window).off("beforeunload");
		// ハッシュ計算
		minhon.qredit.checkUpdate();
		
		var hash = minhon.qredit.getHash();
		
		$(window).on("focus", function(){
			$(window).off("focus");
			setTimeout( function(){
				$(window).on("beforeunload", minhon.qredit.onBeforeunload);
			}, 100);
		});
		if ( hash !== minhon.qredit.hash ){
			return (e || window.event).returnValue = "confirm";
		}
	},
	
	onResize : function(){
		var h = $(window).height();
		$(minhon.qredit.editor).height(h - $("h2").height() - 40);
	},
	
	loadData : function(){
		jQuery.ajax({
			url      : "/app/documentController.php",
			type     : "POST",
			data     : {
							"q_mode" : minhon.define.APP_DOCUMENT_CONTROLLER_MODE_GET,
							"q_id"   : minhon.qredit.documentID
						},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					if ( res.data.is_revision && $(minhon.qredit.editor).attr("data-mode") === "edit" ){
						alert(WORD_J_JS_MINHON_QREDIT_009+"\r\n"+WORD_J_JS_MINHON_QREDIT_010);
					}
					if ( typeof qreditrh !== "undefined" ){
						// tmxセット
						qreditrh.loadTMX("qredit", minhon.qredit.userName, res.data.xml);
					} else {
						minhon.qreditrh.document = res.data.xml;
					}
					
					setTimeout(function(){
						// ハッシュ値初期化
						minhon.qredit.hash = minhon.qredit.getHash();
						// 編集状態監視
						setInterval(function(){minhon.qredit.checkUpdate();}, 1000);
					}, 10);
				} else {
					alert(res.message);
				}
			}
		});
	},
	
	saveData : function( btnElement ){
		var tmx = "";
		if ( typeof qreditrh !== "undefined" ){
			tmx = qreditrh.getTMX("qredit");
		} else {
			tmx = minhon.qreditrh.document;
		}
		
		if ( btnElement ){
			$(btnElement).find(".loading-save").show();
		}
		
		jQuery.ajax({
			url      : "/app/documentController.php",
			type     : "POST",
			data     : {
							"q_token" : $("#q_token_qredit").val(),
							"q_mode"  : minhon.define.APP_DOCUMENT_CONTROLLER_MODE_SET,
							"q_id"    : minhon.qredit.documentID,
							"q_text"  : tmx
						},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					// ハッシュ値更新
					minhon.qredit.hash = minhon.qredit.getHash();
					minhon.qredit.checkUpdate();
				} else {
					alert(res.message);
				}
			},
			complete : function(){
				if ( btnElement ){
					$(btnElement).find(".loading-save").hide();
				}
			}
		});
	},
	
	
	/**************************************************
	 *  コールバック関数
	 *    QReditから呼ばれる関数
	 ************************************************** */
	
	onChangeMode : function(mode){
		$("#btnTemporarySave").hide();
		$("#btnEditSave").hide();
		$("#btnCorrectSave").hide();
		
		switch ( mode ){
			case "edit":
				$("#btnTemporarySave").show().css("display", "block");
				$("#btnEditSave").show().css("display", "block");
				break;
			case "correct":
				$("#btnTemporarySave").show().css("display", "block");
				$("#btnCorrectSave").show().css("display", "block");
				break;
			case "compare":
				break;
			default:
				alert("Error");
		}
	},
	
	onQReditorCompleted : function(){
		minhon.qredit.initialize_Load();
	},
	
	onLookup : function(){
		//qreditrh.changeQReditMode("qredit", $(minhon.qredit.editor).attr("data-mode"));
	},
	
	confirmModify : function( funcAllow, funcDeny ){
		var dfd = $.Deferred().done( funcAllow ).fail( funcDeny );
		var $dialog = $("#confirm_to_modify_dialog").dialog({
			"width" : "auto",
			"modal" : true,
			"buttons" : [
				{ 
					"class" : "btn btn-default",
					"text" : WORD_J_JS_MINHON_QREDIT_011,
					"click" : function(){
						dfd.resolve();
						$dialog.dialog("close");
					}
				}, {
					"class" : "btn btn-default",
					"text"  : WORD_J_JS_MINHON_QREDIT_012,
					"click" : function(){
						// コピーに成功した場合のみダイアログを閉じ、失敗した場合は、メッセージを表示させる（ダイアログは表示されたまま）
						$.ajax({
							url      : "/app/documentController.php",
							type     : "POST",
							data     : {
											"q_token"      : $("#q_token_qredit").val(),
											"q_mode"       : minhon.define.APP_DOCUMENT_CONTROLLER_MODE_COPY,
											"q_id"         : minhon.qredit.documentID,
											"q_project_id" : minhon.qredit.projectID
											//"q_name"       : $("#q_copy_name").val()
										},
							dataType : "json",
							error    : function(){
								alert(minhon.define.AJAX_ERROR);
							},
							success  : function( res ){
								if ( res.result == minhon.define.RES_OK ){
									//res.data.id
									dfd.resolve();
									$dialog.dialog("close");
								} else {
									alert(res.message);
								}
							}
						});
					}
				}
			],
			"open"  : function(event, ui){
				$(this).find('*:focus').blur(); // フォーカスを与えない
			},
			"close" : function(){
				if ( dfd.state() == "pending" ){ // 選択せずに閉じられた
					dfd.reject(); // 拒否
				}
				$dialog.dialog("destroy");
			}
		});
		return dfd.promise();
	},
	
	confirmLookup : function( funcAllow, funcDeny ){
		var dfd = $.Deferred().done( funcAllow ).fail( funcDeny );
		dfd.resolve(); // 常に許可
		return dfd.promise();
	},
	
	/**
	 * [dev-qredit:00345] - [dev-qredit:00321][dev-qredit:00322]
	 * 辞書引きロギング
	 *
	 * @param logInfo ログ情報配列
	 *
	 * ※固定
	 * logInfo["paragraph-number"]: パラグラフ番号
	 * logInfo["slang"]:            翻訳元言語
	 * logInfo["tlang"]:            翻訳先言語
	 * logInfo["paragraph"]:        パラグラフの単語配列
	 * logInfo["lookup-index"]:     翻訳元単語位置(翻訳元文章でクリックしたパラグラフ配列のインデックス)
	 * logInfo["lookup-text"]:      翻訳元単語(翻訳元文章でクリックした単語)
	 * logInfo["lookup-pos"]:       翻訳元単語の品詞
	 * logInfo["place"]:            辞書IDを適用する単語位置
	 * logInfo["dict-ids"]:         辞書ID並び(カンマ区切り)
	 * logInfo["awareness"]:        認知度クラス(awarenessClass)
	 */
	loggingLookup : function( userID, projectID, logInfo, funcSuccess, funcError ){
		var dfd = $.Deferred().done( funcSuccess ).fail( funcError );
		jQuery.ajax({
			url      : "/app/loggingController.php",
			type     : "POST",
			data     : {
							"q_token"       : $("#q_token_qredit").val(),
							"q_mode"        : minhon.define.APP_LOGGING_CONTROLLER_MODE_LOOKUP,
							"q_project_id"  : projectID,
							"q_task_id"     : minhon.qredit.taskID,
							"q_task_type"   : minhon.qredit.taskType,
							"q_task_role"   : minhon.qredit.taskRole,
							"q_document_id" : minhon.qredit.documentID,
							"q_data"        : logInfo
						},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
				dfd.reject();
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					dfd.resolve();
				} else {
					alert(res.message);
					dfd.reject();
				}
			}
		});
		return dfd.promise();
	},

	/**
	 * [dev-qredit:00318] - [dev-qredit:00321][dev-qredit:00322]
	 * 翻訳行動ロギング
	 *
	 * ※辞書引きにつきましては、どの単語（あるいはストリングスパン指定）に対して、
	 *   PLSMRのいずれが選択されたかのログを取り、蓄積する（文書＋セッション＋ユーザ）
	 *
	 * @param logInfo ログ情報配列
	 *
	 * ※固定
	 * logInfo["mode"]: ポップアップモード {P|L|S|TM|M|R}
	 * logInfo["paragraph-number"]: パラグラフ番号
	 * logInfo["slang"]: 翻訳元言語
	 * logInfo["tlang"]: 翻訳先言語
	 * logInfo["paragraph"]: パラグラフの単語配列
	 * logInfo["lookup-index"]: 翻訳元単語位置(翻訳元文章でクリックしたパラグラフ配列のインデックス)
	 * logInfo["lookup-text"]: 翻訳元単語(翻訳元文章でクリックした単語)
	 * logInfo["is-midashi"]: ポップアップ内のクリックした語種別 {見出し(true)|訳語(false)}
	 *
	 * ※可変
	 * Pモード
	 *   logInfo["P-word"]: ポップアップ内のクリックした訳語
	 * Lモード
	 *   logInfo["L-word"]: ポップアップ内のクリックした訳語
	 *   logInfo["L-slang"]: 検索元言語
	 *   logInfo["L-tlang"]: 検索先言語
	 * Sモード
	 *   logInfo["S-query"]: 検索クエリー
	 * TMモード
	 *   logInfo["TM-word"]: 検索語
	 *   logInfo["TM-slang"]: 検索元言語
	 *   logInfo["TM-tlang"]: 検索先言語
	 * Mモード
	 *   logInfo["M-word"]: 検索語
	 *   logInfo["M-slang"]: 検索元言語
	 *   logInfo["M-tlang"]: 検索先言語
	 * Rモード
	 *   logInfo["R-midashi"]: 登録する見出し
	 *   logInfo["R-translation"]: 登録する訳語
	 */
	logging : function( userID, projectID, logInfo, funcSuccess, funcError ){
		var dfd = $.Deferred().done( funcSuccess ).fail( funcError );
		
		jQuery.ajax({
			url      : "/app/loggingController.php",
			type     : "POST",
			data     : {
							"q_token"       : $("#q_token_qredit").val(),
							"q_mode"        : minhon.define.APP_LOGGING_CONTROLLER_MODE_LKUPSL,
							"q_project_id"  : projectID,
							"q_task_id"     : minhon.qredit.taskID,
							"q_task_type"   : minhon.qredit.taskType,
							"q_task_role"   : minhon.qredit.taskRole,
							"q_document_id" : minhon.qredit.documentID,
							"q_data"        : logInfo
						},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
				dfd.reject();
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					dfd.resolve();
				} else {
					alert(res.message);
					dfd.reject();
				}
			}
		});
		return dfd.promise();
	},
	
	/**
	 * 掲示板投稿
	 *
	 * @param logInfo 選択テキスト情報配列
	 *
	 * ※固定
	 * logInfo["revision"]: 
	 * logInfo["repid"]: 
	 * logInfo["lang"]: 
	 * logInfo["pos"]: 
	 * logInfo["length"]: 
	 * logInfo["translated"]: 
	 */
	loggingDialog : function( userID, projectID, logInfo, funcSuccess, funcError ){
		var dfd = $.Deferred().done( funcSuccess ).fail( funcError );
		
		var tmx = "";
		if ( typeof qreditrh !== "undefined" ){
			tmx = qreditrh.getTMX("qredit");
		} else {
			tmx = minhon.qreditrh.document;
		}
		
		var temp = [
			logInfo["repid"],
			logInfo["lang"],
			logInfo["pos"],
			logInfo["length"],
		];
		var select = temp.join("-");
		
		minhon.bbs.post.postDialog( false, null, null, {
			"q_project_id"      : projectID,
			"q_task_id"         : minhon.qredit.taskID, // タスクの役割だけを有効にする
			"q_document"        : tmx,
			"q_document_select" : select
		}).then( function(){
			dfd.resolve();
		}, function(){
			dfd.reject();
		});
		
		return dfd.promise();
	},
	
	onClickTM : function( sText, tText, sLang, tLang, funcSuccess, funcError ){
		var dfd = $.Deferred();
		if ( typeof funcSuccess === "function" || typeof funcError === "function" ){
			dfd.done( funcSuccess ).fail( funcError );
		}
		
		var params = {
			"q_mode" : minhon.define.CONTENT_SEARCH_INDEX_MODE_SIM,
			"q_text" : tText,
			"q_project_id" : minhon.qredit.projectID
		}
		var win = window.open( "/content/search/?" + $.param(params) );
		if ( win ){
			dfd.resolve();
		} else {
			dfd.reject();
		}
		
		return dfd.promise();
	},
	
	onClickBSearch : function( sText, tText, sLang, tLang, funcSuccess, funcError ){
		var dfd = $.Deferred();
		if ( typeof funcSuccess === "function" || typeof funcError === "function" ){
			dfd.done( funcSuccess ).fail( funcError );
		}
		
		var params = {
			"q_mode" : minhon.define.CONTENT_SEARCH_INDEX_MODE_BILINGUAL,
			"q_text" : tText,
			"q_project_id" : minhon.qredit.projectID
		}
		var win = window.open( "/content/search/?" + $.param(params) );
		if ( win ){
			dfd.resolve();
		} else {
			dfd.reject();
		}
		
		return dfd.promise();
	},
	
	onClickTermRegister : function( sText, tText, sLang, tLang, funcSuccess, funcError ){
		var dfd = $.Deferred().done( funcSuccess ).fail( funcError );
		
		sText = sText || "";
		tText = tText || "";
		
		jQuery.ajax({
			url      : "/app/termController.php",
			type     : "POST",
			data     : {
							"q_mode"       : minhon.define.APP_TERM_CONTROLLER_MODE_FRM,
							"q_kind"       : "term",
							"q_project_id" : minhon.qredit.projectID,
							"q_text_s"     : sText,
							"q_text_t"     : tText
						},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					$(minhon.qredit.dialog).empty().html(res.data).dialog({
						"width" : ($(window).width() * 0.6) + "px",
						"title"   : WORD_J_JS_MINHON_QREDIT_013,
						"buttons" : [
							minhon.common.dialogButton.OK( function(){
								var token  = $("#q_token_qredit").val();
								var rootID = $("#q_root_id").val();
								var textS  = $("#q_text_s").val();
								var textT  = $("#q_text_t").val();
								
								if ( jQuery.trim(textS).length == 0 || jQuery.trim(textT).length == 0 ){
									alert(WORD_J_JS_MINHON_QREDIT_014);
									return;
								}
								
								jQuery.ajax({
									url      : "/app/termController.php",
									type     : "POST",
									data     : {
													"q_mode"    : minhon.define.APP_TERM_CONTROLLER_MODE_SET,
													"q_kind"    : "term",
													"q_id"      : minhon.define.INIT_ID,
													"q_text_s"  : textS,
													"q_text_t"  : textT,
													"q_root_id" : rootID,
													"q_token"   : token
												},
									dataType : "json",
									error    : function(){
										alert(minhon.define.STR_AJAX_ERROR);
									},
									success  : function( res ){
										if ( res.result === minhon.define.RES_OK ){
											dfd.resolve();
											$(minhon.qredit.dialog).dialog("close");
										} else {
											alert(res.message);
										}
									}
								});
							} ),
							minhon.common.dialogButton.Cancel()
						],
						"close" : function(){
							if ( dfd.state() == "pending" ){
								dfd.reject();
							}
							$(minhon.qredit.dialog).dialog("destroy");
						}
					});
				} else {
					alert(res.message);
				}
			}
		});
		
		return dfd.promise();
	},
	
	showTermForm : function( sText, tText ){
		minhon.qredit.onClickTermRegister( sText, tText, "", "" );
	},
	
	eod : null
};

// qreditrh読込不可の時に使用
minhon.qreditrh = {
	document : null,
};
