minhon.statistics = {
};

minhon.statistics.bbs = {
	
	initialize : function(){
		var graph = null;
		if ( graph = $("#graph_bar") ){
			var tdMaxSize = 0;
			$("#graph_bar_legend table.fixed td").each( function(){
				tdMaxSize = Math.max( tdMaxSize, $(this).width() );
			});
			$("#graph_bar_legend table.fixed td").each( function(){
				$(this).width( tdMaxSize );
			});
//			graph.height( Math.max( $("#graph_bar_main").height(), $("#graph_bar_legend").height() ) );
		}
	},
	
	onClickIntervalUnit : function( ele, unitScale ){
		var $divInputGroup = $(ele).closest("div.input-group");
		
		$divInputGroup.find("input[name=q_interval_unit]").val( unitScale );
		$divInputGroup.find("button.dropdown-toggle > span.dropdown-text").text( $(ele).text() );
	},
	
	sortGraph : function(a, b){
		if ( a.x < b.x ) return -1;
		if ( a.x > b.x ) return 1;
		return 0;
	},
	
	lineGraph : function( lines, lineLabel, markLabel, maxXValue ){
		// series の設定
		var lineSeries = new Array( lineLabel.lenght );
		for ( var i = 0; i < lineLabel.length; i++ ){
			lineSeries[i] = {
				group : 1,
				showHighlight : false,
				color : lineLabel[i].color || "#CCCCCC",
				label : lineLabel[i].label || null
			};
		}
		var markSeries = new Array( markLabel.length );
		for ( var i = 0; i < markLabel.length; i++ ){
			markSeries[i] = {
				group : 2,
				showLine   : false,
				showMarker : true,
				showHighlight : true,
				color : markLabel[i].color || "#CCCCCC",
				label : markLabel[i].label || null,
				markerOptions : {
					size  : 10.0,
					style : markLabel[i].style || null
				}
			};
		}
		
		var graph = {};
		for ( var i = 0; i < lineLabel.length; i++ ){
			graph[ lineLabel[i].label ] = [];
		}
		var mark = {};
		for ( var i = 0; i < markLabel.length; i++ ){
			mark[ markLabel[i].label ] = [];
		}
		
		var line,
			point;
		for ( var ltype in lines ){
			line = lines[ltype];
			for ( var ptype in line ){
				points = line[ptype];
				
				for ( var i = 0; i < points.length; i++ ){
					graph[ltype].push({
						x : points[i],
						type: ptype
					});
				}
			}
		}
		
		var axis, xValue, yValue, baseXValue;
		for ( var ltype in graph ){
			line = graph[ltype];
			
			line.sort( minhon.statistics.bbs.sortGraph );
			
			axis = [];
			if ( line.length === 0 || line[0].x !== 0.0 ){
				axis.push([0, 0]);
			}
			yValue = 0;
			/*
			for ( var i = 0; i < line.length-1; i++ ){
				xValue = line[i].x;
				ptype  = line[i].type;
				axis.push([xValue, yValue]);
				yValue++;
				axis.push([xValue, yValue]);
				mark[ptype].push([xValue, yValue, ltype]);
			}
			*/
			for ( var i = 0; i < line.length-1; i++ ){
				baseXValue = Math.floor(line[i].x);
				var j = i+1;
				for ( ; j < line.length-1; j++ ){
					if ( baseXValue !== Math.floor(line[j].x) ){
						break;
					}
				}
				j = j-1;
				
				axis.push([baseXValue, yValue]);
				for ( var l = i; l <= j; l++ ){
					// 正しい値を入れるとマーク位置が線上からズレるのでX位置を計算する
					xValue = ((l-i+1) / (j-i+1)) + baseXValue;
					ptype  = line[l].type;
					yValue++;
					mark[ptype].push([xValue, yValue, ltype]);
				}
				if ( baseXValue === maxXValue ){
					// 追加しようとしている時間がDataの最後の時間であり、なおかつその時間がインターバルの区切りだった場合は、x軸を変えずにy+1の値を入れる
					// インターバルの時間が極端に短い場合に来る可能性があるが、それ以外の時は、あまりこないはず
					axis.push([maxXValue, yValue]);
				} else {
					axis.push([baseXValue+1, yValue]);
				}
				
				i = j;
			}
			
			if ( line.length === 0 || line[line.length-1].x !== maxXValue ){
				axis.push([maxXValue, yValue]); //最後
			}
			
			graph[ltype] = axis;
		}
		
		var arrTick = [];
		var tickValue = 0;
		var tickGenerator = $.jqplot.LinearTickGenerator(0, maxXValue, 1, 11, true, true);
		var tickCount = tickGenerator[2];
		var tickStep  = tickGenerator[4];
		if ( tickStep < 1 ){
			tickStep = 1;
		}
		for ( var i = 0; i <= tickCount; i++ ){
			tickValue = i * tickStep;
			if ( tickValue >= maxXValue ) {
				arrTick.push( maxXValue );
				break;
			}
			arrTick.push( tickValue );
		}
		
		var plotData = [];
		for ( var ltype in graph ){
			plotData.push( graph[ltype] );
		}
		for ( var ptype in mark ){
			plotData.push( mark[ptype] );
		}
		var plotSeries = lineSeries.concat(markSeries);
		
		var plot = $.jqplot("line_graph", plotData, {
			fontSize : '16px',
			//title : 'Title',
			seriesDefaults : {
				showMarker : false,
				fillToZero : true
			},
			series : plotSeries,
			legend : {
				renderer : $.jqplot.TableMarkerLegendRenderer,
				show : true,
				location : 'se',
				placement : 'outsideGrid'
			},
			axes : {
				xaxis : {
					label : WORD_J_JS_MINHON_STATISTICS_001,
					pad : 0,
					ticks : arrTick,
					tickOptions : {
						showGridline : false,
						formatString : '%d'
					}
					/*
					rendererOptions : {
						autoscale : false,
						min : 0,
						max : maxXValue
					}
					*/
				},
				yaxis : {
					label : WORD_J_JS_MINHON_STATISTICS_002,
					pad : 0,
					padMax : 1.1
				}
			},
			highlighter : {
				show : true,
//				bringSeriesToFront : true,
				tooltipContentEditor : minhon.statistics.bbs.tooltipContentEditor
			},
			animate : true
		});
	},
	
	tooltipContentEditor : function(str, seriesIndex, pointIndex, plot ){
		var str = "";
		if ( plot.data[seriesIndex][pointIndex][2] ){
			str += "<tr><td>role</td><td>:</td><td>"+plot.data[seriesIndex][pointIndex][2]+"</td></tr>";
		}
		str += "<tr><td>type</td><td>:</td><td>" + plot.series[seriesIndex].label + "</td></tr>";
		str = "<table><tbody>" + str + "</tbody></table>";
		return str;
	},
	
	eod : null
};
