minhon.task = {
	dialog : null,
	
	initialize : function(){
		$("#table_home_task").find("[data-toggle=tooltip]").tooltip();
	},
	
	onClickTask : function( taskID, documentID ){
		if ( minhon.task.dialog ){
			$(minhon.task.dialog).dialog("destroy").remove();
			minhon.task.dialog = null;
		}
		
		jQuery.ajax({
			url      : "/app/taskController.php",
			async    : false,
			type     : "POST",
			data     : {
							"q_mode"        : minhon.define.APP_TASK_CONTROLLER_MODE_ACTION,
							"q_task_id"     : taskID,
							"q_document_id" : documentID
						},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					if ( res.data.url ){
						if ( res.data.popup ){
							window.open( res.data.url, "_blank" );
						} else {
							location.href = res.data.url;
						}
					} else if ( res.data.dialog ){
						minhon.task.dialog = $("<div>");
						minhon.task.dialog.html(res.data.dialog)
							.dialog({
								"title" : WORD_J_JS_MINHON_TASK_001,
								"modal" : true,
								"width" : ($(window).width() * 0.6),
								"buttons" : [{
									"text" : WORD_J_JS_MINHON_TASK_002,
									"class" : "btn btn-default",
									"click" : function(){
										$(minhon.task.dialog).dialog("close");
									}
								}],
								"close"  : function(){
									$(minhon.task.dialog).dialog("destroy").remove();
									minhon.task.dialog = null;
								}
							});
					}
				} else {
					alert(res.message);
				}
			}
		});
	},
	
	setTaskState : function( taskID, state ){
		
		jQuery.ajax({
			url : "/app/taskController.php",
			type : "POST",
			data : {
				"q_mode"       : minhon.define.APP_TASK_CONTROLLER_MODE_SET_STATE, 
				"q_token"      : $("#q_token").val(),
				"q_task_id"    : taskID,
				"q_state"      : state
			},
			dataType : "json",
			error : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					minhon.common.reload();
				} else {
					alert( res.message );
				}
			}
		});
		
	},
	
	eod : null
}

minhon.task.chart = {
	dialog : null,
	mode : "",
	
	value : {},
	
	ganttDefault : {
		"cellWidth"    : 21,
		"slideWidth"   : "100%",
		"showWeekends" : true,
		"behavior" : {
			"draggable" : false,
			"resizable" : false,
			"onClick" : function( obj ){
				$("#chart").trigger("gantt-block-click", [obj]);
			}
		}
	},
	
	_initValidator : function(){
		// フォーム編集画面でのValidator処理
		if ( $.validator ){
			$.validator.setDefaults({
				errorPlacement : function(error, element){
					// 通常処理
					error.insertAfter(element);
					if ( element.closest("#form_task_edit2").length > 0 ){
						// タスク選択
						if ( element.is(":checkbox") && element.parent().is("label.checkbox-inline") ){
							var label = element.closest("label.checkbox-inline");
							var category = label.prevAll(":not(label.checkbox-inline)").get(0);
							// labelに"*"が表示されている
							if ( category !== undefined && $(category).find(".form-required").length > 0 ){
								$(category).append(error);
							} else {
								label.parent().append(error);
							}
						} else if ( element.is(":radio") && element.parent().is("label.radio-inline") ){
							var label = element.closest("label.radio-inline");
							var category = label.prevAll(":not(label.radio-inline)").get(0);
							// labelに"*"が表示されている
							if ( category !== undefined && $(category).find(".form-required").length > 0 ){
								$(category).append(error);
							} else {
								label.parent().append(error);
							}
						} else if ( element.is("input:hidden.validate-item") && (element.attr("name").slice(-2) === "[]") ){
							// 未登録の文書（用語集、翻訳メモリ、データ）
							$.each( element.prevAll(), function(){
								if ( $(this).find(".form-required").length > 0 ){
									$(this).append(error);
									return false;
								}
							} );
						}
					}
				}
			});
			
			$.validator.addMethod("required_group", function(value, element, options){
				var validator = this;
				var selector  = options[1];
				var validOrNot = $(selector, element.form).filter(function(){
					return validator.elementValue(this);
				}).length >= options[0];
				
				return validOrNot;
			}, $.validator.messages["required"]);
			// 日付
			$.validator.addMethod("greatherThanEqual", function(value, element, options){
				if (!/Invalid|NaN/.test(new Date(value))) {
					return new Date(value) >= new Date($(options).val());
				}
				return isNaN(value) && isNaN($(options).val()) || (Number(value) >= Number($(options).val()));
			}, $.validator.messages["date"]);
		}
	},
	
	/***********************************
	 * 名前 : onClickTaskDetail
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	onClickTaskDetail : function( taskID, taskIDs ){
		if ( minhon.task.chart.dialog.data("dialog") && $(minhon.task.chart.dialog).dialog("isOpen") ){
			$(minhon.task.chart.dialog)
				.append(
					$("<div>").attr("id", "overlay").append( $("<i>").addClass("glyphicon glyphicon-refresh glyphicon-spin") )
				);
		}
		jQuery.ajax({
			url      : "/app/taskController.php",
			type     : "POST",
			data     : {
							"q_mode"     : minhon.define.APP_TASK_CONTROLLER_MODE_GET_TASK_DETAIL,
							"q_task_id"  : taskID,
							"q_task_ids" : taskIDs
			},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					$(minhon.task.chart.dialog)
						.empty()
						.html(res.data.dialog)
						.dialog({
							"title" : res.data.title,
							"modal" : true,
							"width" : ($(window).width() * 0.6),
							"buttons" : null,
							"open"  : function(){
								minhon.common.ellipsis( $(this) );
								$(this).find('*:focus').blur(); // フォーカスを与えない
							}
						});
				} else {
					alert(res.message);
				}
			}
		});
	},
	
	/***********************************
	 * 名前 : onClickTaskNew
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	onClickTaskNew : function( taskType, taskTypes, option ){
		minhon.task.chart.onClickTaskEdit( undefined, taskType, taskTypes, option );
	},
	
	/***********************************
	 * 名前 : onClickTaskEdit
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	onClickTaskEdit : function( taskID, taskType, taskTypes, option ){
		var mode = minhon.define.APP_TASK_CONTROLLER_MODE_GET_TASK_EDIT;
		if ( taskID === undefined ){
			mode = minhon.define.APP_TASK_CONTROLLER_MODE_GET_TASK_NEW;
		}
		jQuery.ajax({
			url      : "/app/taskController.php",
			type     : "POST",
			data     : {
							"q_mode"        : mode,
							"q_workflow_id" : minhon.task.chart.value.workflowID,
							"q_task_id"     : taskID,
							"q_task_type"   : taskType,
							"q_task_types"  : taskTypes,
							"q_option"      : option
			},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					var buttons = [];
					buttons.push( minhon.common.dialogButton.OK() );
					// Skipボタン
					if ( typeof taskTypes === "string" ){
						var arrTaskType = taskTypes.split(",");
						var idx = arrTaskType.indexOf( taskType );
						if ( idx < arrTaskType.length-1 ){
							buttons.push( {
								"text" : "Skip",
								"class" : "btn btn-default",
								"click" : function(){
									minhon.task.chart.onClickTaskNew(arrTaskType[idx+1], taskTypes);
								}
							} );
						}
					}
					if ( option === undefined ){
						buttons.push( minhon.common.dialogButton.Cancel() );
					} else {
						buttons.push( minhon.common.dialogButton.Cancel( function(){
							minhon.common.reload();
						}) );
					}
					
					$(minhon.task.chart.dialog)
						.empty().remove()
						.html(res.data.dialog)
						.dialog({
							"title" : res.data.title,
							"modal" : true,
							"width" : ($(window).width() * 0.6),
							"buttons" : buttons,
							"open"  : function(){
								if ( typeof funcReady === "function" ){ funcReady(); }
								minhon.common.ellipsis( $(this) );
								$("#q_start").datepicker({"dateFormat" : "yy-mm-dd"}).on("change", function(){
									//$("#q_end").datepicker("setDate", $(this).datepicker("getDate"));
									$("#q_end").datepicker("option", "defaultDate", $(this).datepicker("getDate"));
								});
								$("#q_end").datepicker({"dateFormat" : "yy-mm-dd", "defaultDate" : $("#q_start").datepicker("getDate")});
								
								$(this).find("*:focus").blur(); //フォーカスを外す
								
								$(minhon.task.chart.dialog).find("form:first").data("validator").settings.submitHandler = function(form){
									minhon.task.chart.onClickTaskUpdate();
								};
								
								var getSyncElement = function( obj ){
									if ( ! $(obj).is("[data-object-sync]")){
										return;
									}
									
									var syncName  = "q_object[" + $(obj).attr("data-object-sync") + "][]";
									var syncValue = $(obj).attr("value");
									return $(obj).closest("form").find("[name='"+syncName+"'][value='"+syncValue+"']").get(0);
								}
								
								var funcSyncEvent = function( syncobj ){
									if ( $(syncobj).is("[disabled]") ){
										return;
									}
									$(syncobj).parent("label").addClass("alert-warning");
									if ( $(syncobj).next("i").length == 0 ){
										$(syncobj).after( $("<i>").addClass("glyphicon glyphicon-link") );
									}
									$(syncobj).one("click", function(){
										$(syncobj).parent("label").removeClass("alert-warning");
										$(syncobj).next("i").remove();
									});
								}
								
								$(minhon.task.chart.dialog).find("[data-object-sync]").bind("click", function(){
									var syncElement = getSyncElement( this );
									if ( syncElement ){
										if ( $(this).is(":checked") ){
											$(syncElement).attr("checked", "checked");
										} else {
											$(syncElement).removeAttr("checked");
										}
										funcSyncEvent( syncElement );
									}
								}).each( function(){
									var syncElement = getSyncElement( this );
									if ( syncElement ){
										if ( taskID === undefined ){
											if ( $(this).is(":checked") ){
												$(syncElement).attr("checked", "checked");
											} else {
												$(syncElement).removeAttr("checked");
											}
											funcSyncEvent( syncElement );
										} else {
											if ( $(this).is(":checked") && $(syncElement).is(":checked") ){
												funcSyncEvent( syncElement );
											} else if ( $(this).is(":not(:checked)") && $(syncElement).is(":not(:checked)") ){
												funcSyncEvent( syncElement );
											}
										}
									}
								});
							},
							"close" : function(){
								$(this).dialog("destroy");
								$(this).remove();
							}
						});
				} else {
					alert(res.message);
				}
			}
		});
	},
	
	/***********************************
	 * 名前 : onClickTaskUpdate
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	onClickTaskUpdate : function(){
		var param = {};
		$( $(minhon.task.chart.dialog).find("form:first").serializeArray() ).each( function(i, val){
			var key   = val.name;
			var value = val.value;
			var reg = key.match(/\[([^\]]*)\]/gi);
			for (var regIndex in reg ){
				// "["と"]"を取り除く
				reg[regIndex] = reg[regIndex].slice(1, -1);
			}
			if ( reg === null){
				param[key] = value;
			} else {
				key = key.substring( 0, key.indexOf("["));
				var idx1, idx2;
				if ( reg.length >= 1 ){
					idx1 = reg[0];
					if ( idx1.length === 0 ){
						if ( param[key] === undefined ){
							param[key] = [];
						}
						param[key].push( value );
					} else if ( reg.length >= 2 ){
						if ( param[key] === undefined ){
							param[key] = {};
						}
						idx2 = reg[1];
						if ( idx2.length === 0 ){
							if ( param[key][idx1] === undefined ){
								param[key][idx1] = [];
							}
							param[key][idx1].push( value );
						} else {
							if ( param[key][idx1] === undefined ){
								param[key][idx1] = {};
							}
							param[key][idx1][idx2] = value;
						}
					}
				}
			}
		});
		jQuery.ajax({
			url      : "/app/taskController.php",
			type     : "POST",
			data     : $.extend(true,  param, {
							"q_mode"        : minhon.define.APP_TASK_CONTROLLER_MODE_SET_TASK_UPDATE,
							"q_workflow_id" : minhon.task.chart.value.workflowID,
						}),
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result == minhon.define.RES_OK ){
					if ( "q_task_types" in param && "q_task_type" in param ){
						var arrTaskType = param["q_task_types"].split(",");
						var idx = arrTaskType.indexOf( param["q_task_type"] );
						if ( idx < arrTaskType.length-1 ){
							var post = [];
							if ( typeof param === "object" ){
								var post = {};
								for ( var key in param ){
									if ( key.substring(0, 8) === "q_actor" ){
										post[key] = param[key];
									} else if ( key.substring(0, 9) === "q_object"){
										post[key] = param[key];
									} else if ( key === "q_end" ){
										// 前回の終了日を次の開始日にする
										post["q_start"] = param[key];
									}
								}
							}
							minhon.task.chart.onClickTaskNew(arrTaskType[idx+1], param["q_task_types"], post);
						} else {
							$(minhon.task.chart.dialog).dialog("close");
							minhon.task.chart.refresh();
						}
					} else {
						$(minhon.task.chart.dialog).dialog("close");
						minhon.task.chart.refresh();
					}
				} else {
					alert(res.message);
				}
			}
		});
	},
	
	/***********************************
	 * 名前 : onClickTaskDelete
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	onClickTaskDelete : function( id, message ){
		var def = null;
		if ( message ){
			def = minhon.common.dialog.confirm(message);
		}
		
		$.when(def).done(function(){
			jQuery.ajax({
				url : "/app/taskController.php",
				type : "POST",
				data : {
					"q_mode"        : minhon.define.APP_TASK_CONTROLLER_MODE_SET_TASK_DELETE,
					"q_workflow_id" : minhon.task.chart.value.workflowID,
					"q_task_id"     : id,
					"q_token"       : $("#token_common").val()
				},
				dataType : "json",
				error : function(){
					alert(minhon.define.AJAX_ERROR);
				},
				success : function( res ){
					if ( res.result == minhon.define.RES_OK ){
						$(minhon.task.chart.dialog).dialog("close");
						minhon.task.chart.refresh();
					} else {
						alert( res.message );
					}
				}
			});
		});
	},
	
	/***********************************
	 * 名前 : refresh
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	refresh : function(){
		if ( minhon.task.chart.mode === "edit" ){
			minhon.task.chart.edit(minhon.common.getParameter());
		} else if ( minhon.task.chart.mode === "detail" ){
			minhon.task.chart.detail(minhon.common.getParameter());
		}
	},
	
	/***********************************
	 * 名前 : editInit
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	editInit : function( workflowID, userID, documentID ){
		minhon.task.chart.mode = "edit";
		minhon.task.chart.dialog = $("<div>");
		minhon.task.chart.value = {
			"workflowID" : workflowID
		};
		
		var data = {
			"q_user_id"           : userID,
			"q_document_id"       : documentID,
		};
		minhon.task.chart.edit(data);
		
		// タスク編集ダイアログの前処理
		minhon.task.chart._initValidator();
	},
	
	/***********************************
	 * 名前 : edit
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	edit : function( parameter ){
		$("#chart").css('margin-top', '');
		$("#chart").empty();
		$("#chart").append($("<img>").attr("src", "/img/loader.gif"));
		
		jQuery.ajax({
			url      : "/app/taskChartController.php",
			type     : "POST",
			data     : $.extend({}, parameter, {
				"q_mode"          : minhon.define.APP_TASK_CHART_CONTROLLER_MODE_ALLOCATE,
				"q_workflow_id"   : minhon.task.chart.value.workflowID
			}),
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				$("#chart").empty();
				
				if ( res.result == minhon.define.RES_OK ){
					$("#menu_task_order").css("display", "block"); //show
					
					var marginTop = $("#chart").attr("data-margin-top");
					if ( parseInt(marginTop) ){
						$("#chart").css('margin-top', marginTop+'px');
					}
					
					$("#chart").ganttView($.extend({}, minhon.task.chart.ganttDefault, {
						"data"            : res.data,
						"start"           : res.startDate,
						"end"             : res.endDate,
					}));
					/* イベント */
					$("#chart").on("gantt-series-click", function(event, obj){
						var $obj = $("#block-"+obj.id);
						if ( $obj.length == 0 ){
							$obj = $("#block-plan-"+obj.id);
						}
						if ( $obj.length > 0 ){
							var sl = $obj.offset().left - $(".ganttview-grid").offset().left;
							$(".ganttview-slide-container").animate({"scrollLeft" : sl}, 1000);
						}
						minhon.task.chart.onClickTaskDetail(obj.taskID, obj.taskIDs);
					});
					$("#chart").on("gantt-block-click", function(event, obj){
						minhon.task.chart.onClickTaskDetail(obj.taskID, obj.taskIDs);
					});
					
					$("#chart").find("[data-toggle=tooltip]").tooltip();
					$("#chart").find("[data-toggle=popover]").popover({
						trigger: "hover",
						delay: {hide: 50}
					// tooltipにカーソルを移動させた場合は、表示はそのまま
					}).on("shown.bs.popover", function(e){
						$(this).data("bs.popover").$tip.data("bs.popover.element", $(this));
						
						$(this).data("bs.popover").$tip.on("mouseenter", function(e){
							$(this).addClass("in-cursor");
						}).on("mouseleave", function(e){
							$(this).removeClass("in-cursor");
							var $element = $(this).data("bs.popover.element");
							$element.popover("hide");
						});
					}).on("hide.bs.popover", function(e){
						if ( $(this).data("bs.popover").$tip.is(".in-cursor") ){
							e.preventDefault();
						}
					});
					
					if ( res.stateHTML !== undefined ){
						var $tabright = $(".nav-tabs-right li.taskState");
						if ( $tabright.length == 0 ){
							$tabright = $("<li>").addClass("taskState").appendTo(".nav-tabs-right");
						}
						$tabright.html(res.stateHTML);
					}
					if ( res.prependHTML !== undefined ){
						$("#chart").prepend( res.prependHTML );
					}
					$(".ganttview-vtheader-item").each( function(index, target){
						var nameElement = $(target).children(".ganttview-vtheader-item-name");
						var seriesElement = nameElement.next();
						var fsize = 1;
						while ( nameElement.height() > seriesElement.height() ){
							fsize -= 0.1;
							nameElement.css("font-size", fsize+"em");
						}
					});
				} else if ( res.result == minhon.define.RES_NO_DATA ){
					$("#chart").append(res.messageHTML);
				} else {
					$("#chart").append(res.messageHTML);
				}
			}
		});
	},
	
	
	/***********************************
	 * 名前 : detailInit
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	detailInit : function( mode, workflowID, taskID, userID, documentID, termRootID, bilingualRootID, fix ){
		if ( ! mode ){
			mode = minhon.define.APP_TASK_CHART_CONTROLLER_MODE_DETAIL;
		}
		
		minhon.task.chart.mode = "detail";
		minhon.task.chart.dialog = $("<div>");
		minhon.task.chart.value = {
			"mode"       : mode,
			"workflowID" : workflowID,
			"taskID"     : taskID,  // 指定されたタスクを強調表示?させる
			"fixParameter" : fix,
		};
		
		var data = {
			"q_user_id"           : userID,
			"q_document_id"       : documentID,
			"q_term_root_id"      : termRootID,
			"q_bilingual_root_id" : bilingualRootID
		};
		minhon.task.chart.detail( data, false );
		
		// タスク詳細ダイアログから編集ダイアログを開くことができるため、前処理が必要
		minhon.task.chart._initValidator();
		
		// pushStateで履歴情報を加えているため
		$(window).on("popstate", function(e){
			window.location.href = window.location.href;
		});
	},
	
	/***********************************
	 * 名前 : detail
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	detail : function( parameter, addHistory ){
		$("#chart").css('margin-top', '');
		$("#chart").empty();
		$("#chart").append($("<img>").attr("src", "/img/loader.gif"));
		
		jQuery.ajax({
			url      : "/app/taskChartController.php",
			type     : "POST",
			data     : $.extend({}, {
				// parameterで指定されていた場合はparameterが優先される
				"q_mode"          : minhon.task.chart.value.mode,
			}, parameter, {
				// parameterで指定されていても上書きする
				"q_workflow_id"   : minhon.task.chart.value.workflowID,
				"q_fix_parameter" : minhon.task.chart.value.fixParameter
			}),
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				$("#chart").empty();
				
				if ( res.result == minhon.define.RES_OK ){
					$("#menu_task_order").css("display", "block"); //show
					
					var marginTop = $("#chart").attr("data-margin-top");
					if ( parseInt(marginTop) ){
						$("#chart").css('margin-top', marginTop+'px');
					}
					
					$("#chart").ganttView($.extend({}, minhon.task.chart.ganttDefault, {
						"data"            : res.data,
						"start"           : res.startDate,
						"end"             : res.endDate
					}));
					$("#chart").on("gantt-series-click", function(event, obj){
						var $obj = $("#block-"+obj.id);
						if ( $obj.length == 0 ){
							$obj = $("#block-plan-"+obj.id);
						}
						if ( $obj.length > 0 ){
							var sl = $obj.offset().left - $(".ganttview-grid").offset().left;
							$(".ganttview-slide-container").animate({"scrollLeft" : sl}, 1000);
						}
						minhon.task.chart.onClickTaskDetail(obj.taskID, obj.taskIDs);
					});
					$("#chart").on("gantt-block-click", function(event, obj){
						minhon.task.chart.onClickTaskDetail(obj.taskID, obj.taskIDs);
					});
					$("#chart").find("[data-toggle=tooltip]").tooltip();
					$("#chart").find("[data-toggle=popover]").popover({
						trigger: "hover",
						delay: {hide: 50}
					// tooltipにカーソルを移動させた場合は、表示はそのまま
					}).on("shown.bs.popover", function(e){
						$(this).data("bs.popover").$tip.data("bs.popover.element", $(this));
						
						$(this).data("bs.popover").$tip.on("mouseenter", function(e){
							$(this).addClass("in-cursor");
						}).on("mouseleave", function(e){
							$(this).removeClass("in-cursor");
							var $element = $(this).data("bs.popover.element");
							$element.popover("hide");
						});
					}).on("hide.bs.popover", function(e){
						if ( $(this).data("bs.popover").$tip.is(".in-cursor") ){
							e.preventDefault();
						}
					});
					
					if ( res.stateHTML !== undefined ){
						var $tabright = $(".nav-tabs-right li.taskState");
						if ( $tabright.length == 0 ){
							$tabright = $("<li>").addClass("taskState").appendTo(".nav-tabs-right");
						}
						$tabright.html(res.stateHTML);
					}
					if ( res.prependHTML !== undefined ){
						$("#chart").prepend( res.prependHTML );
						minhon.common.ellipsis( $("#chart") );
						$("#form_workflow_search a.btn").hover( function(){
							$(this).attr("data-back-class", $(this).attr("class"))
								.attr("class", "btn btn-danger");
							$(this).find("i:first").attr("data-back-class", $(this).find("i:first").attr("class"))
								.attr("class", "glyphicon glyphicon-remove");
						}, function(){
							$(this).attr("class", $(this).attr("data-back-class"))
								.removeAttr("data-back-class");
							$(this).find("i:first").attr("class", $(this).find("i:first").attr("data-back-class"))
								.removeAttr("data-back-class");
						});
					}
					$(".ganttview-vtheader-item").each( function(index, target){
						var nameElement = $(target).children(".ganttview-vtheader-item-name");
						var seriesElement = nameElement.next();
						var fsize = 1;
						
						while ( nameElement.height() > seriesElement.height() ){
							fsize -= 0.1;
							nameElement.css("font-size", fsize+"em");
						}
					});
					
					if ( minhon.task.chart.value.taskID !== undefined ){
						var $taskEle = $(".ganttview-vtheader-series-name[data-task-id=" + minhon.task.chart.value.taskID + "]");
						if ( $taskEle.length > 0 ) {
							$("html body").animate({scrollTop:$taskEle.offset().top}, 500, function(){
								$taskEle.animate({"background-color" : "#0088CC"}, 400, function(){
									
								}).animate({"background-color" : "#0088CC"}, 500, function(){
									
								}).animate({"background-color" : "#FFF"}, 400, function(){
									//minhon.task.chart.onClickTaskDetail(taskID);
								}).promise().done(function(){
									$(this).css("background-color", "");
								});
							});
						}
					}
					
					// 履歴追加
					if ( addHistory ){
						var historyParam = parameter;
						var url = location.href.split("?")[0] + "?" + $.param(historyParam);
						history.pushState(null, null, url);
					}
					
				} else if ( res.result == minhon.define.RES_NO_DATA ){
					$("#chart").append(res.messageHTML);
				} else {
					$("#chart").append(res.messageHTML);
				}
			}
		});
	},
	
	/***********************************
	 * 名前 : onClickTaskFilter
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	onClickTaskFilter : function(type, id, event){
		event.stopPropagation();
		
		var vars = minhon.common.getParameter();
		
		if ( type == "mode" ){
			vars["q_mode"] = id;
		} else {
			if ( "q_"+type+"_id" in vars ){
				var arrID = vars["q_"+type+"_id"].split(",");
				if ( Array.isArray(id) ){
					for ( var i = 0; i < id.length; i++ ){
						arrID.push(id[i]);
					}
					vars["q_"+type+"_id"] = arrID.join(',');
				} else if ( id >= 0 ){
					// 絞り込み条件に追加する。既に対象の場合はそのまま
					if ( arrID.indexOf(String(id)) < 0 ){
						arrID.push( id );
						vars["q_"+type+"_id"] = arrID.join(',');
					} 
				} else {
					// 絞り込み条件から外す
					id = Math.abs(id);
					if ( arrID.indexOf(String(id)) >= 0 ){
						arrID.splice( arrID.indexOf(String(id)), 1);
						if ( arrID.length > 0 ){
							vars["q_"+type+"_id"] = arrID.join(',');
						} else {
							delete vars["q_"+type+"_id"];
						}
					}
				}
			} else {
				if ( Array.isArray(id) ){
					vars["q_"+type+"_id"] = id.join(',');
				} else {
					vars["q_"+type+"_id"] = id;
				}
			}
			if ( type == "user" ){
				vars["q_mode"] = minhon.define.APP_TASK_CHART_CONTROLLER_MODE_DETAIL;
			} else if (type == "document" ){
				vars["q_mode"] = minhon.define.APP_TASK_CHART_CONTROLLER_MODE_DETAIL;
			}
		}
		minhon.task.chart.detail( vars, true );
	},
	
	/***********************************
	 * 名前 : onClickTaskFilterRemoveButton
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	onClickTaskFilterRemoveButton : function(self, event){
		if ( $(self).is("[data-user-id]") ){
			minhon.task.chart.onClickTaskFilter("user", "-"+$(self).attr("data-user-id"), event);
		}
		if ( $(self).is("[data-document-id]") ){
			minhon.task.chart.onClickTaskFilter("document", "-"+$(self).attr("data-document-id"), event);
		}
		if ( $(self).is("[data-term-root-id]") ){
			minhon.task.chart.onClickTaskFilter("term_root", "-"+$(self).attr("data-term-root-id"), event);
		}
		if ( $(self).is("[data-bilingual-root-id]") ){
			minhon.task.chart.onClickTaskFilter("bilingual_root", "-"+$(self).attr("data-bilingual-root-id"), event);
		}
	},
	
	/***********************************
	 * 名前 : onClickTaskFilterClear
	 * 説明 : 
	 * 引数 : 
	 * 返値 : 
	************************************/
	onClickTaskFilterClear : function(self, event){
		var vars = minhon.common.getParameter();
		
		// 残しておく値
		var param = {};
		if ( "q_project_id" in vars ){
			param["q_project_id"] = vars["q_project_id"];
		}
		if ( "q_id" in vars ){
			param["q_id"] = vars["q_id"];
		}
		if ( "q_task_id" in vars ){
			param["q_task_id"] = vars["q_task_id"];
		}
		if ( "q_mode" in vars ){
			param["q_mode"] = vars["q_mode"];
		}
		
		location.href = location.href.split("?")[0] + "?" + $.param(param);
	},
	
	eod : null
}
