minhon.term = {
	initialize : function( readOnly ){
		if ( readOnly !== minhon.define.ON ){
			$("table span.text").hover( function(){
				$(this).addClass("hover");
			}, function(){
				$(this).removeClass("hover");
			}).bind("click", minhon.term.onClickEditMode);
		}
		
		$("#term_register input").keypress(function(e){
			var code = (e.keyCode ? e.keyCode : e.which);
			
			if ( code == 13 ){  // enter key
				minhon.term.onClickRegister();
				$("#term_register input:first").focus();
			}
		});
	},
	
	onClickEditMode : function(){
		var tr = $(this).closest("tr");
		
		$(tr).find("span.delete").hide();
		$(tr).find("span.update").show();
		
		jQuery.each($(tr).find("span.text"), function(){
			var input = $("<input>")
				.attr("type", "text")
				.addClass("form-control")
				.val($(this).text())
			;
			$(this)
				.after(input)
				.hide();
		});
		
		$(this).next("input").focus();
	},
	
	onClickDelete : function( obj ){
		var tr = $(obj).closest("tr");
		var termID = $(tr).attr("class").split("_")[1];
		
		var mode = minhon.define.APP_TERM_CONTROLLER_MODE_DEL;
		
		minhon.term.edit(mode, termID, "", "", function(data){
			$("tr.term_" + data.q_id).remove();
			
			if ( $("table tr").size() == 2 ){
				document.location.reload();
			}
			
			// 件数表示をクリアする
			$(".table-pagination-heading > span").addClass("alert-danger");
			$(".table-pagination-heading .pagination-reload").removeClass("hide");
		});
	},
	
	onClickUpdate : function( obj ){
		var tr = $(obj).closest("tr");
		var termID = $(tr).attr("class").split("_")[1];
		
		var mode = minhon.define.APP_TERM_CONTROLLER_MODE_SET;
		
		var textS  = jQuery.trim($(tr).find("input").eq(0).val());
		var textT  = jQuery.trim($(tr).find("input").eq(1).val());
		
		minhon.term.edit(mode, termID, textS, textT, function(data){
			jQuery.each($("tr.term_" + data.q_id).find("input"), function(){
				$(this).closest("td").find("span.text").text($(this).val()).show();
				$(this).remove();
			});
			$("tr.term_" + data.q_id).find("span.delete").show();
			$("tr.term_" + data.q_id).find("span.update").hide();
		});
	},
	
	onClickRegister : function(){
		var mode   = minhon.define.APP_TERM_CONTROLLER_MODE_SET;
		var termID = minhon.define.INIT_ID;
		var textS  = jQuery.trim($("#text_s").val());
		var textT  = jQuery.trim($("#text_t").val());
		
		if ( textS.length == 0 ){
			return;
		}
		
		minhon.term.edit(mode, termID, textS, textT, function(data){
			var tr = $("<tr>")
				.addClass("term_" + data.q_id)
				.append($("<td>").append($("<span>").addClass("text").text(data.q_text_s)))
				.append($("<td>").append($("<span>").addClass("text").text(data.q_text_t)))
				.append($("<td>")
					.append($("<span>").addClass("delete")
						.append($("<button>").addClass("btn btn-danger").text(WORD_J_JS_MINHON_TERM_001).bind("click", function(){minhon.term.onClickDelete(this)})))
					.append($("<span>").addClass("update")
						.append($("<button>").addClass("btn btn-primary").text(WORD_J_JS_MINHON_TERM_002).bind("click", function(){minhon.term.onClickUpdate(this)})))
				);
				
				$(tr).find("span.text").bind("click", minhon.term.onClickEditMode);
				
			$("tr#term_register")
				.before(tr);
			
			$("tr#term_register input[type=text]").val("");
			
			// 件数表示をクリアする
			$(".table-pagination-heading > span").addClass("alert-danger");
			$(".table-pagination-heading .pagination-reload").removeClass("hide");
		});
	},
	
	edit : function( mode, termID, textS, textT, callback ){
		var token  = $("#q_token").val();
		var rootID = $("#q_id").val();
		var kind   = $("#q_kind").val();
		
		jQuery.ajax({
			url      : "/app/termController.php",
			type     : "POST",
			data     : {
							"q_mode"    : mode,
							"q_kind"    : kind,
							"q_id"      : termID,
							"q_text_s"  : textS,
							"q_text_t"  : textT,
							"q_root_id" : rootID,
							"q_token"   : token
						},
			dataType : "json",
			error    : function(){
				alert(minhon.define.STR_AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result === minhon.define.RES_OK ){
					$("div.alert").hide(100);
					
					if ( typeof callback == "function" ){
						callback(res.data);
					}
				} else {
					alert(res.message);
				}
			}
		});
	},
	
	eod : null
};

minhon.term.import = {
	initialize : function(){
		$("div.term_description > a").bind("click", function(){
			$("div.term_description > div").toggle(100);
		});
		$("#form_term").on("submit", function(e){
			var btnSubmit = $(this).find(":submit");
			var formData = new FormData($(this).get(0));
			formData.append("q_check_mode", true);
			
			var ret = {
				"result" : minhon.define.RES_NG,
				"message" : ""
			};
			
			btnSubmit.attr("disabled", "disabled");
			
			jQuery.ajax({
				"url" : "./import.html", 
				"type": "post",
				"contentType": false,
				"processData": false,
				"data": formData,
				"dataType" : "json",
				"error": function( result ){
					ret.message = minhon.define.STR_AJAX_ERROR;
				},
				"success" : function( result ){
					ret = result;
				},
				"complete" : function(){
					if ( ret.result === minhon.define.RES_OK ){
						// submitさせる
						$("#form_term").off("submit");
						$("#form_term").submit();
					} else if ( ret.result === minhon.define.RES_NO_DATA ){
						minhon.common.dialog.confirm( ret.message ).then(
							function(){
								// そのまま submit させる
								$("#form_term").off("submit");
								$("#form_term").submit();
							}, function(){
								// キャンセルが押された
								btnSubmit.removeAttr("disabled");
							}
						);
					} else {
						alert(ret.message);
						btnSubmit.removeAttr("disabled");
					}
				}
			});
			
			return false;
			
		});
	},
	
	eod : null
};
