minhon.user = {
	initialize : function(){
		minhon.common.search.setEvent("#dialog_user_filter_name");
		minhon.user.initializeSuggest();
		
	},
	
	initializeSuggest : function(){
		var engine = new Bloodhound({
			datumTokenizer: Bloodhound.tokenizers.obj.whitespace("value"),
			queryTokenizer: Bloodhound.tokenizers.whitespace,
			remote : {
				url: "/app/suggestController.php",
				prepare : function(inputValue, setting){
					var param = minhon.common.getFormParamter($("#dialog_user_filter_name form"));
					param["q_mode"] = minhon.define.APP_SUGGEST_CONTROLLER_MODE_USER_NAME;
					
					return $.extend({}, setting, {
						type : "post",
						data : param,
					});
				}
			}
		});
		
		$("#q_keyword").typeahead({
			hint : false,
			highlight : false
		}, {
			displayKey : "value",
			name : "suggest",
			source : engine,
			limit : 20,
			templates : {
				suggestion : function(data){
					var $element = $("<div>");
					var reg = new RegExp(data._query, "i");
					if ( match = reg.exec(data.value) ){
						var before = document.createTextNode( data.value.substring(0, match.index) );
						var after  = document.createTextNode( data.value.substring(match.index + match[0].length) );
						var hit    = $("<strong>").text(match[0]);
						$element.append(before).append(hit).append(after);
					} else {
						$element.text(data.value);
					}
					$element.append( $("<span>").text(" - " + data.org).addClass("tt-is-subtext") );
					return $element;
				}
			},
		}).on("typeahead:open", function(){
			$(this).closest(".ui-dialog").css("overflow", "visible");
			$(this).closest(".ui-dialog-content").css("overflow", "visible");
		}).on("typeahead:close", function(){
			$(this).closest(".ui-dialog").css("overflow", "hidden");
			$(this).closest(".ui-dialog-content").css("overflow", "hidden");
		});
	},
	
	onClickFilterName : function(){
		minhon.common.search.onClickOpenDialog("#dialog_user_filter_name");
	},
	
	onClickFilterNameClear : function(){
		minhon.common.search.onClickClear("#dialog_user_filter_name");
	},
	
	onClickUserState : function( that ){
		var $btn = $(that).closest(".btn-group").find(".dropdown-toggle");
		
		var userID = $(that).closest("tr").attr("data-user-id");
		if ( ! isFinite(userID) ){
			return;
		}
		var state = $(that).attr("data-state");
		
		jQuery.ajax({
			url      : "/app/userController.php",
			type     : "POST",
			data     : {
				"q_token"  : $("#token_common").val(),
				"q_mode"   : minhon.define.APP_USER_CONTROLLER_MODE_SET_STATE,
				"q_id"     : userID,
				"q_state"  : state
			},
			dataType : "json",
			error    : function(){
				alert("Error");
			},
			success  : function(res){
				if ( res.result === minhon.define.RES_OK ){
					// alert-* のクラス名を消す
					$btn.removeClass( function(index, css){
						return ( css.match(/\balert-\S+/g) || []).join(' ');
					} );
					$btn.addClass( res.data.alertClass );
					$btn.empty().text( res.data.stateText ).append("<span class=\"caret\"></span>");
					
					jQuery.each ( $(that).closest("ul.dropdown-menu").find("li > a > i"), function(){
						$(this).removeClass("glyphicon-arrow-right").addClass("glyphicon-none");
					});
					$(that).children("i").removeClass("glyphicon-none").addClass("glyphicon-arrow-right");
					
					// 更新リンク表示
					var $link = $(that).closest("tr").find("a.state-change-reload");
					$link.closest("td").find("dropdown-toggle").addClass("disabled");
					$link.removeClass("hide").removeClass("disabled");
				} else {
					alert(res.message);
				}
			}
		});
	},
	
	onClickWarnNonActive : function ( that ){
		var $btn = $(that).closest(".btn-group").find(".dropdown-toggle");
		
		var userID = $(that).closest("tr").attr("data-user-id");
		if ( ! isFinite(userID) ){
			return;
		}
		var nonActive = $(that).attr("data-value");
		
		jQuery.ajax({
			url      : "/app/userController.php",
			type     : "POST",
			data     : {
				"q_token"      : $("#token_common").val(),
				"q_mode"       : minhon.define.APP_USER_CONTROLLER_MODE_SET_WARN_NON_ACTIVE,
				"q_id"         : userID,
				"q_non_active" : nonActive
			},
			dataType : "json",
			error    : function(){
				alert(minhon.define.AJAX_ERROR);
			},
			success  : function( res ){
				if ( res.result === minhon.define.RES_OK ){
					// alert-* のクラス名を消す
					$btn.removeClass( function(index, css){
						return ( css.match(/\balert-\S+/g) || []).join(' ');
					} );
					$btn.addClass( res.data.alertClass );
					$btn.empty().text( res.data.text ).append("<span class=\"caret\"></span>");
					
					jQuery.each ( $(that).closest("ul.dropdown-menu").find("li > a > i"), function(){
						$(this).removeClass("glyphicon-arrow-right").addClass("glyphicon-none");
					});
					$(that).children("i").removeClass("glyphicon-none").addClass("glyphicon-arrow-right");
				} else {
					alert(res.message);
				}
			},
		});
	},
	
	eod : null
};

minhon.user.edit = {
	initialize : function(){
		// ユーザー名
		$.validator.addMethod("user_name", function(value, element){
			return this.optional(element) || /^[0-9a-z]+$/i.test(value);
		}, WORD_J_JS_MINHON_USER_001);
	},
	
	eod : null
};
