minhon.workflow = {
	eod : null
}

minhon.workflow.edit = {
	initialize : function( prohibitionType ){
		$("#table_workflow_task_type .btn").bind("click", minhon.workflow.edit.onClickType);
		$("#table_workflow_task_type input[type=checkbox]").bind("click", minhon.workflow.edit.refresh);
		$("#form_workflow_edit .type-operation-group-link").bind("click", function(){
			$("#table_workflow_task_type input[type=checkbox]:checked").removeAttr("checked");
			var arrTypes = $(this).attr("data-type").split(",");
			for (var i = 0; i < arrTypes.length; i++ ){
				$("#table_workflow_task_type input[type=checkbox][value="+arrTypes[i]+"]:enabled").attr("checked", "checked");
			}
			minhon.workflow.edit.refresh();
		}).hover( function(){
			var arrTypes = $(this).attr("data-type").split(",");
			for (var i = 0; i < arrTypes.length; i++ ){
				$("#table_workflow_task_type input[type=checkbox][value="+arrTypes[i]+"]:enabled").closest("label").addClass("bold");
			}
		}, function(){
			$("#table_workflow_task_type .bold").removeClass("bold");
		});
		
		$("#q_start").datepicker({"dateFormat" : "yy-mm-dd"});
		$("#q_end").datepicker({"dateFormat" : "yy-mm-dd"});
		
		if ( $.validator ){
			$.validator.setDefaults({
				errorPlacement : function(error, element){
					// 通常処理
					error.insertAfter(element);
					// タスク選択
					if ( element.is(":checkbox") ){
						if ( element.parent().is("label.checkbox-inline") ){
							element.closest(".form-group").children("div").append( error );
						}
					}
				}
			});
		}
		
		// 変更を禁止するタイプ
		if ( prohibitionType ){
			var arrProhibitionType = prohibitionType.split(",");
			for (var i = 0; i < arrProhibitionType.length; i++ ){
				var $tr = $("#table_workflow_task_type tr[data-type-group="+arrProhibitionType[i]+"]");
				if ( $tr.length == 0 ){
					return;
				}
				$tr.find(".btn,input[type=checkbox],label.checkbox-inline").attr("disabled", "disabled");
				$tr.find("td").last().append( $("<span>").addClass("overlay") );
			}
		}
		
		minhon.workflow.edit.refresh();
	},
	
	onClickType : function(){
		if ( $(this).hasClass("btn-danger") ){
			$(this).removeClass("btn-danger");
			$(this).closest("tr").find("input[type=checkbox]").removeAttr("checked");
		} else {
			$(this).addClass("btn-danger");
			$(this).closest("tr").find("input[type=checkbox]").attr("checked", "checked");
		}
	},
	
	refresh : function(){
		jQuery.each($("#table_workflow_task_type tr"), function(){
			if ( $(this).find("input[type=checkbox]:checked").size() == $(this).find("input[type=checkbox]").size() ){
				$(this).find("a.btn").addClass("btn-danger");
			} else {
				$(this).find("a.btn").removeClass("btn-danger");
			}
		});
	},
	
	eod : null
	
	
}
