<?php require_once(dirname(__FILE__) . "/../setting.ini"); ?>
<?php require_once(Setting::get("PATH_ROOT")."/app/class/WebAPI.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 辞書プロセス実行
// argument : 
//--------------------------------------------------------------------
// タイムアウト解除
set_time_limit(0);

//----------------------------
// define
//----------------------------
define("PROCESS_INTERVAL_TIME", 1);
define("PROCESS_LIMIT_TIME",  (24*60*60));

define("PATH_PROCESS",  dirname(__FILE__));
define("PATH_LOG_FILE", dirname(__FILE__));
define("TERM_INCREMENT", 10000);

//----------------------------
// variable
//----------------------------
//----------------------------
// request parameter
//----------------------------
//----------------------------
// check request parameter
//----------------------------
//----------------------------
// function
//----------------------------
function main(){
	$objProc = new Proc(PATH_PROCESS, PROCESS_INTERVAL_TIME, PROCESS_LIMIT_TIME);
	
	//------------------------
	// 処理中か？
	//------------------------
	// 処理中の場合
	if ( $objProc->isProcess() === TRUE ){
		// 待機時間更新
		if ( $objProc->updateWaitTime() === FALSE ){
			Util::printLog("[ERROR]update wait time.", PATH_LOG_FILE);
		}
		exit();
	} else {
		// プロセスファイル作成
		if ( $objProc->makeProcess() === FALSE ){
			Util::printLog("[ERROR]make process.", PATH_LOG_FILE);
			exit();
		}
	}
	
	//------------------------
	// 対象時間取得
	//------------------------
	if ( ($targetTime = $objProc->getTargetTime()) === FALSE ){
		Util::printLog("[ERROR]get target time.", PATH_LOG_FILE);
		exit();
	}
	
	//------------------------
	// 処理
	//------------------------
	if ( run($targetTime) === FALSE ){
		Util::printLog("[ERROR]main dict.", PATH_LOG_FILE);
		exit();
	}
	
	//------------------------
	// プロセス管理ファイル削除
	//------------------------
	if ( $objProc->deleteProcess() === FALSE ){
		Util::printLog("[ERROR]delete process.", PATH_LOG_FILE);
		exit();
	}
	
	//------------------------
	// 終了時間記録
	//------------------------
	if ( $objProc->makeFinish(PATH_PROCESS) === FALSE ){
		Util::printLog("[ERROR]make finish.", PATH_LOG_FILE);
		exit();
	}
}

function run( $targetTime ){
	$result = RES_OK;
	$arrText = array();
	
	$arrUpdateInfo = array();
	
	DAO::connect();
	
	$objDAOExterm = DAO::instance("exterm");
	$objDAOTerm = DAO::instance("term", Term::KIND_TERM);
	
	//----------------------------------------
	// 処理対象取得
	//----------------------------------------
	if ( $result === RES_OK ){
		// *実行
		$resDAOExterm = $objDAOExterm->get(NULL, DAO::T_EXTERM_STATE_NORMAL, NULL, NULL, array("t_exterm_register" => DAO::ASC));
		$result = $resDAOExterm["result"];
		
		if ( $result === RES_OK ){
			$dataExterm = $resDAOExterm["data"][0];
			
			$id         = $dataExterm["t_exterm_id"];
			$langS      = $dataExterm["t_exterm_lang_s"];
			$langT      = $dataExterm["t_exterm_lang_t"];
			$termRootID = $dataExterm["t_exterm_complete_term_root_id"];
			$userID     = $dataExterm["t_user_id"];
		} else if ( $result === RES_NO_DATA ){
			Util::printLog("[INFO]no update.", PATH_LOG_FILE);
			return TRUE;
		} else {
			Util::printLog("[ERROR]select.", PATH_LOG_FILE);
		}
	}
	
	//----------------------------------------
	// 処理中
	//----------------------------------------
	if ( $result === RES_OK ){
		// *実行
		$resDAOExterm = $objDAOExterm->register($id, DAO::T_EXTERM_STATE_WAITNG);
		$result = $resDAOExterm["result"];
		
		if ( $result !== RES_OK ){
			$result = RES_NG;
			Util::printLog("[ERROR]update.", PATH_LOG_FILE);
		}
	}
	
	//----------------------------------------
	// 実行
	//----------------------------------------
	if ( $result === RES_OK ){
		$objWebAPI     = new WebAPI();
		$inputFile = Setting::get("PATH_DATA_EXTERM")."/{$id}/{$id}.tsv";
		$outputFile = Setting::get("PATH_DATA_EXTERM")."/{$id}/result.tsv";
		$tsvFile = Setting::get("PATH_DATA_EXTERM")."/{$id}/output.tsv";

		if ( $objWebAPI->exterm($inputFile, $outputFile, $langS, $langT ) === FALSE ){
			$result = RES_NG;
			Util::printLog("[ERROR]WebAPI exterm.", PATH_LOG_FILE);
		}
		
		if ( $result === RES_OK ){
			$fr = null;
			$fw = null;
			if ( ! file_exists($outputFile) ){
				// 用語抽出結果が 0件だった場合もこの処理
				file_put_contents($tsvFile, "", FILE_APPEND);
			} else {
				if ( ($fr = fopen($outputFile, "r")) === FALSE ){
					$result = RES_NG;
					Util::printLog("[ERROR]exterm open read file.", PATH_LOG_FILE);
				} else if ( ($fw = fopen($tsvFile, "w")) === FALSE ){
					$result = RES_NG;
					Util::printLog("[ERROR]exterm open write file.", PATH_LOG_FILE);
				}
				
				if ( $result === RES_OK ){
					while ( ($line = fgets($fr)) !== FALSE ){
						$line = preg_replace("/(\r|\n)/", "", $line);
						$arr = explode(WebAPI::EXTERM_DELIMITER, $line);
						
						// 単言語の場合
						if (count($arr) < 3){
							$count = array_shift($arr);
							$textS = array_shift($arr);
							$arrTextT = array("");
						// 上記以外の場合
						} else {
							$count = array_shift($arr);
							$textS = array_shift($arr);
							$arrTextT = $arr;
						}
						
						foreach ( $arrTextT as $textT ){
							fwrite($fw, $textS.WebAPI::EXTERM_DELIMITER.$textT."\r\n");
						}
					}
				}
				if ( $fr ){
					fclose($fr);
				}
				if ( $fw ){
					fclose($fw);
				}
			}
		}
	}
	
	//----------------------------------------
	// 用語集登録
	//----------------------------------------
	if ( $result === RES_OK ){
		if ( Validate::isNumeric($termRootID) && $termRootID > 0 ){
			if ( ($f = fopen($tsvFile, "r")) === FALSE ){
				$result = RES_NG;
				Util::printLog("[ERROR]exterm open read tsv file.", PATH_LOG_FILE);
			}
			if ( $result === RES_OK ){
				$warning = FALSE;
				while ( ($line = fgets($f)) !== FALSE ){
					$line = preg_replace("/(\r|\n)/", "", $line);
					$arr = explode(WebAPI::EXTERM_DELIMITER, $line);
					$textS = array_shift($arr);
					$textT = array_shift($arr);
					
					$resDAOTerm = $objDAOTerm->register(DAO::ID_INIT, $textS, $textT, $termRootID, $userID);
					if ( $resDAOTerm["result"] !== RES_OK ){
						$warning = TRUE;
					}
				}
				if ( $warning ){
					Util::printLog("[WARNING]exterm register to term. term_root_id={$termRootID}", PATH_LOG_FILE);
				}
				fclose($f);
			}
		}
	}
	
	//----------------------------------------
	// 更新
	//----------------------------------------
	if ( $result === RES_OK ){
		// *実行
		$resDAOExterm = $objDAOExterm->register($id, DAO::T_EXTERM_STATE_COMPLT);
		$result = $resDAOExterm["result"];
		
		if ( $result !== RES_OK ){
			$result = RES_NG;
			Util::printLog("[ERROR]update.", PATH_LOG_FILE);
		}
	} else {
		// *実行
		$resDAOExterm = $objDAOExterm->register($id, DAO::T_EXTERM_STATE_FAILED);
		if ( $resDAOExterm["result"] !== RES_OK ){
			Util::printLog("[ERROR]update.", PATH_LOG_FILE);
		}
	}
	
	return ($result === RES_OK);
}

//----------------------------
// process
//----------------------------
// 引数チェック
if ( $argc === 1 ){
	main();
} else {
	echo "usage:\n";
	echo "php -f main.php\n";
}
