<?php require_once(dirname(__FILE__) . "/../setting.ini"); ?>
<?php require_once(Setting::get("PATH_ROOT")."/app/class/DocTmx.php"); ?>
<?php require_once(Setting::get("PATH_ROOT")."/app/class/WebAPI.php"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 機械翻訳反映
// argument : 
//--------------------------------------------------------------------
// タイムアウト解除
set_time_limit(0);

//----------------------------
// define
//----------------------------
define("PROCESS_INTERVAL_TIME", 1);
define("PROCESS_LIMIT_TIME",  (24*60*60));

//----------------------------
// variable
//----------------------------
//----------------------------
// request parameter
//----------------------------
//----------------------------
// check request parameter
//----------------------------
//----------------------------
// function
//----------------------------
function main(){
	global $G_LANGS_DIRECTION;
	
	$dirPath = dirname(__FILE__);
	
	$objProc = new Proc($dirPath, PROCESS_INTERVAL_TIME, PROCESS_LIMIT_TIME);
	
	// 処理中か？
	if ( $objProc->isProcess() === TRUE ){
		exit();
	}
	
	run($dirPath);
	
	// プロセス管理ファイル削除
	if ( $objProc->deleteProcess() === FALSE ){
		exit();
	}
	
	// 終了時間記録
	if ( $objProc->makeFinish($dirPath) === FALSE ){
		exit();
	}
}

function run( $dirPath ){
	$result = RES_OK;
	
	$db = DAO::connect();
	
	$objDAODocument = DAO::instance("document");
	
	$objDocTmx     = new DocTmx();
	$objWebAPI     = new WebAPI();
	
	//------------------------------------
	// 文書詳細
	//------------------------------------
	if ( $result === RES_OK ){
		$resDAODocument = $objDAODocument->get(NULL, DAO::T_DOCUMENT_STATE_MTWAIT);
		
		if ( $resDAODocument["result"] === RES_OK ){
			foreach ( $resDAODocument["data"] as $dataDocument ){
				$documentID    = $dataDocument["t_document_id"];
				$documentLangS = $dataDocument["t_document_lang_s"];
				$documentLangT = $dataDocument["t_document_lang_t"];
				$documentText  = $dataDocument["t_document_text"];
				
				if ( $objDocTmx->load($documentText) === FALSE ){
					continue;
				}
				
				// 対訳取得
				$arrSentence = $objDocTmx->getSentence();
				
				foreach ( $arrSentence as &$sentence ){
					$textS = trim($sentence["source_text"]);
					$textT = trim($sentence["target_text"]);
					
					// すでに翻訳が入っている場合
					if ( strcmp($textT, "") !== 0 ){
						continue;
					}
					
					// 翻訳(WebAPI)
					if ( ($textT = $objWebAPI->autoTranslate(WebAPI::TRANSLATOR_ENGINE_NAME_GENERAL, $documentLangS, $documentLangT, $textS )) === FALSE ){
						continue;
					}
					
					echo $textS . "\n";
					echo "-> " . $textT . "\n";
					
					$sentence["target_text"] = $textT;
				}
				
				$objDocTmx->setSentence($arrSentence);
				
				$tmx = $objDocTmx->saveXML();
				
				if ( $result === RES_OK ){
					// *実行
					$resDAODocument = $objDAODocument->register($documentID, DAO::T_DOCUMENT_STATE_MTCOMP, NULL, NULL, NULL, $tmx);
					$result = $resDAODocument["result"];
					
					if ( $result !== RES_OK ){
						Util::printLog("[error]update state {$documentID}", $dirPath);
					}
				}
			}
		} else {
			Util::printLog("[info]no wait", $dirPath);
		}
	}
	
	DAO::close($db);
}

//----------------------------
// process
//----------------------------
if ( $argc == 1 ){
	main();
} else {
	echo "usage:\n";
	echo "php -f main.php\n";
}
Util::printLog("[info]finish", dirname(__FILE__));
