<?php require_once(dirname(__FILE__) . "/../setting.ini"); ?>
<?php
//--------------------------------------------------------------------
// explain  : 対訳データ出力
// argument : 
//--------------------------------------------------------------------
// タイムアウト解除
set_time_limit(0);

//----------------------------
// define
//----------------------------
define("PATH_PROCESS",  dirname(__FILE__));
define("PATH_LOG_FILE", dirname(__FILE__));

define("DATA_LIMIT", 1000);

//----------------------------
// function
//----------------------------
function main( $kind, $outputPath, $processPath = NULL ){
	if ( strcmp($kind, "term") !== 0 && strcmp($kind, "bilingual") !== 0 ){
		return FALSE;
	}
	
	$lasttime = NULL;
	if ( is_null($processPath) ){
		$processPath = PATH_PROCESS;
	}
	$timefile = "{$processPath}/process.time";
	if ( file_exists($timefile)){
		$lasttime = file_get_contents($timefile);
		if ( ! is_numeric($lasttime) ){
			$lasttime = NULL;
		}
	}
	
	$time = time(); // 処理をする前の時間を覚えておく
	
	term($kind, $outputPath, $lasttime);
	
	// 処理開始時間を覚えておく（次回実行時はこの時間より後に更新されたデータのみ処理する）
	file_put_contents($timefile, $time);
}

function term( $kind, $outputPath, $date ){
	DAO::connect();
	
	$objDAOTermRoot = DAO::instance("term_root", $kind);
	
	// *条件
	$arrCondition = array();
	if ( is_numeric($date) ){
		$sqlDate = $objDAOTermRoot->esc(date("Y-m-d H:i:s", $date));
		$arrCondition["update"] = array("type" => DAO::TYPE_SQL, "value" => "t_{$kind}_root_update > \"{$sqlDate}\"");
	}
	
	$objDAOTermRoot->outputTsv( $outputPath, $arrCondition );
}

//----------------------------
// process
//----------------------------
// 引数チェック
if ( $argc === 3 ){
	main( $argv[1], $argv[2] );
} else if ( $argc === 4 ){
	main( $argv[1], $argv[2], $argv[3] );
} else {
	echo "usage:\n";
	echo "php -f run.php <kind> <opath> [<ppath>]\n";
	echo "  <kind>  : \"term\" or \"bilingual\"\n";
	echo "  <opath> : output tsv file directory\n";
	echo "  <ppath> : (optional) process file directory\n";
}
